package com.gx.obe.opening.action;

import org.eclipse.swt.SWT;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.widgets.Composite;

import com.gx.obe.action.bean.Action;
import com.gx.obe.action.listener.ActionListener;
import com.gx.obe.config.ConfigConstants;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.opening.composite.BidOpeningRemoteMultyProjectComposite;
import com.gx.obe.opening.listener.MeetingRoomListener;
import com.gx.obe.opening.shell.BidOpeningRoomShell;
import com.gx.obe.opening.shell.BidOpeningRoomWidenShell;

/** 
 * @Description: 进入项目开标
 * @author guoyr 
 */
public class TopOpeningHallAction extends Action{

	@Override
	public void run() {
		ActionListener listener = this.getListener();
		MeetingRoomListener bidOpeningRemoteDecryptShell = null;
		if("01".equals(PropertiesUtils.getProperty(ConfigConstants.ROOM_USE_WIDEN_SCREEN_, "00"))){
			bidOpeningRemoteDecryptShell = new BidOpeningRoomWidenShell(listener.getParentComposite().getShell());
		}else {
			bidOpeningRemoteDecryptShell = new BidOpeningRoomShell(listener.getParentComposite().getShell());
		}
		Composite parentComposite = bidOpeningRemoteDecryptShell.getLoadParent();
		parentComposite.setData("meetingRoomListener", bidOpeningRemoteDecryptShell);
		BidOpeningRemoteMultyProjectComposite bidOpeningRemoteComposite = new BidOpeningRemoteMultyProjectComposite(parentComposite, this, SWT.NONE);
		bidOpeningRemoteComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		parentComposite.layout();
		bidOpeningRemoteDecryptShell.open();
	}

}
