package com.gx.obe.opening.composite;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;

import com.gx.obe.ColorConstants;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.inter.ProjectStatusCount;
import com.gx.obe.common.widget.listener.StatusCountListener;
import com.gx.obe.message.Messages;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

/** 
 * @Description: 按项目开标的统计
 * @author guoyr 
 */
public class BidOpeningCountComposite extends Composite implements ProjectStatusCount{

	private Label titleLabel;
//	private Label countLabel;
	private StatusCountListener listener;
	private Runnable countRunnable;
	private Label unitLabel;
//	private CLabel changeType;
	private int curIndex = 0;
	private int curCount = 0;
	private int maxNum = 2;
	private List<Map<String, String>> statusList = new ArrayList<Map<String, String>>();
	private int[] counts = new int[]{0};
	private Composite composite;
	private static int DRAW_FLAGS = SWT.DRAW_MNEMONIC | SWT.DRAW_TAB | SWT.DRAW_TRANSPARENT | SWT.DRAW_DELIMITER;
	private int errors = -1;

	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public BidOpeningCountComposite(Composite parent, int style) {
		super(parent, style);
		setForeground(SWTResourceManager.getColor(242, 242, 242));
		setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.horizontalSpacing = 0;
		gridLayout.marginWidth = 2;
		gridLayout.verticalSpacing = 0;
		gridLayout.marginHeight = 2;
		setLayout(gridLayout);
		
		Composite titleComposite = new Composite(this, SWT.NONE);
		titleComposite.setBackground(SWTResourceManager.getColor(242, 242, 242));
		titleComposite.setBackgroundMode(SWT.INHERIT_FORCE);
		GridLayout gl_titleComposite = new GridLayout(1, false);
		gl_titleComposite.marginHeight = 2;
		titleComposite.setLayout(gl_titleComposite);
		titleComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		titleLabel = new Label(titleComposite, SWT.WRAP | SWT.CENTER);
		titleLabel.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, false, 1, 1));
		titleLabel.setForeground(ColorConstants.FONT_BLACK_COLOR);
		titleLabel.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.BOLD));
		titleLabel.setText(Messages.Opening_tendered);
		
		composite = new Composite(this, SWT.NONE);
//		composite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridData gd_composite = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_composite.minimumWidth = 50;
		composite.setLayoutData(gd_composite);
		GridLayout gl_composite = new GridLayout(3, false);
		gl_composite.verticalSpacing = 0;
		gl_composite.marginHeight = 0;
		gl_composite.horizontalSpacing = 0;
		gl_composite.marginWidth = 0;
		composite.setLayout(gl_composite);
		
//		countLabel = new Label(composite, SWT.CENTER);
//		countLabel.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
//		countLabel.setForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
//		countLabel.setFont(SWTResourceManager.getFont("微软雅黑", 20, SWT.NORMAL));
		
//		unitLabel = new CLabel(composite, SWT.NONE);
//		unitLabel.setBottomMargin(6);
//		unitLabel.setFont(SWTResourceManager.getFont("微软雅黑", 11, SWT.NORMAL));
//		unitLabel.setLayoutData(new GridData(SWT.CENTER, SWT.BOTTOM, true, false, 1, 1));
//		unitLabel.setForeground(SWTResourceManager.getColor(161, 205, 226));
//		unitLabel.setText(Messages.Opening_counts);
		
//		Composite unitComposite = new Composite(this, SWT.NONE);
//		unitComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
//		unitComposite.setLayout(new GridLayout(1, false));
//		unitComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
////		

		unitLabel = new Label(this, SWT.WRAP | SWT.CENTER);
		unitLabel.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, false, 1, 1));
		unitLabel.setForeground(ColorConstants.FONT_BLACK_COLOR);
		unitLabel.setFont(SWTResourceManager.getFont("微软雅黑", 11, SWT.NORMAL));
		unitLabel.setText(Messages.Opening_counts);
		
//		changeType = new CLabel(this, SWT.NONE);
//		changeType.addMouseListener(new MouseAdapter() {
//			@Override
//			public void mouseUp(MouseEvent e) {
//				changeShowCountType();
//			}
//		});
//		changeType.setLayoutData(new GridData(SWT.CENTER, SWT.TOP, false, false, 1, 1));
//		changeType.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID,"icons/btn/white/switch.png"));

		
		init();
	}
	public void setMaxNum(int maxNum){
		this.maxNum = maxNum;
	}
	/**
	 * @Description: 初始化
	 * @author guoyr 
	 */
	private void init(){
//		((GridData)changeType.getLayoutData()).exclude = true;
//		changeType.setVisible(false);
		addPaintListener(new PaintListener() {
			public void paintControl(PaintEvent arg0) {
				Rectangle rectangle = getBounds();
				arg0.gc.setForeground(SWTResourceManager.getColor(200, 200, 200));
				arg0.gc.setLineWidth(2);
				arg0.gc.setLineStyle(SWT.LINE_DOT);
				arg0.gc.drawRectangle(0, 0, rectangle.width -1, rectangle.height -1);
			}
		});
		
		composite.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				if(null != listener && curCount > 0){
					listener.selection(curCount);
				}
			}
		});
		
		countRunnable = new Runnable(){
			public void run(){
				if(!composite.isDisposed() && counts.length > curIndex){
					curCount = counts[curIndex];
					composite.redraw();
//					countLabel.setText(curCount + "");
//					if(curCount > 0 && null == countLabel.getCursor()){
//						countLabel.setCursor(SWTResourceManager.getCursor(SWT.CURSOR_HAND));
//					}else {
//						countLabel.setCursor(null);
//					}
//					countLabel.getParent().layout();
				}
			}
		};
		
		composite.addPaintListener(new PaintListener() {
			int num_width = 30;
			int num_height = 35;
			int num_sep_width = 0;
			double widthHeightRate = 0.5;
			String[] countTime = new String[maxNum];
			final Image emptyImage = ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID,"icons/time/blue_e.png");
			public void paintControl(PaintEvent arg0) {
				if( curCount >= 0) {
					String curCountStr = curCount + "";
					maxNum = curCountStr.length() > 0 ? curCountStr.length() : 1;
					if(null != countTime && countTime.length != curCountStr.length()){
						countTime = new String[maxNum];
					}
					for(int i = 0; i < maxNum; i++){
						if(i < curCountStr.length()){
							countTime[maxNum -1 - i] = curCountStr.substring(curCountStr.length() - i -1, curCountStr.length() - i);
						}else {
							countTime[maxNum - 1 - i] = "";
						}
					}
				}else {
					countTime = new String[]{""};
					maxNum = 1;
				}
				if(null != emptyImage){
					widthHeightRate =  (double)emptyImage.getBounds().width / emptyImage.getBounds().height;
					num_width = emptyImage.getBounds().width;
				}
				Rectangle bounds = composite.getBounds();
				num_width = Math.min(bounds.width/maxNum,num_width);// 最多显示4位数
				num_height = (int)((num_width)/widthHeightRate);
				if(num_height > bounds.height){
					num_height = bounds.height;
					num_width = (int)(bounds.height * widthHeightRate);
				}
				int x = (bounds.width - (maxNum - 1)* num_sep_width - maxNum * num_width)/2;
				int y = Math.max((bounds.height - num_height)/2, 0) + 1;
				for(int i = 0; i < countTime.length; i++){
					String num = countTime[i];
					Image image = emptyImage;
					if(num.length() > 0){
						image = ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID,"icons/time/blue_"+num+".png");
						arg0.gc.setAlpha(-1);
					}else {
//						arg0.gc.setAlpha(80);
					}
					if(null != image){
						Rectangle rectangle = image.getBounds();
						arg0.gc.drawImage(image, 0, 0, rectangle.width, rectangle.height, x, y, num_width, num_height);
					}
					x += num_width ;
					if(i > 0){
						x += num_sep_width ;
					}
				}
				if(errors > 0){
					String errorsStr = errors+"";
					Point errorsPoint = arg0.gc.textExtent(errorsStr, DRAW_FLAGS);
					arg0.gc.setBackground(SWTResourceManager.getColor(255, 0, 0));
					arg0.gc.setForeground(SWTResourceManager.getColor(255, 255, 255));
					int subTextSurrondWidth = Math.max(errorsStr.length() > 1 ? errorsPoint.x + 4 : errorsPoint.x  - 2, errorsPoint.y -2);
					int subTextSurrondHeight = errorsPoint.y -2;
					int errorX = Math.min(x -2 , composite.getBounds().width- subTextSurrondWidth - 2);
					int errorY = Math.min(2, y );
					arg0.gc.setAlpha(180);
					arg0.gc.setAdvanced(true);
					if(subTextSurrondWidth > subTextSurrondHeight) {
						arg0.gc.fillRoundRectangle(errorX , errorY , subTextSurrondWidth, subTextSurrondHeight, subTextSurrondHeight, subTextSurrondHeight);
					}else {
						arg0.gc.fillOval(errorX , errorY , subTextSurrondWidth, subTextSurrondHeight);
					}
					arg0.gc.setAdvanced(false);
					arg0.gc.setAlpha(-1);
					arg0.gc.drawText(errorsStr, errorX +(subTextSurrondWidth - errorsPoint.x)/2, errorY + (subTextSurrondHeight - errorsPoint.y)/2 , true);
				}
//				arg0.gc.dispose();
			}
		});
		
	}
	
	
	
	private void changeShowCountType(){
//		if(changeType.getEnabled()){
//			if(curIndex == statusList.size()-1){
//				curIndex = 0;
//			}else if(statusList.size() > curIndex + 1){
//				curIndex += 1;
//			}
//			if(null != listener){
//				listener.changed(curIndex, curCount);
//			}
//			Map<String, String> statusMap = statusList.get(curIndex);
//			if(null != statusMap.get("title")){
//				titleLabel.setText(statusMap.get("title"));
//			}
//			if(null != statusMap.get("unit")){
//				unitLabel.setText(statusMap.get("unit"));
//			}
//			Display.getDefault().syncExec(countRunnable);
//		}
	}
	public void setSelectionIndex(int index){
		if(index > 0){
			curIndex = index;// -1;
		}else {
			curIndex = 0;
		}
		changeShowCountType();
	}

	public void addStatusName(String statusName, String statusUnit){
		if(statusList.size() == 0){
			titleLabel.setText(statusName);
			unitLabel.setText(statusUnit);
		}
		Map<String, String> statusMap = new HashMap<String, String>();
		statusMap.put("title", statusName);
		statusMap.put("unit", statusUnit);
		statusList.add(statusMap);
//		if(statusList.size() > 1 && !changeType.isVisible()){
//			((GridData)changeType.getLayoutData()).exclude = false;
//			changeType.setVisible(true);
//			changeType.setCursor(SWTResourceManager.getCursor(SWT.CURSOR_HAND));
//			changeType.getParent().layout();
//		}
	}

	public void setCountValue(int index, int value) {
		if(index < counts.length){
			int oldCount = counts[index];
			counts[index] = value;
			if(curIndex == index && oldCount != value){
				Display.getDefault().syncExec(countRunnable);
			}
		}
	}
	public void setCounts(int[] _counts) {
		if(_counts.length > curIndex){
			int oldCount = counts.length > curIndex ? counts[curIndex] : 0;
			counts = _counts;
			if(oldCount != _counts[curIndex]){
				Display.getDefault().syncExec(countRunnable);
			}
			
		}
	}
	
	public void setSelection(final boolean selection){
//		Display.getDefault().syncExec(new Runnable(){
//			public void run(){
//				if(!selectionLabel.isDisposed()){
//					if(selection){
//						selectionLabel.setBackground(SWTResourceManager.getColor(235, 253, 254));
//					}else {
//						selectionLabel.setBackground(null);
//					}
//				}
//			}
//		});
	}
	
	public void addStatusCountListener(StatusCountListener listener){
		this.listener = listener;
		
	}
	public void setErrors(int errors){
		if(this.errors != errors){
			this.errors = errors;
			Display.getDefault().syncExec(countRunnable);
		}
	}
	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}
	@Override
	public void setStatusVisible(boolean[] visible) {
		// TODO Auto-generated method stub
		
	}

}
