package com.gx.obe.opening.composite;

import java.text.MessageFormat;
import java.text.SimpleDateFormat;
import java.util.Calendar;
import java.util.Date;
import java.util.List;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.CallBack;
import org.eclipse.swt.core.ImageResolver;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.calendar.CalendarDialog;
import org.eclipse.swt.core.utils.SwtUtils;
import org.eclipse.swt.core.utils.WidgetUtils;
import org.eclipse.swt.core.widgets.ConfirmDialog;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.core.widgets.GifImage;
import org.eclipse.swt.core.widgets.ImageButton;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.custom.StackLayout;
import org.eclipse.swt.events.ControlAdapter;
import org.eclipse.swt.events.ControlEvent;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;

import com.gx.obe.ColorConstants;
import com.gx.obe.action.bean.Action;
import com.gx.obe.business.entity.MenuFunction;
import com.gx.obe.business.enumeration.MenuFunctionEnum;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.button.ImageRaido;
import com.gx.obe.common.widget.listener.ProgressMessageListener;
import com.gx.obe.common.widget.shell.ToolsShell;
import com.gx.obe.common.widget.utils.MenuFunctionUtils;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.I18NEnum;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.config.ConfigConstants;
import com.gx.obe.config.utils.ProjectUtils;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.listener.ProgressMessageAdapter;
import com.gx.obe.message.Messages;
import com.gx.obe.opening.Activator;
import com.gx.obe.opening.dialog.BidOpeningPlanDialog;
import com.gx.obe.opening.dialog.SelectDecryptTypeDialog;
import com.gx.obe.opening.listener.MeetingRoomListener;
import com.gx.obe.opening.shell.BidOpeningRoomShell;
import com.gx.obe.opening.shell.BidOpeningRoomWidenShell;
import com.gx.obe.thread.NewUpdateTenderProjectInfoThread;
import com.gx.obe.util.utils.DateUtils;
import com.gx.obe.web.entity.auth.Menu;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.entity.tender.TenderProjectRuleEntity;
import com.gx.obe.web.service.ProjectRuleService;
import com.gx.obe.web.service.TenderProjectService;
import com.gx.utils.ActionLogUtils;
import com.gx.utils.NowTimeUtils;
import com.gx.utils.Params;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

public class BidOpeningHallComposite extends Composite {
	private ProjectRuleService projectRuleService ;
	private TenderProjectService tenderProjectService;
//	private SupplierService supplierService = ServiceFactory.getInstance("supplierService", SupplierService.class);
	private Composite bidOpeningStageComposite;
	private Label bid_opening_start_time;
	private Label sign_end_time_text;
	private Label decrypt_end_time_text;
	private ELink importBtn;
	private Composite composite_1;
	private Composite operateComposite;
	private TenderProjectRuleEntity tenderProjectRuleEntity;
	private TenderProjectEntity tenderProjectEntity;
	private Composite stackComposite;
	private Label nowDataLabel;
	private CLabel hour_first_label;
	private CLabel hour_second_label;
	private CLabel minute_first_label;
	private CLabel minute_second_label;
	private CLabel seconds_first_label;
	private CLabel seconds_second_label;
	private ImageResolver imageResolver = new ImageResolver();
	private boolean countDownTime = false;
	private String BIDOPENING_STAGE = null;
	private ImageRaido curStageBtn;
	private ELink configSignEndTimeBtn;
	private ELink configDecEndTimeBtn;
	private Composite timeComposite;
	private boolean isShowMeetingRoom = true;
	private Composite hallCcomposite;
	private Canvas hallImageCanvas;
	private GifImage runPeopleGif;
	private int peopleX = 0;
	private int enterHallX = 0;
	private ELink entOpeningHallBtn;
	private String bidOpeningType;
	private Action projectAction;
	private Menu menu;
	private final MenuFunctionUtils menuFunctionUtils = new MenuFunctionUtils();
	private String openingType;
	private StackLayout stackLayout = new StackLayout();
	private Composite refreshTimeComposite;
	private Label messageLabel;
	private Composite confirmTimeComposite;
	private Label confirmSingEndTimeTitle;
	private Label confirmSingEndTimeLabel;
	private Label openingTimeTitle;
	private Label openingTimeLabel;
	private Label decryptEndTimeTitle;
	private Label decryptEndTimeLabel;
	private ELink configBidOpeningTimeBtn;
	private ELink selectBidOpeningTimeBtn;
	private ELink confirmELink;
	private ELink setOpeningTimeELink;

	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public BidOpeningHallComposite(Composite parent, Action projectAction, int style) {
		super(parent, style);
		this.projectAction = projectAction;
		addDisposeListener(new DisposeListener() {
			public void widgetDisposed(DisposeEvent arg0) {
				dispositeAction();
			}
		});
		
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.verticalSpacing = 0;
		gridLayout.marginTop = 10;
		gridLayout.marginWidth = 10;
		setLayout(gridLayout);
		
		nowDataLabel = new Label(this, SWT.NONE);
		nowDataLabel.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		nowDataLabel.setFont(SWTResourceManager.getFont("微软雅黑", 15, SWT.BOLD));
		nowDataLabel.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, false, 1, 1));
		nowDataLabel.setText("");
		
		Composite nowTimeComposite = new Composite(this, SWT.NONE);
		GridLayout gl_composite = new GridLayout(8, false);
		gl_composite.marginHeight = 20;
		nowTimeComposite.setLayout(gl_composite);
		nowTimeComposite.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, false, 1, 1));
		
		
		hour_first_label = new CLabel(nowTimeComposite, SWT.NONE);
		hour_first_label.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		hour_first_label.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/time/time_blue_bg.png"));
		
		hour_second_label = new CLabel(nowTimeComposite, SWT.NONE);
		hour_second_label.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/time/time_blue_bg.png"));
		
		CLabel hour_sep_label = new CLabel(nowTimeComposite, SWT.NONE);
		hour_sep_label.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/time/blue_sep.png"));
		
		minute_first_label = new CLabel(nowTimeComposite, SWT.NONE);
		minute_first_label.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		minute_first_label.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/time/time_blue_bg.png"));
		
		minute_second_label = new CLabel(nowTimeComposite, SWT.NONE);
		minute_second_label.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		minute_second_label.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/time/time_blue_bg.png"));
		
		CLabel minute_sep_label = new CLabel(nowTimeComposite, SWT.NONE);
		minute_sep_label.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/time/blue_sep.png"));
		
		seconds_first_label = new CLabel(nowTimeComposite, SWT.NONE);
		seconds_first_label.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		seconds_first_label.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/time/time_blue_bg.png"));
		
		seconds_second_label = new CLabel(nowTimeComposite, SWT.NONE);
		seconds_second_label.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		seconds_second_label.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/time/time_blue_bg.png"));
		
		bidOpeningStageComposite = new Composite(this, SWT.NONE);
		GridLayout gl_composite_top = new GridLayout(3, false);
		gl_composite_top.marginHeight = 0;
		gl_composite_top.marginWidth = 0;
		bidOpeningStageComposite.setLayout(gl_composite_top);
		bidOpeningStageComposite.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, false, 1, 1));
		
		Label stageLabe = new Label(bidOpeningStageComposite, SWT.NONE);
		stageLabe.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		stageLabe.setText(Messages.Tips_selectBidOpeningStage + "：");
		stageLabe.setFont(SWTResourceManager.getFont("微软雅黑", 19, SWT.NORMAL));
		stageLabe.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		new Label(bidOpeningStageComposite, SWT.NONE);
		new Label(bidOpeningStageComposite, SWT.NONE);
		
		stackComposite = new Composite(this, SWT.NONE);
		stackComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		stackComposite.setLayout(stackLayout);

		refreshTimeComposite = new Composite(stackComposite, SWT.NONE);
		refreshTimeComposite.setBackgroundMode(SWT.INHERIT_FORCE);
		refreshTimeComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		refreshTimeComposite.setLayout(new GridLayout(1, false));
		
		messageLabel = new Label(refreshTimeComposite, SWT.CENTER);
		messageLabel.setFont(SWTResourceManager.getFont("微软雅黑", 25, SWT.NORMAL));
		messageLabel.setForeground(ColorConstants.FONT_BLACK_COLOR);
		messageLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1));
		messageLabel.setText("正在同步开标时间...");
		
		confirmTimeComposite = new Composite(refreshTimeComposite, SWT.NONE);
		confirmTimeComposite.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, true, 1, 1));
		confirmTimeComposite.setLayout(new GridLayout(2, false));
		
		confirmSingEndTimeTitle = new Label(confirmTimeComposite, SWT.NONE);
		confirmSingEndTimeTitle.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true, false, 1, 1));
		confirmSingEndTimeTitle.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		confirmSingEndTimeTitle.setFont(SWTResourceManager.getFont("微软雅黑", 15, SWT.NORMAL));
		confirmSingEndTimeTitle.setText("签到截止时间:");
		
		confirmSingEndTimeLabel = new Label(confirmTimeComposite, SWT.NONE);
		confirmSingEndTimeLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		confirmSingEndTimeLabel.setFont(SWTResourceManager.getFont("微软雅黑", 15, SWT.NORMAL));
		confirmSingEndTimeLabel.setForeground(ColorConstants.FONT_BLACK_COLOR);
		confirmSingEndTimeLabel.setText("");
		
		openingTimeTitle = new Label(confirmTimeComposite, SWT.NONE);
		openingTimeTitle.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true, false, 1, 1));
		openingTimeTitle.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		openingTimeTitle.setFont(SWTResourceManager.getFont("微软雅黑", 15, SWT.NORMAL));
		openingTimeTitle.setText("开标时间:");
		
		openingTimeLabel = new Label(confirmTimeComposite, SWT.NONE);
		openingTimeLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		openingTimeLabel.setFont(SWTResourceManager.getFont("微软雅黑", 15, SWT.NORMAL));
		openingTimeLabel.setForeground(ColorConstants.FONT_BLACK_COLOR);
		openingTimeLabel.setText("");
		
		decryptEndTimeTitle = new Label(confirmTimeComposite, SWT.NONE);
		decryptEndTimeTitle.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true, false, 1, 1));
		decryptEndTimeTitle.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		decryptEndTimeTitle.setFont(SWTResourceManager.getFont("微软雅黑", 15, SWT.NORMAL));
		decryptEndTimeTitle.setText("解密截止时间:");
		
		decryptEndTimeLabel = new Label(confirmTimeComposite, SWT.NONE);
		decryptEndTimeLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		decryptEndTimeLabel.setFont(SWTResourceManager.getFont("微软雅黑", 15, SWT.NORMAL));
		decryptEndTimeLabel.setForeground(ColorConstants.FONT_BLACK_COLOR);
		decryptEndTimeLabel.setText("");
		
		confirmELink = new ELink(confirmTimeComposite, SWT.CENTER);
		confirmELink.setFont(SWTResourceManager.getFont("微软雅黑", 15, SWT.NORMAL));
		confirmELink.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 2, 1));
		confirmELink.setText("确认以上时间与公告中一致，继续开标");
		confirmELink.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/checked.png"));
		confirmELink.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				confirmTimeAction();
			}
		});
		
		setOpeningTimeELink = new ELink(confirmTimeComposite, SWT.CENTER);
		setOpeningTimeELink.setFont(SWTResourceManager.getFont("微软雅黑", 15, SWT.NORMAL));
		setOpeningTimeELink.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 2, 1));
		setOpeningTimeELink.setText("设置开标时间");
		setOpeningTimeELink.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/checked.png"));
		setOpeningTimeELink.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				configBidOpeningTimeAction();
			}
		});
		
		operateComposite = new Composite(stackComposite, SWT.NONE);
		operateComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		
		GridLayout gl_operateComposite = new GridLayout(1, false);
		gl_operateComposite.verticalSpacing = 0;
		gl_operateComposite.horizontalSpacing = 0;
		gl_operateComposite.marginHeight = 0;
		gl_operateComposite.marginWidth = 0;
		operateComposite.setLayout(gl_operateComposite);
		
		composite_1 = new Composite(operateComposite, SWT.NONE);
		GridLayout gl_composite_1 = new GridLayout(3, false);
		gl_composite_1.horizontalSpacing = 20;
		composite_1.setLayout(gl_composite_1);
		GridData gd_composite_1 = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_composite_1.heightHint = 100;
		gd_composite_1.widthHint = 900;
		composite_1.setLayoutData(gd_composite_1);
		
		hallCcomposite = new Composite(composite_1, SWT.NONE);
		hallCcomposite.setLayout(new FormLayout());
		hallCcomposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		hallCcomposite.addControlListener(new ControlAdapter() {
			@Override
			public void controlResized(ControlEvent e) {
				resizeRunPeople();
			}
		});
		runPeopleGif = new GifImage(hallCcomposite, SWT.BOTTOM);
		runPeopleGif.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				if (e.button == 1) {//点击鼠标左键
					entOpeningHallAction();
				}else if(e.button==3){
					enterOpeningAction();
				}
			}
		});
		runPeopleGif.setCursor(SWTResourceManager.getCursor(SWT.CURSOR_HAND));
		FormData fd_runPeopleGif = new FormData();
		fd_runPeopleGif.bottom = new FormAttachment(100,0);
		fd_runPeopleGif.top = new FormAttachment(100, -150);
		fd_runPeopleGif.left = new FormAttachment(30, 0);
		fd_runPeopleGif.right = new FormAttachment(30, 50);
		runPeopleGif.setLayoutData(fd_runPeopleGif);
		runPeopleGif.setGifPath(ProjectUtils.getFileAbsolutePath(Activator.getDefault(), "icons/run.gif"), 85, 98);
		runPeopleGif.setImageData(500, new int[]{3,1});
		
		entOpeningHallBtn = new ELink(hallCcomposite, SWT.NONE);
		FormData fd_enterBtn = new FormData();
		fd_enterBtn.left = new FormAttachment(20);
		fd_enterBtn.bottom = new FormAttachment(100, 0);
		entOpeningHallBtn.setLayoutData(fd_enterBtn);
		entOpeningHallBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				if (e.button == 1) {//点击鼠标左键
					entOpeningHallAction();
				}else if(e.button==3){
					enterOpeningAction();
				}
			}
		});
		entOpeningHallBtn.setText(Messages.Button_enterBidOpeningHall);
		
		
		hallImageCanvas = new Canvas(hallCcomposite, SWT.TRANSPARENT);
		FormData fd_hallImage = new FormData();
		fd_hallImage.top = new FormAttachment(0);
		fd_hallImage.left = new FormAttachment(50,0);
		fd_hallImage.bottom = new FormAttachment(100,0);
		fd_hallImage.right = new FormAttachment(100,0);
		hallImageCanvas.setLayoutData(fd_hallImage);
		new Label(composite_1, SWT.NONE);
		new Label(composite_1, SWT.NONE);
		
		
		timeComposite = new Composite(operateComposite, SWT.NONE);
		GridLayout gl_timeComposite = new GridLayout(4, false);
		gl_timeComposite.horizontalSpacing = 0;
		gl_timeComposite.marginHeight = 0;
		gl_timeComposite.marginWidth = 0;
		timeComposite.setLayout(gl_timeComposite);
		timeComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		
		Composite sign_end_time_composite = new Composite(timeComposite, SWT.NONE);
		sign_end_time_composite.setLayoutData(new GridData(SWT.CENTER, SWT.FILL, true, true, 1, 1));
		sign_end_time_composite.setLayout(new GridLayout(3, false));
		menuFunctionUtils.addFunction(sign_end_time_composite, "SIGN_END_TIME");
		
		Label label_3 = new Label(sign_end_time_composite, SWT.WRAP);
		label_3.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		label_3.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		label_3.setText(Messages.CheckInEndTime);
		
		sign_end_time_text = new Label(sign_end_time_composite, SWT.NONE);
		sign_end_time_text.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, true, 1, 1));
		sign_end_time_text.setFont(SWTResourceManager.getFont("微软雅黑", 25, SWT.NORMAL));
		sign_end_time_text.setForeground(ColorConstants.FONT_BLACK_COLOR);
		sign_end_time_text.setText("00:00:00");
		
		configSignEndTimeBtn = new ELink(sign_end_time_composite, SWT.NONE);
		configSignEndTimeBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/data.png"));
		configSignEndTimeBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				configSignEndTimeAction();
			}
		});
		
		Composite bid_opening_start_composite = new Composite(timeComposite, SWT.NONE);
		bid_opening_start_composite.setLayoutData(new GridData(SWT.CENTER, SWT.FILL, true, true, 1, 1));
		bid_opening_start_composite.setLayout(new GridLayout(4, false));
		menuFunctionUtils.addFunction(bid_opening_start_composite, "BID_OPENING_START");
		
		Label bid_open_time = new Label(bid_opening_start_composite, SWT.WRAP);
		bid_open_time.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true, false, 1, 1));
		bid_open_time.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		bid_open_time.setText(Messages.BidOpeningTime);
		
		bid_opening_start_time = new Label(bid_opening_start_composite, SWT.NONE);
		bid_opening_start_time.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, true, 1, 1));
		bid_opening_start_time.setFont(SWTResourceManager.getFont("微软雅黑", 25, SWT.NORMAL));
		bid_opening_start_time.setForeground(ColorConstants.FONT_BLACK_COLOR);
		bid_opening_start_time.setText("00:00:00");
		
		configBidOpeningTimeBtn = new ELink(bid_opening_start_composite, SWT.NONE);
		configBidOpeningTimeBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/data.png"));
		configBidOpeningTimeBtn.setToolTipText("设置开标时间");
		configBidOpeningTimeBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				configBidOpeningTimeAction();
			}
		});
		
		selectBidOpeningTimeBtn = new ELink(bid_opening_start_composite, SWT.NONE);
		selectBidOpeningTimeBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/switch.png"));
		selectBidOpeningTimeBtn.setText("切换时间");
		selectBidOpeningTimeBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				selectBidOpeningTimeAction();
			}
		});
		
		Composite decrypt_end_time_composite = new Composite(timeComposite, SWT.NONE);
		decrypt_end_time_composite.setLayoutData(new GridData(SWT.CENTER, SWT.FILL, true, true, 1, 1));
		decrypt_end_time_composite.setLayout(new GridLayout(3, false));
		menuFunctionUtils.addFunction(decrypt_end_time_composite, "DECRYPT_END_TIME");
		
		Label label_6 = new Label(decrypt_end_time_composite, SWT.WRAP);
		label_6.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true, false, 1, 1));
		label_6.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		label_6.setText(Messages.DecryptEndTime);
		
		decrypt_end_time_text = new Label(decrypt_end_time_composite, SWT.NONE);
		decrypt_end_time_text.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, true, 1, 1));
		decrypt_end_time_text.setFont(SWTResourceManager.getFont("微软雅黑", 25, SWT.NORMAL));
		decrypt_end_time_text.setForeground(ColorConstants.FONT_BLACK_COLOR);
		decrypt_end_time_text.setText("00:00:00");
		
		configDecEndTimeBtn = new ELink(decrypt_end_time_composite, SWT.NONE);
		configDecEndTimeBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/data.png"));
		configDecEndTimeBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				configDecEndTimeAction();
			}
		});
		
		importBtn = new ELink(timeComposite, SWT.NONE);
		importBtn.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		importBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/edit.png"));
		importBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				importBidOpeningPlanAction();
			}
		});
		importBtn.setText(MessageFormat.format(Messages.Button_importFormat, Messages.BidOpeningAgenda));
		menuFunctionUtils.addFunction(importBtn, "IMPORT");
		
//		decrptyProgressComposite = new DecrptyProgressComposite(composite_2, SWT.NONE);
//		GridData gd_decrptyProgressComposite = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
//		gd_decrptyProgressComposite.heightHint = 100;
//		decrptyProgressComposite.setLayoutData(gd_decrptyProgressComposite);
		tenderProjectService = new TenderProjectService();
		projectRuleService = new ProjectRuleService();
		init();
	}
	
	/**
	 * @Description: 初始化数据
	 * @author guoyr 
	 */
	private void init(){
		menu = projectAction.getMenu();
		menuFunctionUtils.initFunctionAuthority(menu);
		tenderProjectEntity = projectAction.getTenderProject();
		tenderProjectRuleEntity = projectAction.refreshTenderProjectRule();
		
		
		Date nowDate = NowTimeUtils.getNowDate();
		startCountTimeThread(nowDate);
		nowDataLabel.setText(DateUtils.getFormat(nowDate, Messages.Format_dateStr) +" "+NowTimeUtils.getWeakDay());
		
		getDecryptType();
		
		refreshNewProjectInfo();
		
		drawHallImage();
		
		final String keyCharacter = PropertiesUtils.getProperty("keyCharacter", "");
		if(null != keyCharacter && keyCharacter.length() > 0){
			final Listener keyListener = new Listener() {
				public void handleEvent(Event e) {
					if ((e.stateMask == SWT.CTRL) && e.keyCode == keyCharacter.charAt(0)){
						if(!configBidOpeningTimeBtn.isDisposed()){
//							configBidOpeningTime.setVisible(!configBidOpeningTime.getVisible());
							configSignEndTimeBtn.setVisible(!configSignEndTimeBtn.getVisible());
							configDecEndTimeBtn.setVisible(!configDecEndTimeBtn.getVisible());
						}
					}else if ((e.stateMask == SWT.CTRL) && e.keyCode == "t".charAt(0)){
//						configBidOpeningTimeBtn.setVisible(!configBidOpeningTimeBtn.getVisible());
					}else if ((e.stateMask == SWT.CTRL) && e.keyCode == "h".charAt(0)){
						isShowMeetingRoom = !isShowMeetingRoom;
					}else if ((e.stateMask == SWT.CTRL) && e.keyCode == "d".charAt(0)){
						
					}
				}
			};
			timeComposite.getDisplay().addFilter(SWT.KeyDown, keyListener);
			BidOpeningHallComposite.this.addListener(SWT.Activate, new Listener(){
				public void handleEvent(Event arg0) {
					timeComposite.getDisplay().removeFilter(SWT.KeyDown, keyListener);  
					timeComposite.getDisplay().addFilter(SWT.KeyDown, keyListener);
				}
			});
			addListener(SWT.Deactivate, new Listener(){
				public void handleEvent(Event arg0) {
					timeComposite.getDisplay().removeFilter(SWT.KeyDown, keyListener);  
				}
			});
			timeComposite.addDisposeListener(new DisposeListener() {
				public void widgetDisposed(DisposeEvent e) {
					timeComposite.getDisplay().removeFilter(SWT.KeyDown, keyListener);  
				}
			});
		}
		runPeopleGif.stopGifTimer();
	}
	
	private boolean isCompositeBidOpening(){
		boolean isComplateOpening = false;
		if(TenderProjectEnum.BID_OPENING_TWO_STAGE.equals(tenderProjectRuleEntity.getBidOpeningStage())){
			if(null != tenderProjectEntity.getParentId()){
				// 如果当前标段商务和技术标段都开完标了
				if(CommonEnum.COMPLETE.equals(tenderProjectEntity.getBusinessBidStatus()) && CommonEnum.COMPLETE.equals(tenderProjectEntity.getPriceBidStatus())){
					isComplateOpening = true;
				}
			}else {
				if(CommonEnum.YES.equals(tenderProjectEntity.getIsPack())){
					// 如果是按项目，则只判断经济标都完成解密了（经济标在商务标后面）
					isComplateOpening = tenderProjectService.isComplateProjectOpeningByStage(tenderProjectEntity.getId(), TenderProjectEnum.STAGE_PRICE);
				}else {
					isComplateOpening = CommonEnum.COMPLETE.equals(tenderProjectEntity.getPriceBidStatus());
				}
			}
			
		}else {
			if(null != tenderProjectEntity.getParentId()){
				isComplateOpening = CommonEnum.COMPLETE.equals(tenderProjectEntity.getBidOpeningStatus());
			}else {
				if(CommonEnum.YES.equals(tenderProjectEntity.getIsPack())){
					// 如果是按项目，则判断经济标都完成解密了（经济标在商务标后面）
					isComplateOpening = tenderProjectService.isComplateProjectOpeningByStage(tenderProjectEntity.getId(), TenderProjectEnum.STAGE_ALL);
				}else {
					isComplateOpening = CommonEnum.COMPLETE.equals(tenderProjectEntity.getBidOpeningStatus());
				}
			}
		}
		if(isComplateOpening){
			ActionLogUtils.addServerLog(tenderProjectEntity.getId(), "更新最新项目信息 ", tenderProjectEntity.getTenderNo() + tenderProjectEntity.getTenderName() , "已完成开标，不再自动同步最新项目信息" );
		}else {
			ActionLogUtils.addServerLog(tenderProjectEntity.getId(), "更新最新项目信息 ", tenderProjectEntity.getTenderNo() + tenderProjectEntity.getTenderName() , "未完成开标，自动同步最新项目信息" );
		}
		return isComplateOpening;
	}
	/**
	 * @Description: 同步最新投标信息
	 * @author guoyr 
	 */
	private void refreshNewProjectInfo(){
		
		if(MenuFunction.HIDE.equals(menuFunctionUtils.getAuthority(MenuFunctionEnum.SYNCHRONIZE_LATEST_OPENING_TIME))) {
			refreshOpeningOperate();
		}else {
			
			// 如果是从服务器上下载的项目，且没有完成开标，则 同步最新的项目信息
			if(null != tenderProjectEntity.getTransactionServerId() && !isCompositeBidOpening()){
				WidgetUtils.setControlVisible(confirmTimeComposite, false);
				WidgetUtils.setControlVisible(setOpeningTimeELink, false);
				refreshTimeComposite.layout();
				stackLayout.topControl = refreshTimeComposite;
				bidOpeningStageComposite.setVisible(false);
				stackComposite.layout();
				ProgressMessageListener listener = new ProgressMessageAdapter() {
					public void finish(final boolean downloadFlag) {
						tenderProjectEntity = projectAction.getTenderProject();
						tenderProjectRuleEntity = projectAction.refreshTenderProjectRule();
						Display.getDefault().syncExec(new Runnable(){
							public void run(){
								if(!stackComposite.isDisposed()){
									if(downloadFlag){
										refreshOpeningOperate();
									}else {
										refreshTime();
										messageLabel.setText("同步开标时间失败！");
										refreshConfirmTime();
									}
								}
							}
						});
					
					}
					
				};
				new NewUpdateTenderProjectInfoThread(tenderProjectEntity, listener).start();
			}else {
				refreshOpeningOperate();
			}
		}
	}
	
	private void confirmTimeAction() {
		refreshOpeningOperate();
//		refreshTime();
//		stackLayout.topControl = operateComposite;
//		stackComposite.layout();
	}
	
	private void refreshConfirmTime() {
		
		final Date bidOpeningTime = TenderProjectEnum.STAGE_PRICE.equals(BIDOPENING_STAGE) ?  tenderProjectRuleEntity.getPriceBidOpeningTime() : tenderProjectRuleEntity.getBidOpeningStartTime();
		final Date signEndTime = TenderProjectEnum.STAGE_PRICE.equals(BIDOPENING_STAGE) ? tenderProjectRuleEntity.getPriceSignEndTime():  tenderProjectRuleEntity.getSignEndTime();
		final Date decEndTime = TenderProjectEnum.STAGE_PRICE.equals(BIDOPENING_STAGE) ? tenderProjectRuleEntity.getPriceDecryptEndTime() : tenderProjectRuleEntity.getDecryptEndTime();
		
		WidgetUtils.setControlVisible(confirmELink, null != bidOpeningTime);
		WidgetUtils.setControlVisible(openingTimeTitle, null != bidOpeningTime);
		WidgetUtils.setControlVisible(openingTimeLabel, null != bidOpeningTime);
		WidgetUtils.setControlVisible(confirmSingEndTimeTitle, null != signEndTime);
		WidgetUtils.setControlVisible(confirmSingEndTimeLabel, null != signEndTime);
		WidgetUtils.setControlVisible(decryptEndTimeTitle, null != decEndTime);
		WidgetUtils.setControlVisible(decryptEndTimeLabel, null != decEndTime);
		WidgetUtils.setControlVisible(confirmTimeComposite, true);
		SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
		if(null != bidOpeningTime){
			openingTimeLabel.setText(format.format(bidOpeningTime));
		}
		if(null != signEndTime){
			confirmSingEndTimeLabel.setText(format.format(signEndTime));
		}
		if(null != decEndTime){
			decryptEndTimeLabel.setText(format.format(decEndTime));
		}
		confirmTimeComposite.layout();
		refreshTimeComposite.layout();
		stackLayout.topControl = refreshTimeComposite;
		stackComposite.layout();
	}
	/**
	 * @Description: 刷新
	 * @author guoyr 
	 */
	private void refreshOpeningOperate(){
		stackLayout.topControl = operateComposite;
		stackComposite.layout();
		if(TenderProjectEnum.BID_OPENING_TWO_STAGE.equals(tenderProjectRuleEntity.getBidOpeningStage())){
			WidgetUtils.setControlVisible(bidOpeningStageComposite, true);
			for(Control control : bidOpeningStageComposite.getChildren()){
				control.dispose();
			}
			ImageRaido stageBusTec = createBidOpeningStageBtn("商务、技术标", TenderProjectEnum.STAGE_BUS_TEC);
			ImageRaido stageprice = createBidOpeningStageBtn("经济标", TenderProjectEnum.STAGE_PRICE);
			if(TenderProjectEnum.STAGE_PRICE.equals(BIDOPENING_STAGE)) {
				curStageBtn = stageprice;
				BIDOPENING_STAGE = TenderProjectEnum.STAGE_PRICE;
			}else {
				curStageBtn = stageBusTec;
				BIDOPENING_STAGE = TenderProjectEnum.STAGE_BUS_TEC;
			}
			curStageBtn.setSelection(true);
		}else {
			WidgetUtils.setControlVisible(bidOpeningStageComposite, false);
			BIDOPENING_STAGE = TenderProjectEnum.STAGE_ALL;
		}
		refreshTime();
		bidOpeningStageComposite.layout();
		layout();
		autoEnterOpeningHall();
	}
	
	/**
	 * @Description: 开标阶段
	 * @author guoyr
	 * @param stageName
	 * @return 
	 */
	private ImageRaido createBidOpeningStageBtn(String stageName, final String stageType){
		
		final ImageRaido imageButton = new ImageRaido(bidOpeningStageComposite, SWT.NONE);
		imageButton.setFont(SWTResourceManager.getFont("微软雅黑", 19, SWT.NORMAL));
		imageButton.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		imageButton.setActiveForeground(SWTResourceManager.getColor(255, 153, 0));
		imageButton.setSelectionForeground(ColorConstants.FONT_BLUE_COLOR);
		imageButton.setImageSize(24);
		imageButton.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, true, 1, 1));
		imageButton.setText(stageName);
		imageButton.addSelectionListener(new SelectionAdapter() {
			public void widgetSelected(SelectionEvent e) {
				BIDOPENING_STAGE = stageType;
				if(null != curStageBtn && !curStageBtn.isDisposed()){
					curStageBtn.setSelection(false);
				}
				curStageBtn = imageButton;
				curStageBtn.setSelection(true);
				refreshTime();
//				showBidOpeningComposite();
			}
		});
		
		return imageButton;
//		final ImageButton bidOpeningTitle = new ImageButton(bidOpeningStageComposite, SWT.NONE);
//		bidOpeningTitle.setRightMargin(10);
//		bidOpeningTitle.setLeftMargin(10);
//		bidOpeningTitle.setTopMargin(5);
//		bidOpeningTitle.setBottomMargin(5);
//		bidOpeningTitle.setRightMargin(10);
//		bidOpeningTitle.setFont(SWTResourceManager.getFont("微软雅黑", 20, SWT.NORMAL));
//		bidOpeningTitle.setForeground(ColorConstants.NOTE_TIPS_COLOR);
//		bidOpeningTitle.setBackgroundColor(SWTResourceManager.getColor(245, 245, 245));
//		bidOpeningTitle.setActiveForeground(ColorConstants.SKIN_ACTIVE_FOREGROUND);
//		bidOpeningTitle.setActiveBackgroundColor(ColorConstants.SKIN_ACTIVE_BG);
//		bidOpeningTitle.setSelectionForeground(ColorConstants.SKIN_SELECTOIN_FOREGROUND);
//		bidOpeningTitle.setSelectionBgColor(ColorConstants.SKIN_BG);
//		bidOpeningTitle.setText(stageName);
//		bidOpeningTitle.addMouseListener(new MouseAdapter() {
//			@Override
//			public void mouseUp(MouseEvent e) {
//				BIDOPENING_STAGE = stageType;
//				if(null != curStageBtn && !curStageBtn.isDisposed()){
//					curStageBtn.setSelection(false);
//				}
//				curStageBtn = bidOpeningTitle;
//				curStageBtn.setSelection(true);
//				refreshTime();
////				showBidOpeningComposite();
//			}
//		});
//		return bidOpeningTitle;
	}
	
	/**
	 * @Description: 刷新开标界面
	 * @author guoyr 
	 */
	
	private void refreshTime(){
		Date bidOpeningTime = tenderProjectRuleEntity.getBidOpeningStartTime();
		Date signEndTime = tenderProjectRuleEntity.getSignEndTime();
		Date decEndTime = tenderProjectRuleEntity.getDecryptEndTime();
		if(TenderProjectEnum.STAGE_PRICE.equals(BIDOPENING_STAGE)){
			bidOpeningTime = tenderProjectRuleEntity.getPriceBidOpeningTime();
			signEndTime = tenderProjectRuleEntity.getPriceSignEndTime();
			decEndTime = tenderProjectRuleEntity.getPriceDecryptEndTime();
		}
		WidgetUtils.setControlVisible(selectBidOpeningTimeBtn, false);
		WidgetUtils.setControlVisible(configBidOpeningTimeBtn, false);
		WidgetUtils.setControlVisible(setOpeningTimeELink, false);
		if(null == tenderProjectEntity.getParentId() && CommonEnum.YES.equals(tenderProjectEntity.getIsPack())){
			List<Date> packsOpeningTimeList = projectRuleService.getProjectBidOpeningTime(tenderProjectEntity.getId(), BIDOPENING_STAGE);
			if(null != packsOpeningTimeList && packsOpeningTimeList.size() > 0){
				Date selectBidOpeningTime = null;
				if(null != bidOpeningTime){
					for(Date date : packsOpeningTimeList){
						if(date.getTime() == bidOpeningTime.getTime()){
							selectBidOpeningTime = date;
							break;
						}
					}
					if(null == selectBidOpeningTime){
						MessageDialog.openWarning(getShell(), "不存在"+DateUtils.getFormat(bidOpeningTime, "yyyy年MM月dd日 HH时mm分")+"的开标时间！");
					}
				}
				bidOpeningTime = selectBidOpeningTime;
				if(null == bidOpeningTime){
					bidOpeningTime = packsOpeningTimeList.get(0);
					if(null != BIDOPENING_STAGE && BIDOPENING_STAGE.equals(TenderProjectEnum.STAGE_PRICE)){
						tenderProjectRuleEntity.setPriceBidOpeningTime(bidOpeningTime);
						projectRuleService.updateAssignProperty(tenderProjectRuleEntity, new String[]{"priceBidOpeningTime"});
					}else {
						tenderProjectRuleEntity.setBidOpeningStartTime(bidOpeningTime);
						projectRuleService.updateAssignProperty(tenderProjectRuleEntity, new String[]{"bidOpeningStartTime"});
					}
				}
			}else {
				bidOpeningTime = null;
//				messageLabel.setText("未获取到开标时间！");
//				stackLayout.topControl = refreshTimeComposite;
//				stackComposite.layout();
			}
			WidgetUtils.setControlVisible(selectBidOpeningTimeBtn, packsOpeningTimeList.size() > 1);
		}
		
		if(null != bidOpeningTime){
			stackLayout.topControl = operateComposite;
			stackComposite.layout();
			bid_opening_start_time.setForeground(ColorConstants.FONT_BLACK_COLOR);
			bid_opening_start_time.setText(DateUtils.getFormat(bidOpeningTime, "HH:mm:ss"));
			// 如果是经济标开标，且配置可以修改开标时间，因为需要根据实际商务技术评标时间的情况随时修改开标时间，所以可以设置开标时间
			if(MenuFunction.SHOW.equals(menuFunctionUtils.getAuthority("EDIT_BID_OPENING_TIME"))){
				WidgetUtils.setControlVisible(configBidOpeningTimeBtn, true);
			}
		}else {
			bid_opening_start_time.setForeground(SWTResourceManager.getColor(240, 240, 240));
			bid_opening_start_time.setText("00:00:00");
			// 如果是经济标开标，且没有设置开标时间，因为需要根据实际商务技术评标时间的情况随时修改开标时间，所以可以设置开标时间
			if(TenderProjectEnum.STAGE_PRICE.equals(BIDOPENING_STAGE)){
				WidgetUtils.setControlVisible(configBidOpeningTimeBtn, true);
				WidgetUtils.setControlVisible(setOpeningTimeELink, true);
			}
			messageLabel.setText("未获取到开标时间！");
			refreshConfirmTime();
		}
//		if(null == signEndTime){
//			signEndTime = bidOpeningTime;
//		}
		configBidOpeningTimeBtn.getParent().layout();
		if(null != signEndTime){
			configSignEndTimeBtn.setVisible(false);
			sign_end_time_text.setForeground(ColorConstants.FONT_BLACK_COLOR);
			sign_end_time_text.setText(DateUtils.getFormat(signEndTime, "HH:mm:ss"));
			if(MenuFunction.SHOW.equals(menuFunctionUtils.getAuthority("EDIT_SIGN_END_TIME"))){
				configSignEndTimeBtn.setVisible(true);
			}
		}else {
			configSignEndTimeBtn.setVisible(true);
			sign_end_time_text.setForeground(SWTResourceManager.getColor(240, 240, 240));
			sign_end_time_text.setText("00:00:00");
		}
		if(null != decEndTime){
			configDecEndTimeBtn.setVisible(false);
			decrypt_end_time_text.setForeground(ColorConstants.FONT_BLACK_COLOR);
			decrypt_end_time_text.setText(DateUtils.getFormat(decEndTime, "HH:mm:ss"));
			if(MenuFunction.SHOW.equals(menuFunctionUtils.getAuthority("EDIT_DECRYPT_END_TIME"))){
				configDecEndTimeBtn.setVisible(true);
			}
		}else {
			configDecEndTimeBtn.setVisible(true);
			decrypt_end_time_text.setForeground(SWTResourceManager.getColor(240, 240, 240));
			decrypt_end_time_text.setText("00:00:00");
		}
	}
	
	
	/**
	 * @Description: 自动进入开标大厅
	 * @author guoyr 
	 */
	private void autoEnterOpeningHall(){
		new Thread(new Runnable(){
			public void run(){
				if(!TenderProjectEnum.BID_OPENING_TWO_STAGE.equals(tenderProjectRuleEntity.getBidOpeningStage()) && openingType.split(",").length == 1 ){
					if(checkEnterOpeningHall(true)){
						try {
							Thread.sleep(100);
						} catch (InterruptedException e) {
						}
						Display.getDefault().syncExec(new Runnable(){
							public void run(){
								if(!runPeopleGif.isDisposed()){
									entOpeningHallAction();
								}
							}
						});
					}
				}
			}
		}).start();
	}
	
	/**
	 * @Description: 直接进入大厅
	 * @author guoyr 
	 */
	private void enterOpeningAction() {
		if(!checkEnterOpeningHall(false)){
			return;
		}
		bidOpeningByTypeAction();
	}
	/**
	 * @Description: 进入开标大厅
	 * @author guoyr 
	 */
	private void entOpeningHallAction(){
		if(!checkEnterOpeningHall(false)){
			return;
		}
		runPeopleGif.startGifTimer();
		hallImageCanvas.moveAbove(runPeopleGif);
//		runPeopleGif.moveAbove(hallImageCanvas);
		if(!entOpeningHallBtn.getEnabled())return;
		runPeopleGif.setVisible(true);
		entOpeningHallBtn.setEnabled(false);
		entOpeningHallBtn.setVisible(false);
		final int step = runPeopleGif.getBounds().width / 5;
		
		final Point point = runPeopleGif.getLocation();
		final Point peoplePoint = runPeopleGif.getLocation();
		final Runnable runnable = new Runnable(){
			public void run(){
				if(!runPeopleGif.isDisposed()){
					point.x += step;
					peoplePoint.x = point.x;
					runPeopleGif.setLocation(peoplePoint);
				}else {
					enterHallX = -1;
				}
			}
		};
		new Thread(new Runnable(){
			public void run(){
				while(true){
					Display.getDefault().syncExec(runnable);
					if(peoplePoint.x > enterHallX){
						break;
					}
					try {
						Thread.sleep(200);
					} catch (InterruptedException e) {
					}
				}
				Display.getDefault().syncExec(new Runnable(){
					public void run(){
						if(!runPeopleGif.isDisposed()){
							entOpeningHallBtn.setEnabled(true);
							entOpeningHallBtn.setVisible(true);
							bidOpeningByTypeAction();
							peoplePoint.x = peopleX;
							runPeopleGif.setLocation(peoplePoint);
							runPeopleGif.stopGifTimer(0);
						}
					}
				});
			}
		}).start();
	}
	
	private void drawHallImage(){
		final Image hallImage = ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/hall.png");
		hallImageCanvas.addPaintListener(new PaintListener(){
			public void paintControl(PaintEvent arg0) {
				arg0.gc.drawImage(hallImage, 0, 0, hallImage.getBounds().width, hallImage.getBounds().height, 0,  0, hallImageCanvas.getBounds().width, hallImageCanvas.getBounds().height);
			}
		});
		hallCcomposite.layout();
	}
	
	private void resizeRunPeople(){
		Rectangle hallImageRectangle = hallCcomposite.getBounds();
		if(hallImageRectangle.width> 0){
			Point targetPoint = getZoomPoint(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/hall.png"), hallCcomposite.getBounds().width, hallCcomposite.getBounds().height);
			FormData fd_hallImage = (FormData)hallImageCanvas.getLayoutData();
			fd_hallImage.left = new FormAttachment(40, 0);
			fd_hallImage.right = new FormAttachment(40, targetPoint.x);
			fd_hallImage.top = new FormAttachment(100, 0 - targetPoint.y);
			
			int peopleHeight = targetPoint.y/3;
			int peopleWidth = (int)(220/(double)300 * peopleHeight);
			FormData fd_runPeopleGif = (FormData)runPeopleGif.getLayoutData();
			fd_runPeopleGif.top = new FormAttachment(100, 0-peopleHeight -28);
			fd_runPeopleGif.bottom = new FormAttachment(100 , -28);
//			fd_runPeopleGif.left = new FormAttachment(100, -1*(hallImageWidth + (3*peopleWidth)));
			fd_runPeopleGif.left = new FormAttachment(hallImageCanvas, -1*(3*peopleWidth), SWT.LEFT);
			fd_runPeopleGif.right = new FormAttachment(hallImageCanvas, -1*(2*peopleWidth), SWT.LEFT);
			
			entOpeningHallBtn.moveAbove(runPeopleGif);
			FormData fd_enterBtn = (FormData)entOpeningHallBtn.getLayoutData();
			fd_enterBtn.left = new FormAttachment(runPeopleGif, 0, SWT.LEFT);
			hallCcomposite.layout();
			peopleX = runPeopleGif.getLocation().x;
			enterHallX =  entOpeningHallBtn.getLocation().x;
		}
	}
	public Point getZoomPoint(Image image, int width, int height){
		
		double tarWidth = width;
		double tarHeight = height;
		int imageWidth = image.getImageData().width;
		int imageHeight = image.getImageData().height;
		if (imageWidth / imageHeight >= width / height) {
			if (imageWidth > width) {
				tarWidth = width;
				tarHeight = (1d * imageHeight * width) / imageWidth;
			} else {
				// tarWidth = imageWidth;
				// tarHeight = imageHeight;
				if (1d * height / imageHeight > 1d * width / imageWidth) {
					tarWidth = width;
					tarHeight = (1d * imageHeight * width) / imageWidth;
				} else {
					tarHeight = height;
					tarWidth = (1d * imageWidth * height) / imageHeight;
					
				}
			}
			
		} else {
			if (imageHeight > height) {
				tarHeight = height;
				tarWidth = (1d * imageWidth * height) / imageHeight;
			} else {
				// tarWidth = imageWidth;
				// tarHeight = imageHeight;
				if (1d * height / imageHeight > 1d * width / imageWidth) {
					tarWidth = width;
					tarHeight = (1d * imageHeight * width) / imageWidth;
				} else {
					tarHeight = height;
					tarWidth = (1d * imageWidth * height) / imageHeight;
					
				}
			}
			
		}
		return new Point((int)tarWidth, (int)tarHeight);
	}	
	

	/**
	 * @Description: 切换开标时间
	 * @author guoyr 
	 */
	private void selectBidOpeningTimeAction(){
		if(selectBidOpeningTimeBtn.getVisible() && selectBidOpeningTimeBtn.getEnabled()){
			Date bidOpeningTime = tenderProjectRuleEntity.getBidOpeningStartTime();
			if(null != BIDOPENING_STAGE && BIDOPENING_STAGE.equals(TenderProjectEnum.STAGE_PRICE)){
				bidOpeningTime = tenderProjectRuleEntity.getPriceBidOpeningTime();
			}
			final ToolsShell moreToolsShell = new ToolsShell(getShell());
			final Composite selectOpeningTimeComposite = moreToolsShell.addToolBar("选择开标时间", null, false);
			selectOpeningTimeComposite.setLayout(new GridLayout(1, false));
			List<Date> dateTimeList = projectRuleService.getProjectBidOpeningTime(tenderProjectEntity.getId(), BIDOPENING_STAGE);
			for(final Date date : dateTimeList){
				ImageButton dateButton = new ImageButton(selectOpeningTimeComposite, SWT.NONE);
				dateButton.setLeftMargin(15);
				dateButton.setRightMargin(15);
//				dateButton.setBackground(ColorConstants.SKIN_BG);
				dateButton.setBorderColor(ColorConstants.BORDER_LINE_COLOR);
				dateButton.setActiveBgColor(ColorConstants.SKIN_BG);
				dateButton.setFont(SWTResourceManager.getFont("微软雅黑", 11, SWT.NORMAL));
				dateButton.setForeground(ColorConstants.FONT_BLACK_COLOR);
				dateButton.setActiveForeground(ColorConstants.SKIN_FOREGROUND);
				dateButton.setText(DateUtils.getFormat(date, "yyyy-MM-dd HH:mm:ss"));
				if(null != bidOpeningTime && bidOpeningTime.getTime() == date.getTime()){
					dateButton.setSelection(true);
				}
				dateButton.addMouseListener(new MouseAdapter() {
					@Override
					public void mouseUp(MouseEvent e) {
						StringBuilder message = new StringBuilder();
						message.append("确认要选择开标时间为"+DateUtils.getFormat(date, "yyyy年MM月dd日 HH时mm分")+"的"+com.gx.obe.components.core.I18N.getString(I18NEnum.SUBPACKAGE, tenderProjectEntity.getTenderType())+"进行开标吗？");
						ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), null, message.toString() , null);
						confirmDialog.addButton("确认", "01", SWTResourceManager.getColor(77, 163, 19));
						confirmDialog.addCancel(Messages.Button_close, SWTResourceManager.getColor(255, 153, 0));
						confirmDialog.setTipsColor(SWTResourceManager.getColor(255, 0, 0));
						confirmDialog.setTips("注：请务必确认所选择开标时间与项目公告中的时间保持一致（以公告时间为准）");
						confirmDialog.open();
						if("01".equals(confirmDialog.getClickStatus())){
							if(null != BIDOPENING_STAGE && BIDOPENING_STAGE.equals(TenderProjectEnum.STAGE_PRICE)){
								tenderProjectRuleEntity.setPriceBidOpeningTime(date);
								projectRuleService.updateAssignProperty(tenderProjectRuleEntity, new String[]{"priceBidOpeningTime"});
							}else {
								tenderProjectRuleEntity.setBidOpeningStartTime(date);
								projectRuleService.updateAssignProperty(tenderProjectRuleEntity, new String[]{"bidOpeningStartTime"});
							}
							refreshTime();
						}
						if (!moreToolsShell.isDisposed()) {
							moreToolsShell.close();
						}
					}
				});
			}
			moreToolsShell.pack();
			SwtUtils.setCenter(moreToolsShell);
			moreToolsShell.open();
		}
	}
	

	/**
	 * @Description: 设置开标时间
	 * @author guoyr 
	 */
	private void configBidOpeningTimeAction(){
		Date bidOpeningTime = tenderProjectRuleEntity.getBidOpeningStartTime();
		Date decEndTime = tenderProjectRuleEntity.getDecryptEndTime();
		if(null != BIDOPENING_STAGE && BIDOPENING_STAGE.equals(TenderProjectEnum.STAGE_PRICE)){
			bidOpeningTime = tenderProjectRuleEntity.getPriceBidOpeningTime();
			decEndTime = tenderProjectRuleEntity.getPriceDecryptEndTime();
		}
		final Date _decEndTime = decEndTime;
		final CalendarDialog timeDialog = new CalendarDialog(getShell(),  bidOpeningTime, null, null);
		timeDialog.setCallBack(new CallBack(){
			public void callBackDate(final Date date) {
				if(null == date)return;
				if(null != _decEndTime && date.getTime() >= _decEndTime.getTime()){
					MessageDialog.openWarning(timeDialog.getShell(), TenderProjectEnum.getOpenBidEnum(tenderProjectEntity.getPhaseType())+"时间必须在解密截止时间之前！");
					return;
				}
				if(!bid_opening_start_time.isDisposed()){
					StringBuilder message = new StringBuilder();
					message.append(MessageFormat.format(Messages.Tips_confirmSetBidOpeningTime, DateUtils.getFormat(date, Messages.Format_dateMinuteCNStr)));
					ConfirmDialog confirmDialog = new ConfirmDialog(timeDialog.getShell(), null, message.toString() , null);
					confirmDialog.addButton(Messages.Button_confirm, "01", SWTResourceManager.getColor(77, 163, 19));
					confirmDialog.addCancel(Messages.Button_close, SWTResourceManager.getColor(255, 153, 0));
					confirmDialog.setTipsColor(SWTResourceManager.getColor(255, 0, 0));
					confirmDialog.setTips(MessageFormat.format(Messages.Tips_changeDealine, com.gx.obe.components.core.I18N.getString(I18NEnum.SUPPLIERNAME, tenderProjectEntity.getTenderType())));
					confirmDialog.open();
					if(!"01".equals(confirmDialog.getClickStatus())){
						return;
					}
					
					String[] params = new String[]{"bidOpeningStartTime"};
					if(null != BIDOPENING_STAGE && BIDOPENING_STAGE.equals(TenderProjectEnum.STAGE_PRICE)){
						tenderProjectRuleEntity.setPriceBidOpeningTime(date);
						params[0] = "priceBidOpeningTime";
					}else {
						tenderProjectRuleEntity.setBidOpeningStartTime(date);
					}
					ActionLogUtils.addServerLog(tenderProjectEntity.getId(),"修改开标时间", new Params("tenderNo", tenderProjectEntity.getTenderNo()).add(params[0], date));
					projectRuleService.updateAssignProperty(tenderProjectRuleEntity, params);
					if(null == tenderProjectEntity.getParentId() && CommonEnum.YES.equals(tenderProjectEntity.getIsPack())){			 
						projectRuleService.updateAssignPropertyByProjectId(tenderProjectEntity.getId(), tenderProjectRuleEntity, params);
					}
					refreshOpeningOperate();
				}
			}
		});
		timeDialog.open();
	}
	
	/**
	 * @Description: 设置签到时间
	 * @author guoyr 
	 */
	private void configSignEndTimeAction(){
		Date signEndTime = tenderProjectRuleEntity.getSignEndTime();
		Date bidOpeningTime = tenderProjectRuleEntity.getBidOpeningStartTime();
		
		
		if(null != BIDOPENING_STAGE && BIDOPENING_STAGE.equals(TenderProjectEnum.STAGE_PRICE)){
			signEndTime = tenderProjectRuleEntity.getPriceSignEndTime();
			bidOpeningTime = tenderProjectRuleEntity.getPriceBidOpeningTime();
		}
		if(null == bidOpeningTime){
			MessageDialog.openShortMessage(Messages.Tips_noBidOpeningTime);
			return;
		}
		
		final Date openingStartTime = bidOpeningTime;
		final CalendarDialog timeDialog = new CalendarDialog(getShell(),  signEndTime, null, bidOpeningTime);
		timeDialog.setCallBack(new CallBack(){
			public void callBackDate(final Date date) {
				if(!bid_opening_start_time.isDisposed()){
					
					StringBuilder message = new StringBuilder();
					if(null != date ){
						if(date.getTime() > openingStartTime.getTime()){
							message.append(Messages.Tips_signTimeAfterOpeningTime);
							message.append("\r\n");
						}
						message.append(MessageFormat.format(Messages.Tips_confirmSetSigningDealine, DateUtils.getFormat(date, Messages.Format_dateMinuteCNStr)));
					}else {
						message.append(Messages.Tips_confirmCancelSigningDealine);
					}
					ConfirmDialog confirmDialog = new ConfirmDialog(timeDialog.getShell(), null, message.toString() , null);
					confirmDialog.addButton(Messages.Button_confirm, "01", SWTResourceManager.getColor(77, 163, 19));
					confirmDialog.addCancel(Messages.Button_close, SWTResourceManager.getColor(255, 153, 0));
					confirmDialog.setTipsColor(SWTResourceManager.getColor(255, 0, 0));
					confirmDialog.setTips(MessageFormat.format(Messages.Tips_changeDealine, com.gx.obe.components.core.I18N.getString(I18NEnum.SUPPLIERNAME, tenderProjectEntity.getTenderType())));
					confirmDialog.open();
					if(!"01".equals(confirmDialog.getClickStatus())){
						return;
					}
					
					String[] params = new String[]{"signEndTime"};
					if(null != BIDOPENING_STAGE && BIDOPENING_STAGE.equals(TenderProjectEnum.STAGE_PRICE)){
						tenderProjectRuleEntity.setPriceSignEndTime(date);
						params[0] = "priceSignEndTime";
					}else {
						tenderProjectRuleEntity.setSignEndTime(date);
					}
					ActionLogUtils.addServerLog(tenderProjectEntity.getId(),"修改签到截止时间", new Params("tenderNo", tenderProjectEntity.getTenderNo()).add(params[0], date));
					projectRuleService.updateAssignProperty(tenderProjectRuleEntity, params);
					if(null == tenderProjectEntity.getParentId() && CommonEnum.YES.equals(tenderProjectEntity.getIsPack())){			 
						projectRuleService.updateAssignPropertyByProjectId(tenderProjectEntity.getId(), tenderProjectRuleEntity, params);
					}
					refreshTime();
				}
			}
		});
		timeDialog.open();
	}
	/**
	 * @Description: 解密截止时间
	 * @author guoyr 
	 */
	private void configDecEndTimeAction(){
		Date bidOpeningTime = tenderProjectRuleEntity.getBidOpeningStartTime();
		Date decEndTime = tenderProjectRuleEntity.getDecryptEndTime();
		if(null != BIDOPENING_STAGE && BIDOPENING_STAGE.equals(TenderProjectEnum.STAGE_PRICE)){
			decEndTime = tenderProjectRuleEntity.getPriceDecryptEndTime();
			bidOpeningTime = tenderProjectRuleEntity.getPriceBidOpeningTime();
		}
		final Date _bidOpeningTime = bidOpeningTime;
		final CalendarDialog timeDialog = new CalendarDialog(getShell(),  decEndTime, null, null);
		timeDialog.setCallBack(new CallBack(){
			public void callBackDate(final Date date) {
				// 解密截止时间必须设置在解密时间10分种之后，否则有可能完成不了解密
				if(null != date && null != _bidOpeningTime && date.getTime() <= _bidOpeningTime.getTime()){
					MessageDialog.openWarning(getShell(), Messages.Tips_decryptDealineBeforeOpeningTime);
					return;
				}
				if(!decrypt_end_time_text.isDisposed()){
					StringBuilder message = new StringBuilder();
					if(null != date ){
						message.append(MessageFormat.format(Messages.Tips_decryptUseTime, DateUtils.timeSpan(date.getTime() - _bidOpeningTime.getTime())));
						message.append("\r\n");
						if(date.getTime() - _bidOpeningTime.getTime()< 1000 * 60 * 10){
							message.append(Messages.Tips_setReasonableDecryptDeadline);
						}
						message.append(MessageFormat.format(Messages.Tips_confirmSetDecryptdeadline, DateUtils.getFormat(date, Messages.Format_dateMinuteCNStr)));
					}else {
						message.append(Messages.Tips_confirmCancelDecryptdeadline);
					}
					ConfirmDialog confirmDialog = new ConfirmDialog(timeDialog.getShell(), null, message.toString() , null);
					confirmDialog.addButton(Messages.Button_confirm, "01", SWTResourceManager.getColor(77, 163, 19));
					confirmDialog.addCancel(Messages.Button_close, SWTResourceManager.getColor(255, 153, 0));
					confirmDialog.setTipsColor(SWTResourceManager.getColor(255, 0, 0));
					confirmDialog.setTips(MessageFormat.format(Messages.Tips_changeDealine, com.gx.obe.components.core.I18N.getString(I18NEnum.SUPPLIERNAME, tenderProjectEntity.getTenderType())));
					confirmDialog.open();
					if(!"01".equals(confirmDialog.getClickStatus())){
						return;
					}
					
					String[] params = new String[]{"decryptEndTime"};
					if(null != BIDOPENING_STAGE && BIDOPENING_STAGE.equals(TenderProjectEnum.STAGE_PRICE)){
						params[0] = "priceDecryptEndTime";
						tenderProjectRuleEntity.setPriceDecryptEndTime(date);
					}else {
						tenderProjectRuleEntity.setDecryptEndTime(date);
					}
					ActionLogUtils.addServerLog(tenderProjectEntity.getId(),"修改解密截止时间", new Params("tenderNo", tenderProjectEntity.getTenderNo()).add(params[0], date));
					
					projectRuleService.updateAssignProperty(tenderProjectRuleEntity, params);
					if(null == tenderProjectEntity.getParentId() && CommonEnum.YES.equals(tenderProjectEntity.getIsPack())){			 
						projectRuleService.updateAssignPropertyByProjectId(tenderProjectEntity.getId(), tenderProjectRuleEntity, params);
					}
					refreshTime();
				}
			}
		});
		timeDialog.open();
	}
	
	/**
	 * @Description: 启动倒计时线程
	 * @author guoyr
	 */
	private void startCountTimeThread(final Date nowDate){
		countDownTime = true;
		showCountDownTime();
		Thread showCountDownTimeThread = new Thread(new Runnable(){
			final String[] time = new String[]{"","", "","", "", ""};//00:00:00";
			public void run(){
				long millis = nowDate.getTime();
				Calendar calendar = Calendar.getInstance();
				SimpleDateFormat timeFormat = new SimpleDateFormat("HHmmss");
				
				final Runnable timeRunnable = new Runnable(){
					public void run(){
						if(!hour_first_label.isDisposed()){
							hour_first_label.setData(time[0]);
							hour_second_label.setData(time[1]);
							hour_first_label.redraw();
							hour_second_label.redraw();
							minute_first_label.setData(time[2]);
							minute_second_label.setData(time[3]);
							minute_first_label.redraw();
							minute_second_label.redraw();
							seconds_first_label.setData(time[4]);
							seconds_second_label.setData(time[5]);
							seconds_first_label.redraw();
							seconds_second_label.redraw();
						}
					}
				};
				String timeStr = "000000";
				while(countDownTime){
					calendar.setTimeInMillis(millis);
					timeStr = timeFormat.format(calendar.getTime());
//					time[0] = timeStr.substring(0, 1);
//					time[1] = timeStr.substring(1, 2);
//					time[2] = timeStr.substring(2, 3);
//					time[3] = timeStr.substring(3, 4);
//					time[4] = timeStr.substring(4, 5);
//					time[5] = timeStr.substring(5, 6);
					for(int i = 0; i < timeStr.length() ; i++){
						time[i] = timeStr.substring(i, i+1);
					}
					Display.getDefault().syncExec(timeRunnable);
					try {
						Thread.sleep(1000);
					} catch (InterruptedException e) {
					}
					millis += 1000;
				}
//				calendar.setTimeInMillis(millis);
//				calendar.get(Calendar.HOUR_OF_DAY);
			
			}
		});
		showCountDownTimeThread.setName(tenderProjectEntity.getTenderName() + "显示时钟线程");
		showCountDownTimeThread.start();
		
	}

	/**
	 * @Description: 显示倒计时
	 * @author guoyr
	 */
	private void showCountDownTime(){
		Image image_0 = imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/time/white_0.png");
		Image timeBg = ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/time/time_blue_bg.png");
		final int x = (timeBg.getBounds().width - image_0.getBounds().width)/2 + hour_second_label.getLeftMargin();
		final int y = (timeBg.getBounds().height - image_0.getBounds().height)/2 + hour_second_label.getTopMargin();
		hour_first_label.addPaintListener(new NumPaintListener(x, y));
		hour_second_label.addPaintListener(new NumPaintListener(x, y));
		minute_first_label.addPaintListener(new NumPaintListener(x, y));
		minute_second_label.addPaintListener(new NumPaintListener(x, y));
		seconds_first_label.addPaintListener(new NumPaintListener(x, y));
		seconds_second_label.addPaintListener(new NumPaintListener(x, y));
	}
	
	class NumPaintListener implements PaintListener{

		private int x;
		private int y;
		public NumPaintListener(int x, int y){
			this.x = x;
			this.y = y;
		}
		public void paintControl(PaintEvent arg0) {
			CLabel label = ((CLabel)arg0.getSource());
			String num = (String)label.getData();
			if(null == num){
				num = "0";
			}
			Image timeImage = imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/time/white_"+num+".png");
			arg0.gc.drawImage(timeImage, x, y);
//			arg0.gc.drawImage(timeImage, (arg0.width-timeImage.getBounds().width)/2, (arg0.height-timeImage.getBounds().height)/2);
			arg0.gc.dispose();
		}
	}

	private boolean checkEnterOpeningHall(boolean isAuto){
//		Date signEndTime = tenderProjectRuleEntity.getSignEndTime();
//		Date decEndTime = tenderProjectRuleEntity.getDecryptEndTime();
		if(null != BIDOPENING_STAGE && BIDOPENING_STAGE.equals(TenderProjectEnum.STAGE_PRICE)){
//			signEndTime = tenderProjectRuleEntity.getPriceSignEndTime();
//			decEndTime = tenderProjectRuleEntity.getPriceDecryptEndTime();
			if(null == tenderProjectRuleEntity.getPriceBidOpeningTime()){
				if(!isAuto){
					MessageDialog.openShortMessage(Messages.Tips_noBidOpeningTime);
				}
				return false;
			}
			
		}else {
			if(null == tenderProjectRuleEntity.getBidOpeningStartTime()){
				if(!isAuto){
					MessageDialog.openShortMessage(Messages.Tips_noBidOpeningTime);
				}
				return false;
			}
		}
		
		if(openingType.split(",").length > 1){
			SelectDecryptTypeDialog dialog = new SelectDecryptTypeDialog(getShell(), openingType.split(","));
			dialog.setTitle(MessageFormat.format(Messages.Tips_pleaseSelect, Messages.Button_decryptType));
			dialog.open();
			bidOpeningType = dialog.getSelectOpeningType();
		}else {
			bidOpeningType = openingType;
		}
		
		if(null == bidOpeningType || bidOpeningType.length() == 0){
			return false;
		}
		
		return true;
	}
	
	/**
	 * @Description: 获得解密方式
	 * @author guoyr 
	 */
	private void getDecryptType(){
		openingType = tenderProjectRuleEntity.getDecodeType();
		if(null != openingType && openingType.length() > 0) {
			return;
		}
		openingType = PropertiesUtils.getProperty(ConfigConstants.DECRYPT_TYPE, Constants.DECRYPT_LOCAL+ "," + /**Constants.DECRYPT_LOCAL_SELF + ","+ **/ Constants.DECRYPT_REMOTE + "," + Constants.DECRYPT_FOCUS);
		StringBuilder openingTypeFromDb = new StringBuilder();
		if(MenuFunction.SHOW.equals(menuFunctionUtils.getAuthority("DECRYPT_LOCAL"))){
			openingTypeFromDb.append(Constants.DECRYPT_LOCAL);
		}
		if(MenuFunction.SHOW.equals(menuFunctionUtils.getAuthority("DECRYPTR_EMOTE"))){
			if(openingTypeFromDb.length() > 0){
				openingTypeFromDb.append(",");
			}
			openingTypeFromDb.append(Constants.DECRYPT_REMOTE);
			
		}
		if(MenuFunction.SHOW.equals(menuFunctionUtils.getAuthority("DECRYPT_CENTRALIZE"))){
			if(openingTypeFromDb.length() > 0){
				openingTypeFromDb.append(",");
			}
			openingTypeFromDb.append(Constants.DECRYPT_FOCUS);
			
		}
		if(openingTypeFromDb.length() > 0){
			openingType = openingTypeFromDb.toString();
		}
	}
	/**
	 * @Description: 设置解密方式
	 * @author guoyr
	 * @param bidOpeningType 
	 */
	private void bidOpeningByTypeAction(){
//		String tableTitle = null;
//		if(TenderProjectEnum.STAGE_BUS_TEC.equals(BIDOPENING_STAGE)){
//			tableTitle = "技术、技术标";
//		}else if(TenderProjectEnum.STAGE_PRICE.equals(BIDOPENING_STAGE)){
//			tableTitle = Messages.EconomicBid;
//		}
		if(Constants.DECRYPT_REMOTE.equals(bidOpeningType)){
			MeetingRoomListener bidOpeningRemoteDecryptShell = null;
			if("01".equals(PropertiesUtils.getProperty(ConfigConstants.ROOM_USE_WIDEN_SCREEN_, "00"))){
				bidOpeningRemoteDecryptShell = new BidOpeningRoomWidenShell(getShell());
			}else {
				bidOpeningRemoteDecryptShell = new BidOpeningRoomShell(getShell());
			}
			Composite parentComposite = bidOpeningRemoteDecryptShell.getLoadParent();
			parentComposite.setData("tenderProjectEntity", tenderProjectEntity);
			parentComposite.setData("bidopeningStage", BIDOPENING_STAGE);
			parentComposite.setData("meetingRoomListener", bidOpeningRemoteDecryptShell);
			parentComposite.setData("menuFunctions", menuFunctionUtils);
			if(null == tenderProjectEntity.getParentId() && null != tenderProjectEntity.getIsPack() && tenderProjectEntity.getIsPack().equals(CommonEnum.YES)){
                BidOpeningRemoteByProjectComposite bidOpeningRemoteComposite = new BidOpeningRemoteByProjectComposite(parentComposite, SWT.NONE);
                bidOpeningRemoteComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
			}else {
                BidOpeningRemoteComposite bidOpeningRemoteComposite = new BidOpeningRemoteComposite(parentComposite, SWT.NONE);
                bidOpeningRemoteComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
			}
			parentComposite.layout();
			bidOpeningRemoteDecryptShell.open();
			
		}else {//if(Constants.DECRYPT_FOCUS.equals(bidOpeningType)){
			BidOpeningRoomShell bidOpeningRemoteDecryptShell = new BidOpeningRoomShell(getShell());
			Composite parentComposite = bidOpeningRemoteDecryptShell.getLoadParent();
			parentComposite.setData("isFocus", "1");
			parentComposite.setData("tenderProjectEntity", tenderProjectEntity);
			parentComposite.setData("bidopeningStage", BIDOPENING_STAGE);
			parentComposite.setData("meetingRoomListener", bidOpeningRemoteDecryptShell);
			parentComposite.setData("menuFunctions", menuFunctionUtils);
			if(null == tenderProjectEntity.getParentId() && null != tenderProjectEntity.getIsPack() && tenderProjectEntity.getIsPack().equals(CommonEnum.YES)){
                BidOpeningRemoteByProjectComposite bidOpeningRemoteComposite = new BidOpeningRemoteByProjectComposite(parentComposite, SWT.NONE);
                bidOpeningRemoteComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
			}else {
                BidOpeningRemoteComposite bidOpeningRemoteComposite = new BidOpeningRemoteComposite(parentComposite, SWT.NONE);
                bidOpeningRemoteComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
			}
			parentComposite.layout();
			bidOpeningRemoteDecryptShell.open();
			
		}
		refreshTime();
	}
	/**
	 * @Description: 编辑开标议程
	 * @author guoyr 
	 */
	private void importBidOpeningPlanAction(){
		BidOpeningPlanDialog dialog = new BidOpeningPlanDialog(getShell(), tenderProjectRuleEntity, BIDOPENING_STAGE);
		dialog.open();
	}
	
	/**
	 * @Description: 打开开标议程
	 * @author guoyr 
	 */
//	private void openOpeningPlanAction(){
//		if(null != BIDOPENING_STAGE && BIDOPENING_STAGE.equals(TenderProjectEnum.STAGE_PRICE)){
//			if(null == tenderProjectRuleEntity.getPriceBidOpeningTime()){
//				MessageDialog.openShortMessage("未设置"+(null != curStageBtn && !curStageBtn.isDisposed() ? curStageBtn.getText() : Messages.EconomicBid)+TenderProjectEnum.getOpenBidEnum(tenderProjectEntity.getPhaseType())+"时间！");
//				return;
//			}
//			
//		}else {
//			if(null == tenderProjectRuleEntity.getBidOpeningStartTime()){
//				MessageDialog.openShortMessage("未设置"+(null != curStageBtn && !curStageBtn.isDisposed() ? curStageBtn.getText() : "")+TenderProjectEnum.getOpenBidEnum(tenderProjectEntity.getPhaseType())+"时间！");
//				return;
//			}
//		}
//		Date bidOpeningTime = tenderProjectRuleEntity.getBidOpeningStartTime();
//		String bidOpeningAgenda = tenderProjectRuleEntity.getBidOpeningAgenda();
//		if(null != BIDOPENING_STAGE && BIDOPENING_STAGE.equals(TenderProjectEnum.STAGE_PRICE)){
//			if(null != tenderProjectRuleEntity.getPriceBidOpeningTime()){
//				bidOpeningTime = tenderProjectRuleEntity.getPriceBidOpeningTime();
//			}
//			if(null != tenderProjectRuleEntity.getPriceBidOpeningAgenda() && tenderProjectRuleEntity.getPriceBidOpeningAgenda().length() > 0){
//				bidOpeningAgenda = tenderProjectRuleEntity.getPriceBidOpeningAgenda();
//			}
//		}
//		BidOpeningCountDownShell countDownShell = new BidOpeningCountDownShell(getShell(), tenderProjectEntity, bidOpeningTime, bidOpeningAgenda);
//		countDownShell.open();
//	}
	
	private void dispositeAction(){
		countDownTime = false;
		imageResolver.disposite();
		enterHallX = -1;
	}
	
	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}
}
