package com.gx.obe.opening.composite;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;

import com.gx.obe.ColorConstants;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.inter.ProjectStatusCount;
import com.gx.obe.common.widget.listener.StatusCountListener;
import com.gx.obe.message.Messages;
import com.gx.obe.opening.Activator;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

/** 
 * @Description: 按项目开标的统计
 * @author guoyr 
 */
public class BidOpeningPackCountComposite extends Composite implements ProjectStatusCount{

	private Label titleLabel;
	private Label countLabel;
	private StatusCountListener listener;
//	private Label selectionLabel;
	private Runnable countRunnable;
	private Label unitLabel;
	private CLabel changeType;
	private int curIndex = 0;
	private int curCount = 0;
	private int maxNum = 2;
	private List<Map<String, String>> statusList = new ArrayList<Map<String, String>>();
	private int[] counts = new int[]{0};
	private boolean[] visible;
	private Color whiteColor = Display.getCurrent().getSystemColor(SWT.COLOR_WHITE);
	private Color errorColor = SWTResourceManager.getColor(SWT.COLOR_RED);//SWTResourceManager.getColor(255, 153, 153);
	private static int DRAW_FLAGS = SWT.DRAW_MNEMONIC | SWT.DRAW_TAB | SWT.DRAW_TRANSPARENT | SWT.DRAW_DELIMITER;
	private int errors = -1;

	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public BidOpeningPackCountComposite(Composite parent, int style) {
		super(parent, style);
		setBackgroundMode(SWT.INHERIT_FORCE);
		setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gridLayout = new GridLayout(4, false);
		gridLayout.marginWidth = 2;
		gridLayout.marginLeft = 0;
		gridLayout.marginHeight = 2;
		gridLayout.horizontalSpacing = 0;
		setLayout(gridLayout);
		
		Composite titleComposite = new Composite(this, SWT.NONE);
		titleComposite.setBackground(SWTResourceManager.getColor(242, 242, 242));
		titleComposite.setBackgroundMode(SWT.INHERIT_FORCE);
		GridData gd_titleComposite = new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1);
		gd_titleComposite.widthHint = 25;
		titleComposite.setLayoutData(gd_titleComposite);
		GridLayout gl_titleComposite = new GridLayout(1, false);
		gl_titleComposite.marginWidth = 0;
		titleComposite.setLayout(gl_titleComposite);
		
		titleLabel = new Label(titleComposite, SWT.WRAP | SWT.CENTER);
//		titleLabel.setForeground(SWTResourceManager.getColor(23, 101, 174));
		titleLabel.setForeground(ColorConstants.FONT_BLACK_COLOR);
		titleLabel.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.BOLD));
		titleLabel.setText(Messages.Opening_tendered);
		titleLabel.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, true, 1, 1));
		
		Composite composite = new Composite(this, SWT.NONE);
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_composite = new GridLayout(1, false);
		gl_composite.verticalSpacing = 0;
		gl_composite.marginHeight = 0;
		gl_composite.horizontalSpacing = 0;
		gl_composite.marginWidth = 0;
		composite.setLayout(gl_composite);
		
		countLabel = new Label(composite, SWT.CENTER);
		countLabel.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		countLabel.setForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		countLabel.setFont(SWTResourceManager.getFont("微软雅黑", 8, SWT.NORMAL));
//		countLabel.setText(" 0 ");
		
//		selectionLabel = new Label(composite, SWT.NONE);
//		GridData gd_label = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
//		gd_label.heightHint = 1;
//		gd_label.widthHint = 50;
//		selectionLabel.setLayoutData(gd_label);
		
		Composite composite_1 = new Composite(this, SWT.NONE);
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1));
		GridLayout gl_composite_1 = new GridLayout(1, false);
		gl_composite_1.marginWidth = 0;
		gl_composite_1.marginHeight = 0;
		gl_composite_1.marginBottom = 5;
		gl_composite_1.verticalSpacing = 0;
		composite_1.setLayout(gl_composite_1);
		
		changeType = new CLabel(composite_1, SWT.NONE);
		changeType.setLayoutData(new GridData(SWT.CENTER, SWT.TOP, true, false, 1, 1));
		changeType.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				changeShowCountType(1);
			}
		});
		changeType.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID,"icons/btn/blue/switch.png"));
		
		unitLabel = new Label(composite_1, SWT.WRAP | SWT.CENTER);
		unitLabel.setFont(SWTResourceManager.getFont("微软雅黑", 11, SWT.NORMAL));
		unitLabel.setForeground(ColorConstants.FONT_BLACK_COLOR);
		GridData gd_unitLabel = new GridData(SWT.CENTER, SWT.CENTER, true, true, 1, 2);
		gd_unitLabel.widthHint = 20;
		unitLabel.setLayoutData(gd_unitLabel);
		unitLabel.setText(Messages.Opening_counts);

		init();
	}
	
	/**
	 * @Description: 初始化
	 * @author guoyr 
	 */
	private void init(){
		((GridData)changeType.getLayoutData()).exclude = true;
		changeType.setVisible(false);
		countLabel.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				if(null != listener && curCount > 0){
					listener.selection(curCount);
				}
			}
		});
		
		countRunnable = new Runnable(){
			public void run(){
				if(!countLabel.isDisposed() && counts.length > curIndex){
					curCount = counts[curIndex];
					countLabel.redraw();
//					countLabel.setText(curCount + "");
//					if(curCount > 0 && null == countLabel.getCursor()){
//						countLabel.setCursor(SWTResourceManager.getCursor(SWT.CURSOR_HAND));
//					}else {
//						countLabel.setCursor(null);
//					}
//					countLabel.getParent().layout();
				}
			}
		};
		addPaintListener(new PaintListener() {
			public void paintControl(PaintEvent arg0) {
				Rectangle rectangle = getBounds();
				arg0.gc.setForeground(SWTResourceManager.getColor(200, 200, 200));
				arg0.gc.setLineWidth(3);
				arg0.gc.setLineStyle(SWT.LINE_DOT);
				arg0.gc.drawRectangle(0, 0, rectangle.width -1, rectangle.height -1);
			}
		});
		countLabel.addPaintListener(new PaintListener() {
			int num_width = 30;
			int num_height = 35;
			int num_sep_width = 0;
			double widthHeightRate = 0.5;
			String[] countTime = new String[maxNum];
			final Image emptyImage = ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID,"icons/time/blue_e.png");
			public void paintControl(PaintEvent arg0) {
				if(curCount >= 0) {
					String curCountStr = curCount + "";
					maxNum = curCountStr.length() > 0 ? curCountStr.length() : 1;
					if(null != countTime && countTime.length != curCountStr.length()){
						countTime = new String[maxNum];
					}
					for(int i = 0; i < maxNum; i++){
						if(i < curCountStr.length()){
							countTime[maxNum -1 - i] = curCountStr.substring(curCountStr.length() - i -1, curCountStr.length() - i);
						}else {
							countTime[maxNum - 1 - i] = "";
						}
					}
				} else {
                    countTime = new String[]{""};
                    maxNum = 1;
                }
				if(null != emptyImage){
					widthHeightRate =  (double)emptyImage.getBounds().width / emptyImage.getBounds().height;
					num_width = emptyImage.getBounds().width;
				}
				Rectangle bounds = countLabel.getBounds();
				
				num_width = Math.min(bounds.width/maxNum,num_width);// 最多显示4位数
				num_height = (int)((num_width)/widthHeightRate);
				if(num_height > bounds.height){
					num_height = bounds.height;
					num_width = (int)(bounds.height * widthHeightRate);
				}
				int x = (bounds.width - (maxNum - 1)* num_sep_width - maxNum * num_width)/2;
				int y = Math.max((bounds.height - num_height)/2, 0) + 1;
				for(int i = 0; i < countTime.length; i++){
					String num = countTime[i];
					Image image = emptyImage;
					if(num.length() > 0){
						image = ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID,"icons/time/blue_"+num+".png");
						arg0.gc.setAlpha(-1);
					}else {
//						arg0.gc.setAlpha(80);
					}
					if(null != image){
						Rectangle rectangle = image.getBounds();
						arg0.gc.drawImage(image, 0, 0, rectangle.width, rectangle.height, x, y, num_width, num_height);
					}
					x += num_width ;
					if(i > 0){
						x += num_sep_width ;
					}
				}
				if(errors > 0){
					String errorsStr = errors+"";
					Point errorsPoint = arg0.gc.textExtent(errorsStr, DRAW_FLAGS);
					arg0.gc.setBackground(errorColor);
					arg0.gc.setForeground(whiteColor);
					int subTextSurrondWidth = Math.max(errorsStr.length() > 1 ? errorsPoint.x + 4 : errorsPoint.x  - 2, errorsPoint.y -2);
					int subTextSurrondHeight = errorsPoint.y -2;
					int errorX = Math.min(x -2 , countLabel.getBounds().width- subTextSurrondWidth - 2);
					int errorY = Math.min(2, y );
					arg0.gc.setAlpha(180);
					arg0.gc.setAntialias(SWT.ON);//消除锯齿
					arg0.gc.setAdvanced(true);
					if(subTextSurrondWidth > subTextSurrondHeight) {
						arg0.gc.fillRoundRectangle(errorX , errorY , subTextSurrondWidth, subTextSurrondHeight, subTextSurrondHeight, subTextSurrondHeight);
					}else {
						arg0.gc.fillOval(errorX , errorY , subTextSurrondWidth, subTextSurrondHeight);
					}
					arg0.gc.setAdvanced(false);
					arg0.gc.setAlpha(-1);
					arg0.gc.drawText(errorsStr, errorX +(subTextSurrondWidth - errorsPoint.x)/2, errorY + (subTextSurrondHeight - errorsPoint.y)/2 , true);
				}
				arg0.gc.dispose();
			}
		});
	}
	
	private void changeShowCountType(int step){
		if(changeType.getEnabled()){
			if(step > 0) {
				if(curIndex == statusList.size()-1){
					curIndex = 0;
				}else if(statusList.size() > curIndex + step){
					curIndex += step;
				}
			}
			if(null != visible && visible.length > curIndex) {
				if(!visible[curIndex]) {
					changeShowCountType(1);
					return;
				}
			}
			if(null != listener){
				listener.changed(curIndex, curCount);
			}
			Map<String, String> statusMap = statusList.get(curIndex);
			if(null != statusMap.get("title")){
				titleLabel.setText(statusMap.get("title"));
			}
			if(null != statusMap.get("unit")){
				unitLabel.setText(statusMap.get("unit"));
			}
			unitLabel.getParent().layout();
			Display.getDefault().syncExec(countRunnable);
		}
	}
	public void setSelectionIndex(int index){
		if(index > 0){
			curIndex = index;// -1;
		}else {
			curIndex = 0;
		}
		changeShowCountType(0);
	}

	public void addStatusName(String statusName, String statusUnit){
		if(statusList.size() == 0){
			titleLabel.setText(statusName);
			unitLabel.setText(statusUnit);
		}
		Map<String, String> statusMap = new HashMap<String, String>();
		statusMap.put("title", statusName);
		statusMap.put("unit", statusUnit);
		statusList.add(statusMap);
		if(statusList.size() > 1 && !changeType.isVisible()){
			((GridData)changeType.getLayoutData()).exclude = false;
			changeType.setVisible(true);
			changeType.setCursor(SWTResourceManager.getCursor(SWT.CURSOR_HAND));
			changeType.getParent().layout();
		}
	}

	public void setCountValue(int index, int value) {
		if(index < counts.length){
			int oldCount = counts[index];
			counts[index] = value;
			if(curIndex == index && oldCount != value){
				Display.getDefault().syncExec(countRunnable);
			}
		}
	}
	
	public void setCounts(int[] _counts) {
		if(_counts.length > curIndex){
			int oldCount = counts.length > curIndex ? counts[curIndex] : 0;
			counts = _counts;
			if(oldCount != _counts[curIndex]){
				Display.getDefault().syncExec(countRunnable);
			}
			
		}
	}
	
	public void setErrors(int errors){
		if(this.errors != errors){
			this.errors = errors;
			Display.getDefault().syncExec(countRunnable);
		}
	}
	public void setSelection(final boolean selection){
//		Display.getDefault().syncExec(new Runnable(){
//			public void run(){
//				if(!selectionLabel.isDisposed()){
//					if(selection){
//						selectionLabel.setBackground(SWTResourceManager.getColor(23, 101, 174));
//					}else {
//						selectionLabel.setBackground(null);
//					}
//				}
//			}
//		});
	}
	
	public void addStatusCountListener(StatusCountListener listener){
		this.listener = listener;
		
	}
	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}

	@Override
	public void setStatusVisible(boolean[] visible) {
		this.visible = visible;
	}

}
