package com.gx.obe.opening.composite;

import java.awt.Dimension;
import java.awt.Toolkit;
import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Timer;
import java.util.TimerTask;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.ImageResolver;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.listener.ConfirmListener;
import org.eclipse.swt.core.listener.LoadingAdatper;
import org.eclipse.swt.core.listener.ScrollMessageListener;
import org.eclipse.swt.core.utils.SwtUtils;
import org.eclipse.swt.core.utils.WidgetUtils;
import org.eclipse.swt.core.widgets.ConfirmDialog;
import org.eclipse.swt.core.widgets.EButton;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.core.widgets.ImageButton;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowData;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;

import com.gx.obe.ColorConstants;
import com.gx.obe.VideoConfigConstants;
import com.gx.obe.business.entity.MenuFunction;
import com.gx.obe.business.enumeration.MenuFunctionEnum;
import com.gx.obe.common.dialog.BidOpeningReportDialog;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.composite.PageNumComposite;
import com.gx.obe.common.widget.dialog.InputDialog;
import com.gx.obe.common.widget.inter.ProjectStatusCount;
import com.gx.obe.common.widget.listener.PageListener;
import com.gx.obe.common.widget.listener.StatusCountListener;
import com.gx.obe.common.widget.shell.ProgressMessageDialog;
import com.gx.obe.common.widget.shell.ToolsShell;
import com.gx.obe.common.widget.thread.MyRunnable;
import com.gx.obe.common.widget.utils.MenuFunctionUtils;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.I18NEnum;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.components.core.enumeration.VideoMeetingEmum;
import com.gx.obe.config.ConfigConstants;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.meeting.utils.VideoMeetingUtils;
import com.gx.obe.message.Messages;
import com.gx.obe.opening.dialog.BatchRemoteBidOpeningDialog;
import com.gx.obe.opening.dialog.BatchRemoteSignResultDialog;
import com.gx.obe.opening.dialog.BatchStartBidOpeningHallDialog;
import com.gx.obe.opening.dialog.HSTMeetingInfoDialog;
import com.gx.obe.opening.listener.BatchRemoteBidOpeningListener;
import com.gx.obe.opening.listener.BatchRemoteComplateAndUploadListener;
import com.gx.obe.opening.listener.BatchRemoteDecryptListener;
import com.gx.obe.opening.listener.BatchRemoteSignListener;
import com.gx.obe.opening.listener.MeetingRoomListener;
import com.gx.obe.opening.listener.TenderPackOpeningStatus;
import com.gx.obe.opening.shell.BidOpeningCountDownShell;
import com.gx.obe.opening.shell.SendMessageDialog;
import com.gx.obe.opening.shell.SingBidShell;
import com.gx.obe.opening.shell.TenderPackOpeningSupplierDetailsShell;
import com.gx.obe.opening.thread.BatchDownRemoteBidOpeningResultThread;
import com.gx.obe.opening.thread.BatchDownRemoteSignInfoThread;
import com.gx.obe.opening.thread.BatchFocusDecryptBidFilThread;
import com.gx.obe.opening.thread.BatchRemoteDecryptBidFilThread;
import com.gx.obe.opening.thread.BatchRemoteStartBidopeningHallThread;
import com.gx.obe.opening.thread.BatchUploadBidOpeningResultThread;
import com.gx.obe.opening.thread.RefreshProjectBidOpeningInfoThread;
import com.gx.obe.opening.utils.TenderPackDecInfoComparator;
import com.gx.obe.opening.widgets.RoomOperatorButton;
import com.gx.obe.thread.RefreshProjectSupplierTenderInfoThread;
import com.gx.obe.util.utils.ScreenUtils;
import com.gx.obe.util.utils.StringUtils;
import com.gx.obe.web.entity.Page;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.entity.tender.TenderProjectRuleEntity;
import com.gx.obe.web.service.ProjectRuleService;
import com.gx.obe.web.service.TenderProjectService;
import com.gx.obe.web.service.evaluation.EvaluationStepService;
import com.gx.obe.web.vo.TenderPackOpeningInfo;
import com.gx.security.NowTimeUtils;
import com.gx.utils.ActionLogUtils;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

public class BidOpeningRemoteByProjectComposite extends OpeningTimeComposite implements BatchRemoteBidOpeningListener, BatchRemoteSignListener, BatchRemoteDecryptListener, BatchRemoteComplateAndUploadListener {
	
	private ImageResolver imageResolver = new ImageResolver();
	private TenderProjectService tenderProjectService ;
	private ProjectRuleService projectRuleService ;
	private TenderProjectEntity tenderProjectEntity;
	private String bidopeningStage;
	private TenderProjectRuleEntity tenderProjectRuleEntity;
	private Image zoomBgImage;
	private Composite decryptMainComposite;
	private Composite progressComposite;
	private ScrolledComposite scrolledComposite;
	private Composite decryptSupplierComposite;
	private RoomOperatorButton openBiddingAgendaBtn;
	private RoomOperatorButton bidOpeningBtn;
	private RoomOperatorButton signResultBtn;
//	private Map<String, RemoteSupplierListener> remoteSupplierListener;
	private BatchDownRemoteBidOpeningResultThread remoteProjectBidOpeningThread;
	private BatchDownRemoteSignInfoThread remoteProjectSignThread;
	private MyRunnable showInRemoteStatusThread;
	private boolean downDecInfoProgress;
	private boolean isPriceStage = false;
	private boolean isBusAndTecStage = false;
	private boolean isShowDownloadProgress = false;
	private boolean isFocusDecrypt = false;
	private ImageButton startBidopeningBtn;
	private String SUPPLIER_NAME = "供应商";
	private String PACK_NAME = "包件";
	private String decryptName = Messages.Button_decryptRemote;
	private Composite totalCountComposite;
	private ProjectStatusCount curStatusCount;
	private ProjectStatusCount tenderStatusCount;
	private ProjectStatusCount signStatusCount;
	private ProjectStatusCount decStatusCount;
	private ProjectStatusCount confirmStatusCount;
	private ProjectStatusCount complateStatusCount;
	private List<TenderPackOpeningInfo> tenderPackOpeningInfoList;
	private Map<String, TenderPackOpeningInfo> tenderPackOpeningInfoMap;
	private Map<String, TenderPackOpeningStatus> tenderPackOpeningStatusMap = new HashMap<String, TenderPackOpeningStatus>();
	private RefreshProjectBidOpeningInfoThread refreshProjectBidOpeningInfoThread;
	private int supplierListHeight = 300;
	private int PAGE_SIZE = 20;
	private int PAGE_NO = 1;
	private int CUR_TYPE = 0;
	private PageNumComposite pageComposite;
	private Composite composite;
	public static int projectNameFontSize = 20;
	public static boolean showProjectNo = true;
//	private RoomOperatorButton refreshSupplierBtn;
	private RoomOperatorButton signBidBtn;
	private Canvas signNext;
	private RoomOperatorButton signatureBtn;
	private Canvas signatureNextBtn;
	private BidOpeningPackCountComposite signCountComposite;
	private BidOpeningPackCountComposite confirmCountComposite;
	private boolean showOpeningCount = false;
	private int threeIndex = 1;
	private int openingIndex = 2;
	private Timer decStartTimer;
	private Timer decEndTimer;
	private MeetingRoomListener meetingRoomListener;
	private RoomOperatorButton reFreshBtn;
	private RoomOperatorButton sendMessageBtn;
	private SendMessageDialog sendMessageDialog;
	private MenuFunctionUtils menuFunctions;
	private GridLayout gl_decryptSupplierComposite;
	private boolean showNowTime = false;
	private boolean automaticSwitchPage = false;
	private int complateDetailCount = 0;
	private int decFailCount = 0;
	private int totalTenderCount = 0;
	private int decTotalCount = 0;
	private int noPriceCount = 0;
	private int intervalSecond = 5;
	private Canvas startBidOpeningNext;
	private RoomOperatorButton downTenderInfoBtn;
	private ScrollMessageListener scrollMessageListener;
	private boolean anonymousAllInfo = false;
	private RoomOperatorButton startMeetingBtn;
 
	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public BidOpeningRemoteByProjectComposite(Composite parent, int style) {
		super(parent, style);
		addDisposeListener(new DisposeListener() {
			public void widgetDisposed(DisposeEvent arg0) {
				close();
			}
		});
		setBackgroundMode(SWT.INHERIT_FORCE);
		this.tenderProjectEntity = (TenderProjectEntity) parent.getData("tenderProjectEntity");
		this.bidopeningStage = (String) parent.getData("bidopeningStage");;
		this.meetingRoomListener = (MeetingRoomListener) parent.getData("meetingRoomListener");;
		this.menuFunctions = (MenuFunctionUtils) parent.getData("menuFunctions");
		this.isFocusDecrypt = null != parent.getData("isFocus") ? true : false;
		this.anonymousAllInfo = "true".equals(parent.getData("ANONYMOUS_ALL_INFO"));
		GridLayout gridLayout = new GridLayout(2, false);
		setLayout(gridLayout);
		
		Composite centerComposite = new Composite(this, SWT.NONE);
		GridLayout gl_centerComposite = new GridLayout(1, false);
		gl_centerComposite.marginHeight = 0;
		gl_centerComposite.verticalSpacing = 0;
		gl_centerComposite.horizontalSpacing = 0;
		gl_centerComposite.marginWidth = 0;
		centerComposite.setLayout(gl_centerComposite);
		centerComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		composite = new Composite(centerComposite, SWT.NONE);
		GridLayout gl_composite = new GridLayout(2, false);
		gl_composite.marginWidth = 0;
		gl_composite.marginHeight = 0;
		composite.setLayout(gl_composite);
		GridData gd_composite = new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1);
		gd_composite.heightHint = 20;
		composite.setLayoutData(gd_composite);
		
		decryptMainComposite = new Composite(centerComposite, SWT.NONE);
		GridLayout gl_decryptMainComposite = new GridLayout(1, false);
		gl_decryptMainComposite.horizontalSpacing = 0;
		gl_decryptMainComposite.verticalSpacing = 0;
		gl_decryptMainComposite.marginHeight = 0;
		gl_decryptMainComposite.marginWidth = 0;
		decryptMainComposite.setLayout(gl_decryptMainComposite);
		decryptMainComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		scrolledComposite = new ScrolledComposite(decryptMainComposite, SWT.H_SCROLL | SWT.V_SCROLL);
		scrolledComposite.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, true, 1, 1));
		scrolledComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		scrolledComposite.setExpandHorizontal(true);
		scrolledComposite.setExpandVertical(true);
		
		decryptSupplierComposite = new Composite(scrolledComposite, SWT.NONE);
		gl_decryptSupplierComposite = new GridLayout(1, false);
		gl_decryptSupplierComposite.marginHeight = 0;
		gl_decryptSupplierComposite.marginWidth = 0;
		gl_decryptSupplierComposite.verticalSpacing = 0;
		decryptSupplierComposite.setLayout(gl_decryptSupplierComposite);
		
		scrolledComposite.setContent(decryptSupplierComposite);
		scrolledComposite.setMinSize(decryptSupplierComposite.computeSize(SWT.DEFAULT, SWT.DEFAULT));
		
		pageComposite = new PageNumComposite(decryptMainComposite, SWT.NONE);
		pageComposite.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		pageComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		
		progressComposite = new Composite(this, SWT.NONE);
		
		GridLayout gl_progressComposite = new GridLayout(1, false);
		gl_progressComposite.verticalSpacing = 0;
		gl_progressComposite.horizontalSpacing = 0;
		gl_progressComposite.marginHeight = 0;
		gl_progressComposite.marginWidth = 0;
		progressComposite.setLayout(gl_progressComposite);
		GridData gd_progressComposite = new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1);
		gd_progressComposite.widthHint = 180;
		progressComposite.setLayoutData(gd_progressComposite);
		
		totalCountComposite = new Composite(progressComposite, SWT.NONE);
		GridLayout gl_totalCountComposite = new GridLayout(1, false);
		gl_totalCountComposite.marginHeight = 0;
		gl_totalCountComposite.marginWidth = 0;
		totalCountComposite.setLayout(gl_totalCountComposite);
		totalCountComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		BidOpeningPackCountComposite tenderCountComposite = new BidOpeningPackCountComposite(totalCountComposite, SWT.NONE);
		tenderCountComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		tenderStatusCount = tenderCountComposite;
		signCountComposite = new BidOpeningPackCountComposite(totalCountComposite, SWT.NONE);
		signCountComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		signStatusCount = signCountComposite;
		BidOpeningPackCountComposite decCountComposite = new BidOpeningPackCountComposite(totalCountComposite, SWT.NONE);
		decCountComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		decStatusCount = decCountComposite;
		confirmCountComposite = new BidOpeningPackCountComposite(totalCountComposite, SWT.NONE);
		confirmCountComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		confirmStatusCount = confirmCountComposite;
		BidOpeningPackCountComposite complateCountComposite = new BidOpeningPackCountComposite(totalCountComposite, SWT.NONE);
		complateCountComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		complateStatusCount = complateCountComposite;
		tenderProjectService = new TenderProjectService();
		init();
	}
	
	/**
	 * @Description: 添加操作按钮
	 * @author guoyr
	 */
	private void addOperatorBtn() {
		
		Composite operatorComposite = new Composite(null != meetingRoomListener.getOperatorParent() ? meetingRoomListener.getOperatorParent() : decryptMainComposite, SWT.TRANSPARENT);
		GridLayout gl_composite = new GridLayout(8, false);
		gl_composite.marginHeight = 0;
		gl_composite.horizontalSpacing = 3;
		operatorComposite.setLayout(gl_composite);
		operatorComposite.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, true, 1, 1));
		
		RoomOperatorButton moreActionBtn = new RoomOperatorButton(operatorComposite, SWT.NONE);
		moreActionBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/more_op.png"));
		moreActionBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, true, 1, 1));
		moreActionBtn.setText(Messages.Button_moreOperate);
		moreActionBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				moreConfigAction();
			}
		});
		
		openBiddingAgendaBtn = new RoomOperatorButton(operatorComposite, SWT.NONE);
		openBiddingAgendaBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, true, 1, 1));
		openBiddingAgendaBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/tips.png"));
		openBiddingAgendaBtn.setText(Messages.BidOpeningAgenda);
		openBiddingAgendaBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				showBidOpeningCountDown();
			}
		});
		if(null != menuFunctions && MenuFunction.SHOW.equals(menuFunctions.getAuthority("SHOW_MEETING_VIDEO"))){
			startMeetingBtn = new RoomOperatorButton(operatorComposite, SWT.NONE);
			startMeetingBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/voice_config.png"));
			startMeetingBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, true, 1, 1));
			startMeetingBtn.setText(Messages.Button_opeingMeeting);
			startMeetingBtn.addMouseListener(new MouseAdapter() {
				@Override
				public void mouseUp(MouseEvent e) {
					String meetingType = PropertiesUtils.getProperty(ConfigConstants.VIDEO_MEETING_TYPE, "");
					if(meetingType.equals(VideoMeetingEmum.MEETING_HST)){
						if (e.button == 1) {//点击鼠标左键
							startmeetingAction();
						}else if(e.button==3){
							String roomIdAndPwd = tenderProjectEntity.getBidMeeting();
							if(null == roomIdAndPwd || roomIdAndPwd.length() == 0) {
								return;
							}
							String roomId = "";
							String rpwd = "";
							if(roomIdAndPwd.contains("_")) {
								roomId = roomIdAndPwd.substring(0,roomIdAndPwd.indexOf("_"));
								rpwd = roomIdAndPwd.substring(roomIdAndPwd.indexOf("_")+1);
							}else {
								roomId = roomIdAndPwd;
								rpwd = "123456";
							}
							HSTMeetingInfoDialog dialog = new HSTMeetingInfoDialog(getShell(),roomId,rpwd);
							dialog.open();
						}
					}else {
						startmeetingAction();
					}
				}
			});
		}
		ESepator vSep1 = new ESepator(operatorComposite, SWT.VERTICAL);
		vSep1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1));
		vSep1.setLineWidth(2);
		vSep1.setBackground(ColorConstants.SKIN_BG);
		
		Composite stepComposite = new Composite(operatorComposite, SWT.NONE);
		stepComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		RowLayout rl_stepComposite = new RowLayout(SWT.HORIZONTAL);
		rl_stepComposite.center = true;
		rl_stepComposite.spacing = 0;
		rl_stepComposite.marginLeft = 0;
		rl_stepComposite.marginRight = 0;
		rl_stepComposite.marginTop = 0;
		rl_stepComposite.marginBottom = 0;
		rl_stepComposite.marginHeight = 0;
		stepComposite.setLayout(rl_stepComposite);
		stepComposite.setLayoutData(new GridData(SWT.CENTER, SWT.FILL, true, true, 1, 1));
		
		downTenderInfoBtn = new RoomOperatorButton(stepComposite, SWT.NONE | EButton.CSS_BLUE);
		downTenderInfoBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/refresh.png"));
		downTenderInfoBtn.setText(Messages.Button_syncNewTenderInfo);
		downTenderInfoBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				downTenderInfoBtn.setEnabled(false);
				if(synNewBidInfoInfo(Messages.Tips_synchronizingNewTenderInfo)){
					refreshProjectRemoteInfo();
				}
			}
		});
		
		addNextSep(stepComposite);
		
		startBidopeningBtn = new RoomOperatorButton(stepComposite, SWT.NONE | EButton.CSS_BLUE);
		startBidopeningBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/wifi.png"));
		startBidopeningBtn.setText(Messages.Button_openRemoteBidOpeningHall);
		startBidopeningBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				startBidopeningAction();
			}
		});
		startBidOpeningNext = addNextSep(stepComposite);
		
		bidOpeningBtn = new RoomOperatorButton(stepComposite, SWT.NONE | EButton.CSS_BLUE);
		bidOpeningBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/key.png"));
		bidOpeningBtn.setText(MessageFormat.format(Messages.Button_batchFormat, decryptName));
		bidOpeningBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				openBidAction(true);
			}
		});
		addNextSep(stepComposite);
		signResultBtn = new RoomOperatorButton(stepComposite, SWT.NONE | EButton.CSS_BLUE);
		signResultBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/submit.png"));
		signResultBtn.setText(MessageFormat.format(Messages.Button_batchFormat, Messages.Button_complateDecrypt));
		signResultBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				remoteComplateAction();
			}
		});
		signNext = addNextSep(stepComposite);
		signBidBtn = new RoomOperatorButton(stepComposite, SWT.NONE | EButton.CSS_BLUE);
		signBidBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/sing.png"));
		signBidBtn.setText(Messages.Button_signBid);
		signBidBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				signBidAction();
			}
		});
		
		signatureNextBtn = addNextSep(stepComposite);
		signatureBtn = new RoomOperatorButton(stepComposite, SWT.NONE | EButton.CSS_BLUE);
		signatureBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/signature.png"));
		signatureBtn.setText(Messages.Button_openingResultSignature);
		signatureBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				signatureAction();
			}
		});
		
		ESepator vSep2 = new ESepator(operatorComposite, SWT.VERTICAL);
		vSep2.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1));
		vSep2.setLineWidth(2);
		vSep2.setBackground(ColorConstants.SKIN_BG);
		
		sendMessageBtn = new RoomOperatorButton(operatorComposite, SWT.NONE);
		sendMessageBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/tips.png"));
		sendMessageBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, true, 1, 1));
		sendMessageBtn.setText(Messages.Button_sendMessage);
		sendMessageBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				sendMessageAction();
			}
		});
		
		reFreshBtn = new RoomOperatorButton(operatorComposite, SWT.NONE);
		reFreshBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/refresh.png"));
		reFreshBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, true, 1, 1));
		reFreshBtn.setText(Messages.Button_refresh);
		reFreshBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				refreshAction();
			}
		});
		
		
//		RoomOperatorButton closeBtn = new RoomOperatorButton(bottomContent, SWT.NONE);
//		closeBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/exit.png"));
//		closeBtn.setLeftMargin(20);
//		closeBtn.setRightMargin(20);
//		closeBtn.setBackgroundColor(SWTResourceManager.getColor(208, 88, 89));
//		closeBtn.setActiveBackgroundColor(SWTResourceManager.getColor(SWT.COLOR_RED));
//		closeBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
//		closeBtn.setText(" 退出 ");
//		closeBtn.addMouseListener(new MouseAdapter() {
//			@Override
//			public void mouseUp(MouseEvent e) {
//				exitAction();
//			}
//		});
		
//		Image image = ResourceManager.getPluginImage(SWTCoreActivator.PLUGIN_ID, "icons/bg.png");
//		Region region = new Region();
//		ImageData imageData = image.getImageData();
//		if (imageData.alphaData != null) {
//			for (int y = 0; y < imageData.height; y++) {
//				for (int x = 0; x < imageData.width; x++) {
//					if (imageData.getAlpha(x, y) == 255) {
//						region.add(imageData.x + x,imageData.y + y,1,1);
//					}
//				}
//			}
//		}
//		meetingRoomListener.setOperatorRegion(region);
		// 解中解密
		if (isFocusDecrypt) {
			// 不需要开启开标大厅
			WidgetUtils.setControlVisible(startBidopeningBtn, false);
			WidgetUtils.setControlVisible(startBidOpeningNext, false);
			
			// 不显示签到信息
			WidgetUtils.setControlVisible(signCountComposite, false);
		}
		if (isBusAndTecStage) {
			WidgetUtils.setControlVisible(signBidBtn, false);
			WidgetUtils.setControlVisible(signNext, false);
			WidgetUtils.setControlVisible(signatureBtn, false);
			WidgetUtils.setControlVisible(signatureNextBtn, false);
		}
		boolean showSignature = false;
		if(null != menuFunctions && MenuFunction.SHOW.equals(menuFunctions.getAuthority("REMOTE_SIGNATURE"))){
			showSignature = true;
		}
		WidgetUtils.setControlVisible(signatureBtn, showSignature);
		WidgetUtils.setControlVisible(signatureNextBtn, showSignature);
		meetingRoomListener.refreshOperator();
		if(null != menuFunctions && MenuFunction.SHOW.equals(menuFunctions.getAuthority("SHOW_OPENING_TIPS"))){
			showOpeningTips(bidOpeningBtn.getParent());
		}
	}
	
	private Canvas addNextSep(Composite stepComposite){
		final Image nextImage = ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/right_arrow.png");
		final Canvas nextLabel = new Canvas(stepComposite, SWT.TRANSPARENT);
		nextLabel.setLayoutData(new RowData(8, 22));
		nextLabel.addPaintListener(new PaintListener() {
			public void paintControl(PaintEvent arg0) {
				arg0.gc.drawImage(nextImage, 0, 0, nextImage.getBounds().width, nextImage.getBounds().height, 0, 0, nextLabel.getBounds().width, nextLabel.getBounds().height);
			}
		});
		return nextLabel;
	}
	
	/**
	 * @Description: 初始化
	 * @author guoyr
	 */
	private void init() {
		projectRuleService = new ProjectRuleService();
		SUPPLIER_NAME = com.gx.obe.components.core.I18N.getString(I18NEnum.SUPPLIERNAME, tenderProjectEntity.getTenderType());
		PACK_NAME = com.gx.obe.components.core.I18N.getString(I18NEnum.SUBPACKAGE, tenderProjectEntity.getTenderType());
		
		if (isFocusDecrypt) {
			decryptName = Messages.Button_decryptCentralize;
		} else {
			decryptName = Messages.Button_decryptRemote;
		}
		showNowTime = PropertiesUtils.getProperty(ConfigConstants.SHOW_NOW_TIME, "00").equals("01");
		tenderProjectRuleEntity = projectRuleService.getProjectRule(tenderProjectEntity.getId());
		if (showProjectNo) {
			meetingRoomListener.refreshMeetingTitle("[" + tenderProjectEntity.getTenderNo() + "]" + tenderProjectEntity.getTenderName());
		} else {
			meetingRoomListener.refreshMeetingTitle(tenderProjectEntity.getTenderName());
		}
		isPriceStage = false;
		isBusAndTecStage = false;
		bidOpeningTime = tenderProjectRuleEntity.getBidOpeningStartTime();
		decryptEndTime = tenderProjectRuleEntity.getDecryptEndTime();
		signEndTime = tenderProjectRuleEntity.getSignEndTime();
		if (null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_PRICE)) {
			isPriceStage = true;
			bidOpeningTime = tenderProjectRuleEntity.getPriceBidOpeningTime();
			signEndTime = tenderProjectRuleEntity.getPriceSignEndTime();
			decryptEndTime = tenderProjectRuleEntity.getPriceDecryptEndTime();
//			if(null != tenderProjectEntity.getBusinessBidStatus() && tenderProjectEntity.getBusinessBidStatus().equals(CommonEnum.COMPLETE)){
			if (StringUtils.isEmpty(tenderProjectEntity.getBusinessBidStatus()) || tenderProjectEntity.getBusinessBidStatus().equals(CommonEnum.NOT_START)) {
				showOpeningCount = false;
			} else {
				showOpeningCount = true;
			}
			meetingRoomListener.refreshManagerTable(Messages.EconomicBid);
		} else if (null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_BUS_TEC)) {
			isBusAndTecStage = true;
			if (null != tenderProjectEntity.getBusinessBidStatus() && tenderProjectEntity.getBusinessBidStatus().equals(CommonEnum.COMPLETE)) {
				showOpeningCount = true;
			}
			meetingRoomListener.refreshManagerTable(Messages.BusinessTechnologyBid);
		}
		
		addOperatorBtn();
		
		progressComposite.layout();
		WidgetUtils.setControlVisible(pageComposite, false);
		pageComposite.setBorderColor(SWTResourceManager.getColor(204, 204, 204));
		pageComposite.setForeground(SWTResourceManager.getColor(204, 204, 204));
		pageComposite.setSelectionBgColor(SWTResourceManager.getColor(24, 112, 221));
		pageComposite.setSelectionForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		pageComposite.addPageListener(new PageListener() {
			public void changed(int pageNo, int pageSize) {
				PAGE_NO = pageNo;
				showTenderPackList(CUR_TYPE);
			}
		});
		
		progressComposite.layout();
		
		tenderStatusCount.addStatusName(Messages.Opening_tendered, Messages.Opening_counts);
		tenderStatusCount.addStatusName(Messages.Opening_canOpening, Messages.Opening_counts);
		tenderStatusCount.addStatusName(Messages.Opening_ecryptable, Messages.Opening_counts);
		tenderStatusCount.addStatusName(Messages.Opening_totalTenders, Messages.Opening_packCount);
		tenderStatusCount.addStatusCountListener(new StatusCountListener() {
			public void selection(int count) {
				PAGE_NO = 1;
				showTenderPackList(0);
			};
			
			public void changed(int index, int count) {
				if (index == openingIndex) {
					showOpeningCount = true;
					refreshTenderInfoStatus(showOpeningCount);
				} else if (showOpeningCount) {
					showOpeningCount = false;
					refreshTenderInfoStatus(showOpeningCount);
				}
			};
		});
		signStatusCount.addStatusName(Messages.Opening_signedIn, Messages.Opening_counts);
		signStatusCount.addStatusName(Messages.Opening_signedIn, Messages.Opening_packCount);
		signStatusCount.addStatusCountListener(new StatusCountListener() {
			public void selection(int count) {
				PAGE_NO = 1;
				showTenderPackList(TenderPackDecInfoComparator.ORDERBY_NO_SIGN);
				MessageDialog.openShortMessage("按未签到比例由大倒小排序");
			}
		});
		decStatusCount.addStatusName(Messages.Opening_decrypted, Messages.Opening_counts);
		decStatusCount.addStatusName(Messages.Opening_decrypted, Messages.Opening_packCount);
		decStatusCount.addStatusCountListener(new StatusCountListener() {
			public void selection(int count) {
				PAGE_NO = 1;
				showTenderPackList(TenderPackDecInfoComparator.ORDERBY_NO_DEC);
				MessageDialog.openShortMessage("按解密异常或未解密比例由大倒小排序");
			}
		});
		confirmStatusCount.addStatusName(Messages.Opening_confirmed, Messages.Opening_counts);
		confirmStatusCount.addStatusName(Messages.Opening_confirmed, Messages.Opening_packCount);
		confirmStatusCount.addStatusCountListener(new StatusCountListener() {
			public void selection(int count) {
				PAGE_NO = 1;
				showTenderPackList(TenderPackDecInfoComparator.ORDERBY_NO_CONFIRM);
				MessageDialog.openShortMessage("按未确认比例由大倒小排序");
			}
		});
		complateStatusCount.addStatusName(Messages.Opening_complated, Messages.Opening_counts);
		complateStatusCount.addStatusName(Messages.Opening_complated, Messages.Opening_packCount);
		complateStatusCount.addStatusCountListener(new StatusCountListener() {
			public void selection(int count) {
				PAGE_NO = 1;
				showTenderPackList(TenderPackDecInfoComparator.ORDERBY_NO_COMPLATE);
				MessageDialog.openShortMessage("按未完成比例由大倒小排序");
			}
		});
		
		if (PropertiesUtils.getProperty(ConfigConstants.SHOW_CONFIRM_STATUS, "00").equals("00")) {
			WidgetUtils.setControlVisible(confirmCountComposite, false);
			totalCountComposite.layout();
		}
		
		refreshAction();
		composite.setForeground(SWTResourceManager.getColor(SWT.COLOR_BLUE));
		composite.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		scrollMessageListener = new ScrollMessageListener(composite);
		composite.addPaintListener(scrollMessageListener);
		
		showScrollMsg(Messages.Tips_openingHall);

		progressComposite.layout();
		meetingRoomListener.refreshMeetingTime(Messages.BidOpeningTimeOnBoard, bidOpeningTime);
		meetingRoomListener.refreshCountDownTime(Messages.CountdownOnBoard, bidOpeningTime);
		addBidopeningStartTimer(bidOpeningTime, decryptEndTime);
		addDecryptEndTimer(decryptEndTime);
		
		automaticSwitchPageAction();
	}
	
	/**
	 * @Description: 开启自动切换页
	 * @author chenxw
	 */
	private void automaticSwitchPageAction() {
		if (pageComposite.getLastPage() == 1) {
			automaticSwitchPage = false;
			return;
		}
		final Runnable autoSwitchPage = new Runnable() {
			public void run() {
				if (pageComposite.isDisposed()) {
					automaticSwitchPage = false;
				} else {
					pageComposite.switchPageAction();
				}
			}
		};
		new Thread(new Runnable() {
			public void run() {
				while (automaticSwitchPage) {
					Display.getDefault().syncExec(autoSwitchPage);
					try {
						Thread.sleep(intervalSecond * 1000);
					} catch (InterruptedException e) {}
				}
			}
		}).start();
	}
	
	/**
	 * @Description: 开始解密定时期
	 * @author guoyr
	 * @param bidOpeningTime
	 */
	private void addBidopeningStartTimer(Date bidOpeningTime, final Date decryptEndTime) {
		if (null != decStartTimer) {
			decStartTimer.cancel();
		}
		if (bidOpeningTime.after(NowTimeUtils.getNowDate())) {
			if(CommonEnum.YES.equals(tenderProjectEntity.getLatestBidinfo())){
				ActionLogUtils.addServerLog(tenderProjectEntity.getId(), "重置获取最新投标信息状态", "未到开标时间，但状态为已获取过最新投标时间");
				tenderProjectEntity.setLatestBidinfo(CommonEnum.NO);
				tenderProjectService.updateAssignProperty(tenderProjectEntity, new String[]{"latestBidinfo"});			
			}
			decStartTimer = new Timer(true);
			decStartTimer.schedule(new TimerTask() {
				public void run() {
					final boolean refresh = anonymousAllInfo;
					anonymousAllInfo = isShowAnonymName(tenderProjectRuleEntity.getIsAnonymous());
					if (!Display.getDefault().isDisposed()) {
						Display.getDefault().syncExec(new Runnable() {
							public void run() {
								if (!getShell().isDisposed()) {
									showScrollMsg(Messages.Tips_timeForBidOpeningAndSynchronizInfo);
									boolean synNewFlag = synNewBidInfoInfo(Messages.Tips_timeForBidOpeningAndSynchronizInfo);
									if(refresh || synNewFlag) {
										refreshProjectRemoteInfo();
									}
									ConfirmDialog synTenderInfoDialog = new ConfirmDialog(getShell(), decryptName, MessageFormat.format(Messages.Tips_timeForBidOpening, bidOpeningBtn.getText()), null);
									synTenderInfoDialog.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/tips_info.png"), -1, -1);
									synTenderInfoDialog.setTips(synNewFlag ? Messages.Tips_synchronizedNewTenderInfoComplate : Messages.Tips_checkSynchronizNewTenderInfo);
									synTenderInfoDialog.addButton(bidOpeningBtn.getText(), "dec");
									synTenderInfoDialog.addCancel(Messages.Button_cancel, null);
									synTenderInfoDialog.setAlpha(230);
									synTenderInfoDialog.open();
									if (synTenderInfoDialog.getClickStatus().equals("dec")) {
										openBidAction(!synNewFlag);
									}
								}
							}
						});
						if (null != decryptEndTime) {
							meetingRoomListener.refreshMeetingTime(Messages.Deadline, decryptEndTime);
							meetingRoomListener.refreshCountDownTime(Messages.CountdownOnBoard, decryptEndTime);
						} else if (showNowTime) {
							meetingRoomListener.showNowTime(2000);
						}
					}
				}
				
			}, bidOpeningTime.getTime() - NowTimeUtils.getNowDate().getTime());
		} else if (null != decryptEndTime) {
			meetingRoomListener.refreshMeetingTime(Messages.Deadline, decryptEndTime);
			meetingRoomListener.refreshCountDownTime(Messages.CountdownOnBoard, decryptEndTime);
		} else if (showNowTime) {
			meetingRoomListener.showNowTime(2000);
		}
	}
	
	/**
	 * @Description: 解密截止定时期
	 * @author guoyr
	 * @param bidOpeningDeadlineTime
	 */
	private void addDecryptEndTimer(Date bidOpeningDeadlineTime) {
		if (null != decEndTimer) {
			decEndTimer.cancel();
		}
		if (null != bidOpeningDeadlineTime && bidOpeningDeadlineTime.after(NowTimeUtils.getNowDate())) {
			decEndTimer = new Timer(true);
			decEndTimer.schedule(new TimerTask() {
				public void run() {
					if (showNowTime) {
						meetingRoomListener.showNowTime(5000);
					}
					ActionLogUtils.addServerLog(tenderProjectEntity.getId(),"批量解密截止时间已到", "共解密" + decTotalCount +"家次");
					showScrollMsg(MessageFormat.format(Messages.Tips_complateAndUploadResultForDeadline, MessageFormat.format(Messages.Button_batchFormat, Messages.Button_complateDecrypt)));
					if (!Display.getDefault().isDisposed()) {
						Display.getDefault().syncExec(new Runnable() {
							public void run() {
								if (!getShell().isDisposed()) {
									ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), Messages.Dialog_warmTips, MessageFormat.format(Messages.Tips_complateAndUploadResultForDeadline, MessageFormat.format(Messages.Button_batchFormat, Messages.Button_complateDecrypt)), new ConfirmListener() {
										public void click(String key) {
											if (key.equals("01")) {
												remoteComplateAction();
											}
										}
									});
									confirmDialog.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/tips_info.png"), -1, -1);
									confirmDialog.addButton(MessageFormat.format(Messages.Button_batchFormat, MessageFormat.format(Messages.Button_batchFormat, Messages.Button_complateDecrypt)), "01", null);
									confirmDialog.addCancel(Messages.Button_cancel, null);
									confirmDialog.setAlpha(230);
									confirmDialog.open();
								}
							}
						});
					}
					downDecInfoProgress = false;
					isShowDownloadProgress = false;
					if (null != remoteProjectBidOpeningThread) {
						remoteProjectBidOpeningThread.stop();
					}
					if (null != remoteProjectSignThread) {
						remoteProjectSignThread.stop();
					}
					setDownloadBidopeningInfo(false);
				}
				
			}, bidOpeningDeadlineTime.getTime() - NowTimeUtils.getNowDate().getTime());
		}
	}
	
	
	private void showScrollMsg(final String msg) {
		if(null == msg){
			return;
		}
		scrollMessageListener.showMessage(msg);
	}
	
	/**
	 * @Description: 显示签到包件列表
	 * @author guoyr
	 */
	private void showTenderPackList(final int type) {
		CUR_TYPE = type;
		if (null != curStatusCount) {
			curStatusCount.setSelection(false);
		}
		
		if (type == TenderPackDecInfoComparator.ORDERBY_NO_SIGN) {
			curStatusCount = signStatusCount;
		} else if (type == TenderPackDecInfoComparator.ORDERBY_NO_DEC) {
			curStatusCount = decStatusCount;
		} else if (type == TenderPackDecInfoComparator.ORDERBY_NO_CONFIRM) {
			curStatusCount = confirmStatusCount;
		} else if (type == TenderPackDecInfoComparator.ORDERBY_NO_COMPLATE) {
			curStatusCount = complateStatusCount;
		} else {
			curStatusCount = tenderStatusCount;
		}
		curStatusCount.setSelection(true);
		new Thread(new Runnable() {
			public void run() {
				Display.getDefault().syncExec(new Runnable() {
					public void run() {
						if (!decryptSupplierComposite.isDisposed()) {
							supplierListHeight = scrolledComposite.getBounds().height - gl_decryptSupplierComposite.marginHeight * 2 - gl_decryptSupplierComposite.marginTop - gl_decryptSupplierComposite.marginBottom;
							PAGE_SIZE = supplierListHeight / (TenderPackOpeningListItemComposite.rowHeight + gl_decryptSupplierComposite.verticalSpacing);
							if (null != tenderPackOpeningInfoList && tenderPackOpeningInfoList.size() > PAGE_SIZE && !pageComposite.getVisible()) {
								supplierListHeight -= Math.max(pageComposite.getBounds().height, 31);
								PAGE_SIZE = supplierListHeight / (TenderPackOpeningListItemComposite.rowHeight + gl_decryptSupplierComposite.verticalSpacing);
							}
						}
					}
				});
				final Page<TenderPackOpeningInfo> projectPage = new Page<TenderPackOpeningInfo>();
				if (null != tenderPackOpeningInfoList) {
					int totalCount = 0;
					List<TenderPackOpeningInfo> tenderPackList = new ArrayList<TenderPackOpeningInfo>();
					int pageStart = (PAGE_NO - 1) * PAGE_SIZE;
					
					for (TenderPackOpeningInfo tenderPackOpeningInfo : tenderPackOpeningInfoList) {
						if (null != tenderPackOpeningInfoMap) {
							tenderPackOpeningInfo = tenderPackOpeningInfoMap.get(tenderPackOpeningInfo.getTenderProject().getId());
						}
						if (null != tenderPackOpeningInfo) {
							boolean isJoin = false;
							if (type == TenderPackDecInfoComparator.ORDERBY_NO_SIGN) {
								isJoin = !tenderPackOpeningInfo.isSignComplate();
							} else if (type == TenderPackDecInfoComparator.ORDERBY_NO_DEC) {
								isJoin = !tenderPackOpeningInfo.isDecComplate();
								if (tenderPackOpeningInfo.getDecFailCount() > 0 || tenderPackOpeningInfo.getNoPriceCount() > 0) {
									isJoin = true;
								}
							} else if (type == TenderPackDecInfoComparator.ORDERBY_NO_CONFIRM) {
								isJoin = !tenderPackOpeningInfo.isConfirmComplate();
							} else if (type == TenderPackDecInfoComparator.ORDERBY_NO_COMPLATE) {
								isJoin = !tenderPackOpeningInfo.isComplate();
							} else {
								isJoin = true;
							}
							
							if (isJoin) {
//								if(totalCount >= pageStart && totalCount < pageStart + PAGE_SIZE){
//									tenderPackList.add(tenderPackOpeningInfo);
//								} 
								tenderPackList.add(tenderPackOpeningInfo);
								totalCount++;
							}
						}
					}
					if (type != 0) {
						TenderPackDecInfoComparator tenderPackDecInfoComparator = new TenderPackDecInfoComparator(type);
						Collections.sort(tenderPackList, tenderPackDecInfoComparator);
					}
					
					projectPage.setRecords(tenderPackList.subList(pageStart, Math.min(pageStart + PAGE_SIZE, tenderPackList.size())));
					projectPage.setCurrent(PAGE_NO);
					projectPage.setSize(PAGE_SIZE);
					projectPage.setTotal(totalCount);
				}
				tenderPackOpeningStatusMap.clear();
				
				if (!Display.getDefault().isDisposed()) {
					
					Display.getDefault().syncExec(new Runnable() {
						public void run() {
							if (!decryptSupplierComposite.isDisposed()) {
								decryptSupplierComposite.setData("isFocus", isFocusDecrypt ? "1" : null);
								
								for (Control control : decryptSupplierComposite.getChildren()) {
									control.dispose();
								}
								int width = decryptSupplierComposite.getBounds().width;
								int totalHeight = 0;
								if (null != projectPage && null != projectPage.getRecords() && projectPage.getSize() > 0) {
									for (TenderPackOpeningInfo tenderPackOpeningInfo : projectPage.getRecords()) {
										TenderProjectEntity tenderPack = tenderPackOpeningInfo.getTenderProject();
										
										TenderPackOpeningListItemComposite tenderPackOpeningListItemComposite = new TenderPackOpeningListItemComposite(decryptSupplierComposite, SWT.NONE);
										tenderPackOpeningListItemComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1));
										GridData gd_item = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
										gd_item.widthHint = 500;
										tenderPackOpeningListItemComposite.setLayoutData(gd_item);
										totalHeight += tenderPackOpeningListItemComposite.computeSize(width, SWT.DEFAULT).y;
										tenderPackOpeningListItemComposite.addBatchRemoteBidOpeningListener(BidOpeningRemoteByProjectComposite.this);
										tenderPackOpeningListItemComposite.setTenderPack(tenderPack);
										tenderPackOpeningListItemComposite.refreshTenderPackOpeningInfo(tenderPackOpeningInfo, tenderProjectRuleEntity, bidopeningStage, showOpeningCount, anonymousAllInfo);
										tenderPackOpeningStatusMap.put(tenderPack.getId(), tenderPackOpeningListItemComposite);
									}
								}
								
								boolean oldVisible = pageComposite.getVisible();
								if (projectPage.getPages() > 1) {
									pageComposite.refreshPages(projectPage);
									if (!oldVisible) {
										WidgetUtils.setControlVisible(pageComposite, true);
									}
								} else {
									if (oldVisible) {
										WidgetUtils.setControlVisible(pageComposite, false);
									}
								}
								if (!decryptMainComposite.isDisposed()) {
									decryptMainComposite.layout();
									if (projectPage.getSize() > 0) {
										supplierListHeight = scrolledComposite.getBounds().height - gl_decryptSupplierComposite.marginHeight * 2 - gl_decryptSupplierComposite.marginTop - gl_decryptSupplierComposite.marginBottom;
										
										int surplusHeight = supplierListHeight - projectPage.getSize() * gl_decryptSupplierComposite.verticalSpacing - totalHeight;
										if (surplusHeight > 0) {
											int perHeight = surplusHeight / projectPage.getSize();
											for (Entry<String, TenderPackOpeningStatus> supplierRemoteListner : tenderPackOpeningStatusMap.entrySet()) {
												TenderPackOpeningStatus tenderPackOpeningStatus = supplierRemoteListner.getValue();
												TenderPackOpeningListItemComposite tenderPackOpeningListItemComposite = (TenderPackOpeningListItemComposite) tenderPackOpeningStatus;
												int height = tenderPackOpeningListItemComposite.computeSize(width, SWT.DEFAULT).y + perHeight;
												((GridData) tenderPackOpeningListItemComposite.getLayoutData()).heightHint = height > 70 ? 70 : height;
											}
										}
									}
									reFreshBtn.setEnabled(true);
									decryptSupplierComposite.layout();
									scrolledComposite.setMinSize(decryptSupplierComposite.computeSize(SWT.DEFAULT, SWT.DEFAULT));
								}
								
							}
						}
					});
				}
			}
		}).start();
	}
	
	/**
	 * @Description: 刷新
	 * @author guoyr
	 */
	private void refreshAction() {
		bidOpeningBtn.setEnabled(true);
		downDecInfoProgress = false;
		
		refreshProjectRemoteInfo();
		
		decryptSupplierComposite.layout();
		scrolledComposite.setMinSize(decryptSupplierComposite.computeSize(SWT.DEFAULT, SWT.DEFAULT));
	}
	
	/**
	 * @Description: 开启远程开标大厅
	 * @author guoyr
	 */
	private void startBidopeningAction() {
		if (!startBidopeningBtn.getEnabled()) {
			return;
		}
		
		if(!checkStartOpeningHall()){
			return;
		}
		StringBuilder message = getStartOpeningHallConfirmMsg();
		message.append("\r\n");
		message.append(Messages.Tips_checkAndConfirmOpeningSetting);
		
		ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), null, message.toString(), null);
		confirmDialog.setTipsColor(SWTResourceManager.getColor(255, 0, 0));
		confirmDialog.setTips(Messages.Tips_checkBidOpeningTime);
		confirmDialog.setMinimumSize(new Point(600, 250));
		confirmDialog.addButton(Messages.Button_confirmCorrectAndContinue, "01", null);
		confirmDialog.addCancel(Messages.Button_cancel, null);
		confirmDialog.open();
		
		if (!confirmDialog.getClickStatus().equals("01")) {
			return;
		}
		
		if(!CommonEnum.YES.equals(tenderProjectEntity.getLatestBidinfo())){
			if (synNewBidInfoInfo(Messages.Tips_synchronizingNewTenderInfo)) {
				refreshProjectRemoteInfo();
			}
		}
		BatchStartBidOpeningHallDialog selectBatchOpeningDialog = new BatchStartBidOpeningHallDialog(getShell(), tenderProjectEntity, bidOpeningTime, bidopeningStage, anonymousAllInfo);
		selectBatchOpeningDialog.setTitle(Messages.Button_openRemoteBidOpeningHall);
		selectBatchOpeningDialog.open();
		final List<TenderProjectEntity> tenderPackList = selectBatchOpeningDialog.getSelectTenderPackList();
		if (null != tenderPackList && tenderPackList.size() > 0) {
			startBidopeningBtn.setEnabled(false);
			startBidopeningBtn.setText(Messages.Tips_starting);
			final boolean isSynchronizedInfoOnly = selectBatchOpeningDialog.isSynchronizedInfoOnly();
			final ProgressMessageDialog messageProgress = new ProgressMessageDialog(getShell(), false, -1, new LoadingAdatper() {
				public void finish(boolean openRemoteHall) {
					if (openRemoteHall) {
						if (isSynchronizedInfoOnly) {
							showScrollMsg(Messages.Tips_synchronizingSigninInfo);
						} else {
							showScrollMsg(Messages.Tips_startOpeningHallSuccess);
						}
						// 开启后调用远程签到、解密、确认状态
						if (null != tenderPackOpeningInfoMap) {
							for (TenderProjectEntity tenderPack : tenderPackList) {
								TenderPackOpeningInfo tenderPackOpeningInfo = tenderPackOpeningInfoMap.get(tenderPack.getId());
								if (null != tenderPackOpeningInfo) {
									tenderPackOpeningInfo.setTenderProject(tenderPack);
								}
							}
							refreshTenderPackBidOpeningInfo(null);
						}
						getRemoteProjectSignInfoThread();
					} else {
						showScrollMsg(Messages.Tips_startOpeningHallFail);
					}
					Display.getDefault().syncExec(new Runnable() {
						public void run() {
							if (!startBidopeningBtn.isDisposed()) {
								startBidopeningBtn.setText(Messages.Button_openRemoteBidOpeningHall);
								startBidopeningBtn.setEnabled(true);
								
							}
						}
					});
				}
			});
			new BatchRemoteStartBidopeningHallThread(tenderProjectEntity, tenderPackList, bidopeningStage, bidOpeningTime, signEndTime, decryptEndTime, isSynchronizedInfoOnly, messageProgress).start();
			messageProgress.setTitle(Messages.Button_openRemoteBidOpeningHall);
			messageProgress.open();
		}
	}
	
	/**
	 * @Description: 开标议程
	 * @author guoyr
	 */
	public void showBidOpeningCountDown() {
		if (!openBiddingAgendaBtn.getEnabled()) {
			return;
		}
		String bidOpeningAgenda = tenderProjectRuleEntity.getBidOpeningAgenda();
		if (isPriceStage) {
			if (null != tenderProjectRuleEntity.getPriceBidOpeningAgenda() && tenderProjectRuleEntity.getPriceBidOpeningAgenda().length() > 0) {
				bidOpeningAgenda = tenderProjectRuleEntity.getPriceBidOpeningAgenda();
			}
		}
		BidOpeningCountDownShell countDownShell = new BidOpeningCountDownShell(getShell(), tenderProjectEntity, bidOpeningTime, bidOpeningAgenda);
		countDownShell.open();
	}
	
	/**
	 * @Description: 开标解密
	 * @author guoyr
	 */
	private void openBidAction(boolean synTenderInfo) {
		if (!bidOpeningBtn.getEnabled()) {
			return;
		}
		if (!checkBidOpening()) {
			return;
		}
		
		StringBuilder message = getStartDecryptConfirmMsg();
		message.append("\r\n");
		message.append(Messages.Tips_checkAndConfirmOpeningSetting);
		ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), null, message.toString(), null);
		confirmDialog.setTipsColor(SWTResourceManager.getColor(255, 0, 0));
		confirmDialog.setTips(Messages.Tips_checkSynchronizNewTenderInfoAndCheckTime);
		confirmDialog.setMinimumSize(new Point(600, 250));
		confirmDialog.addButton(Messages.Button_confirmCorrectAndContinue, "01", null);
		confirmDialog.addCancel(Messages.Button_cancel, null);
		confirmDialog.open();
		if (!confirmDialog.getClickStatus().equals("01")) {
			return;
		}
		if(synTenderInfo || !CommonEnum.YES.equals(tenderProjectEntity.getLatestBidinfo())){
			// 经济标不强制同步
			if(!isPriceStage || !CommonEnum.YES.equals(tenderProjectEntity.getLatestBidinfo())) {
				if (synNewBidInfoInfo(Messages.Tips_synchronizingNewTenderInfo)) {
					refreshProjectRemoteInfo();
				}else {
					return;
				}
			}
		}
		if (isFocusDecrypt) {
			decryptRemoteFocusAction();
		} else {
			decryptRemoteAction();
		}
	}
	
	/**
	 * @Description: 远程解密
	 * @author guoyr
	 */
	private void decryptRemoteAction() {
		String title = MessageFormat.format(Messages.Button_batchFormat, decryptName);
		BatchRemoteBidOpeningDialog selectBatchOpeningDialog = new BatchRemoteBidOpeningDialog(getShell(), tenderProjectEntity, bidOpeningTime, bidopeningStage, menuFunctions, anonymousAllInfo);
		if (null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_BUS_TEC)) {
			title = (Messages.BusinessTechnologyBid + " - " + MessageFormat.format(Messages.Button_batchFormat, decryptName));
		} else if (null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_PRICE)) {
			title = (Messages.EconomicBid + " - " + MessageFormat.format(Messages.Button_batchFormat, decryptName));
		}
		selectBatchOpeningDialog.setTitle(title);
		selectBatchOpeningDialog.open();
		final List<TenderProjectEntity> tenderPackList = selectBatchOpeningDialog.getSelectTenderPackList();
		if (null != tenderPackList && tenderPackList.size() > 0) {
			bidOpeningBtn.setEnabled(false);
			final boolean isSynchronizedInfoOnly = selectBatchOpeningDialog.isSynchronizedInfoOnly();
			
			final ProgressMessageDialog messageProgress = new ProgressMessageDialog(getShell(), false, -1, new LoadingAdatper() {
				public void finish(final boolean bool) {
					if (bool) {
						if (isSynchronizedInfoOnly) {
							showScrollMsg(Messages.Tips_synchronizingDecryptInfo);
						} else {
							showScrollMsg(Messages.Tips_startDecryptSuccess);
						}
						refreshProjectRemoteInfo();
						if (!downDecInfoProgress || null == remoteProjectBidOpeningThread) {
							downDecInfoProgress = true;
							getRemoteProjectSignInfoThread();
							getRemoteProjectBidOpeningInfoThread();
						}
					} else {
						showScrollMsg(Messages.Tips_startDecryptFail);
					}
					Display.getDefault().syncExec(new Runnable() {
						public void run() {
							if (!bidOpeningBtn.isDisposed()) {
								bidOpeningBtn.setEnabled(true);
							}
						}
					});
				}
			});
			messageProgress.setTitle(title);
			new BatchRemoteDecryptBidFilThread(tenderProjectEntity, decryptEndTime, bidopeningStage, tenderPackList, isSynchronizedInfoOnly, messageProgress).start();
			messageProgress.open();
		}
	}
	
	/**
	 * @Description: 开标解密
	 * @author guoyr
	 */
	private void decryptRemoteFocusAction() {
		getShell().setData("isFocus", "1");
		String title = MessageFormat.format(Messages.Button_batchFormat, decryptName);
		BatchRemoteBidOpeningDialog selectBatchOpeningDialog = new BatchRemoteBidOpeningDialog(getShell(), tenderProjectEntity, bidOpeningTime, bidopeningStage, menuFunctions, false);
		if (null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_BUS_TEC)) {
			title = (Messages.BusinessTechnologyBid + " - " + MessageFormat.format(Messages.Button_batchFormat, decryptName));
		} else if (null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_PRICE)) {
			title = (Messages.EconomicBid + " - " + MessageFormat.format(Messages.Button_batchFormat, decryptName));
		}
		selectBatchOpeningDialog.setTitle(title);
		selectBatchOpeningDialog.open();
		final List<TenderProjectEntity> tenderPackList = selectBatchOpeningDialog.getSelectTenderPackList();
		if (null != tenderPackList && tenderPackList.size() > 0) {
			final boolean isSynchronizedInfoOnly = selectBatchOpeningDialog.isSynchronizedInfoOnly();
			final ProgressMessageDialog messageProgress = new ProgressMessageDialog(getShell(), false, -1, new LoadingAdatper() {
				public void finish(boolean bool) {
					if (bool) {
						if (isSynchronizedInfoOnly) {
							showScrollMsg(Messages.Tips_synchronizingDecryptInfo);
						} else {
							showScrollMsg(Messages.Tips_startFocusDecryptSuccess);
						}
						refreshProjectRemoteInfo();
						if (!downDecInfoProgress || null == remoteProjectBidOpeningThread) {
							downDecInfoProgress = true;
							getRemoteProjectSignInfoThread();
							getRemoteProjectBidOpeningInfoThread();
						}
					} else {
						showScrollMsg(Messages.Tips_startDecryptFail);
					}
					Display.getDefault().syncExec(new Runnable() {
						public void run() {
							if (!bidOpeningBtn.isDisposed()) {
								bidOpeningBtn.setEnabled(true);
							}
						}
					});
				}
			});
			new BatchFocusDecryptBidFilThread(tenderProjectEntity, tenderPackList, bidopeningStage, bidOpeningTime, signEndTime, decryptEndTime, isSynchronizedInfoOnly, messageProgress).start();
			messageProgress.setTitle(title);
			messageProgress.open();
		}
	}
	
	/**
	 * @Description: 启动远程获得项目的解密、确认等开标信息
	 * @author guoyr
	 */
	private void getRemoteProjectBidOpeningInfoThread() {
		if (null != remoteProjectBidOpeningThread) {
			remoteProjectBidOpeningThread.stop();
			remoteProjectBidOpeningThread = null;
		}
		remoteProjectBidOpeningThread = new BatchDownRemoteBidOpeningResultThread(tenderProjectEntity, tenderProjectRuleEntity, bidopeningStage, this);
		remoteProjectBidOpeningThread.start();
		Display.getDefault().syncExec(new Runnable() {
			public void run() {
				if (!totalCountComposite.isDisposed()) {
					tenderStatusCount.setSelectionIndex(openingIndex);
				}
			}
		});
	}
	
	/**
	 * @Description: 获得远程签到信息
	 * @author guoyr
	 */
	private void getRemoteProjectSignInfoThread() {
		if (null != remoteProjectSignThread) {
			remoteProjectSignThread.stop();
			remoteProjectSignThread = null;
		}
		// 集中解密不需要下载签到信息
		if (!isFocusDecrypt) {
			remoteProjectSignThread = new BatchDownRemoteSignInfoThread(tenderProjectEntity, tenderProjectRuleEntity, bidopeningStage, this);
			remoteProjectSignThread.start();
		}
	}
	
	/**
	 * @Description: 批量完成
	 * @author guoyr
	 */
	private void remoteComplateAction() { 
		if (!signResultBtn.getEnabled()) {
			return;
		}
		
		if(decFailCount > 0 || (noPriceCount > 0 && noPriceCount != decTotalCount)){
			StringBuilder msg = new StringBuilder();
			msg.append(MessageFormat.format(Messages.Tips_projectTotalTenderCountAndDecryptSuccessCount, totalTenderCount, decTotalCount));
			if(decFailCount > 0){
				msg.append(MessageFormat.format(Messages.Tips_decryptFailedCount, decFailCount));
			}
			if(noPriceCount > 0){
				if(decFailCount > 0){
					msg.append(Messages.Comma);
				}
				msg.append(MessageFormat.format(Messages.Tips_obtainQuotationFailedCount, noPriceCount));
			}
			msg.append(Messages.Period);
			msg.append(Messages.Tips_confirmComplateAndUploadOpeningResult);
			
			ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), null, msg.toString(), null);
			confirmDialog.setTipsColor(SWTResourceManager.getColor(255, 0, 0));
			confirmDialog.setTips(Messages.Tips_problemsSolve);
			confirmDialog.setTipsAlignment(SWT.CENTER);
			confirmDialog.addButton(Messages.Button_iKnownAndContinue, "01", SWTResourceManager.getColor(255, 0, 0));
			confirmDialog.addCancel(Messages.Button_cancel, null);
			confirmDialog.open();
			if (!confirmDialog.getClickStatus().equals("01")) {
				return;
			}
		}
		
		BatchRemoteSignResultDialog selectBatchOpeningDialog = new BatchRemoteSignResultDialog(getShell(), tenderProjectEntity, bidOpeningTime, bidopeningStage, anonymousAllInfo, menuFunctions);
		selectBatchOpeningDialog.setTitle(MessageFormat.format(Messages.Button_batchFormat, Messages.Button_complateDecrypt));
		selectBatchOpeningDialog.open();
		String publicType = selectBatchOpeningDialog.getPublicType();
		final List<TenderPackOpeningInfo> tenderPackList = selectBatchOpeningDialog.getSelectTenderPackList();
		if (null != tenderPackList && tenderPackList.size() > 0) {
			signResultBtn.setEnabled(false);
			final boolean complateOnly = selectBatchOpeningDialog.isComplateOnly();
			BatchUploadBidOpeningResultThread uploadBidOpeningResultThread = new BatchUploadBidOpeningResultThread(tenderProjectEntity, tenderPackList, bidopeningStage, publicType, this, complateOnly);
			uploadBidOpeningResultThread.start();
			if (complateOnly) {
				showScrollMsg(Messages.Tips_inCompletingOpening);
			} else {
				showScrollMsg(Messages.Tips_inUploadingAndComplateOpening);
			}
		}
	}
	
	/**
	 * @Description: 获取第一个解密完成的标段
	 * @author guoyr
	 * @return 
	 */
	private TenderProjectEntity getFirstDecryptComplateTenderPack() {
		TenderProjectEntity firstDecryptTenderPack = null;
		if (null != tenderPackOpeningInfoMap) {
			for (Entry<String, TenderPackOpeningInfo> entry : tenderPackOpeningInfoMap.entrySet()) {
				TenderProjectEntity tenderPack = entry.getValue().getTenderProject();
				if (CommonEnum.COMPLETE.equals(tenderPack.getPriceBidStatus())) {
					firstDecryptTenderPack = tenderPack;
					break;
				}
			}
			if (null == firstDecryptTenderPack) {
				for (Entry<String, TenderPackOpeningInfo> entry : tenderPackOpeningInfoMap.entrySet()) {
					if(entry.getValue().getDecCount() > 0 && entry.getValue().isDecComplate()) {
						firstDecryptTenderPack = entry.getValue().getTenderProject();
						break;
					}
				}
			}
		}
		return firstDecryptTenderPack;
	}
	/**
	 * @Description: 唱标
	 * @author guoyr
	 */
	private void signBidAction() {
		if (!signBidBtn.getEnabled()) return;
		
		TenderProjectEntity complateTenderPack = getFirstDecryptComplateTenderPack();
		if (null == complateTenderPack) {
			MessageDialog.openShortMessage("没有可唱标的" + PACK_NAME + "！");
			return;
		}
		SingBidShell singBidShell = new SingBidShell(getShell(), complateTenderPack);
		singBidShell.open();
	}
	
	/**
	 * @Description: 签字确认
	 * @author guoyr 
	 */
	private void signatureAction() {
		if(!signatureBtn.getEnabled())return;
		TenderProjectEntity complateTenderPack = getFirstDecryptComplateTenderPack();
		if (null == complateTenderPack) {
			MessageDialog.openShortMessage("没有可签字确认的" + PACK_NAME + "！");
			return;
		}
		BidOpeningReportDialog dialog = new BidOpeningReportDialog(getShell(), complateTenderPack, true, menuFunctions);
		dialog.setTitle(Messages.Button_remoteSignatureOpeningResult);
		dialog.open();
	}
	
	/**
	 * @Description: 发送消息
	 * @author guoyr
	 */
	private void sendMessageAction() {
		if (null != sendMessageDialog && !sendMessageDialog.isDisposed()) {
			sendMessageDialog.showDialog();
		} else {
			StringBuilder stageIds = new StringBuilder();
			for (TenderPackOpeningInfo tenderPackOpeningInfo : tenderPackOpeningInfoList) {
				if (stageIds.length() > 0) {
					stageIds.append(",");
				}
				if (null != tenderPackOpeningInfo.getTenderProject().getStageId()) {
					stageIds.append(tenderPackOpeningInfo.getTenderProject().getStageId());
				}
			}
			sendMessageDialog = new SendMessageDialog(getShell(), tenderProjectEntity, bidopeningStage, stageIds.toString());
			sendMessageDialog.setSize(200, 300);
			sendMessageDialog.setAlpha(250);
			ScreenUtils screenUtils = new ScreenUtils();
			sendMessageDialog.setLocation(0, 0);
			sendMessageDialog.setLocation((screenUtils.getScreenWight() - sendMessageDialog.getBounds().width), screenUtils.getScreenHight() - sendMessageDialog.getBounds().height - 40);
			sendMessageDialog.open();
		}
	}
	
	/**
	 * @Description: 修改开标状态
	 * @author guoyr
	 * @param status
	 */
	
	/**
	 * @Description: 鼠标拖动事件
	 * @author guoyr
	 */
	
	protected void createContents() {
		setSize(450, 300);
		Dimension d = Toolkit.getDefaultToolkit().getScreenSize(); // 取得当前屏幕属性
		int w = d.width; // 获取屏幕宽度
		int h = d.height; // 获取屏幕高度
		setSize(w, h);
		
	}
	
	/**
	 * @Description: 检查是否允许开标
	 * @author guoyr
	 * @return
	 */
	private boolean checkBidOpening() {
		
		if(!checkStartDecrypt()){
			return false;
		}
		// 如果是经济标类型评标步骤，必须开完经济标才能操作
		if (isPriceStage) {
			if(null != menuFunctions && MenuFunction.SHOW.equals(menuFunctions.getAuthority("NEED_COMPLATE_BUS_TEC"))){
				EvaluationStepService evaluationStepService = new EvaluationStepService();
				if (!evaluationStepService.isComplateBusAndTecEvaluation(tenderProjectEntity.getId())) {
					ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), null, Messages.Tips_cantDescryptEconomicBid, null);
					confirmDialog.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/tips_info.png"), -1, -1);
					confirmDialog.addCancel(Messages.Button_cancel, null);
					confirmDialog.open();
					return false;
				}
			}
		}
		return true;
	}
	
//	private void exitAction() {
//		if (downDecInfoProgress && isShowDownloadProgress) {
//			ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), null, "正在" + decryptName + "中，确认要退出吗？", null);
//			confirmDialog.addButton("确认退出", "01", null);
//			confirmDialog.addCancel(Messages.Button_cancel, null);
//			confirmDialog.open();
//			if (confirmDialog.isCancel()) {
//				return;
//			}
//		}
//		close();
//		if (null != meetingRoomListener) {
//			meetingRoomListener.exitMeetingRoom();
//		}
//	}
	
	/**
	 * @Description: 查看详情
	 * @author guoyr
	 * @param tenderPackOpeningInfo
	 */
	public void clickTenderPackInfo(TenderPackOpeningInfo tenderPackOpeningInfo) {
		if (isFocusDecrypt) {
			getShell().setData("isFocus", isFocusDecrypt ? "1" : null);
		}
		TenderPackOpeningSupplierDetailsShell detailsShell = new TenderPackOpeningSupplierDetailsShell(getShell(), tenderPackOpeningInfo, tenderProjectRuleEntity, bidopeningStage);
		detailsShell.addBatchRemoteBidOpeningListener(this);
		detailsShell.setSize(getSize());
		detailsShell.setLocation(toDisplay(0, 0));
		detailsShell.open();
	}
	
	/**
	 * @Description: 初始化刷新包件列表
	 * @author guoyr
	 * @param tenderPackOpeningInfoList
	 */
	public void initRefreshTenderPackList(List<TenderPackOpeningInfo> _tenderPackOpeningInfoList) {
		if (null == tenderPackOpeningInfoList && null != _tenderPackOpeningInfoList) {
			
			tenderPackOpeningInfoList = _tenderPackOpeningInfoList;
			for (TenderPackOpeningInfo tenderPackOpeningInfo : tenderPackOpeningInfoList) {
				TenderProjectEntity tenderPack = tenderPackOpeningInfo.getTenderProject();
				String bidStatus = tenderPack.getBusinessBidStatus();
				if (isPriceStage) {
					bidStatus = tenderPack.getPriceBidStatus();
				}
				if(!downDecInfoProgress) {
					downDecInfoProgress = isInDecProgress(bidStatus);
				}
				
				if(!showOpeningCount) {
					showOpeningCount = isShowOpeningCount(bidStatus);
				}
			}
			if (downDecInfoProgress) {
				getRemoteProjectBidOpeningInfoThread();
			}
			
			getRemoteProjectSignInfoThread();
			
			Display.getDefault().syncExec(new Runnable() {
				public void run() {
					if (!decryptSupplierComposite.isDisposed()) {
						showTenderPackList(0);
						tenderStatusCount.setSelectionIndex(showOpeningCount ? openingIndex : isFocusDecrypt ? threeIndex : 0);
					}
				}
			});
		}
	}
	
	private boolean isInDecProgress(String bidStatus) {
		if(CommonEnum.IN_PROGRESS.equals(bidStatus)) {
			return true;
		}else {
			return false;
		}
	}
	private boolean isShowOpeningCount(String bidStatus) {
		if(StringUtils.isEmpty(bidStatus) || CommonEnum.NOT_START.equals(bidStatus)) {
			return false;
		}else {
			return true;
		}
	}
	
	/**
	 * @Description: 刷新签到信息
	 * @author guoyr
	 * @param tenderPackOpeningInfo
	 */
	public void refreshTenderPackInfo(TenderProjectEntity tenderPack) {
		if (null != tenderPack && null != tenderPackOpeningInfoMap) {
			TenderPackOpeningInfo tenderPackOpeningInfo = tenderPackOpeningInfoMap.get(tenderPack.getId());
			if (null != tenderPackOpeningInfo) {
				tenderPackOpeningInfo.setTenderProject(tenderPack);
				refreshBidOpeningStatusInfo(tenderPackOpeningInfo);
			}
		}
	}
	
	/**
	 * @Description: 刷新签到信息
	 * @author guoyr
	 * @param tenderPackOpeningInfo
	 */
	public void refreshTenderInfoStatus(boolean isShowEffectiveCount) {
		if (null != tenderPackOpeningInfoMap) {
			Map<String, TenderPackOpeningStatus> tempTenderPackOpeningStatusMap = new HashMap<String, TenderPackOpeningStatus>();
			tempTenderPackOpeningStatusMap.putAll(tenderPackOpeningStatusMap);
			for (Entry<String, TenderPackOpeningStatus> entry : tempTenderPackOpeningStatusMap.entrySet()) {
				TenderPackOpeningStatus tenderPackOpeningStatus = entry.getValue();
				if (null != tenderPackOpeningStatus) {
					tenderPackOpeningStatus.refreshTenderInfoStatus(isShowEffectiveCount);
				}
			}
			tempTenderPackOpeningStatusMap.clear();
			tempTenderPackOpeningStatusMap = null;
		}
	}
	
	/**
	 * @Description: 刷新签到信息
	 * @author guoyr
	 * @param tenderPackOpeningInfo
	 */
	public void refreshSignInfo(TenderPackOpeningInfo tenderPackOpeningInfo) {
		if (tenderPackOpeningInfo.getSignCount() > 0) {
			boolean showNewMsg = false;
			if (null != tenderPackOpeningInfoMap) {
				TenderPackOpeningInfo beforeTenderPackOpeningInfo = tenderPackOpeningInfoMap.get(tenderPackOpeningInfo.getTenderProject().getId());
				if (null != beforeTenderPackOpeningInfo && beforeTenderPackOpeningInfo.getSignCount() != tenderPackOpeningInfo.getSignCount()) {
					showNewMsg = true;
				}
			} else {
				showNewMsg = true;
			}
			
			TenderProjectEntity tenderPack = tenderPackOpeningInfo.getTenderProject();
			if (showNewMsg) {
				if(tenderPackOpeningInfo.isSignComplate()) {
					showScrollMsg(MessageFormat.format(Messages.Tips_tenderProjectSignintAll, tenderPack.getTenderName()));
				}else {
					showScrollMsg(MessageFormat.format(Messages.Tips_tenderProjectSigninInfo, tenderPack.getTenderName(), anonymousAllInfo ? "*" : tenderPackOpeningInfo.getSignCount()));
				}
				refreshBidOpeningStatusInfo(tenderPackOpeningInfo);
			}
		}
	}
	
	/**
	 * @Description: 刷新远程解密信息
	 * @author guoyr
	 * @param tenderPackOpeningInfo
	 */
	public void refreshDescInfo(TenderPackOpeningInfo tenderPackOpeningInfo) {
		
		boolean showNewMsg = false;
		if (null != tenderPackOpeningInfoMap) {
			TenderPackOpeningInfo beforeTenderPackOpeningInfo = tenderPackOpeningInfoMap.get(tenderPackOpeningInfo.getTenderProject().getId());
			if (null != beforeTenderPackOpeningInfo && (beforeTenderPackOpeningInfo.getDecCount() != tenderPackOpeningInfo.getDecCount() || tenderPackOpeningInfo.getDecFailCount() != beforeTenderPackOpeningInfo.getDecFailCount()|| tenderPackOpeningInfo.getNoPriceCount() != beforeTenderPackOpeningInfo.getNoPriceCount())) {
				showNewMsg = true;
			}
			
		} else {
			showNewMsg = true;
		}
		if (showNewMsg) {
			TenderProjectEntity tenderPack = tenderPackOpeningInfo.getTenderProject();
			if(tenderPackOpeningInfo.isDecComplate()) {
				showScrollMsg(MessageFormat.format(Messages.Tips_tenderProjectDecryptAll, tenderPack.getTenderName()));
			}else {
				showScrollMsg(MessageFormat.format(Messages.Tips_tenderProjectDecryptInfo, tenderPack.getTenderName(), anonymousAllInfo ? "*" : tenderPackOpeningInfo.getDecCount()));
			}
			refreshBidOpeningStatusInfo(tenderPackOpeningInfo);
		} else if (tenderPackOpeningInfo.openingCount > 0 && null != tenderPackOpeningInfoMap) {
			tenderPackOpeningInfoMap.put(tenderPackOpeningInfo.getTenderProject().getId(), tenderPackOpeningInfo);
			int openingCount = 0;
			for (Entry<String, TenderPackOpeningInfo> entry : tenderPackOpeningInfoMap.entrySet()) {
				TenderPackOpeningInfo _tenderPackOpeningInfo = entry.getValue();
				if (!anonymousAllInfo) {
					openingCount += _tenderPackOpeningInfo.getOpeningCount();
				}
			}
			if (anonymousAllInfo && openingCount == 0) {
				 openingCount = -1;
			}
			tenderStatusCount.setCountValue(openingIndex, openingCount);
		}
		
	}
	
	/**
	 * @Description: 刷新完成开标信息
	 * @author guoyr
	 * @param tenderPackOpeningInfo
	 */
	public void refreshUploadComplateInfo(TenderPackOpeningInfo tenderPackOpeningInfo) {
		if (tenderPackOpeningInfo.isComplate()) {
			TenderProjectEntity tenderPack = tenderPackOpeningInfo.getTenderProject();
			showScrollMsg(MessageFormat.format(Messages.Tips_projectDecryptComplate, tenderPack.getTenderName()));
			refreshBidOpeningStatusInfo(tenderPackOpeningInfo);
		}
	}
	
	/**
	 * @Description: 显示消息
	 * @author guoyr
	 * @param flag
	 * @param message
	 */
	public void showMessage(int flag, String message) {
		showScrollMsg(message);
	}
	
	/**
	 * @Description: 完成上传开标结果
	 * @author guoyr
	 * @param successCount
	 * @param failCount
	 */
	public void finishComplateAndUpload(int successCount, int failCount) {
		Display.getDefault().syncExec(new Runnable() {
			public void run() {
				if (!signResultBtn.isDisposed()) {
					signResultBtn.setEnabled(true);
				}
			}
		});
		
		if (failCount > 0) {
			showScrollMsg(MessageFormat.format(Messages.Tips_uploadOpeningResultFailCount, failCount));
		}
	}
	
	/**
	 * @Description: 刷新包件的开标信息
	 * @author guoyr
	 * @param _tenderPackOpeningInfoMap
	 */
	public synchronized void refreshTenderPackBidOpeningInfo(Map<String, TenderPackOpeningInfo> _tenderPackOpeningInfoMap) {
		if (null != _tenderPackOpeningInfoMap) {
			tenderPackOpeningInfoMap = _tenderPackOpeningInfoMap;
		}
		refreshTotalCount();
		new Thread(new Runnable() {
			public void run() {
				if (null != tenderPackOpeningInfoMap) {
					Map<String, TenderPackOpeningStatus> tempTenderPackOpeningStatusMap = new HashMap<String, TenderPackOpeningStatus>();
					tempTenderPackOpeningStatusMap.putAll(tenderPackOpeningStatusMap);
					for (Entry<String, TenderPackOpeningStatus> entry : tempTenderPackOpeningStatusMap.entrySet()) {
						TenderPackOpeningStatus tenderPackOpeningStatus = entry.getValue();
						if (null != tenderPackOpeningStatus) {
							tenderPackOpeningStatus.refreshTenderPackOpeningInfo(tenderPackOpeningInfoMap.get(tenderPackOpeningStatus.getTenderPack().getId()), tenderProjectRuleEntity, bidopeningStage, showOpeningCount, anonymousAllInfo);
						}
					}
					tempTenderPackOpeningStatusMap.clear();
					tempTenderPackOpeningStatusMap = null;
				}
				
				Display.getDefault().syncExec(new Runnable() {
					public void run() {
						if(!downTenderInfoBtn.isDisposed()){
							downTenderInfoBtn.setEnabled(true);
						}
					}
				});
			}
		}).start();
	}
	
	/**
	 * @Description: 刷新总的统计数据
	 * @author guoyr
	 */
	private void refreshTotalCount() {
		if (null != tenderPackOpeningInfoMap) {
			int tenderPackCount = tenderPackOpeningInfoMap.size();
			int threeTenderCount = 0;
			int openingCount = 0;
			int signComplateCount = 0;
			int signDetailCount = 0;
			int decComplateCount = 0;
			int confirmComplateCount = 0;
			int confirmDetailCount = 0;
			int complateCount = 0;
			totalTenderCount = 0;
			decTotalCount = 0;
			noPriceCount = 0;
			decFailCount = 0;
			complateDetailCount = 0;
//			int noPriceCount = 0;
			for (Entry<String, TenderPackOpeningInfo> entry : tenderPackOpeningInfoMap.entrySet()) {
				TenderPackOpeningInfo tenderPackOpeningInfo = entry.getValue();
                    
				if (!anonymousAllInfo) {
                	totalTenderCount += tenderPackOpeningInfo.getTenderCount();
                	if (tenderPackOpeningInfo.getTenderCount() > 2) {
                		threeTenderCount += tenderPackOpeningInfo.getTenderCount();
                	}
                	openingCount += tenderPackOpeningInfo.getOpeningCount();
                	if (tenderPackOpeningInfo.isSignComplate()) {
                		signComplateCount++;
                	}
                	signDetailCount += tenderPackOpeningInfo.getSignCount();
                	if (tenderPackOpeningInfo.isDecComplate()) {
                		decComplateCount++;
                	}
                	decTotalCount += tenderPackOpeningInfo.getDecCount();
                	decFailCount += tenderPackOpeningInfo.getDecFailCount();
    				noPriceCount += tenderPackOpeningInfo.getNoPriceCount();
                	if (tenderPackOpeningInfo.isConfirmComplate()) {
                		confirmComplateCount++;
                	}
                	confirmDetailCount += tenderPackOpeningInfo.getConfirmCount();
                	if (tenderPackOpeningInfo.isComplate()) {
                		complateCount++;
                		complateDetailCount += tenderPackOpeningInfo.getDecCount();
                	}
                }
			}
			
			if(anonymousAllInfo) {
				totalTenderCount = totalTenderCount == 0 ? -1 : totalTenderCount;
				threeTenderCount = threeTenderCount == 0 ? -1 : threeTenderCount;
				openingCount = openingCount == 0 ? -1 : openingCount;
				signDetailCount = signDetailCount == 0 ? -1 : signDetailCount;
				signComplateCount = signComplateCount == 0 ? -1 : signComplateCount;
				decTotalCount = decTotalCount == 0 ? -1 : decTotalCount;
				decComplateCount = decComplateCount == 0 ? -1 : decComplateCount;
				confirmDetailCount = confirmDetailCount == 0 ? -1 : confirmDetailCount;
				confirmComplateCount = confirmComplateCount == 0 ? -1 : confirmComplateCount;
				complateDetailCount = complateDetailCount == 0 ? -1 : complateDetailCount;
			}
			
			tenderStatusCount.setCounts(new int[] { totalTenderCount, threeTenderCount, openingCount, tenderPackCount });
			signStatusCount.setCounts(new int[] { signDetailCount, signComplateCount });
			decStatusCount.setCounts(new int[] { decTotalCount, decComplateCount });
			decStatusCount.setErrors(decFailCount + noPriceCount);
			confirmStatusCount.setCounts(new int[] { confirmDetailCount, confirmComplateCount });
			complateStatusCount.setCounts(new int[] { complateDetailCount, complateCount });
			if(decFailCount + noPriceCount > 0){
				String message = "";
				if(decFailCount > 0) {
					message = MessageFormat.format(Messages.Tips_decryptFailedCount, decFailCount);
				}
				if(noPriceCount > 0) {
					message = message.concat(MessageFormat.format(Messages.Tips_obtainQuotationFailedCount, noPriceCount));
				}
				showScrollMsg(message);
			}
			if (isFocusDecrypt) {
				
				// 集中解密不需要签到，则刷新总投标座位人数
				meetingRoomListener.refreshPeopleCount(totalTenderCount);
			} else {
				
				// 刷新签到座位人数
				meetingRoomListener.refreshPeopleCount(signDetailCount);
			}
			
			if (complateCount > 0 && (null == tenderProjectEntity.getBidOpeningStatus() || !tenderProjectEntity.getBidOpeningStatus().equals(CommonEnum.COMPLETE))) {
				tenderProjectEntity.setBidOpeningStatus(CommonEnum.COMPLETE);
				tenderProjectService.updateAssignProperty(tenderProjectEntity, new String[] {"id" ,"bidOpeningStatus" });
			}
			
			if (complateDetailCount > 0 && (decFailCount + noPriceCount == 0) && complateDetailCount == decTotalCount) {
				tenderProjectService.updateBidOpeningStatus(tenderProjectEntity, bidopeningStage, CommonEnum.COMPLETE);
			}
		}
	}
	
	/**
	 * @Description: 刷新远程开标信息
	 * @author guoyr
	 */
	public void refreshProjectRemoteInfo() {
		anonymousAllInfo = isShowAnonymName(tenderProjectRuleEntity.getIsAnonymous());
		if (null != refreshProjectBidOpeningInfoThread) {
			refreshProjectBidOpeningInfoThread.stop();
			refreshProjectBidOpeningInfoThread = null;
		}
		refreshProjectBidOpeningInfoThread = new RefreshProjectBidOpeningInfoThread(tenderProjectEntity, tenderProjectRuleEntity, bidopeningStage, this);
		refreshProjectBidOpeningInfoThread.start();
	}
	
	/**
	 * @Description: 刷新包件的远程开标结果
	 * @author guoyr
	 * @param tenderPackOpeningInfo
	 */
	public synchronized void refreshBidOpeningStatusInfo(TenderPackOpeningInfo tenderPackOpeningInfo) {
		if (null != tenderPackOpeningInfo && null != tenderPackOpeningInfoMap) {
			tenderPackOpeningInfoMap.put(tenderPackOpeningInfo.getTenderProject().getId(), tenderPackOpeningInfo);
			refreshTotalCount();
			TenderPackOpeningStatus tenderPackOpeningStatus = tenderPackOpeningStatusMap.get(tenderPackOpeningInfo.getTenderProject().getId());
			if (null != tenderPackOpeningStatus) {
				tenderPackOpeningStatus.refreshTenderPackOpeningInfo(tenderPackOpeningInfo, tenderProjectRuleEntity, bidopeningStage, showOpeningCount, anonymousAllInfo);
			}
		}
	}
	
	/**
	 * @Description: 是否正在下载开标信息中
	 * @author guoyr
	 * @param isDownloading
	 */
	public void setDownloadBidopeningInfo(boolean isDownloading) {
		if (isDownloading) {
			if (!isShowDownloadProgress) {
				showInRemoteStatusThread();
			}
		} else {
			if (null != showInRemoteStatusThread) {
				showInRemoteStatusThread.stop();
				showInRemoteStatusThread = null;
			}
			downDecInfoProgress = false;
		}
	}
	
	/**
	 * @Description: 此次解密完成
	 * @author guoyr
	 * @param decryptCount
	 * @param decryptFailCount
	 */
	public void decryptComplate(final int decryptCount, final int decryptFailCount, final int noPriceCount) {
		refreshTotalCount();
		if (decryptCount > 0) {
			Display.getDefault().syncExec(new Runnable() {
				public void run() {
					StringBuilder msg = new StringBuilder();
					msg.append(Messages.Tips_decryptableFileDecryptComplate);
					if(decryptFailCount > 0 || (noPriceCount > 0 && noPriceCount != decryptCount)){
						if(decryptFailCount > 0){
							msg.append(MessageFormat.format(Messages.Tips_decryptFailedCount, decryptFailCount));
						}
						if(noPriceCount > 0){
							if(decryptFailCount > 0){
								msg.append(Messages.Comma);
							}
							msg.append(MessageFormat.format(Messages.Tips_obtainQuotationFailedCount, noPriceCount));
						}
						msg.append(Messages.Period);
						ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), null, msg.toString(), null);
						confirmDialog.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/tips_info.png"), -1, -1);
						confirmDialog.addButton(Messages.Button_ok, "01", null, 90);
						confirmDialog.setTipsAlignment(SWT.CENTER);
						confirmDialog.setTipsColor(SWTResourceManager.getColor(255, 0, 0));
						confirmDialog.setTips(Messages.Tips_problemsSolve);
						confirmDialog.open();
						return;
					}
					if (!getShell().isDisposed() && complateDetailCount < decryptCount) {
						msg.append(Messages.Tips_whetherComplateAndUploadOpeningResult);
						ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), null, msg.toString(), null);
//						confirmDialog.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/tips_info.png"), -1, -1);
						confirmDialog.addButton(Messages.Button_complateAndUploadOpeningResult, "01", SWTResourceManager.getColor(77, 163, 19), 90);
						confirmDialog.addCancel(Messages.Button_cancel, null);
						confirmDialog.setTipsAlignment(SWT.CENTER);
						confirmDialog.setTipsColor(SWTResourceManager.getColor(255, 0, 0));
						confirmDialog.open();
						if("01".equals(confirmDialog.getClickStatus())) {
							remoteComplateAction();
						}
					}
				}
			});
		}
	}
	
	/**
	 * @Description: 显示是否正在下载远程开标信息
	 * @author guoyr
	 */
	private void showInRemoteStatusThread() {
		if (null != showInRemoteStatusThread) {
			showInRemoteStatusThread.stop();
			showInRemoteStatusThread = null;
		}
		
		final Runnable show = new Runnable() {
			public void run() {
				if (!bidOpeningBtn.isDisposed()) {
					bidOpeningBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/wifi.png"));
				} else {
					isShowDownloadProgress = false;
				}
			}
		};
		final Runnable hide = new Runnable() {
			public void run() {
				if (!bidOpeningBtn.isDisposed()) {
					bidOpeningBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/key.png"));
				} else {
					isShowDownloadProgress = false;
				}
			}
		};
		
		showInRemoteStatusThread = new MyRunnable() {
			public void stop() {
				isShowDownloadProgress = false;
				super.stop();
			}
			
			public void run() {
				boolean isShow = true;
				isShowDownloadProgress = true;
				while (null != this.thread && isShowDownloadProgress) {
					if (isShow) {
						Display.getDefault().syncExec(show);
					} else {
						Display.getDefault().syncExec(hide);
					}
					try {
						Thread.sleep(1000);
					} catch (InterruptedException e) {}
					isShow = !isShow;
				}
				isShowDownloadProgress = false;
				Display.getDefault().syncExec(hide);
			}
		};
		showInRemoteStatusThread.start();
	}
	
	/**
	 * @Description: 同步最新投标信息
	 * @author guoyr
	 * @return 
	 */
	private boolean synNewBidInfoInfo(String title){
		final ProgressMessageDialog messageProgress = new ProgressMessageDialog(getShell(), true, -1, new LoadingAdatper() {
			public void finish(final boolean flag) {
				if(flag){
					// 如果已过开标时间，则标识为已同步最新投标信息
					if(NowTimeUtils.getNowDate().after(bidOpeningTime)){
						tenderProjectEntity.setLatestBidinfo(CommonEnum.YES);
						ActionLogUtils.addServerLog(tenderProjectEntity.getId(), "开标时间之后最后同步过最新投标人信息", tenderProjectEntity.getTenderNo() + tenderProjectEntity.getTenderName());
						tenderProjectService.updateAssignProperty(tenderProjectEntity, new String[]{"latestBidinfo"});
					}
				}
				Display.getDefault().syncExec(new Runnable(){
					public void run(){
						if(!downTenderInfoBtn.isDisposed()){
							downTenderInfoBtn.setEnabled(true);
						}
					}
				});
			}
		});
		messageProgress.setTitle(title);
		RefreshProjectSupplierTenderInfoThread refreshProjectSupplierTenderInfoThread = new RefreshProjectSupplierTenderInfoThread(tenderProjectEntity, messageProgress);
		refreshProjectSupplierTenderInfoThread.start();
		messageProgress.open();
		refreshProjectSupplierTenderInfoThread.stop();
		return messageProgress.getFinishFlag();
	}
	
	
	/**
	 * @Description: 更多设置
	 * @author guoyr
	 */
	private void moreConfigAction() {
		
		final ToolsShell moreToolsShell = new ToolsShell(getShell());
		final Composite actionGroup = moreToolsShell.addToolBar(Messages.Button_moreOperate, null, false);
		
		moreToolsShell.addTool(actionGroup, Messages.Button_syncNewTenderInfo, imageResolver.loadImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/wifi.png"), true, new ToolsShell.ClickListener() {
			public void click() {
				moreToolsShell.close();
				if (synNewBidInfoInfo(Messages.Tips_synchronizingNewTenderInfo)) {
					refreshProjectRemoteInfo();
				}
			}
		});
		
//		final boolean showFullScreen = PropertiesUtils.getProperty(ConfigConstants.BID_OPENING_FULLSCREEN, "00").equals("01");
		boolean isFullScreen = getShell().getMaximized();
		moreToolsShell.addTool(actionGroup, isFullScreen? "显示任务栏" : "全屏显示", imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/btn/blue/evaluation.png"), true, new ToolsShell.ClickListener(){
			public void click() {
//				PropertiesUtils.saveProperty(ConfigConstants.BID_OPENING_FULLSCREEN, (!showFullScreen) ? "01" : "00");
//				if(PropertiesUtils.getProperty(ConfigConstants.BID_OPENING_FULLSCREEN, "00").equals("00")){
//				}
				moreToolsShell.close();
				if(isFullScreen) {
					getShell().setMaximized(false);
					ScreenUtils screenUtils = new ScreenUtils();
					int w = screenUtils.getScreenWight(); // 获取屏幕宽度
					int h = screenUtils.getScreenHight() - screenUtils.getTaskBarHight(); // 获取屏幕高度
					getShell().setLocation(0, 0);
					getShell().setSize(w,h);
				}else {
					getShell().setMaximized(true);
					getShell().notifyListeners(SWT.Resize, null);
				}
				
			}
		});
		
		Composite toolGroup = moreToolsShell.addToolBar(Messages.Config_propertyConfiguration, null, false);
		
		moreToolsShell.addTool(toolGroup, showProjectNo ? Messages.Button_notShowProjectCode : Messages.Button_showProjectCode, null, true, new ToolsShell.ClickListener() {
			public void click() {
				showProjectNo = !showProjectNo;
				if (!moreToolsShell.isDisposed()) {
					moreToolsShell.close();
				}
				if (showProjectNo) {
					meetingRoomListener.refreshMeetingTitle("[" + tenderProjectEntity.getTenderNo() + "]" + tenderProjectEntity.getTenderName());
				} else {
					meetingRoomListener.refreshMeetingTitle(tenderProjectEntity.getTenderName());
				}
			}
		});
		
		if(null != menuFunctions && MenuFunction.SHOW.equals(menuFunctions.getAuthority("SHOW_CONFIRM_STATUS"))){
			final boolean isShowConfirm = PropertiesUtils.getProperty(ConfigConstants.SHOW_CONFIRM_STATUS, "00").equals("01");
			moreToolsShell.addTool(toolGroup, isShowConfirm ? Messages.Button_noNeedConfirmResult : Messages.Button_needConfirmResult, imageResolver.loadImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/user.png"), true, new ToolsShell.ClickListener() {
				public void click() {
					PropertiesUtils.saveProperty(ConfigConstants.SHOW_CONFIRM_STATUS, (!isShowConfirm) ? "01" : "00");
					moreToolsShell.close();
					WidgetUtils.setControlVisible(confirmCountComposite, !isShowConfirm);
//				((GridData) confirmCountComposite.getLayoutData()).exclude = (!isShowConfirm) ? false : true;
//				confirmCountComposite.setVisible(!isShowConfirm);
					totalCountComposite.layout();
					totalCountComposite.getParent().layout();
					if (null != tenderPackOpeningInfoMap) {
						Map<String, TenderPackOpeningStatus> tempTenderPackOpeningStatusMap = new HashMap<String, TenderPackOpeningStatus>();
						tempTenderPackOpeningStatusMap.putAll(tenderPackOpeningStatusMap);
						for (Entry<String, TenderPackOpeningStatus> entry : tempTenderPackOpeningStatusMap.entrySet()) {
							TenderPackOpeningStatus tenderPackOpeningStatus = entry.getValue();
							if (null != tenderPackOpeningStatus) {
								tenderPackOpeningStatus.setShowComfirmStatus(!isShowConfirm);
							}
						}
						tempTenderPackOpeningStatusMap.clear();
						tempTenderPackOpeningStatusMap = null;
					}
				}
			});
		}
		
		moreToolsShell.addTool(toolGroup, automaticSwitchPage ? Messages.Button_autoSwitchPageOff : Messages.Button_autoSwitchPageOn, imageResolver.loadImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/switch.png"), pageComposite.getLastPage() != 1, new ToolsShell.ClickListener() {
			public void click() {
				automaticSwitchPage = !automaticSwitchPage;
				if (automaticSwitchPage) {
					automaticSwitchPageAction();
				}
				moreToolsShell.close();
			}
		});
		
		moreToolsShell.addTool(toolGroup, Messages.Button_setAutoSwitchPageTime, imageResolver.loadImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/config.png"), pageComposite.getLastPage() != 1, new ToolsShell.ClickListener() {
			public void click() {
				InputDialog dialog = new InputDialog(getShell(), Messages.Button_setAutoSwitchPageTime+"("+Messages.Time_second+")", intervalSecond + "");
				dialog.open();
				int _intervalSecond = Integer.parseInt(dialog.getInputValue());
				if (_intervalSecond <= 0) {
					MessageDialog.openShortMessage(MessageFormat.format(Messages.Tips_pleaseEnterTheValid, Messages.Button_setAutoSwitchPageTime));
					return;
				}
				intervalSecond = _intervalSecond;
			}
		});
		
		moreToolsShell.addTool(toolGroup, showNowTime ? Messages.Button_notShowNowTime + "（"+Messages.Tips_reEntryOpeningHallEffect+"）" : Messages.Button_showNowTime + " （"+Messages.Tips_reEntryOpeningHallEffect+"）", imageResolver.loadImage(IconsActivator.PLUGIN_ID, "icons/data.png"), true, new ToolsShell.ClickListener() {
			public void click() {
				showNowTime = !showNowTime;
				PropertiesUtils.saveProperty(ConfigConstants.SHOW_NOW_TIME, showNowTime ? "01" : "00");
				moreToolsShell.close();
			}
		});
		if(null != menuFunctions && MenuFunction.SHOW.equals(menuFunctions.getAuthority(MenuFunctionEnum.SHOW_IS_ANONYMOUS_CONFIG))){
			
			moreToolsShell.addTool(toolGroup, tenderProjectRuleEntity.getIsAnonymous() ? "非匿名显示" : "匿名显示", imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/btn/blue/question.png"), true, new ToolsShell.ClickListener(){
				public void click() {
					tenderProjectRuleEntity.setIsAnonymous(!tenderProjectRuleEntity.getIsAnonymous());
					projectRuleService.updateAssignProperty(tenderProjectRuleEntity, new String[] {"isAnonymous"});
					projectRuleService.updateAssignPropertyByProjectId(tenderProjectEntity.getId(), tenderProjectRuleEntity, new String[] {"isAnonymous"});
					moreToolsShell.close();
				}
			});
		}
		
		if(null != menuFunctions && MenuFunction.SHOW.equals(menuFunctions.getAuthority(VideoConfigConstants.USE_LIVE))){
			final Composite livingAddressConfigComposite = moreToolsShell.addToolBar(Messages.Config_liveBroadcastConfiguration, null, false);
			livingAddressConfigComposite.setLayout(new GridLayout(1, false));
			ComfigLivingAddressComposite comfigLivingAddressComposite = new ComfigLivingAddressComposite(livingAddressConfigComposite, SWT.None);
			comfigLivingAddressComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
			moreToolsShell.setWidth(700);
		}else {
			moreToolsShell.setWidth(500);
		}
		
		moreToolsShell.pack();
		SwtUtils.setCenter(moreToolsShell);
		moreToolsShell.open();
	}
	
	public void close() {
		automaticSwitchPage = false;
		if (null != remoteProjectBidOpeningThread) {
			remoteProjectBidOpeningThread.stop();
			remoteProjectBidOpeningThread = null;
		}
		if (null != remoteProjectSignThread) {
			remoteProjectSignThread.stop();
			remoteProjectSignThread = null;
		}
		if(null != showInRemoteStatusThread){
			showInRemoteStatusThread.stop();
			showInRemoteStatusThread = null;
		}
		
		imageResolver.disposite();
		if (null != zoomBgImage) {
			zoomBgImage.dispose();
		}
		if (null != decStartTimer) {
			decStartTimer.cancel();
		}
		if (null != decEndTimer) {
			decEndTimer.cancel();
		}
		if (null != sendMessageDialog && !sendMessageDialog.isDisposed()) {
			sendMessageDialog.close();
		}
	}
	/**
	 * 视频会议
	 */
	public void startmeetingAction() {
		if(null != startMeetingBtn && !startMeetingBtn.getEnabled())return;
		startMeetingBtn.setEnabled(false);
		final ProgressMessageDialog messageProgress = new ProgressMessageDialog(getShell(), true, -1, new LoadingAdatper() {
			public void finish(boolean flag) {
				Display.getDefault().syncExec(new Runnable() {
					public void run() {
						if(!startMeetingBtn.isDisposed()) {
							startMeetingBtn.setEnabled(true);
						}
					}
				});
			}
		});
		
		new Thread(new Runnable(){
			public void run() {
				VideoMeetingUtils.createMeeting(tenderProjectEntity, Constants.USER, VideoMeetingUtils.ROLE_MANAGER, true, true, messageProgress);
			}
		}).start();
		messageProgress.setTitle("正在启动视频会议");
		messageProgress.open();
	}
	public void addMeetingRoomListener(MeetingRoomListener meetingRoomListener) {
		this.meetingRoomListener = meetingRoomListener;
	}
	
	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}
	
}
