package com.gx.obe.opening.composite;

import java.math.BigDecimal;
import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.Iterator;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Timer;
import java.util.TimerTask;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.CallBack;
import org.eclipse.swt.core.ImageResolver;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.listener.ConfirmListener;
import org.eclipse.swt.core.listener.LoadingAdatper;
import org.eclipse.swt.core.utils.SwtUtils;
import org.eclipse.swt.core.utils.WidgetUtils;
import org.eclipse.swt.core.widgets.ConfirmDialog;
import org.eclipse.swt.core.widgets.EButton;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.core.widgets.ImageButton;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowData;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;

import com.gx.obe.ColorConstants;
import com.gx.obe.VideoConfigConstants;
import com.gx.obe.business.entity.MenuFunction;
import com.gx.obe.business.enumeration.MenuFunctionEnum;
import com.gx.obe.business.enumeration.SupplierEnum;
import com.gx.obe.common.dialog.BidOpeningReportDialog;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.button.CountDownLabel;
import com.gx.obe.common.widget.composite.PageNumComposite;
import com.gx.obe.common.widget.dialog.MessageViewDialog;
import com.gx.obe.common.widget.inter.ProjectStatusCount;
import com.gx.obe.common.widget.listener.PageListener;
import com.gx.obe.common.widget.listener.SelectionTenderPackListener;
import com.gx.obe.common.widget.shell.ProgressMessageDialog;
import com.gx.obe.common.widget.shell.SelectTenderPackShell;
import com.gx.obe.common.widget.shell.ToolsShell;
import com.gx.obe.common.widget.utils.MenuFunctionUtils;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.I18NEnum;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.components.core.enumeration.VideoMeetingEmum;
import com.gx.obe.config.ConfigConstants;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.meeting.utils.VideoMeetingUtils;
import com.gx.obe.message.Messages;
import com.gx.obe.opening.dialog.HSTMeetingInfoDialog;
import com.gx.obe.opening.listener.DecryptRemoteBidFileListener;
import com.gx.obe.opening.listener.MeetingRoomListener;
import com.gx.obe.opening.listener.RemoteSupplierListener;
import com.gx.obe.opening.listener.SupplierRemoteBidOpeningListener;
import com.gx.obe.opening.shell.BidOpeningCountDownShell;
import com.gx.obe.opening.shell.SendMessageDialog;
import com.gx.obe.opening.shell.SingBidShell;
import com.gx.obe.opening.thread.DownloadSupplierBidPriceUtils;
import com.gx.obe.opening.thread.RefreshSupplierRemoteBidOpeningInfoThread;
import com.gx.obe.opening.thread.RemoteDecryptStatusThread;
import com.gx.obe.opening.thread.RemoteSupplierConfirmThread;
import com.gx.obe.opening.thread.RemoteSupplierSignThread;
import com.gx.obe.opening.thread.RomoteSupplierOnlineThread;
import com.gx.obe.opening.thread.StartFocusDecryptBidFilThread;
import com.gx.obe.opening.thread.StartRemoteBidopeningHallThread;
import com.gx.obe.opening.thread.StartRemoteDecryptBidFilThread;
import com.gx.obe.opening.thread.UploadBidOpeningResultThread;
import com.gx.obe.opening.widgets.RoomOperatorButton;
import com.gx.obe.thread.RefreshProjectSupplierTenderInfoThread;
import com.gx.obe.util.thread.CountTimeThread;
import com.gx.obe.util.utils.ScreenUtils;
import com.gx.obe.util.utils.StringUtils;
import com.gx.obe.web.entity.Page;
import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.SupplierOpeningResult;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.entity.tender.TenderProjectRuleEntity;
import com.gx.obe.web.service.ProjectRuleService;
import com.gx.obe.web.service.SupplierService;
import com.gx.obe.web.service.TenderProjectService;
import com.gx.obe.web.service.evaluation.EvaluationStepService;
import com.gx.obe.web.vo.TenderPackOpeningInfo;
import com.gx.security.NowTimeUtils;
import com.gx.utils.ActionLogUtils;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

public class BidOpeningRemoteComposite extends OpeningTimeComposite implements SupplierRemoteBidOpeningListener{

	private ImageResolver imageResolver = new ImageResolver();
	private TenderProjectService tenderProjectService ;
	private ProjectRuleService projectRuleService;
	private SupplierService supplierService = new SupplierService();
	private TenderPackOpeningInfo tenderPackOpeningInfo;
	private TenderProjectEntity curTenderPack;
	private TenderProjectEntity tenderProjectEntity;
	private TenderProjectEntity project;
	private String bidopeningStage;
	private TenderProjectRuleEntity tenderProjectRuleEntity;
	private Image zoomBgImage;
//	private Label bidOpeningTimeLabel;
	private Composite progressComposite;
	private ScrolledComposite scrolledComposite;
	private Composite decryptSupplierComposite;
	private Composite loadDecryptSupplierComposite;
	private RoomOperatorButton openBiddingAgendaBtn;
	private RoomOperatorButton bidOpeningBtn;
	private RoomOperatorButton reFreshBtn;
	private GridLayout gl_decryptSupplierComposite;
	private RemoteSupplierSignThread getSupplierRemoteSignThread;
	private RomoteSupplierOnlineThread romoteSupplierOnlineThread;
	private RemoteSupplierConfirmThread getSupplierRemoteConfirmThread;
	private RemoteDecryptStatusThread getRemoteDecryptStatusThread;
	private Map<String, RemoteSupplierListener> remoteSupplierListener;
	private DecryptRemoteBidFileListener decryptBidFileListener;
	private boolean isInRemoteProgress;
	private boolean isPriceStage = false;
	boolean isShowConfirm = false;
	private boolean isBusAndTecStage = false;
	private boolean isFocusDecrypt = false;
	private ImageButton startBidopeningBtn;
	private boolean isStartRemoteBidopening = false;
	private ImageButton complateBidopeningBtn;
//	private Label bidOpeningStageLabel;
	private String SUPPLIER_NAME;
	private String decryptName = Messages.Button_decryptRemote;
	private int PAGE_SIZE = 5;
	private int PAGE_NO = 1;
	private Label packName;
	public static boolean showProjectNo = true;
	private Composite packageComposite;
	private SelectionTenderPackListener selectionTenderPackListener;
	private ImageButton signBidBtn;
	private Canvas signNext;
	private RoomOperatorButton signatureBtn;
	private Canvas signatureNextBtn;
	private Timer decStartTimer;
	private Timer decEndTimer;
	private MeetingRoomListener meetingRoomListener;
	private Composite statusComposite;
	private BidOpeningCountComposite signCountComposite;
	private ProjectStatusCount tenderStatusCount;
	private ProjectStatusCount decStatusCount;
	private ProjectStatusCount signStatusCount;
	private int decSuccessCount = 0;
	private int decFaildCount = 0;
	private int noPriceCount = 0;
	private int noDecCount = 0;
	private int supplierCount = 0;
	private int supplierSignCount = 0;
	private RefreshSupplierRemoteBidOpeningInfoThread refreshProjectBidOpeningInfoThread;
	private List<Supplier> supplierList;
	private Map<String, Supplier> supplierMap = new HashMap<String, Supplier>();
	private PageNumComposite pageComposite;
	private int supplierListHeight = 300;
	private RoomOperatorButton sendMessageBtn;
	private SendMessageDialog sendMessageDialog;
	private boolean showNowTime = false;
	private int minSupplierCount = 3;
	private Canvas startBidOpeningNext;
	private RoomOperatorButton downTenderInfoBtn;
	private MenuFunctionUtils menuFunctions;
	private boolean anonymousAllInfo = false;
//	private boolean ANONYMOUS_ALL_INFO = false;
	private CountDownLabel countDownLabel;
	private RoomOperatorButton startMeetingBtn;
	private String publicType = "01";// 公开类型：默认或01为公开，02：不公开
	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public BidOpeningRemoteComposite(Composite parent, int style) {
		super(parent, style);
		setBackgroundMode(SWT.INHERIT_FORCE);
		this.tenderProjectEntity = (TenderProjectEntity)parent.getData("tenderProjectEntity");
		this.bidopeningStage = (String)parent.getData("bidopeningStage");;
		this.meetingRoomListener = (MeetingRoomListener)parent.getData("meetingRoomListener");;
		this.isFocusDecrypt = null != parent.getData("isFocus") ? true : false;
		this.menuFunctions = (MenuFunctionUtils) parent.getData("menuFunctions");
//		this.ANONYMOUS_ALL_INFO = "true".equals(parent.getData("ANONYMOUS_ALL_INFO"));
//		setBackgroundImage(bgImage);
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.verticalSpacing = 0;
		gridLayout.horizontalSpacing = 0;
		gridLayout.marginHeight = 0;
		gridLayout.marginWidth = 0;
		setLayout(gridLayout);
		
		Composite centerComposite = new Composite(this, SWT.NONE);
		GridLayout gl_centerComposite = new GridLayout(2, false);
		gl_centerComposite.verticalSpacing = 0;
		gl_centerComposite.horizontalSpacing = 0;
		gl_centerComposite.marginWidth = 0;
		gl_centerComposite.marginHeight = 0;
		centerComposite.setLayout(gl_centerComposite);
		centerComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		loadDecryptSupplierComposite = new Composite(centerComposite, SWT.NONE);
		loadDecryptSupplierComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_loadDecryptSupplierComposite = new GridLayout(1, false);
		gl_loadDecryptSupplierComposite.marginHeight = 0;
		gl_loadDecryptSupplierComposite.marginWidth = 0;
		gl_loadDecryptSupplierComposite.verticalSpacing = 0;
		loadDecryptSupplierComposite.setLayout(gl_loadDecryptSupplierComposite);
		
		packageComposite = new Composite(loadDecryptSupplierComposite, SWT.NONE);
		packageComposite.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, false, 1, 1));
		GridLayout gl_packageComposite = new GridLayout(2, false);
		gl_packageComposite.marginHeight = 0;
		gl_packageComposite.marginWidth = 0;
		packageComposite.setLayout(gl_packageComposite);
		
		packName = new Label(packageComposite, SWT.WRAP);
		packName.setAlignment(SWT.CENTER);
		packName.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		packName.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.BOLD));
		packName.setForeground(SWTResourceManager.getColor(100, 100, 100));
		packName.setText("         ");
		
		ELink changePackLink = new ELink(packageComposite, SWT.WRAP);
		changePackLink.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				changeTenderPackAction();
			}
		});
		changePackLink.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		changePackLink.setFont(SWTResourceManager.getFont("微软雅黑", 18, SWT.BOLD));
		changePackLink.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/arrow_down.png"));
		changePackLink.setToolTipText(Messages.Button_change);
		
		scrolledComposite = new ScrolledComposite(loadDecryptSupplierComposite, SWT.NONE | SWT.H_SCROLL | SWT.V_SCROLL);
		scrolledComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		scrolledComposite.setExpandHorizontal(true);
		scrolledComposite.setExpandVertical(true);
		
		decryptSupplierComposite = new Composite(scrolledComposite, SWT.NONE);
		gl_decryptSupplierComposite = new GridLayout(1, false);
		gl_decryptSupplierComposite.marginTop = 5;
		gl_decryptSupplierComposite.marginHeight = 0;
		gl_decryptSupplierComposite.marginWidth = 8;
		decryptSupplierComposite.setLayout(gl_decryptSupplierComposite);
		
		scrolledComposite.setContent(decryptSupplierComposite);
		scrolledComposite.setMinSize(decryptSupplierComposite.computeSize(SWT.DEFAULT, SWT.DEFAULT));
		
		pageComposite = new PageNumComposite(loadDecryptSupplierComposite, SWT.NONE);
		pageComposite.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		pageComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		
		progressComposite = new Composite(centerComposite, SWT.NONE);
		GridLayout gl_progressComposite = new GridLayout(1, false);
		gl_progressComposite.verticalSpacing = 0;
		gl_progressComposite.horizontalSpacing = 0;
		gl_progressComposite.marginHeight = 5;
		progressComposite.setLayout(gl_progressComposite);
		GridData gd_progressComposite = new GridData(SWT.FILL, SWT.FILL, false, true, 1, 2);
		gd_progressComposite.widthHint = 150;
		progressComposite.setLayoutData(gd_progressComposite);
		
		statusComposite = new Composite(progressComposite, SWT.NONE);
		statusComposite.setLayout(new GridLayout(1, false));
		statusComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		BidOpeningCountComposite tenderCountComposite = new BidOpeningCountComposite(statusComposite, SWT.NONE);
		tenderCountComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		tenderStatusCount = tenderCountComposite;
		
		signCountComposite = new BidOpeningCountComposite(statusComposite, SWT.NONE);
		signCountComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		signStatusCount = signCountComposite;
		
		BidOpeningCountComposite decryptCountComposite = new BidOpeningCountComposite(statusComposite, SWT.NONE);
		decryptCountComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		decStatusCount = decryptCountComposite;
		new Label(centerComposite, SWT.NONE);
		
		tenderStatusCount.addStatusName(Messages.Opening_tendered, Messages.Opening_counts);
		signStatusCount.addStatusName(Messages.Opening_signedIn, Messages.Opening_counts);
		decStatusCount.addStatusName(Messages.Opening_decrypted, Messages.Opening_counts);
		tenderProjectService = new TenderProjectService();
		init();
	}

	/**
	 * @Description: 初始化
	 * @author guoyr 
	 */
	private void init(){
		if(null == menuFunctions){
			menuFunctions = new MenuFunctionUtils();
		}
		projectRuleService = new ProjectRuleService();
		SUPPLIER_NAME = com.gx.obe.components.core.I18N.getString(I18NEnum.SUPPLIERNAME, tenderProjectEntity.getTenderType());
		if(isFocusDecrypt){
			decryptName = Messages.Button_decryptCentralize;
		}else {
			decryptName = Messages.Button_decryptRemote;
		}
		showNowTime = PropertiesUtils.getProperty(ConfigConstants.SHOW_NOW_TIME, "00").equals("01");
		tenderProjectRuleEntity = projectRuleService.getProjectRule(tenderProjectEntity.getId());
		
		tenderProjectEntity = tenderProjectService.getById(tenderProjectEntity.getId());
		if(null != tenderProjectEntity.getParentId()){
			project = tenderProjectService.getById(tenderProjectEntity.getParentId());
			tenderProjectEntity.setParentProjectEntity(project);		
			packName.setText(tenderProjectEntity.getTenderName());
			packageComposite.layout();
		}else {
			packageComposite.dispose();
		}
		
		showMeetingTitle();
		
		isShowConfirm = PropertiesUtils.getProperty(ConfigConstants.SHOW_CONFIRM_STATUS, "00").equals("01");
		isPriceStage = false;
		isBusAndTecStage = false;
		if(null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_PRICE)){
			isPriceStage = true;
			meetingRoomListener.refreshManagerTable(Messages.EconomicBid);
		}else if(null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_BUS_TEC)){
			isBusAndTecStage = true;
			meetingRoomListener.refreshManagerTable(Messages.BusinessTechnologyBid);
		}
		
		addOperatorBtn();
		
		selectionTenderPackListener = new SelectionTenderPackListener(){
			public void selectPack(TenderProjectEntity tenderPack) {
				// 选择后重新查询一次(当前已经是查询全部属性)
//				tenderPack = tenderProjectService.getById(tenderPack.getId());
				loadTenderPackMan(tenderPack);
			}
		};
		
		addListener();
		loadTenderPackMan(tenderProjectEntity);
		scrolledComposite.getVerticalBar().setIncrement(SupplierRemoteDecryptComposite.rowHeight + gl_decryptSupplierComposite.verticalSpacing);
		scrolledComposite.forceFocus();
		addListener(SWT.Activate, new Listener() {
	        public void handleEvent(Event e) {
	            scrolledComposite.setFocus();
	        }
	    });
	}
	private void addListener(){
		decryptBidFileListener = new DecryptRemoteBidFileListener(){
			public void stopRemoteDecrypt(){
				isInRemoteProgress = false;
				Display.getDefault().syncExec(new Runnable(){
					public void run(){
						if(!bidOpeningBtn.isDisposed()){
							decryptFinish();
							boolean complateBidOpening = refreshComplateBtnStatus();
							if(decSuccessCount > 0){
								StringBuilder msg = new StringBuilder();
								msg.append(Messages.Tips_decryptableFileDecryptComplate);
								if(decFaildCount > 0 || (noPriceCount > 0 && noPriceCount != decSuccessCount)){
									if(decFaildCount > 0){
										msg.append(MessageFormat.format(Messages.Tips_decryptFailedCount, decFaildCount));
									}
									if(noPriceCount > 0){
										if(decFaildCount > 0){
											msg.append(Messages.Comma);
										}
										msg.append(MessageFormat.format(Messages.Tips_obtainQuotationFailedCount, noPriceCount));
									}
									msg.append(Messages.Period);
									ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), null, msg.toString(), null);
									confirmDialog.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/tips_info.png"), -1, -1);
									confirmDialog.addButton(Messages.Button_ok, "01", null, 90);
									confirmDialog.setTipsAlignment(SWT.CENTER);
									confirmDialog.setTipsColor(SWTResourceManager.getColor(255, 0, 0));
									confirmDialog.setTips(Messages.Tips_problemsSolve);
									confirmDialog.open();
									return;
								}
								if(!getShell().isDisposed() && !complateBidOpening){
									msg.append(Messages.Tips_whetherComplateAndUploadOpeningResult);
									ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), null, msg.toString(), null);
									confirmDialog.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/tips_info.png"), -1, -1);
									confirmDialog.addButton(Messages.Button_complateAndUploadOpeningResult, "01", SWTResourceManager.getColor(77, 163, 19), 90);
									confirmDialog.addCancel(Messages.Button_cancel, null);
									confirmDialog.setTipsAlignment(SWT.CENTER);
									confirmDialog.setTipsColor(SWTResourceManager.getColor(255, 0, 0));
									confirmDialog.open();
									if("01".equals(confirmDialog.getClickStatus())) {
										complateBidOpeningAction(false);
									}
								}
							}
						}
					}
				});
			}
			
			
			public void refreshBidOpeningStatus(Supplier supplier, String businessBidStatus, String technologyBidStatus, String priceBidStatus, boolean hasBidPrice){
				// 更新最新的供应商
				supplierMap.put(supplier.getId(), supplier);
				RemoteSupplierListener listener = remoteSupplierListener.get(supplier.getId());
				if(null != listener){
					listener.refreshBidOpeningStatus(supplier, bidopeningStage, businessBidStatus, technologyBidStatus, priceBidStatus, hasBidPrice);
				}
			}
			public void refreshProgress(int totalCount, int successCount, int noDecCount, int failedDecCout, int errorsCount){
				refreshStatusCount(totalCount, successCount, noDecCount, failedDecCout, errorsCount);
				
				// 当存在有开标成功或失败的供应商时，则开始获取确认状态
				if(successCount + failedDecCout > 0 && null == getSupplierRemoteConfirmThread){
					startRefreshRemoteConfirmInfoThread();
				}
			}
		};
		addDisposeListener(new DisposeListener() {
			public void widgetDisposed(DisposeEvent arg0) {
				close();
			}
		});
	}
	
	/**
	 * @Description: 添加操作按钮
	 * @author guoyr 
	 */
	private void addOperatorBtn(){
		
		Composite operatorComposite = new Composite(null != meetingRoomListener.getOperatorParent() ? meetingRoomListener.getOperatorParent() : this, SWT.TRANSPARENT);
		GridLayout gl_composite = new GridLayout(8, false);
		gl_composite.marginHeight = 0;
		gl_composite.horizontalSpacing = 3;
		operatorComposite.setLayout(gl_composite);
		operatorComposite.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, true, 1, 1));
		
		RoomOperatorButton moreActionBtn = new RoomOperatorButton(operatorComposite, SWT.NONE);
		moreActionBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/more_op.png"));
		moreActionBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, true, 1, 1));
		moreActionBtn.setText(Messages.Button_moreOperate);
		moreActionBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				moreConfigAction();
			}
		});
		
		openBiddingAgendaBtn = new RoomOperatorButton(operatorComposite, SWT.NONE);
		openBiddingAgendaBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, true, 1, 1));
		openBiddingAgendaBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/tips.png"));
		openBiddingAgendaBtn.setText(Messages.BidOpeningAgenda);
		openBiddingAgendaBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				showBidOpeningCountDown();
			}
		});
		if(null != menuFunctions && MenuFunction.SHOW.equals(menuFunctions.getAuthority("SHOW_MEETING_VIDEO"))){
			startMeetingBtn = new RoomOperatorButton(operatorComposite, SWT.NONE);
			startMeetingBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/voice_config.png"));
			startMeetingBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
			startMeetingBtn.setText(Messages.Button_opeingMeeting);
			startMeetingBtn.addMouseListener(new MouseAdapter() {
				@Override
				public void mouseUp(MouseEvent e) {
					String meetingType = PropertiesUtils.getProperty(ConfigConstants.VIDEO_MEETING_TYPE, "");
					if(meetingType.equals(VideoMeetingEmum.MEETING_HST)){
						if (e.button == 1) {//点击鼠标左键
							startmeetingAction();
						}else if(e.button==3){
							String roomIdAndPwd = tenderProjectEntity.getBidMeeting();
							if(null == roomIdAndPwd || roomIdAndPwd.length() == 0) {
								return;
							}
							String roomId = "";
							String rpwd = "";
							if(roomIdAndPwd.contains("_")) {
								roomId = roomIdAndPwd.substring(0,roomIdAndPwd.indexOf("_"));
								rpwd = roomIdAndPwd.substring(roomIdAndPwd.indexOf("_")+1);
							}else {
								roomId = roomIdAndPwd;
								rpwd = "123456";
							}
							HSTMeetingInfoDialog dialog = new HSTMeetingInfoDialog(getShell(),roomId,rpwd);
							dialog.open();
						}
					}else {
						startmeetingAction();
					}
				}
			});
		}
		ESepator vSep = new ESepator(operatorComposite, SWT.VERTICAL);
		vSep.setLayoutData(new GridData(SWT.CENTER, SWT.FILL, false, true, 1, 1));
		vSep.setLineWidth(2);
		vSep.setBackground(ColorConstants.SKIN_BG);
		
		Composite stepComposite = new Composite(operatorComposite, SWT.NONE);
		stepComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		RowLayout rl_stepComposite = new RowLayout(SWT.HORIZONTAL);
		rl_stepComposite.center = true;
		rl_stepComposite.spacing = 0;
		rl_stepComposite.marginLeft = 0;
		rl_stepComposite.marginRight = 0;
		rl_stepComposite.marginTop = 0;
		rl_stepComposite.marginBottom = 0;
		rl_stepComposite.marginHeight = 0;
		stepComposite.setLayout(rl_stepComposite);
		stepComposite.setLayoutData(new GridData(SWT.CENTER, SWT.FILL, true, true, 1, 1));
		
		downTenderInfoBtn = new RoomOperatorButton(stepComposite, SWT.NONE | EButton.CSS_BLUE);
		downTenderInfoBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/refresh.png"));
		downTenderInfoBtn.setText(Messages.Button_syncNewTenderInfo);
		downTenderInfoBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				downTenderInfoBtn.setEnabled(false);
				synNewBidInfoInfo(Messages.Tips_synchronizingNewTenderInfo);
			}
		});
		addNextSep(stepComposite);
		startBidopeningBtn = new RoomOperatorButton(stepComposite, SWT.NONE | EButton.CSS_BLUE);
		startBidopeningBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/wifi.png"));
		startBidopeningBtn.setText(Messages.Button_openRemoteBidOpeningHall);
		startBidopeningBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				startBidopeningAction();
			}
		});
		
		startBidOpeningNext = addNextSep(stepComposite);
		bidOpeningBtn = new RoomOperatorButton(stepComposite, SWT.NONE | EButton.CSS_BLUE);
		bidOpeningBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/key.png"));
		bidOpeningBtn.setText(decryptName);
		bidOpeningBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				openBidAction();
			}
		});
		
		
		addNextSep(stepComposite);
		complateBidopeningBtn = new RoomOperatorButton(stepComposite, SWT.NONE | EButton.CSS_BLUE);
		complateBidopeningBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/submit.png"));
		complateBidopeningBtn.setText(Messages.Button_complateAndUploadOpeningResult);
		complateBidopeningBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				complateBidOpeningAction(true);
			}
		});
		
		signNext = addNextSep(stepComposite);
		signBidBtn = new RoomOperatorButton(stepComposite, SWT.NONE | EButton.CSS_BLUE);
		signBidBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/sing.png"));
		signBidBtn.setText(Messages.Button_signBid);
		signBidBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				signBidAction();
			}
		});
		
		signatureNextBtn = addNextSep(stepComposite);
		signatureBtn = new RoomOperatorButton(stepComposite, SWT.NONE | EButton.CSS_BLUE);
		signatureBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/signature.png"));
		signatureBtn.setText(Messages.Button_openingResultSignature);
		signatureBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				signatureAction();
			}
		});
		
		ESepator vSep2 = new ESepator(operatorComposite, SWT.VERTICAL);
		vSep2.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1));
		vSep2.setLineWidth(2);
		vSep2.setBackground(ColorConstants.SKIN_BG);
		
		sendMessageBtn = new RoomOperatorButton(operatorComposite, SWT.NONE);
		sendMessageBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/tips.png"));
		sendMessageBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, true, 1, 1));
		sendMessageBtn.setText(Messages.Button_sendMessage);
		sendMessageBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				sendMessageAction();
			}
		});
		
		reFreshBtn = new RoomOperatorButton(operatorComposite, SWT.NONE);
		reFreshBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/refresh.png"));
		reFreshBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, true, 1, 1));
		reFreshBtn.setText(Messages.Button_refresh);
		reFreshBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				refreshAction();
			}
		});
		
//		RoomOperatorButton closeBtn = new RoomOperatorButton(bottomContent, SWT.NONE);
//		closeBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/exit.png"));
//		closeBtn.setLeftMargin(20);
//		closeBtn.setRightMargin(20);
//		closeBtn.setBackgroundColor(SWTResourceManager.getColor(208, 88, 89));
//		closeBtn.setActiveBackgroundColor(SWTResourceManager.getColor(SWT.COLOR_RED));
//		closeBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
//		closeBtn.setText(" 退出 ");
//		closeBtn.addMouseListener(new MouseAdapter() {
//			@Override
//			public void mouseUp(MouseEvent e) {
//				exitAction();
//			}
//		});
//		Image image = ResourceManager.getPluginImage(SWTCoreActivator.PLUGIN_ID, "icons/bg.png");
//		Region region = new Region();
//		ImageData imageData = image.getImageData();
//		if (imageData.alphaData != null) {
//			for (int y = 0; y < imageData.height; y++) {
//				for (int x = 0; x < imageData.width; x++) {
//					if (imageData.getAlpha(x, y) == 255) {
//						region.add(imageData.x + x,imageData.y + y,1,1);
//					}
//				}
//			}
//		}
		
		// 解中解密
		if(isFocusDecrypt){
			//不需要开启开标大厅
			WidgetUtils.setControlVisible(startBidopeningBtn, false);
			WidgetUtils.setControlVisible(startBidOpeningNext, false);
			//不显示签到信息
			WidgetUtils.setControlVisible(signCountComposite, false);
		}
		if(isBusAndTecStage){
			WidgetUtils.setControlVisible(signBidBtn, false);
			WidgetUtils.setControlVisible(signNext, false);
			WidgetUtils.setControlVisible(signatureNextBtn, false);
			WidgetUtils.setControlVisible(signatureBtn, false);
		}
//		meetingRoomListener.setOperatorRegion(region);
		boolean showSignature = false;
		if(null != menuFunctions && MenuFunction.SHOW.equals(menuFunctions.getAuthority("REMOTE_SIGNATURE"))){
			showSignature = true;
		}
		WidgetUtils.setControlVisible(signatureBtn, showSignature);
		WidgetUtils.setControlVisible(signatureNextBtn, showSignature);
		meetingRoomListener.refreshOperator();
		if(null != menuFunctions && MenuFunction.SHOW.equals(menuFunctions.getAuthority("SHOW_OPENING_TIPS"))){
			showOpeningTips(bidOpeningBtn.getParent());
		}
	}
	
	private Canvas addNextSep(Composite stepComposite){
		final Image nextImage = ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/right_arrow.png");
		final Canvas nextLabel = new Canvas(stepComposite, SWT.TRANSPARENT);
		nextLabel.setLayoutData(new RowData(8, 22));
		nextLabel.addPaintListener(new PaintListener() {
			public void paintControl(PaintEvent arg0) {
				arg0.gc.drawImage(nextImage, 0, 0, nextImage.getBounds().width, nextImage.getBounds().height, 0, 0, nextLabel.getBounds().width, nextLabel.getBounds().height);
			}
		});
		return nextLabel;
	}
	
	/**
	 * @Description: 开始解密定时期
	 * @author guoyr
	 * @param bidOpeningTime 
	 */
	private void addBidopeningStartTimer(Date bidOpeningTime, final Date decryptEndTime){
		if(null != decStartTimer){
			decStartTimer.cancel();
		}
		if(bidOpeningTime.after(NowTimeUtils.getNowDate())){
			if(CommonEnum.YES.equals(curTenderPack.getLatestBidinfo())){
				ActionLogUtils.addServerLog(curTenderPack.getId(), "重置获取最新投标信息状态", "未到开标时间，但状态为已获取过最新投标时间");
				curTenderPack.setLatestBidinfo(CommonEnum.NO);
				tenderProjectService.updateAssignProperty(curTenderPack, new String[]{"latestBidinfo"});			
			}
			
			bidOpeningBtn.setEnabled(false);
			decStartTimer =  new Timer(true); 
			decStartTimer.schedule(new TimerTask(){
				public void run() {
					final boolean refresh = anonymousAllInfo;
					anonymousAllInfo = isShowAnonymName(tenderProjectRuleEntity.getIsAnonymous());
					
					// 如果是匿名项目，则开标时间到后要重新刷新一下显示列表以显示供应商名称
//					if(tenderProjectRuleEntity.getIsAnonymous()) {
//						showSupplierPage(PAGE_NO);
//					}
					
					if(!Display.getDefault().isDisposed()){
						Display.getDefault().syncExec(new Runnable(){
							public void run(){
								// 如果是匿名项目，则开标时间到后要重新刷新一下显示列表以显示供应商名称
								if(refresh) {
									refreshAction();
								}
								if(!bidOpeningBtn.isDisposed()){
									bidOpeningBtn.setEnabled(true);
									boolean synNewFlag = synNewBidInfoInfo(Messages.Tips_timeForBidOpeningAndSynchronizInfo);
								
									ConfirmDialog synTenderInfoDialog = new ConfirmDialog(getShell(), decryptName, MessageFormat.format(Messages.Tips_timeForBidOpening, decryptName), null);
									synTenderInfoDialog.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/tips_info.png"), -1, -1);
									synTenderInfoDialog.setTips(synNewFlag ? Messages.Tips_synchronizedNewTenderInfoComplate : Messages.Tips_checkSynchronizNewTenderInfo);
//									synTenderInfoDialog.addButton(Messages.Button_syncNewTenderInfo, "syn", SWTResourceManager.getColor(77, 163, 19));
									synTenderInfoDialog.addButton(MessageFormat.format(Messages.Button_startFormat, decryptName), "dec");
									synTenderInfoDialog.addCancel(Messages.Button_cancel, null);
									synTenderInfoDialog.setAlpha(230);
									synTenderInfoDialog.open();
//									if(synTenderInfoDialog.getClickStatus().equals("syn")){
//										
//									}else 
									if(synTenderInfoDialog.getClickStatus().equals("dec")){
										doDecBidAction(false, !synNewFlag);
									}
								
								}
							}
						});
					}
					if(null != decryptEndTime){
						meetingRoomListener.refreshMeetingTime(Messages.Deadline, decryptEndTime);
						meetingRoomListener.refreshCountDownTime(Messages.CountdownOnBoard, decryptEndTime);
					}else if(showNowTime){
						meetingRoomListener.showNowTime(2000);
					}
				}
				
			}, bidOpeningTime.getTime() - NowTimeUtils.getNowDate().getTime());
		}else {
			if(null != decryptEndTime){
				meetingRoomListener.refreshMeetingTime(Messages.Deadline, decryptEndTime);
				meetingRoomListener.refreshCountDownTime(Messages.CountdownOnBoard, decryptEndTime);
			}else if(showNowTime){
				meetingRoomListener.showNowTime(2000);
			}
		}
	}
	
	/**
	 * @Description:  解密截止定时期
	 * @author guoyr
	 * @param bidOpeningDeadlineTime 
	 */
	private void addDecryptEndTimer(Date bidOpeningDeadlineTime){
		if(null != decEndTimer){
			decEndTimer.cancel();
		}
		if(null != bidOpeningDeadlineTime && bidOpeningDeadlineTime.after(NowTimeUtils.getNowDate())){
			decEndTimer =  new Timer(true); 
			decEndTimer.schedule(new TimerTask(){
				public void run() {
					if(showNowTime){
						meetingRoomListener.showNowTime(5000);
					}
					ActionLogUtils.addServerLog(curTenderPack.getId(),"解密截止时间已到", "共解密" + decSuccessCount +"家次");
					if(!Display.getDefault().isDisposed()){
						Display.getDefault().syncExec(new Runnable(){
							public void run(){
								if(!getShell().isDisposed()){
									stopDecBidAction();
									final boolean canComplate = complateBidopeningBtn.getEnabled();
									ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), Messages.Button_complateBidOpening, MessageFormat.format(Messages.Tips_complateBidOpeningForDeadline, complateBidopeningBtn.getText()), new ConfirmListener(){
										public void click(String key) {
											if(key.equals("01")){
												if(canComplate){
													complateBidOpeningAction(false);
												}
											}
										}
									});
									confirmDialog.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/tips_info.png"), -1, -1);
									confirmDialog.addButton(complateBidopeningBtn.getText(), "01");
									confirmDialog.addButton(Messages.Button_cancel);
									confirmDialog.setAlpha(230);
									confirmDialog.open();
								}
							}
						});
					}
				}
				
			}, bidOpeningDeadlineTime.getTime() - NowTimeUtils.getNowDate().getTime());
		}
	}
	
	private void changeTenderPackAction(){
		SelectTenderPackShell selectTenderPackShell = new SelectTenderPackShell(getShell(), curTenderPack.getParentId() , curTenderPack.getId(), selectionTenderPackListener);
		Point point = packName.toDisplay(0,packName.getBounds().height);
		selectTenderPackShell.setLocation(point);
		selectTenderPackShell.open();
	}
	
	/**
	 * @Description: 加载项目或切换包件
	 * @author guoyr
	 * @param tenderPack 
	 */
	private void loadTenderPackMan(TenderProjectEntity tenderPack){
		this.curTenderPack = tenderPack;
		
		// 如果是按包件进入的开标，避免切换包件时查出来的包件的时间没有
		Date bidOpeningStartTime = tenderProjectRuleEntity.getBidOpeningStartTime();
		Date priceOpeningTime = tenderProjectRuleEntity.getPriceBidOpeningTime();
		tenderProjectRuleEntity = projectRuleService.getProjectRule(tenderPack.getId());
		if(null == tenderProjectRuleEntity.getBidOpeningStartTime()){
			tenderProjectRuleEntity.setBidOpeningStartTime(bidOpeningStartTime);
		}
		if(null == tenderProjectRuleEntity.getPriceBidOpeningTime()){
			tenderProjectRuleEntity.setPriceBidOpeningTime(priceOpeningTime);
		}
		minSupplierCount = 3;
		if(null != tenderProjectEntity.getTenderMethod() && tenderProjectEntity.getTenderMethod().equals(TenderProjectEnum.JZXTP)){
			minSupplierCount = 2;
		}else if(null != tenderProjectEntity.getTenderMethod() && tenderProjectEntity.getTenderMethod().equals(TenderProjectEnum.DYLY)){
			minSupplierCount = 1;
		}
		
		if(!packageComposite.isDisposed()){
			packName.setText("["+curTenderPack.getTenderNo() + "]"+curTenderPack.getTenderName());
			packageComposite.layout();
		}
		bidOpeningTime = tenderProjectRuleEntity.getBidOpeningStartTime();
		signEndTime = tenderProjectRuleEntity.getSignEndTime();
		decryptEndTime = tenderProjectRuleEntity.getDecryptEndTime();
		if(isPriceStage){
			bidOpeningTime = tenderProjectRuleEntity.getPriceBidOpeningTime();
			signEndTime = tenderProjectRuleEntity.getPriceSignEndTime();
			decryptEndTime = tenderProjectRuleEntity.getPriceDecryptEndTime();
		}
		
		meetingRoomListener.refreshMeetingTime(Messages.BidOpeningTimeOnBoard, bidOpeningTime);
		meetingRoomListener.refreshCountDownTime(Messages.CountdownOnBoard, bidOpeningTime);
		
		anonymousAllInfo = isShowAnonymName(tenderProjectRuleEntity.getIsAnonymous());
//		anonymousAllInfo = tenderProjectEntity.isHideSupplierInfo(bidOpeningTime);
		
		// 切换包件后重新启动开标时间定时器
		addBidopeningStartTimer(bidOpeningTime, decryptEndTime);
		addDecryptEndTimer(decryptEndTime);
		if(null != sendMessageDialog && !sendMessageDialog.isDisposed()){
			sendMessageDialog.close();
		}
		refreshStatusCount(0, 0, 0, 0, 0);
		refreshAction();
	}
	
	/**
	 * @Description: 刷新
	 * @author guoyr 
	 */
	private void refreshAction(){
		if(!reFreshBtn.getEnabled()){
			return;
		}
		anonymousAllInfo = isShowAnonymName(tenderProjectRuleEntity.getIsAnonymous());
		// 停止所有线程
		stopAllRemoteThread();
		
		refreshSupplierRemoteBidOpeningInfo();
		
		WidgetUtils.setControlVisible(pageComposite, false);
		loadDecryptSupplierComposite.layout();
		pageComposite.setMaxPageCount(15);
		pageComposite.setBorderColor(SWTResourceManager.getColor(204, 204, 204));
		pageComposite.setForeground(SWTResourceManager.getColor(204, 204, 204));
		pageComposite.setSelectionBgColor(SWTResourceManager.getColor(24, 112, 221));
		pageComposite.setSelectionForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		pageComposite.addPageListener(new PageListener(){
			public void changed(int pageNo, int pageSize) {
				PAGE_NO = pageNo;
				showSupplierPage(PAGE_NO);
			}
		});
	}
	
	/**
	 * @Description: 启动刷新远程投标供应商线程
	 * @author guoyr 
	 */
	private void refreshSupplierRemoteBidOpeningInfo(){
		if(null != refreshProjectBidOpeningInfoThread){
			refreshProjectBidOpeningInfoThread.stop();
			refreshProjectBidOpeningInfoThread = null;
		}
		reFreshBtn.setEnabled(false);
		downTenderInfoBtn.setEnabled(false);
		if(null == remoteSupplierListener){
			remoteSupplierListener = new HashMap<String, RemoteSupplierListener>();
		}
		refreshProjectBidOpeningInfoThread = new RefreshSupplierRemoteBidOpeningInfoThread(curTenderPack, tenderProjectRuleEntity, bidopeningStage, this);
		refreshProjectBidOpeningInfoThread.start();
	}
	
	/**
	 * @Description: 刷新已投标的供应商
	 * @author guoyr
	 * @param supplierList 
	 */
	public void refreshSupplierList(List<Supplier> _supplierList){
		if(null != _supplierList){
			this.supplierList = _supplierList;
			for(Supplier supplier : _supplierList){
				supplierMap.put(supplier.getId(), supplier);
			}
		}
		showSupplierPage(PAGE_NO);
	}
	
	/**
	 * @Description: 刷新远程解密结果
	 * @author guoyr
	 * @param tenderPackOpeningInfo 
	 */
	public void refreshDescInfo(TenderPackOpeningInfo tenderPackOpeningInfo){
		this.tenderPackOpeningInfo = tenderPackOpeningInfo;
		curTenderPack = tenderPackOpeningInfo.getTenderProject();
		refreshStatusCount(tenderPackOpeningInfo.getTenderCount(), tenderPackOpeningInfo.getDecCount(), tenderPackOpeningInfo.getTenderCount() - tenderPackOpeningInfo.getDecCount(), tenderPackOpeningInfo.getDecFailCount(), tenderPackOpeningInfo.getNoPriceCount());
		Display.getDefault().syncExec(new Runnable(){
			public void run(){
				if(!bidOpeningBtn.isDisposed()){
					reFreshBtn.setEnabled(true);
					downTenderInfoBtn.setEnabled(true);
					refreshComplateBtnStatus();
				}
			};
		});
		// 在刷新完供应商状态后，如果处在开标中，则继续启动获取状态线程
		if(isInRemoteProgress){
			downloadSupplierRemoteDecryptStatus();
		}
		startRefreshRemoteSignInfoThread();
		
		startRefreshOnlineStatusThread();
		if(decSuccessCount + decFaildCount > 0){
			startRefreshRemoteConfirmInfoThread();
		}
		
	}
	
	/**
	 * @Description: 停止同步解密数据状态
	 * @author guoyr 
	 */
	private void decryptFinish(){
		if(null != getSupplierRemoteSignThread){
			getSupplierRemoteSignThread.stop();
			getSupplierRemoteSignThread = null;
		}
		if(null != getRemoteDecryptStatusThread){
			getRemoteDecryptStatusThread.stop();
			getRemoteDecryptStatusThread = null;
		}
		tenderProjectService.updateBidOpeningStatus(curTenderPack, bidopeningStage, CommonEnum.STOP);
		isInRemoteProgress = false;
		bidOpeningBtn.setEnabled(true);
		bidOpeningBtn.setText(decFaildCount > 0 ? Messages.Button_continueDecrypt : Messages.Button_decryptRemote);
		
		Iterator<Entry<String, RemoteSupplierListener>> iterator = remoteSupplierListener.entrySet().iterator();
		while(iterator.hasNext()) {
			Entry<String, RemoteSupplierListener> entry = iterator.next();
//		for(Entry<String, RemoteSupplierListener> entry : remoteSupplierListener.entrySet()){
			if(null != entry.getValue()){
				entry.getValue().showStatus();
			}
		}
	}
	
	
	private boolean refreshComplateBtnStatus(){
		curTenderPack = tenderProjectService.getById(curTenderPack.getId());
		isInRemoteProgress = false;
		if(isPriceStage){
			if(CommonEnum.IN_PROGRESS.equals(curTenderPack.getPriceBidStatus())){
				isInRemoteProgress = true;
			}
		}else if(isBusAndTecStage){
			if(CommonEnum.IN_PROGRESS.equals(curTenderPack.getBusinessBidStatus()) || CommonEnum.IN_PROGRESS.equals(curTenderPack.getTechnologyBidStatus())){
				isInRemoteProgress = true;
			}
		}else {
			if(CommonEnum.IN_PROGRESS.equals(curTenderPack.getBusinessBidStatus()) || CommonEnum.IN_PROGRESS.equals(curTenderPack.getTechnologyBidStatus()) || CommonEnum.IN_PROGRESS.equals(curTenderPack.getPriceBidStatus())){
				isInRemoteProgress = true;
			}
		}
		isStartRemoteBidopening  = false;
		if(isPriceStage){
			isStartRemoteBidopening = CommonEnum.YES.equals(curTenderPack.getStartPriceBidOpening());
		}else {
			isStartRemoteBidopening = CommonEnum.YES.equals(curTenderPack.getStartBidOpening());
		}
		if(isFocusDecrypt) {
			isStartRemoteBidopening = true;
		}
		if(isStartRemoteBidopening){
			startBidopeningBtn.setText(Messages.Button_openRemoteBidOpeningHallAlready);
			startBidopeningBtn.setEnabled(false);
		}else {
			startBidopeningBtn.setText(Messages.Button_openRemoteBidOpeningHall);
			startBidopeningBtn.setEnabled(true);
			if(tenderPackOpeningInfo.getTenderCount() < 0){
				startBidopeningBtn.setEnabled(false);
			}
		}
		bidOpeningBtn.setEnabled(tenderPackOpeningInfo.getTenderCount() > 0);
		if(isInRemoteProgress){
			bidOpeningBtn.setEnabled(false);
//			bidOpeningBtn.setText(Messages.Button_stopDecrypt);
			complateBidopeningBtn.setEnabled(false);
		}else {
			bidOpeningBtn.setText(decFaildCount > 0 ? Messages.Button_continueDecrypt : decryptName);
		}
		
		if(anonymousAllInfo){
            for(Control control : decryptSupplierComposite.getChildren()){
                control.dispose();
            }
            Label tips = new Label(decryptSupplierComposite, SWT.NONE);
            tips.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, true, 1, 1));
            tips.setFont(SWTResourceManager.getFont("微软雅黑", 25, SWT.BOLD));
            tips.setForeground(SWTResourceManager.getColor(100, 100, 100));
            tips.setText("开标倒计时");
            
            countDownLabel = new CountDownLabel(decryptSupplierComposite, SWT.WRAP);
    		countDownLabel.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.NORMAL));
    		GridData gd_countDownLabel = new GridData(SWT.CENTER, SWT.CENTER, true, true, 1, 1);
    		gd_countDownLabel.widthHint = 540;
    		gd_countDownLabel.heightHint = 120;
    		countDownLabel.setLayoutData(gd_countDownLabel);
    		countDownLabel.setForeground(ColorConstants.FONT_BLACK_COLOR);
    		countDownLabel.refreshCountDown(new String[]{"0","0","0","0","0","0"});
    		startCountTimeThread();
            decryptSupplierComposite.layout();
        }
		
		boolean complateBidOpening = false;
		if(isPriceStage){
			if(CommonEnum.COMPLETE.equals(curTenderPack.getPriceBidStatus())){
				complateBidOpening = true;
			}
		}else if(isBusAndTecStage){
			if(CommonEnum.COMPLETE.equals(curTenderPack.getBusinessBidStatus()) && CommonEnum.COMPLETE.equals(curTenderPack.getTechnologyBidStatus())){
				complateBidOpening = true;
			}
		}else{
			if(CommonEnum.COMPLETE.equals(curTenderPack.getBusinessBidStatus()) && CommonEnum.COMPLETE.equals(curTenderPack.getTechnologyBidStatus()) && CommonEnum.COMPLETE.equals(curTenderPack.getPriceBidStatus())){
				complateBidOpening = true;
			}
		}
		
		complateBidopeningBtn.setEnabled(true);
		complateBidopeningBtn.setText(Messages.Button_complateAndUploadOpeningResult);
		if(!isStartRemoteBidopening){
			complateBidopeningBtn.setEnabled(false);
		}
		
		if(decSuccessCount + decFaildCount == 0){
			complateBidopeningBtn.setEnabled(false);
		}
		complateBidopeningBtn.setData("isComplate", null);
		if(complateBidOpening){
			bidOpeningBtn.setEnabled(false);
			complateBidopeningBtn.setData("isComplate", true);
			boolean isComplateUploadResult = false;
			if(isPriceStage){
				if(CommonEnum.COMPLETE.equals(curTenderPack.getUploadPriceOpeningResultStatus())){
					isComplateUploadResult = true;
				}
			}else {
				if(CommonEnum.COMPLETE.equals(curTenderPack.getUploadOpeningResultStatus())){
					isComplateUploadResult = true;
				}
			}
			if(isComplateUploadResult){
				complateBidopeningBtn.setEnabled(false);
			}
			
			// 如果是开标完成之前不显示供应商，则在完成开标后再做一次刷新操作
//			if(anonymousAllInfo){
//				anonymousAllInfo = false;
//	            refreshAction();
//	        }
		}	
		signBidBtn.setEnabled(complateBidOpening || (decSuccessCount + decFaildCount > 0));
		signatureBtn.setEnabled(complateBidOpening || (decSuccessCount + decFaildCount > 0));
		return complateBidOpening;
	}
	
	/**
	 * @Description: 启动倒计时线程
	 * @author guoyr
	 */
	private void startCountTimeThread(){
		meetingRoomListener.addCountTimeListener(new CountTimeThread.CountTime() {
			public void countTime(String[] countDownTime) {
				if(null != countDownLabel && !countDownLabel.isDisposed()){
					countDownLabel.refreshCountDown(countDownTime);
				}
			}
		});
	}
	
	private void showSupplierPage(int curPage){
		this.PAGE_NO = curPage;
		if(anonymousAllInfo)return;
		new Thread(new Runnable(){
			public void run(){
				Display.getDefault().syncExec(new Runnable(){
					public void run(){
						if(!decryptSupplierComposite.isDisposed()){
							supplierListHeight = scrolledComposite.getBounds().height - gl_decryptSupplierComposite.marginHeight * 2 - gl_decryptSupplierComposite.marginTop - gl_decryptSupplierComposite.marginBottom;
							PAGE_SIZE = supplierListHeight / (SupplierRemoteDecryptComposite.rowHeight + gl_decryptSupplierComposite.verticalSpacing);
							if(null != supplierList && supplierList.size() > PAGE_SIZE && !pageComposite.getVisible()){
								supplierListHeight -= Math.max(pageComposite.getBounds().height, 31);
								PAGE_SIZE = supplierListHeight / (SupplierRemoteDecryptComposite.rowHeight + gl_decryptSupplierComposite.verticalSpacing);
							}
						}
					}
				});
				final Page<Supplier> supplierPage = new Page<Supplier>();
				if(null != supplierList){
					List<Supplier> supplierPageList = new ArrayList<Supplier>();
					int totalCount = 0;
					int pageStart = (PAGE_NO-1) * PAGE_SIZE;
					if(supplierList.size() < pageStart){
						pageStart = 0;
						PAGE_NO = 1;
					}
					boolean isAnonymous = isShowAnonymName(tenderProjectRuleEntity.getIsAnonymous());
					for(Supplier supplier : supplierList){
						supplier.setAnonymous(isAnonymous);
						if(null != supplierMap){
							Supplier newSupplier = supplierMap.get(supplier.getId());
							if(null != newSupplier){
								supplier = newSupplier;
							}
						}
						if(totalCount >= pageStart && totalCount < pageStart + PAGE_SIZE){
							supplierPageList.add(supplier);
						} 
						totalCount ++;
					}
					supplierPage.setRecords(supplierPageList);
					supplierPage.setCurrent(PAGE_NO);
					supplierPage.setSize(PAGE_SIZE);
					supplierPage.setTotal(totalCount);
				}
				if(null != remoteSupplierListener){
					remoteSupplierListener.clear();
				}else {
					remoteSupplierListener = new HashMap<String, RemoteSupplierListener>();
				}
				
				Display.getDefault().syncExec(new Runnable(){
					public void run(){
						if(!decryptSupplierComposite.isDisposed()){
							decryptSupplierComposite.setData("isFocus", isFocusDecrypt ? "1" : null);
							for(Control control : decryptSupplierComposite.getChildren()){
								control.dispose();
							}
							int width = decryptSupplierComposite.getBounds().width;
							int totalHeight = 0;
							if(null != supplierPage && null != supplierPage.getRecords() && supplierPage.getSize() > 0){
								for(Supplier supplier : supplierPage.getRecords()){
									if(!decryptSupplierComposite.isDisposed()){
										SupplierOpeningResult supplierOpeningResult = supplier.getSupplierOpeningResult();
										if(null == supplierOpeningResult){
											supplierOpeningResult = new SupplierOpeningResult();
										}
										SupplierRemoteDecryptComposite supplierComposite = new SupplierRemoteDecryptComposite(decryptSupplierComposite, curTenderPack, supplier, menuFunctions, SWT.NONE);
										supplierComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
										totalHeight += supplierComposite.computeSize(width, SWT.DEFAULT).y;//supplierComposite.getRowHeight();
										remoteSupplierListener.put(supplier.getId(), supplierComposite);
										boolean hasBidPrice = false;
										if(null != supplierOpeningResult.getBidPrice() && supplierOpeningResult.getBidPrice().compareTo(BigDecimal.ZERO) > 0){
											hasBidPrice = true;
										}
										
										Date signTime = isPriceStage ? supplier.getPriceSignTime() : supplier.getSignTime();
										String signPerson = isPriceStage ? supplier.getPriceSignPerson() : supplier.getSignPerson();
										String signPersonTel = isPriceStage ? supplier.getPriceSignPersonTel() : supplier.getSignPersonTel();
										String signPersonCard = isPriceStage ? supplier.getPriceSignPersonCard() : supplier.getSignPersonCard();
										String confirmStatus = isPriceStage ? supplierOpeningResult.getPriceConfirmStatus() : supplierOpeningResult.getConfirmStatus();
										Date confirmTime = isPriceStage ? supplierOpeningResult.getPriceConfirmTime() : supplierOpeningResult.getConfirmTime();
										supplierComposite.refreshSignInfo(signTime, signPerson, signPersonTel, signPersonCard);
										supplierComposite.refreshBidOpeningStatus(supplier, bidopeningStage, supplierOpeningResult.getBusinessBidStatus(), supplierOpeningResult.getTechnologyBidStatus(), supplierOpeningResult.getPriceBidStatus(), hasBidPrice);
										if(isShowConfirm){
											supplierComposite.refreshConfirmInfo(confirmTime, confirmStatus);
										}
										if(isInRemoteProgress && !supplierComposite.isDescryComplate()){
											supplierComposite.showProgress();
										}
									}
								}
							}
							
							boolean oldVisible = pageComposite.getVisible();
							if(supplierPage.getPages() > 1){
								pageComposite.refreshPages(supplierPage);
								if(!oldVisible){
									WidgetUtils.setControlVisible(pageComposite, true);
								}
							}else {
								if(oldVisible){
									WidgetUtils.setControlVisible(pageComposite, false);
								}
							}
							
							if(!decryptSupplierComposite.isDisposed()){
								loadDecryptSupplierComposite.layout();
								if(supplierPage.getSize() > 0){
									supplierListHeight = scrolledComposite.getBounds().height - gl_decryptSupplierComposite.marginHeight * 2 - gl_decryptSupplierComposite.marginTop - gl_decryptSupplierComposite.marginBottom;
									
									int surplusHeight = supplierListHeight - supplierPage.getSize() * gl_decryptSupplierComposite.verticalSpacing - totalHeight;
									if(surplusHeight > 0){
										int perHeight = surplusHeight/supplierPage.getSize();
										
										Iterator<Entry<String, RemoteSupplierListener>> iterator = remoteSupplierListener.entrySet().iterator();
										while(iterator.hasNext()) {
											Entry<String, RemoteSupplierListener> supplierRemoteListner = iterator.next();
//										}
//										for(Entry<String, RemoteSupplierListener> supplierRemoteListner : remoteSupplierListener.entrySet()){
											SupplierRemoteDecryptComposite remoteSupplier = (SupplierRemoteDecryptComposite)supplierRemoteListner.getValue();
											int height = remoteSupplier.computeSize(width, SWT.DEFAULT).y + perHeight;
											((GridData)remoteSupplier.getLayoutData()).heightHint = height > 70 ? 70 : height;
//											remoteSupplierListener.setRowHeight(remoteSupplierListener.getRowHeight() + perHeight);
										}
									}
								}
								reFreshBtn.setEnabled(true);
								decryptSupplierComposite.layout();
								scrolledComposite.setMinSize(decryptSupplierComposite.computeSize(SWT.DEFAULT, SWT.DEFAULT));
							}
							
						}
					}
				});
				
			}
		}).start();
	}
	
	
	/**
	 * @Description: 开启开标流程
	 * @author guoyr 
	 */
	private void startBidopeningAction(){
		if(!checkStartOpeningHall()){
			return;
		}
		StringBuilder message = getStartOpeningHallConfirmMsg();
		if(startBidopeningBtn.getEnabled()){
			message.append("\r\n").append(Messages.Tips_confirmStartOpeningHall);
			ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), null, message.toString(), null);
			confirmDialog.addButton(Messages.Button_openRemoteBidOpeningHall, "01", null);
			confirmDialog.addCancel(Messages.Button_cancel, null);
			confirmDialog.setTipsColor(SWTResourceManager.getColor(255, 0, 0));
			confirmDialog.setTips(Messages.Tips_checkBidOpeningTime);
			confirmDialog.setMinimumSize(new Point(600, 250));
			confirmDialog.open();
			if (!confirmDialog.getClickStatus().equals("01")) {
				return;
			}
			startBidopeningBtn.setText(Messages.Tips_starting);
		}else{
			boolean isStart = false;
			if(isPriceStage){
				isStart = CommonEnum.YES.equals(curTenderPack.getStartPriceBidOpening());
			}else {
				isStart = CommonEnum.YES.equals(curTenderPack.getStartBidOpening());
			}
			if(isStart){
				message.append("\r\n").append(Messages.Tips_reStartOpeningHall);
				ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), null, message.toString(), null);
				confirmDialog.addButton(Messages.Button_openRemoteBidOpeningHall, "reStart", SWTResourceManager.getColor(77, 163, 19));
				confirmDialog.addCancel(Messages.Button_cancel, null);
				confirmDialog.setMinimumSize(new Point(600, 250));
				confirmDialog.open();
				if(confirmDialog.isCancel()){
					return;
				}
			}
		}

		startBidopeningBtn.setEnabled(false);
//		if(!CommonEnum.YES.equals(curTenderPack.getLatestBidinfo())){
			synNewBidInfoInfo(Messages.Tips_synchronizingNewTenderInfo);
//		}
		
		final ProgressMessageDialog messageProgress = new ProgressMessageDialog(getShell(), false, -1, new LoadingAdatper() {
			public void finish(boolean flag) {
				isStartRemoteBidopening = flag;
				Display.getDefault().syncExec(new Runnable(){
					public void run(){
						if(!startBidopeningBtn.isDisposed()){
							if(flag){
								startBidopeningBtn.setText(Messages.Button_openRemoteBidOpeningHallAlready);
								MessageDialog.openShortMessage(Messages.Tips_startOpeningHallSuccess);
								startBidopeningBtn.setEnabled(false);
							}else {
								startBidopeningBtn.setText(Messages.Button_openRemoteBidOpeningHall);
								startBidopeningBtn.setEnabled(true);
							}
						}
					}
				});
			}
		});
		messageProgress.setTitle(Messages.Button_openRemoteBidOpeningHall);
		new StartRemoteBidopeningHallThread(tenderProjectEntity, curTenderPack, bidopeningStage, bidOpeningTime, signEndTime, decryptEndTime,messageProgress).start();
		messageProgress.open();
	}
	
	/**
	 * @Description: 下载供应商签到结果
	 * @author guoyr 
	 */
	private void startRefreshRemoteSignInfoThread(){
		if(null != getSupplierRemoteSignThread){
			getSupplierRemoteSignThread.stop();
		}
		if(isFocusDecrypt){
			// 集中解密不需要签到，则刷新总投标座位人数
			meetingRoomListener.refreshPeopleCount(supplierCount);
		}else {
			getSupplierRemoteSignThread = new RemoteSupplierSignThread(curTenderPack, bidopeningStage, new RemoteSupplierSignThread.RemoteSignListener() {
				public void refreshSignInfo(Supplier supplier, Date signTime, String signPerson, String signPersonTel, String signPersonCard){
					supplierMap.put(supplier.getId(), supplier);
					RemoteSupplierListener supplierListener = remoteSupplierListener.get(supplier.getId());
					if(null != supplierListener){
						supplierListener.refreshSignInfo(signTime, signPerson, signPersonTel, signPersonCard);
					}
				}
				public void refreshSignCount(int signCount){
					supplierSignCount = signCount;
					tenderPackOpeningInfo.setSignCount(signCount);
					signStatusCount.setCounts(new int[]{anonymousAllInfo ? -1 : supplierSignCount});
					// 刷新签到座位人数
					meetingRoomListener.refreshPeopleCount(anonymousAllInfo ? 0 : supplierSignCount);
				}
			});
			getSupplierRemoteSignThread.start();
		
		}
	}
	
	/**
	 * @Description: 获得供应商在线关态
	 * @author guoyr 
	 */
	private void startRefreshOnlineStatusThread(){
		if(null != romoteSupplierOnlineThread){
			romoteSupplierOnlineThread.stop();
		}
		romoteSupplierOnlineThread = new RomoteSupplierOnlineThread(curTenderPack, bidopeningStage, new RomoteSupplierOnlineThread.EnterOpenListener() {
			public void enterStatus(final Map<String, String> enterStatusMap) {
				if(null != enterStatusMap){
					if(null != remoteSupplierListener){
						Iterator<Entry<String, RemoteSupplierListener>> iterator = remoteSupplierListener.entrySet().iterator();
						while(iterator.hasNext()) {
							Entry<String, RemoteSupplierListener> supplierRemoteListner = iterator.next();
//						for(Entry<String, RemoteSupplierListener> supplierRemoteListner : remoteSupplierListener.entrySet()){
							Supplier supplier = supplierRemoteListner.getValue().getSupplier();
							String onlineStatus = "";
							if(null != supplier && null != supplier.getOrgCode()){
								onlineStatus = enterStatusMap.get(supplier.getOrgCode());
								supplierRemoteListner.getValue().refreshOnlineStatus(onlineStatus);
							}
						}
					}
				}
			}
		});
		romoteSupplierOnlineThread.start();
	}
	
	/**
	 * @Description: 下载供应商确认结果
	 * @author guoyr 
	 */
	private void startRefreshRemoteConfirmInfoThread(){
		if(null != getSupplierRemoteConfirmThread){
			getSupplierRemoteConfirmThread.stop();
		}
		
		if(isShowConfirm){
			getSupplierRemoteConfirmThread = new RemoteSupplierConfirmThread(curTenderPack, bidopeningStage, new RemoteSupplierConfirmThread.RemoteConfirmListener() {
				public void refreshConfirmInfo(Supplier supplier, Date confirmTime, String confirmStatus) {
					supplierMap.put(supplier.getId(), supplier);
					if(null != remoteSupplierListener){
						RemoteSupplierListener listener = remoteSupplierListener.get(supplier.getId());
						if(null != listener){
							listener.refreshConfirmInfo(confirmTime, confirmStatus);
						}
					}
				}
			});
			getSupplierRemoteConfirmThread.start();
		}
	}
	/**
	 * @Description: 下载开标结果
	 * @author guoyr 
	 */
	private void downloadSupplierRemoteDecryptStatus(){
		if(null != getRemoteDecryptStatusThread){
			getRemoteDecryptStatusThread.stop();
		}
		getRemoteDecryptStatusThread = new RemoteDecryptStatusThread(curTenderPack, bidopeningStage, decryptBidFileListener);
		getRemoteDecryptStatusThread.start();
	}
	
	
	/**
	 * @Description: 开标议程
	 * @author guoyr
	 */
	public void showBidOpeningCountDown(){
		if(!openBiddingAgendaBtn.getEnabled()){
			return ;
		}
		String bidOpeningAgenda = tenderProjectRuleEntity.getBidOpeningAgenda();
		if(isPriceStage){
			if(null != tenderProjectRuleEntity.getPriceBidOpeningAgenda() && tenderProjectRuleEntity.getPriceBidOpeningAgenda().length() > 0){
				bidOpeningAgenda = tenderProjectRuleEntity.getPriceBidOpeningAgenda();
			}
		}
		BidOpeningCountDownShell countDownShell = new BidOpeningCountDownShell(getShell(), curTenderPack, bidOpeningTime, bidOpeningAgenda);
		countDownShell.open();
	}
	
	/**
	 * @Description: 开标解密
	 * @author guoyr 
	 */
	private void openBidAction(){
		if(!bidOpeningBtn.getEnabled()){
			return;
		}
		boolean isInRemoteProgress = false;
		if(isPriceStage){
			if(null != curTenderPack.getPriceBidStatus() && curTenderPack.getPriceBidStatus().equals(CommonEnum.IN_PROGRESS)){
				isInRemoteProgress = true;
			}
		}else if(isBusAndTecStage){
			if((null != curTenderPack.getBusinessBidStatus() && curTenderPack.getBusinessBidStatus().equals(CommonEnum.IN_PROGRESS))||(null != curTenderPack.getTechnologyBidStatus() && curTenderPack.getTechnologyBidStatus().equals(CommonEnum.IN_PROGRESS))){
				isInRemoteProgress = true;
			}
		}else {
			if((null != curTenderPack.getBusinessBidStatus() && curTenderPack.getBusinessBidStatus().equals(CommonEnum.IN_PROGRESS))||(null != curTenderPack.getTechnologyBidStatus() && curTenderPack.getTechnologyBidStatus().equals(CommonEnum.IN_PROGRESS)) || (null != curTenderPack.getPriceBidStatus() && curTenderPack.getPriceBidStatus().equals(CommonEnum.IN_PROGRESS))){
				isInRemoteProgress = true;
			}
		}
		if(isInRemoteProgress){
			// 不允午主动停止获取
			stopDecBidAction();
		}else {
			doDecBidAction(false, true);
		}
	} 
	
	
	/**
	 * @Description: 停止解密
	 * @author guoyr 
	 */
	private void stopDecBidAction(){
		if(null != getSupplierRemoteSignThread){
			getSupplierRemoteSignThread.stop();
			getSupplierRemoteSignThread = null;
		}
		if(null != getRemoteDecryptStatusThread){
			getRemoteDecryptStatusThread.stop();
			getRemoteDecryptStatusThread = null;
		}
		if(null != getSupplierRemoteConfirmThread){
			getSupplierRemoteConfirmThread.stop();
			getSupplierRemoteConfirmThread = null;
		}
		ActionLogUtils.addServerLog(curTenderPack.getId(),"停止获取", "停止获取开标结果");
		tenderProjectService.updateBidOpeningStatus(curTenderPack, bidopeningStage, CommonEnum.STOP);
		isInRemoteProgress = false;
		bidOpeningBtn.setEnabled(true);
		bidOpeningBtn.setText(decryptName);
		refreshComplateBtnStatus();
		Iterator<Entry<String, RemoteSupplierListener>> iterator = remoteSupplierListener.entrySet().iterator();
		while(iterator.hasNext()) {
			Entry<String, RemoteSupplierListener> entry = iterator.next();
//		for(Entry<String, RemoteSupplierListener> entry : remoteSupplierListener.entrySet()){
			if(null != entry.getValue()){
				entry.getValue().showStatus();
			}
		}
	}
	
	private void doDecBidAction(final boolean synchronizedInfoOnly, boolean showTips){
		
		if(!synchronizedInfoOnly){
			if(!isFocusDecrypt && !isStartRemoteBidopening ){
				MessageDialog.openShortMessage(Messages.Tips_noStartOpeningHall);
				return;
			}
			if(!checkBidOpening(showTips)){
				return;
			}
		}
//		BidOpeningStageComfirmShell bidOpeningSelectShell = new BidOpeningStageComfirmShell(getShell(), bidopeningStage, new DecBidListener(){
//
//			public void decBid(boolean decBusinessBid, boolean decTechnologyBid, boolean decPriceBid) {}
//		});
//		bidOpeningSelectShell.open();

		Display.getDefault().syncExec(new Runnable(){
			public void run(){
				if(!bidOpeningBtn.isDisposed()){
					bidOpeningBtn.setEnabled(false);
					complateBidopeningBtn.setEnabled(false);
				}
			}
		});
		
		final ProgressMessageDialog messageProgress = new ProgressMessageDialog(getShell(), false, -1, new LoadingAdatper() {
			public void finish(boolean flag) {
				if(flag){
					isInRemoteProgress = true;
					curTenderPack = tenderProjectService.getById(curTenderPack.getId());
					Display.getDefault().syncExec(new Runnable(){
						public void run(){
							if(!bidOpeningBtn.isDisposed()){
								bidOpeningBtn.setEnabled(false);
//								bidOpeningBtn.setEnabled(true);
//								bidOpeningBtn.setText(Messages.Button_stopDecrypt);
								complateBidopeningBtn.setEnabled(false);
							}
							// 当前页显示远程解密进度
							Iterator<Entry<String, RemoteSupplierListener>> iterator = remoteSupplierListener.entrySet().iterator();
							while(iterator.hasNext()) {
								Entry<String, RemoteSupplierListener> entry = iterator.next();
//							for(Entry<String, RemoteSupplierListener> entry : remoteSupplierListener.entrySet()){
								RemoteSupplierListener listener = entry.getValue();
								if(null != listener){
									listener.showProgress();
								}
							}
						}
					});
					// 成功启动远程开标后，开始下载解密信息
					downloadSupplierRemoteDecryptStatus();
				}else {
					Display.getDefault().syncExec(new Runnable(){
						public void run(){
							if(!bidOpeningBtn.isDisposed()){
								bidOpeningBtn.setEnabled(true);
							}
						}
					});
				}
			
			}
			
		});
		if(isFocusDecrypt){
			// 启动远程解密
			StartFocusDecryptBidFilThread startRemoteDecryptBidFilThread = new StartFocusDecryptBidFilThread(curTenderPack, decryptEndTime, bidopeningStage, messageProgress, synchronizedInfoOnly);
			startRemoteDecryptBidFilThread.start();
		}else {
			// 启动远程解密
			StartRemoteDecryptBidFilThread startRemoteDecryptBidFilThread = new StartRemoteDecryptBidFilThread(curTenderPack, decryptEndTime, bidopeningStage, messageProgress, synchronizedInfoOnly);
			startRemoteDecryptBidFilThread.start();
		}
		messageProgress.setTitle(bidOpeningBtn.getText());
		messageProgress.open();
	}
	
	private void refreshStatusCount(final int totalCount, final int successCount, final int noDecCount, final int failedDecCout, final int noPriceCount){
		this.decSuccessCount = successCount;
		this.decFaildCount = failedDecCout;
		this.noDecCount = noDecCount;
		this.supplierCount = totalCount;
		this.noPriceCount = noPriceCount;
		
		tenderStatusCount.setCounts(new int[]{anonymousAllInfo? -1 : supplierCount});
		signStatusCount.setCounts(new int[]{anonymousAllInfo? -1 : supplierSignCount});
		decStatusCount.setCounts(new int[]{anonymousAllInfo? -1 : decSuccessCount});
		decStatusCount.setErrors(failedDecCout + noPriceCount);
	}
	
	
	/**
	 * @Description: 唱标
	 * @author guoyr 
	 */
	private void signBidAction(){
		if(signBidBtn.getEnabled()){
			SingBidShell singBidShell = new SingBidShell(getShell(), null != curTenderPack ? curTenderPack : tenderProjectEntity);
			singBidShell.open();
		}
	}
	/**
	 * @Description: 签字确认
	 * @author guoyr 
	 */
	private void signatureAction() {
		if(!signatureBtn.getEnabled())return;
		if(!CommonEnum.COMPLETE.equals(curTenderPack.getBidOpeningStatus())){
			if(!MessageDialog.openConfirm(getShell(), null, Messages.Tips_notComplateBidOpeningOperate, new String[]{Messages.Button_confirm, Messages.Button_cancel})){
				return;
			}
		}
		BidOpeningReportDialog dialog = new BidOpeningReportDialog(getShell(), curTenderPack, false, menuFunctions);
		dialog.setTitle(Messages.Button_remoteSignatureOpeningResult);
		dialog.open();
	}
	/**
	 * @Description: 发送消息
	 * @author guoyr 
	 */
	private void sendMessageAction(){
		if(null != sendMessageDialog && !sendMessageDialog.isDisposed()){
			sendMessageDialog.showDialog();
		}else {
			sendMessageDialog = new SendMessageDialog(getShell(), curTenderPack, bidopeningStage, null);
			sendMessageDialog.setSize(200, 300);
			sendMessageDialog.setAlpha(250);
			ScreenUtils screenUtils = new ScreenUtils();
			sendMessageDialog.setLocation(0, 0);
			sendMessageDialog.setLocation((screenUtils.getScreenWight() - sendMessageDialog.getBounds().width), screenUtils.getScreenHight() -  sendMessageDialog.getBounds().height - 40);
			sendMessageDialog.open();
		}
	}
	
	/**
	 * @Description: 鼠标拖动事件
	 * @author guoyr
	 */
	
	class NumPaintListener implements PaintListener{

		private int x;
		private int y;
		public NumPaintListener(int x, int y){
			this.x = x;
			this.y = y;
		}
		public void paintControl(PaintEvent arg0) {
			String num = (String)((CLabel)arg0.getSource()).getData();
			if(null == num){
				num = "0";
			}
			arg0.gc.drawImage(imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/time/white_"+num+".png"), x, y);
			arg0.gc.dispose();
		}
	}

	/**
	 * @Description: 完成开标
	 * @author guoyr 
	 */
	private void complateBidOpeningAction(boolean showTips){
		if(!complateBidopeningBtn.getEnabled()){
			if(null != complateBidopeningBtn.getData("isComplate")){
				ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), null, Messages.Tips_reuploadBidOpeningResult, null);
				addPublicType(confirmDialog);
				confirmDialog.addButton("确认重新上传结果", "01", null);
				confirmDialog.addCancel(Messages.Button_cancel, null);
				confirmDialog.open();
				if(confirmDialog.isCancel()){
					return;
				}
			}else {
				return;
			}
		}else if(!checkComplate(showTips)){
			return;
		}
		
		complateBidopeningBtn.setEnabled(false);
		
		final ProgressMessageDialog messageProgress = new ProgressMessageDialog(getShell(), false, -1, new LoadingAdatper() {
			public void finish(boolean flag) {
				Display.getDefault().syncExec(new Runnable(){
					public void run(){
						if(!complateBidopeningBtn.isDisposed()){
							refreshAction();
//							refreshComplateBtnStatus();
						}
					}
				});
			}
		});
		UploadBidOpeningResultThread uploadBidOpeningResultThread = new UploadBidOpeningResultThread(curTenderPack, bidopeningStage, publicType, messageProgress);
		uploadBidOpeningResultThread.start();
		messageProgress.setTitle(MessageFormat.format(Messages.Tips_uploadingFormat, Messages.BidOpeningResult));
		messageProgress.open();
	}

	public void addPublicType(ConfirmDialog confirmDialog) {
		if(null != menuFunctions && MenuFunction.SHOW.equals(menuFunctions.getAuthority("PUBLIC_TYPE"))){
			// 如果是竞争性谈判和竞争性磋商（目前是其他），则需要选择是否公开
			if(!isBusAndTecStage && (TenderProjectEnum.JZXTP.equals(curTenderPack.getTenderMethod()) || TenderProjectEnum.CONSULTATION.equals(curTenderPack.getTenderMethod()) || TenderProjectEnum.OTHER.equals(curTenderPack.getTenderMethod()))) {
				publicType = "02";
				confirmDialog.addCheckBox("向投标人公开开标一览表汇总表", "01".equals(publicType), new SelectionAdapter() {
					public void widgetSelected(SelectionEvent e) {
						if(confirmDialog.getCheckBtnSelection()) {
							publicType = "01";
							MessageDialog.openShortMessage("参与开标的投标人可以看到开标一览表汇总表！");
						}else {
							MessageDialog.openShortMessage("参与开标的投标人不能看到开标一览表汇总表！");
							publicType = "02";
						}
					}
				});
			}
		}
	}
	
	/**
	 * @Description: 检查是否允许开标
	 * @author guoyr
	 * @return 
	 */
	private boolean checkBidOpening(boolean showTips){
		
		if(!checkStartDecrypt()){
			return false;
		}
		
//		if(!CommonEnum.YES.equals(curTenderPack.getLatestBidinfo())){//强制在解密时同步
		if((showTips && !CommonEnum.COMPLETE.equals(curTenderPack.getBidOpeningStatus())) || !CommonEnum.YES.equals(curTenderPack.getLatestBidinfo())){
			// 经济标不强制同步
			if(!isPriceStage || !CommonEnum.YES.equals(curTenderPack.getLatestBidinfo())) {
				if(!synNewBidInfoInfo(Messages.Tips_synchronizingNewTenderInfo)) {
					return false;
				}
			}
		}
			
		boolean synNewTenderInfo = false;
		
		// 如果是经济标类型评标步骤，必须开完经济标才能操作
		if(isPriceStage){
			if(null != menuFunctions && MenuFunction.SHOW.equals(menuFunctions.getAuthority("NEED_COMPLATE_BUS_TEC"))){
				EvaluationStepService evaluationStepService = new EvaluationStepService();
				if(!evaluationStepService.isComplateBusAndTecEvaluation(curTenderPack.getId())){
					ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), null, Messages.Tips_cantDescryptEconomicBid, null);
					confirmDialog.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/tips_info.png"), -1, -1);
					confirmDialog.addCancel(Messages.Button_cancel, null);
					confirmDialog.setMinimumSize(new Point(600, 250));
					confirmDialog.open();
					return false;
				}
			}
		}

		if(decFaildCount + noDecCount == 0){
			ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), null, MessageFormat.format(Messages.Tips_noSupplierToDecrypt, SUPPLIER_NAME), null);
			confirmDialog.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/tips_info.png"), -1, -1);
			confirmDialog.addCancel(Messages.Button_cancel, null);
			confirmDialog.open();
			return false;
		}
		List<Supplier> supplierList = supplierService.getSupplierOpenBidList(curTenderPack.getId());
		int signCount = 0;
		if(null != supplierList && supplierList.size() >0){
			for(Supplier supplier : supplierList){
				SupplierOpeningResult supplierOpeningResult = supplier.getSupplierOpeningResult();
				// 判断投标人是否废标
				if(null != supplierOpeningResult && StringUtils.equals(SupplierEnum.REVOKE_YES, supplierOpeningResult.getRevokeStatus())){
					continue;
				}else if(null == supplier.getTenderTime()){
					continue;
				}
				signCount ++;
			}
		}
		StringBuilder message = getStartDecryptConfirmMsg();
		message.append("\r\n");
		
		if(signCount < minSupplierCount){

			if(!MenuFunction.HIDE.equals(menuFunctions.getAuthority(MenuFunctionEnum.LESS_THAN_THREE_FILTER)) || (TenderProjectEnum.GKZB.equals(curTenderPack.getTenderMethod()) || TenderProjectEnum.YQZB.equals(curTenderPack.getTenderMethod()))){
				ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), null, MessageFormat.format(Messages.Tips_cantBidOpeningCondition, SUPPLIER_NAME, minSupplierCount), null);
				confirmDialog.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/tips_info.png"), -1, -1);
				confirmDialog.addCancel(Messages.Button_cancel, null);
//				confirmDialog.setMinimumSize(new Point(600, 250));
				confirmDialog.open();
				return false;
			}else {
				ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), null, message.toString() + MessageFormat.format(Messages.Tips_lessThanBidOpeningCondition, SUPPLIER_NAME, minSupplierCount), null);
				confirmDialog.setTips(Messages.Tips_checkSynchronizNewTenderInfoAndCheckTime);
				confirmDialog.setTipsColor(SWTResourceManager.getColor(255, 0, 0));
				confirmDialog.addButton(MessageFormat.format(Messages.Button_syncAndStartFormat, decryptName), "syn", SWTResourceManager.getColor(77, 163, 19));
				confirmDialog.addButton(Messages.Button_continueDecrypt, "01", null);
				confirmDialog.addCancel(Messages.Button_cancel, null);
				confirmDialog.setMinimumSize(new Point(600, 250));
				confirmDialog.open();
				
				if(confirmDialog.isCancel()){
					return false;
				}
				if(confirmDialog.getClickStatus().equals("syn")){
					synNewTenderInfo = true;
				}
			}
		
		}else if(showTips){
			ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), decryptName, message.toString() + MessageFormat.format(Messages.Tips_confirmStartBidOpening, decryptName), null);
			confirmDialog.setTips(Messages.Tips_checkSynchronizNewTenderInfoAndCheckTime);
			confirmDialog.setTipsColor(SWTResourceManager.getColor(255, 0, 0));
			confirmDialog.addButton(MessageFormat.format(Messages.Button_syncAndStartFormat, decryptName), "syn", SWTResourceManager.getColor(77, 163, 19));
			confirmDialog.addButton(MessageFormat.format(Messages.Button_startFormat, decryptName), "01", null);
			confirmDialog.addCancel(Messages.Button_cancel, null);
			confirmDialog.setMinimumSize(new Point(600, 250));
			confirmDialog.open();
			if(confirmDialog.isCancel()){
				return false;
			}
			if(confirmDialog.getClickStatus().equals("syn")){
				synNewTenderInfo = true;
				return synNewBidInfoInfo(Messages.Tips_synchronizingNewTenderInfo);
			}
		}
		
		if(synNewTenderInfo || !CommonEnum.YES.equals(curTenderPack.getLatestBidinfo())){
			if (!synNewBidInfoInfo(Messages.Tips_synchronizingNewTenderInfo)) {
				ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), null, Messages.Tips_synchronizTenderInfoFail, null);
				confirmDialog.addButton(Messages.Tips_confirmAndContinueDecrypt, "01", SWTResourceManager.getColor(77, 163, 19));
				confirmDialog.addCancel(Messages.Button_cancel, null);
				confirmDialog.setMinimumSize(new Point(600, 250));
				confirmDialog.open();
				if (confirmDialog.getClickStatus().equals("01")) {
					ActionLogUtils.addServerLog(curTenderPack.getId(),"启动解密", "未同步成功最新投标信息，但已确认当前为最新投标信息，继续解密");
				}else {
					return false;
				}
			}
		}
		return true;
	}
	
	/**
	 * @Description: 检查是否允完成开标
	 * @author guoyr
	 * @return 
	 */
	private boolean checkComplate(boolean showTips){
		
		List<Supplier> supplierList = supplierService.getSupplierOpenBidList(curTenderPack.getId());
		if(null != supplierList && supplierList.size() >0){
			int unConfirmCount = 0;
			boolean isShowConfirm = PropertiesUtils.getProperty(ConfigConstants.SHOW_CONFIRM_STATUS, "00").equals("01");
			int decCount = 0;
			int decSuccessCount = 0;
//			int decFailCount = 0;
			for(Supplier supplier : supplierList){
				SupplierOpeningResult supplierOpeningResult = supplier.getSupplierOpeningResult();
				// 判断投标人是否废标
				if(null != supplierOpeningResult && StringUtils.equals(SupplierEnum.REVOKE_YES, supplierOpeningResult.getRevokeStatus())){
					continue;
				}else if(null == supplier.getTenderTime()){
					continue;
				}else {
					String confirmStatus = null;
					String descStatus = null;
					if(isPriceStage){
						confirmStatus = supplierOpeningResult.getPriceConfirmStatus();
						descStatus = supplierOpeningResult.getPriceBidStatus();
					}else {
						confirmStatus = supplierOpeningResult.getConfirmStatus();
						descStatus = supplierOpeningResult.getBusinessBidStatus();
					}
					
					if(null != descStatus && descStatus.equals(SupplierEnum.OPENBID_SUCCESS)){
						decSuccessCount ++;
						decCount ++;
					}else if(null != descStatus && descStatus.equals(SupplierEnum.OPENBID_FIALE)){
//						decFailCount ++;
						decCount ++;
					}
					if(null == confirmStatus || !confirmStatus.equals(SupplierEnum.CONFIRM_YES)){
						unConfirmCount ++;
					} 
				}
			}
			
			if(decCount == 0){
				MessageDialog.openShortMessage(Messages.Tips_noStartDecrypt);
				return false;
			}
			
			StringBuilder msg = new StringBuilder();
			msg.append(MessageFormat.format(Messages.Tips_totalTenderCountAndDecryptSuccessCount, supplierCount, decSuccessCount));
			
			if(decFaildCount > 0 || (noPriceCount > 0 && noPriceCount != decSuccessCount)){
				if(decFaildCount > 0){
					msg.append(MessageFormat.format(Messages.Tips_decryptFailedCount, decFaildCount));
				}
				if(noPriceCount > 0){
					if(decFaildCount > 0){
						msg.append(Messages.Comma);
					}
					msg.append(MessageFormat.format(Messages.Tips_obtainQuotationFailedCount, noPriceCount));
				}
				msg.append(Messages.Exclamatory);
				
				ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), null, msg.toString(), null);
//				confirmDialog.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/tips_info.png"), -1, -1);
				confirmDialog.addButton(Messages.Button_confirm, "01", null, 90);
				confirmDialog.setTipsAlignment(SWT.CENTER);
				confirmDialog.setTipsColor(SWTResourceManager.getColor(255, 0, 0));
				confirmDialog.setTips(Messages.Tips_problemsSolve);
				confirmDialog.open();
				return false;
			}
			
			if(isShowConfirm && unConfirmCount > 0){
				msg.append(MessageFormat.format(Messages.Tips_noConfirmOpeningResutlCount, unConfirmCount, SUPPLIER_NAME)).append(Messages.Comma);
			}
			msg.append(Messages.Tips_confirmComplateAndUploadOpeningResult);
			
			StringBuilder tips = new StringBuilder();
			if(noDecCount > 0){
				tips.append(MessageFormat.format(Messages.Tips_noDecryptCount, noDecCount)).append(Messages.Semicolon);
			}
			if(noPriceCount > 0 && noPriceCount == decSuccessCount) {
				if(tips.length() > 0)tips.append("\r\n");
				tips.append(MessageFormat.format(Messages.Tips_obtainQuotationFailedCount, noPriceCount)).append((Messages.Semicolon));
			}
			if(decSuccessCount < minSupplierCount){
				if(tips.length() > 0)tips.append("\r\n");
				tips.append(MessageFormat.format(Messages.Tips_LessThanThreeSuppliersDecrypted, SUPPLIER_NAME, minSupplierCount)).append(Messages.Semicolon);
			}
			ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), "完成解密并上传结果", msg.toString(), null);
			addPublicType(confirmDialog);
			confirmDialog.addButton("确认完成解密并上传结果", "01", null);
			confirmDialog.addCancel(Messages.Button_cancel, null);
			if(tips.length() > 0) {
				if(noDecCount > 0) {
					tips.append("\r\n完成解密并上传结果后，还未成功解密的标书将不能继续解密！");
				}
				confirmDialog.setTipsAlignment(SWT.LEFT);
				confirmDialog.setTips(tips.toString());
				confirmDialog.setTipsColor(SWTResourceManager.getColor(255, 0, 0));
			}
			confirmDialog.open();
			if("01".equals(confirmDialog.getClickStatus())){
				ActionLogUtils.addServerLog(curTenderPack.getId(),"确认完成解密并上传结果", tips.toString());
				return true;
			}
		}
		return false;
	}
	
	private void showMeetingTitle(){
		String titleName = tenderProjectEntity.getTenderName();
		if(showProjectNo){
			titleName = "["+tenderProjectEntity.getTenderNo() + "]"+ tenderProjectEntity.getTenderName();
		}
		if(null != project){
			titleName = project.getTenderName();
			if(showProjectNo){
				titleName = "["+project.getTenderNo() + "]"+ project.getTenderName();
			}
		}
		meetingRoomListener.refreshMeetingTitle(titleName);
	}
	
	/**
	 * @Description: 同步最新投标信息
	 * @author guoyr
	 * @return 
	 */
	private boolean synNewBidInfoInfo(String title){
		final ProgressMessageDialog messageProgress = new ProgressMessageDialog(getShell(), true, -1, new LoadingAdatper() {
			public void finish(final boolean flag) {
				if(flag){
					// 如果已过开标时间，则标识为已同步最新投标信息
					if(NowTimeUtils.getNowDate().after(bidOpeningTime)){
						curTenderPack.setLatestBidinfo(CommonEnum.YES);
						ActionLogUtils.addServerLog(curTenderPack.getId(), "开标时间之后最后同步过最新投标人信息", curTenderPack.getTenderNo() + curTenderPack.getTenderName());
						tenderProjectService.updateAssignProperty(curTenderPack, new String[]{"latestBidinfo"});
					}
				}
				Display.getDefault().syncExec(new Runnable(){
					public void run(){
						if(!decryptSupplierComposite.isDisposed()){
							if(flag){
								refreshAction();
							}else {
								downTenderInfoBtn.setEnabled(true);
							}
						}
					}
				});
			}
		});
		messageProgress.setTitle(title);
		RefreshProjectSupplierTenderInfoThread refreshProjectSupplierTenderInfoThread = new RefreshProjectSupplierTenderInfoThread(curTenderPack, messageProgress);
		refreshProjectSupplierTenderInfoThread.start();
		messageProgress.open();
		refreshProjectSupplierTenderInfoThread.stop();
		return messageProgress.getFinishFlag();
	}
	
	/**
	 * @Description: 更多设置
	 * @author guoyr 
	 */
	private void moreConfigAction(){
		final ToolsShell moreToolsShell = new ToolsShell(getShell());
		final Composite actionGroup = moreToolsShell.addToolBar(Messages.Button_moreOperate, null, false);
		
		moreToolsShell.addTool(actionGroup, Messages.Button_syncNewTenderInfo, imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/btn/blue/download.png"), true, new ToolsShell.ClickListener() {
			public void click() {
				moreToolsShell.close();
				synNewBidInfoInfo(Messages.Tips_synchronizingNewTenderInfo);
			}
		});
		
		moreToolsShell.addTool(actionGroup, Messages.Button_syncDecryptInfo , imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/btn/blue/download.png"), true, new ToolsShell.ClickListener(){
			public void click() {
				if(!moreToolsShell.isDisposed()){
					moreToolsShell.close();
				}
				doDecBidAction(true, false);
//				new Thread(new Runnable(){
//					public void run(){
//						if(isPriceStage){
//							curTenderPack.setStartPriceBidOpening(CommonEnum.YES);
//							tenderProjectService.updateAssignProperty(curTenderPack, new String[]{"startPriceBidOpening"});
//						}else {
//							curTenderPack.setStartBidOpening(CommonEnum.YES);
//							tenderProjectService.updateAssignProperty(curTenderPack, new String[]{"startBidOpening"});
//						}
//						// 初始化开标结果
//						supplierService.initSupplierBidOpeningResult(tenderProjectEntity.getId());
//						tenderProjectService.updateBidOpeningStatus(curTenderPack, bidopeningStage, CommonEnum.IN_PROGRESS);
//						Display.getDefault().syncExec(new Runnable(){
//							public void run(){
//								if(!decryptSupplierComposite.isDisposed()){
//									refreshAction();
//								}
//							}
//						});
//					}
//				}).start();
			}
		});
		
		moreToolsShell.addTool(actionGroup, Messages.Button_syncQuoteInfo , imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/btn/blue/download.png"), true, new ToolsShell.ClickListener(){
			public void click() {
				if(!moreToolsShell.isDisposed()){
					moreToolsShell.close();
				}
				List<Supplier> supplierList = supplierService.getSupplierOpenBidList(curTenderPack.getId());
				if(null != supplierList && supplierList.size() > 0){
					final MessageViewDialog dialog = new MessageViewDialog(getShell(),-1);
					dialog.setTitle(Messages.Button_syncQuoteInfo);
					DownloadSupplierBidPriceUtils downloadSupplierBidPriceUtils = new DownloadSupplierBidPriceUtils(curTenderPack);
					final int[] downloadSuccess = new int[]{0};
					CallBack callBack = new CallBack(){
						public void callBackString(String msg) {
							dialog.getCallBack().callBackString(msg);
						}
						
						public void after() {
							dialog.getCallBack().after();
						}
						public void callBackBoolean(boolean bool) {
							if(bool){
								downloadSuccess[0]++;
							}
						}
					};
					int count = 0;
					for(Supplier supplier : supplierList){
						if(null != supplier.getTenderTime()){
							count ++;
							downloadSupplierBidPriceUtils.downloadBidPrice(supplier, callBack);
						}
					}
					if(count == 0){
						dialog.getCallBack().callBackString(Messages.Tips_noSyncQuotation);
					}
					dialog.open();
					if(downloadSuccess[0] > 0){
						refreshAction();
					}
				}
			}
		});
		
		boolean isFullScreen = getShell().getMaximized();
		moreToolsShell.addTool(actionGroup, isFullScreen? "显示任务栏" : "全屏显示", imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/btn/blue/evaluation.png"), true, new ToolsShell.ClickListener(){
			public void click() {
				moreToolsShell.close();
				if(isFullScreen) {
					getShell().setMaximized(false);
					ScreenUtils screenUtils = new ScreenUtils();
					int w = screenUtils.getScreenWight(); // 获取屏幕宽度
					int h = screenUtils.getScreenHight() - screenUtils.getTaskBarHight(); // 获取屏幕高度
					getShell().setLocation(0, 0);
					getShell().setSize(w,h);
				}else {
					getShell().setMaximized(true);
					getShell().notifyListeners(SWT.Resize, null);
				}
				
			}
		});
		
		Composite toolGroup = moreToolsShell.addToolBar(Messages.Config_propertyConfiguration, null, false);
		moreToolsShell.addTool(toolGroup, showProjectNo ? Messages.Button_notShowProjectCode : Messages.Button_showProjectCode, null, true, new ToolsShell.ClickListener(){
			public void click() {
				showProjectNo = !showProjectNo;
				if(!moreToolsShell.isDisposed()){
					moreToolsShell.close();
				}
				showMeetingTitle();
				
			}
		});
		if(null != menuFunctions && MenuFunction.SHOW.equals(menuFunctions.getAuthority("SHOW_CONFIRM_STATUS"))){
			moreToolsShell.addTool(toolGroup, isShowConfirm? Messages.Button_noNeedConfirmResult : Messages.Button_needConfirmResult, imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/btn/blue/user.png"), true, new ToolsShell.ClickListener(){
				public void click() {
					isShowConfirm = !isShowConfirm;
					PropertiesUtils.saveProperty(ConfigConstants.SHOW_CONFIRM_STATUS, isShowConfirm ? "01" : "00");
					moreToolsShell.close();
					if(null != remoteSupplierListener){
						Iterator<Entry<String, RemoteSupplierListener>> iterator = remoteSupplierListener.entrySet().iterator();
						while(iterator.hasNext()) {
							Entry<String, RemoteSupplierListener> entry = iterator.next();
//					for(Entry<String, RemoteSupplierListener> entry : remoteSupplierListener.entrySet()){
							RemoteSupplierListener listener = entry.getValue();
							if(null != listener){
								listener.setShowComfirmStatus(isShowConfirm);
							}
						}
					}
				}
			});
		}
		if(null != curTenderPack.getPhaseType() && curTenderPack.getPhaseType().equals(TenderProjectEnum.PHASE_TYPE_PRE)){
			final boolean hiddenPrevaluationPrice = PropertiesUtils.getProperty(ConfigConstants.HIDDEN_PREEVALUATION_PRICE, "01").equals("01");
			moreToolsShell.addTool(toolGroup, hiddenPrevaluationPrice? "显示经济标 " : "隐藏经济标", imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/btn/blue/config.png"), true, new ToolsShell.ClickListener(){
				public void click() {
					PropertiesUtils.saveProperty(ConfigConstants.HIDDEN_PREEVALUATION_PRICE, (!hiddenPrevaluationPrice) ? "01" : "00");
					moreToolsShell.close();
					if(null != remoteSupplierListener){
						Iterator<Entry<String, RemoteSupplierListener>> iterator = remoteSupplierListener.entrySet().iterator();
						while(iterator.hasNext()) {
							Entry<String, RemoteSupplierListener> entry = iterator.next();
//						for(Entry<String, RemoteSupplierListener> entry : remoteSupplierListener.entrySet()){
							RemoteSupplierListener listener = entry.getValue();
							if(null != listener){
								listener.setShowPriceStatus((!hiddenPrevaluationPrice)? false : true);
								}
						}
					 }
				}
			});
		}
		moreToolsShell.addTool(toolGroup, showNowTime? Messages.Button_notShowNowTime + "（"+Messages.Tips_reEntryOpeningHallEffect+"） " : Messages.Button_showNowTime + "（"+Messages.Tips_reEntryOpeningHallEffect+"）       ", imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/data.png"), true, new ToolsShell.ClickListener(){
			public void click() {
				showNowTime = !showNowTime;
				PropertiesUtils.saveProperty(ConfigConstants.SHOW_NOW_TIME, showNowTime ? "01" : "00");
				moreToolsShell.close();
			}
		});
		if(null != menuFunctions && !MenuFunction.HIDE.equals(menuFunctions.getAuthority(MenuFunctionEnum.SHOW_IS_ANONYMOUS_CONFIG))){
			moreToolsShell.addTool(toolGroup, tenderProjectRuleEntity.getIsAnonymous() ? "非匿名显示" : "匿名显示", imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/btn/blue/question.png"), true, new ToolsShell.ClickListener(){
				public void click() {
					tenderProjectRuleEntity.setIsAnonymous(!tenderProjectRuleEntity.getIsAnonymous());
					projectRuleService.updateAssignProperty(tenderProjectRuleEntity, new String[] {"isAnonymous"});
					showSupplierPage(PAGE_NO);
					moreToolsShell.close();
				}
			});
		}
		
		if(null != menuFunctions && MenuFunction.SHOW.equals(menuFunctions.getAuthority(VideoConfigConstants.USE_LIVE))){
			
			final Composite livingAddressConfigComposite = moreToolsShell.addToolBar(Messages.Config_liveBroadcastConfiguration, null, false);
			livingAddressConfigComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
			livingAddressConfigComposite.setLayout(new GridLayout(1, true));
			ComfigLivingAddressComposite comfigLivingAddressComposite = new ComfigLivingAddressComposite(livingAddressConfigComposite, SWT.None);
			comfigLivingAddressComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
			moreToolsShell.setWidth(700);
		}else {
			moreToolsShell.setWidth(500);
		}
		moreToolsShell.pack();
		SwtUtils.setCenter(moreToolsShell);
		moreToolsShell.open();
	}
	
	/**
	 * @Description: 停止所有远程线程
	 * @author guoyr 
	 */
	private void stopAllRemoteThread(){
		if(null != getSupplierRemoteSignThread){
			getSupplierRemoteSignThread.stop();
			getSupplierRemoteSignThread = null;
		}
		if(null != romoteSupplierOnlineThread){
			romoteSupplierOnlineThread.stop();
			romoteSupplierOnlineThread = null;
		}
		if(null != getRemoteDecryptStatusThread){
			getRemoteDecryptStatusThread.stop();
			getRemoteDecryptStatusThread = null;
		}
		if(null != getSupplierRemoteConfirmThread){
			getSupplierRemoteConfirmThread.stop();
			getSupplierRemoteConfirmThread = null;
		}
		if(null != refreshProjectBidOpeningInfoThread){
			refreshProjectBidOpeningInfoThread.stop();
			refreshProjectBidOpeningInfoThread = null;
		}
	}
	
//	private void exitAction(){
//		if(isInRemoteProgress){
//			ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), null,  "正在远程"+TenderProjectEnum.getOpenBidEnum(tenderProjectEntity.getPhaseType())+"中，确认要退出吗？", null);
//			confirmDialog.addButton("确认退出", "01");
//			confirmDialog.addCancel(Messages.Button_cancel, null);
//			confirmDialog.open();
//			if(confirmDialog.isCancel()){
//				return;
//			}
//		}
//		stopAllRemoteThread();
//		close();
//		if(null != meetingRoomListener){
//			meetingRoomListener.exitMeetingRoom();
//			
//		}
//	}

	public void addMeetingRoomListener(MeetingRoomListener meetingRoomListener){
		this.meetingRoomListener = meetingRoomListener;
	}
	
	/**
	 * 视频会议
	 */
	public void startmeetingAction() {
		if(!startMeetingBtn.getEnabled())return;
		startMeetingBtn.setEnabled(false);
		final ProgressMessageDialog messageProgress = new ProgressMessageDialog(getShell(), true, -1, new LoadingAdatper() {
			public void finish(boolean flag) {
				Display.getDefault().syncExec(new Runnable() {
					public void run() {
						if(!startMeetingBtn.isDisposed()) {
							startMeetingBtn.setEnabled(true);
						}
					}
				});
			}
		});
		
		new Thread(new Runnable(){
			public void run() {
				VideoMeetingUtils.createMeeting(tenderProjectEntity, Constants.USER, VideoMeetingUtils.ROLE_MANAGER, true, true, messageProgress);
			}
		}).start();
		messageProgress.setTitle("正在启动视频会议");
		messageProgress.open();
	}

	public void close() {
		stopAllRemoteThread();
		if(null != imageResolver){
			imageResolver.disposite();
		}
		if(null != zoomBgImage){
			zoomBgImage.dispose();
		}
		if(null != decStartTimer){
			decStartTimer.cancel();
		}
		if(null != decEndTimer){
			decEndTimer.cancel();
		}
		if(null != sendMessageDialog && !sendMessageDialog.isDisposed()){
			sendMessageDialog.close();
		}
	}
	
	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}

}
