package com.gx.obe.opening.composite;

import java.awt.Dimension;
import java.awt.Toolkit;
import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.Collections;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;
import java.util.Timer;
import java.util.TimerTask;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.ImageResolver;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.listener.ConfirmListener;
import org.eclipse.swt.core.listener.LoadingAdatper;
import org.eclipse.swt.core.listener.ScrollMessageListener;
import org.eclipse.swt.core.utils.SwtUtils;
import org.eclipse.swt.core.utils.WidgetUtils;
import org.eclipse.swt.core.widgets.ConfirmDialog;
import org.eclipse.swt.core.widgets.EButton;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.core.widgets.ImageButton;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowData;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

import com.gx.obe.ColorConstants;
import com.gx.obe.VideoConfigConstants;
import com.gx.obe.action.bean.Action;
import com.gx.obe.business.entity.MenuFunction;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.composite.PageNumComposite;
import com.gx.obe.common.widget.inter.ProjectStatusCount;
import com.gx.obe.common.widget.listener.PageListener;
import com.gx.obe.common.widget.listener.StatusCountListener;
import com.gx.obe.common.widget.shell.ProgressMessageDialog;
import com.gx.obe.common.widget.shell.ToolsShell;
import com.gx.obe.common.widget.thread.MyRunnable;
import com.gx.obe.common.widget.utils.MenuFunctionUtils;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.I18NEnum;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.config.ConfigConstants;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.listener.TenderProjectListListener;
import com.gx.obe.message.Messages;
import com.gx.obe.opening.dialog.AddBidOpeningRoomProjectDialog;
import com.gx.obe.opening.dialog.BatchMultyProjectRemoteBidOpeningDialog;
import com.gx.obe.opening.dialog.BatchMultyProjectRemoteSignResultDialog;
import com.gx.obe.opening.dialog.BatchMultyProjectStartBidOpeningHallDialog;
import com.gx.obe.opening.dialog.SelectBidOpeningTypeDialog;
import com.gx.obe.opening.listener.BatchRemoteBidOpeningListener;
import com.gx.obe.opening.listener.BatchRemoteComplateAndUploadListener;
import com.gx.obe.opening.listener.BatchRemoteDecryptListener;
import com.gx.obe.opening.listener.BatchRemoteSignListener;
import com.gx.obe.opening.listener.MeetingRoomListener;
import com.gx.obe.opening.listener.OpenRemoteHallListener;
import com.gx.obe.opening.listener.StartRemoteBidOpeningListener;
import com.gx.obe.opening.listener.TenderPackOpeningStatus;
import com.gx.obe.opening.shell.BidOpeningCountDownShell;
import com.gx.obe.opening.shell.SendMessageDialog;
import com.gx.obe.opening.shell.TenderPackListDetailsShell;
import com.gx.obe.opening.shell.TenderPackOpeningSupplierDetailsShell;
import com.gx.obe.opening.thread.MultyProjectDownRemoteBidOpeningResultThread;
import com.gx.obe.opening.thread.MultyProjectDownRemoteSignInfoThread;
import com.gx.obe.opening.thread.MultyProjectFocusDecryptBidFilThread;
import com.gx.obe.opening.thread.MultyProjectRefreshBidOpeningInfoThread;
import com.gx.obe.opening.thread.MultyProjectRefreshSupplierTenderInfoThread;
import com.gx.obe.opening.thread.MultyProjectRemoteDecryptBidFilThread;
import com.gx.obe.opening.thread.MultyProjectRemoteStartBidopeningHallThread;
import com.gx.obe.opening.thread.MultyProjectUploadBidOpeningResultThread;
import com.gx.obe.opening.utils.TenderPackDecInfoComparator;
import com.gx.obe.opening.widgets.RoomOperatorButton;
import com.gx.obe.util.utils.ScreenUtils;
import com.gx.obe.util.utils.StringUtils;
import com.gx.obe.web.entity.Page;
import com.gx.obe.web.entity.auth.Menu;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.entity.tender.TenderProjectRuleEntity;
import com.gx.obe.web.service.ProjectRuleService;
import com.gx.obe.web.service.evaluation.EvaluationStepService;
import com.gx.obe.web.vo.TenderPackOpeningInfo;
import com.gx.security.NowTimeUtils;
import com.gx.utils.ActionLogUtils;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

public class BidOpeningRemoteMultyProjectComposite extends OpeningTimeComposite implements BatchRemoteBidOpeningListener, BatchRemoteSignListener, BatchRemoteDecryptListener, BatchRemoteComplateAndUploadListener{

	private ImageResolver imageResolver = new ImageResolver();
	private ProjectRuleService projectRuleService ;
	private List<TenderProjectEntity> tenderProjectList;
	private String bidopeningStage;
	private Image zoomBgImage;
	private Composite decryptMainComposite;
	private Composite progressComposite;
	private ScrolledComposite scrolledComposite;
	private Composite decryptSupplierComposite;
	private RoomOperatorButton openBiddingAgendaBtn;
	private RoomOperatorButton bidOpeningBtn;
	private RoomOperatorButton signResultBtn;
//	private Map<String, RemoteSupplierListener> remoteSupplierListener;
	private MultyProjectDownRemoteBidOpeningResultThread remoteProjectBidOpeningThread;
	private MultyProjectDownRemoteSignInfoThread remoteProjectSignThread;
	private MyRunnable showInRemoteStatusThread;
	private boolean downDecInfoProgress;
	private boolean isPriceStage = false;
	private boolean isBusAndTecStage = false;
	private boolean isShowDownloadProgress = false;
	private boolean isFocusDecrypt = false;
	private ImageButton startBidopeningBtn;
	private String SUPPLIER_NAME = "供应商";
	private String PACK_NAME = "包件";
	private String decryptName = Messages.Button_decryptRemote;
	private Composite totalCountComposite;
	private ProjectStatusCount curStatusCount;
	private ProjectStatusCount tenderStatusCount;
	private ProjectStatusCount signStatusCount;
	private ProjectStatusCount decStatusCount;
	private ProjectStatusCount confirmStatusCount;
	private ProjectStatusCount complateStatusCount;
	private List<TenderPackOpeningInfo> tenderPackOpeningInfoList;
	private Map<String, TenderPackOpeningInfo> tenderPackOpeningInfoMap;
	private Map<String, TenderPackOpeningStatus> tenderPackOpeningStatusMap = new HashMap<String, TenderPackOpeningStatus>();
	private MultyProjectRefreshBidOpeningInfoThread refreshProjectBidOpeningInfoThread;
	private int supplierListHeight = 300;
	private int PAGE_SIZE = 20;
	private int PAGE_NO = 1;
	private int CUR_TYPE = 0;
	private PageNumComposite pageComposite;
	private Composite composite;
	public static int projectNameFontSize = 20;
	public static boolean showProjectNo = false;
//	private RoomOperatorButton refreshSupplierBtn;
//	private RoomOperatorButton signBidBtn;
	private BidOpeningPackCountComposite signCountComposite;
	private BidOpeningPackCountComposite confirmCountComposite;
	private boolean showOpeningCount = false;
	private int threeIndex = 1;
	private int openingIndex = 2;
	private Timer decStartTimer;
	private Timer decEndTimer;
	private MeetingRoomListener meetingRoomListener;
	private RoomOperatorButton reFreshBtn;
	private SendMessageDialog sendMessageDialog;
	private GridLayout gl_decryptSupplierComposite;
	private boolean showNowTime = false;
	private int complateDetailCount = 0;
	private Canvas startBidOpeningNext;
	private RoomOperatorButton downTenderInfoBtn;
	private ScrollMessageListener scrollMessageListener;
	private Menu menu;
	private MenuFunctionUtils menuFunctions;
	private String openingType;
	private Composite operatorComposite;
	
	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public BidOpeningRemoteMultyProjectComposite(Composite parent, Action action, int style) {
		super(parent, style);
		addDisposeListener(new DisposeListener() {
			public void widgetDisposed(DisposeEvent arg0) {
				close();
			}
		});
		setBackgroundMode(SWT.INHERIT_FORCE);
		this.bidopeningStage = (String)parent.getData("bidopeningStage");;
		this.meetingRoomListener = (MeetingRoomListener)parent.getData("meetingRoomListener");;
		this.isFocusDecrypt = null != parent.getData("isFocus") ? true : false;
		this.menu = action.getMenu();
		
		GridLayout gridLayout = new GridLayout(2, false);
		setLayout(gridLayout);
		
		Composite centerComposite = new Composite(this, SWT.NONE);
		GridLayout gl_centerComposite = new GridLayout(1, false);
		gl_centerComposite.marginHeight = 0;
		gl_centerComposite.verticalSpacing = 0;
		gl_centerComposite.horizontalSpacing = 0;
		gl_centerComposite.marginWidth = 0;
		centerComposite.setLayout(gl_centerComposite);
		centerComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		composite = new Composite(centerComposite, SWT.NONE);
		GridLayout gl_composite = new GridLayout(2, false);
		gl_composite.marginWidth = 0;
		gl_composite.marginHeight = 0;
		composite.setLayout(gl_composite);
		GridData gd_composite = new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1);
		gd_composite.heightHint = 20;
		composite.setLayoutData(gd_composite);
		
		decryptMainComposite = new Composite(centerComposite, SWT.NONE);
		GridLayout gl_decryptMainComposite = new GridLayout(1, false);
		gl_decryptMainComposite.horizontalSpacing = 0;
		gl_decryptMainComposite.verticalSpacing = 0;
		gl_decryptMainComposite.marginHeight = 0;
		gl_decryptMainComposite.marginWidth = 0;
		decryptMainComposite.setLayout(gl_decryptMainComposite);
		decryptMainComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		
		scrolledComposite = new ScrolledComposite(decryptMainComposite, SWT.H_SCROLL | SWT.V_SCROLL);
		scrolledComposite.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, true, 1, 1));
		scrolledComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		scrolledComposite.setExpandHorizontal(true);
		scrolledComposite.setExpandVertical(true);
		
		decryptSupplierComposite = new Composite(scrolledComposite, SWT.NONE);
		gl_decryptSupplierComposite = new GridLayout(1, false);
		gl_decryptSupplierComposite.marginHeight = 0;
		gl_decryptSupplierComposite.marginWidth = 0;
		gl_decryptSupplierComposite.verticalSpacing = 0;
		decryptSupplierComposite.setLayout(gl_decryptSupplierComposite);
		
		scrolledComposite.setContent(decryptSupplierComposite);
		scrolledComposite.setMinSize(decryptSupplierComposite.computeSize(SWT.DEFAULT, SWT.DEFAULT));
		
		pageComposite = new PageNumComposite(decryptMainComposite, SWT.NONE);
		pageComposite.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		pageComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		
		progressComposite = new Composite(this, SWT.NONE);
		
		GridLayout gl_progressComposite = new GridLayout(1, false);
		gl_progressComposite.verticalSpacing = 0;
		gl_progressComposite.horizontalSpacing = 0;
		gl_progressComposite.marginHeight = 0;
		gl_progressComposite.marginWidth = 0;
		progressComposite.setLayout(gl_progressComposite);
		GridData gd_progressComposite = new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1);
		gd_progressComposite.widthHint = 180;
		progressComposite.setLayoutData(gd_progressComposite);
		
		totalCountComposite = new Composite(progressComposite, SWT.NONE);
		GridLayout gl_totalCountComposite = new GridLayout(1, false);
		gl_totalCountComposite.marginHeight = 0;
		gl_totalCountComposite.marginWidth = 0;
		totalCountComposite.setLayout(gl_totalCountComposite);
		totalCountComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		BidOpeningPackCountComposite tenderCountComposite = new BidOpeningPackCountComposite(totalCountComposite, SWT.NONE);
		tenderCountComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		tenderStatusCount = tenderCountComposite;
		signCountComposite = new BidOpeningPackCountComposite(totalCountComposite, SWT.NONE);
		signCountComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		signStatusCount = signCountComposite;
		BidOpeningPackCountComposite decCountComposite = new BidOpeningPackCountComposite(totalCountComposite, SWT.NONE);
		decCountComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		decStatusCount = decCountComposite;
		confirmCountComposite = new BidOpeningPackCountComposite(totalCountComposite, SWT.NONE);
		confirmCountComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		confirmStatusCount = confirmCountComposite;
		BidOpeningPackCountComposite complateCountComposite = new BidOpeningPackCountComposite(totalCountComposite, SWT.NONE);
		complateCountComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		complateStatusCount = complateCountComposite;
		init();
	}
	
	/**
	 * @Description: 添加操作按钮
	 * @author guoyr 
	 */
	private void addOperatorBtn(){
		
		operatorComposite = new Composite(null != meetingRoomListener.getOperatorParent() ? meetingRoomListener.getOperatorParent() : decryptMainComposite, SWT.TRANSPARENT);
		GridLayout gl_composite = new GridLayout(7, false);
		gl_composite.marginHeight = 0;
		operatorComposite.setLayout(gl_composite);
		operatorComposite.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, true, 1, 1));
		
		RoomOperatorButton moreActionBtn = new RoomOperatorButton(operatorComposite, SWT.NONE);
		moreActionBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/more_op.png"));
		moreActionBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, true, 1, 1));
		moreActionBtn.setText(Messages.Button_moreOperate);
		moreActionBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				moreConfigAction();
			}
		});
		
		openBiddingAgendaBtn = new RoomOperatorButton(operatorComposite, SWT.NONE);
		openBiddingAgendaBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, true, 1, 1));
		openBiddingAgendaBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/tips.png"));
		openBiddingAgendaBtn.setText(Messages.BidOpeningAgenda);
		openBiddingAgendaBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				showBidOpeningCountDown();
			}
		});
		
		ESepator vSep = new ESepator(operatorComposite, SWT.VERTICAL);
		vSep.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1));
		vSep.setLineWidth(2);
		vSep.setBackground(ColorConstants.SKIN_BG);
		

		Composite stepComposite = new Composite(operatorComposite, SWT.NONE);
		stepComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		RowLayout rl_stepComposite = new RowLayout(SWT.HORIZONTAL);
		rl_stepComposite.center = true;
		rl_stepComposite.spacing = 0;
		rl_stepComposite.marginTop = 0;
		rl_stepComposite.marginBottom = 0;
		rl_stepComposite.marginHeight = 0;
		stepComposite.setLayout(rl_stepComposite);
		stepComposite.setLayoutData(new GridData(SWT.CENTER, SWT.FILL, true, true, 1, 1));
		
		openBiddingAgendaBtn = new RoomOperatorButton(stepComposite, SWT.NONE | EButton.CSS_BLUE);
		openBiddingAgendaBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/add.png"));
		openBiddingAgendaBtn.setText(MessageFormat.format(Messages.Button_addToFormat, Messages.TenderProject));
		openBiddingAgendaBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				addMultyProjectdAction();
			}
		});
		
		addNextSep(stepComposite);
		
		downTenderInfoBtn = new RoomOperatorButton(stepComposite, SWT.NONE | EButton.CSS_BLUE);
		downTenderInfoBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/refresh.png"));
		downTenderInfoBtn.setText(Messages.Button_syncNewTenderInfo);
		downTenderInfoBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				downloadTenderInfoAction();
			}
		});
		
		addNextSep(stepComposite);
		
		startBidopeningBtn = new RoomOperatorButton(stepComposite, SWT.NONE | EButton.CSS_BLUE);
		startBidopeningBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/wifi.png"));
		startBidopeningBtn.setText(Messages.Button_openRemoteBidOpeningHall);
		startBidopeningBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				startBidopeningAction();
			}
		});
		
		startBidOpeningNext = addNextSep(stepComposite);
		
		bidOpeningBtn = new RoomOperatorButton(stepComposite, SWT.NONE | EButton.CSS_BLUE);
		bidOpeningBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/key.png"));
		bidOpeningBtn.setText(MessageFormat.format(Messages.Button_batchFormat, decryptName));
		bidOpeningBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				openBidAction(true);
			}
		});
		
		addNextSep(stepComposite);
		signResultBtn = new RoomOperatorButton(stepComposite, SWT.NONE | EButton.CSS_BLUE);
		signResultBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/submit.png"));
		signResultBtn.setText(MessageFormat.format(Messages.Button_batchFormat, Messages.Button_complateDecrypt));
		signResultBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				remoteComplateAction();
			}
		});
//		
//		signBidBtn = new RoomOperatorButton(bottomContent, SWT.NONE);
//		signBidBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/sing.png"));
//		signBidBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
//		signBidBtn.setText(Messages.Button_signBid);
//		signBidBtn.setLeftMargin(20);
//		signBidBtn.setRightMargin(20);
//		signBidBtn.addMouseListener(new MouseAdapter() {
//			@Override
//			public void mouseUp(MouseEvent e) {
//				signBidAction();
//			}
//		});
		
//		RoomOperatorButton sendMessageBtn = new RoomOperatorButton(bottomContent, SWT.NONE);
//		sendMessageBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/tips.png"));
//		sendMessageBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
//		sendMessageBtn.setText(Messages.Button_sendMessage);
//		sendMessageBtn.setLeftMargin(20);
//		sendMessageBtn.setRightMargin(20);
//		sendMessageBtn.addMouseListener(new MouseAdapter() {
//			@Override
//			public void mouseUp(MouseEvent e) {
//				sendMessageAction();
//			}
//		});
		
		ESepator vSep2 = new ESepator(operatorComposite, SWT.VERTICAL);
		vSep2.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1));
		vSep2.setLineWidth(2);
		vSep2.setBackground(ColorConstants.SKIN_BG);
		
		reFreshBtn = new RoomOperatorButton(operatorComposite, SWT.NONE);
		reFreshBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/refresh.png"));
		reFreshBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		reFreshBtn.setText(Messages.Button_refresh);
		reFreshBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				refreshAction();
			}
		});
		
		
//		Image image = ResourceManager.getPluginImage(SWTCoreActivator.PLUGIN_ID, "icons/bg.png");
//		Region region = new Region();
//		ImageData imageData = image.getImageData();
//		if (imageData.alphaData != null) {
//			for (int y = 0; y < imageData.height; y++) {
//				for (int x = 0; x < imageData.width; x++) {
//					if (imageData.getAlpha(x, y) == 255) {
//						region.add(imageData.x + x,imageData.y + y,1,1);
//					}
//				}
//			}
//		}
//		meetingRoomListener.setOperatorRegion(region);
		// 解中解密
		if(Constants.DECRYPT_FOCUS.equals(openingType)){
			isFocusDecrypt = true;
			//不需要开启开标大厅
			WidgetUtils.setControlVisible(startBidopeningBtn, false);
			WidgetUtils.setControlVisible(startBidOpeningNext, false);
			//不显示签到信息
			WidgetUtils.setControlVisible(signCountComposite, false);
			decryptName = Messages.Button_decryptCentralize;
			bidOpeningBtn.setText(MessageFormat.format(Messages.Button_batchFormat, decryptName));
			operatorComposite.getParent().layout();
		}
//		if(isBusAndTecStage){
//			((GridData)signBidBtn.getLayoutData()).exclude = true;
//			signBidBtn.setVisible(false);
//		}
		meetingRoomListener.refreshOperator();
	}
	
	private Canvas addNextSep(Composite stepComposite){
		final Image nextImage = ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/right_arrow.png");
		final Canvas nextLabel = new Canvas(stepComposite, SWT.TRANSPARENT);
		nextLabel.setLayoutData(new RowData(8, 22));
		nextLabel.addPaintListener(new PaintListener() {
			public void paintControl(PaintEvent arg0) {
				arg0.gc.drawImage(nextImage, 0, 0, nextImage.getBounds().width, nextImage.getBounds().height, 0, 0, nextLabel.getBounds().width, nextLabel.getBounds().height);
			}
		});
		return nextLabel;
	}
	
	/**
	 * @Description: 初始化
	 * @author guoyr 
	 */
	private void init(){
		menuFunctions = new MenuFunctionUtils();
		menuFunctions.initFunctionAuthority(menu);
		projectRuleService = new ProjectRuleService();
		showNowTime = PropertiesUtils.getProperty(ConfigConstants.SHOW_NOW_TIME, "00").equals("01");
		
		getDecryptType();
		
		addOperatorBtn();
		
		progressComposite.layout();
		WidgetUtils.setControlVisible(pageComposite, false);
		pageComposite.setBorderColor(SWTResourceManager.getColor(204, 204, 204));
		pageComposite.setForeground(SWTResourceManager.getColor(204, 204, 204));
		pageComposite.setSelectionBgColor(SWTResourceManager.getColor(24, 112, 221));
		pageComposite.setSelectionForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		pageComposite.addPageListener(new PageListener(){
			public void changed(int pageNo, int pageSize) {
				PAGE_NO = pageNo;
				showTenderPackList(CUR_TYPE);
			}
		});
		
		progressComposite.layout();
		
		tenderStatusCount.addStatusName(Messages.Opening_tendered, Messages.Opening_counts);
		tenderStatusCount.addStatusName(Messages.Opening_canOpening, Messages.Opening_counts);
		tenderStatusCount.addStatusName(Messages.Opening_ecryptable, Messages.Opening_counts);
		tenderStatusCount.addStatusName("总项目", Messages.Number_2);
		tenderStatusCount.addStatusCountListener(new StatusCountListener(){
			public void selection(int count){
				PAGE_NO = 1;
				showTenderPackList(0);
			};
			public void changed(int index, int count){
				if(index == openingIndex){
					showOpeningCount = true;
					refreshTenderInfoStatus(showOpeningCount);
				}else if(showOpeningCount){
					showOpeningCount = false;
					refreshTenderInfoStatus(showOpeningCount);
				}
			};
		});
		signStatusCount.addStatusName(Messages.Opening_signedIn, Messages.Opening_counts);
		signStatusCount.addStatusName(Messages.Opening_signedIn, Messages.Opening_packCount);
		signStatusCount.addStatusCountListener(new StatusCountListener(){
			public void selection(int count){
				PAGE_NO = 1;
				showTenderPackList(TenderPackDecInfoComparator.ORDERBY_NO_SIGN);
				MessageDialog.openShortMessage("按未签到比例由大倒小排序");
			}
		});
		decStatusCount.addStatusName(Messages.Opening_decrypted, Messages.Opening_counts);
		decStatusCount.addStatusName(Messages.Opening_decrypted, Messages.Opening_packCount);
		decStatusCount.addStatusCountListener(new StatusCountListener(){
			public void selection(int count){
				PAGE_NO = 1;
				showTenderPackList(TenderPackDecInfoComparator.ORDERBY_NO_DEC);
				MessageDialog.openShortMessage("按解密异常或未解密比例由大倒小排序");
			}
		});
		confirmStatusCount.addStatusName(Messages.Opening_confirmed, Messages.Opening_counts);
		confirmStatusCount.addStatusName(Messages.Opening_confirmed, Messages.Opening_packCount);
		confirmStatusCount.addStatusCountListener(new StatusCountListener(){
			public void selection(int count){
				PAGE_NO = 1;
				showTenderPackList(TenderPackDecInfoComparator.ORDERBY_NO_CONFIRM);
				MessageDialog.openShortMessage("按未确认比例由大倒小排序");
			}
		});
		complateStatusCount.addStatusName(Messages.Opening_complated, Messages.Opening_counts);
		complateStatusCount.addStatusName(Messages.Opening_complated, Messages.Opening_packCount);
		complateStatusCount.addStatusCountListener(new StatusCountListener(){
			public void selection(int count){
				PAGE_NO = 1;
				showTenderPackList(TenderPackDecInfoComparator.ORDERBY_NO_COMPLATE);
				MessageDialog.openShortMessage("按未完成比例由大倒小排序");
			}
		});
		
		if(PropertiesUtils.getProperty(ConfigConstants.SHOW_CONFIRM_STATUS, "00").equals("00")){
			WidgetUtils.setControlVisible(confirmCountComposite, false);
			totalCountComposite.layout();
		}
		meetingRoomListener.refreshMeetingTitle(PropertiesUtils.getProperty("meetingTitle", Messages.LoginDialog_bidOpeningTitle));
		refreshAction();
		composite.setForeground(SWTResourceManager.getColor(SWT.COLOR_BLUE));
		composite.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		scrollMessageListener = new ScrollMessageListener(composite);
		composite.addPaintListener(scrollMessageListener);
		
		showScrollMsg(Messages.Tips_openingHall);
		if(showNowTime){
			meetingRoomListener.showNowTime(3000);
		}
		progressComposite.layout();
	}
	
	/**
	 * @Description: 添加项目
	 * @author guoyr 
	 */
	private void addMultyProjectdAction(){
		
		AddBidOpeningRoomProjectDialog addBidOpeningRoomProjectDialog = new AddBidOpeningRoomProjectDialog(getShell(), tenderProjectList, new TenderProjectListListener(){
			public boolean refreshTenderProjectList(List<TenderProjectEntity> tenderProjectList) {
				return initMultyProjectList(tenderProjectList);
			}
		});
		addBidOpeningRoomProjectDialog.open();
	}
	/**
	 * @Description: 同步最新投标信息
	 * @author guoyr 
	 */
	private void downloadTenderInfoAction(){
		if(!checkTenderProjectList()){
			return;
		}
		downTenderInfoBtn.setEnabled(false);
		if(synNewBidInfoInfo(Messages.Tips_synchronizingNewTenderInfo)){
			refreshProjectRemoteInfo();
		}
	}
	/**
	 * @Description: 添加项目
	 * @author guoyr 
	 */
	public boolean initMultyProjectList(List<TenderProjectEntity> _tenderProjectList){
		this.tenderProjectList = _tenderProjectList;
		if(null == tenderProjectList || tenderProjectList.size() == 0){
			if(null != tenderPackOpeningInfoMap){
				tenderPackOpeningInfoMap.clear();
			}
			if(null != tenderPackOpeningInfoList){
				tenderPackOpeningInfoList.clear();
			}
			for(Control control : decryptSupplierComposite.getChildren()){
				control.dispose();
			}
			decryptSupplierComposite.layout();
//			meetingRoomListener.refreshMeetingTitle("请点击“添加项目”将项目加入到开标大厅");
			bidOpeningTime = null;
			meetingRoomListener.refreshMeetingTime(Messages.BidOpeningTimeOnBoard, bidOpeningTime);
			meetingRoomListener.refreshCountDownTime(Messages.CountdownOnBoard, bidOpeningTime);
			// 刷新签到座位人数
			meetingRoomListener.refreshPeopleCount(0);
			tenderStatusCount.setCounts(new int[]{0, 0, 0, 0});
			signStatusCount.setCounts(new int[]{0, 0});
			decStatusCount.setCounts(new int[]{0, 0});
			confirmStatusCount.setCounts(new int[]{0, 0});
			complateStatusCount.setCounts(new int[]{0, 0});
			return false;
		}
		TenderProjectEntity tenderProjectEntity = tenderProjectList.get(0);
		
		SUPPLIER_NAME = com.gx.obe.components.core.I18N.getString(I18NEnum.SUPPLIERNAME, tenderProjectEntity.getTenderType());
		PACK_NAME = com.gx.obe.components.core.I18N.getString(I18NEnum.SUBPACKAGE, tenderProjectEntity.getTenderType());
		
//		if(showProjectNo){
//			meetingRoomListener.refreshMeetingTitle("["+tenderProjectEntity.getTenderNo() + "]"+ tenderProjectEntity.getTenderName());
//		}else {
//			meetingRoomListener.refreshMeetingTitle(tenderProjectEntity.getTenderName());
//		}
		meetingRoomListener.refreshMeetingTitle(PropertiesUtils.getProperty("meetingTitle", Messages.LoginDialog_bidOpeningTitle));
		isPriceStage = false;
		isBusAndTecStage = false;
		
		boolean showSelectDialog = true;
		
		TenderProjectRuleEntity tenderProjectRuleEntity = projectRuleService.getProjectRule(tenderProjectEntity.getId());
		
		// 如果不是两阶段开标
		if(!TenderProjectEnum.BID_OPENING_TWO_STAGE.equals(tenderProjectRuleEntity.getBidOpeningStage())){
			bidopeningStage = TenderProjectEnum.STAGE_ALL;
			// 如果只定了一种解密方式，则不需要选择
			if(openingType.split(",").length == 1){
				showSelectDialog = false;
				if(openingType.indexOf(Constants.DECRYPT_FOCUS) >= 0){
					isFocusDecrypt = true;
				}
			}
		}
		
		if(showSelectDialog){
			SelectBidOpeningTypeDialog selectBidOpeningTypeDialog = new SelectBidOpeningTypeDialog(getShell(), openingType, tenderProjectRuleEntity);
			selectBidOpeningTypeDialog.open();
			isFocusDecrypt = selectBidOpeningTypeDialog.isFocusDecrypt();
			
			bidopeningStage = selectBidOpeningTypeDialog.getBidopeningStage();
		}
		if(null == bidopeningStage){
			return false;
		}
		
		refreshBidOpeningTime(tenderProjectRuleEntity);
		if(null == bidOpeningTime) {
			MessageDialog.openWarning(getShell(), "未获取到开标时间！");
			return false;
		}
		if(TenderProjectEnum.STAGE_PRICE.equals(bidopeningStage)){
			isPriceStage = true;
			meetingRoomListener.refreshManagerTable(Messages.EconomicBid);
		}else if(TenderProjectEnum.STAGE_BUS_TEC.equals(bidopeningStage)){
			isBusAndTecStage = true;
			meetingRoomListener.refreshManagerTable(Messages.BusinessTechnologyBid);
		}

		String firstBidOpeningStage = StringUtils.isNotEmpty(tenderProjectRuleEntity.getBidOpeningStage())? tenderProjectRuleEntity.getBidOpeningStage() : TenderProjectEnum.BID_OPENING_ONE_STAGE;
		for(int i = 1; i < tenderProjectList.size(); i++) {
			TenderProjectEntity _tenderProject = tenderProjectList.get(i);
			TenderProjectRuleEntity tenderProjectRule = projectRuleService.getProjectRule(_tenderProject.getId());
			if(null == tenderProjectRule) {
				MessageDialog.openShortMessage("缺少开标规则！");
				return false;
			}
			if(!firstBidOpeningStage.equals(tenderProjectRule.getBidOpeningStage())) {
				MessageDialog.openWarning(getShell(), "["+_tenderProject.getTenderNo() +"]"+ _tenderProject.getTenderName() + "与其他项目的开阶段类型不一致，不能一起批量开标！");
				return false;
			}
			Date tempBidOpeningTime = null;
			if(isPriceStage){
				tempBidOpeningTime = tenderProjectRule.getPriceBidOpeningTime();
			}else {
				tempBidOpeningTime = tenderProjectRule.getBidOpeningStartTime();
			}
			if(null == tempBidOpeningTime) {
				MessageDialog.openWarning(getShell(), "["+_tenderProject.getTenderNo() +"]"+ _tenderProject.getTenderName() + "未获取到开标时间！");
				return false;
			}
			if(!MenuFunction.HIDE.equals(menuFunctions.getAuthority("SAME_TIME"))){
//			只能相同开标时间的项目一起开标
				if(bidOpeningTime.compareTo(tempBidOpeningTime) != 0) {
					MessageDialog.openWarning(getShell(), "["+_tenderProject.getTenderNo() +"]"+ _tenderProject.getTenderName() + "与其他项目开标时间不一致，不能一起批量开标！");
					return false;
				}
			}else {
				refreshBidOpeningTime(tenderProjectRule);
			}
		}
		
		if(isFocusDecrypt){
			WidgetUtils.setControlVisible(startBidopeningBtn, false);
			WidgetUtils.setControlVisible(signCountComposite, false);
			WidgetUtils.setControlVisible(startBidOpeningNext, false);
			decryptName = Messages.Button_decryptCentralize;
		}else {
			WidgetUtils.setControlVisible(signCountComposite, true);
			WidgetUtils.setControlVisible(startBidopeningBtn, true);
			WidgetUtils.setControlVisible(startBidOpeningNext, true);
			decryptName = Messages.Button_decryptRemote;
		}
		totalCountComposite.layout();
		bidOpeningBtn.setText(MessageFormat.format(Messages.Button_batchFormat, decryptName));
		operatorComposite.getParent().layout();
//		for(TenderProjectEntity _tenderProject : tenderProjectList){
//			refreshBidOpeningTime(_tenderProject);
//		}
		

		meetingRoomListener.refreshMeetingTime(Messages.BidOpeningTimeOnBoard, bidOpeningTime);
		meetingRoomListener.refreshCountDownTime(Messages.CountdownOnBoard, bidOpeningTime);
//		decryptEndTime = DateUtils.add(NowTimeUtils.getNowDate(),DateUtils.MINUTE, 1);
		addBidopeningStartTimer(bidOpeningTime, decryptEndTime);
		addDecryptEndTimer(decryptEndTime);

//		if(isBusAndTecStage){
//			((GridData)signBidBtn.getLayoutData()).exclude = true;
//			signBidBtn.setVisible(false);
//		}
		refreshAction();
		return true;
	}
	
	/**
	 * @Description: 获得解密方式
	 * @author guoyr 
	 */
	private void getDecryptType(){
		openingType = PropertiesUtils.getProperty(ConfigConstants.DECRYPT_TYPE, Constants.DECRYPT_LOCAL+ "," + /**Constants.DECRYPT_LOCAL_SELF + ","+ **/ Constants.DECRYPT_REMOTE + "," + Constants.DECRYPT_FOCUS);
		StringBuilder openingTypeFromDb = new StringBuilder();
		if(MenuFunction.SHOW.equals(menuFunctions.getAuthority("DECRYPT_LOCAL"))){
			openingTypeFromDb.append(Constants.DECRYPT_LOCAL);
		}
		if(MenuFunction.SHOW.equals(menuFunctions.getAuthority("DECRYPTR_EMOTE"))){
			if(openingTypeFromDb.length() > 0){
				openingTypeFromDb.append(",");
			}
			openingTypeFromDb.append(Constants.DECRYPT_REMOTE);
			
		}
		if(MenuFunction.SHOW.equals(menuFunctions.getAuthority("DECRYPT_CENTRALIZE"))){
			if(openingTypeFromDb.length() > 0){
				openingTypeFromDb.append(",");
			}
			openingTypeFromDb.append(Constants.DECRYPT_FOCUS);
			
		}
		if(openingTypeFromDb.length() > 0){
			openingType = openingTypeFromDb.toString();
		}
	}
	
	private void refreshBidOpeningTime(TenderProjectRuleEntity tenderProjectRuleEntity){
		boolean refreshTime = false;
		if(null == bidOpeningTime){
			refreshTime = true;
			if(isPriceStage){
				bidOpeningTime = tenderProjectRuleEntity.getPriceBidOpeningTime();
			}else {
				bidOpeningTime = tenderProjectRuleEntity.getBidOpeningStartTime();
			}
		}else {
			// 取最晚的开标时间
			if(isPriceStage && null != tenderProjectRuleEntity.getPriceBidOpeningTime() && tenderProjectRuleEntity.getPriceBidOpeningTime().after(bidOpeningTime)){
				refreshTime = true;
				bidOpeningTime = tenderProjectRuleEntity.getPriceBidOpeningTime();
			}else if(null != tenderProjectRuleEntity.getBidOpeningStartTime() && tenderProjectRuleEntity.getBidOpeningStartTime().after(bidOpeningTime)){
				refreshTime = true;
				bidOpeningTime = tenderProjectRuleEntity.getBidOpeningStartTime();
			}
		}
		if(null == decryptEndTime){
			refreshTime = true;
			if(isPriceStage){
				decryptEndTime = tenderProjectRuleEntity.getPriceDecryptEndTime();
			}else {
				decryptEndTime = tenderProjectRuleEntity.getDecryptEndTime();
			}
		}else{
			// 取最晚的截止时间
			if(isPriceStage && null != tenderProjectRuleEntity.getPriceDecryptEndTime() && tenderProjectRuleEntity.getPriceDecryptEndTime().after(decryptEndTime)){
				refreshTime = true;
				decryptEndTime = tenderProjectRuleEntity.getPriceDecryptEndTime();
			}else if(null != tenderProjectRuleEntity.getDecryptEndTime() && tenderProjectRuleEntity.getDecryptEndTime().after(decryptEndTime)){
				refreshTime = true;
				decryptEndTime = tenderProjectRuleEntity.getDecryptEndTime();
			}
		}
	}
	/**
	 * @Description: 开始解密定时期
	 * @author guoyr
	 * @param bidOpeningTime 
	 */
	private void addBidopeningStartTimer(Date bidOpeningTime, final Date decryptEndTime){
		if(null != decStartTimer){
			decStartTimer.cancel();
		}
		if(null != bidOpeningTime && bidOpeningTime.after(NowTimeUtils.getNowDate())){
			decStartTimer =  new Timer(true); 
			decStartTimer.schedule(new TimerTask(){
				public void run() {
					showScrollMsg(Messages.Tips_timeForBidOpeningAndSynchronizInfo);
					
					if(!Display.getDefault().isDisposed()){
						Display.getDefault().syncExec(new Runnable(){
							public void run(){
								if(!getShell().isDisposed()){
									boolean synNewFlag = synNewBidInfoInfo(Messages.Tips_timeForBidOpeningAndSynchronizInfo);
									if(synNewFlag){
										refreshProjectRemoteInfo();
									}
									
									ConfirmDialog synTenderInfoDialog = new ConfirmDialog(getShell(), decryptName, MessageFormat.format(Messages.Tips_timeForBidOpening, bidOpeningBtn.getText()), null);
									synTenderInfoDialog.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/tips_info.png"), -1, -1);
									synTenderInfoDialog.setTips(synNewFlag ? Messages.Tips_synchronizedNewTenderInfoComplate : Messages.Tips_checkSynchronizNewTenderInfo);
//									synTenderInfoDialog.addButton(Messages.Button_syncNewTenderInfo, "syn", SWTResourceManager.getColor(77, 163, 19));
									synTenderInfoDialog.addButton(bidOpeningBtn.getText(), "dec");
									synTenderInfoDialog.addCancel(Messages.Button_cancel, null);
									synTenderInfoDialog.setAlpha(230);
									synTenderInfoDialog.open();
//									if(synTenderInfoDialog.getClickStatus().equals("syn")){
//									}else 
									if(synTenderInfoDialog.getClickStatus().equals("dec")){
										openBidAction(!synNewFlag);
									}
								}
							}
						});
						if(null != decryptEndTime){
							meetingRoomListener.refreshMeetingTime(Messages.Deadline, decryptEndTime);
							meetingRoomListener.refreshCountDownTime(Messages.CountdownOnBoard, decryptEndTime);
						}else if(showNowTime){
							meetingRoomListener.showNowTime(2000);
						}
					}
				}
				
			}, bidOpeningTime.getTime() - NowTimeUtils.getNowDate().getTime());
		}else {
			if(null != decryptEndTime){
				showNowTime = false;
				meetingRoomListener.refreshMeetingTime(Messages.Deadline, decryptEndTime);
				meetingRoomListener.refreshCountDownTime(Messages.CountdownOnBoard, decryptEndTime);
			}else if(showNowTime){
				meetingRoomListener.showNowTime(2000);
			}
		}
	}
	
	/**
	 * @Description:  解密截止定时期
	 * @author guoyr
	 * @param bidOpeningDeadlineTime 
	 */
	private void addDecryptEndTimer(Date bidOpeningDeadlineTime){
		if(null != decEndTimer){
			decEndTimer.cancel();
		}
		if(null != bidOpeningDeadlineTime && bidOpeningDeadlineTime.after(NowTimeUtils.getNowDate())){
			decEndTimer =  new Timer(true); 
			decEndTimer.schedule(new TimerTask(){
				public void run() {
					if(showNowTime){
						meetingRoomListener.showNowTime(5000);
					}
					ActionLogUtils.addServerLog(Constants.USER.getId(),"多项目解密截止时间已到", "");
					showScrollMsg(MessageFormat.format(Messages.Tips_complateAndUploadResultForDeadline, MessageFormat.format(Messages.Button_batchFormat, Messages.Button_complateDecrypt)));
					if(!Display.getDefault().isDisposed()){
						Display.getDefault().syncExec(new Runnable(){
							public void run(){
								if(!getShell().isDisposed()){
									ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), Messages.Dialog_warmTips, MessageFormat.format(Messages.Tips_complateAndUploadResultForDeadline, MessageFormat.format(Messages.Button_batchFormat, Messages.Button_complateDecrypt)), new ConfirmListener(){
										public void click(String key) {
											if(key.equals("01")){
												remoteComplateAction();
											}
										}
									});
									confirmDialog.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/tips_info.png"), -1, -1);
									confirmDialog.addButton(MessageFormat.format(Messages.Button_batchFormat, Messages.Button_complateDecrypt), "01");
									confirmDialog.addCancel(Messages.Button_cancel, null);
									confirmDialog.setAlpha(230);
									confirmDialog.open();
								}
							}
						});
					}
					downDecInfoProgress = false;
					isShowDownloadProgress = false;
					if(null != remoteProjectBidOpeningThread){
						remoteProjectBidOpeningThread.stop();
					}
					if(null != remoteProjectSignThread){
						remoteProjectSignThread.stop();
					}
					setDownloadBidopeningInfo(false);
				}
				
			}, bidOpeningDeadlineTime.getTime() - NowTimeUtils.getNowDate().getTime());
		}
	}
	
	private void showScrollMsg(final String msg){
		if(null == msg){
			return;
		}
		scrollMessageListener.showMessage(msg);
	}
	
	/**
	 * @Description: 显示签到包件列表
	 * @author guoyr 
	 */
	private void showTenderPackList(final int type){
		CUR_TYPE = type;
		if(null != curStatusCount){
			curStatusCount.setSelection(false);
		}
		if(type == 1){
			curStatusCount = signStatusCount;
		}else if(type == 2){
			curStatusCount = decStatusCount;
		}else if(type == 3){
			curStatusCount = confirmStatusCount;
		}else if(type == 4){
			curStatusCount = complateStatusCount;
		}else {
			curStatusCount = tenderStatusCount;
		}
		curStatusCount.setSelection(true);
		new Thread(new Runnable(){
			public void run(){
				Display.getDefault().syncExec(new Runnable(){
					public void run(){
						if(!decryptSupplierComposite.isDisposed()){
							supplierListHeight = scrolledComposite.getBounds().height - gl_decryptSupplierComposite.marginHeight * 2 - gl_decryptSupplierComposite.marginTop - gl_decryptSupplierComposite.marginBottom;
							PAGE_SIZE = supplierListHeight / (TenderPackOpeningListItemComposite.rowHeight + gl_decryptSupplierComposite.verticalSpacing);
							if(null != tenderPackOpeningInfoList && tenderPackOpeningInfoList.size() > PAGE_SIZE && !pageComposite.getVisible()){
								supplierListHeight -= Math.max(pageComposite.getBounds().height, 31);
								PAGE_SIZE = supplierListHeight / (TenderPackOpeningListItemComposite.rowHeight + gl_decryptSupplierComposite.verticalSpacing);
							}
						}
					}
				});
				final Page<TenderPackOpeningInfo> projectPage = new Page<TenderPackOpeningInfo>();
				if(null != tenderPackOpeningInfoList){
					int totalCount = 0;
					List<TenderPackOpeningInfo> tenderPackList = new ArrayList<TenderPackOpeningInfo>();
					int pageStart = (PAGE_NO-1) * PAGE_SIZE;
					for(TenderPackOpeningInfo tenderProjectOpeningInfo : tenderPackOpeningInfoList){
						if(null != tenderPackOpeningInfoMap){
							tenderProjectOpeningInfo = tenderPackOpeningInfoMap.get(tenderProjectOpeningInfo.getTenderProject().getId());
						}
						if(null != tenderProjectOpeningInfo){
							boolean isJoin = false;
							if(type == TenderPackDecInfoComparator.ORDERBY_NO_SIGN){
								isJoin = !tenderProjectOpeningInfo.isSignComplate();
							}else if(type == TenderPackDecInfoComparator.ORDERBY_NO_DEC){
								isJoin = !tenderProjectOpeningInfo.isDecComplate();
								if(tenderProjectOpeningInfo.getDecFailCount() > 0 || tenderProjectOpeningInfo.getNoPriceCount() > 0){
									isJoin = true;
								}
							}else if(type == TenderPackDecInfoComparator.ORDERBY_NO_CONFIRM){
								isJoin = !tenderProjectOpeningInfo.isConfirmComplate();
							}else if(type == TenderPackDecInfoComparator.ORDERBY_NO_COMPLATE){
								isJoin = !tenderProjectOpeningInfo.isComplate();
							}else {
								isJoin = true;
							}
							
							if(isJoin){
//								if(totalCount >= pageStart && totalCount < pageStart + PAGE_SIZE){
//									tenderPackList.add(tenderProjectOpeningInfo);
//								} 
								tenderPackList.add(tenderProjectOpeningInfo);
								totalCount ++;
							}
						}
					}
					if(type != 0){
						TenderPackDecInfoComparator tenderPackDecInfoComparator = new TenderPackDecInfoComparator(type);
						Collections.sort(tenderPackList, tenderPackDecInfoComparator);
					}
					
					projectPage.setRecords(tenderPackList.subList(pageStart, Math.min(pageStart + PAGE_SIZE, tenderPackList.size())));
					projectPage.setCurrent(PAGE_NO);
					projectPage.setSize(PAGE_SIZE);
					projectPage.setTotal(totalCount);
				}
				tenderPackOpeningStatusMap.clear();
				
				if(!Display.getDefault().isDisposed()){
					Display.getDefault().syncExec(new Runnable(){
						public void run(){
							if(!decryptSupplierComposite.isDisposed()){
								decryptSupplierComposite.setData("isFocus", isFocusDecrypt ? "1" : null);
								
								for(Control control : decryptSupplierComposite.getChildren()){
									control.dispose();
								}
								int width = decryptSupplierComposite.getBounds().width;
								int totalHeight = 0;
								if(null != projectPage && null != projectPage.getRecords() && projectPage.getSize() > 0){
									for(TenderPackOpeningInfo tenderProjectOpeningInfo : projectPage.getRecords()){
										TenderProjectEntity tenderProjectEntity = tenderProjectOpeningInfo.getTenderProject();
										if(tenderProjectOpeningInfo.isProject()){
										}else {
										}
//									TenderProjectEntity tenderPack = tenderProjectOpeningInfo.getTenderPack();
										TenderPackOpeningListItemComposite tenderPackOpeningListItemComposite = new TenderPackOpeningListItemComposite(decryptSupplierComposite, SWT.NONE);
										tenderPackOpeningListItemComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1));
										GridData gd_item = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
										gd_item.widthHint = 500;
										tenderPackOpeningListItemComposite.setLayoutData(gd_item);
										totalHeight += tenderPackOpeningListItemComposite.computeSize(width, SWT.DEFAULT).y;
										tenderPackOpeningListItemComposite.addBatchRemoteBidOpeningListener(BidOpeningRemoteMultyProjectComposite.this);
										tenderPackOpeningListItemComposite.setTenderPack(tenderProjectEntity);
										tenderPackOpeningListItemComposite.refreshTenderPackOpeningInfo(tenderProjectOpeningInfo, null, bidopeningStage, showOpeningCount, false);
										tenderPackOpeningStatusMap.put(tenderProjectEntity.getId(), tenderPackOpeningListItemComposite);
									}
								}
								
								boolean oldVisible = pageComposite.getVisible();
								if(projectPage.getPages() > 1){
									pageComposite.refreshPages(projectPage);
									if(!oldVisible){
										WidgetUtils.setControlVisible(pageComposite, true);
									}
								}else {
									if(oldVisible){
										WidgetUtils.setControlVisible(pageComposite, false);
									}
								}
								if(!decryptMainComposite.isDisposed()){
									decryptMainComposite.layout();
									if(projectPage.getSize() > 0){
										supplierListHeight = scrolledComposite.getBounds().height - gl_decryptSupplierComposite.marginHeight * 2 - gl_decryptSupplierComposite.marginTop - gl_decryptSupplierComposite.marginBottom;
										
										int surplusHeight = supplierListHeight - projectPage.getSize() * gl_decryptSupplierComposite.verticalSpacing - totalHeight;
										if(surplusHeight > 0){
											int perHeight = surplusHeight/projectPage.getSize();
											for(Entry<String, TenderPackOpeningStatus> supplierRemoteListner : tenderPackOpeningStatusMap.entrySet()){
												TenderPackOpeningStatus tenderPackOpeningStatus = supplierRemoteListner.getValue();
												TenderPackOpeningListItemComposite tenderPackOpeningListItemComposite = (TenderPackOpeningListItemComposite)tenderPackOpeningStatus;
												int height = tenderPackOpeningListItemComposite.computeSize(width, SWT.DEFAULT).y + perHeight;
												((GridData)tenderPackOpeningListItemComposite.getLayoutData()).heightHint = height > 70 ? 70 : height;
											}
										}
									}
									reFreshBtn.setEnabled(true);
									decryptSupplierComposite.layout();
									scrolledComposite.setMinSize(decryptSupplierComposite.computeSize(SWT.DEFAULT, SWT.DEFAULT));
								}
								
							}
						}
					});
				}
			}
		}).start();
	}
	
	
	/**
	 * @Description: 刷新
	 * @author guoyr 
	 */
	private void refreshAction(){
		
		bidOpeningBtn.setEnabled(true);
		downDecInfoProgress = false;
		downTenderInfoBtn.setEnabled(false);
		refreshProjectRemoteInfo();
		
		decryptSupplierComposite.layout();
		scrolledComposite.setMinSize(decryptSupplierComposite.computeSize(SWT.DEFAULT, SWT.DEFAULT));
	}
	
	/**
	 * @Description: 开启远程开标大厅
	 * @author guoyr 
	 */
	private void startBidopeningAction(){
		if(!startBidopeningBtn.getEnabled()){
			return;
		}
		if(!checkTenderProjectList()){
			return;
		}
		if(!checkStartOpeningHall()){
			return;
		}
//		boolean hasVideoLiveUrl = true;
//		String videoLiveUrl = VideoConfigConstants.getLivingAddress();
//		if (null == videoLiveUrl || videoLiveUrl.trim().length() <= 0) {
//			hasVideoLiveUrl = false;
//		}
		
		StringBuilder message = getStartOpeningHallConfirmMsg();
//		if(!hasVideoLiveUrl){
//			message.append(Messages.Tips_noConfigLiveAddress);
//		}
		message.append("\r\n");
		message.append(Messages.Tips_checkAndConfirmOpeningSetting);
		ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), null, message.toString(), null);
		confirmDialog.setTipsColor(SWTResourceManager.getColor(255, 0, 0));
		confirmDialog.setTips(Messages.Tips_checkBidOpeningTime);
		confirmDialog.setMinimumSize(new Point(600, 250));
//		if(!hasVideoLiveUrl){
//			confirmDialog.addButton(Messages.Config_liveBroadcastConfiguration, "config", SWTResourceManager.getColor(77, 163, 19));
//		}
		confirmDialog.addButton(Messages.Button_confirmCorrectAndContinue, "01", null);
		confirmDialog.addCancel(Messages.Button_cancel, null);
		confirmDialog.open();
		
		if(confirmDialog.getClickStatus().equals("config")){
			moreConfigAction();
			return;
		}
		if (!confirmDialog.getClickStatus().equals("01")) {
			return;
		}
		
		BatchMultyProjectStartBidOpeningHallDialog selectBatchOpeningDialog = new BatchMultyProjectStartBidOpeningHallDialog(getShell(), tenderProjectList, bidopeningStage);
		selectBatchOpeningDialog.setTitle(Messages.Button_openRemoteBidOpeningHall);
		selectBatchOpeningDialog.open();
		final List<TenderProjectEntity> tenderProjectAndPackList = selectBatchOpeningDialog.getSelectTenderProjectList();
		if(null != tenderProjectAndPackList && tenderProjectAndPackList.size() > 0){
			startBidopeningBtn.setEnabled(false);
			final boolean isSynchronizedInfoOnly = selectBatchOpeningDialog.isSynchronizedInfoOnly();
			final ProgressMessageDialog messageProgress = new ProgressMessageDialog(getShell(), false, -1, new LoadingAdatper() {
				public void finish(boolean flag) {
					for(TenderProjectEntity tenderProjectEntity : tenderProjectList){
						// 为了获取最新的开启状态
						TenderPackOpeningInfo tenderProjectOpeningInfo = tenderPackOpeningInfoMap.get(tenderProjectEntity.getId());
						if(null != tenderProjectOpeningInfo){
							if(isPriceStage){
								tenderProjectEntity.setStartPriceBidOpening(tenderProjectOpeningInfo.getTenderProject().getStartPriceBidOpening());
							}else {
								tenderProjectEntity.setStartBidOpening(tenderProjectOpeningInfo.getTenderProject().getStartBidOpening());
							}
						}
					}
					getRemoteProjectSignInfoThread();
					Display.getDefault().syncExec(new Runnable(){
						public void run(){
							if(!startBidopeningBtn.isDisposed()){
								startBidopeningBtn.setEnabled(true);
							}
						}
					});
				}
			});
			new MultyProjectRemoteStartBidopeningHallThread(tenderProjectAndPackList, bidopeningStage, bidOpeningTime, signEndTime, decryptEndTime, isSynchronizedInfoOnly, new OpenRemoteHallListener(){
				public void openRemoteHall(final boolean bool, final TenderProjectEntity tenderProjectEntity, String msg){
					if(bool){
						if(isSynchronizedInfoOnly){
							showScrollMsg(MessageFormat.format(Messages.Tips_synchronizingProjectSigninInfo, tenderProjectEntity.getTenderName()));
						}else {
							showScrollMsg(MessageFormat.format(Messages.Tips_startProjectOpeningHallSuccess, tenderProjectEntity.getTenderName()));
						}
						if(null != tenderPackOpeningInfoMap){
							TenderPackOpeningInfo tenderProjectOpeningInfo = tenderPackOpeningInfoMap.get(tenderProjectEntity.getId());
							if(null != tenderProjectOpeningInfo){
								tenderProjectOpeningInfo.setTenderProject(tenderProjectEntity);
								refreshBidOpeningStatusInfo(tenderProjectOpeningInfo);
							}
						}
					}else {
						showScrollMsg(MessageFormat.format(Messages.Tips_startProjectOpeningHallFail, tenderProjectEntity.getTenderName()));
					}
				}
			}, messageProgress).start();
			messageProgress.setTitle(Messages.Button_openRemoteBidOpeningHall);
			messageProgress.open();
		}
	}
	
	
	
	/**
	 * @Description: 开标议程
	 * @author guoyr
	 */
	public void showBidOpeningCountDown(){
		if(!openBiddingAgendaBtn.getEnabled()){
			return ;
		}
		if(!checkTenderProjectList()){
			return;
		}
		if(null != tenderProjectList && tenderProjectList.size() > 0){
			TenderProjectEntity tenderProjectEntity = tenderProjectList.get(0);
			TenderProjectRuleEntity tenderProjectRuleEntity = projectRuleService.getProjectRule(tenderProjectEntity.getId());
			String bidOpeningAgenda = tenderProjectRuleEntity.getBidOpeningAgenda();
			if(isPriceStage){
				if(null != tenderProjectRuleEntity.getPriceBidOpeningAgenda() && tenderProjectRuleEntity.getPriceBidOpeningAgenda().length() > 0){
					bidOpeningAgenda = tenderProjectRuleEntity.getPriceBidOpeningAgenda();
				}
			}
			BidOpeningCountDownShell countDownShell = new BidOpeningCountDownShell(getShell(), tenderProjectEntity, bidOpeningTime, bidOpeningAgenda);
			countDownShell.open();
		}else {
			MessageDialog.openShortMessage("请先添加项目");
		}
	}
	
	/**
	 * @Description: 开标解密
	 * @author guoyr 
	 */
	private void openBidAction(boolean synNewBidInfo){
		if(!bidOpeningBtn.getEnabled()){
			return;
		}
		if(!checkTenderProjectList()){
			return;
		}
		if(!checkBidOpening()){
			return;
		}
		StringBuilder message = getStartDecryptConfirmMsg();
		message.append("\r\n");
		message.append(Messages.Tips_checkAndConfirmOpeningSetting);
		ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), null, message.toString(), null);
		confirmDialog.setTipsColor(SWTResourceManager.getColor(255, 0, 0));
//		confirmDialog.setTips(Messages.Tips_checkSynchronizNewTenderInfoAndCheckTime);
//		confirmDialog.setMinimumSize(new Point(600, 250));
		confirmDialog.addButton(Messages.Button_confirmCorrectAndContinue, "01", null);
		confirmDialog.addCancel(Messages.Button_cancel, null);
		confirmDialog.open();
		if (!confirmDialog.getClickStatus().equals("01")) {
			return;
		}
		if(synNewBidInfo) {
			if (synNewBidInfoInfo(Messages.Tips_synchronizingNewTenderInfo)) {
				refreshProjectRemoteInfo();
			}else {
				return;
			}
		}
		if(isFocusDecrypt){
			decryptRemoteFocusAction();
		}else {
			decryptRemoteAction();
		}
	} 
	
	/**
	 * @Description: 远程解密
	 * @author guoyr 
	 */
	private void decryptRemoteAction(){
		
		BatchMultyProjectRemoteBidOpeningDialog selectBatchOpeningDialog = new BatchMultyProjectRemoteBidOpeningDialog(getShell(), tenderProjectList, bidopeningStage, menuFunctions);
		String title = MessageFormat.format(Messages.Button_batchFormat, decryptName);
		if(null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_BUS_TEC)){
			title = (Messages.BusinessTechnologyBid + " - " + MessageFormat.format(Messages.Button_batchFormat, decryptName));
		}else if(null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_PRICE)){
			title = (Messages.EconomicBid + " - " + MessageFormat.format(Messages.Button_batchFormat, decryptName));
		}
		selectBatchOpeningDialog.setTitle(title);
		selectBatchOpeningDialog.open();
		final List<TenderProjectEntity> tenderProjectAndPackList = selectBatchOpeningDialog.getSelectTenderProjectList();
		if(null != tenderProjectAndPackList && tenderProjectAndPackList.size() > 0){
			bidOpeningBtn.setEnabled(false);
			final boolean isSynchronizedInfoOnly = selectBatchOpeningDialog.isSynchronizedInfoOnly();
			final ProgressMessageDialog messageProgress = new ProgressMessageDialog(getShell(), false, -1, new LoadingAdatper() {
				public void finish(boolean flag) {
					if(!downDecInfoProgress || null == remoteProjectBidOpeningThread){
						downDecInfoProgress = true;
						for(TenderProjectEntity tenderProjectEntity : tenderProjectList){
							// 为了获取最新的开启状态
							TenderPackOpeningInfo tenderProjectOpeningInfo = tenderPackOpeningInfoMap.get(tenderProjectEntity.getId());
							if(null != tenderProjectOpeningInfo){
								if(isPriceStage){
									tenderProjectEntity.setPriceBidStatus(tenderProjectOpeningInfo.getTenderProject().getPriceBidStatus());
								}else {
									tenderProjectEntity.setBusinessBidStatus(tenderProjectOpeningInfo.getTenderProject().getBusinessBidStatus());
								}
							}
						}
						getRemoteProjectBidOpeningInfoThread();
					}
					Display.getDefault().syncExec(new Runnable(){
						public void run(){
							if(!bidOpeningBtn.isDisposed()){
								bidOpeningBtn.setEnabled(true);
							}
						}
					});
				}
			});
			new MultyProjectRemoteDecryptBidFilThread(tenderProjectAndPackList, bidopeningStage, decryptEndTime, isSynchronizedInfoOnly, new StartRemoteBidOpeningListener(){
				public void startRemoteBidOpening(final boolean bool, TenderPackOpeningInfo tenderPackOpeningInfo, String msg){
					if(bool){
						if(isSynchronizedInfoOnly){
							showScrollMsg(MessageFormat.format(Messages.Tips_synchronizingProjectDecryptInfo, tenderPackOpeningInfo.getTenderProject().getTenderName()));
						}else {
							showScrollMsg(MessageFormat.format(Messages.Tips_startProjectDecryptSuccess, tenderPackOpeningInfo.getTenderProject().getTenderName()));
						}
						TenderPackOpeningInfo existTenderPackOpeningInfo = tenderPackOpeningInfoMap.get(tenderPackOpeningInfo.getTenderProject().getId());
						if(null != existTenderPackOpeningInfo){
							existTenderPackOpeningInfo.setTenderProject(tenderPackOpeningInfo.getTenderProject());
							existTenderPackOpeningInfo.setOpeningCount(tenderPackOpeningInfo.getOpeningCount());
							existTenderPackOpeningInfo.setDecCount(tenderPackOpeningInfo.getDecCount());
							existTenderPackOpeningInfo.setDecFailCount(tenderPackOpeningInfo.getDecFailCount());
							existTenderPackOpeningInfo.setNoPriceCount(tenderPackOpeningInfo.getNoPriceCount());
							existTenderPackOpeningInfo.setComplateSupplierCount(tenderPackOpeningInfo.getComplateSupplierCount());
						}else {
							existTenderPackOpeningInfo = tenderPackOpeningInfo;
						}
						refreshBidOpeningStatusInfo(existTenderPackOpeningInfo);
					}else {
						showScrollMsg(MessageFormat.format(Messages.Tips_startProjectDecryptFail, tenderPackOpeningInfo.getTenderProject().getTenderName()));
					}
				}
			}, messageProgress).start();
			if(!isSynchronizedInfoOnly){
				showScrollMsg(Messages.Tips_requesting);
			}
			messageProgress.setTitle(title);
			messageProgress.setCountDownTime(3);
			messageProgress.open();
			
		}
	} 
	
	
	/**
	 * @Description: 集中解密
	 * @author guoyr 
	 */
	private void decryptRemoteFocusAction(){
		getShell().setData("isFocus", "1");
		String title = MessageFormat.format(Messages.Button_batchFormat, decryptName);
		BatchMultyProjectRemoteBidOpeningDialog selectBatchOpeningDialog = new BatchMultyProjectRemoteBidOpeningDialog(getShell(), tenderProjectList, bidopeningStage, menuFunctions);
		if(null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_BUS_TEC)){
			title = (Messages.BusinessTechnologyBid + " - " + MessageFormat.format(Messages.Button_batchFormat, decryptName));
		}else if(null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_PRICE)){
			title = (Messages.EconomicBid + " - " + MessageFormat.format(Messages.Button_batchFormat, decryptName));
		}
		selectBatchOpeningDialog.setTitle(title);
		selectBatchOpeningDialog.open();
		final List<TenderProjectEntity> tenderProjectAndPackList = selectBatchOpeningDialog.getSelectTenderProjectList();
		if(null != tenderProjectAndPackList && tenderProjectAndPackList.size() > 0){
			bidOpeningBtn.setEnabled(false);
			final boolean isSynchronizedInfoOnly = selectBatchOpeningDialog.isSynchronizedInfoOnly();
			final ProgressMessageDialog messageProgress = new ProgressMessageDialog(getShell(), true, -1, new LoadingAdatper() {
				public void finish(boolean flag) {
					if(!downDecInfoProgress || null == remoteProjectBidOpeningThread){
						downDecInfoProgress = true;
						for(TenderProjectEntity tenderProjectEntity : tenderProjectList){
							// 为了获取最新的开启状态
							TenderPackOpeningInfo tenderProjectOpeningInfo = tenderPackOpeningInfoMap.get(tenderProjectEntity.getId());
							if(null != tenderProjectOpeningInfo){
								if(isPriceStage){
									tenderProjectEntity.setPriceBidStatus(tenderProjectOpeningInfo.getTenderProject().getPriceBidStatus());
								}else {
									tenderProjectEntity.setBusinessBidStatus(tenderProjectOpeningInfo.getTenderProject().getBusinessBidStatus());
								}
							}
						}
						getRemoteProjectBidOpeningInfoThread();
					}
					Display.getDefault().syncExec(new Runnable(){
						public void run(){
							if(!bidOpeningBtn.isDisposed()){
								bidOpeningBtn.setEnabled(true);
							}
						}
					});
				}
			});
			new MultyProjectFocusDecryptBidFilThread(tenderProjectAndPackList, bidopeningStage, bidOpeningTime, signEndTime, decryptEndTime, isSynchronizedInfoOnly, new StartRemoteBidOpeningListener(){
				public void startRemoteBidOpening(final boolean bool, final TenderPackOpeningInfo tenderPackOpeningInfo, String msg2){
					if(bool){
						if(isSynchronizedInfoOnly){
							showScrollMsg(MessageFormat.format(Messages.Tips_synchronizingProjectDecryptInfo, tenderPackOpeningInfo.getTenderProject().getTenderName()));
						}else {
							showScrollMsg(MessageFormat.format(Messages.Tips_startProjectDecryptSuccess, tenderPackOpeningInfo.getTenderProject().getTenderName()));
						}
						TenderPackOpeningInfo existTenderPackOpeningInfo = tenderPackOpeningInfoMap.get(tenderPackOpeningInfo.getTenderProject().getId());
						if(null != existTenderPackOpeningInfo){
							existTenderPackOpeningInfo.setTenderProject(tenderPackOpeningInfo.getTenderProject());
							existTenderPackOpeningInfo.setOpeningCount(tenderPackOpeningInfo.getOpeningCount());
							existTenderPackOpeningInfo.setDecCount(tenderPackOpeningInfo.getDecCount());
							existTenderPackOpeningInfo.setDecFailCount(tenderPackOpeningInfo.getDecFailCount());
							existTenderPackOpeningInfo.setNoPriceCount(tenderPackOpeningInfo.getNoPriceCount());
							existTenderPackOpeningInfo.setComplateSupplierCount(tenderPackOpeningInfo.getComplateSupplierCount());
						}else {
							existTenderPackOpeningInfo = tenderPackOpeningInfo;
						}
						refreshBidOpeningStatusInfo(existTenderPackOpeningInfo);
					}else {
						showScrollMsg(MessageFormat.format(Messages.Tips_startProjectDecryptFail, tenderPackOpeningInfo.getTenderProject().getTenderName()));
					}
				}
			}, messageProgress).start();
			messageProgress.setTitle(title);
			messageProgress.setCountDownTime(3);
			messageProgress.open();
		}
	} 
	
	
	/**
	 * @Description: 启动远程获得项目的解密、确认等开标信息
	 * @author guoyr 
	 */
	private void getRemoteProjectBidOpeningInfoThread(){
		if(null != remoteProjectBidOpeningThread){
			remoteProjectBidOpeningThread.stop();
			remoteProjectBidOpeningThread = null;
		}
		if(null != tenderProjectList && tenderProjectList.size() > 0){
			remoteProjectBidOpeningThread = new MultyProjectDownRemoteBidOpeningResultThread(tenderProjectList, bidopeningStage, this);
			remoteProjectBidOpeningThread.start();
			
			Display.getDefault().syncExec(new Runnable(){
				public void run(){
					if(!totalCountComposite.isDisposed()){
						tenderStatusCount.setSelectionIndex(openingIndex);
					}
				}
			});
		}
	}
	
	/**
	 * @Description: 获得远程签到信息
	 * @author guoyr 
	 */
	private void getRemoteProjectSignInfoThread(){
		if(null != remoteProjectSignThread){
			remoteProjectSignThread.stop();
			remoteProjectSignThread = null;
		}
		// 集中解密不需要下载签到信息
		if(!isFocusDecrypt){
			remoteProjectSignThread = new MultyProjectDownRemoteSignInfoThread(tenderProjectList, bidopeningStage, this);
			remoteProjectSignThread.start();
		}
	}
	
	/**
	 * @Description: 批量完成
	 * @author guoyr 
	 */
	private void remoteComplateAction(){
		if(!signResultBtn.getEnabled()){
			return;
		}
		if(!checkTenderProjectList()){
			return;
		}
		BatchMultyProjectRemoteSignResultDialog selectBatchOpeningDialog = new BatchMultyProjectRemoteSignResultDialog(getShell(), tenderProjectList, bidopeningStage, menuFunctions);
		selectBatchOpeningDialog.setTitle(MessageFormat.format(Messages.Button_batchFormat, Messages.Button_complateDecrypt));
		selectBatchOpeningDialog.open();
		final List<TenderPackOpeningInfo> tenderProjectAndPackList = selectBatchOpeningDialog.getSelectTenderPackList();
		if(null != tenderProjectAndPackList && tenderProjectAndPackList.size() > 0){
			signResultBtn.setEnabled(false);
			final boolean complateOnly = selectBatchOpeningDialog.isComplateOnly();
			String publicType = selectBatchOpeningDialog.getPublicType();
			MultyProjectUploadBidOpeningResultThread uploadBidOpeningResultThread = new MultyProjectUploadBidOpeningResultThread(tenderProjectAndPackList, bidopeningStage, publicType, this, complateOnly);
			uploadBidOpeningResultThread.start();
			if(complateOnly){
				showScrollMsg(Messages.Tips_inCompletingOpening);
			}else {
				showScrollMsg(Messages.Tips_inUploadingAndComplateOpening);
			}
		}
	}
	
	/**
	 * @Description: 唱标
	 * @author guoyr 
	 */
	private void signBidAction(){
		if(!checkTenderProjectList()){
			return;
		}
//		if(signBidBtn.getEnabled()){
//			TenderProjectEntity signTenderPack = null;
//			if(null != tenderPackOpeningInfoMap){
//				for(Entry<String, TenderProjectOpeningInfo> entry : tenderPackOpeningInfoMap.entrySet()){
//					TenderProjectEntity tenderPack = entry.getValue().getTenderPack();
//					if(null != tenderPack.getPriceBidStatus() && tenderPack.getPriceBidStatus().equals(CommonEnum.COMPLETE)){
//						signTenderPack = tenderPack;
//						break;
//					}
//				}
//			}
//			
//			if(null == signTenderPack){
//				MessageDialog.openShortMessage("没有可唱标的"+PACK_NAME+"！");
//				return;
//			}
//			SingBidShell singBidShell = new SingBidShell(getShell(), signTenderPack);
//			singBidShell.open();
//		}
	}
	
	/**
	 * @Description: 发送消息
	 * @author guoyr 
	 */
	private void sendMessageAction(){
		if(!checkTenderProjectList()){
			return;
		}
//		if(null != sendMessageDialog && !sendMessageDialog.isDisposed()){
//			sendMessageDialog.showDialog();
//		}else {
//			StringBuilder stageIds = new StringBuilder();
//			for(TenderProjectOpeningInfo tenderProjectOpeningInfo : tenderPackOpeningInfoList){
//				if(stageIds.length() > 0){
//					stageIds.append(",");
//				}
//				if(null != tenderProjectOpeningInfo.getTenderPack().getStageId()){
//					stageIds.append(tenderProjectOpeningInfo.getTenderPack().getStageId());
//				}
//			}
//			sendMessageDialog = new SendMessageDialog(getShell(), tenderProjectEntity, bidopeningStage, stageIds.toString());
//			sendMessageDialog.setSize(200, 300);
//			sendMessageDialog.setAlpha(200);
//			ScreenUtils screenUtils = new ScreenUtils();
//			sendMessageDialog.setLocation(0, 0);
//			sendMessageDialog.setLocation((screenUtils.getScreenWight() - sendMessageDialog.getBounds().width), screenUtils.getScreenHight() -  sendMessageDialog.getBounds().height - 40);
//			sendMessageDialog.open();
//		}
	}
	
	/**
	 * @Description: 检查是否已添加项目
	 * @author guoyr
	 * @param status 
	 */
	private boolean checkTenderProjectList(){
		if(null != tenderProjectList && tenderProjectList.size() > 0){
			return true;
		}else {
			MessageDialog.openShortMessage("请先添加项目！");
			return false;
		}
	}	
	/**
	 * @Description: 鼠标拖动事件
	 * @author guoyr
	 */
	

	protected void createContents() {
		setSize(450, 300);
		Dimension d = Toolkit.getDefaultToolkit().getScreenSize(); // 取得当前屏幕属性
		int w = d.width; // 获取屏幕宽度
		int h = d.height; // 获取屏幕高度
		setSize(w,h);

	}


	/**
	 * @Description: 检查是否允许开标
	 * @author guoyr
	 * @return 
	 */
	private boolean checkBidOpening(){
		if(null != tenderProjectList && tenderProjectList.size() > 0){
			if(null != bidOpeningTime && bidOpeningTime.after(NowTimeUtils.getNowDate())){
				ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), null, Messages.Tips_timeBeforeForBidOpening, null);
				confirmDialog.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/tips_info.png"), -1, -1);
				confirmDialog.addCancel(Messages.Button_cancel, null);
				confirmDialog.open();
				return false;
			}
			
			if(null != decryptEndTime && NowTimeUtils.getNowDate().after(decryptEndTime)){
				ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), null, Messages.Tips_decryptionDeadline, null);
				confirmDialog.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/tips_info.png"), -1, -1);
				confirmDialog.addCancel(Messages.Button_cancel, null);
				confirmDialog.open();
				return false;
			}
			
			// 如果是经济标类型评标步骤，必须开完经济标才能操作
			if(isPriceStage){
				if(null != menuFunctions && MenuFunction.SHOW.equals(menuFunctions.getAuthority("NEED_COMPLATE_BUS_TEC"))){
					EvaluationStepService evaluationStepService = new EvaluationStepService();
					if(!evaluationStepService.isComplateBusAndTecEvaluation(tenderProjectList.get(0).getId())){
						ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), null, Messages.Tips_cantDescryptEconomicBid, null);
						confirmDialog.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/tips_info.png"), -1, -1);
						confirmDialog.addCancel(Messages.Button_cancel, null);
						confirmDialog.open();
						return false;
					}
				}
			}
			return true;
		}
		return false;
	}
	
	
	private void exitAction(){
		if(downDecInfoProgress && isShowDownloadProgress){
			ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), null,  "正在"+decryptName+"中，确认要退出吗？", null);
			confirmDialog.addButton("确认退出", "01");
			confirmDialog.addCancel(Messages.Button_cancel, null);
			confirmDialog.open();
			if(confirmDialog.isCancel()){
				return;
			}
		}
		close();
		if(null != meetingRoomListener){
			meetingRoomListener.exitMeetingRoom();
		}
	}

	
	/** 
	 * @Description: 查看详情
	 * @author guoyr
	 * @param tenderProjectOpeningInfo 
	 */
	public void clickTenderPackInfo(TenderPackOpeningInfo tenderProjectOpeningInfo){
		if(isFocusDecrypt){
			getShell().setData("isFocus", isFocusDecrypt ? "1" : null);
		}
		TenderProjectEntity tenderProjectEntity = tenderProjectOpeningInfo.getTenderProject();
		TenderProjectRuleEntity tenderProjectRuleEntity = projectRuleService.getProjectRule(tenderProjectEntity.getId());
		if(null == tenderProjectEntity.getParentId() && (null != tenderProjectEntity.getIsPack() && tenderProjectEntity.getIsPack().equals(CommonEnum.YES))){
			TenderPackListDetailsShell detailsShell = new TenderPackListDetailsShell(getShell(), tenderProjectOpeningInfo, tenderProjectRuleEntity, bidopeningStage, showOpeningCount, this);
			detailsShell.setSize(getSize());
			detailsShell.setLocation(toDisplay(0, 0));
			detailsShell.open();
		}else {
			TenderPackOpeningSupplierDetailsShell detailsShell = new TenderPackOpeningSupplierDetailsShell(getShell(), tenderProjectOpeningInfo, tenderProjectRuleEntity, bidopeningStage);
//			detailsShell.addBatchRemoteBidOpeningListener(this);
			detailsShell.setSize(getSize());
			detailsShell.setLocation(toDisplay(0, 0));
			detailsShell.open();
		}
	}
	

	/** 
	 * @Description: 刷新签到信息
	 * @author guoyr
	 * @param tenderProjectOpeningInfo 
	 */
	public void refreshTenderPackInfo(TenderProjectEntity tenderPack) {
		if(null != tenderPack && null != tenderPackOpeningInfoMap){
			TenderPackOpeningInfo tenderProjectOpeningInfo = tenderPackOpeningInfoMap.get(tenderPack.getId());
			if(null != tenderProjectOpeningInfo){
				tenderProjectOpeningInfo.setTenderProject(tenderPack);
				refreshBidOpeningStatusInfo(tenderProjectOpeningInfo);
			}
		}
	}
	
	/** 
	 * @Description: 刷新签到信息
	 * @author guoyr
	 * @param tenderProjectOpeningInfo 
	 */
	public void refreshTenderInfoStatus(boolean isShowEffectiveCount){
		if(null != tenderPackOpeningInfoMap){
			 Map<String, TenderPackOpeningStatus> tempTenderPackOpeningStatusMap = new HashMap<String, TenderPackOpeningStatus>();
			 tempTenderPackOpeningStatusMap.putAll(tenderPackOpeningStatusMap);
			 for(Entry<String, TenderPackOpeningStatus> entry : tempTenderPackOpeningStatusMap.entrySet()){
				 TenderPackOpeningStatus tenderPackOpeningStatus = entry.getValue();
				 if(null != tenderPackOpeningStatus){
					 tenderPackOpeningStatus.refreshTenderInfoStatus(isShowEffectiveCount);
				 }
			 }
			 tempTenderPackOpeningStatusMap.clear();
			 tempTenderPackOpeningStatusMap = null;
		 }
	}
	
	/** 
	 * @Description: 刷新签到信息
	 * @author guoyr
	 * @param _tenderProjectOpeningInfo 
	 */
	public void refreshSignInfo(TenderPackOpeningInfo _tenderProjectOpeningInfo) {
		if(_tenderProjectOpeningInfo.getSignCount() > 0){
			TenderPackOpeningInfo existTenderPackOpeningInfo = null;
			boolean showNewMsg = false;
			TenderProjectEntity tenderProjectEntity = _tenderProjectOpeningInfo.getTenderProject();
			if(null != tenderPackOpeningInfoMap){
				existTenderPackOpeningInfo = tenderPackOpeningInfoMap.get(tenderProjectEntity.getId());
				if(null != existTenderPackOpeningInfo && _tenderProjectOpeningInfo.getSignCount() > existTenderPackOpeningInfo.getSignCount()){
					existTenderPackOpeningInfo.setSignCount(_tenderProjectOpeningInfo.getSignCount());
					showNewMsg = true;
				}
			}else {
				showNewMsg = true;
			}
			
			if(showNewMsg){
				if(null == existTenderPackOpeningInfo){
					existTenderPackOpeningInfo = _tenderProjectOpeningInfo;
				}
				if(existTenderPackOpeningInfo.isSignComplate()) {
					showScrollMsg(MessageFormat.format(Messages.Tips_tenderProjectSignintAll, tenderProjectEntity.getTenderName()));
				}else {
					showScrollMsg(MessageFormat.format(Messages.Tips_tenderProjectSigninInfo, tenderProjectEntity.getTenderName(), existTenderPackOpeningInfo.getSignCount()));
				}
				refreshBidOpeningStatusInfo(existTenderPackOpeningInfo);
			}
		}
	}
	
	/** 
	 * @Description: 刷新远程解密信息
	 * @author guoyr
	 * @param tenderProjectOpeningInfo 
	 */
	public void refreshDescInfo(TenderPackOpeningInfo tenderProjectOpeningInfo) {

		TenderPackOpeningInfo existTenderPackOpeningInfo = null;
		boolean showNewMsg = false;
		TenderProjectEntity tenderProjectEntity = tenderProjectOpeningInfo.getTenderProject();
		if(null != tenderPackOpeningInfoMap){
			existTenderPackOpeningInfo = tenderPackOpeningInfoMap.get(tenderProjectEntity.getId());
			if(null != existTenderPackOpeningInfo){
				if(tenderProjectOpeningInfo.getDecCount() > existTenderPackOpeningInfo.getDecCount() || tenderProjectOpeningInfo.getDecFailCount() != existTenderPackOpeningInfo.getDecFailCount() || tenderProjectOpeningInfo.getNoPriceCount() != existTenderPackOpeningInfo.getNoPriceCount()){
					showNewMsg = true;
				}
				
				existTenderPackOpeningInfo.setOpeningCount(tenderProjectOpeningInfo.getOpeningCount());
				existTenderPackOpeningInfo.setDecCount(tenderProjectOpeningInfo.getDecCount());
				existTenderPackOpeningInfo.setDecFailCount(tenderProjectOpeningInfo.getDecFailCount());
				existTenderPackOpeningInfo.setNoPriceCount(tenderProjectOpeningInfo.getNoPriceCount());
			}
		}else {
			showNewMsg = true;
		}
		
		if(null == existTenderPackOpeningInfo){
			existTenderPackOpeningInfo = tenderProjectOpeningInfo;
		}
		if(showNewMsg){
			if(existTenderPackOpeningInfo.isDecComplate()) {
				showScrollMsg(MessageFormat.format(Messages.Tips_tenderProjectDecryptAll, tenderProjectEntity.getTenderName()));
			}else {
				showScrollMsg(MessageFormat.format(Messages.Tips_tenderProjectDecryptInfo, tenderProjectEntity.getTenderName(), existTenderPackOpeningInfo.getDecCount()));
			}
			refreshBidOpeningStatusInfo(existTenderPackOpeningInfo);
		}else {
			tenderPackOpeningInfoMap.put(existTenderPackOpeningInfo.getTenderProject().getId(), existTenderPackOpeningInfo);
			int openingCount = 0;
			for(Entry<String, TenderPackOpeningInfo> entry : tenderPackOpeningInfoMap.entrySet()){
				TenderPackOpeningInfo _tenderPackOpeningInfo = entry.getValue();
				openingCount += _tenderPackOpeningInfo.getOpeningCount();
			}
			tenderStatusCount.setCountValue(openingIndex, openingCount);
		}
	
		
	}
	/** 
	 * @Description: 刷新完成开标信息
	 * @author guoyr
	 * @param tenderProjectOpeningInfo 
	 */
	public void refreshUploadComplateInfo(TenderPackOpeningInfo tenderProjectOpeningInfo) {
		if(tenderProjectOpeningInfo.getComplatePackCount() > 0){
			TenderProjectEntity tenderProjectEntity = tenderProjectOpeningInfo.getTenderProject();
			TenderPackOpeningInfo existTenderPackOpeningInfo = null;
			boolean showNewMsg = false;
			if(null != tenderPackOpeningInfoMap){
				existTenderPackOpeningInfo = tenderPackOpeningInfoMap.get(tenderProjectEntity.getId());
				if(null != existTenderPackOpeningInfo && tenderProjectOpeningInfo.getComplateSupplierCount() != existTenderPackOpeningInfo.getComplateSupplierCount()){
					existTenderPackOpeningInfo.setComplatePackCount(tenderProjectOpeningInfo.getComplatePackCount());
					existTenderPackOpeningInfo.setComplateSupplierCount(tenderProjectOpeningInfo.getComplateSupplierCount());
					existTenderPackOpeningInfo.setComplate(tenderProjectOpeningInfo.isComplate());
					showNewMsg = true;
				}
			}else {
				showNewMsg = true;
			}
			if(showNewMsg){
				showScrollMsg(MessageFormat.format(Messages.Tips_projectDecryptComplate, tenderProjectEntity.getTenderName()));
				if(null == existTenderPackOpeningInfo){
					existTenderPackOpeningInfo = tenderProjectOpeningInfo;
				}
				refreshBidOpeningStatusInfo(existTenderPackOpeningInfo);
			}
		}
	}
	
	/** 
	 * @Description: 显示消息
	 * @author guoyr
	 * @param flag
	 * @param message 
	 */
	public void showMessage(int flag, String message){
		showScrollMsg(message);
	}
	
	/** 
	 * @Description: 完成上传开标结果
	 * @author guoyr
	 * @param successCount
	 * @param failCount 
	 */
	public void finishComplateAndUpload(int successCount, int failCount){
		Display.getDefault().syncExec(new Runnable(){
			public void run(){
				if(!signResultBtn.isDisposed()){
					signResultBtn.setEnabled(true);
				}
			}
		});
		
//		if(failCount > 0){
//			showScrollMsg(failCount + Messages.Number_2 + com.gx.obe.components.core.I18N.getString(I18NEnum.SUBPACKAGE, tenderProjectEntity.getTenderType())+"上传并完成解密失败！");
//		}
	}
	
	
	/**
	 * @Description: 刷新远程开标信息
	 * @author guoyr 
	 */
	public void refreshProjectRemoteInfo() {
		if(null != refreshProjectBidOpeningInfoThread){
			refreshProjectBidOpeningInfoThread.stop();
			refreshProjectBidOpeningInfoThread = null;
		}
		if(null != tenderProjectList && tenderProjectList.size() > 0){
			
			refreshProjectBidOpeningInfoThread = new MultyProjectRefreshBidOpeningInfoThread(tenderProjectList, bidopeningStage, this);
			refreshProjectBidOpeningInfoThread.start();
		}else {
//			meetingRoomListener.refreshMeetingTitle("请点击“添加项目”将项目加入到开标大厅");
		}
	}
	
	
	/** 
	 * @Description: 初始化刷新包件列表
	 * @author guoyr
	 * @param tenderPackOpeningInfoList 
	 */
	public void initRefreshTenderPackList(List<TenderPackOpeningInfo> _tenderPackOpeningInfoList){
		
		if(null != _tenderPackOpeningInfoList){
			tenderProjectList.clear();
			tenderPackOpeningInfoList = _tenderPackOpeningInfoList;
			for(TenderPackOpeningInfo tenderProjectOpeningInfo : tenderPackOpeningInfoList){
				TenderProjectEntity tenderProjectEntity = tenderProjectOpeningInfo.getTenderProject();
				tenderProjectList.add(tenderProjectEntity);
				String bidStatus = null;
				if(tenderProjectOpeningInfo.isProject() && null != tenderProjectOpeningInfo.getTenderPackList()){
					for(TenderProjectEntity tenderPack : tenderProjectOpeningInfo.getTenderPackList()){
						if(isPriceStage){
							bidStatus = tenderPack.getPriceBidStatus();
						}else {
							bidStatus = tenderPack.getBusinessBidStatus();
						}
						if(!downDecInfoProgress) {
							downDecInfoProgress = isInDecProgress(bidStatus);
						}
						if(!showOpeningCount) {
							showOpeningCount = isShowOpeningCount(bidStatus);
						}
					}
				}else {
					if(isPriceStage){
						bidStatus = tenderProjectEntity.getPriceBidStatus();
					}else {
						bidStatus = tenderProjectEntity.getBusinessBidStatus();
					}
					if(!downDecInfoProgress) {
						downDecInfoProgress = isInDecProgress(bidStatus);
					}
					if(!showOpeningCount) {
						showOpeningCount = isShowOpeningCount(bidStatus);
					}
				}
			}
			
			// 或当前包件未解密完成，则继续下载开标信息
			 if(downDecInfoProgress){
				 getRemoteProjectBidOpeningInfoThread();
			 }
			 
			 getRemoteProjectSignInfoThread();
			 
			Display.getDefault().syncExec(new Runnable(){
				public void run(){
					if(!decryptSupplierComposite.isDisposed()){
						showTenderPackList(0);
						tenderStatusCount.setSelectionIndex(showOpeningCount ? openingIndex : isFocusDecrypt ? threeIndex : 0);
					}
				}
			});
		}
	}
	
	private boolean isInDecProgress(String bidStatus) {
		if(StringUtils.isEmpty(bidStatus) || CommonEnum.NOT_START.equals(bidStatus)) {
			return false;
		}else {
			return true;
		}
	}
	private boolean isShowOpeningCount(String bidStatus) {
		if(StringUtils.isEmpty(bidStatus) || CommonEnum.NOT_START.equals(bidStatus)) {
			return false;
		}else {
			return true;
		}
	}
	
	/** 
	 * @Description: 刷新包件的开标信息
	 * @author guoyr
	 * @param _tenderPackOpeningInfoMap 
	 */
	public synchronized void refreshTenderPackBidOpeningInfo(Map<String, TenderPackOpeningInfo> _tenderPackOpeningInfoMap) {
		if(null != _tenderPackOpeningInfoMap){
			tenderPackOpeningInfoMap = _tenderPackOpeningInfoMap;
		}
		refreshTotalCount();
		 new Thread(new Runnable(){
			 public void run(){
				 if(null != tenderPackOpeningInfoMap){
					 Map<String, TenderPackOpeningStatus> tempTenderPackOpeningStatusMap = new HashMap<String, TenderPackOpeningStatus>();
					 tempTenderPackOpeningStatusMap.putAll(tenderPackOpeningStatusMap);
					 for(Entry<String, TenderPackOpeningStatus> entry : tempTenderPackOpeningStatusMap.entrySet()){
						 TenderPackOpeningStatus tenderPackOpeningStatus = entry.getValue();
						 if(null != tenderPackOpeningStatus){
							 tenderPackOpeningStatus.refreshTenderPackOpeningInfo(tenderPackOpeningInfoMap.get(tenderPackOpeningStatus.getTenderPack().getId()), null, bidopeningStage, showOpeningCount, false);
						 }
					 }
					 tempTenderPackOpeningStatusMap.clear();
					 tempTenderPackOpeningStatusMap = null;
				 }
				 Display.getDefault().syncExec(new Runnable(){
						public void run(){
							if(!downTenderInfoBtn.isDisposed()){
								downTenderInfoBtn.setEnabled(true);
							}
						}
					});
			 }
		 }).start();
	}

	/**
	 * @Description: 刷新总的统计数据
	 * @author guoyr 
	 */
	private void refreshTotalCount(){
		if(null != tenderPackOpeningInfoMap){
			int tenderPackCount = tenderPackOpeningInfoMap.size();
			int tenderDetailCount = 0;
			int threeTenderCount = 0;
			int openingCount = 0;
			int signComplateCount = 0;
			int signDetailCount = 0;
			int decComplateCount = 0;
			int decDetailCount = 0;
			int confirmComplateCount = 0;
			int confirmDetailCount = 0;
			int complateCount = 0;
			complateDetailCount  = 0;
			int errorsCount = 0;
			for(Entry<String, TenderPackOpeningInfo> entry : tenderPackOpeningInfoMap.entrySet()){
				TenderPackOpeningInfo tenderProjectOpeningInfo = entry.getValue();
				tenderDetailCount += tenderProjectOpeningInfo.getTenderCount();
				threeTenderCount += tenderProjectOpeningInfo.getThreeTenderCount();
				openingCount += tenderProjectOpeningInfo.getOpeningCount();
				if(tenderProjectOpeningInfo.isSignComplate()){
					signComplateCount ++;
				}
				signDetailCount += tenderProjectOpeningInfo.getSignCount();
				if(tenderProjectOpeningInfo.isDecComplate()){
					decComplateCount ++;
				}
				decDetailCount += tenderProjectOpeningInfo.getDecCount();
				if(tenderProjectOpeningInfo.isConfirmComplate()){
					confirmComplateCount ++;
				}
				confirmDetailCount += tenderProjectOpeningInfo.getConfirmCount();
				
				complateCount += tenderProjectOpeningInfo.getComplatePackCount();
				complateDetailCount += tenderProjectOpeningInfo.getComplateSupplierCount();
				errorsCount += tenderProjectOpeningInfo.getNoPriceCount();
				errorsCount += tenderProjectOpeningInfo.getDecFailCount();
			}
			tenderStatusCount.setCounts(new int[]{tenderDetailCount, threeTenderCount, openingCount, tenderPackCount});
			signStatusCount.setCounts(new int[]{signDetailCount, signComplateCount});
			decStatusCount.setCounts(new int[]{decDetailCount, decComplateCount});
			decStatusCount.setErrors(errorsCount);
			confirmStatusCount.setCounts(new int[]{confirmDetailCount, confirmComplateCount});
			complateStatusCount.setCounts(new int[]{complateDetailCount, complateCount});
			if(errorsCount > 0){
				showScrollMsg(MessageFormat.format(Messages.Tips_decryptErrors, errorsCount));
			}
			if(isFocusDecrypt){
				
				// 集中解密不需要签到，则刷新总投标座位人数
				meetingRoomListener.refreshPeopleCount(tenderDetailCount);
			}else {
				
				// 刷新签到座位人数
				meetingRoomListener.refreshPeopleCount(signDetailCount);
			}
		}
	}
	
	/**
	 * @Description: 刷新包件的远程开标结果
	 * @author guoyr
	 * @param tenderProjectOpeningInfo 
	 */
	public synchronized void refreshBidOpeningStatusInfo(TenderPackOpeningInfo tenderProjectOpeningInfo) {
		if(null != tenderProjectOpeningInfo && null != tenderPackOpeningInfoMap){
			tenderPackOpeningInfoMap.put(tenderProjectOpeningInfo.getTenderProject().getId(), tenderProjectOpeningInfo);
			refreshTotalCount();
			TenderPackOpeningStatus tenderPackOpeningStatus = tenderPackOpeningStatusMap.get(tenderProjectOpeningInfo.getTenderProject().getId());
			if(null != tenderPackOpeningStatus){
				tenderPackOpeningStatus.refreshTenderPackOpeningInfo(tenderProjectOpeningInfo, null, bidopeningStage, showOpeningCount, false);
			}
		}
	}
	
	/**
	 * @Description: 是否正在下载开标信息中
	 * @author guoyr
	 * @param isDownloading 
	 */
	public void setDownloadBidopeningInfo(boolean isDownloading){
		if(isDownloading){
			if(!isShowDownloadProgress){
				showInRemoteStatusThread();
			}
		}else {
			if(null != showInRemoteStatusThread){
				showInRemoteStatusThread.stop();
				showInRemoteStatusThread = null;
			}
			downDecInfoProgress = false;
		}
	}
	
	/** 
	 * @Description: 此次解密完成
	 * @author guoyr
	 * @param decryptCount
	 * @param decryptFailCount 
	 */
	public void decryptComplate(final int decryptCount, final int decryptFailCount, final int noPriceCount){
		refreshTotalCount();
		if(decryptCount > 0){
			Display.getDefault().syncExec(new Runnable(){
				public void run(){
					StringBuilder msg = new StringBuilder();
					msg.append(Messages.Tips_decryptableFileDecryptComplate);
					if(decryptFailCount > 0 || (noPriceCount > 0 && noPriceCount != decryptCount)){
						if(decryptFailCount > 0){
							msg.append(MessageFormat.format(Messages.Tips_decryptFailedCount, decryptFailCount));
						}
						if(noPriceCount > 0){
							if(decryptFailCount > 0){
								msg.append(Messages.Comma);
							}
							msg.append(MessageFormat.format(Messages.Tips_obtainQuotationFailedCount, noPriceCount));
						}
						msg.append(Messages.Period);
						ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), null, msg.toString(), null);
						confirmDialog.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/tips_info.png"), -1, -1);
						confirmDialog.addButton(Messages.Button_ok, "01", null, 90);
						confirmDialog.setTipsAlignment(SWT.CENTER);
						confirmDialog.setTipsColor(SWTResourceManager.getColor(255, 0, 0));
						confirmDialog.setTips(Messages.Tips_problemsSolve);
						confirmDialog.open();
						return;
					}
					if(!getShell().isDisposed() && complateDetailCount < decryptCount){
						msg.append(Messages.Tips_whetherComplateAndUploadOpeningResult);
						ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), null, msg.toString(), null);
//						confirmDialog.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/tips_info.png"), -1, -1);
						confirmDialog.addButton(Messages.Button_complateAndUploadOpeningResult, "01", SWTResourceManager.getColor(77, 163, 19), 90);
						confirmDialog.addCancel(Messages.Button_cancel, null);
						confirmDialog.setTipsAlignment(SWT.CENTER);
						confirmDialog.setTipsColor(SWTResourceManager.getColor(255, 0, 0));
						confirmDialog.open();
						if("01".equals(confirmDialog.getClickStatus())) {
							remoteComplateAction();
						}
					}
				}
			});
		}
	}
	
	/**
	 * @Description: 显示是否正在下载远程开标信息
	 * @author guoyr 
	 */
	private void showInRemoteStatusThread(){
		if(null != showInRemoteStatusThread){
			showInRemoteStatusThread.stop();
			showInRemoteStatusThread = null;
		}

		final Runnable show = new Runnable(){
			public void run(){
				if(!bidOpeningBtn.isDisposed()){
					bidOpeningBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/wifi.png"));
				}else {
					isShowDownloadProgress = false;
				}
			}
		};
		final Runnable hide = new Runnable(){
			public void run(){
				if(!bidOpeningBtn.isDisposed()){
					bidOpeningBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/key.png"));
				}else {
					isShowDownloadProgress = false;
				}
			}
		};
		
		showInRemoteStatusThread = new MyRunnable(){
			public void stop() {
				isShowDownloadProgress = false;
				super.stop();
			}
			public void run() {
				boolean isShow = true;
				isShowDownloadProgress = true;
				while(null != this.thread && isShowDownloadProgress){
					if(isShow){
						Display.getDefault().syncExec(show);
					}else {
						Display.getDefault().syncExec(hide);
					}
					try {
						Thread.sleep(1000);
					} catch (InterruptedException e) {
					}
					isShow = !isShow;
				}
				isShowDownloadProgress = false;
				Display.getDefault().syncExec(hide);
			}
		};
		showInRemoteStatusThread.start();
	}
	
	/**
	 * @Description: 同步最新投标信息
	 * @author guoyr
	 * @return 
	 */
	private boolean synNewBidInfoInfo(String title){
		
		final ProgressMessageDialog messageProgress = new ProgressMessageDialog(getShell(), true, -1, new LoadingAdatper() {
			public void finish(final boolean flag) {
				Display.getDefault().syncExec(new Runnable(){
					public void run(){
						if(!downTenderInfoBtn.isDisposed()){
							downTenderInfoBtn.setEnabled(true);
						}
					}
				});
			}
		});
		messageProgress.setTitle(title);
		
		MultyProjectRefreshSupplierTenderInfoThread refreshProjectSupplierTenderInfoThread = new MultyProjectRefreshSupplierTenderInfoThread(tenderProjectList, messageProgress);
		refreshProjectSupplierTenderInfoThread.start();
		messageProgress.open();
		refreshProjectSupplierTenderInfoThread.stop();
		return messageProgress.getFinishFlag();
	}

	
	/**
	 * @Description: 更多设置
	 * @author guoyr 
	 */
	private void moreConfigAction(){
		
		final ToolsShell moreToolsShell = new ToolsShell(getShell());
		final Composite actionGroup = moreToolsShell.addToolBar(Messages.Button_moreOperate, null, false);
		
		Composite content = new Composite(actionGroup, SWT.NONE);
		content.setLayoutData(new RowData(700, SWT.DEFAULT));
		content.setLayout(new GridLayout(3, false));
		
		{
			Label label = new Label(content, SWT.NONE);
			label.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
			label.setText(Messages.LedTitle + "：");
			
			final Text text = new Text(content, SWT.BORDER);
			text.setBackground(ColorConstants.LIGHT_BACKGROUND_COLOR);
			text.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
			text.setText(PropertiesUtils.getProperty("meetingTitle", Messages.LoginDialog_bidOpeningTitle));
			EButton confirm = new EButton(content, SWT.NONE);
			confirm.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
			confirm.setText(Messages.Button_ok);
			confirm.addMouseListener(new MouseAdapter() {
				@Override
				public void mouseUp(MouseEvent e) {
					meetingRoomListener.refreshMeetingTitle(text.getText().trim());
					PropertiesUtils.saveProperty("meetingTitle", text.getText().trim());
				}
			});
		}
		moreToolsShell.addTool(actionGroup, Messages.Button_syncNewTenderInfo, imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/btn/blue/wifi.png"), null != tenderProjectList && tenderProjectList.size() > 0, new ToolsShell.ClickListener() {
			public void click() {
				moreToolsShell.close();
				if(synNewBidInfoInfo(Messages.Tips_synchronizingNewTenderInfo)){
					refreshProjectRemoteInfo();
				}
			}
		});
		
		if(!isFocusDecrypt){
			if(null != menuFunctions && MenuFunction.SHOW.equals(menuFunctions.getAuthority("SHOW_CONFIRM_STATUS"))){
				final boolean isShowConfirm = PropertiesUtils.getProperty(ConfigConstants.SHOW_CONFIRM_STATUS, "00").equals("01");
				moreToolsShell.addTool(actionGroup, isShowConfirm? Messages.Button_noNeedConfirmResult : Messages.Button_needConfirmResult, imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/btn/blue/user.png"), true, new ToolsShell.ClickListener(){
					public void click() {
						PropertiesUtils.saveProperty(ConfigConstants.SHOW_CONFIRM_STATUS, (!isShowConfirm) ? "01" : "00");
						moreToolsShell.close();
						WidgetUtils.setControlVisible(confirmCountComposite, !isShowConfirm);
						totalCountComposite.layout();
						totalCountComposite.getParent().layout();
						if(null != tenderPackOpeningInfoMap){
							Map<String, TenderPackOpeningStatus> tempTenderPackOpeningStatusMap = new HashMap<String, TenderPackOpeningStatus>();
							tempTenderPackOpeningStatusMap.putAll(tenderPackOpeningStatusMap);
							for(Entry<String, TenderPackOpeningStatus> entry : tempTenderPackOpeningStatusMap.entrySet()){
								TenderPackOpeningStatus tenderPackOpeningStatus = entry.getValue();
								if(null != tenderPackOpeningStatus){
									tenderPackOpeningStatus.setShowComfirmStatus(!isShowConfirm);
								}
							}
							tempTenderPackOpeningStatusMap.clear();
							tempTenderPackOpeningStatusMap = null;
						}
					}
				});
			}
		}
		boolean isFullScreen = getShell().getMaximized();
		moreToolsShell.addTool(actionGroup, isFullScreen? "显示任务栏" : "全屏显示 ", imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/btn/blue/evaluation.png"), true, new ToolsShell.ClickListener(){
			public void click() {
				moreToolsShell.close();
				if(isFullScreen) {
					getShell().setMaximized(false);
					ScreenUtils screenUtils = new ScreenUtils();
					int w = screenUtils.getScreenWight(); // 获取屏幕宽度
					int h = screenUtils.getScreenHight() - screenUtils.getTaskBarHight(); // 获取屏幕高度
					getShell().setLocation(0, 0);
					getShell().setSize(w,h);
				}else {
					getShell().setMaximized(true);
					getShell().notifyListeners(SWT.Resize, null);
				}
			}
		});
		moreToolsShell.addTool(actionGroup, showNowTime? Messages.Button_notShowNowTime + "（"+Messages.Tips_reEntryOpeningHallEffect+"）" : Messages.Button_showNowTime + "（"+Messages.Tips_reEntryOpeningHallEffect+"） ", imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/data.png"), true, new ToolsShell.ClickListener(){
			public void click() {
				showNowTime = !showNowTime;
				PropertiesUtils.saveProperty(ConfigConstants.SHOW_NOW_TIME, showNowTime ? "01" : "00");
				moreToolsShell.close();
			}
		});
		if(null != menuFunctions && MenuFunction.SHOW.equals(menuFunctions.getAuthority(VideoConfigConstants.USE_LIVE))){
			final Composite livingAddressConfigComposite = moreToolsShell.addToolBar(Messages.Config_liveBroadcastConfiguration, null, false);
			livingAddressConfigComposite.setLayout(new GridLayout(1, false));
			ComfigLivingAddressComposite comfigLivingAddressComposite = new ComfigLivingAddressComposite(livingAddressConfigComposite, SWT.None);
			comfigLivingAddressComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
			moreToolsShell.setWidth(700);
		}else {
			moreToolsShell.setWidth(500);
		}
		moreToolsShell.pack();
		SwtUtils.setCenter(moreToolsShell);
		moreToolsShell.open();
	}
	
	public void close() {
		showNowTime = false;
		if(null != remoteProjectBidOpeningThread){
			remoteProjectBidOpeningThread.stop();
			remoteProjectBidOpeningThread = null;
		}
		if(null != remoteProjectSignThread){
			remoteProjectSignThread.stop();
			remoteProjectSignThread = null;
		}
		if(null != showInRemoteStatusThread){
			showInRemoteStatusThread.stop();
			showInRemoteStatusThread = null;
		}
		
		imageResolver.disposite();
		if(null != zoomBgImage){
			zoomBgImage.dispose();
		}
		if(null != decStartTimer){
			decStartTimer.cancel();
		}
		if(null != decEndTimer){
			decEndTimer.cancel();
		}
		if(null != sendMessageDialog && !sendMessageDialog.isDisposed()){
			sendMessageDialog.close();
		}
	}
	
	public void addMeetingRoomListener(MeetingRoomListener meetingRoomListener){
		this.meetingRoomListener = meetingRoomListener;
	}
	
	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}

}
