package com.gx.obe.opening.composite;

import java.math.BigDecimal;
import java.text.MessageFormat;
import java.util.Properties;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.widgets.BigButton;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.layout.RowLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Scale;
import org.eclipse.swt.widgets.Text;

import com.gx.obe.ColorConstants;
import com.gx.obe.action.bean.Action;
import com.gx.obe.business.enumeration.ProjectRuleEnum;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.utils.MenuFunctionUtils;
import com.gx.obe.components.core.util.MoneyUtils;
import com.gx.obe.config.ConfigConstants;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.http.json.JsonUtil;
import com.gx.obe.listener.ProjectRuleListener;
import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.LogUtils;
import com.gx.obe.util.utils.ObjectUtils;
import com.gx.obe.util.utils.StringUtils;
import com.gx.obe.web.entity.auth.Menu;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.entity.tender.TenderProjectRuleEntity;
import com.gx.obe.web.service.ProjectRuleService;
import com.gx.obe.web.service.TenderProjectService;
import com.gx.obe.web.service.evaluation.EvaluationFactorService;
import com.gx.utils.ActionLogUtils;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

/** 
 * @Description: 开标评标规则
 * @author guoyr 
 */
public class BidOpeningRuleComposite extends Composite {
	
	private ProjectRuleService projectRuleService ;
	public EvaluationFactorService evaluationFactorService = new EvaluationFactorService();
//	public TenderProjectService tenderProjectService = ServiceFactory.getInstance("tenderProjectService", TenderProjectService.class);
	private TenderProjectEntity tenderProjectEntity;
	private TenderProjectRuleEntity tenderProjectRuleEntity;
//	private Composite composite;
//	private Composite priceUtinComposite;
	private Label speekRateLabel;
	private Scale scale;
	private int speed = 0;
	private ProjectRuleListener projectRuleListener;
	private Text fileText;
	private Button filterKhBtn;
	private Properties configProperties;
	private Button signTenderName;
	private Button sealSituation_btn;
	private Button singBidPriceLimitBtn;
	private Text singBidPriceLimitNameText;
	private Text singPrefixText;
	private Text singSuffixText;
	private Composite baseRoleComposite;
	private Label bidPriceLimitLabel;
	private Composite singBidPriceLimitParentComposite;
	private ELink editLimitPriceElink;
	private Text bidPriceLimitText;
	private Label priceUnitUNLabel;
	private Action projectAction;
	private Menu menu;
	public TenderProjectService tenderProjectService;
	private MenuFunctionUtils menuFunctionUtils = new MenuFunctionUtils();
	private Composite buttonComposite;
	{
		LogUtils.logClass(BidOpeningRuleComposite.class);
	}
	
	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public BidOpeningRuleComposite(Composite parent, Action projectAction, int style) {
		super(parent, style);
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.verticalSpacing = 1;
		gridLayout.horizontalSpacing = 1;
		gridLayout.marginHeight = 1;
		gridLayout.marginWidth = 1;
		setLayout(gridLayout);
		this.projectAction = projectAction;
		
		baseRoleComposite = new Composite(this, SWT.NONE);
		baseRoleComposite.setFont(SWTResourceManager.getFont("微软雅黑", 11, SWT.BOLD));
		GridLayout gl_group = new GridLayout(2, false);
		gl_group.marginWidth = 10;
		gl_group.marginHeight = 8;
		baseRoleComposite.setLayout(gl_group);
		baseRoleComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
//		Label label_1 = new Label(baseRoleComposite, SWT.NONE);
//		label_1.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
//		label_1.setText("投标（报价）单位：");
//		
//		priceUtinComposite = new Composite(baseRoleComposite, SWT.NONE);
//		GridLayout gl_priceUtinComposite = new GridLayout(3, false);
//		gl_priceUtinComposite.marginHeight = 0;
//		gl_priceUtinComposite.marginWidth = 0;
//		priceUtinComposite.setLayout(gl_priceUtinComposite);
//		priceUtinComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
//		
//		Button button_2 = new Button(priceUtinComposite, SWT.RADIO);
//		button_2.setSelection(true);
//		button_2.setText("元");
//		button_2.setData(CommonEnum.YUAN);
//		
//		Button button_3 = new Button(priceUtinComposite, SWT.RADIO);
//		button_3.setText("万元");
//		button_3.setData(CommonEnum.WAN_YUAN);
//		
//		Button button_4 = new Button(priceUtinComposite, SWT.RADIO);
//		button_4.setText("%");
//		button_4.setData(CommonEnum.PRICE_PERENT);
		
//		Label label_23 = new Label(priceUtinComposite, SWT.WRAP);
//		label_23.setForeground(SWTResourceManager.getColor(SWT.COLOR_DARK_GRAY));
//		label_23.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
//		label_23.setText("设置系统中所有金额单位。");
		
		speekRateLabel = new Label(baseRoleComposite, SWT.NONE);
		speekRateLabel.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		speekRateLabel.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		speekRateLabel.setText(Messages.SpeechRate + "：");
		
		Composite composite_1 = new Composite(baseRoleComposite, SWT.NONE);
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		GridLayout gl_composite_1 = new GridLayout(3, false);
		gl_composite_1.marginWidth = 0;
		gl_composite_1.marginHeight = 0;
		composite_1.setLayout(gl_composite_1);
		
		Label label_3 = new Label(composite_1, SWT.NONE);
		label_3.setText(Messages.Slow);
		scale = new Scale(composite_1, SWT.NONE);
		scale.setSelection(10);
		scale.setPageIncrement(1);
		scale.setMaximum(20);
		
		Label label_2 = new Label(composite_1, SWT.NONE);
		label_2.setText(Messages.Fast);
		
		Label label_6 = new Label(baseRoleComposite, SWT.NONE);
		label_6.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		label_6.setText(Messages.SingOption + "：");
		
		Composite singSelection_composite = new Composite(baseRoleComposite, SWT.NONE);
		RowLayout rl_singSelection_composite = new RowLayout(SWT.HORIZONTAL);
		rl_singSelection_composite.marginLeft = 0;
		singSelection_composite.setLayout(rl_singSelection_composite);
		singSelection_composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		
		signTenderName = new Button(singSelection_composite, SWT.CHECK);
		signTenderName.setText(MessageFormat.format(Messages.SingFormat, Messages.ProjectName));
		
		sealSituation_btn = new Button(singSelection_composite, SWT.CHECK);
		sealSituation_btn.setText(MessageFormat.format(Messages.SingFormat, Messages.SealingStatus));
		
		Label label_5 = new Label(baseRoleComposite, SWT.NONE);
		label_5.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		label_5.setText(Messages.BiddingControlPrice + "：");
		menuFunctionUtils.addFunction(label_5, "BIDDING_PRICE");
		
		singBidPriceLimitParentComposite = new Composite(baseRoleComposite, SWT.NONE);
		GridLayout gl_composite_4 = new GridLayout(4, false);
		gl_composite_4.marginWidth = 0;
		gl_composite_4.marginHeight = 0;
		singBidPriceLimitParentComposite.setLayout(gl_composite_4);
		menuFunctionUtils.addFunction(singBidPriceLimitParentComposite, "BIDDING_PRICE");
		
		singBidPriceLimitBtn = new Button(singBidPriceLimitParentComposite, SWT.CHECK);
		singBidPriceLimitBtn.setText("");
		
		Composite singBidPriceLimitComposite = new Composite(singBidPriceLimitParentComposite, SWT.NONE);
		singBidPriceLimitComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		GridLayout gl_singBidPriceLimitComposite = new GridLayout(7, false);
		gl_singBidPriceLimitComposite.verticalSpacing = 0;
		gl_singBidPriceLimitComposite.horizontalSpacing = 0;
		gl_singBidPriceLimitComposite.marginHeight = 0;
		gl_singBidPriceLimitComposite.marginWidth = 0;
		singBidPriceLimitComposite.setLayout(gl_singBidPriceLimitComposite);
		
		Label singBidPrice = new Label(singBidPriceLimitComposite, SWT.CHECK);
		singBidPrice.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 2));
		singBidPrice.setText(MessageFormat.format(Messages.SingFormat, ""));
		
		singBidPriceLimitNameText = new Text(singBidPriceLimitComposite, SWT.NONE);
		GridData gd_singBidPriceLimitNameText = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_singBidPriceLimitNameText.widthHint = 80;
		singBidPriceLimitNameText.setLayoutData(gd_singBidPriceLimitNameText);
		singBidPriceLimitNameText.setTextLimit(20);
		
		Label label_11 = new Label(singBidPriceLimitComposite, SWT.CHECK);
		label_11.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 2));
		label_11.setText("，");
		
		bidPriceLimitText = new Text(singBidPriceLimitComposite, SWT.NONE);
		bidPriceLimitText.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		priceUnitUNLabel = new Label(singBidPriceLimitComposite, SWT.NONE);
		priceUnitUNLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 2));
		priceUnitUNLabel.setText("");
		
		bidPriceLimitLabel = new Label(singBidPriceLimitComposite, SWT.NONE);
		bidPriceLimitLabel.setForeground(SWTResourceManager.getColor(SWT.COLOR_BLUE));
		bidPriceLimitLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 2));
		bidPriceLimitLabel.setText("");
		
		editLimitPriceElink = new ELink(singBidPriceLimitComposite, SWT.NONE);
		editLimitPriceElink.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				updateLimitPrice();
			}
		});
		editLimitPriceElink.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/save.png"));
		editLimitPriceElink.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 2));
		
		
		ESepator singBidPriceLimitSep = new ESepator(singBidPriceLimitComposite, SWT.NONE);
		singBidPriceLimitSep.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		singBidPriceLimitSep.setBackground(ColorConstants.BORDER_LINE_COLOR);
		
		ESepator bidPriceLimitSep = new ESepator(singBidPriceLimitComposite, SWT.NONE);
		bidPriceLimitSep.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		bidPriceLimitSep.setBackground(ColorConstants.BORDER_LINE_COLOR);
		
		Label label = new Label(baseRoleComposite, SWT.NONE);
		label.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		label.setText(Messages.SingFilter + "：");
		
		filterKhBtn = new Button(baseRoleComposite, SWT.CHECK);
		filterKhBtn.setText(Messages.SingFilterTitle);
		
		Label preTitleLabel = new Label(baseRoleComposite, SWT.NONE);
		preTitleLabel.setLayoutData(new GridData(SWT.RIGHT, SWT.TOP, false, false, 1, 2));
		preTitleLabel.setText(Messages.SingStartContent + "：");
		
		Label preTips = new Label(baseRoleComposite, SWT.WRAP);
		preTips.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		preTips.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		preTips.setText(Messages.Tips_singStartContent);
		
		singPrefixText = new Text(baseRoleComposite, SWT.BORDER | SWT.WRAP | SWT.MULTI | SWT.V_SCROLL);
		singPrefixText.setTextLimit(2000);
		GridData gd_singPrefixText = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_singPrefixText.heightHint = 50;
		singPrefixText.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		singPrefixText.setLayoutData(gd_singPrefixText);
		
		Label suffixTitleLabel = new Label(baseRoleComposite, SWT.NONE);
		suffixTitleLabel.setLayoutData(new GridData(SWT.RIGHT, SWT.TOP, false, false, 1, 2));
		suffixTitleLabel.setText(Messages.SingEndContent + "：");
		
		Label suffixTips = new Label(baseRoleComposite, SWT.WRAP);
		suffixTips.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		suffixTips.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		suffixTips.setText(Messages.Tips_singEndContent);
		
		singSuffixText = new Text(baseRoleComposite, SWT.BORDER | SWT.WRAP | SWT.MULTI | SWT.V_SCROLL);
		singSuffixText.setTextLimit(2000);
		singSuffixText.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		GridData gd_singSuffixText = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_singSuffixText.heightHint = 50;
		singSuffixText.setLayoutData(gd_singSuffixText);
		Label ssLabel = new Label(baseRoleComposite, SWT.NONE);
		ssLabel.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		ssLabel.setText(Messages.SingReplace + "：");
		
		Label filterChar = new Label(baseRoleComposite, SWT.CHECK);
		filterChar.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		filterChar.setText(Messages.Tips_singReplace);
		
		Label label_4 = new Label(baseRoleComposite, SWT.NONE);
		label_4.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		
		fileText = new Text(baseRoleComposite, SWT.BORDER | SWT.WRAP | SWT.MULTI);
		fileText.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		fileText.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridData gd_fileText = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_fileText.heightHint = 40;
		fileText.setLayoutData(gd_fileText);
		
		buttonComposite = new Composite(this, SWT.NONE);
		buttonComposite.setLayout(new GridLayout(1, false));
		buttonComposite.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, false, 1, 1));
		
		BigButton saveBtn = new BigButton(buttonComposite, SWT.NONE);
		saveBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				saveConfigAction();
			}
		});
		saveBtn.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		GridData gd_savebutton_1 = new GridData(SWT.CENTER, SWT.FILL, true, true, 1, 1);
		saveBtn.setLayoutData(gd_savebutton_1);
		saveBtn.setText(Messages.Button_save);
		menuFunctionUtils.addFunction(saveBtn, "SAVE");
		tenderProjectService = new TenderProjectService();
		projectRuleService = new ProjectRuleService();
		init();
	}



	/**
	 * @Description: 初始化
	 * @author guoyr 
	 */
	private void init(){
		this.tenderProjectEntity = projectAction.getTenderProject();
		this.tenderProjectRuleEntity = projectAction.refreshTenderProjectRule();
		this.menu = projectAction.getMenu();
		if(null == tenderProjectRuleEntity){
			tenderProjectRuleEntity = new TenderProjectRuleEntity();
		}
		// 默认以按所有评标专家的自由进度进行控制
		if(StringUtils.isEmpty(tenderProjectRuleEntity.getOrderReview())){
			tenderProjectRuleEntity.setOrderReview(com.gx.obe.components.core.enumeration.EvaluationStepEnum.ORDER_REVIEW_NO);
		}
		tenderProjectEntity.setProjectRule(tenderProjectRuleEntity);
		priceUnitUNLabel.setText(tenderProjectRuleEntity.getPriceUnitUseDefault());
		refreshProjectRuleForm();
		menuFunctionUtils.initFunctionAuthority(menu, buttonComposite);
	}

	
	/**
	 * @Description: 刷新表单
	 * @author guoyr 
	 */
	private void refreshProjectRuleForm(){
		if(null == configProperties){
			configProperties = PropertiesUtils.getProperties("config.properties");
		}
		singBidPriceLimitNameText.addModifyListener(new ModifyListener() {
			public void modifyText(ModifyEvent arg0) {
				if(singBidPriceLimitNameText.getText().trim().length() == 0){
					singBidPriceLimitNameText.setText(Messages.BiddingControlPrice);
				}
			}
		});
		singBidPriceLimitBtn.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				singBidPriceLimitNameText.getParent().setEnabled(singBidPriceLimitBtn.getSelection());
				if(singBidPriceLimitBtn.getSelection()){
					if(null != tenderProjectEntity.getBidPriceLimit()){
						bidPriceLimitText.setText(MoneyUtils.getMoneyFormatByUnit(tenderProjectEntity.getBidPriceLimit(), tenderProjectRuleEntity.getEvalPriceUnit()));
						bidPriceLimitLabel.setText("("+MoneyUtils.amountToChinese(tenderProjectEntity.getBidPriceLimit().doubleValue())+")");
					}else {
						MessageDialog.openShortMessage(MessageFormat.format(Messages.Tips_notSetFormat, Messages.BiddingControlPrice));
						singBidPriceLimitBtn.setSelection(false);
						bidPriceLimitLabel.setText("");
					}
				}else {
					bidPriceLimitText.setText("");
					bidPriceLimitLabel.setText("");
				}
				bidPriceLimitLabel.getParent().layout();
				singBidPriceLimitParentComposite.layout();
				singBidPriceLimitParentComposite.getParent().layout();
				baseRoleComposite.layout();
			}
		});
		
		// 唱标语速
		speed = Integer.parseInt(ObjectUtils.getObjString(configProperties.getProperty(ConfigConstants.SPEED), "0"));
		filterKhBtn.setSelection(configProperties.getProperty(ConfigConstants.FILTER_BRACKET_CONTENT, "00").equals("01"));
		signTenderName.setSelection(configProperties.getProperty(ConfigConstants.SING_TENDERNAME, "00").equals("01"));
		sealSituation_btn.setSelection(configProperties.getProperty(ConfigConstants.SEAL_SITUATION, "01").equals("01"));
		
		Object signBidPriceLimitName = tenderProjectRuleEntity.getParamByKey(ProjectRuleEnum.PARAM_PRICE_LIMIT_NAME);
		if(null != signBidPriceLimitName && signBidPriceLimitName.toString().length() > 0){
			singBidPriceLimitNameText.setText(signBidPriceLimitName.toString());
		}else {
			singBidPriceLimitNameText.setText(Messages.BiddingControlPrice);
		}
		Object signBidPriceLimit = tenderProjectRuleEntity.getParamByKey(ProjectRuleEnum.PARAM_SIGN_BID_PRICE_LIMIT);
		if(null != signBidPriceLimit && signBidPriceLimit.toString().equals("01") && null != tenderProjectEntity.getBidPriceLimit()){
			singBidPriceLimitBtn.setSelection(true);
		}else {
			singBidPriceLimitBtn.setSelection(false);
		}
		singBidPriceLimitBtn.notifyListeners(SWT.Selection, null);
		singPrefixText.setText(ObjectUtils.getObjString(tenderProjectRuleEntity.getSingPrefix()));
		singSuffixText.setText(ObjectUtils.getObjString(tenderProjectRuleEntity.getSingSuffix()));
		fileText.setText(configProperties.getProperty(ConfigConstants.FILTER_CHAR, "0"));
		scale.setSelection(speed+10);
		speekRateLabel.setText(Messages.SpeechRate + "：\r\n( "+speed+" )"); 
		scale.addListener(SWT.Selection, new Listener() { 
			public void handleEvent(Event event) { 
				speed = scale.getSelection() - 10;
				speekRateLabel.setText(Messages.SpeechRate + "：\r\n( "+speed+" )"); 
				
			} 
		});
//		WidgetUtils.setRadioChecked(priceUtinComposite, null != tenderProjectRuleEntity.getPriceUnitType()?tenderProjectRuleEntity.getPriceUnitType():CommonEnum.YUAN);
		
	}
	
	public void addProjectRuleListener(ProjectRuleListener projectRuleListener){
		this.projectRuleListener = projectRuleListener;
	}
	
	/**
	 * 修改控制价
	 */
	private void updateLimitPrice() {
		BigDecimal oldLimitPrice = tenderProjectEntity.getBidPriceLimit();
		BigDecimal limitPrcieBigDecimal = BigDecimal.ZERO;;
		tenderProjectRuleEntity.setParam(ProjectRuleEnum.PARAM_SIGN_BID_PRICE_LIMIT, "01");	
		tenderProjectRuleEntity.setParam(ProjectRuleEnum.PARAM_PRICE_LIMIT_NAME, singBidPriceLimitNameText.getText().trim());
		if(null != bidPriceLimitText.getText()){
			limitPrcieBigDecimal = MoneyUtils.getMoneyFromText(bidPriceLimitText.getText(),tenderProjectRuleEntity.getPriceUnitUseDefault());
		}
		if(null != limitPrcieBigDecimal && !limitPrcieBigDecimal.equals(oldLimitPrice)){
			tenderProjectEntity.setBidPriceLimit(limitPrcieBigDecimal);
		}else{
			return;
		}
		ActionLogUtils.addServerLog(tenderProjectEntity.getId(), "修改控制价", null != limitPrcieBigDecimal ? limitPrcieBigDecimal.toString() : null);
		if(tenderProjectService.updateAssignProperty(tenderProjectEntity,new String[]{"bidPriceLimit"})){
			refreshProjectRuleForm();
		}
	}
	
	
	/**
	 * @Description: 保存
	 * @author guoyr 
	 */
	private void saveConfigAction(){
		PropertiesUtils.setPropertyValue(ConfigConstants.SPEED, speed+"");
		String[] params = new String[]{"id","params", "singPrefix", "singSuffix"};
		if(singBidPriceLimitBtn.getSelection()){
			tenderProjectRuleEntity.setParam(ProjectRuleEnum.PARAM_SIGN_BID_PRICE_LIMIT, "01");	
			tenderProjectRuleEntity.setParam(ProjectRuleEnum.PARAM_PRICE_LIMIT_NAME, singBidPriceLimitNameText.getText().trim());	
		}else {
			tenderProjectRuleEntity.setParam(ProjectRuleEnum.PARAM_SIGN_BID_PRICE_LIMIT, null);	
		}
		tenderProjectRuleEntity.setSingPrefix(singPrefixText.getText());
		tenderProjectRuleEntity.setSingSuffix(singSuffixText.getText());
		
//		String priceUnit = ObjectUtils.getObjString(WidgetUtils.getRadioVal(priceUtinComposite));
//		if(!ObjectUtils.equals(tenderProjectRuleEntity.getPriceUnitType(), priceUnit)){
//			tenderProjectRuleEntity.setPriceUintType(priceUnit);
//			params = new String[]{"id","params", "priceUint", "singPrefix", "singSuffix"};
//			projectRuleService.updateAssignProperty(tenderProjectRuleEntity, params);
//		}
		projectRuleService.updateAssignProperty(tenderProjectRuleEntity, params);
		ActionLogUtils.addServerLog(tenderProjectRuleEntity.getTenderId(), "更新项目开标规则", JsonUtil.jsonObjectToStr(tenderProjectRuleEntity));
		PropertiesUtils.setPropertyValue(ConfigConstants.FILTER_BRACKET_CONTENT, filterKhBtn.getSelection()?"01" : "00");
		PropertiesUtils.setPropertyValue(ConfigConstants.FILTER_CHAR, fileText.getText().trim());
		PropertiesUtils.setPropertyValue(ConfigConstants.SING_TENDERNAME, signTenderName.getSelection() ? "01" : "00");
		PropertiesUtils.setPropertyValue(ConfigConstants.SEAL_SITUATION, sealSituation_btn.getSelection() ? "01" : "00");
		configProperties.put(ConfigConstants.FILTER_BRACKET_CONTENT, filterKhBtn.getSelection()?"01" : "00");
		configProperties.put(ConfigConstants.FILTER_CHAR, fileText.getText().trim());
		configProperties.put(ConfigConstants.SING_TENDERNAME, signTenderName.getSelection()?"01" : "00");
		configProperties.put(ConfigConstants.SEAL_SITUATION, sealSituation_btn.getSelection()?"01" : "00");
		PropertiesUtils.saveProperties(configProperties);
		MessageDialog.openShortMessage(Messages.Tips_saveSuccess);
		if(null != projectRuleListener){
			projectRuleListener.updateProjectRule(tenderProjectRuleEntity);
		}
	}
	
	@Override
	protected void checkSubclass() {
	}
}
