package com.gx.obe.opening.composite;

import java.text.SimpleDateFormat;
import java.util.Date;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.ImageResolver;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;

import com.gx.obe.ColorConstants;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.opening.Activator;
import com.gx.obe.util.thread.CountTimeThread;
import com.gx.utils.NowTimeUtils;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

public class CountDownComposite extends Composite {

	private PaintListener paintListener;
	private boolean selection = false;
	private Composite content;
	private ImageResolver imageResolver = new ImageResolver();
	private CLabel countDownNum_label;
	private Composite countDown_composite;
	private Label time_label;
	private Label title_label;
	private Label year_label;
	private SimpleDateFormat dateFormat = new SimpleDateFormat("yyyy-MM-dd");
	private SimpleDateFormat timeFormat = new SimpleDateFormat("HH : mm");
	private CountTimeThread countTimeThread;
	private Date myTime;
	private CountDownListener listener;
	private GridLayout gl_composite_5;
	private GridData gd_content;
	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public CountDownComposite(Composite parent, int style) {
		super(parent, style);
		addDisposeListener(new DisposeListener() {
			public void widgetDisposed(DisposeEvent arg0) {
				disposeResource();
			}
		});
		gl_composite_5 = new GridLayout(1, false);
		gl_composite_5.marginHeight = 15;
		gl_composite_5.marginWidth = 8;
		setLayout(gl_composite_5);
		
		content = new Composite(this, SWT.NONE);
		content.setBackgroundImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/time/content_center_bg.png"));
		gd_content = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_content.minimumWidth = 220;
		gd_content.heightHint = 67;
		content.setLayoutData(gd_content);
//		content.setBackground(SWTResourceManager.getColor(160, 0, 80));
		GridLayout gl_composite_2 = new GridLayout(5, false);
		gl_composite_2.marginHeight = 12;
		gl_composite_2.marginWidth = 15;
		gl_composite_2.verticalSpacing = 0;
		content.setLayout(gl_composite_2);
		
		title_label = new Label(content, SWT.WRAP);
		title_label.setFont(SWTResourceManager.getFont("微软雅黑", 11, SWT.NORMAL));
		title_label.setAlignment(SWT.RIGHT);
		title_label.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		title_label.setForeground(SWTResourceManager.getColor(80, 80, 80));
		title_label.setText("签到\r\n截止时间");
		
		CLabel label = new CLabel(content, SWT.NONE);
		label.setLayoutData(new GridData(SWT.LEFT, SWT.FILL, false, true, 1, 1));
		label.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/time/v_sep.png"));
		
		Composite composite_8 = new Composite(content, SWT.NONE);
		composite_8.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, true, 1, 1));
		GridLayout gl_composite_8 = new GridLayout(1, false);
		gl_composite_8.horizontalSpacing = 0;
		gl_composite_8.verticalSpacing = 0;
		gl_composite_8.marginWidth = 0;
		gl_composite_8.marginHeight = 0;
		composite_8.setLayout(gl_composite_8);
		
		year_label = new Label(composite_8, SWT.NONE);
		year_label.setFont(SWTResourceManager.getFont("微软雅黑", 9, SWT.NORMAL));
		year_label.setForeground(SWTResourceManager.getColor(150, 150, 150));
		year_label.setText("2016-10-10");
		
		time_label = new Label(composite_8, SWT.NONE);
		time_label.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		time_label.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		time_label.setFont(SWTResourceManager.getFont("微软雅黑", 15, SWT.NORMAL));
		time_label.setText("18 : 18");
		
		countDown_composite = new Composite(content, SWT.NONE);
		GridData gd_countDown_composite = new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1);
		gd_countDown_composite.widthHint = 0;
		countDown_composite.setLayoutData(gd_countDown_composite);
		GridLayout gl_countDown_composite = new GridLayout(2, false);
		gl_countDown_composite.marginLeft = 5;
		gl_countDown_composite.marginWidth = 0;
		gl_countDown_composite.marginHeight = 0;
		countDown_composite.setLayout(gl_countDown_composite);
		
		Label countDown_label = new Label(countDown_composite, SWT.WRAP);
		countDown_label.setFont(SWTResourceManager.getFont("宋体", 9, SWT.NORMAL));
		countDown_label.setForeground(SWTResourceManager.getColor(150, 150, 150));
		countDown_label.setText("倒\r\n计\r\n时");
		
		countDownNum_label = new CLabel(countDown_composite, SWT.NONE);
		countDownNum_label.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		Label label_1 = new Label(content, SWT.NONE);
		label_1.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		label_1.setText("");
		init();
	}
	
	private void init(){
		paintListener = new PaintListener() {
			public void paintControl(PaintEvent arg0) {
				Image bgImage = ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/time/content_center_bg.png");
				arg0.gc.drawImage(bgImage, 0, 0, bgImage.getBounds().width, bgImage.getBounds().height, 0, (arg0.height - bgImage.getBounds().height)/2, arg0.width, bgImage.getBounds().height);
				if(selection){
					Image topImage = ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/time/top_border.png");
					arg0.gc.drawImage(topImage, 0, 0, topImage.getBounds().width, topImage.getBounds().height, 0, 0, arg0.width, topImage.getBounds().height);
					Image bottomImage = ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/time/bottom_border.png");
					arg0.gc.drawImage(bottomImage, 0, 0, bottomImage.getBounds().width, bottomImage.getBounds().height, 0, arg0.height - bottomImage.getBounds().height, arg0.width, bottomImage.getBounds().height);
					Image leftImage = ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/time/left_border.png");
					int leftBorderHeight = arg0.height - topImage.getBounds().height - bottomImage.getBounds().height;
					if(leftBorderHeight > 0){
						arg0.gc.drawImage(leftImage, 0, 0, leftImage.getBounds().width, leftImage.getBounds().height, -1, topImage.getImageData().height, leftImage.getImageData().width, leftBorderHeight);
						Image rightImage = ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/time/right_border.png");
						arg0.gc.drawImage(rightImage, 0, 0, rightImage.getBounds().width, rightImage.getBounds().height, arg0.width - leftImage.getImageData().width +1, topImage.getImageData().height, rightImage.getImageData().width, arg0.height - topImage.getBounds().height - bottomImage.getBounds().height);
					}
				}
				arg0.gc.dispose();
			}
		};
		this.addPaintListener(paintListener);
		
		countDownNum_label.addPaintListener(new PaintListener() {
			int num_width = 35;
			int num_sep_width = 0;
			int second_width = 10;
			public void paintControl(PaintEvent arg0) {
				String[] countTime = (String[])(countDownNum_label).getData();
				if(null != countTime && countTime.length == 4){
				}else {
					countTime = new String[]{"8", "8", "8", "8"};
				}
				Rectangle bounds = countDownNum_label.getBounds();
				num_width = (bounds.width - second_width - num_sep_width*2)/4;
				Image imageSep = imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/time/red_sep.png");
				int x = 0;
				for(int i = 0; i < countTime.length; i++){
					String num = countTime[i];
					Image image = imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/time/red_"+num+".png");
					if(null != image){
						
						Rectangle rectangle = image.getBounds();
						arg0.gc.drawImage(image, 0, 0, rectangle.width, rectangle.height, x, 0, num_width, bounds.height);
//					arg0.gc.drawImage(imageResolver.loadImage(SWTCoreIconsActivator.PLUGIN_ID,"icons/time/red_"+num+".png"), x, y);
						x += num_width;
						if(i % 2 == 0){
							x += num_sep_width;
						}
						if(i == 1){
							arg0.gc.drawImage(imageSep, 0, 0, imageSep.getBounds().width, imageSep.getBounds().height, x, 0, second_width, bounds.height);
							x += second_width;
							
						}
					}
				}
//				arg0.gc.dispose();
			}
		});
	}
	
	public void refresh(String text, Date myTime){
		title_label.setText(text);
		this.myTime = myTime;
		if(null != myTime){
			year_label.setText(dateFormat.format(myTime));
			time_label.setText(timeFormat.format(myTime));
		}else {
			year_label.setText("    -  -  ");
			time_label.setText("00 : 00");
		}
		if(null != countTimeThread){
			countTimeThread.stop();
			countTimeThread = null;
		}
		startCountTimeThread();
	}
	public void setSelection(boolean selection){
		this.selection = selection;
		if(selection){
			gl_composite_5.marginWidth = 8;
			if(null != countTimeThread){
				countTimeThread.start();
			}
			content.setBackgroundImage(null);
			((GridData)countDown_composite.getLayoutData()).widthHint = 130;
		}else {
			gl_composite_5.marginWidth = 0;
			((GridData)countDown_composite.getLayoutData()).widthHint = 0;
			content.setBackgroundImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/time/content_center_bg.png"));
			if(null != countTimeThread){
				countTimeThread.stop();
			}
		}
		countDown_composite.layout();
		content.layout();
		this.layout();
		
	}
	
	public boolean isSelection() {
		return selection;
	}

	/**
	 * @Description: 启动倒计时线程
	 * @author guoyr
	 */
	private void startCountTimeThread(){
		countTimeThread = new CountTimeThread(NowTimeUtils.getNowDate() , myTime, new CountTimeThread.CountTime() {
			private final String[] countTime = new String[]{"8", "8", "8", "8"};
			Runnable drawRunnable = new Runnable(){
				public void run(){
					if(!countDownNum_label.isDisposed()){
						countDownNum_label.setData(countTime);
						countDownNum_label.redraw();
//						redraw();
					}
				}
			};
			Runnable refreshTimeRunnable = new Runnable(){
				public void run(){
					if(null != listener){
						try {
							Thread.sleep(1000);
						} catch (InterruptedException e) {
						}
						listener.countTimeComplate();
					}
				}
			};
			public void countTime(final long day, final long hour, final long minute, final long second) {
				if(day > 0 || hour > 0){
					countTime[0] = "8";
					countTime[1] = "8";
				}else {
					
					if(minute > 9){
						countTime[0] = (minute+"").substring(0,1);
						countTime[1] = (minute+"").substring(1);
					}else {
						countTime[0] = "0";
						countTime[1] = minute+"";
					}
				}
				if(second > 9){
					countTime[2] = (second+"").substring(0,1);
					countTime[3] = (second+"").substring(1);
				}else {
					countTime[2] = "0";
					countTime[3] = second+"";
				}
				Display.getDefault().asyncExec(drawRunnable);
				if(hour == 0 && minute == 0 && second == 0 && null != listener){
					if(null != countTimeThread){
						countTimeThread.stop();
						countTimeThread = null;
					}
					Display.getDefault().syncExec(refreshTimeRunnable);
				}
				
			}
		});
	}
	


	/**
	 * @Description: 添加倒计时监听
	 * @author guoyr
	 * @param listener
	 */
	public void addCountDownListener(CountDownListener listener){
		this.listener = listener;
	}
	private void disposeResource() {
		if(null != countTimeThread){
			countTimeThread.stop();
		}
		imageResolver.disposite();
		this.removePaintListener(paintListener);
		super.dispose();
	}

	public interface CountDownListener{
		public void countTimeComplate();
	}
	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}

}
