package com.gx.obe.opening.composite;

import java.util.Date;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.ImageResolver;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;

import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.util.thread.CountTimeThread;
import com.gx.utils.NowTimeUtils;

public class CountDownTimeComposite extends Composite {

	private PaintListener paintListener;
	private ImageResolver imageResolver = new ImageResolver();
	private CLabel countDownNum_label;
	private CountTimeThread countTimeThread;
	private Date myTime;
	private CountDownListener listener;
	private GridLayout gl_composite_5;
	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public CountDownTimeComposite(Composite parent, int style) {
		super(parent, style);
		addDisposeListener(new DisposeListener() {
			public void widgetDisposed(DisposeEvent arg0) {
				disposeResource();
			}
		});
		gl_composite_5 = new GridLayout(1, false);
		gl_composite_5.marginHeight = 5;
		gl_composite_5.marginWidth = 5;
		setLayout(gl_composite_5);
		
		countDownNum_label = new CLabel(this, SWT.NONE);
		GridData gd_countDownNum_label = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_countDownNum_label.minimumHeight = 35;
		countDownNum_label.setLayoutData(gd_countDownNum_label);
		init();
	}
	
	private void init(){
		paintListener = new PaintListener() {
			int num_width = 35;
			int num_sep_width = 0;
			int second_width = 10;
			public void paintControl(PaintEvent arg0) {
				String[] countTime = (String[])(countDownNum_label).getData();
				if(null != countTime && countTime.length == 6){
				}else {
					countTime = new String[]{"8", "8", "8", "8", "8", "8"};
				}
				Rectangle bounds = countDownNum_label.getBounds();
				num_width = Math.max((bounds.width - second_width * 2 - num_sep_width * 3)/countTime.length, 0);
				if(num_width <= 0){
					return;
				}
				Image imageSep = imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/time/red_sep.png");
				int x = 0;
				for(int i = 0; i < countTime.length; i++){
					String num = countTime[i];
					Image image = imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/time/red_"+num+".png");
					if(null != image){
						Rectangle rectangle = image.getBounds();
						arg0.gc.drawImage(image, 0, 0, rectangle.width, rectangle.height, x, 0, num_width, bounds.height);
//					arg0.gc.drawImage(imageResolver.loadImage(SWTCoreIconsActivator.PLUGIN_ID,"icons/time/red_"+num+".png"), x, y);
						x += num_width;
						if(i % 2 == 0){
							x += num_sep_width;
						}
						if(i == 1 || i == 3){
							arg0.gc.drawImage(imageSep, 0, 0, imageSep.getBounds().width, imageSep.getBounds().height, x, 0, second_width, bounds.height);
							x += second_width;
							
						}
					}
				}
//				arg0.gc.dispose();
			}
		};
		countDownNum_label.addPaintListener(paintListener);
	}
	
	public void refresh(String text, Date myTime){
		this.myTime = myTime;
		if(null != countTimeThread){
			countTimeThread.stop();
			countTimeThread = null;
		}
		startCountTimeThread();
	}
	
	/**
	 * @Description: 启动倒计时线程
	 * @author guoyr
	 */
	private void startCountTimeThread(){
		countTimeThread = new CountTimeThread(NowTimeUtils.getNowDate() , myTime, new CountTimeThread.CountTime() {
			private final String[] countTime = new String[]{"8", "8", "8", "8", "8", "8"};
			Runnable drawRunnable = new Runnable(){
				public void run(){
					if(!countDownNum_label.isDisposed()){
						countDownNum_label.setData(countTime);
						countDownNum_label.redraw();
//						redraw();
					}
				}
			};
//			Runnable refreshTimeRunnable = new Runnable(){
//				public void run(){
//					if(null != listener && null != countTimeThread){
//						listener.countTimeComplate();
//					}
//				}
//			};
			public void countTime(final long day, final long hour, final long minute, final long second) {
				if(day > 0){
					countTime[0] = "8";
					countTime[1] = "8";
				}else {
					if(hour > 9){
						countTime[0] = (hour+"").substring(0,1);
						countTime[1] = (hour+"").substring(1);
					}else {
						countTime[0] = "0";
						countTime[1] = hour+"";
					}
				}
				if(minute > 9){
					countTime[2] = (minute+"").substring(0,1);
					countTime[3] = (minute+"").substring(1);
				}else {
					countTime[2] = "0";
					countTime[3] = minute+"";
				}
				if(second > 9){
					countTime[4] = (second+"").substring(0,1);
					countTime[5] = (second+"").substring(1);
				}else {
					countTime[4] = "0";
					countTime[5] = second+"";
				}
				Display.getDefault().asyncExec(drawRunnable);
				if(day == 0 && hour == 0 && minute == 0 && second == 0 && null != listener){
					if(null != listener && null != countTimeThread){
						listener.countTimeComplate();
					}
//					Display.getDefault().syncExec(refreshTimeRunnable);
					if(null != countTimeThread){
						countTimeThread.stop();
						countTimeThread = null;
					}
				}
				
			}
		});
		countTimeThread.start();
	}
	


	/**
	 * @Description: 添加倒计时监听
	 * @author guoyr
	 * @param listener
	 */
	public void addCountDownListener(CountDownListener listener){
		this.listener = listener;
	}
	private void disposeResource() {
		if(null != countTimeThread){
			countTimeThread.stop();
		}
		imageResolver.disposite();
		if(null != paintListener && !countDownNum_label.isDisposed()){
			countDownNum_label.removePaintListener(paintListener);
		}
		super.dispose();
	}

	public interface CountDownListener{
		public void countTimeComplate();
	}
	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}

}
