package com.gx.obe.opening.composite;

import java.util.List;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.listener.RoundBorderLineListener;
import org.eclipse.swt.core.widgets.ETabFolder;
import org.eclipse.swt.core.widgets.ETabItem;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;

import com.gx.obe.ColorConstants;
import com.gx.obe.action.bean.Action;
import com.gx.obe.action.listener.ActionListener;
import com.gx.obe.action.utils.ActionUtil;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.thread.MyRunnable;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.message.menu.MenuMessages;
import com.gx.obe.web.entity.auth.Menu;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.listener.WebEntityListener;
import com.gx.obe.web.service.TenderProjectService;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

public class LeftSubMenuComposite extends Composite implements ActionListener{

	private Composite loadComposite;
	private TenderProjectEntity tenderProjectEntity;
	private Menu menu;
	private TenderProjectService tenderProjectService ;
	private ETabFolder eTabFolder;
	private boolean isParentProject = false;

	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public LeftSubMenuComposite(Composite parent, int style) {
		super(parent, style);
		tenderProjectService = new TenderProjectService();
		tenderProjectEntity = (TenderProjectEntity)parent.getData("tenderProjectEntity");
		menu = (Menu)parent.getData("menu");
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.verticalSpacing = 0;
		gridLayout.horizontalSpacing = 0;
		gridLayout.marginHeight = 0;
		gridLayout.marginWidth = 0;
		setLayout(gridLayout);
		
		eTabFolder = new ETabFolder(this, SWT.NONE);
		eTabFolder.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		
		loadComposite = new Composite(this, SWT.NONE);
		loadComposite.setForeground(SWTResourceManager.getColor(SWT.COLOR_BLUE));
		loadComposite.setBackgroundMode(SWT.INHERIT_FORCE);
		FillLayout fl_loadComposite = new FillLayout(SWT.HORIZONTAL);
		fl_loadComposite.marginWidth = 10;
		fl_loadComposite.marginHeight = 5;
		loadComposite.setLayout(fl_loadComposite);
		loadComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		loadComposite.addPaintListener(new RoundBorderLineListener(ColorConstants.BORDER_LINE_COLOR, -1));
	}
	class RefreshActionThread extends MyRunnable{
		private WebEntityListener<TenderProjectEntity> listener;
		private String id;
 		public RefreshActionThread(String id ,WebEntityListener<TenderProjectEntity> listener){
			this.listener = listener;	
			this.id = id;
		}
		@Override
		public void run() {
			final TenderProjectEntity	tenderProjectEntity = tenderProjectService.getById(id);
			Display.getDefault().syncExec(new Runnable() {
				public void run() {
					listener.run(tenderProjectEntity);
					eTabFolder.getParent().layout();
				}
			});
		}
	}	
	
	public void init(final TenderProjectEntity tenderProjectEntity, final Menu menu){
		this.tenderProjectEntity = tenderProjectEntity;
		this.menu = menu;
		

		if(null == tenderProjectEntity.getParentId() && tenderProjectEntity.getChildrenCountIntValue() > 0){
			isParentProject = true;
		}
		RefreshActionThread refreshActionThread = new RefreshActionThread(tenderProjectEntity.getId(),new WebEntityListener<TenderProjectEntity>() {
			@Override
			public void run(TenderProjectEntity entity) {
				LeftSubMenuComposite.this.tenderProjectEntity  = entity;
				boolean  isParentProject = false;
				if(null != tenderProjectEntity.getIsPack() && tenderProjectEntity.getIsPack().equals(CommonEnum.YES)){
					isParentProject = true;
				}
				
				eTabFolder.setTabHeight(40);
				eTabFolder.setTopOffset(6);
				eTabFolder.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.NORMAL));
				eTabFolder.setDefaultForeground(ColorConstants.NOTE_TIPS_COLOR);
				eTabFolder.setSelectionForeground(ResourceManager.getColor(SWT.COLOR_WHITE));
				eTabFolder.setDefaultBackgroundColor(SWTResourceManager.getColor(247, 247, 247));
				eTabFolder.setDefaultBorderColor(SWTResourceManager.getColor(224, 224, 224));
				eTabFolder.setSelectionBackgroundImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/tab_selected.png"));
				eTabFolder.setSelectionBorder(new int[]{7,7});
				loadComposite.setData("tenderProjectEntity", tenderProjectEntity);
				
				ETabItem firstItem = null;
				List<Menu> subMenuList = menu.getChildList();
				int menuCount = 0;
				if(null != subMenuList && subMenuList.size() > 0){
					for(Menu subMenu : subMenuList){
						boolean showThisMenu = true;
						if(isParentProject){
							if("00".equals(subMenu.getParam("parentVisible"))){
								showThisMenu = false;;
							}
						}else {
							if("00".equals(subMenu.getParam("packVisible"))){
								showThisMenu = false;;
							}
						}
						if(!showThisMenu){
							continue;
						}
						
						ETabItem baseInfoItem = new ETabItem(eTabFolder, SWT.NONE);
						baseInfoItem.setRightMargin(15);
						baseInfoItem.setLeftMargin(15);
						baseInfoItem.setImage(null);
						baseInfoItem.setImage(null);
						baseInfoItem.setText(MenuMessages.getValue(subMenu.getLanguageCode(), subMenu.getMenuShortName()));
						
						final Action action = (Action)ActionUtil.getAction(subMenu.getMenuUrl());
						if(null != action){
							action.setParentProject(tenderProjectEntity.getParentProjectEntity());
							action.setTenderProject(tenderProjectEntity);
							action.addActionListener(LeftSubMenuComposite.this);
							action.setData("menu", subMenu);
							action.setMenu(subMenu);
							baseInfoItem.addSelectionListener(new ETabFolder.SelectionListener() {
								public void selected(MouseEvent e) {
									action.run();
								}
							});
						}
						if(menuCount == 0){
							firstItem = baseInfoItem;
						}
						
						if("01".equals(subMenu.getParam("firstMenu"))){
							firstItem = baseInfoItem;
						}
						menuCount ++;
					}
				}
				if(menuCount > 1){
					eTabFolder.setTabHeight(40);
				}else {
					eTabFolder.setTabHeight(0);
				}
				if(null != firstItem){
					firstItem.notifyListeners(SWT.MouseUp, null);
				}
			}
		});
		refreshActionThread.start();	
	}

	public void onLoad(Action action) {
		action.setTenderProject(tenderProjectEntity);
		loadComposite.setData("menu", action.getMenu());
		for(Control control : loadComposite.getChildren()){
			control.dispose();
		}
	}

	public void loadComposite(Action action, Composite composite) {
		loadComposite.layout();
	}

	public Composite getParentComposite() {
		return loadComposite;
	}
	@Override
	protected void checkSubclass() {
	}

}
