package com.gx.obe.opening.composite;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.dnd.Clipboard;
import org.eclipse.swt.dnd.TextTransfer;
import org.eclipse.swt.dnd.Transfer;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;

import com.gx.obe.common.file.enumeration.FileConstants;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.tools.ole.vlc.RtmpVideoWindow;
import com.gx.tools.utils.QRCodeUtil;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

public class LivingAddressComposite extends Composite {

	private Label livingAddressLabel;
	private String livingAddress;
	private String title;
	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public LivingAddressComposite(Composite parent, int style, String livingAddress, String title) {
		super(parent, style);
		this.livingAddress = livingAddress;
		this.title = title;
		setLayout(new GridLayout(1, false));
		
		Label otherLivingLabel = new Label(this, SWT.NONE);
		otherLivingLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		otherLivingLabel.setFont(SWTResourceManager.getFont("微软雅黑", 14, SWT.NORMAL));
		otherLivingLabel.setAlignment(SWT.CENTER);
		otherLivingLabel.setText(title);
		
		livingAddressLabel = new Label(this, SWT.NONE);
		livingAddressLabel.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, true, 2, 1));
		
		Composite composite = new Composite(this, SWT.NONE);
		composite.setLayout(new GridLayout(2, false));
		composite.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 2, 1));
		
		ELink label_2 = new ELink(composite, SWT.NONE);
		label_2.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				viewLiving();
			}
		});
		label_2.setShowSubLine(false);
		label_2.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID,"icons/btn/blue/view.png"));
		label_2.setLayoutData(new GridData(SWT.CENTER, SWT.FILL, true, false, 1, 1));
		label_2.setFont(SWTResourceManager.getFont("微软雅黑", 11, SWT.NORMAL));
		label_2.setText("预览");
		
		ELink label_1 = new ELink(composite, SWT.NONE);
		label_1.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				copyAddress();
			}
		});
		label_1.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, false, 1, 1));
		label_1.setFont(SWTResourceManager.getFont("微软雅黑", 11, SWT.NORMAL));
		label_1.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/copy.png"));
		label_1.setText("复制");
		init();
	}
	/**
	 * 复制地址
	 */
	private void copyAddress(){
		Clipboard clipboard = new Clipboard(Display.getDefault()); 
		TextTransfer textTransfer = TextTransfer.getInstance(); 
			
			clipboard.setContents(new String[]{ title + "地址："+ livingAddress}, new Transfer[]{textTransfer}); 
		clipboard.dispose(); 
		MessageDialog.openShortMessage("直播地址已复制");
	}
	/**
	 * 初始化数据
	 */
	private void init(){
		try {
			livingAddressLabel.setImage(new Image(this.getDisplay(), QRCodeUtil.convertToSWT(QRCodeUtil.createImage(livingAddress, FileConstants.PRODUCT_ROOT.concat("icons/QRcode.png"), true))));
			livingAddressLabel.setImage(new Image(this.getDisplay(), QRCodeUtil.convertToSWT(QRCodeUtil.createImage(livingAddress, FileConstants.PRODUCT_ROOT.concat("icons/QRcode.png"), true))));
			this.layout();
		} catch (Exception e1) {
			e1.printStackTrace();
		}
	}
	
	/**
	 * 查看直播
	 */
	private void viewLiving(){
		RtmpVideoWindow dialog = new RtmpVideoWindow(title, livingAddress);
		dialog.open();
	}
	protected void checkSubclass() {
	}

}
