package com.gx.obe.opening.composite;

import java.text.SimpleDateFormat;
import java.util.Date;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.custom.StyleRange;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;

import com.gx.obe.ColorConstants;
import com.gx.obe.business.enumeration.SupplierEnum;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.config.ConfigConstants;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.StringUtils;
import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.SupplierOpeningResult;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

public class RemoteDecryptPackDetailComposite extends Composite {

	private final SimpleDateFormat timeFormat = new SimpleDateFormat("HH:mm:ss");
	private StyledText supplierNameLabel;
	private CLabel signPersonLabel;
	private CLabel signTimeLabel;
	private CLabel confirmStatusLabel;
	private CLabel confirmTimeLabel;
	private CLabel decryptStatusLabel;
	private Composite supplierSignComposite;
	private Composite supplierConfirmComposite;
	private boolean isPriceStage = false;
	private boolean isBusAndTecStage = false;
	private CLabel decTimeLabel;
	private Composite stackComposite;
	private boolean isShowConfirm = false;
	private boolean isFocus = false;
	private boolean isPreEvaluation = false;

	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 * @param signPersonLabel 
	 */
	public RemoteDecryptPackDetailComposite(Composite parent, int style) {
		super(parent, style);
		setBackgroundMode(SWT.INHERIT_FORCE);
//		setBackground(ColorConstants.SKIN_BG);
		GridLayout gridLayout = new GridLayout(3, false);
		gridLayout.horizontalSpacing = 0;
		gridLayout.verticalSpacing = 0;
		gridLayout.marginWidth = 1;
		gridLayout.marginHeight = 1;
		setLayout(gridLayout);
		if(null != parent.getData("isFocus")){
			isFocus = true;
		}

		Composite trComposite = new Composite(this, SWT.NONE);
		trComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		GridLayout gl_trComposite = new GridLayout(4, false);
		gl_trComposite.verticalSpacing = 0;
		gl_trComposite.marginHeight = 0;
		gl_trComposite.marginWidth = 0;
		trComposite.setLayout(gl_trComposite);
//		trComposite.setBackground(SWTResourceManager.getColor(249, 253, 254));
		
		Composite supplierNameComposite = new Composite(trComposite, SWT.NONE);
		GridLayout gl_supplierNameComposite = new GridLayout(2, false);
		gl_supplierNameComposite.marginWidth = 0;
		gl_supplierNameComposite.horizontalSpacing = 0;
		gl_supplierNameComposite.verticalSpacing = 10;
		supplierNameComposite.setLayout(gl_supplierNameComposite);
		GridData gd_supplierNameComposite = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_supplierNameComposite.widthHint = 200;
		gd_supplierNameComposite.minimumWidth = 200;
		supplierNameComposite.setLayoutData(gd_supplierNameComposite);
		
		supplierNameLabel = new StyledText(supplierNameComposite, SWT.READ_ONLY);
		supplierNameLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1));
		supplierNameLabel.setForeground(SWTResourceManager.getColor(50, 50, 20));
		supplierNameLabel.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.NORMAL));
		
		supplierSignComposite = new Composite(trComposite, SWT.NONE);
		GridData gd_supplierSignComposite = new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1);
		gd_supplierSignComposite.widthHint = 100;
		supplierSignComposite.setLayoutData(gd_supplierSignComposite);
		GridLayout gl_supplierSignComposite = new GridLayout(1, false);
		gl_supplierSignComposite.verticalSpacing = 0;
		gl_supplierSignComposite.marginHeight = 0;
		gl_supplierSignComposite.marginWidth = 0;
		supplierSignComposite.setLayout(gl_supplierSignComposite);
		
		signPersonLabel = new CLabel(supplierSignComposite, SWT.WRAP);
		signPersonLabel.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		signPersonLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1));
		signPersonLabel.setAlignment(SWT.CENTER);
		signPersonLabel.setText(Messages.SignInStatus_no);
		
		signTimeLabel = new CLabel(supplierSignComposite, SWT.WRAP | SWT.CENTER);
		signTimeLabel.setFont(SWTResourceManager.getFont("微软雅黑", 9, SWT.NORMAL));
		signTimeLabel.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, true, 1, 1));
		signTimeLabel.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		
		stackComposite = new Composite(trComposite, SWT.NONE);
		GridLayout gl_stackComposite = new GridLayout(1, false);
		gl_stackComposite.verticalSpacing = 0;
		gl_stackComposite.marginHeight = 0;
		gl_stackComposite.marginWidth = 0;
		stackComposite.setLayout(gl_stackComposite);
		GridData gd_stackComposite = new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1);
		gd_stackComposite.widthHint = 100;
		stackComposite.setLayoutData(gd_stackComposite);
		
		decryptStatusLabel = new CLabel(stackComposite, SWT.NONE);
		decryptStatusLabel.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		decryptStatusLabel.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, true, 1, 1));
		decryptStatusLabel.setText(Messages.Decrypt_no);
		
		decTimeLabel = new CLabel(stackComposite, SWT.WRAP | SWT.CENTER);
		decTimeLabel.setFont(SWTResourceManager.getFont("微软雅黑", 9, SWT.NORMAL));
		decTimeLabel.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, true, 1, 1));
		decTimeLabel.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		
		supplierConfirmComposite = new Composite(trComposite, SWT.NONE);
		GridData gd_supplierConfirmComposite = new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1);
		gd_supplierConfirmComposite.widthHint = 100;
		supplierConfirmComposite.setLayoutData(gd_supplierConfirmComposite);
		GridLayout gl_supplierConfirmComposite = new GridLayout(1, false);
		gl_supplierConfirmComposite.verticalSpacing = 0;
		gl_supplierConfirmComposite.marginHeight = 0;
		gl_supplierConfirmComposite.marginWidth = 0;
		supplierConfirmComposite.setLayout(gl_supplierConfirmComposite);
		
		confirmStatusLabel = new CLabel(supplierConfirmComposite, SWT.NONE);
		confirmStatusLabel.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		confirmStatusLabel.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, true, 1, 1));
		confirmStatusLabel.setText(Messages.Confirm_no);
		
		confirmTimeLabel = new CLabel(supplierConfirmComposite, SWT.WRAP | SWT.CENTER);
		confirmTimeLabel.setFont(SWTResourceManager.getFont("微软雅黑", 9, SWT.NORMAL));
		confirmTimeLabel.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, true, 1, 1));
		confirmTimeLabel.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		
		ESepator label = new ESepator(trComposite, SWT.NONE);
		label.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 4, 1));
		label.setBackground(SWTResourceManager.getColor(224, 224, 224));
		label.setLineWidth(2);
		label.setLineStyle(SWT.LINE_DOT);
		
		init();
	}
	
	
	
	private void init() {
		if(isFocus || PropertiesUtils.getProperty(ConfigConstants.SHOW_SIGN_INFO_STATUS, "01").equals("00")){
			((GridData)supplierSignComposite.getLayoutData()).exclude = true;
			supplierSignComposite.setVisible(false);
		}
		isShowConfirm = PropertiesUtils.getProperty(ConfigConstants.SHOW_CONFIRM_STATUS, "00").equals("01");
		if(!isShowConfirm){
			((GridData)supplierConfirmComposite.getLayoutData()).exclude = true;
			supplierConfirmComposite.setVisible(false);
		}
	}

	public void refresh(int index, TenderProjectEntity tenderPack, Supplier supplier, String bidopeningStage) {
		supplierNameLabel.setText(index +"、"+supplier.getSupplierName());
		SupplierOpeningResult supplierOpeningResult = supplier.getSupplierOpeningResult();
		if(null != tenderPack.getPhaseType() && tenderPack.getPhaseType().equals(TenderProjectEnum.PHASE_TYPE_PRE)){
			isPreEvaluation = true;
		}
		String msg = null;
		// 判断投标人是否废标
		if(StringUtils.equals(SupplierEnum.REVOKE_YES, supplierOpeningResult.getRevokeStatus())){
			msg = "   已废标";
		}
		if(null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_PRICE)){
			isPriceStage = true;
			if(StringUtils.isNotEmpty(tenderPack.getBusinessBidStatus()) && !tenderPack.getBusinessBidStatus().equals(CommonEnum.NOT_START)){
//			if(null != tenderPack.getBusinessBidStatus() && tenderPack.getBusinessBidStatus().equals(CommonEnum.COMPLETE)){
				
				if (null == supplierOpeningResult || null == supplierOpeningResult.getBusinessBidStatus() || !supplierOpeningResult.getBusinessBidStatus().equals(SupplierEnum.OPENBID_SUCCESS)) {
					msg = "   未参与商务标、技术标解密";
				}
			}
		}else if(null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_BUS_TEC)){
			isBusAndTecStage = true;
			if(null != tenderPack.getPriceBidStatus() && tenderPack.getPriceBidStatus().equals(CommonEnum.COMPLETE)){
				if (null == supplierOpeningResult || null == supplierOpeningResult.getPriceBidStatus() || !supplierOpeningResult.getPriceBidStatus().equals(SupplierEnum.OPENBID_SUCCESS)) {
					msg = "   未参与经济标解密";
				}
			}
		}
		if(null != msg){
			int start = supplierNameLabel.getText().length();
			supplierNameLabel.append(msg);
			StyleRange styleRange = new StyleRange(); 
			styleRange.start = start; 
			styleRange.length = msg.length(); 
			styleRange.foreground = SWTResourceManager.getColor(255, 50, 50);
			styleRange.fontStyle = SWT.NORMAL; 
			supplierNameLabel.setStyleRange(styleRange);
		}
		refreshSignState(supplier);
		refreshDecStatus(supplier);
		if(isShowConfirm){
			refreshConfirmStatus(supplier);
		}
	}

	private void refreshSignState(Supplier supplier) {
		Date signTime;
		String signPerson;
		if (isPriceStage) {
			signTime = supplier.getPriceSignTime();
			signPerson = supplier.getPriceSignPerson();
		} else {
			signTime = supplier.getSignTime();
			signPerson = supplier.getSignPerson();
		}
		if(null != signTime){
			signPersonLabel.setForeground(ColorConstants.FONT_BLACK_COLOR);
			signPersonLabel.setText(null != signPerson ? signPerson : Messages.Opening_signedIn);
			signTimeLabel.setText(timeFormat.format(signTime));
			((GridData)signTimeLabel.getLayoutData()).exclude = false;
			signTimeLabel.setVisible(true);
		}else {
			signPersonLabel.setText(Messages.SignInStatus_no);
			signPersonLabel.setForeground(SWTResourceManager.getColor(220, 220, 220));
			((GridData)signTimeLabel.getLayoutData()).exclude = true;
			signTimeLabel.setVisible(false);
		}
		supplierSignComposite.layout();
	}

	private void refreshConfirmStatus(Supplier supplier) {
		SupplierOpeningResult supplierOpeningResult = supplier.getSupplierOpeningResult();
		boolean isComplateBidOpening = false;
		Date confirmTime = null;
		String confirmStatus = "";
		String businessBidStatus = "";
		String technologyBidStatus = "";
		String priceBidStatus = "";
		if(null != supplierOpeningResult){
			businessBidStatus = supplierOpeningResult.getBusinessBidStatus();
			technologyBidStatus = supplierOpeningResult.getTechnologyBidStatus();
			priceBidStatus = supplierOpeningResult.getPriceBidStatus();
			if (isPriceStage) {
				confirmTime = supplierOpeningResult.getPriceConfirmTime();
				confirmStatus = supplierOpeningResult.getPriceConfirmStatus();
				if(StringUtils.isNotEmpty(priceBidStatus)){
					isComplateBidOpening = true;
				}
			} else {
				if(StringUtils.isNotEmpty(businessBidStatus)&& StringUtils.isNotEmpty(technologyBidStatus)){
					isComplateBidOpening = true;
				}
				confirmTime = supplierOpeningResult.getConfirmTime();
				confirmStatus = supplierOpeningResult.getConfirmStatus();
			}
		}
		
		if(isComplateBidOpening){
			if(SupplierEnum.CONFIRM_YES.equals(confirmStatus)){
				confirmStatusLabel.setCursor(null);
				confirmStatusLabel.setForeground(SWTResourceManager.getColor(80, 80, 80));
				confirmStatusLabel.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/ok.png"));
				confirmStatusLabel.setText(Messages.Confirm_yes);
			}else if(SupplierEnum.CONFIRM_TIME_OUT.equals(confirmStatus)){
				confirmStatusLabel.setCursor(null);
				confirmStatusLabel.setForeground(SWTResourceManager.getColor(255, 153, 0));
				confirmStatusLabel.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/warning.png"));
				confirmStatusLabel.setText(Messages.Confirm_timeOutAndNo);
			}else if(SupplierEnum.CONFIRM_QUESTION.equals(confirmStatus)){
				confirmStatusLabel.setCursor(SWTResourceManager.getCursor(SWT.CURSOR_HAND));
				confirmStatusLabel.setForeground(SWTResourceManager.getColor(255, 50, 50));
				confirmStatusLabel.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/question.png"));
				confirmStatusLabel.setText(Messages.Confirm_question);
			}else {
				confirmStatusLabel.setCursor(SWTResourceManager.getCursor(SWT.CURSOR_HAND));
				confirmStatusLabel.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/hourglass.png"));
				confirmStatusLabel.setForeground(SWTResourceManager.getColor(255, 153, 0));
				confirmStatusLabel.setText(Messages.Confirm_toBe);
			}
		}else {
			confirmStatusLabel.setImage(null);
			confirmStatusLabel.setForeground(SWTResourceManager.getColor(220, 220, 220));
			confirmStatusLabel.setText(Messages.Confirm_no);
		}
		if(null != confirmTime){
			confirmTimeLabel.setText(timeFormat.format(confirmTime));
			((GridData)confirmTimeLabel.getLayoutData()).exclude = false;
			confirmTimeLabel.setVisible(true);
		}else {
			((GridData)confirmTimeLabel.getLayoutData()).exclude = true;
			confirmTimeLabel.setVisible(false);
		}
		supplierConfirmComposite.layout();
	}

	private void refreshDecStatus(Supplier supplier) {
		SupplierOpeningResult supplierOpeningResult = supplier.getSupplierOpeningResult();
		String decBidStatus = "";
		Date decTime = supplierOpeningResult.getBidOpeningTime();
		if(null != supplierOpeningResult){
			decBidStatus = supplierOpeningResult.getBusinessBidStatus();
			if (isPriceStage) {
				decTime = supplierOpeningResult.getPriceBidOpeningTime();
				decBidStatus = supplierOpeningResult.getPriceBidStatus();
			}
		}
		if (SupplierEnum.OPENBID_SUCCESS.equals(decBidStatus) && SupplierEnum.OPENBID_SUCCESS.equals(decBidStatus)) {
			decryptStatusLabel.setText(Messages.Decrypt_yes);
			decryptStatusLabel.setForeground(SWTResourceManager.getColor(SWT.COLOR_DARK_GREEN));
			if(null != decTime){
				decTimeLabel.setText(timeFormat.format(decTime));
				((GridData)decTimeLabel.getLayoutData()).exclude = false;
				decTimeLabel.setVisible(true);
			}
			if(!isBusAndTecStage && !isPreEvaluation){
				if(null == supplierOpeningResult || null == supplierOpeningResult.getBidPrice()){
					decryptStatusLabel.setForeground(SWTResourceManager.getColor(255, 153, 0));
					decryptStatusLabel.setToolTipText(Messages.NoBidPrice);
				}
			}
		} else if (SupplierEnum.OPENBID_FIALE.equals(decBidStatus)) {
			decryptStatusLabel.setText(Messages.Decrypt_fail);
			decryptStatusLabel.setForeground(SWTResourceManager.getColor(SWT.COLOR_RED));
			if(null != decTime){
				decTimeLabel.setText(timeFormat.format(decTime));
				((GridData)decTimeLabel.getLayoutData()).exclude = false;
				decTimeLabel.setVisible(true);
			}
		} else {
			decryptStatusLabel.setText(Messages.Decrypt_no);
			decryptStatusLabel.setForeground(SWTResourceManager.getColor(220, 220, 220));
			((GridData)decTimeLabel.getLayoutData()).exclude = true;
			decTimeLabel.setVisible(false);
		}
		stackComposite.layout();
		
		
	}

	protected void checkSubclass() {}

}
