package com.gx.obe.opening.composite;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;
import java.util.Map;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.CallBack;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.widgets.EButton;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.custom.StyleRange;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.TraverseEvent;
import org.eclipse.swt.events.TraverseListener;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Text;

import com.gx.obe.ColorConstants;
import com.gx.obe.common.shell.FastReplysShell;
import com.gx.obe.message.Messages;
import com.gx.obe.opening.thread.GetBidOpeningNoticeListThread;
import com.gx.obe.opening.thread.SendNoticeThread;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.swtdesigner.SWTResourceManager;

public class SendBidOpeningMessageComposite extends Composite {

	private StyledText history_messgae_text;
	private Text noticeText;
	private TenderProjectEntity tenderProjectEntity;
	private String bidopeningStage;
	private SendNoticeThread sendNoticeThread;
	private StringBuilder sendMessage = new StringBuilder();
	private SimpleDateFormat format = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
	private EButton sendBtn;
	private StringBuffer tempMessgae = new StringBuffer();
	Color blue = SWTResourceManager.getColor(SWT.COLOR_BLUE);
	Color red = SWTResourceManager.getColor(SWT.COLOR_RED);
	private StyleRange title = new StyleRange();
	private StyleRange content = new StyleRange();
	private String stageIds;
	private Composite sendForm_compoite;
	private CLabel fastReplylabel;
	private Composite composite_1;
	private FastReplysShell fastReplysShell;

	/**
	 * Create the composite.
	 * 
	 * @param parent
	 * @param style
	 */
	public SendBidOpeningMessageComposite(Composite parent, int style) {
		super(parent, style);
		setBackground(ColorConstants.BORDER_LINE_COLOR);
		this.tenderProjectEntity = (TenderProjectEntity) parent.getData("tenderProjectEntity");
		this.bidopeningStage = (String) parent.getData("bidopeningStage");
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.marginHeight = 1;
		gridLayout.marginWidth = 1;
		gridLayout.verticalSpacing = 1;
		setLayout(gridLayout);

		Composite composite = new Composite(this, SWT.NONE);
		composite.setBackground(SWTResourceManager.getColor(237, 246, 250));
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		composite.setLayout(new GridLayout(1, false));
		history_messgae_text = new StyledText(composite, SWT.MULTI | SWT.READ_ONLY | SWT.WRAP);
		//		history_messgae_text.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		history_messgae_text.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));

		sendForm_compoite = new Composite(this, SWT.NONE);
		sendForm_compoite.setBackground(SWTResourceManager.getColor(237, 246, 250));
//		sendForm_compoite.setBackground(SWTResourceManager.getColor(250, 250, 250));
		GridData gd_sendForm_compoite = new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1);
		gd_sendForm_compoite.heightHint = 114;
		sendForm_compoite.setLayoutData(gd_sendForm_compoite);
		sendForm_compoite.setLayout(new GridLayout(1, false));

		noticeText = new Text(sendForm_compoite, SWT.WRAP);
		noticeText.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, true, 1, 1));
		noticeText.setTopIndex(8);
		noticeText.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		noticeText.setForeground(SWTResourceManager.getColor(SWT.COLOR_DARK_GREEN));
		GridData gd_noticeText = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_noticeText.heightHint = 114;
		noticeText.setLayoutData(gd_noticeText);

		
		composite_1 = new Composite(sendForm_compoite, SWT.NONE);
		GridLayout gl_composite_1 = new GridLayout(3, false);
		gl_composite_1.marginHeight = 1;
		gl_composite_1.marginWidth = 1;
		composite_1.setLayout(gl_composite_1);
		composite_1.setLayoutData(new GridData(SWT.RIGHT, SWT.FILL, true, false, 1, 1));
		
		
		EButton deleteBtn = new EButton(composite_1, SWT.NONE);
		GridData gd_deleteBtn = new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1);
		deleteBtn.setLayoutData(gd_deleteBtn);
		deleteBtn.setForeground(ColorConstants.SKIN_BG);
		deleteBtn.setText(Messages.Button_clear);
		deleteBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				noticeText.setText("");
			}
		});

		sendBtn = new EButton(composite_1, SWT.NONE);
		GridData gd_sendBtn = new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1);
		gd_sendBtn.widthHint = 90;
		sendBtn.setLayoutData(gd_sendBtn);
		sendBtn.setForeground(ColorConstants.SKIN_BG);
		sendBtn.setText(Messages.Button_send);
		sendBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				sendMessageAction();
			}
		});

		fastReplylabel = new CLabel(composite_1, SWT.NONE);
		fastReplylabel.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		fastReplylabel.setCursor(SWTResourceManager.getCursor(SWT.CURSOR_HAND));
		fastReplylabel.setForeground(ColorConstants.SKIN_BG);
		fastReplylabel.setText("∨");
		fastReplylabel.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				addFastReplyMessageAction();
			}
		});
		
		init();
	}

	private void init() {
		//		sendBtn.setEnabled(false);
		new Thread(new GetBidOpeningNoticeListThread(tenderProjectEntity, new CallBack() {
			public void callBackObject(Object obj) {
				initHistoryMessage((List<Map<String, String>>) obj);
			}

			public void after() {
				Display.getDefault().syncExec(new Runnable() {
					public void run() {
						if (sendBtn.isDisposed()) {
							return;
						}
						startSend();
						sendBtn.setEnabled(true);
					}
				});
			}
		})).start();

		noticeText.setFocus();

	}

	/**
	 * @Description: 初始化历史数据
	 * @author guoyr
	 * @param messageList
	 */
	private void initHistoryMessage(final List<Map<String, String>> messageList) {
		final StyleRange[] grf = new StyleRange[messageList.size() * 2];
		int index = 0;
		for (Map<String, String> messageMap : messageList) {
			sendMessage.append("\r\n");
			int startIndex = sendMessage.length();
			sendMessage.append(messageMap.get("sendTime"));
			int endIndex = sendMessage.length();
			grf[index++] = getStyleRange(startIndex, endIndex, blue, null);
			sendMessage.append("\r\n	");
			startIndex = sendMessage.length();
			sendMessage.append(messageMap.get("noticeContents"));
			endIndex = sendMessage.length();
			grf[index++] = getStyleRange(startIndex, endIndex, red, null);
		}
		Display.getDefault().syncExec(new Runnable() {
			public void run() {
				if (!history_messgae_text.isDisposed()) {
					history_messgae_text.setText(sendMessage.toString());
					history_messgae_text.replaceStyleRanges(0, sendMessage.length(), grf);
				}
			}
		});
	}

	private void startSend() {
		final Runnable sendNoticeRunnable = new Runnable() {
			public void run() {
				if (!history_messgae_text.isDisposed()) {
					if (null != tempMessgae && tempMessgae.length() > 0) {
						history_messgae_text.append(tempMessgae.toString());
						history_messgae_text.setSelection(history_messgae_text.getText().length());
						StyleRange[] style = new StyleRange[2];
						style[0] = title;
						style[1] = content;
						history_messgae_text.replaceStyleRanges(sendMessage.length() - tempMessgae.length(), tempMessgae.length(), style);
					}
				}
			}
		};
		sendNoticeRunnable.run();
		if (null == tenderProjectEntity) {
			sendBtn.setEnabled(false);
			return;
		}
		sendNoticeThread = new SendNoticeThread(tenderProjectEntity, bidopeningStage, new SendNoticeThread.SendListener() {
			public void sendMessage(boolean sendFlag, Date sendTime, String message) {
				int startIndex = sendMessage.length();
				tempMessgae = new StringBuffer();
				if (sendMessage.length() > 0) {
					sendMessage.append("\r\n");
					tempMessgae.append("\r\n");

				}
				if (sendFlag) {
					sendMessage.append(format.format(sendTime));
					tempMessgae.append(format.format(sendTime));
				} else {
					sendMessage.append(format.format(sendTime) + "  [消息发送失败]");
					tempMessgae.append(format.format(sendTime) + "  [消息发送失败]");
				}
				int endIndex = sendMessage.length();
				getStyleRange(startIndex, endIndex, blue, title);
				sendMessage.append("\r\n	");
				tempMessgae.append("\r\n	");
				startIndex = sendMessage.length();
				sendMessage.append(message);
				tempMessgae.append(message);
				endIndex = sendMessage.length();
				getStyleRange(startIndex, endIndex, red, content);
				Display.getDefault().asyncExec(sendNoticeRunnable);
			}
		});
		sendNoticeThread.start();
		// 加入加回车事件
		if (!noticeText.isDisposed()) {

			noticeText.addTraverseListener(new TraverseListener() {
				public void keyTraversed(TraverseEvent e) {
					if (e.keyCode == 13 || e.keyCode == 16777296) {
						sendMessageAction();
					}
				}
			});
		}
	}

	/**
	 * @Description: 发送消息内容
	 * @author guoyr
	 */
	private void sendMessageAction() {
		if (sendBtn.getEnabled()) {
			if (noticeText.getText().trim().length() > 0) {
				String message = noticeText.getText();
				if(null != sendNoticeThread){
					sendNoticeThread.sendNotice(stageIds, message);
					noticeText.setText("");
				}else{
					MessageDialog.openShortMessage("连接失败!");
				}
			} else {
				MessageDialog.openShortMessage("请输入发送内容！");
			}
		}
	}

	/**
	 * @Description: 选择快捷回复
	 * @author wangxiang
	 */
	private void addFastReplyMessageAction() {
		if (fastReplylabel.getEnabled()) {
			if(null != fastReplysShell && !fastReplysShell.isDisposed()){
				fastReplysShell.listFastReplys();
				fastReplysShell.showDialog();
			}else{
				Point this_Point = this.getParent().toDisplay(new Point(0, 0));
				Rectangle parentRectangle = this.getBounds();
				fastReplysShell = new FastReplysShell(getShell(), new CallBack() {
					@Override
					public void callBackString(String msg) {
						noticeText.setText(msg);
					}
				});
				fastReplysShell.listFastReplys();
				int height = fastReplysShell.computeSize(parentRectangle.width, SWT.DEFAULT).y;
				fastReplysShell.setSize(parentRectangle.width +100, this.getSize().y+40);
				fastReplysShell.setLocation(this_Point.x - fastReplysShell.getSize().x, this_Point.y);
				fastReplysShell.setAlpha(220);
				fastReplysShell.open();
			}
			
		}
	}

	private StyleRange getStyleRange(int startIndex, int endIndex, Color color, StyleRange messageStyleRange) {
		if (null == messageStyleRange) {
			messageStyleRange = new StyleRange();
		}
		messageStyleRange.start = startIndex;
		messageStyleRange.length = endIndex - startIndex;
		messageStyleRange.foreground = color;//SWTResourceManager.getColor(SWT.COLOR_RED);
		return messageStyleRange;
	}

	public void setTenderPackStageIds(String stageIds) {
		this.stageIds = stageIds;
	}

	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}

}
