package com.gx.obe.opening.composite;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.listener.ChangeTextListener;
import org.eclipse.swt.core.utils.SwtUtils;
import org.eclipse.swt.core.utils.WidgetUtils;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.core.widgets.ImageButton;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseTrackAdapter;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;

import com.gx.obe.ColorConstants;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.utils.MenuFunctionUtils;
import com.gx.obe.components.core.I18NEnum;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.listener.ProjectItemMouseEnterListener;
import com.gx.obe.message.Messages;
import com.gx.obe.opening.composite.SubPackageListComposite.PackageOpListener;
import com.gx.obe.util.utils.DateUtils;
import com.gx.obe.util.utils.ObjectUtils;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.vo.TenderProjectVo;
import com.gx.security.NowTimeUtils;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

/** 
 * @Description: 子包件项目界面 
 * @author guoyr 
 */
public class SubPackageItemComposite extends Composite {

	private Label indexLabel;
	private Label tenderNoLabel;
	private ELink tenderNameLabel;
	private CLabel phaseTypeLabel;
	private Label supplierCount_label;
	private Label supplierCountValue;
	private Label tenderTypeValueLabel;
	private Label tenderMethodValueLabel;
	private Label bidOpeningTimeValueLabel;
	private Label evalTimeValueLabel;
	public static final String  FORMAT = "yyyy-MM-dd HH:mm";
	private TenderProjectEntity tenderProjectEntity;
	private PackageOpListener listener;
	private ELink goto_btn;
	private ELink deleteBtn;
	private MenuFunctionUtils menuFunctions;
	private Composite openingStatusComposite;
	private Label openingStatusLabel;
	private ImageButton openingUploadStatusLabel;

	/** 
	 * @author guoyr
	 * @param parent
	 * @param style 
	 */
	public SubPackageItemComposite(Composite parent, MenuFunctionUtils menuFunctions, int style) {
		super(parent, style);
		this.menuFunctions = menuFunctions;
		setBackgroundMode(SWT.INHERIT_FORCE);
		setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.marginHeight = 2;
		gridLayout.marginWidth = 2;
		gridLayout.horizontalSpacing = 0;
		gridLayout.verticalSpacing = 0;
		setLayout(gridLayout);
	
		Composite composite = new Composite(this, SWT.NONE);
		composite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		composite.setLayout(new GridLayout(5, false));
		GridData gd_composite = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_composite.widthHint = 700;
		composite.setLayoutData(gd_composite);
		
		Composite composite_2 = new Composite(composite, SWT.NONE);
		composite_2.setBackgroundMode(SWT.INHERIT_FORCE);
		composite_2.setBackground(SWTResourceManager.getColor(255, 153, 51));
		composite_2.setLayout(new GridLayout(1, false));
		
		indexLabel = new Label(composite_2, SWT.NONE);
		indexLabel.setAlignment(SWT.CENTER);
		indexLabel.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.BOLD));
		indexLabel.setForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
//		label_1.setBackground(SWTResourceManager.getColor(255, 153, 51));
		indexLabel.setText("01");
		
		tenderNoLabel = new Label(composite, SWT.NONE);
		tenderNoLabel.setFont(SWTResourceManager.getFont("微软雅黑", 11, SWT.NORMAL));
		tenderNoLabel.setForeground(ColorConstants.FONT_BLACK_COLOR);
		tenderNoLabel.setForeground(SWTResourceManager.getColor(SWT.COLOR_BLACK));
		tenderNoLabel.setText("");
		
		tenderNameLabel = new ELink(composite, SWT.NONE);
		tenderNameLabel.setForeground(SWTResourceManager.getColor(SWT.COLOR_BLACK));
		tenderNameLabel.setFont(SWTResourceManager.getFont("微软雅黑", 11, SWT.NORMAL));
		tenderNameLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		tenderNameLabel.setText("");
		
		goto_btn = new ELink(composite, SWT.NONE);
		goto_btn.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		goto_btn.setActiveColor(SWTResourceManager.getColor(255, 153, 0));
		goto_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/goto.png"));
		goto_btn.setText(Messages.Enter);
		
		deleteBtn = new ELink(composite, SWT.NONE);
		deleteBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				deleteProjectAction();
			}
		});
		deleteBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/delete.png"));
		deleteBtn.setText(Messages.Button_delete);
		menuFunctions.addFunction(deleteBtn, "DELETE_PACKAGE");
		
		
		Label label = new Label(this, SWT.NONE);
		label.setBackground(SWTResourceManager.getColor(240, 240, 240));
		GridData gd_label = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_label.heightHint = 1;
		label.setLayoutData(gd_label);
		
		Composite composite_1 = new Composite(this, SWT.NONE);
		composite_1.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_composite_1 = new GridLayout(4, false);
		gl_composite_1.horizontalSpacing = 0;
		gl_composite_1.marginWidth = 0;
		gl_composite_1.marginHeight = 0;
		composite_1.setLayout(gl_composite_1);
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		menuFunctions.addFunction(composite_1, "PHASE_TYPE");
		
		phaseTypeLabel = new CLabel(composite_1, SWT.NONE);
		phaseTypeLabel.setAlignment(SWT.CENTER);
		GridData gd_phaseTypeLabel = new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1);
		gd_phaseTypeLabel.widthHint = 32;
		phaseTypeLabel.setLayoutData(gd_phaseTypeLabel);
		phaseTypeLabel.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/phase_type.png"));
		phaseTypeLabel.setText("");
		
		CLabel label_4 = new CLabel(composite_1, SWT.NONE);
		label_4.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/gv.png"));
		label_4.setText("");
		menuFunctions.addFunction(label_4, "COUNT");
		
		Composite infoComposite = new Composite(composite_1, SWT.NONE);
		GridLayout gl_infoComposite = new GridLayout(9, false);
		gl_infoComposite.marginWidth = 0;
		gl_infoComposite.marginHeight = 0;
		infoComposite.setLayout(gl_infoComposite);
		infoComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		Composite subPackCountComposite = new Composite(infoComposite, SWT.NONE);
		subPackCountComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		GridLayout gl_subPackCountComposite = new GridLayout(2, false);
		gl_subPackCountComposite.horizontalSpacing = 0;
		gl_subPackCountComposite.marginWidth = 0;
		gl_subPackCountComposite.marginHeight = 0;
		subPackCountComposite.setLayout(gl_subPackCountComposite);
		menuFunctions.addFunction(subPackCountComposite, "COUNT");
		
		supplierCount_label = new Label(subPackCountComposite, SWT.NONE);
		supplierCount_label.setText("投标人数：");
		supplierCount_label.setForeground(ColorConstants.FONT_BLACK_COLOR);
		
		supplierCountValue = new Label(subPackCountComposite, SWT.NONE);
		supplierCountValue.setForeground(SWTResourceManager.getColor(72, 152, 21));
		supplierCountValue.setText("2个");
		
		CLabel lab_5 = new CLabel(infoComposite, SWT.NONE);
		lab_5.setAlignment(SWT.CENTER);
		GridData gd_lab_5 = new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1);
		gd_lab_5.widthHint = 20;
		lab_5.setLayoutData(gd_lab_5);
		lab_5.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/v_gray.png"));
		lab_5.setText("");
		menuFunctions.addFunction(lab_5, "TENDER_TYPE");
		
		Composite tenderTypeComposite = new Composite(infoComposite, SWT.NONE);
		subPackCountComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		GridLayout gl_tenderTypeComposite = new GridLayout(2, false);
		gl_tenderTypeComposite.horizontalSpacing = 0;
		gl_tenderTypeComposite.marginWidth = 0;
		gl_tenderTypeComposite.marginHeight = 0;
		tenderTypeComposite.setLayout(gl_tenderTypeComposite);
		menuFunctions.addFunction(tenderTypeComposite, "TENDER_TYPE");
		
		Label tenderTypeLabel = new Label(tenderTypeComposite, SWT.NONE);
		tenderTypeLabel.setText(Messages.TenderType + "：");
		tenderTypeLabel.setForeground(ColorConstants.FONT_BLACK_COLOR);
		
		tenderTypeValueLabel = new Label(tenderTypeComposite, SWT.NONE);
		tenderTypeValueLabel.setForeground(SWTResourceManager.getColor(72, 152, 21));
		tenderTypeValueLabel.setText("政府采购");
		
		CLabel label_5 = new CLabel(infoComposite, SWT.NONE);
		label_5.setAlignment(SWT.CENTER);
		GridData gd_label_5 = new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1);
		gd_label_5.widthHint = 20;
		label_5.setLayoutData(gd_label_5);
		label_5.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/v_gray.png"));
		label_5.setText("");
		menuFunctions.addFunction(label_5, "TENDER_METHOD");
		
		Composite tenderMethodComposite = new Composite(infoComposite, SWT.NONE);
		subPackCountComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		GridLayout gl_tenderMethodComposite = new GridLayout(2, false);
		gl_tenderMethodComposite.horizontalSpacing = 0;
		gl_tenderMethodComposite.marginWidth = 0;
		gl_tenderMethodComposite.marginHeight = 0;
		tenderMethodComposite.setLayout(gl_tenderMethodComposite);
		menuFunctions.addFunction(tenderMethodComposite, "TENDER_METHOD");
		
		Label tenderMethodLabel = new Label(tenderMethodComposite, SWT.NONE);
		tenderMethodLabel.setText(Messages.TenderMethod+"：");
		tenderMethodLabel.setForeground(ColorConstants.FONT_BLACK_COLOR);
		
		tenderMethodValueLabel = new Label(tenderMethodComposite, SWT.NONE);
		tenderMethodValueLabel.setForeground(SWTResourceManager.getColor(72, 152, 21));
		tenderMethodValueLabel.setText("公开招标   ");
		
		CLabel label_6 = new CLabel(infoComposite, SWT.NONE);
		label_6.setAlignment(SWT.CENTER);
		GridData gd_label_6 = new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1);
		gd_label_6.widthHint = 20;
		label_6.setLayoutData(gd_label_6);
		label_6.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/v_gray.png"));
		label_6.setText("");
		menuFunctions.addFunction(label_6, "OPENING_TIME");
		
		Composite bidOpeningTimeComposite = new Composite(infoComposite, SWT.NONE);
		subPackCountComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		GridLayout gl_bidOpeningTimeComposite = new GridLayout(2, false);
		gl_bidOpeningTimeComposite.horizontalSpacing = 0;
		gl_bidOpeningTimeComposite.marginWidth = 0;
		gl_bidOpeningTimeComposite.marginHeight = 0;
		bidOpeningTimeComposite.setLayout(gl_bidOpeningTimeComposite);
		menuFunctions.addFunction(bidOpeningTimeComposite, "OPENING_TIME");
		
		Label bidOpeningTimeLabel = new Label(bidOpeningTimeComposite, SWT.NONE);
		bidOpeningTimeLabel.setText(Messages.BidOpeningTime+"：");
		bidOpeningTimeLabel.setForeground(ColorConstants.FONT_BLACK_COLOR);
		
		bidOpeningTimeValueLabel = new Label(bidOpeningTimeComposite, SWT.NONE);
		bidOpeningTimeValueLabel.setForeground(SWTResourceManager.getColor(72, 152, 21));
		bidOpeningTimeValueLabel.setText("2016-01-17 09:00");
		
		CLabel label_7 = new CLabel(infoComposite, SWT.NONE);
		label_7.setAlignment(SWT.CENTER);
		GridData gd_label_7 = new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1);
		gd_label_7.widthHint = 20;
		label_7.setLayoutData(gd_label_7);
		label_7.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/v_gray.png"));
		label_7.setText("");
		menuFunctions.addFunction(label_7, "OPENING_STATUS");
		
		openingStatusComposite = new Composite(infoComposite, SWT.NONE);
		subPackCountComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		GridLayout gl_openingStatusComposite = new GridLayout(3, false);
		gl_openingStatusComposite.horizontalSpacing = 0;
		gl_openingStatusComposite.marginWidth = 0;
		gl_openingStatusComposite.marginHeight = 0;
		openingStatusComposite.setLayout(gl_openingStatusComposite);
		menuFunctions.addFunction(openingStatusComposite, "OPENING_STATUS");
		
		Label bidOpeningStatusTitle = new Label(openingStatusComposite, SWT.NONE);
		bidOpeningStatusTitle.setText(Messages.BidOpeningStatus + ": ");
		bidOpeningStatusTitle.setForeground(ColorConstants.FONT_BLACK_COLOR);
		
		openingStatusLabel = new Label(openingStatusComposite, SWT.NONE);
		openingStatusLabel.setForeground(SWTResourceManager.getColor(100, 100, 100));
//		openingStatusLabel.setText(Messages.OpeningStatus_none);
		
		openingUploadStatusLabel = new ImageButton(openingStatusComposite, SWT.NONE);
		openingUploadStatusLabel.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/update.png"));
		
		CLabel label_8 = new CLabel(infoComposite, SWT.NONE);
		label_8.setAlignment(SWT.CENTER);
		GridData gd_label_8 = new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1);
		gd_label_8.widthHint = 20;
		label_8.setLayoutData(gd_label_8);
		label_8.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/v_gray.png"));
		label_8.setText("");
		menuFunctions.addFunction(label_8, "EVAL_TIME");
		
		Composite evalTimeComposite = new Composite(infoComposite, SWT.NONE);
		subPackCountComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		GridLayout gl_evalTimeComposite = new GridLayout(2, false);
		gl_evalTimeComposite.horizontalSpacing = 0;
		gl_evalTimeComposite.marginWidth = 0;
		gl_evalTimeComposite.marginHeight = 0;
		evalTimeComposite.setLayout(gl_evalTimeComposite);
		menuFunctions.addFunction(evalTimeComposite, "EVAL_TIME");
		
		Label evalTimeLabel = new Label(evalTimeComposite, SWT.NONE);
		evalTimeLabel.setText(Messages.EvaluationTime + ": ");
		evalTimeLabel.setForeground(ColorConstants.FONT_BLACK_COLOR);
		
		evalTimeValueLabel = new Label(evalTimeComposite, SWT.NONE);
		evalTimeValueLabel.setForeground(SWTResourceManager.getColor(72, 152, 21));
		evalTimeValueLabel.setText("2016-01-17 10:00");
		
		Composite composite_3 = new Composite(composite_1, SWT.NONE);
		composite_3.setLayout(new GridLayout(1, false));
		composite_3.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true, false, 1, 1));
		
		init();
	}

	/**
	 * @Description: 界面数据初始化
	 * @author guoyr 
	 */
	public void init(){
		ProjectItemMouseEnterListener myMouseTrackListener = new ProjectItemMouseEnterListener(this);
		setBackgroundColor(this, myMouseTrackListener);
		EnterListener enterListener = new EnterListener();
		tenderNoLabel.addMouseListener(new ChangeTextListener());
		tenderNameLabel.addMouseListener(enterListener);
		goto_btn.addMouseListener(enterListener);
		menuFunctions.refreshFunctionAuthority();
	}
	/**
	 * @Description: 递归设置当前面板的鼠标进入时整个面板的背景颜色
	 * @author guoyr
	 * @param targetComposite
	 * @param myMouseTrackListener 
	 */
	private void setBackgroundColor(Composite targetComposite, ProjectItemMouseEnterListener myMouseTrackListener){
		targetComposite.addMouseTrackListener(myMouseTrackListener);
		for(Control contrl : targetComposite.getChildren()){
			if(contrl instanceof Composite){
				setBackgroundColor((Composite)contrl, myMouseTrackListener);
			}else{
				contrl.addMouseTrackListener(myMouseTrackListener);
			}
		}
	}

	/**
	 * @Description:刷新界面子包件信息
	 * @author guoyr
	 * @param resultMap
	 */
	public void refresh(int index, TenderProjectEntity parentProject, TenderProjectVo tenderProjectVo){
		tenderProjectEntity = new TenderProjectEntity();
		tenderProjectEntity.setId(tenderProjectVo.getTenderId());
		tenderProjectEntity.setTenderNo(tenderProjectVo.getTenderNo());
		tenderProjectEntity.setTenderName(tenderProjectVo.getTenderName());
		tenderProjectEntity.setTenderType(tenderProjectVo.getTenderType());
		tenderProjectEntity.setPhaseType(tenderProjectVo.getPhaseType());
		tenderProjectEntity.setIsPack(tenderProjectVo.getIsPack());
		tenderProjectEntity.setTenderMethod(tenderProjectVo.getTenderMethod());
		tenderProjectEntity.setRemoteStatus(tenderProjectVo.getRemoteStatus());
		tenderProjectEntity.setBidOpeningStatus(tenderProjectVo.getBidOpeningStatus());
		tenderProjectEntity.setParentId(parentProject.getId());
		tenderProjectEntity.setParentProjectEntity(parentProject);
		if(index < 10){
			indexLabel.setText("0"+index);
		}else {
			indexLabel.setText(""+index);
		}
		supplierCount_label.setText(com.gx.obe.components.core.I18N.getString(I18NEnum.SUPPLIERNAME, tenderProjectEntity.getTenderType()) + "：");
		int supplierCount  = tenderProjectVo.getSupplierCount();
		if(supplierCount > 0){
			if(null != tenderProjectVo.getBidOpeningStartTime() && tenderProjectVo.getBidOpeningStartTime().after(NowTimeUtils.getNowDate())) {
				supplierCountValue.setText("*"+Messages.SupplierCouns);
			}else {
				supplierCountValue.setText(supplierCount+Messages.SupplierCouns);
			}
		}else {
			supplierCountValue.setText(Messages.None);
		}
		tenderProjectEntity.setSupplierCount(supplierCount);
		if(TenderProjectEnum.PHASE_TYPE_PRE.equals(tenderProjectVo.getPhaseType())){
			phaseTypeLabel.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/phase_type.png"));
		}else {
			phaseTypeLabel.setImage(null);
		}
		if(CommonEnum.COMPLETE.equals(tenderProjectVo.getBidOpeningStatus())){
			WidgetUtils.setControlVisible(deleteBtn, false);
		}
		tenderNoLabel.setText("["+tenderProjectEntity.getTenderNo() + "]");
		tenderNameLabel.setText(tenderProjectEntity.getTenderName());
		tenderTypeValueLabel.setText(TenderProjectEnum.getProjectTypeCN(tenderProjectEntity.getTenderType()));
		tenderMethodValueLabel.setText(TenderProjectEnum.getTenderMethodCN(tenderProjectEntity.getTenderMethod()));
		bidOpeningTimeValueLabel.setText(ObjectUtils.getObjString(DateUtils.getFormat(tenderProjectVo.getBidOpeningStartTime(), FORMAT)));
		openingStatusLabel.setText(ObjectUtils.getObjString(tenderProjectVo.getBidOpeningStatusCN()));
		if(CommonEnum.COMPLETE.equals(tenderProjectVo.getBidOpeningStatus())){
			openingStatusLabel.setForeground(SWTResourceManager.getColor(72, 152, 21));
			openingStatusLabel.setText(Messages.OpeningStatus_opend);
		}else if(CommonEnum.IN_PROGRESS.equals(tenderProjectVo.getBidOpeningStatus())){
			openingStatusLabel.setText(Messages.OpeningStatus_opening);
		}else {
			openingStatusLabel.setText(Messages.OpeningStatus_none);
		}
		if(CommonEnum.COMPLETE.equals(tenderProjectVo.getUploadOpeningResultStatus())){
			openingUploadStatusLabel.setEnabled(true);
		}else {
			openingUploadStatusLabel.setEnabled(false);
		}
		WidgetUtils.setControlVisible(deleteBtn, false);
		deleteBtn.setEnabled(false);
	}
	
	class MyMouseTrackListener extends MouseTrackAdapter{
		@Override
		public void mouseEnter(MouseEvent arg0) {
			setBackground(SWTResourceManager.getColor(255, 153, 51));
		}
		@Override
		public void mouseExit(MouseEvent e) {
			Point mousePoint = SwtUtils.getMouseLoaction();
			Point p = Display. getDefault ().map(SubPackageItemComposite.this, null , 0,0);
			if(new Rectangle(p.x + 5, p.y + 5, getBounds().width -10, getBounds().height -10).contains(mousePoint)){
			}else {
				setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
			}
		}
	}
	class EnterListener extends MouseAdapter{
		@Override
		public void mouseUp(MouseEvent e) {
			listener.enterPackage(tenderProjectEntity);
			super.mouseUp(e);
		}
	}
	
	/**
	 * @Description: 删除包件
	 * @author guoyr 
	 */
	private void deleteProjectAction(){
		if(deleteBtn.getVisible() && deleteBtn.getEnabled()) {
//			listener.deletePackage(tenderProjectEntity);
		}
	}
	
	public void addPackageOpListener(PackageOpListener listener){
		this.listener = listener;
	}
	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}
}
