package com.gx.obe.opening.composite;

import java.io.File;
import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.Date;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.CallBack;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.utils.SwtUtils;
import org.eclipse.swt.core.widgets.EOp;
import org.eclipse.swt.core.widgets.ImageButton;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.custom.StackLayout;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.ProgressBar;

import com.gx.obe.ColorConstants;
import com.gx.obe.business.entity.MenuFunction;
import com.gx.obe.business.enumeration.MenuFunctionEnum;
import com.gx.obe.business.enumeration.SupplierEnum;
import com.gx.obe.common.dialog.InputSupplierBidOpeningOpinionDialog;
import com.gx.obe.common.dialog.RevokeSupplierDialog;
import com.gx.obe.common.file.enumeration.FileConstants;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.dialog.MessageViewDialog;
import com.gx.obe.common.widget.utils.MenuFunctionUtils;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.config.ConfigConstants;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.message.Messages;
import com.gx.obe.opening.Activator;
import com.gx.obe.opening.listener.RemoteSupplierListener;
import com.gx.obe.opening.thread.DownloadSupplierBidPriceUtils;
import com.gx.obe.thread.DownloadRemoteBidOpeningQuestionThread;
import com.gx.obe.util.utils.DateUtils;
import com.gx.obe.util.utils.ObjectUtils;
import com.gx.obe.util.utils.RuntimeUtils;
import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.SupplierOpeningResult;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.service.SupplierOpeningResultService;
import com.gx.obe.web.service.TenderProjectService;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

public class SupplierRemoteDecryptComposite extends Composite implements RemoteSupplierListener{
	
	private ImageButton businessBid;
	private ImageButton technologyBid;
	private ImageButton priceBid;
	private ImageButton deccryptStatusBtn;
	private Supplier supplier;
	private Composite statusComposite;
	private ImageButton supplierStatusLabel;
	private Label signPersonLabel;
	private Label signTimeLabel;
	private Composite supplierSignComposite;
	private String onlineStatus;
	private Date confirmTime;
	private String confirmStatus;
	private String businessBidStatus;
	private String technologyBidStatus;
	private String priceBidStatus;
//	private String bidOpeningStatus;
	private Date signTime;
	private String signPerson;
	private String signPersonTel;
	private String signPersonCard;
	private Runnable onlineStatusRunnable;
	private Runnable confirmInfoRunnable;
	private Runnable signInfoRunnable;
	private CLabel confirmStatusLabel;
	private Label confirmTimeLabel;
	private final SimpleDateFormat timeFormat = new SimpleDateFormat("HH:mm:ss");
	private Composite progressComposite;
	private Composite stackComposite;
	private StackLayout stackLayout = new StackLayout();
	private ProgressBar progressBar;
	private Label messageLabel;
	private String bidopeningStage;
	private boolean isPriceStage = false;
	private boolean isComplateBidOpening = false;
	private boolean isPreEvaluation = false;
	private Composite supplierConfirmComposite;
	private EOp supplierOp;
	private TenderProjectEntity tenderProjectEntity;
	private Label supplierNameLabel;
	private boolean isFocus = false;
	private Composite trComposite;
	private GridData trGridData;
	public static int rowHeight = 45;
	private TenderProjectService tenderProjectService ;
	private MenuFunctionUtils menuFunctions;
	

	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public SupplierRemoteDecryptComposite(Composite parent, TenderProjectEntity tenderProjectEntity, Supplier supplier, MenuFunctionUtils menuFunctions, int style) {
		super(parent, style);
		this.tenderProjectEntity = tenderProjectEntity;
		this.supplier = supplier;
		this.menuFunctions = menuFunctions;
		if(null != parent.getData("isFocus")){
			isFocus = true;
		}
		GridLayout gridLayout = new GridLayout(3, false);
		gridLayout.horizontalSpacing = 0;
		gridLayout.verticalSpacing = 0;
		gridLayout.marginWidth = 1;
		gridLayout.marginHeight = 1;
		setLayout(gridLayout);
		
		trComposite = new Composite(this, SWT.NONE);
		trGridData = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		trComposite.setLayoutData(trGridData);
		GridLayout gl_trComposite = new GridLayout(4, false);
		gl_trComposite.marginWidth = 0;
		gl_trComposite.marginHeight = 0;
		trComposite.setLayout(gl_trComposite);
		
		Composite supplierNameComposite = new Composite(trComposite, SWT.NONE);
		GridLayout gl_supplierNameComposite = new GridLayout(2, false);
		gl_supplierNameComposite.marginHeight = 0;
		gl_supplierNameComposite.marginLeft = 5;
		gl_supplierNameComposite.marginWidth = 0;
		gl_supplierNameComposite.horizontalSpacing = 0;
		gl_supplierNameComposite.verticalSpacing = 0;
		supplierNameComposite.setLayout(gl_supplierNameComposite);
		GridData gd_supplierNameComposite = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_supplierNameComposite.widthHint = 200;
		gd_supplierNameComposite.minimumWidth = 200;
		supplierNameComposite.setLayoutData(gd_supplierNameComposite);
		
		supplierStatusLabel = new ImageButton(supplierNameComposite, SWT.NONE);
		supplierStatusLabel.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/online.png"));
		
		supplierNameLabel = new Label(supplierNameComposite, SWT.WRAP);
		supplierNameLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1));
		supplierNameLabel.setText(supplier.getSupplierName());
		supplierNameLabel.setForeground(SWTResourceManager.getColor(100, 100, 100));
		supplierNameLabel.setFont(SWTResourceManager.getFont("微软雅黑", 11, SWT.BOLD));
		
		supplierSignComposite = new Composite(trComposite, SWT.NONE);
		GridData gd_supplierSignComposite = new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1);
		gd_supplierSignComposite.widthHint = 90;
		supplierSignComposite.setLayoutData(gd_supplierSignComposite);
		GridLayout gl_supplierSignComposite = new GridLayout(1, false);
		gl_supplierSignComposite.verticalSpacing = 0;
		gl_supplierSignComposite.marginHeight = 0;
		gl_supplierSignComposite.marginWidth = 0;
		supplierSignComposite.setLayout(gl_supplierSignComposite);
		
		signPersonLabel = new Label(supplierSignComposite, SWT.WRAP);
		signPersonLabel.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		signPersonLabel.setForeground(SWTResourceManager.getColor(100, 100, 100));
		signPersonLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1));
		signPersonLabel.setAlignment(SWT.CENTER);
		signPersonLabel.setText(Messages.SignInStatus_no);
		
		signTimeLabel = new Label(supplierSignComposite, SWT.WRAP | SWT.CENTER);
		signTimeLabel.setFont(SWTResourceManager.getFont("微软雅黑", 9, SWT.NORMAL));
		signTimeLabel.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, true, 1, 1));
		signTimeLabel.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		
		supplierConfirmComposite = new Composite(trComposite, SWT.NONE);
		GridData gd_supplierConfirmComposite = new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1);
		gd_supplierConfirmComposite.widthHint = 100;
		supplierConfirmComposite.setLayoutData(gd_supplierConfirmComposite);
		GridLayout gl_supplierConfirmComposite = new GridLayout(1, false);
		gl_supplierConfirmComposite.verticalSpacing = 0;
		gl_supplierConfirmComposite.marginHeight = 0;
		gl_supplierConfirmComposite.marginWidth = 0;
		supplierConfirmComposite.setLayout(gl_supplierConfirmComposite);
		
		confirmStatusLabel = new CLabel(supplierConfirmComposite, SWT.NORMAL);
		confirmStatusLabel.setForeground(SWTResourceManager.getColor(100, 100, 100));
		confirmStatusLabel.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		confirmStatusLabel.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, true, 1, 1));
		confirmStatusLabel.setText(Messages.Confirm_no);
		
		confirmTimeLabel = new Label(supplierConfirmComposite, SWT.WRAP | SWT.CENTER);
		confirmTimeLabel.setFont(SWTResourceManager.getFont("微软雅黑", 9, SWT.NORMAL));
		confirmTimeLabel.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, true, 1, 1));
		confirmTimeLabel.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		
		stackComposite = new Composite(trComposite, SWT.NONE);
		stackComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		stackComposite.setLayout(stackLayout);
		
		statusComposite = new Composite(stackComposite, SWT.NONE);
		GridLayout gl_composite = new GridLayout(3, false);
		gl_composite.marginHeight = 0;
		gl_composite.marginWidth = 0;
		gl_composite.horizontalSpacing = 0;
		gl_composite.verticalSpacing = 0;
		statusComposite.setLayout(gl_composite);
		statusComposite.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, false, 1, 1));
		
		progressComposite = new Composite(stackComposite, SWT.NONE);
		GridLayout gl_progress_composite = new GridLayout(1, false);
		gl_progress_composite.marginHeight = 0;
		gl_progress_composite.marginWidth = 0;
		gl_progress_composite.horizontalSpacing = 0;
		gl_progress_composite.verticalSpacing = 0;
		progressComposite.setLayout(gl_progress_composite);
		
		messageLabel = new Label(progressComposite, SWT.NONE);
		messageLabel.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		messageLabel.setAlignment(SWT.CENTER);
		messageLabel.setLayoutData(new GridData(SWT.CENTER, SWT.BOTTOM, true, true, 1, 1));
		messageLabel.setText("正在远程解密中...");
		
		progressBar = new ProgressBar(progressComposite, SWT.SMOOTH | SWT.INDETERMINATE);
		GridData gd_progressBar = new GridData(SWT.FILL, SWT.TOP, true, true, 1, 1);
		gd_progressBar.widthHint = 100;
		gd_progressBar.heightHint = 4;
		progressBar.setLayoutData(gd_progressBar);
		tenderProjectService = new TenderProjectService();
		init();
	}
	
	/**
	 * @Description: 初台化
	 * @author guoyr 
	 */
	private void init(){
		stackLayout.topControl = statusComposite;
		supplierStatusLabel.setEnabled(false);
		if(TenderProjectEnum.PHASE_TYPE_PRE.equals(tenderProjectEntity.getPhaseType())){
			isPreEvaluation = true;
		}
		if(null != menuFunctions && MenuFunction.SHOW.equals(menuFunctions.getAuthority(MenuFunctionEnum.SHOW_OPENING_BID_DETAIL_STATUS))) {
			businessBid = addDecBidTypeBtn(Messages.BusinessBid, "");
			technologyBid = addDecBidTypeBtn(Messages.TechnologyBid, "");
			priceBid = addDecBidTypeBtn(Messages.EconomicBid, "");
			if(isPreEvaluation){
				if(PropertiesUtils.getProperty(ConfigConstants.HIDDEN_PREEVALUATION_PRICE, "01").equals("01")){
					((GridData)priceBid.getLayoutData()).exclude = true;
					priceBid.setVisible(false);
				}
			}
		}else {
			deccryptStatusBtn = addDecBidTypeBtn(Messages.Decrypt_no, "");
			deccryptStatusBtn.setMinWidth(100);
		}
		
		
		((GridData)confirmTimeLabel.getLayoutData()).exclude = true;
		confirmTimeLabel.setVisible(false);
		onlineStatusRunnable = new Runnable(){
			public void run(){
				if(!supplierStatusLabel.isDisposed()){
					if(null != onlineStatus && onlineStatus.equals("01")){
						if(!supplierStatusLabel.getEnabled()){
							supplierStatusLabel.setEnabled(true);
						}
					}else {
						if(supplierStatusLabel.getEnabled()){
							supplierStatusLabel.setEnabled(false);
						}
					}
				}
			}
		};
		signInfoRunnable = new Runnable(){
			public void run(){
				if(!signTimeLabel.isDisposed()){
					if(null != signTime){
						signPersonLabel.setForeground(ColorConstants.FONT_BLACK_COLOR);
						signPersonLabel.setText(null != signPerson ? signPerson : Messages.Opening_signedIn);
						signTimeLabel.setText(timeFormat.format(signTime));
						((GridData)signTimeLabel.getLayoutData()).exclude = false;
						signTimeLabel.setVisible(true);
					}else {
						signPersonLabel.setText(Messages.SignInStatus_no);
						signPersonLabel.setForeground(SWTResourceManager.getColor(220, 220, 220));
						((GridData)signTimeLabel.getLayoutData()).exclude = true;
						signTimeLabel.setVisible(false);
					}
					supplierSignComposite.layout();
				}
			}
		};
		signInfoRunnable.run();
		confirmInfoRunnable = new Runnable(){
			public void run(){
				if(!confirmStatusLabel.isDisposed()){
					
					if(isComplateBidOpening){
						if(null != confirmStatus && confirmStatus.equals(SupplierEnum.CONFIRM_YES)){
							confirmStatusLabel.setCursor(null);
							confirmStatusLabel.setForeground(SWTResourceManager.getColor(80, 80, 80));
							confirmStatusLabel.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/ok.png"));
							confirmStatusLabel.setText(Messages.Confirm_yes);
						}else if(null != confirmStatus && confirmStatus.equals(SupplierEnum.CONFIRM_TIME_OUT)){
							confirmStatusLabel.setCursor(null);
							confirmStatusLabel.setForeground(SWTResourceManager.getColor(255, 153, 0));
							confirmStatusLabel.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/warning.png"));
							confirmStatusLabel.setText(Messages.Confirm_timeOutAndNo);
						}else if(null != confirmStatus && confirmStatus.equals(SupplierEnum.CONFIRM_QUESTION)){
							confirmStatusLabel.setCursor(SWTResourceManager.getCursor(SWT.CURSOR_HAND));
							confirmStatusLabel.setForeground(SWTResourceManager.getColor(255, 50, 50));
							confirmStatusLabel.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/question.png"));
							confirmStatusLabel.setText(Messages.Confirm_question);
						}else {
							confirmStatusLabel.setCursor(SWTResourceManager.getCursor(SWT.CURSOR_HAND));
							confirmStatusLabel.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/hourglass.png"));
							confirmStatusLabel.setForeground(SWTResourceManager.getColor(255, 153, 0));
							confirmStatusLabel.setText(Messages.Confirm_toBe);
						}
					}else {
						confirmStatusLabel.setImage(null);
						confirmStatusLabel.setForeground(SWTResourceManager.getColor(220, 220, 220));
						confirmStatusLabel.setText(Messages.Confirm_no);
					}
					if(null != confirmTime){
						confirmTimeLabel.setText(timeFormat.format(confirmTime));
						((GridData)confirmTimeLabel.getLayoutData()).exclude = false;
						confirmTimeLabel.setVisible(true);
					}else {
						((GridData)confirmTimeLabel.getLayoutData()).exclude = true;
						confirmTimeLabel.setVisible(false);
					}
					supplierConfirmComposite.layout();
				
				}
			}
			
		};
		boolean hasBidPrice = false;
		SupplierOpeningResult supplierOpeningResult = supplier.getSupplierOpeningResult();
		if(null == supplierOpeningResult){
			supplierOpeningResult = new SupplierOpeningResult();
		}
		if(null != supplierOpeningResult.getBidPrice() && supplierOpeningResult.getBidPrice().compareTo(BigDecimal.ZERO) > 0){
			hasBidPrice = true;
		}
		refreshBidOpeningStatus(supplier, bidopeningStage, supplierOpeningResult.getBusinessBidStatus(), supplierOpeningResult.getTechnologyBidStatus(), supplierOpeningResult.getPriceBidStatus(), hasBidPrice);
		
		confirmStatusLabel.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				opAction();
			}
		});
		
		supplierNameLabel.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				supplierOpAction();
			}
		});
		// 为废标的投标人名称上添加删除线
		supplierNameLabel.addPaintListener(new PaintListener() {
			public void paintControl(PaintEvent paint) {
				SupplierOpeningResult supplierOpeningResult = supplier.getSupplierOpeningResult();
				if(null != supplierOpeningResult && null != supplierOpeningResult.getRevokeStatus() && supplierOpeningResult.getRevokeStatus().equals(SupplierEnum.REVOKE_YES)){
					int width = SwtUtils.getStringWidth(supplierNameLabel, supplierNameLabel.getText());
					int height = paint.gc.getFontMetrics().getHeight()/2;
					paint.gc.setLineWidth(8);
					paint.gc.setAlpha(100);
					paint.gc.setForeground(SWTResourceManager.getColor(SWT.COLOR_RED));
					paint.gc.drawLine(0, height, width, height);
				}
			
				paint.gc.dispose();
			}
		});
		addPaintListener(new PaintListener() {
			public void paintControl(PaintEvent arg0) {
				Rectangle rectangle = getBounds();
				arg0.gc.setForeground(SWTResourceManager.getColor(200, 200, 200));
				arg0.gc.setLineWidth(3);
				arg0.gc.setLineStyle(SWT.LINE_DOT);
				arg0.gc.drawRectangle(0, 0, rectangle.width -1, rectangle.height -1);
			}
		});
		
		// 查看签到信息
		MouseAdapter signMouseListener = new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				if(null != signTime) {
					StringBuilder content = new StringBuilder();
					if(null != signPerson) {
						content.append(Messages.SignerName).append(":").append(signPerson);
					}
					content.append("\r\n").append(Messages.CheckInTime).append(":").append(DateUtils.getTimestampFormat(signTime));
					if(null != signPersonTel) {
						content.append("\r\n").append(Messages.LinkerTel).append(":").append(signPersonTel);
					}
					MessageDialog.openShortMessage(content.toString());
				}
			}
		};
		signPersonLabel.addMouseListener(signMouseListener);
		signTimeLabel.addMouseListener(signMouseListener);
		
		if(isFocus || PropertiesUtils.getProperty(ConfigConstants.SHOW_SIGN_INFO_STATUS, "01").equals("00")){
			((GridData)supplierSignComposite.getLayoutData()).exclude = true;
			supplierSignComposite.setVisible(false);
		}
		
		if(PropertiesUtils.getProperty(ConfigConstants.SHOW_CONFIRM_STATUS, "00").equals("00")){
			((GridData)supplierConfirmComposite.getLayoutData()).exclude = true;
			supplierConfirmComposite.setVisible(false);
		}
//		rowHeight = trComposite.getBounds().height + 2;
	}
	
	private ImageButton addDecBidTypeBtn(final String title, String status){
		final ImageButton label = new ImageButton(statusComposite, SWT.BOTTOM);
		label.setTopMargin(0);
		label.setBottomMargin(0);
		label.setGAP(-3);
		label.setText(title);
		label.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/undec.png"));
		label.setForeground(ColorConstants.FONT_BLACK_COLOR);
		label.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		label.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, true, 1, 1));
		label.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				SupplierOpeningResult supplierOpeningResult = supplier.getSupplierOpeningResult();
				if(null != supplierOpeningResult){
					if(title.equals(Messages.EconomicBid)){
						if(null != supplierOpeningResult.getPriceBidOpeningTime()){
							MessageDialog.openShortMessage(DateUtils.getTimestampFormat(supplierOpeningResult.getPriceBidOpeningTime()));
						}
					}else {
						if(null != supplierOpeningResult.getBidOpeningTime()){
							MessageDialog.openShortMessage(DateUtils.getTimestampFormat(supplierOpeningResult.getBidOpeningTime()));
						}
					}
				}
			}
		});
		return label;
	}
	
	private void refreshStatus(ImageButton businessBid, String status){
		if(null != status && status.equals(SupplierEnum.OPENBID_SUCCESS)){
			businessBid.setForeground(SWTResourceManager.getColor(SWT.COLOR_DARK_GREEN));
			businessBid.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/decSuccess.png"));
		}else if(null != status && status.equals(SupplierEnum.OPENBID_FIALE)){
			businessBid.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/decFail.png"));
			businessBid.setForeground(SWTResourceManager.getColor(SWT.COLOR_RED));
		}else {
			businessBid.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/undec.png"));
			businessBid.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		}
		businessBid.redraw();
	}
	
	/**
	 * @Description: 刷新状态
	 * @author guoyr
	 * @param businessBidStatus
	 * @param technologyBidStatus
	 * @param priceBidStatus 
	 */
	public void refreshBidOpeningStatus(Supplier supplier, String bidopeningStage, final String businessBidStatus, final String technologyBidStatus, final String priceBidStatus, final boolean hasBidPrice){
		this.supplier = supplier;
		this.bidopeningStage = bidopeningStage;
		this.businessBidStatus = businessBidStatus;
		this.technologyBidStatus = technologyBidStatus;
		this.priceBidStatus = priceBidStatus;
		if(null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_PRICE)){
			isPriceStage = true;
		}else {
			isPriceStage = false;
		}
		boolean _isComplateBidOpening = isComplateBidOpening;
		
		if(isPriceStage){
			if(null != priceBidStatus && priceBidStatus.length() > 0){
				isComplateBidOpening = true;
			}else {
				isComplateBidOpening = false;
			}
		}else {
			if(null != businessBidStatus && businessBidStatus.length() > 0 && null != technologyBidStatus && technologyBidStatus.length() > 0){
				isComplateBidOpening = true;
			}else {
				isComplateBidOpening = false;
			}
		}
		// 如果在开标过程中，如果是完成开标，则需要刷新确认状态
		if(!_isComplateBidOpening && isComplateBidOpening){
			Display.getDefault().syncExec(confirmInfoRunnable);
		}
		Display.getDefault().syncExec(new Runnable(){
			public void run(){
				if(!statusComposite.isDisposed()){
					if(null != deccryptStatusBtn) {
						deccryptStatusBtn.setSubImage(null);
						if(isPriceStage) {
							if(SupplierEnum.OPENBID_SUCCESS.equals(priceBidStatus)){
								SupplierOpeningResult supplierOpeningResult = supplier.getSupplierOpeningResult();
								if(null != supplierOpeningResult && null != supplierOpeningResult.getPriceBidOpeningTime()){
									deccryptStatusBtn.setText(timeFormat.format(supplierOpeningResult.getPriceBidOpeningTime()));
								}else {
									deccryptStatusBtn.setText(Messages.Decrypt_success);
								}
								// 如果是经济标开标成功，但没有报价时，则显示为红色
								if(!hasBidPrice){
									deccryptStatusBtn.setForeground(SWTResourceManager.getColor(255, 153, 0));
									deccryptStatusBtn.setSubTextHorAlign(SWT.RIGHT);
									deccryptStatusBtn.setSubTextVerAlign(SWT.BOTTOM);
									deccryptStatusBtn.setSubTextSurroundColor(SWTResourceManager.getColor(255, 0, 0));
									deccryptStatusBtn.setSubTextSurroundAlpha(180);
									deccryptStatusBtn.setSubTextForeground(SWTResourceManager.getColor(255, 255, 255));
									deccryptStatusBtn.setSubTextFont(SWTResourceManager.getFont("微软雅黑", 8, SWT.NORMAL));
									deccryptStatusBtn.setSubTextBottomtMargin(-1);
									deccryptStatusBtn.setSubText("无报价");
								}
							}else if(SupplierEnum.OPENBID_FIALE.equals(priceBidStatus)){
								deccryptStatusBtn.setText(Messages.Decrypt_fail);
							}else {
								deccryptStatusBtn.setText(Messages.Decrypt_no);
							}
							
							refreshStatus(deccryptStatusBtn, priceBidStatus);
						}else {
							if(SupplierEnum.OPENBID_SUCCESS.equals(businessBidStatus)){
								SupplierOpeningResult supplierOpeningResult = supplier.getSupplierOpeningResult();
								if(null != supplierOpeningResult && null != supplierOpeningResult.getBidOpeningTime()){
									deccryptStatusBtn.setText(timeFormat.format(supplierOpeningResult.getBidOpeningTime()));
								}else {
									deccryptStatusBtn.setText(Messages.Decrypt_success);
								}
								// 如果是经济标已解密（不分阶段时），则显示为红色
								if(SupplierEnum.OPENBID_SUCCESS.equals(priceBidStatus) && !isPreEvaluation && !hasBidPrice) {
									deccryptStatusBtn.setForeground(SWTResourceManager.getColor(255, 153, 0));
									deccryptStatusBtn.setSubTextHorAlign(SWT.RIGHT);
									deccryptStatusBtn.setSubTextVerAlign(SWT.BOTTOM);
									deccryptStatusBtn.setSubTextSurroundColor(SWTResourceManager.getColor(255, 0, 0));
									deccryptStatusBtn.setSubTextSurroundAlpha(180);
									deccryptStatusBtn.setSubTextForeground(SWTResourceManager.getColor(255, 255, 255));
									deccryptStatusBtn.setSubTextFont(SWTResourceManager.getFont("微软雅黑", 8, SWT.NORMAL));
									deccryptStatusBtn.setSubTextBottomtMargin(-1);
									deccryptStatusBtn.setSubText("无报价");
								}
							}else if(SupplierEnum.OPENBID_FIALE.equals(businessBidStatus)){
								deccryptStatusBtn.setText(Messages.Decrypt_fail);
							}else {
								deccryptStatusBtn.setText(Messages.Decrypt_no);
							}
							
							refreshStatus(deccryptStatusBtn, businessBidStatus);
						}
					}else {
						priceBid.setSubImage(null);
						if(null != priceBidStatus && priceBidStatus.equals(SupplierEnum.OPENBID_SUCCESS) && !isPreEvaluation){
							if(!hasBidPrice){
								priceBid.setForeground(SWTResourceManager.getColor(255, 153, 0));
								priceBid.setSubImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/tray_close.png"));
								
							}
						}
						refreshStatus(businessBid, businessBidStatus);
						refreshStatus(technologyBid, technologyBidStatus);
						refreshStatus(priceBid, priceBidStatus);
					}
					statusComposite.layout();
					stackLayout.topControl = statusComposite;
					stackComposite.layout();
				}
			}
		});
	}
	
	/**
	 * @Description: 显示开标解密状态
	 * @author guoyr 
	 */
	public void showStatus(){
		Display.getDefault().syncExec(new Runnable(){
			public void run(){
				if(!progressComposite.isDisposed()){
					stackLayout.topControl = statusComposite;
					stackComposite.layout();
				}
			}
		});
	}
	/**
	 * @Description: 显示进度
	 * @author guoyr 
	 */
	public void showProgress(){
		Display.getDefault().syncExec(new Runnable(){
			public void run(){
				if(!progressComposite.isDisposed()){
					stackLayout.topControl = progressComposite;
					stackComposite.layout();
				}
			}
		});
	}
	@Override
	protected void checkSubclass() {
	}

	/** 
	 * @Description: 刷新在线状态
	 * @author guoyr
	 * @param onlineStatus 
	 */
	public void refreshOnlineStatus(String onlineStatus) {
		this.onlineStatus = onlineStatus;
		Display.getDefault().syncExec(onlineStatusRunnable);
	}

	/** 
	 * @Description: 刷新确认信息
	 * @author guoyr
	 * @param confirmTime
	 * @param confirmStatus 
	 */
	public void refreshConfirmInfo(Date confirmTime, String confirmStatus) {
		this.confirmTime = confirmTime;
		this.confirmStatus = confirmStatus;
		Display.getDefault().syncExec(confirmInfoRunnable);
	}
	
	public void setShowSignInfoStatus(boolean showSignInfoStatus){
		((GridData)supplierSignComposite.getLayoutData()).exclude = !showSignInfoStatus;
		supplierSignComposite.setVisible(showSignInfoStatus);
		supplierSignComposite.getParent().layout();
	}
	
	public void setShowComfirmStatus(boolean showConfrim){
		((GridData)supplierConfirmComposite.getLayoutData()).exclude = !showConfrim;
		supplierConfirmComposite.setVisible(showConfrim);
		supplierConfirmComposite.getParent().layout();
	}
	public void setShowPriceStatus(boolean showPriceStatus){
		if(null != priceBid) {
			((GridData)priceBid.getLayoutData()).exclude = !showPriceStatus;
			priceBid.setVisible(showPriceStatus);
			priceBid.getParent().layout();
		}
	}

	/** 
	 * @Description: 刷新签到信息
	 * @author guoyr
	 * @param signTime
	 * @param signPerson
	 * @param signPersonTel
	 * @param signPersonCard 
	 */
	public void refreshSignInfo(Date signTime, String signPerson, String signPersonTel, String signPersonCard) {
		this.signTime = signTime;
		this.signPerson = signPerson;
		this.signPersonTel = signPersonTel;
		this.signPersonCard = signPersonCard;
		Display.getDefault().syncExec(signInfoRunnable);
	}

	private void opAction(){
		if(!isComplateBidOpening){
			return;
		}
		EOp op = null;
		if(null == confirmStatus || confirmStatus.length() == 0){
			op = new EOp(getShell());
			op.addOpItem("超时确认", ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/hourglass.png"), true, new EOp.ClickListener() {
				public void click() {
				}
			});
			if(null != op){
				op.setForeground(SWTResourceManager.getColor(80, 80, 80));
				op.setBackground(SWTResourceManager.getColor(60, 138, 226));
//				op.setAlpha(200);
				op.open(confirmStatusLabel);
			}
		}else if(null != confirmStatus && confirmStatus.equals(SupplierEnum.CONFIRM_QUESTION)){
			op = new EOp(getShell());
			op.addOpItem("查看质疑", ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/open.png"), true, new EOp.ClickListener() {
				public void click() {
					final File supplierQuestinFile = new File(FileConstants.getBidFileQuestionPath(supplier.getTenderId(), supplier.getId()) + supplier.getId() + "_"+bidopeningStage+".pdf");
					
					if(null != supplierQuestinFile && supplierQuestinFile.exists()){
						RuntimeUtils.openFIle(supplierQuestinFile);
					}else {
						final TenderProjectEntity tenderProjectEntity = tenderProjectService.getById(supplier.getTenderId());
						if(null != tenderProjectEntity){
							DownloadRemoteBidOpeningQuestionThread downloadBidOpeningQuestionThread = new DownloadRemoteBidOpeningQuestionThread(tenderProjectEntity, supplier, bidopeningStage, new CallBack(){
								public void after() {
									if(null != supplierQuestinFile && supplierQuestinFile.exists()){
										RuntimeUtils.openFIle(supplierQuestinFile);
									}else {
										Display.getDefault().syncExec(new Runnable(){
											public void run(){
												if(!confirmStatusLabel.isDisposed()){
													MessageDialog.openShortMessage("未获取到质疑文件！");
												}
											}
										});
									}
								}
							});
							downloadBidOpeningQuestionThread.start();
						}
					}
				}
			});
			if(null != op){
				op.setForeground(SWTResourceManager.getColor(80, 80, 80));
				op.setBackground(SWTResourceManager.getColor(60, 138, 226));
//				op.setAlpha(200);
				op.open(confirmStatusLabel);
			}
		}
		
	}
	
	/**
	 * @Description: 
	 * @author guoyr 
	 */
	private void supplierOpAction(){
		final SupplierOpeningResult supplierOpeningResult = supplier.getSupplierOpeningResult();
		supplierOp = new EOp(getShell());
		supplierOp.setForeground(SWTResourceManager.getColor(80, 80, 80));
		supplierOp.addOpItem("解密详情", ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/message.png"), true, new EOp.ClickListener() {
			public void click() {
				if(null != supplierOpeningResult.getBidOpeningRecord() && supplierOpeningResult.getBidOpeningRecord().length() > 0){
					MessageDialog.openMessage(getShell(), supplierOpeningResult.getBidOpeningRecord());
				}
			}
		});

		
		// 已经废标
		if(null != supplierOpeningResult && null != supplierOpeningResult.getRevokeStatus() && supplierOpeningResult.getRevokeStatus().equals(SupplierEnum.REVOKE_YES)){
			
			supplierOp.addOpItem("取消废标", ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/refresh.png"), true, new EOp.ClickListener() {
				public void click() {
					if(MessageDialog.openConfirm(getShell(),"取消废标", supplier.getSupplierName()+"已废标\r\n废标原因：\r\n    "+ObjectUtils.getObjString(supplierOpeningResult.getRevokeReason())+"\r\n\r\n确认要取消废标吗？", "取消废标")){
						SupplierOpeningResultService supplierOpeningResultService = new SupplierOpeningResultService();
						supplierOpeningResult.setRevokeStatus(SupplierEnum.REVOKE_NO);
						supplierOpeningResult.setRevokeReason("");
						supplierOpeningResultService.updateAssignProperty(supplierOpeningResult,  new String[]{"revokeStatus","revokeReason"});
						supplierNameLabel.redraw();
					}
				}
			});
		}else {
			supplierOp.addOpItem("废标", ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/delete.png"), true, new EOp.ClickListener() {
				public void click() {

					final RevokeSupplierDialog dialog = new RevokeSupplierDialog(getShell(), tenderProjectEntity, supplier, new RevokeSupplierDialog.RevokeSupplierListener() {
						public void revoke(boolean revoke, SupplierOpeningResult supplierOpeningResult) {
							supplier.setSupplierOpeningResult(supplierOpeningResult);
							supplierNameLabel.redraw();
						}
					});
					dialog.setTitle("废标");
					dialog.open();
				}
			});
		}
		
		supplierOp.addOpItem("录入"+TenderProjectEnum.getOpenBidEnum(tenderProjectEntity.getPhaseType()) +"意见", ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/edit.png"), true, new EOp.ClickListener() {
			public void click() {
				final InputSupplierBidOpeningOpinionDialog dialog = new InputSupplierBidOpeningOpinionDialog(getShell(), tenderProjectEntity, supplier, supplierOpeningResult);
				dialog.setTitle("录入"+TenderProjectEnum.getOpenBidEnum(tenderProjectEntity.getPhaseType()) +"意见");
				dialog.open();
			}
		});
		supplierOp.addOpItem(Messages.Button_syncQuoteInfo, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/download.png"), true, new EOp.ClickListener() {
			public void click() {
				final MessageViewDialog dialog = new MessageViewDialog(getShell(),-1);
				dialog.setTitle(Messages.Button_syncQuoteInfo);
				DownloadSupplierBidPriceUtils downloadSupplierBidPriceUtils = new DownloadSupplierBidPriceUtils(tenderProjectEntity);
				downloadSupplierBidPriceUtils.downloadBidPrice(supplier, new CallBack(){
					public void callBackString(String msg) {
						dialog.getCallBack().callBackString(msg);
					}

					public void after() {
						dialog.getCallBack().after();
					}

					public void callBackBoolean(boolean bool) {
						SupplierOpeningResult supplierOpeningResult = supplier.getSupplierOpeningResult();
						boolean hasBidPrice = false;
						if(null != supplierOpeningResult && null != supplierOpeningResult.getBidPrice() && supplierOpeningResult.getBidPrice().compareTo(BigDecimal.ZERO) > 0){
							hasBidPrice = true;
						}
						refreshBidOpeningStatus(supplier, bidopeningStage, businessBidStatus, technologyBidStatus, SupplierEnum.OPENBID_SUCCESS, hasBidPrice);
					}
					
				});
				dialog.open();
			}
		});
	
		supplierOp.setBackground(SWTResourceManager.getColor(60, 138, 226));
		supplierOp.setAlpha(200);
		supplierOp.open(supplierNameLabel);
	}
	public int getRowHeight(){
		return rowHeight;
	}
	public void setRowHeight(int height){
		if(height > 70){
			height = 70;
		}
		trGridData.heightHint = height -2;
	}
	public String getBusinessBidStatus() {
		return businessBidStatus;
	}

	public String getTechnologyBidStatus() {
		return technologyBidStatus;
	}

	public String getPriceBidStatus() {
		return priceBidStatus;
	}

	public Supplier getSupplier(){
		return this.supplier;
	}
	public boolean isDescryComplate(){
		return isComplateBidOpening;
	}
}
