package com.gx.obe.opening.composite;

import java.text.MessageFormat;
import java.util.Date;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.listener.VerifyCardIdListener;
import org.eclipse.swt.core.listener.VerifyPhoneListener;
import org.eclipse.swt.core.listener.VerifyValueListener;
import org.eclipse.swt.core.utils.ValidateUtils;
import org.eclipse.swt.core.widgets.EButton;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.events.VerifyEvent;
import org.eclipse.swt.events.VerifyListener;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Text;

import com.gx.obe.ColorConstants;
import com.gx.obe.business.enumeration.SupplierEnum;
import com.gx.obe.common.file.thread.CheckHttpBidFileThread;
import com.gx.obe.message.Messages;
import com.gx.obe.opening.Activator;
import com.gx.obe.opening.listener.SupplierSignListener;
import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.tools.ca.CACert;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

/** 
 * @Description: 投标人签到
 * @author guoyr 
 */
public class SupplierSignComposite extends Composite {

	private Label projectNameLabel;
	private Label supplierMessage;
	private Text signPersonText;
	private Text personIDCard;
	private Text signPersonTelText;
	private EButton signButton;
	private TenderProjectEntity tenderProjectEntity;
	private Supplier supplier;
	private CACert caCert;
	private Label packNameLabel;
	private SupplierSignListener supplierSignListener;
	private Button importBtn;
	private Button onLineBtn;
	private Button paperBtn;
	private CheckHttpBidFileThread checkSupplierBidFileThread;

	/** 
	 * @author guoyr
	 * @param parent
	 * @param style 
	 */
	public SupplierSignComposite(Composite parent, int style) {
		super(parent, style);
		setLayout(new GridLayout(1, false));
		
		Composite composite = new Composite(this, SWT.NONE);
		composite.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, true, 1, 1));
		composite.setLayout(new GridLayout(1, false));
		
		Composite composite_6 = new Composite(composite, SWT.NONE);
		composite_6.setLayout(new GridLayout(1, false));
		composite_6.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		projectNameLabel = new Label(composite_6, SWT.CENTER);
		projectNameLabel.setText("[项目编号]项目名称");
		projectNameLabel.setAlignment(SWT.CENTER);
		projectNameLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		projectNameLabel.setFont(SWTResourceManager.getFont("微软雅黑", 18, SWT.BOLD));
		projectNameLabel.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		
		packNameLabel = new Label(composite_6, SWT.CENTER);
		packNameLabel.setFont(SWTResourceManager.getFont("微软雅黑", 15, SWT.NORMAL));
		packNameLabel.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		packNameLabel.setText(Messages.PackageNumAndName);
		packNameLabel.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		
		Composite composite_7 = new Composite(composite, SWT.NONE);
		GridLayout gl_composite_7 = new GridLayout(1, false);
		gl_composite_7.marginHeight = 30;
		composite_7.setLayout(gl_composite_7);
		composite_7.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		
		supplierMessage = new Label(composite_7, SWT.NONE);
		supplierMessage.setText("投标人名称");
		supplierMessage.setAlignment(SWT.CENTER);
		supplierMessage.setFont(SWTResourceManager.getFont("宋体", 12, SWT.BOLD));
		supplierMessage.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1));
		supplierMessage.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		
		Composite composite_1 = new Composite(composite, SWT.NONE);
		GridLayout gl_composite_1 = new GridLayout(1, false);
		gl_composite_1.marginWidth = 20;
		gl_composite_1.verticalSpacing = 15;
		composite_1.setLayout(gl_composite_1);
		composite_1.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, false, 1, 1));
		
		Composite composite_2 = new Composite(composite_1, SWT.NONE);
		composite_2.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		GridLayout gl_composite_2 = new GridLayout(2, false);
		gl_composite_2.marginHeight = 10;
		gl_composite_2.verticalSpacing = 25;
		composite_2.setLayout(gl_composite_2);
		
		Label label = new Label(composite_2, SWT.NONE);
		label.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.NORMAL));
		label.setAlignment(SWT.RIGHT);
		label.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		label.setText("   签到人姓名：");
		
		signPersonText = new Text(composite_2, SWT.NO_BACKGROUND);
		signPersonText.setFont(SWTResourceManager.getFont("微软雅黑", 13, SWT.NORMAL));
		signPersonText.addVerifyListener(new SupplierSignTextListener(signPersonText, "请输入签到人姓名"));
		signPersonText.setTextLimit(10);
		GridData gd_text = new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1);
		gd_text.heightHint = 30;
		signPersonText.setLayoutData(gd_text);
		
		Label label_2 = new Label(composite_2, SWT.NONE);
		label_2.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.NORMAL));
		label_2.setAlignment(SWT.RIGHT);
		label_2.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		label_2.setText(Messages.IDCard+"：");
		
		personIDCard = new Text(composite_2, SWT.NO_BACKGROUND);
		personIDCard.setFont(SWTResourceManager.getFont("微软雅黑", 13, SWT.NORMAL));
		GridData gd_personIDCard = new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1);
		gd_personIDCard.heightHint = 30;
		personIDCard.setLayoutData(gd_personIDCard);
		personIDCard.addVerifyListener(new VerifyCardIdListener(MessageFormat.format(Messages.Tips_pleaseEnterTheCorrect, Messages.IDCard)));
		personIDCard.addVerifyListener(new SupplierSignTextListener(personIDCard, "请输入签到人身份证号码"));
		personIDCard.setTextLimit(20);
		
		Label label_1 = new Label(composite_2, SWT.NONE);
		label_1.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.NORMAL));
		label_1.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		label_1.setAlignment(SWT.RIGHT);
		label_1.setText(Messages.LinkerTel+"：");
		
		signPersonTelText = new Text(composite_2, SWT.NO_BACKGROUND);
		signPersonTelText.setFont(SWTResourceManager.getFont("微软雅黑", 13, SWT.NORMAL));
		GridData gd_text_1 = new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1);
		gd_text_1.heightHint = 30;
		signPersonTelText.setLayoutData(gd_text_1);
		signPersonTelText.setTextLimit(20);
		signPersonTelText.addVerifyListener(new SupplierSignTextListener(signPersonTelText, "请输入签到人联系电话"));
		signPersonTelText.addVerifyListener(new VerifyPhoneListener(MessageFormat.format(Messages.Tips_pleaseEnterTheValid, Messages.LinkerTel)));
		
		Group composite_3 = new Group(composite_1, SWT.NONE);
		composite_3.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.NORMAL));
		GridLayout gl_composite_3 = new GridLayout(3, false);
		gl_composite_3.marginWidth = 10;
		gl_composite_3.marginHeight = 20;
		composite_3.setLayout(gl_composite_3);
		composite_3.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, false, 1, 1));
		composite_3.setText("投递标书方式");
		
		/**
		 *投递标书类型 01：在线投递成功；02：现场导入电子标书；03：纸质标书
		 */
		onLineBtn = new Button(composite_3, SWT.RADIO);
		onLineBtn.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.NORMAL));
		onLineBtn.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, false, true, 1, 1));
		onLineBtn.setText(SupplierEnum.getSupplierTenderType(SupplierEnum.ONLINE_ELECTRONIC));
		onLineBtn.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/tender_online.png"));
		
		importBtn = new Button(composite_3, SWT.RADIO);
		importBtn.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.NORMAL));
		importBtn.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, false, true, 1, 1));
		importBtn.setText(SupplierEnum.getSupplierTenderType(SupplierEnum.IMPORT_ELECTRONIC));
		importBtn.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/tender_elec.png"));
		
		paperBtn = new Button(composite_3, SWT.RADIO);
		paperBtn.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.NORMAL));
		paperBtn.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, false, true, 1, 1));
		paperBtn.setText(SupplierEnum.getSupplierTenderType(SupplierEnum.PAPER));
		paperBtn.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/tender_pager.png"));
		
		Composite composite_4 = new Composite(composite_1, SWT.NONE);
		composite_4.setLayout(new GridLayout(2, false));
		composite_4.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		
		signButton = new EButton(composite_4, SWT.NONE | EButton.CSS_GREEN);
		signButton.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.BOLD));
		GridData gd_signButton = new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1);
		gd_signButton.widthHint = 100;
		gd_signButton.heightHint = 50;
		signButton.setLayoutData(gd_signButton);
		signButton.setText("下一步");
		signButton.addMouseListener(new org.eclipse.swt.events.MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent mouseevent) {
				gotoSignPageAction();
			}
		});

		EButton button_1 = new EButton(composite_4, SWT.NONE | EButton.CSS_GREEN);
		button_1.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.BOLD));
		GridData gd_button_1 = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
		gd_button_1.widthHint = 100;
		gd_button_1.heightHint = 50;
		button_1.setLayoutData(gd_button_1);
		button_1.addMouseListener(new org.eclipse.swt.events.MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent mouseevent) {
				supplierSignListener.reReadCa(supplier.getSupplierName());
				supplierSignListener.gotoSupplierWelcomePage();
				
			}
		});
		button_1.setText(Messages.Button_cancel);

		init();
	}

	/**
	 * @Description:初始化 
	 * @author guoyr 
	 */
	private void init(){
		onLineBtn.setEnabled(false);
//		refresh(tenderProjectEntity, supplier, supplierSignListener);
	}

	/**
	 * @Description: 刷新项目列表
	 * @author guoyr
	 * @param tenderProjectEntity
	 * @param supplier
	 * @param supplierSignListener 
	 */
	public void refresh(TenderProjectEntity tenderProjectEntity, Supplier supplier, CACert caCert, SupplierSignListener supplierSignListener){
		this.supplierSignListener = supplierSignListener;
		this.tenderProjectEntity = tenderProjectEntity;
		this.supplier = supplier;
		this.caCert = caCert;
		
		checkBidFile();
		if(null != tenderProjectEntity.getParentProjectEntity()){
			projectNameLabel.setText("["+tenderProjectEntity.getParentProjectEntity().getTenderNo() + "]"+tenderProjectEntity.getParentProjectEntity().getTenderName());
			packNameLabel.setText("["+tenderProjectEntity.getTenderNo()+"]"+tenderProjectEntity.getTenderName());
			packNameLabel.setVisible(true);
		}else {
			projectNameLabel.setText("["+tenderProjectEntity.getTenderNo()+"]"+tenderProjectEntity.getTenderName());
			packNameLabel.setVisible(false);
		}
		supplierMessage.setText(supplier.getSupplierName());
		if(null != supplier.getSignPerson()){
			signPersonText.setText(supplier.getSignPerson());
		}else if(null != supplier.getLinker()){
			signPersonText.setText(supplier.getLinker());
		}else {
			signPersonText.setText("");
		}
		if(null != supplier.getSignPersonTel()){
			signPersonTelText.setText(supplier.getSignPersonTel());
		}else if(null != supplier.getLinker()){
			signPersonTelText.setText(supplier.getLinkerTel());
		}else {
			signPersonTelText.setText("");
		}
		if(null != supplier.getSignPersonCard()){
			personIDCard.setText(supplier.getSignPersonCard());
		}else if(null != supplier.getIdCard()){
			personIDCard.setText(supplier.getIdCard());
		}else {
			personIDCard.setText("");
		}
	}
	
	/**
	 * @Description: 检查是否成功在线递交
	 * @author guoyr 
	 */
	private void checkBidFile(){
		if(null != checkSupplierBidFileThread){
			checkSupplierBidFileThread.stop();
		}
		onLineBtn.setSelection(false);
		importBtn.setSelection(false);
		paperBtn.setSelection(false);
		if(null != supplier.getBidFileType() && !"".equals(supplier.getBidFileType())){
			if(supplier.getBidFileType().equals(SupplierEnum.ONLINE_ELECTRONIC)){
				onLineBtn.setSelection(true);
				onLineBtn.setEnabled(true);
			}else if(supplier.getBidFileType().equals(SupplierEnum.IMPORT_ELECTRONIC)){
				importBtn.setSelection(true);
			}else if(supplier.getBidFileType().equals(SupplierEnum.PAPER)){
				paperBtn.setSelection(true);
			}else {
				MessageDialog.openWarning(getShell(), "请选择投递标书方式！");
				return ;
			}
		}else if(null != tenderProjectEntity.getTransactionServerId()){
			checkSupplierBidFileThread = new CheckHttpBidFileThread(tenderProjectEntity, supplier, new CheckHttpBidFileThread.CheckCallBack() {
				public void callBackString(String returnMessage) {
				}
				public void bidFile(boolean hasbidFile, Date tenderTime, long bidFileSize, String downUrl) {
					supplier.setFileSize(bidFileSize);
					if(hasbidFile){
						Display.getDefault().syncExec(new Runnable(){
							public void run(){
								if(!onLineBtn.isDisposed()){
									onLineBtn.setSelection(true);
									importBtn.setSelection(false);
									paperBtn.setSelection(false);
									onLineBtn.setEnabled(true);
								}
							}
						});
					}
				}
			});
			checkSupplierBidFileThread.start();
		}
	}

	/**
	 * @Description:去签到 
	 * @author guoyr 
	 */
	public void gotoSignPageAction(){
		
		if(!ValidateUtils.checkInput(personIDCard.getParent())){
			return;
		}
		if(onLineBtn.getSelection()){
			supplier.setBidFileType(SupplierEnum.ONLINE_ELECTRONIC);
		}else if(importBtn.getSelection()){
			supplier.setBidFileType(SupplierEnum.IMPORT_ELECTRONIC);
			
		}else if(paperBtn.getSelection()){
			supplier.setBidFileType(SupplierEnum.PAPER);
		}else {
			MessageDialog.openWarning(getShell(), "请选择投递标书方式！");
			return ;
		}
		
		supplier.setSignPersonCard(personIDCard.getText().trim());
		supplier.setSignPerson(signPersonText.getText().trim());
		supplier.setSignPersonTel(signPersonTelText.getText().trim());
		supplier.setSignType(SupplierEnum.SIGN_LOCAL);
		supplierSignListener.gotoSignaturePage(supplier, caCert);
	}
	
	private class SupplierSignTextListener implements VerifyListener, VerifyValueListener{
		
		private String hint;
		private Text text;
		public SupplierSignTextListener(Text text, final String hint){
			this.hint = hint;
			this.text = text;
			addPaintControl();
		}

		public void addPaintControl() {
			text.addPaintListener(new PaintListener() {
				public void paintControl(PaintEvent arg0) {
					if(!arg0.gc.isDisposed() && null != hint && hint.length() > 0){
						arg0.gc.setForeground(SWTResourceManager.getColor(192, 192, 192));
						if(text.getText().trim().length() == 0){
							arg0.gc.drawText(hint, 0, (text.getBounds().height - arg0.gc.getFontMetrics().getHeight())/2, true);
						}
						arg0.gc.drawLine(0, text.getBounds().height -1, text.getBounds().width, text.getBounds().height -1);
					}
				
				}
			});
		}

		public String verifyMsg(String text) {
			if (null == text || "".equals(text.trim())) {
				
				return hint;
			}
			return VerifyValueListener.ACCEPT;
		}

		public void verifyText(VerifyEvent arg0) {
			
		}

	}
	
	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}

}
