package com.gx.obe.opening.composite;

import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.StyleRange;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;

import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.config.ConfigConstants;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.message.Messages;
import com.gx.obe.opening.listener.BatchRemoteBidOpeningListener;
import com.gx.obe.opening.listener.TenderPackOpeningStatus;
import com.gx.obe.opening.widgets.BidOpeningStatusButton;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.entity.tender.TenderProjectRuleEntity;
import com.gx.obe.web.vo.TenderPackOpeningInfo;
import com.swtdesigner.SWTResourceManager;

public class TenderPackOpeningListItemComposite extends Composite implements TenderPackOpeningStatus{
	
	private TenderProjectEntity tenderPack;
	private StyledText styledText;
	private BidOpeningStatusButton tenderCountBtn;
	private BidOpeningStatusButton signCountBtn;
	private BidOpeningStatusButton descCountBtn;
	private BidOpeningStatusButton confirmCountBtn;
	private Runnable freshInfoRunnable;
	private Runnable changeTenderCountRunnable;
	private TenderProjectRuleEntity tenderProjectRuleEntity;
	private TenderPackOpeningInfo tenderPackOpeningInfo;
	private String bidopeningStage;
	private Composite parentComposite;
	private MouseAdapter showDetailListener;
	private boolean isFocus = false;
	private boolean showOpeningCount = false;
	private BatchRemoteBidOpeningListener batchRemoteBidOpeningListener;
	public static int rowHeight = 45;
	private int maxSignLength = 3;
	private int maxDecLength = 3;
	private boolean isLayout = false;
	private StyleRange tenderNameStyle;
	private boolean hasErrors = false;
	private boolean anonymousAllInfo = false;
	
	/**
	 * Create the composite.
	 * @param parent
	 * @param style
	 */
	public TenderPackOpeningListItemComposite(Composite parent, int style) {
		super(parent, style);
		GridLayout gridLayout = new GridLayout(5, false);
		gridLayout.marginHeight = 0;
		gridLayout.marginBottom = 2;
		gridLayout.verticalSpacing = 3;
		setLayout(gridLayout);
//		this.setBackground(ColorConstants.FONT_BLUE_COLOR);
		this.setBackgroundMode(SWT.INHERIT_FORCE);
		this.parentComposite = parent;
		if(null != parent.getData("isFocus")){
			isFocus = true;
		}
		styledText = new StyledText(this, SWT.READ_ONLY);
		styledText.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1));
		
		tenderCountBtn = new BidOpeningStatusButton(this, SWT.NONE);
		GridData gd_tenderCountBtn = new GridData(SWT.FILL, SWT.CENTER, false, true, 1, 1);
//		gd_tenderCountBtn.widthHint = 50;
		gd_tenderCountBtn.minimumWidth = 50;
		tenderCountBtn.setLayoutData(gd_tenderCountBtn);
		tenderCountBtn.setForeground(SWTResourceManager.getColor(41, 150, 206));
		tenderCountBtn.setFont(SWTResourceManager.getFont("微软雅黑", 13, SWT.NORMAL));
		tenderCountBtn.setStatusName(Messages.Opening_tendered);
		tenderCountBtn.setText(" 0 个");
		
		signCountBtn = new BidOpeningStatusButton(this, SWT.NONE);
		GridData gd_signCountBtn = new GridData(SWT.FILL, SWT.CENTER, false, true, 1, 1);
		gd_signCountBtn.minimumWidth = 50;
		signCountBtn.setLayoutData(gd_signCountBtn);
		signCountBtn.setForeground(SWTResourceManager.getColor(41, 150, 206));
		signCountBtn.setFont(SWTResourceManager.getFont("微软雅黑", 13, SWT.NORMAL));
		signCountBtn.setStatusName(Messages.Opening_signedIn);
		signCountBtn.setText(" 0 个");
		
		descCountBtn = new BidOpeningStatusButton(this, SWT.NONE);
		GridData gd_descCountBtn = new GridData(SWT.FILL, SWT.CENTER, false, true, 1, 1);
		gd_descCountBtn.minimumWidth = 50;
		descCountBtn.setLayoutData(gd_descCountBtn);
		descCountBtn.setForeground(SWTResourceManager.getColor(41, 150, 206));
		descCountBtn.setFont(SWTResourceManager.getFont("微软雅黑", 13, SWT.NORMAL));
		descCountBtn.setStatusName(Messages.Opening_decrypted);
		descCountBtn.setText(" 0 个");
		
		confirmCountBtn = new BidOpeningStatusButton(this, SWT.NONE);
		GridData gd_confirmCountBtn = new GridData(SWT.FILL, SWT.CENTER, false, true, 1, 1);
		gd_confirmCountBtn.minimumWidth = 50;
		confirmCountBtn.setLayoutData(gd_confirmCountBtn);
		confirmCountBtn.setForeground(SWTResourceManager.getColor(41, 150, 206));
		confirmCountBtn.setFont(SWTResourceManager.getFont("微软雅黑", 13, SWT.NORMAL));
		confirmCountBtn.setStatusName(Messages.Opening_confirmed);
		confirmCountBtn.setText(" 0 个");
//		
//		ESepator label = new ESepator(this, SWT.NONE);
//		label.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 5, 1));
//		label.setBackground(SWTResourceManager.getColor(224, 224, 224));
//		label.setLineWidth(2);
//		label.setLineStyle(SWT.LINE_DOT);

		init();
	}

	/**
	 * @Description: 初始化
	 * @author guoyr 
	 */
	private void init(){
		styledText.setCursor(SWTResourceManager.getCursor(SWT.CURSOR_HAND));
		styledText.setEditable(false);
		
					
		freshInfoRunnable = new Runnable(){
			public void run(){
				if(!tenderCountBtn.isDisposed()){
					if(showOpeningCount && tenderPackOpeningInfo.getOpeningCount() > 0){
						tenderCountBtn.setStatusName(Messages.Opening_ecryptable);
//						tenderCountBtn.setText((tenderPackOpeningInfo.getTenderCount()-tenderPackOpeningInfo.getRevokeCount() - tenderPackOpeningInfo.getInvalidCount())+Messages.SupplierCouns);
						tenderCountBtn.setText(tenderPackOpeningInfo.getOpeningCount()+Messages.SupplierCouns);
					}else {
						tenderCountBtn.setStatusName(Messages.Opening_tendered);
						tenderCountBtn.setText(tenderPackOpeningInfo.getTenderCount()+Messages.SupplierCouns);
					}
					
					String signCount = tenderPackOpeningInfo.getSignCount()+Messages.SupplierCouns;
					String decCount = tenderPackOpeningInfo.getDecCount()+Messages.SupplierCouns;
					if(!isLayout && signCount.length() > maxSignLength){
						isLayout = true;
						maxSignLength = signCount.length();
					}
					if(!isLayout && decCount.length() > maxDecLength){
						maxDecLength = decCount.length();
						isLayout = true;
					}
					
					signCountBtn.setText(signCount);
					descCountBtn.setText(decCount);
					confirmCountBtn.setText(tenderPackOpeningInfo.getConfirmCount()+Messages.SupplierCouns);
					
					if (anonymousAllInfo) {
					    tenderCountBtn.setText("*" + Messages.SupplierCouns);
					    signCountBtn.setText("*" + Messages.SupplierCouns);
		                descCountBtn.setText("*" + Messages.SupplierCouns);
		                confirmCountBtn.setText("*" + Messages.SupplierCouns);
	                } 
					
					boolean isPriceStage = false;
					if(null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_PRICE)){
						isPriceStage = true;
					}
					boolean isStartSign = false;
					String startBidopening = tenderPackOpeningInfo.getTenderProject().getStartBidOpening();
					if(isPriceStage){
						startBidopening = tenderPackOpeningInfo.getTenderProject().getStartPriceBidOpening();
					}
					if(null != startBidopening && startBidopening.equals(CommonEnum.YES)){
						isStartSign = true;
					}
					// 是否已经启动开标大厅
					if (isStartSign) {
						signCountBtn.setForeground(SWTResourceManager.getColor(41, 150, 206));
						
						// 是否已经启动解密
						boolean isStartDecrypt = true;
						if(isPriceStage){
							if(null == tenderPackOpeningInfo.getTenderProject().getPriceBidStatus() || tenderPackOpeningInfo.getTenderProject().getPriceBidStatus().equals(CommonEnum.NOT_START)){
								isStartDecrypt = false;
							}
							
						}else {
							if(null == tenderPackOpeningInfo.getTenderProject().getBusinessBidStatus() || tenderPackOpeningInfo.getTenderProject().getBusinessBidStatus().equals(CommonEnum.NOT_START)){
								isStartDecrypt = false;
							}
						}
						
						signCountBtn.setComplate(tenderPackOpeningInfo.isSignComplate());
						if (isStartDecrypt) {
							if(tenderPackOpeningInfo.getDecFailCount() > 0 || tenderPackOpeningInfo.getNoPriceCount() > 0){
								hasErrors = true;
								descCountBtn.setErrorCount(tenderPackOpeningInfo.getDecFailCount()+ tenderPackOpeningInfo.getNoPriceCount());
							}else {
								descCountBtn.setErrorCount(0);
								if(hasErrors) {
									descCountBtn.redraw();
								}
								hasErrors = false;
							}
							descCountBtn.setForeground(SWTResourceManager.getColor(41, 150, 206));
							confirmCountBtn.setForeground(SWTResourceManager.getColor(41, 150, 206));
							descCountBtn.setComplate(tenderPackOpeningInfo.isDecComplate());
							confirmCountBtn.setComplate(tenderPackOpeningInfo.isConfirmComplate());
							
							if(tenderPackOpeningInfo.isComplate()){
								tenderCountBtn.setForeground(SWTResourceManager.getColor(99, 183, 35));
								signCountBtn.setForeground(SWTResourceManager.getColor(99, 183, 35));
								descCountBtn.setForeground(SWTResourceManager.getColor(99, 183, 35));
								confirmCountBtn.setForeground(SWTResourceManager.getColor(99, 183, 35));
							}else if(tenderPackOpeningInfo.isProject() && tenderPackOpeningInfo.getComplateSupplierCount() > 0){
								if(tenderPackOpeningInfo.getComplateSupplierCount() >= tenderPackOpeningInfo.getDecCount()){
									tenderCountBtn.setForeground(SWTResourceManager.getColor(99, 183, 35));
									signCountBtn.setForeground(SWTResourceManager.getColor(99, 183, 35));
									descCountBtn.setForeground(SWTResourceManager.getColor(99, 183, 35));
									confirmCountBtn.setForeground(SWTResourceManager.getColor(99, 183, 35));
								}
							}
						}else {
							descCountBtn.setForeground(SWTResourceManager.getColor(102, 102, 102));
							confirmCountBtn.setForeground(SWTResourceManager.getColor(102, 102, 102));
						}
					}else {
						signCountBtn.setForeground(SWTResourceManager.getColor(102, 102, 102));
						descCountBtn.setForeground(SWTResourceManager.getColor(102, 102, 102));
						confirmCountBtn.setForeground(SWTResourceManager.getColor(102, 102, 102));
					}
					if(isLayout){
						layout();
						isLayout = false;
					}
				}
			}
		};

		changeTenderCountRunnable = new Runnable(){
			public void run(){
				if(!tenderCountBtn.isDisposed()){
					if(showOpeningCount && tenderPackOpeningInfo.getOpeningCount() > 0){
						tenderCountBtn.setStatusName(Messages.Opening_ecryptable);
//						tenderCountBtn.setText((tenderPackOpeningInfo.getTenderCount()-tenderPackOpeningInfo.getRevokeCount() - tenderPackOpeningInfo.getInvalidCount())+Messages.SupplierCouns);
						tenderCountBtn.setText(tenderPackOpeningInfo.getOpeningCount()+Messages.SupplierCouns);
					}else {
						tenderCountBtn.setStatusName(Messages.Opening_tendered);
						tenderCountBtn.setText(tenderPackOpeningInfo.getTenderCount()+Messages.SupplierCouns);
					}
					if (anonymousAllInfo) {
						tenderCountBtn.setText("*" + Messages.SupplierCouns);
					}
					tenderCountBtn.redraw();
				}
			}
		};
		
		showDetailListener = new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				if (anonymousAllInfo) {
					tenderCountBtn.setText("*" + Messages.SupplierCouns);
				}
				// 点击后增加一个颜色的变化，用于区分哪些包件查看过
				tenderNameStyle.foreground = SWTResourceManager.getColor(255, 153, 0);
				styledText.setStyleRange(tenderNameStyle);
				if(null != batchRemoteBidOpeningListener){
					batchRemoteBidOpeningListener.clickTenderPackInfo(tenderPackOpeningInfo);
				}
			}
		};
		styledText.addMouseListener(showDetailListener);
		addPaintListener(new PaintListener() {
			public void paintControl(PaintEvent arg0) {
				Rectangle rectangle = getBounds();
				arg0.gc.setForeground(SWTResourceManager.getColor(200, 200, 200));
				arg0.gc.setLineWidth(3);
				arg0.gc.setLineStyle(SWT.LINE_DOT);
				arg0.gc.drawLine(0, rectangle.height, rectangle.width, rectangle.height);
			}
		});
		if(isFocus || PropertiesUtils.getProperty(ConfigConstants.SHOW_SIGN_INFO_STATUS, "01").equals("00")){
			((GridData)signCountBtn.getLayoutData()).exclude = true;
			signCountBtn.setVisible(false);
		}
		
		if(PropertiesUtils.getProperty(ConfigConstants.SHOW_CONFIRM_STATUS, "00").equals("00")){
			((GridData)confirmCountBtn.getLayoutData()).exclude = true;
			confirmCountBtn.setVisible(false);
		}
	}
	
	/** 
	 * @Description: 设置是否显示签到信息
	 * @author guoyr
	 * @param isShow 
	 */
	public void setShowSignInfoStatus(boolean isShow){
		((GridData)signCountBtn.getLayoutData()).exclude = !isShow;
		signCountBtn.setVisible(isShow);
		layout();
	}
	/** 
	 * @Description: 设置是否显示确认信息
	 * @author guoyr
	 * @param isShow 
	 */
	public void setShowComfirmStatus(boolean isShow){
		((GridData)confirmCountBtn.getLayoutData()).exclude = !isShow;
		confirmCountBtn.setVisible(isShow);
		layout();
	}
	
	public void setTenderPack(final TenderProjectEntity tenderPack){
		this.tenderPack = tenderPack;
		
		styledText.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.NORMAL));
		styledText.setText("["+tenderPack.getTenderNo()+"]" + tenderPack.getTenderName());
		StyleRange styleRange = new StyleRange(); 
		styleRange.start = 0;
		styleRange.length = 1;
		styleRange.foreground = SWTResourceManager.getColor(100, 100, 100);
		styledText.setStyleRange(styleRange);
		styleRange.start = tenderPack.getTenderNo().length() + 1;
		styleRange.length = 1;
		styledText.setStyleRange(styleRange);
		
		StyleRange tenderNoStyle = new StyleRange(); 
		tenderNoStyle.start = 1;
		tenderNoStyle.length = tenderPack.getTenderNo().length();
		tenderNoStyle.font = SWTResourceManager.getFont("微软雅黑", 12, SWT.BOLD);
//		tenderNoStyle.foreground = SWTResourceManager.getColor(150, 150, 150);
		tenderNoStyle.foreground = SWTResourceManager.getColor(209, 89, 88);
		styledText.setStyleRange(tenderNoStyle);
		
		tenderNameStyle = new StyleRange(); 
		tenderNameStyle.start = tenderPack.getTenderNo().length() + 2;
		tenderNameStyle.length = tenderPack.getTenderName().length();
		tenderNameStyle.foreground = SWTResourceManager.getColor(102, 102, 102);
		styledText.setStyleRange(tenderNameStyle);
		layout();
	}
	
	public TenderProjectEntity getTenderPack(){
		return tenderPack;
	}

	public synchronized void refreshTenderPackOpeningInfo(TenderPackOpeningInfo tenderPackOpeningInfo, TenderProjectRuleEntity tenderProjectRuleEntity, String bidopeningStage, boolean showCanOpeningCount, boolean anonymousAllInfo) {
		this.tenderPackOpeningInfo = tenderPackOpeningInfo;
		this.tenderProjectRuleEntity = tenderProjectRuleEntity;
		this.bidopeningStage = bidopeningStage;
		this.showOpeningCount = showCanOpeningCount;
		this.anonymousAllInfo = anonymousAllInfo;
		if(null != tenderPackOpeningInfo && null != freshInfoRunnable){
			Display.getDefault().syncExec(freshInfoRunnable);
		}
		
	}

	public void refreshTenderInfoStatus(boolean isShowEffectiveCount){
		this.showOpeningCount = isShowEffectiveCount;
		if(null != tenderPackOpeningInfo && null != changeTenderCountRunnable){
			Display.getDefault().syncExec(changeTenderCountRunnable);
		}
	}
	
	public void removeShowDetailListener(){
		if(null != styledText){
			styledText.removeMouseListener(showDetailListener);
		}
	}
	
	public void addBatchRemoteBidOpeningListener(BatchRemoteBidOpeningListener batchRemoteBidOpeningListener){
		this.batchRemoteBidOpeningListener = batchRemoteBidOpeningListener;
		
	}
	@Override
	public void dispose() {
		freshInfoRunnable = null;
		super.dispose();
	}
	
	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}
}
