package com.gx.obe.opening.dialog;

import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.eclipse.nebula.widgets.grid.Grid;
import org.eclipse.nebula.widgets.grid.GridColumn;
import org.eclipse.nebula.widgets.grid.GridItem;
import org.eclipse.swt.SWT;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.calendar.CalendarUtil;
import org.eclipse.swt.core.listener.PaintImageListener;
import org.eclipse.swt.core.listener.RoundBorderLineListener;
import org.eclipse.swt.core.utils.GridUtils;
import org.eclipse.swt.core.widgets.EButton;
import org.eclipse.swt.core.widgets.EDialog;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import com.gx.obe.ColorConstants;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.composite.PageFoodComposite;
import com.gx.obe.common.widget.composite.PageFoodComposite.PageListener;
import com.gx.obe.components.core.Constants;
import com.gx.obe.listener.TenderProjectListListener;
import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.DateUtils;
import com.gx.obe.util.utils.ScreenUtils;
import com.gx.obe.web.entity.Page;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.service.TenderProjectService;
import com.gx.obe.web.vo.TenderProjectVo;
import com.gx.utils.NowTimeUtils;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

public class AddBidOpeningRoomProjectDialog extends EDialog {

	private int CUR_PAGE_NO = 1;
	private int PAGE_SIZE = 0;
	private Grid allProjectGrid;
	private TenderProjectService tenderProjectService ;
	private PageFoodComposite pageFoodComposite;
	private Grid selectionProjectGrid;
	private Map<String, String> selectionTenderProjectMap = null;
	private List<TenderProjectEntity> selectionTenderProjectList;
	private TenderProjectListListener tenderProjectListListener;
	private EButton addBtn;
	private EButton delBtn;
	private Text start_time;
	private Text end_time;
	private String dataFormat = "yyyy-MM-dd HH:mm:00";
	private EButton searchBtn;
	private ELink onePageBtn;
	private long totalCount = 0;
	private boolean onlyOnePage = false;
	/**
	 * Create the dialog.
	 * @param parentShell
	 */
	public AddBidOpeningRoomProjectDialog(Shell parentShell, List<TenderProjectEntity> selectionTenderProjectList, TenderProjectListListener tenderProjectListListener) {
		super(parentShell);
		this.selectionTenderProjectList = selectionTenderProjectList;
		this.tenderProjectListListener = tenderProjectListListener;
		this.setOperator(SWT.MAX);
	}

	/**
	 * Create contents of the dialog.
	 * @param parent
	 */
	@Override
	protected Control createDialogArea(Composite parent) {
		Composite container = (Composite) super.createDialogArea(parent);
		container.setLayout(new GridLayout(3, false));
		
		Composite allProjectComposite = new Composite(container, SWT.NONE);
		GridLayout gl_allProjectComposite = new GridLayout(1, false);
		gl_allProjectComposite.horizontalSpacing = 0;
		gl_allProjectComposite.verticalSpacing = 0;
		gl_allProjectComposite.marginHeight = 1;
		gl_allProjectComposite.marginWidth = 1;
		allProjectComposite.setLayout(gl_allProjectComposite);
		GridData gd_allProjectComposite = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_allProjectComposite.widthHint = 400;
		allProjectComposite.setLayoutData(gd_allProjectComposite);
		allProjectComposite.addPaintListener(new RoundBorderLineListener(ColorConstants.BORDER_LINE_COLOR));
		
		Composite composite = new Composite(allProjectComposite, SWT.NONE);
		GridLayout gl_composite = new GridLayout(7, false);
		gl_composite.horizontalSpacing = 2;
		composite.setLayout(gl_composite);
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		
//		Label label = new Label(composite, SWT.NONE);
//		label.setForeground(ColorConstants.FONT_BLACK_COLOR);
//		label.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
//		label.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
//		label.setText("选择要开标的项目");
		
		start_time = new Text(composite, SWT.BORDER|SWT.READ_ONLY | SWT.DRAW_TAB);
		start_time.setCursor(SWTResourceManager.getCursor(SWT.CURSOR_ARROW));
		GridData gd_text_1 = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_text_1.widthHint = 120;
		start_time.setLayoutData(gd_text_1);
		start_time.addPaintListener(new PaintImageListener(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/data.png")));
		start_time.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				CalendarUtil.getDates(start_time, null, (Date)end_time.getData("date"), dataFormat);
			}
		});
		
		Label connet_label = new Label(composite, SWT.NONE);
		connet_label.setText("—");
		connet_label.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		
//		text_2 = new Text(composite_2, SWT.BORDER);
//		text_2.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		
		end_time = new Text(composite, SWT.BORDER | SWT.READ_ONLY | SWT.DRAW_TAB);
		end_time.setCursor(SWTResourceManager.getCursor(SWT.CURSOR_ARROW));
		GridData gd_text_2 = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_text_2.widthHint = 120;
		end_time.setLayoutData(gd_text_2);
		end_time.addPaintListener(new PaintImageListener(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/data.png")));
		end_time.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				CalendarUtil.getDates(end_time, (Date)start_time.getData("date"), null, dataFormat);
			}
		});
		
		searchBtn = new EButton(composite, SWT.NONE);
		searchBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				searchAction();
			}
		});
		searchBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/search.png"));
		searchBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		searchBtn.setText(Messages.Button_search);
		
		onePageBtn = new ELink(composite, SWT.NONE);
		onePageBtn.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true, false, 1, 1));
		onePageBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				onlyOnePageAction();
			}
		});
		onePageBtn.setText("一页显示");
		
		ELink allSelectionAllBtn = new ELink(composite, SWT.NONE);
		allSelectionAllBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/select_all.png"));
		allSelectionAllBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/select_all.png"));
		allSelectionAllBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		allSelectionAllBtn.setText(Messages.Button_selectAll);
		allSelectionAllBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				selectionAction(1);
			}
		});
		
		ELink allSelectionInvertBtn = new ELink(composite, SWT.NONE);
		allSelectionInvertBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		allSelectionInvertBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/switch.png"));
		allSelectionInvertBtn.setText(Messages.Button_selectInvert);
		allSelectionInvertBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				selectionAction(-1);
			}
		});
		
		{
			ESepator sep = new ESepator(allProjectComposite, SWT.NONE);
			sep.setBackground(ColorConstants.SEP_LIGHT_COLOR);
			sep.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		}
		
		allProjectGrid = new Grid(allProjectComposite, SWT.H_SCROLL | SWT.V_SCROLL);
		allProjectGrid.setHeaderVisible(true);
		allProjectGrid.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		GridColumn tenderNoColumn = new GridColumn(allProjectGrid, SWT.CHECK);
		tenderNoColumn.setText(Messages.ProjectCode);
		tenderNoColumn.setWidth(80);
		tenderNoColumn.setMinimumWidth(80);
		tenderNoColumn.setMaxmumWidth(150);
		tenderNoColumn.setWordWrap(true);
		
		GridColumn tenderNameColumn = new GridColumn(allProjectGrid, SWT.NONE);
		tenderNameColumn.setText(Messages.ProjectName);
		tenderNameColumn.setWordWrap(true);
		tenderNameColumn.setWidth(250);
		
		GridColumn supplierCountColumn = new GridColumn(allProjectGrid, SWT.CENTER);
		supplierCountColumn.setText(Messages.TenderPackage);
		supplierCountColumn.setWidth(50);
		supplierCountColumn.setMinimumWidth(50);
		supplierCountColumn.setMaxmumWidth(80);
		
		pageFoodComposite = new PageFoodComposite(allProjectComposite, SWT.NONE);
		pageFoodComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		Composite opComposite = new Composite(container, SWT.NONE);
		opComposite.setLayout(new GridLayout(1, false));
		
		addBtn = new EButton(opComposite, SWT.NONE);
		addBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				addAction();
			}
		});
		GridData gd_button = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_button.widthHint = 80;
		addBtn.setLayoutData(gd_button);
		addBtn.setText(">>" + Messages.Button_addTo);
		
		delBtn = new EButton(opComposite, SWT.NONE);
		delBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		delBtn.setText("<<" + Messages.Button_delete);
		delBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				delAction();
			}
		});
		
		EButton closeBtn = new EButton(opComposite, SWT.NONE);
		closeBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		closeBtn.setText(Messages.Button_confirm);
		closeBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				closeAction();
			}
		});
		
		Composite selectionProjectComposite = new Composite(container, SWT.NONE);
		GridLayout gl_selectionProjectComposite = new GridLayout(1, false);
		gl_selectionProjectComposite.verticalSpacing = 0;
		gl_selectionProjectComposite.horizontalSpacing = 0;
		gl_selectionProjectComposite.marginHeight = 1;
		gl_selectionProjectComposite.marginWidth = 1;
		selectionProjectComposite.setLayout(gl_selectionProjectComposite);
		GridData gd_selectionProjectComposite = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_selectionProjectComposite.widthHint = 300;
		selectionProjectComposite.setLayoutData(gd_selectionProjectComposite);
		selectionProjectComposite.addPaintListener(new RoundBorderLineListener(ColorConstants.BORDER_LINE_COLOR));
		
		Composite composite_1 = new Composite(selectionProjectComposite, SWT.NONE);
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		composite_1.setLayout(new GridLayout(2, false));
		
		Label label_1 = new Label(composite_1, SWT.NONE);
		label_1.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		label_1.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		label_1.setText(MessageFormat.format(Messages.Title_selected, Messages.TenderProject));
		{
			ESepator sep = new ESepator(selectionProjectComposite, SWT.NONE);
			sep.setBackground(ColorConstants.SEP_LIGHT_COLOR);
			sep.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		}
		
		ELink selectionAllBtn = new ELink(composite_1, SWT.NONE);
		selectionAllBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/select_all.png"));
		selectionAllBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/select_all.png"));
		selectionAllBtn.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true, false, 1, 1));
		selectionAllBtn.setText(Messages.Button_selectAll);
		selectionAllBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				selectedAllAction(1);
			}
		});
		
//		ELink selectionInvertBtn = new ELink(composite_1, SWT.NONE);
//		selectionInvertBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
//		selectionInvertBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/switch.png"));
//		selectionInvertBtn.setText(Messages.Button_selectInvert);
//		selectionInvertBtn.addMouseListener(new MouseAdapter() {
//			public void mouseUp(MouseEvent e) {
//				selectedBackAction(-1);
//			}
//		});
//		
		
		selectionProjectGrid = new Grid(selectionProjectComposite, SWT.H_SCROLL | SWT.V_SCROLL | SWT.MULTI);
		selectionProjectGrid.setHeaderVisible(true);
		selectionProjectGrid.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		GridColumn selectTenderNoColumn = new GridColumn(selectionProjectGrid, SWT.NONE);
		selectTenderNoColumn.setText(Messages.ProjectCode);
		selectTenderNoColumn.setWidth(80);
		selectTenderNoColumn.setMinimumWidth(80);
		selectTenderNoColumn.setMaxmumWidth(150);
		selectTenderNoColumn.setWordWrap(true);
		
		GridColumn selectTenderNameColumn = new GridColumn(selectionProjectGrid, SWT.NONE);
		selectTenderNameColumn.setText(Messages.ProjectName);
		selectTenderNameColumn.setWidth(200);
		selectTenderNameColumn.setWordWrap(true);
		tenderProjectService = new TenderProjectService();
		init();
		return container;
	}
	
	private void init(){
		this.setTitle(Messages.Tips_selectOpeningProject);
		allProjectGrid.setItemHeight(Constants.ROW_HIGHT);
		allProjectGrid.setAutoHeight(true);
		allProjectGrid.setAutoWidth(true);
		selectionProjectGrid.setItemHeight(Constants.ROW_HIGHT);
		selectionProjectGrid.setAutoHeight(true);
		selectionProjectGrid.setAutoWidth(true);
		CalendarUtil.setDate(start_time, NowTimeUtils.getNowDate(), "yyyy-MM-dd 00:00:00");
		CalendarUtil.setDate(end_time, NowTimeUtils.getNowDate(), "yyyy-MM-dd 23:59:59");
		
		// 进入项目的事件
		pageFoodComposite.addPageListener(new PageListener(){
			public void changed(int pageNo, int pageSize) {
				queryProjectPage(pageNo);
			}
			
		});
		selectionTenderProjectMap = new HashMap<String, String>();
		refreshSelectionProject();
		onePageBtn.setVisible(false);
		queryProjectPage(CUR_PAGE_NO);
		
//		allProjectGrid.addListener(SWT.Selection, new Listener(){
//			public void handleEvent(Event event) {
//				// 选中了复选框事件
//				if(event.detail == SWT.CHECK){
//					GridItem item = (GridItem)event.item;
//					if(item.getChecked(0)){
//					
//					}else {
//					
//					}
//				}
//			}
//			
//		});
	}
	
	/**
	 * @Description: 刷新已选项目
	 * @author guoyr 
	 */
	private void refreshSelectionProject(){
		if(null != selectionTenderProjectList && selectionTenderProjectList.size() > 0){
			for(TenderProjectEntity tenderProjectEntity : selectionTenderProjectList){
				addSelectoinProject(tenderProjectEntity);
			}
		}
	}
	
	/**
	 * @Description: 添加选中
	 * @author guoyr
	 * @param tenderProjectEntity 
	 */
	private void addSelectoinProject(TenderProjectEntity tenderProjectEntity){
		GridItem item = new GridItem(selectionProjectGrid, SWT.NONE);
		item.setData("tenderProjectEntity", tenderProjectEntity);
		item.setData("tenderId", tenderProjectEntity.getId());
		item.setText(0, tenderProjectEntity.getTenderNo());
		item.setText(1, tenderProjectEntity.getTenderName());
		selectionTenderProjectMap.put(tenderProjectEntity.getId(), tenderProjectEntity.getId());
	}
	
	/**
	 * @Description: 全选、反选
	 * @author guoyr
	 * @param selectionType 
	 */
	private void selectionAction(int selectionType){
		if(selectionType == 1){
			GridUtils.checkAll(allProjectGrid, 0, true);
		}else {
			GridUtils.checkAllBack(allProjectGrid, 0);
			
		}
	}
	
	/**
	 * @Description: 全选、反选
	 * @author guoyr
	 * @param selectionType 
	 */
	private void selectedAllAction(int selectionType){
		if(selectionType == 1){
			selectionProjectGrid.setSelection(0, selectionProjectGrid.getItemCount()-1);
		}
	}
	
	
	private void searchAction(){
		onePageBtn.setVisible(false);
		onlyOnePage = false;
		onePageBtn.setText("一页显示");
		totalCount = 0;
		queryProjectPage(1);
	}
	/**
	 * @Description: 一页显示
	 * @author guoyr 
	 */
	private void onlyOnePageAction(){
		if(onePageBtn.getVisible()){
			if(onlyOnePage){
				onePageBtn.setText("一页显示");
			}else {
				onePageBtn.setText("分页显示");
			}
			onlyOnePage = !onlyOnePage;
			queryProjectPage(1);
		}
	}
	/**
	 * @Description: 按分页显示项目
	 * @author guoyr
	 * @param pageNo 
	 */
	public void queryProjectPage(int pageNo){
		this.CUR_PAGE_NO = pageNo;
		allProjectGrid.removeAll();
		final Date startTime = start_time.getText().length() > 0 ? DateUtils.toDate(start_time.getText()) : null;
		final Date endTime = end_time.getText().length() > 0 ? DateUtils.toDate(end_time.getText()) : null;
		new Thread(new Runnable(){
			public void run(){
				if(totalCount > 0 && onlyOnePage){
					PAGE_SIZE = (int)totalCount + 5;
				}else {
					Display.getDefault().syncExec(new Runnable(){
						public void run(){
							if(!allProjectGrid.isDisposed()){
								PAGE_SIZE = selectionProjectGrid.getBounds().height / (selectionProjectGrid.getItemHeight() + 2);
								PAGE_SIZE -= 1;
							}
						}
					});
					if(PAGE_SIZE < 10){
						PAGE_SIZE = 10;
					}
				}
				final Page<TenderProjectVo> projectPage = tenderProjectService.getMyOpeningProjectPageList(Constants.USER.getId(), null, null, startTime, endTime, CUR_PAGE_NO, PAGE_SIZE);
				if(null != projectPage && projectPage.getRecords().size() > 0){
					totalCount = projectPage.getTotal();
					
					Display.getDefault().syncExec(new Runnable(){
						public void run(){
							if(!allProjectGrid.isDisposed()){
								if(projectPage.getPages() > 1){
									onePageBtn.setVisible(true);
								}
								for(TenderProjectVo projectMap : projectPage.getRecords()){
									TenderProjectEntity tenderProjectEntity = new TenderProjectEntity();
									tenderProjectEntity.setId(projectMap.getTenderId());
									tenderProjectEntity.setTenderNo(projectMap.getTenderNo());
									tenderProjectEntity.setTenderName(projectMap.getTenderName());
									tenderProjectEntity.setTenderType(projectMap.getTenderType());
									tenderProjectEntity.setPhaseType(projectMap.getPhaseType());
									tenderProjectEntity.setIsPack(projectMap.getIsPack());
									tenderProjectEntity.setTenderMethod(projectMap.getTenderMethod());
									int childCount  = projectMap.getChildCount();
									tenderProjectEntity.setChildrenCount(childCount);
									
									GridItem item = new GridItem(allProjectGrid, SWT.NONE);
									item.setData("tenderProjectEntity", tenderProjectEntity);
									item.setData("tenderId", tenderProjectEntity.getId());
									item.setText(0, tenderProjectEntity.getTenderNo());
									item.setText(1, tenderProjectEntity.getTenderName());
									item.setText(2, childCount + "");
									if(selectionTenderProjectMap.containsKey(tenderProjectEntity.getId())){
										item.setChecked(0, true);
										item.setCheckable(0, false);
										item.setGrayed(true);
									}
								}
//								allProjectGrid.resizeColumnWidth();
								pageFoodComposite.refreshPages(projectPage);
								
							}
						}
					});
				}
			}
		}).start();
	}

	/**
	 * @Description: 加入到已选
	 * @author guoyr 
	 */
	private void addAction(){
		for(GridItem gridItem : allProjectGrid.getItems()){
			if(gridItem.getChecked(0) && gridItem.getCheckable(0)){
				gridItem.setChecked(0, true);
				gridItem.setCheckable(0, false);
				gridItem.setGrayed(true);
				TenderProjectEntity tenderProjectEntity = (TenderProjectEntity)gridItem.getData("tenderProjectEntity");
				if(!selectionTenderProjectMap.containsKey(tenderProjectEntity.getId())){
					addSelectoinProject(tenderProjectEntity);
				}
			}
		}
	}
	
	/**
	 * @Description: 删除已选
	 * @author guoyr 
	 */
	private void delAction(){
		GridItem[] selectionItems = selectionProjectGrid.getSelection();
		if(selectionItems.length > 0){
			for(GridItem gridItem : selectionItems){
				TenderProjectEntity tenderProjectEntity = (TenderProjectEntity)gridItem.getData("tenderProjectEntity");
				gridItem.dispose();
				selectionTenderProjectMap.remove(tenderProjectEntity.getId());
				for(GridItem item : allProjectGrid.getItems()){
					String tenderId = (String)item.getData("tenderId");
					if(null != tenderId && tenderId.equals(tenderProjectEntity.getId())){
						item.setChecked(0, false);
						item.setCheckable(0, true);
						item.setGrayed(false);
						break;
					}
				}
			}
		}else {
			MessageDialog.openShortMessage("请选择要删除的项目！");
		}
	}
	
	/**
	 * @Description: 关闭
	 * @author guoyr 
	 */
	private void closeAction(){
		List<TenderProjectEntity> newSectionTenderProjectList = new ArrayList<TenderProjectEntity>();
		for(GridItem item : selectionProjectGrid.getItems()){
			TenderProjectEntity tenderProjectEntity = (TenderProjectEntity)item.getData("tenderProjectEntity");
			newSectionTenderProjectList.add(tenderProjectEntity);
		}
		if(tenderProjectListListener.refreshTenderProjectList(newSectionTenderProjectList)) {
			close();
		}
		
	}
	/**
	 * Return the initial size of the dialog.
	 */
	@Override
	protected Point getInitialSize() {
		ScreenUtils  util = new ScreenUtils();
		return new Point((int)(util.getScreenWight() * 0.8), (int)(util.getScreenHight() * 0.8));
//		return new Point(900, 600);
	}
}
