package com.gx.obe.opening.dialog;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.nebula.widgets.grid.Grid;
import org.eclipse.nebula.widgets.grid.GridColumn;
import org.eclipse.nebula.widgets.grid.GridItem;
import org.eclipse.nebula.widgets.grid.listener.GridCheckedListener;
import org.eclipse.nebula.widgets.grid.listener.GridSelectionListener;
import org.eclipse.swt.SWT;
import org.eclipse.swt.core.ImageResolver;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.utils.GridUtils;
import org.eclipse.swt.core.widgets.EButton;
import org.eclipse.swt.core.widgets.EDialog;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.core.widgets.EMenu;
import org.eclipse.swt.core.widgets.ImageButton;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;

import com.gx.obe.ColorConstants;
import com.gx.obe.business.entity.MenuFunction;
import com.gx.obe.business.enumeration.MenuFunctionEnum;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.utils.MenuFunctionUtils;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.I18NEnum;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.ScreenUtils;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.service.SupplierService;
import com.gx.obe.web.service.TenderProjectService;
import com.gx.obe.web.vo.TenderPackOpeningInfo;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

public class BatchMultyProjectRemoteBidOpeningDialog extends EDialog {

	private Grid grid;
	private String bidopeningStage;
	private TenderProjectService tenderProjectService;
	private SupplierService supplierService = new SupplierService();
	private String PACK_NAME = "包件";
	private String SUPPLIER_NAME = "供应商";
	private GridColumn supplierCountColumn;
	private EButton confirmBtn;
	private ImageButton complateBtn;
	private ImageButton unComplateBtn;
	private ImageButton curBtn;
	private ELink synchronizedInfoBtn;
	private boolean synchronizedInfoOnly = false;
	boolean filterLessThanThree = false;
	private boolean isFocus = false;
	private GridColumn signCountColumn;
	private GridColumn effectiveCountColumn;
	private ELink selectionAllSignBtn;
	private ELink selectionInvertBtn;
	private List<TenderProjectEntity> tenderProjectList;
	private List<TenderProjectEntity> selectTenderProjectList;
	private GridColumn indexColumn;
	private MenuFunctionUtils menuFunctions;

	/**
	 * Create the dialog.
	 * @param parentShell
	 */
	public BatchMultyProjectRemoteBidOpeningDialog(Shell parentShell, List<TenderProjectEntity> tenderProjectList, String bidopeningStage, MenuFunctionUtils menuFunctions) {
		super(parentShell);
		this.tenderProjectList = tenderProjectList;
		this.bidopeningStage = bidopeningStage;
		this.menuFunctions = menuFunctions;
		if(null != parentShell.getData("isFocus")){
			isFocus = true;
		}
	}

	/**
	 * Create contents of the dialog.
	 * @param parent
	 */
	@Override
	protected Control createDialogArea(Composite parent) {
		Composite container = (Composite) super.createDialogArea(parent);
		container.setLayout(new GridLayout(1, false));
		
		Composite composite_3 = new Composite(container, SWT.NONE);
		composite_3.setBackground(ColorConstants.BORDER_LINE_COLOR);
		composite_3.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_composite_3 = new GridLayout(1, false);
		gl_composite_3.verticalSpacing = 1;
		gl_composite_3.horizontalSpacing = 1;
		gl_composite_3.marginHeight = 1;
		gl_composite_3.marginWidth = 1;
		composite_3.setLayout(gl_composite_3);
		
		Composite composite = new Composite(composite_3, SWT.NONE);
		composite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		composite.setLayout(new GridLayout(6, false));
		composite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		
		complateBtn = new ImageButton(composite, SWT.NONE);
		complateBtn.setSelectionForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		complateBtn.setSelectionBgColor(ColorConstants.BUTTON_BG);
		complateBtn.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		complateBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				listTenderPack(true);
			}
		});
		complateBtn.setText("已启动解密");
		
		unComplateBtn = new ImageButton(composite, SWT.NONE);
		unComplateBtn.setSelectionBgColor(ColorConstants.BUTTON_BG);
		unComplateBtn.setSelectionForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		unComplateBtn.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1));
		unComplateBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				listTenderPack(false);
			}
		});
		unComplateBtn.setText("未启动解密");
		
		
		ELink selectionAllEffectiveBtn = new ELink(composite, SWT.NONE);
		selectionAllEffectiveBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		selectionAllEffectiveBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/select_all.png"));
		selectionAllEffectiveBtn.setText("全选(有效投标超过三家)");
		selectionAllEffectiveBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				selectionAction(1);
			}
		});
		
		selectionAllSignBtn = new ELink(composite, SWT.NONE);
		selectionAllSignBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		selectionAllSignBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/select_all.png"));
		selectionAllSignBtn.setText("全选(签到超过3家)");
		selectionAllSignBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				selectionAction(2);
			}
		});
		
		
		selectionInvertBtn = new ELink(composite, SWT.NONE);
		selectionInvertBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		selectionInvertBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/switch.png"));
		selectionInvertBtn.setText(Messages.Button_selectInvert);
		selectionInvertBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				selectionAction(-1);
			}
		});
		
		ELink selectionNoBtn = new ELink(composite, SWT.NONE);
		selectionNoBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		selectionNoBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/disselect_all.png"));
		selectionNoBtn.setText(Messages.Button_deselected);
		selectionNoBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				selectionAction(0);
			}
		});
		
		Composite composite_1 = new Composite(composite_3, SWT.NONE);
		composite_1.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_composite_1 = new GridLayout(1, false);
		gl_composite_1.marginHeight = 0;
		gl_composite_1.marginWidth = 0;
		composite_1.setLayout(gl_composite_1);
		
		
		
		grid = new Grid(composite_1, SWT.V_SCROLL);
		grid.setHeaderVisible(true);
		grid.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		indexColumn = new GridColumn(grid, SWT.NONE);
		indexColumn.setText(Messages.Num);
		indexColumn.setWidth(150);
		indexColumn.setWidth(50);
		indexColumn.setMaxmumWidth(50);
		
		GridColumn packNameColumn = new GridColumn(grid, SWT.CHECK);
		packNameColumn.setText("项目");
		packNameColumn.setWidth(250);
		packNameColumn.setMinimumWidth(150);
		packNameColumn.setWordWrap(true);
		
		supplierCountColumn = new GridColumn(grid, SWT.CENTER);
		supplierCountColumn.setText("投标家数");
		supplierCountColumn.setWidth(80);
		supplierCountColumn.setMaxmumWidth(80);
		
		effectiveCountColumn = new GridColumn(grid, SWT.CENTER);
		effectiveCountColumn.setText("有效家数");
		effectiveCountColumn.setWidth(80);
		effectiveCountColumn.setMaxmumWidth(80);
		
		signCountColumn = new GridColumn(grid, SWT.CENTER);
		signCountColumn.setText("签到家数");
		signCountColumn.setWidth(80);
		signCountColumn.setMaxmumWidth(80);
		
		Composite composite_2 = new Composite(container, SWT.NONE);
		composite_2.setLayout(new GridLayout(4, false));
		composite_2.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		synchronizedInfoBtn = new ELink(composite_2, SWT.NONE);
		synchronizedInfoBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				confirmAction(true);
			}
		});
		synchronizedInfoBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		synchronizedInfoBtn.setText("仅同步解密信息");
		
		Label label = new Label(composite_2, SWT.NONE);
		label.setForeground(SWTResourceManager.getColor(255, 69, 0));
		label.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		label.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, false, 1, 1));
		label.setText(Messages.Tips_checkSynchronizNewTenderInfo);
		
		confirmBtn = new EButton(composite_2, SWT.NONE);
		confirmBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				confirmAction(false);
			}
		});
		GridData gd_button = new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1);
		gd_button.widthHint = 90;
		confirmBtn.setLayoutData(gd_button);
		confirmBtn.setText(Messages.Button_confirm);
		
		EButton button_1 = new EButton(composite_2, SWT.NONE);
		GridData gd_button_1 = new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1);
		gd_button_1.widthHint = 90;
		button_1.setLayoutData(gd_button_1);
		button_1.setText(Messages.Button_cancel);
		button_1.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				getShell().close();
			}
		});
		tenderProjectService = new TenderProjectService();
		init();
		return container;
	}
	
	/**
	 * @Description: 
	 * @author guoyr 
	 */
	private void init(){
//		filterLessThanThree = PropertiesUtils.getProperty(ConfigConstants.LESS_THAN_THREE_FILTER, "00").equals("01"); 
		filterLessThanThree = !MenuFunction.HIDE.equals(menuFunctions.getAuthority(MenuFunctionEnum.LESS_THAN_THREE_FILTER)) ? true : false;
		
		grid.setAutoHeight(true);
		grid.setItemHeight(Constants.ROW_HIGHT);
		indexColumn.setTreeIndent(0);
		grid.setAutoHeight(true);
		grid.setTreeLinesVisible(false);
		indexColumn.setTreeTogglePic(ImageResolver.RESOLVER_INSTANCE.loadImage(IconsActivator.PLUGIN_ID,"icons/tree_expend.png"), ImageResolver.RESOLVER_INSTANCE.loadImage(IconsActivator.PLUGIN_ID,"icons/tree_close.png"));
		indexColumn.setShowTreeTogglePic(true);
		indexColumn.setTree(true);
		
		String tenderType = "";
		if(null != tenderProjectList && tenderProjectList.size() > 0){
			tenderProjectList.get(0);
			tenderType = tenderProjectList.get(0).getTenderType();
		}
		PACK_NAME = com.gx.obe.components.core.I18N.getString(I18NEnum.SUBPACKAGE, tenderType);
		SUPPLIER_NAME = com.gx.obe.components.core.I18N.getString(I18NEnum.SUPPLIERNAME, tenderType);
		
		if(isFocus){
			signCountColumn.setVisible(false);
			((GridData)selectionAllSignBtn.getLayoutData()).exclude = true;
			selectionAllSignBtn.setVisible(false);
		}
		
		listTenderPack(false);
		
		// 添加投标人表格的选中事件和右键菜单事件
		grid.addListener(SWT.Selection, new GridSelectionListener(){
			public void rightMouseButtonDown(GridItem item) {
				supplierMenuDetectAction();
			}
			
		});
		synchronizedInfoBtn.setVisible(false);
		synchronizedInfoBtn.setEnabled(false);
		((GridData)selectionInvertBtn.getLayoutData()).exclude = true;
		selectionInvertBtn.setVisible(false);
		final String keyCharacter = PropertiesUtils.getProperty("keyCharacter", "g");
		if(null != keyCharacter && keyCharacter.length() > 0){
			final Listener keyListener = new Listener() {
				public void handleEvent(Event e) {
					if ((e.stateMask == SWT.CTRL) && e.keyCode == keyCharacter.charAt(0)){
						boolean visible = !synchronizedInfoBtn.getVisible();
						synchronizedInfoBtn.setVisible(visible);
						synchronizedInfoBtn.setEnabled(visible);
						// 仅同步时允许启动
						confirmBtn.setEnabled(!visible);
						((GridData)selectionInvertBtn.getLayoutData()).exclude = !visible;
						selectionInvertBtn.setVisible(visible);
						selectionInvertBtn.getParent().layout();
					}
				}
			};
			
			grid.getDisplay().addFilter(SWT.KeyDown, keyListener);;
			grid.addDisposeListener(new DisposeListener() {
				public void widgetDisposed(DisposeEvent e) {
					grid.getDisplay().removeFilter(SWT.KeyDown, keyListener);  
				}
			});
		}
		grid.addListener(SWT.Selection, new GridCheckedListener(1, false));
	}
	
	/**
	 * @Description: 投标人右建菜单
	 * @author guoyr
	 */
	private void supplierMenuDetectAction(){
		if(grid.getSelectionCount() > 0){
			final GridItem gridItem = grid.getSelection()[0];
			if(null != gridItem.getData("isComplate")){
				final EMenu gmenu = new EMenu(getShell());
				gmenu.addMenuItem("允许重新解密", ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/ok.png"), true, new EMenu.ClickListener() {
					public void click() {
						gridItem.setCheckVisible(1, true);
						gridItem.setChecked(1, true);
						GridItem projectItem = gridItem.getParentItem();
						if(null != projectItem){
							projectItem.setCheckVisible(1, true);
							projectItem.setChecked(1, true);
							GridUtils.refreshGridCheckedStatus(projectItem, 1);
						}else if(gridItem.getItemCount() > 0){
							for(GridItem childItem : gridItem.getItems()){
								childItem.setCheckVisible(1, true);
								childItem.setChecked(1, true);
							}
						}
					}
				});
				gmenu.addMenuItem("允许所有已开启解密的重新解密", ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/ok.png"), true, new EMenu.ClickListener() {
					public void click() {
						for(GridItem gridItem : grid.getItems()){
							gridItem.setCheckVisible(1, true);
							gridItem.setChecked(1, true);
							gridItem.setGrayed(1, false);
						}
					}
				});
				gmenu.open();
			}
		}
	}
	
	private void listTenderPack(final boolean isShowComplateOnly){
		if(null != curBtn){
			if(!curBtn.getEnabled()){
				return;
			}
			curBtn.setSelection(false);
		}
		if(isShowComplateOnly){
			curBtn = complateBtn;
		}else {
			curBtn = unComplateBtn;
		}
		curBtn.setSelection(true);
		complateBtn.setEnabled(false);
		unComplateBtn.setEnabled(false);
		grid.removeAll();
		new Thread(new Runnable(){
			private int projectIndex = 1;
			public void run(){
				if(null != tenderProjectList && tenderProjectList.size() > 0){
					List<TenderProjectEntity> allProjectList = new ArrayList<TenderProjectEntity>();
					allProjectList.addAll(tenderProjectList);
					final boolean isPriceStage = null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_PRICE) ? true : false;
					for(final TenderProjectEntity tenderProjectEntity : allProjectList){
						if(null != tenderProjectEntity.getChildList() && tenderProjectEntity.getChildList().size() > 0){
							final List<TenderPackOpeningInfo> tenderPackOpeningInfoList = tenderProjectService.getTenderPackOpeningInfoList(tenderProjectEntity.getId(), bidopeningStage);
							Display.getDefault().syncExec(new Runnable(){
								public void run(){
									if(!grid.isDisposed()){
										int projectTenderCount = 0;
										int projectEffectiveCount = 0;
										int projectSignCount = 0;
										GridItem projectGridItem = null;
										boolean projectIsStart = false;
										int index = 1;
										for(TenderPackOpeningInfo tenderPackOpeningInfo : tenderPackOpeningInfoList){
											TenderProjectEntity tenderPack = tenderPackOpeningInfo.getTenderProject();
											String startBidOpening = tenderPack.getStartBidOpening();
											if(isPriceStage){
												startBidOpening = tenderPack.getStartPriceBidOpening();
											}
											if(!isFocus && (null == startBidOpening || !startBidOpening.equals(CommonEnum.YES))){
												// 未开启开标大厅的不能解密
												continue;
											}
											boolean isComplate = false;
											if(isPriceStage){
												if(null != tenderPack.getPriceBidStatus() && (tenderPack.getPriceBidStatus().equals(CommonEnum.IN_PROGRESS) || tenderPack.getPriceBidStatus().equals(CommonEnum.COMPLETE))){
													isComplate = true;
												}
											}else {
												if(null != tenderPack.getBusinessBidStatus() && (tenderPack.getBusinessBidStatus().equals(CommonEnum.IN_PROGRESS) || tenderPack.getBusinessBidStatus().equals(CommonEnum.COMPLETE))){
													isComplate = true;
												}
											}
											if(isShowComplateOnly){
												if(!isComplate){
													continue;
												}
											}else if(isComplate){
												continue;
											}
											if(!projectIsStart){
												projectIsStart = isComplate;
											}
											int effectiveCount = tenderPackOpeningInfo.getTenderCount() - tenderPackOpeningInfo.getRevokeCount() - Math.max(tenderPackOpeningInfo.getDecFailCount(), tenderPackOpeningInfo.getNoPriceCount());
											projectTenderCount += tenderPackOpeningInfo.getTenderCount();
											projectSignCount += tenderPackOpeningInfo.getSignCount();
											projectEffectiveCount += effectiveCount;
											if(null == projectGridItem){
												projectGridItem = addGridItem(tenderProjectEntity, null, projectIndex+"", projectTenderCount, projectEffectiveCount, projectSignCount, projectIsStart);
											}
											addGridItem(tenderPack, projectGridItem, projectIndex+"."+index, tenderPackOpeningInfo.getTenderCount(), effectiveCount, tenderPackOpeningInfo.getSignCount(), isComplate);
											index++;
										}
										if(null != projectGridItem){
											projectGridItem.setData("tenderCount", projectTenderCount);
											projectGridItem.setData("effectiveCount", projectEffectiveCount);
											projectGridItem.setData("signCount", projectSignCount);
											projectGridItem.setText(2, projectTenderCount+"");
											projectGridItem.setText(3, projectEffectiveCount+"");
											projectGridItem.setText(4, projectSignCount+"");
											if(projectEffectiveCount == projectSignCount){
												projectGridItem.setForeground(4, SWTResourceManager.getColor(SWT.COLOR_DARK_GREEN));
											}
											if(projectIsStart){
												projectGridItem.setData("isComplate", true);
												projectGridItem.setCheckVisible(1, false);
												projectGridItem.setImage(1, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/ok.png"));
											}
											if(projectTenderCount < 3) {
												projectGridItem.setForeground(1, SWTResourceManager.getColor(SWT.COLOR_RED));
												projectGridItem.setForeground(2, SWTResourceManager.getColor(SWT.COLOR_RED));
												if(projectTenderCount == 0) {
													projectGridItem.setCheckVisible(1, false);
													projectGridItem.setImage(1, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/warning.png"));
													projectGridItem.setToolTipText(1, "未投标！");
												}
											}
											projectGridItem.setExpanded(true);
//											projectGridItem.setCheckable(1, false);
											projectIndex ++;
										}
										
									}
								}
							});
						}else {
							final TenderPackOpeningInfo tenderPackOpeningInfo = tenderProjectService.getTenderPackOpeningInfo(tenderProjectEntity.getId(), bidopeningStage);
							final TenderProjectEntity _tenderProject = tenderPackOpeningInfo.getTenderProject();
							boolean isComplate = false;
							if(isPriceStage){
								if(null != _tenderProject.getPriceBidStatus() && (_tenderProject.getPriceBidStatus().equals(CommonEnum.IN_PROGRESS) || _tenderProject.getPriceBidStatus().equals(CommonEnum.COMPLETE))){
									isComplate = true;
								}
							}else {
								if(null != _tenderProject.getBusinessBidStatus() && (_tenderProject.getBusinessBidStatus().equals(CommonEnum.IN_PROGRESS) || _tenderProject.getBusinessBidStatus().equals(CommonEnum.COMPLETE))){
									isComplate = true;
								}
							}
							
							if(isShowComplateOnly){
								if(!isComplate){
									continue;
								}
							}else if(isComplate){
								continue;
							}
							final int effectiveCount = tenderPackOpeningInfo.getTenderCount() - tenderPackOpeningInfo.getRevokeCount() - (Math.max(tenderPackOpeningInfo.getDecFailCount(), tenderPackOpeningInfo.getNoPriceCount()));
							final boolean _isComplate = isComplate;
							Display.getDefault().syncExec(new Runnable(){
								public void run(){
									if(!grid.isDisposed()){
										addGridItem(_tenderProject, null, projectIndex+"", tenderPackOpeningInfo.getTenderCount(), effectiveCount, tenderPackOpeningInfo.getSignCount(), _isComplate);
									}
								}
							});
							projectIndex++;
						}
					}
				}
				Display.getDefault().syncExec(new Runnable(){
					public void run(){
						if(!complateBtn.isDisposed()){
							complateBtn.setEnabled(true);
							unComplateBtn.setEnabled(true);
						}
					}
				});
			}
		}).start();
	}
	
	private GridItem addGridItem(TenderProjectEntity tenderProjectEntity, GridItem parentItem, String index, int tenderCount, int effectiveCount, int signCount, boolean isComplate){
		GridItem gridItem = null;//new GridItem(null != parentItem ? parentItem : grid, SWT.NONE);;
		if(null != parentItem ){
			gridItem = new GridItem(parentItem, SWT.NONE);
		}else {
			
			gridItem = new GridItem(grid, SWT.NONE);
		}
		gridItem.setData("effectiveCount", effectiveCount);
		gridItem.setData("signCount", signCount);
		gridItem.setData("tenderProjectEntity", tenderProjectEntity);
		gridItem.setText(0, index);
		gridItem.setText(1, "["+tenderProjectEntity.getTenderNo() + "]"+ tenderProjectEntity.getTenderName());
		if(tenderCount == 0){
			gridItem.setCheckVisible(1, false);
		}else if(signCount == 0){
//			gridItem.setCheckVisible(1, false);
		}
		
		int minSupplierCount = 3;
		if(TenderProjectEnum.JZXTP.equals(tenderProjectEntity.getTenderMethod())){
			minSupplierCount = 2;
		}else if(TenderProjectEnum.DYLY.equals(tenderProjectEntity.getTenderMethod())){
			minSupplierCount = 1;
		}
			
		if(!CommonEnum.YES.equals(tenderProjectEntity.getIsPack())) {
			if((filterLessThanThree || TenderProjectEnum.GKZB.equals(tenderProjectEntity.getTenderMethod())|| TenderProjectEnum.YQZB.equals(tenderProjectEntity.getTenderMethod())) && tenderCount < minSupplierCount){
				gridItem.setCheckVisible(1, false);
				gridItem.setImage(1, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/warning.png"));
				gridItem.setToolTipText(1, "有效投标家数不足"+minSupplierCount+"家！");
			}
			if(tenderCount < 3) {
				gridItem.setForeground(1, SWTResourceManager.getColor(SWT.COLOR_RED));
				gridItem.setForeground(2, SWTResourceManager.getColor(SWT.COLOR_RED));
				if(tenderCount == 0) {
					gridItem.setCheckVisible(1, false);
					gridItem.setImage(1, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/warning.png"));
					gridItem.setToolTipText(1, "未投标！");
				}
			}
		}
		if(isComplate){
			gridItem.setData("isComplate", true);
			gridItem.setCheckVisible(1, false);
			gridItem.setImage(1, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/ok.png"));
		}
		gridItem.setText(2, tenderCount+"");
		gridItem.setFont(2, SWTResourceManager.getFont("微软雅黑", 11, SWT.BOLD));
		
		gridItem.setText(3, effectiveCount+"");
		gridItem.setFont(3, SWTResourceManager.getFont("微软雅黑", 11, SWT.BOLD));
		
		gridItem.setText(4, signCount+"");
		gridItem.setFont(4, SWTResourceManager.getFont("微软雅黑", 11, SWT.BOLD));
		if(effectiveCount < 3){
			gridItem.setForeground(3, SWTResourceManager.getColor(SWT.COLOR_RED));
			if(null != parentItem){
				parentItem.setForeground(4, SWTResourceManager.getColor(SWT.COLOR_RED));
			}
		}
		if(signCount < 3){
			gridItem.setForeground(4, SWTResourceManager.getColor(SWT.COLOR_RED));
			if(null != parentItem){
				parentItem.setForeground(4, SWTResourceManager.getColor(SWT.COLOR_RED));
			}
		}else if(effectiveCount == signCount){
			gridItem.setForeground(4, SWTResourceManager.getColor(SWT.COLOR_DARK_GREEN));
		}
		return gridItem;
	}
	
	/**
	 * @Description: 全选、反选和取消选择
	 * @author guoyr
	 * @param selectionType 
	 */
	private void selectionAction(int selectionType){
		if(selectionType == 1 || selectionType == 2){
			GridUtils.checkAll(grid, 1, false);
			int selectProjectCount = 0;
			int noSelectProjectCount = 0;
			int selectPackCount = 0;
			int noSelectPackCount = 0;
			String filterType = "effectiveCount";
			if(selectionType == 2){
				filterType = "signCount";
			}
			for(GridItem gridItem : grid.getItems()){
				if(gridItem.getItemCount() > 0){
					int selectChildCount = 0;
					for(GridItem chidItem : gridItem.getItems()){
						if(!chidItem.getCheckVisible(1))continue;
						int effectiveCount = (Integer)chidItem.getData(filterType);
						if(effectiveCount < 3){
							continue;
						}
						selectChildCount ++;
						chidItem.setChecked(1, true);
					}
					selectPackCount += selectChildCount;
					noSelectPackCount += (gridItem.getItemCount() - selectPackCount);
					if(selectChildCount > 0){
						selectProjectCount ++;
						gridItem.setChecked(1, true);
					}else {
						noSelectProjectCount ++;
					}
					GridUtils.refreshGridCheckedStatus(gridItem, 1);
				}else if(null == gridItem.getParentItem()){
					if(!gridItem.getCheckVisible(1))continue;
					int effectiveCount = (Integer)gridItem.getData(filterType);
					if(effectiveCount < 3){
						noSelectProjectCount ++;
					}else {
						gridItem.setChecked(1, true);
						selectProjectCount ++;
					}
				}
			}
			
			String msg = "没有可选的项目！";
			if(selectProjectCount > 0){
				msg = getSelectionMessage(selectProjectCount, noSelectProjectCount, selectPackCount, noSelectPackCount);
				if(noSelectProjectCount > 0 || noSelectPackCount > 0){
					if(selectionType == 1){
						msg += "有效投标家数不足三家未选择（如需选择请手动选择）！";
					}else {
						msg += "在线签到家数不足三家未选择（如需选择请手动选择）！";
					}
				}
			}
			MessageDialog.openShortMessage(msg);
		}else if(selectionType == -1){
			GridUtils.checkAllBack(grid, 1);
		}else {
			GridUtils.checkAll(grid, 1, false);
		}
	}

	private String getSelectionMessage(int selectProjectCount, int noSelectProjectCount, int selectPackCount, int noSelectPackCount){
		StringBuilder msg = new StringBuilder();
		if(selectProjectCount > 0){
			msg.append("已选择").append(selectProjectCount).append("个项目");
			if(selectPackCount > 0){
				msg.append("（共计").append(selectPackCount).append(Messages.Number_2).append(PACK_NAME).append("）");
			}
			if(noSelectPackCount > 0 || noSelectProjectCount > 0){
				msg.append("，还有");
				if(noSelectProjectCount > 0){
					msg.append(noSelectProjectCount).append("个项目");
					if(noSelectPackCount > 0){
						msg.append("（共计").append(noSelectPackCount).append(Messages.Number_2).append(PACK_NAME).append("）");
					}
				}else if(noSelectPackCount >0){
					msg.append("共计").append(noSelectPackCount).append(Messages.Number_2).append(PACK_NAME).append("");
				}
			}
		}
		return msg.toString();
	}

	
	/**
	 * @Description: 确认开启远程开标大厅
	 * @author guoyr 
	 */
	private void confirmAction(boolean isSynchronizedInfoOnly){
		this.synchronizedInfoOnly = isSynchronizedInfoOnly;
		if(null != selectTenderProjectList){
			selectTenderProjectList.clear();
		}else {
			selectTenderProjectList = new ArrayList<TenderProjectEntity>();
		}
		
		if(synchronizedInfoBtn.getVisible()){
			if(!isSynchronizedInfoOnly){
				return;
			}
		}

		int selectProjectCount = 0;
		int noSelectProjectCount = 0;
		int selectPackCount = 0;
		int noSelectPackCount = 0;
		for(GridItem gridItem : grid.getItems()){
			TenderProjectEntity tenderProjectEntity = (TenderProjectEntity)gridItem.getData("tenderProjectEntity");
			if(gridItem.getItemCount() > 0){
				List<TenderProjectEntity> childList = new ArrayList<TenderProjectEntity>();
				for(GridItem chidItem : gridItem.getItems()){
					if(chidItem.getCheckVisible(1) && chidItem.getChecked(1)){
						selectPackCount ++;
						TenderProjectEntity tenderPack = (TenderProjectEntity)chidItem.getData("tenderProjectEntity");
						childList.add(tenderPack);
					}else {
						noSelectPackCount ++;
					}
				}
				if(childList.size() > 0){
					tenderProjectEntity.setChildList(childList);
					selectTenderProjectList.add(tenderProjectEntity);
					selectProjectCount ++;
				}else {
					noSelectProjectCount ++;
				}
			}else if(null == gridItem.getParentItem()){
				if(gridItem.getCheckVisible(1) && gridItem.getChecked(1)){
					selectTenderProjectList.add(tenderProjectEntity);
					selectProjectCount ++;
				}else {
					noSelectProjectCount ++;
				}
			}
		}
		if(selectTenderProjectList.size() == 0){
			if(isSynchronizedInfoOnly){
				MessageDialog.openShortMessage("请至少选择一个要同步解密信息的项目！");
			}else {
				MessageDialog.openShortMessage("请至少选择一个要解密的项目！");
			}
			return;
		}
		String msg = getSelectionMessage(selectProjectCount, noSelectProjectCount, selectPackCount, noSelectPackCount);
		if(null != msg && msg.length() > 0){
			if(noSelectProjectCount > 0 || noSelectPackCount > 0){
				msg = msg.concat("未选择，");
			}
		}
		if(isSynchronizedInfoOnly){
			
			if(!MessageDialog.openConfirm(getShell(), Messages.Button_syncDecryptInfo, msg.concat("确认要同步已选择项目的解密信息吗？"), new String[]{"确认同步", Messages.Button_cancel})){
				selectTenderProjectList.clear();
				return;
			}
		}else {
			
			if(isFocus){
				if(!MessageDialog.openConfirm(getShell(), "远程集中解密", msg.concat("确认要远程集中解密已选择的项目吗？"), new String[]{"确认集中解密", Messages.Button_cancel})){
					selectTenderProjectList.clear();
					return;
				}
			}else {
				if(!MessageDialog.openConfirm(getShell(), Messages.Button_decryptRemote, msg.concat("确认要远程解密已选择的项目吗？"), new String[]{"确认远程解密", Messages.Button_cancel})){
					selectTenderProjectList.clear();
					return;
				}
			}
		}
		getShell().close();
	}
	
	
	public boolean isSynchronizedInfoOnly(){
		return synchronizedInfoOnly;
	};
	
	
	public List<TenderProjectEntity> getSelectTenderProjectList(){
		return selectTenderProjectList;
	}

	/**
	 * Return the initial size of the dialog.
	 */
	@Override
	protected Point getInitialSize() {
		ScreenUtils  util = new ScreenUtils();
		return new Point((int)(util.getScreenWight() * 0.7), (int)(util.getScreenHight() * 0.8));
//		return new Point(800, 600);
	}

}
