package com.gx.obe.opening.dialog;

import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.List;

import org.eclipse.nebula.widgets.grid.Grid;
import org.eclipse.nebula.widgets.grid.GridColumn;
import org.eclipse.nebula.widgets.grid.GridItem;
import org.eclipse.nebula.widgets.grid.listener.GridCheckedListener;
import org.eclipse.nebula.widgets.grid.listener.GridSelectionListener;
import org.eclipse.swt.SWT;
import org.eclipse.swt.core.ImageResolver;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.utils.GridUtils;
import org.eclipse.swt.core.widgets.ConfirmDialog;
import org.eclipse.swt.core.widgets.EButton;
import org.eclipse.swt.core.widgets.EDialog;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.core.widgets.EMenu;
import org.eclipse.swt.core.widgets.ImageButton;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;

import com.gx.obe.ColorConstants;
import com.gx.obe.business.entity.MenuFunction;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.utils.MenuFunctionUtils;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.I18NEnum;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.config.ConfigConstants;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.ScreenUtils;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.service.TenderProjectService;
import com.gx.obe.web.vo.TenderPackOpeningInfo;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

public class BatchMultyProjectRemoteSignResultDialog extends EDialog {

	private Grid grid;
	private String bidopeningStage;
	private TenderProjectService tenderProjectService ;
	private String PACK_NAME = "包件";
	private String SUPPLIER_NAME = "供应商";
	private GridColumn supplierCountColumn;
	private EButton confirmBtn;
	private GridColumn confirmCountColumn;
	private ImageButton complateBtn;
	private ImageButton unComplateBtn;
	private ImageButton curBtn;
	private boolean complateOnly = false;
	private ELink complateOnlyBtn;
	private ELink selectionInvertBtn;
	private List<TenderProjectEntity> tenderProjectList;
	private List<TenderPackOpeningInfo> selectTenderProjectList;
	private GridColumn indexColumn;
	private MenuFunctionUtils menuFunctions;
	private String publicType = "01";// 公开类型：默认或01为公开，02：不公开
	
	/**
	 * Create the dialog.
	 * @param parentShell
	 */
	public BatchMultyProjectRemoteSignResultDialog(Shell parentShell, List<TenderProjectEntity> tenderProjectList, String bidopeningStage, MenuFunctionUtils menuFunctions) {
		super(parentShell);
		this.tenderProjectList = tenderProjectList;
		this.bidopeningStage = bidopeningStage;
		this.menuFunctions = menuFunctions;
	}

	/**
	 * Create contents of the dialog.
	 * @param parent
	 */
	@Override
	protected Control createDialogArea(Composite parent) {
		Composite container = (Composite) super.createDialogArea(parent);
		container.setLayout(new GridLayout(1, false));
		
		Composite composite_3 = new Composite(container, SWT.NONE);
		composite_3.setBackground(ColorConstants.BORDER_LINE_COLOR);
		composite_3.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_composite_3 = new GridLayout(1, false);
		gl_composite_3.verticalSpacing = 1;
		gl_composite_3.horizontalSpacing = 1;
		gl_composite_3.marginHeight = 1;
		gl_composite_3.marginWidth = 1;
		composite_3.setLayout(gl_composite_3);
		
		Composite composite = new Composite(composite_3, SWT.NONE);
		composite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		composite.setLayout(new GridLayout(5, false));
		composite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		
		complateBtn = new ImageButton(composite, SWT.NONE);
		complateBtn.setSelectionForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		complateBtn.setSelectionBgColor(ColorConstants.BUTTON_BG);
		complateBtn.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		complateBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				listTenderPack(true);
			}
		});
		complateBtn.setText("已完成开标");
		
		unComplateBtn = new ImageButton(composite, SWT.NONE);
		unComplateBtn.setSelectionBgColor(ColorConstants.BUTTON_BG);
		unComplateBtn.setSelectionForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		unComplateBtn.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		unComplateBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				listTenderPack(false);
			}
		});
		unComplateBtn.setText("未完成开标");
		
		
		ELink selectionAllBtn = new ELink(composite, SWT.NONE);
		selectionAllBtn.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true, false, 1, 1));
		selectionAllBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/select_all.png"));
		selectionAllBtn.setText("全选(已解密超过三家)");
		selectionAllBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				selectionAction(1);
			}
		});
		
		selectionInvertBtn = new ELink(composite, SWT.NONE);
		selectionInvertBtn.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		selectionInvertBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/switch.png"));
		selectionInvertBtn.setText(Messages.Button_selectInvert);
		selectionInvertBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				selectionAction(-1);
			}
		});
		
		ELink selectionNoBtn = new ELink(composite, SWT.NONE);
		selectionNoBtn.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		selectionNoBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/disselect_all.png"));
		selectionNoBtn.setText(Messages.Button_deselected);
		selectionNoBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				selectionAction(0);
			}
		});
		
		Composite composite_1 = new Composite(composite_3, SWT.NONE);
		composite_1.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_composite_1 = new GridLayout(1, false);
		gl_composite_1.marginHeight = 0;
		gl_composite_1.marginWidth = 0;
		composite_1.setLayout(gl_composite_1);
		
		grid = new Grid(composite_1, SWT.V_SCROLL);
		grid.setHeaderVisible(true);
		grid.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		indexColumn = new GridColumn(grid, SWT.NONE);
		indexColumn.setText(Messages.Num);
		indexColumn.setWidth(50);
		indexColumn.setMaxmumWidth(70);
		
		GridColumn packNameColumn = new GridColumn(grid, SWT.CHECK);
		packNameColumn.setText("项目");
		packNameColumn.setMinimumWidth(150);
		packNameColumn.setWordWrap(true);
		
		supplierCountColumn = new GridColumn(grid, SWT.CENTER);
		supplierCountColumn.setText("投标家数");
		supplierCountColumn.setWidth(80);
		supplierCountColumn.setMaxmumWidth(80);
		
		GridColumn signCountColumn = new GridColumn(grid, SWT.CENTER);
		signCountColumn.setText("签到家数");
		signCountColumn.setWidth(80);
		signCountColumn.setMaxmumWidth(80);
		
		GridColumn decCountColumn = new GridColumn(grid, SWT.CENTER);
		decCountColumn.setText("已解密家数");
		decCountColumn.setWidth(80);
		decCountColumn.setMaxmumWidth(80);
		
		GridColumn decFailCountColumn = new GridColumn(grid, SWT.CENTER);
		decFailCountColumn.setText("解密失败家数");
		decFailCountColumn.setWidth(80);
		decFailCountColumn.setMaxmumWidth(100);
		
		confirmCountColumn = new GridColumn(grid, SWT.CENTER);
		confirmCountColumn.setText("已确认家数");
		confirmCountColumn.setWidth(80);
		confirmCountColumn.setMaxmumWidth(80);
		
		Composite composite_2 = new Composite(container, SWT.NONE);
		composite_2.setLayout(new GridLayout(3, false));
		composite_2.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		
		complateOnlyBtn = new ELink(composite_2, SWT.NONE);
		complateOnlyBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				complateAction(true);
			}
		});
		complateOnlyBtn.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1));
		complateOnlyBtn.setText("仅完成解密");
		
		confirmBtn = new EButton(composite_2, SWT.NONE);
		confirmBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				complateAction(false);
			}
		});
		GridData gd_button = new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1);
		confirmBtn.setLayoutData(gd_button);
		confirmBtn.setText(Messages.Button_complateAndUploadOpeningResult);
		
		EButton button_1 = new EButton(composite_2, SWT.NONE);
		GridData gd_button_1 = new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1);
		gd_button_1.widthHint = 90;
		button_1.setLayoutData(gd_button_1);
		button_1.setText(Messages.Button_cancel);
		button_1.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				getShell().close();
			}
		});
		tenderProjectService = new TenderProjectService();
		init();
		return container;
	}
	
	/**
	 * @Description: 
	 * @author guoyr 
	 */
	private void init(){
		grid.setItemHeight(Constants.ROW_HIGHT);
		indexColumn.setTreeIndent(0);
		grid.setTreeLinesVisible(false);
		indexColumn.setTreeTogglePic(ImageResolver.RESOLVER_INSTANCE.loadImage(IconsActivator.PLUGIN_ID,"icons/tree_expend.png"), ImageResolver.RESOLVER_INSTANCE.loadImage(IconsActivator.PLUGIN_ID,"icons/tree_close.png"));
		indexColumn.setShowTreeTogglePic(true);
		indexColumn.setTree(true);
		
		String tenderType = "";
		if(null != tenderProjectList && tenderProjectList.size() > 0){
			tenderProjectList.get(0);
			tenderType = tenderProjectList.get(0).getTenderType();
		}
		PACK_NAME = com.gx.obe.components.core.I18N.getString(I18NEnum.SUBPACKAGE, tenderType);
		SUPPLIER_NAME = com.gx.obe.components.core.I18N.getString(I18NEnum.SUPPLIERNAME, tenderType);
		grid.setAutoHeight(true);
//		if(null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_BUS_TEC)){
//			stageLabel.setImage(ResourceManager.getPluginImage(SWTCoreActivator.PLUGIN_ID, "icons/tender_pager.png"));
//			stageLabel.setText("商务标、技术标 - 远程解密");
//		}else if(null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_PRICE)){
//			stageLabel.setImage(ResourceManager.getPluginImage(SWTCoreActivator.PLUGIN_ID, "icons/tender_pager.png"));
//			stageLabel.setText("经济标 - 远程解密");
//		}else{
//			stageLabel.setText("");
//			
//		}
		
		if(PropertiesUtils.getProperty(ConfigConstants.SHOW_CONFIRM_STATUS, "00").equals("00")){
			confirmCountColumn.setVisible(false);
		}
		
		listTenderPack(false);
		
		// 添加投标人表格的选中事件和右键菜单事件
		grid.addListener(SWT.Selection, new GridSelectionListener(){
			public void rightMouseButtonDown(GridItem item) {
				supplierMenuDetectAction();
			}
			
		});
		
		complateOnlyBtn.setVisible(false);
		complateOnlyBtn.setEnabled(false);
		((GridData)selectionInvertBtn.getLayoutData()).exclude = true;
		selectionInvertBtn.setVisible(false);
		
		final String keyCharacter = PropertiesUtils.getProperty("keyCharacter", "g");
		if(null != keyCharacter && keyCharacter.length() > 0){
			final Listener keyListener = new Listener() {
				public void handleEvent(Event e) {
					if ((e.stateMask == SWT.CTRL) && e.keyCode == keyCharacter.charAt(0)){
						boolean visible = !complateOnlyBtn.getVisible();
						complateOnlyBtn.setVisible(visible);
						complateOnlyBtn.setEnabled(visible);
						// 仅同步时允许启动
						confirmBtn.setEnabled(!visible);
						
						((GridData)selectionInvertBtn.getLayoutData()).exclude = !visible;
						selectionInvertBtn.setVisible(visible);
						selectionInvertBtn.getParent().layout();
					}
				}
			};
			grid.getDisplay().addFilter(SWT.KeyDown, keyListener);;
			grid.addDisposeListener(new DisposeListener() {
				public void widgetDisposed(DisposeEvent e) {
					grid.getDisplay().removeFilter(SWT.KeyDown, keyListener);  
				}
			});
		
		}
		grid.addListener(SWT.Selection, new GridCheckedListener(1, false));
	}
	
	/**
	 * @Description: 投标人右建菜单
	 * @author guoyr
	 */
	private void supplierMenuDetectAction(){
		if(grid.getSelectionCount() > 0){
			final GridItem gridItem = grid.getSelection()[0];
			
			if(null != gridItem.getData("isComplate")){
				final EMenu gmenu = new EMenu(getShell());
				gmenu.addMenuItem("允许重新上传结果", ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/ok.png"), true, new EMenu.ClickListener() {
					public void click() {
						gridItem.setCheckVisible(1, true);
						gridItem.setChecked(1, true);
						GridItem projectItem = gridItem.getParentItem();
						if(null != projectItem){
							projectItem.setCheckVisible(1, true);
							projectItem.setChecked(1, true);
							GridUtils.refreshGridCheckedStatus(projectItem, 1);
						}else if(gridItem.getItemCount() > 0){
							for(GridItem childItem : gridItem.getItems()){
								childItem.setCheckVisible(1, true);
								childItem.setChecked(1, true);
							}
						}
					}
				});
				gmenu.addMenuItem("允许所有已完成的重新上传结果", ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/ok.png"), true, new EMenu.ClickListener() {
					public void click() {
						for(GridItem gridItem : grid.getItems()){
							gridItem.setCheckVisible(1, true);
							gridItem.setChecked(1, true);
							gridItem.setGrayed(1, false);
						}
					}
				});
				gmenu.open();
			}
		}
	}
	
	private void listTenderPack(final boolean isShowComplateOnly){
		if(null != curBtn){
			if(!curBtn.getEnabled()){
				return;
			}
			curBtn.setSelection(false);
		}
		if(isShowComplateOnly){
			curBtn = complateBtn;
		}else {
			curBtn = unComplateBtn;
		}
		curBtn.setSelection(true);
		complateBtn.setEnabled(false);
		unComplateBtn.setEnabled(false);
		grid.removeAll();
		new Thread(new Runnable(){
			private int projectIndex = 1;

			public void run(){
				if(null != tenderProjectList && tenderProjectList.size() > 0){
					final boolean isPriceStage = null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_PRICE) ? true : false;
					for(final TenderProjectEntity tenderProjectEntity : tenderProjectList){
						if(null != tenderProjectEntity.getChildList() && tenderProjectEntity.getChildList().size() > 0){
							final List<TenderPackOpeningInfo> tenderPackOpeningInfoList = tenderProjectService.getTenderPackOpeningInfoList(tenderProjectEntity.getId(), bidopeningStage);
							Display.getDefault().syncExec(new Runnable(){
								public void run(){
									if(!grid.isDisposed()){
										TenderPackOpeningInfo projectOpeningInfo = new TenderPackOpeningInfo(tenderProjectEntity, tenderProjectEntity.getChildList());
										int projectTenderCount = 0;
										int projectSignCount = 0;
										int projectDecCount = 0;
										int projectDecFailCount = 0;
										int projectConfirmCount = 0;
										int projectConfirmQuestionCount = 0;
										GridItem projectGridItem = null;
										boolean projectIsStart = false;
										int index = 1;
										for(TenderPackOpeningInfo tenderPackOpeningInfo : tenderPackOpeningInfoList){
											TenderProjectEntity tenderPack = tenderPackOpeningInfo.getTenderProject();
											boolean isComplate = false;
											if(isPriceStage){
												if(null == tenderPack.getPriceBidStatus() || CommonEnum.NOT_START.equals(tenderPack.getPriceBidStatus())){
													// 如果未启动开标则不能完成
													continue;
												}
												if(null != tenderPack.getPriceBidStatus() && tenderPack.getPriceBidStatus().equals(CommonEnum.COMPLETE)){
													isComplate = true;
												}
											}else {
												if(null == tenderPack.getBusinessBidStatus() || CommonEnum.NOT_START.equals(tenderPack.getBusinessBidStatus())){
													// 如果未启动开标则不能完成
													continue;
												}
												if(null != tenderPack.getBusinessBidStatus() && tenderPack.getBusinessBidStatus().equals(CommonEnum.COMPLETE)){
													isComplate = true;
												}
											}
											if(isShowComplateOnly){
												if(!isComplate){
													continue;
												}
											}else if(isComplate){
												continue;
											}
											if(!projectIsStart){
												projectIsStart = isComplate;
											}
											projectTenderCount += tenderPackOpeningInfo.getTenderCount();
											projectSignCount += tenderPackOpeningInfo.getSignCount();
											projectDecCount += tenderPackOpeningInfo.getDecCount();
											projectDecFailCount += tenderPackOpeningInfo.getDecFailCount();
											projectConfirmCount += tenderPackOpeningInfo.getConfirmCount();
											projectConfirmQuestionCount += tenderPackOpeningInfo.getConfirmQuestionCount();
											projectOpeningInfo.setTenderCount(projectTenderCount);
											projectOpeningInfo.setSignCount(projectSignCount);
											projectOpeningInfo.setDecCount(projectDecCount);
											projectOpeningInfo.setDecFailCount(projectDecFailCount);
											projectOpeningInfo.setConfirmCount(projectConfirmCount);
											projectOpeningInfo.setConfirmQuestionCount(projectConfirmQuestionCount);
											if(null == projectGridItem){
												projectGridItem = addGridItem(projectOpeningInfo, null, projectIndex+"", projectTenderCount, projectSignCount, projectDecCount, projectDecFailCount, projectConfirmCount, projectConfirmQuestionCount, projectIsStart);
											}
											addGridItem(tenderPackOpeningInfo, projectGridItem, projectIndex+"."+index, tenderPackOpeningInfo.getTenderCount(), tenderPackOpeningInfo.getSignCount(), tenderPackOpeningInfo.getDecCount(), tenderPackOpeningInfo.getDecFailCount(), tenderPackOpeningInfo.getConfirmCount(), tenderPackOpeningInfo.getConfirmQuestionCount(), isComplate);
											index++;
										}
										if(null != projectGridItem){
											projectGridItem.setText(2, projectTenderCount+"");
											projectGridItem.setText(3, projectSignCount+"");
											projectGridItem.setText(4, projectDecCount+"");
											projectGridItem.setText(5, projectDecFailCount+"");
											projectGridItem.setText(6, projectConfirmCount+"");
											if(projectTenderCount == 0){
												projectGridItem.setCheckVisible(1, false);
											}else if(projectSignCount == 0){
//												projectGridItem.setCheckVisible(1, false);
											}

											if(projectDecFailCount > 0){
												projectGridItem.setForeground(5, SWTResourceManager.getColor(SWT.COLOR_RED));
											}
											if(confirmCountColumn.getVisible()){
												if(projectDecCount > 0 && projectConfirmCount < projectDecCount){
													projectGridItem.setForeground(6, SWTResourceManager.getColor(SWT.COLOR_RED));
												}
												if(projectConfirmQuestionCount > 0){
													projectGridItem.setForeground(6, SWTResourceManager.getColor(255, 255, 0));
												}
											}
										
											projectGridItem.setExpanded(true);
//											projectGridItem.setCheckable(1, false);
											projectIndex ++;
										}
										
									}
								}
							});
						}else {
							final TenderPackOpeningInfo tenderPackOpeningInfo = tenderProjectService.getTenderPackOpeningInfo(tenderProjectEntity.getId(), bidopeningStage);
							final TenderProjectEntity _tenderProject = tenderPackOpeningInfo.getTenderProject();
							boolean isComplate = false;
							if(isPriceStage){
								if(null != _tenderProject.getPriceBidStatus() && _tenderProject.getPriceBidStatus().equals(CommonEnum.COMPLETE)){
									isComplate = true;
								}
							}else {
								if(null != _tenderProject.getBusinessBidStatus() && _tenderProject.getBusinessBidStatus().equals(CommonEnum.COMPLETE)){
									isComplate = true;
								}
							}
							if(isShowComplateOnly){
								if(!isComplate){
									continue;
								}
							}else if(isComplate){
								continue;
							}
							final boolean _isComplate = isComplate;
							Display.getDefault().syncExec(new Runnable(){
								public void run(){
									if(!grid.isDisposed()){
										addGridItem(tenderPackOpeningInfo,null, projectIndex+"", tenderPackOpeningInfo.getTenderCount(), tenderPackOpeningInfo.getSignCount(), tenderPackOpeningInfo.getDecCount(), tenderPackOpeningInfo.getDecFailCount(), tenderPackOpeningInfo.getConfirmCount(), tenderPackOpeningInfo.getConfirmQuestionCount(), _isComplate);
									}
								}
							});
							projectIndex++;
						}
						
					}
					Display.getDefault().syncExec(new Runnable(){
						public void run(){
							if(!grid.isDisposed()){
//								grid.resizeColumnWidth(0);
							}
						}
					});
				}
				Display.getDefault().syncExec(new Runnable(){
					public void run(){
						if(!complateBtn.isDisposed()){
							complateBtn.setEnabled(true);
							unComplateBtn.setEnabled(true);
						}
					}
				});
			}
		}).start();
	}
	
	private GridItem addGridItem(TenderPackOpeningInfo tenderPackOpeningInfo, GridItem parentItem, String index, int tenderCount, int signCount, int decCount, int decFailCount, int confirmCount, int confirmQuestionCount, boolean isComplate){
		GridItem gridItem = null;//new GridItem(null != parentItem ? parentItem : grid, SWT.NONE);;
		if(null != parentItem ){
			gridItem = new GridItem(parentItem, SWT.NONE);
		}else {
			
			gridItem = new GridItem(grid, SWT.NONE);
		}
		TenderProjectEntity tenderProjectEntity = tenderPackOpeningInfo.getTenderProject();
		gridItem.setData("decCount", decCount);
		gridItem.setData("decFailCount", decFailCount);
		gridItem.setData("confirmCount", confirmCount);
		gridItem.setData("tenderPackOpeningInfo", tenderPackOpeningInfo);
		
		if(isComplate){
			gridItem.setData("isComplate", true);
			gridItem.setCheckVisible(1, false);
			gridItem.setImage(1, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/ok.png"));
		}
		
		gridItem.setFont(SWTResourceManager.getFont("微软雅黑", 11, SWT.BOLD));
		gridItem.setFont(0, SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		gridItem.setFont(1, SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		
		gridItem.setText(0, index+"");
		gridItem.setText(1, "["+tenderProjectEntity.getTenderNo() + "]"+ tenderProjectEntity.getTenderName());
		gridItem.setText(2, tenderCount+"");
		gridItem.setText(3, signCount+"");
		gridItem.setText(4, decCount+"");
		gridItem.setText(5, decFailCount+"");
		gridItem.setText(6, confirmCount+"");
		if(tenderCount == 0){
			gridItem.setCheckVisible(1, false);
			gridItem.setCheckable(1, false);
		}else if(signCount == 0){
//			gridItem.setCheckVisible(1, false);
		}
		if(decCount < 3 || decCount < signCount){
			gridItem.setForeground(4, SWTResourceManager.getColor(SWT.COLOR_RED));
			if(null != parentItem){
				parentItem.setForeground(4, SWTResourceManager.getColor(SWT.COLOR_RED));
			}
		}
		if(tenderPackOpeningInfo.getDecCount() == 0) {
			gridItem.setCheckVisible(1, false);
			gridItem.setCheckable(1, false);
			gridItem.setImage(1, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/warning.png"));
			gridItem.setToolTipText(1, "未解密");
		}

		if(tenderPackOpeningInfo.getDecFailCount() > 0){
			for(int i = 1; i < grid.getColumnCount(); i++){
				gridItem.setForeground(i, SWTResourceManager.getColor(SWT.COLOR_RED));
			}
			gridItem.setCheckVisible(1, false);
			gridItem.setCheckable(1, false);
			gridItem.setToolTipText(1, MessageFormat.format(Messages.Tips_decryptFailedCount, tenderPackOpeningInfo.getDecFailCount()));
			gridItem.setImage(1, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/flag_red.png"));
		}
		
		if(tenderPackOpeningInfo.getNoPriceCount() > 0){
			for(int i = 1; i < grid.getColumnCount(); i++){
				gridItem.setForeground(i, SWTResourceManager.getColor(SWT.COLOR_RED));
			}
			gridItem.setToolTipText(1, MessageFormat.format(Messages.Tips_obtainQuotationFailedCount, tenderPackOpeningInfo.getNoPriceCount()));
			if(tenderPackOpeningInfo.getNoPriceCount() != tenderPackOpeningInfo.getOpeningCount()){
				gridItem.setCheckVisible(1, false);
				gridItem.setCheckable(1, false);
			}
			gridItem.setImage(1, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/about.png"));
		}
		if(confirmCountColumn.getVisible()){
			if(decCount > 0 && confirmCount < decCount){
				gridItem.setForeground(6, SWTResourceManager.getColor(SWT.COLOR_RED));
				if(null != parentItem){
					parentItem.setForeground(6, SWTResourceManager.getColor(SWT.COLOR_RED));
				}
			}else if(decCount > 0 && confirmCount == decCount){
				gridItem.setForeground(6, SWTResourceManager.getColor(SWT.COLOR_DARK_GREEN));
			}
			if(confirmQuestionCount > 0){
				gridItem.setForeground(6, SWTResourceManager.getColor(255, 255, 0));
			}
		}
	
		
		return gridItem;
	}
	
	/**
	 * @Description: 全选、反选和取消选择
	 * @author guoyr
	 * @param selectionType 
	 */
	private void selectionAction(int selectionType){
		if(selectionType == 1){
			GridUtils.checkAll(grid, 1, false);
			int selectProjectCount = 0;
			int noSelectProjectCount = 0;
			int selectPackCount = 0;
			int noSelectPackCount = 0;
			for(GridItem gridItem : grid.getItems()){
				if(gridItem.getItemCount() > 0){
					int selectChildCount = 0;
					for(GridItem chidItem : gridItem.getItems()){
						if(!gridItem.getCheckVisible(1)){
							continue;
						}
						int decCount = (Integer)chidItem.getData("decCount");
						if(decCount < 3){
							continue;
						}
						selectChildCount ++;
						chidItem.setChecked(1, true);
					}
					selectPackCount += selectChildCount;
					noSelectPackCount += (gridItem.getItemCount() - selectPackCount);
					if(selectChildCount > 0){
						selectProjectCount ++;
						gridItem.setChecked(1, true);
					}else {
						noSelectProjectCount ++;
					}
					GridUtils.refreshGridCheckedStatus(gridItem, 1);
				}else if(null == gridItem.getParentItem()){
					if(!gridItem.getCheckVisible(1)){
						continue;
					}
					int decCount = (Integer)gridItem.getData("decCount");
					if(decCount < 3){
						noSelectProjectCount ++;
					}else {
						gridItem.setChecked(1, true);
						selectProjectCount ++;
					}
				}
			}
			
			String msg = "没有可选的项目！";
			if(selectProjectCount > 0){
				msg = getSelectionMessage(selectProjectCount, noSelectProjectCount, selectPackCount, noSelectPackCount);
				if(noSelectPackCount > 0){
					msg += "已解密家数不足三家未选择（如需选择请手动选择）！";
				}
			}
			MessageDialog.openShortMessage(msg);
		}else if(selectionType == -1){
			GridUtils.checkAllBack(grid, 1);
		}else {
			GridUtils.checkAll(grid, 1, false);
		}
	}
	
	private String getSelectionMessage(int selectProjectCount, int noSelectProjectCount, int selectPackCount, int noSelectPackCount){
		StringBuilder msg = new StringBuilder();
		if(selectProjectCount > 0){
			msg.append("已选择").append(selectProjectCount).append("个项目");
			if(selectPackCount > 0){
				msg.append("（共计").append(selectPackCount).append(Messages.Number_2).append(PACK_NAME).append("）");
			}
			if(noSelectPackCount > 0 || noSelectProjectCount > 0){
				msg.append("，其中");
				if(noSelectProjectCount > 0){
					msg.append(noSelectProjectCount).append("个项目");
					if(noSelectPackCount > 0){
						msg.append("（共计").append(noSelectPackCount).append(Messages.Number_2).append(PACK_NAME).append("）");
					}
				}else if(noSelectPackCount >0){
					msg.append("共计").append(noSelectPackCount).append(Messages.Number_2).append(PACK_NAME).append("");
					
				}
			}else {
				msg.append("，");
			}
		}
		return msg.toString();
	}

	
	/**
	 * @Description: 确认开启远程开标大厅
	 * @author guoyr 
	 */
	private void complateAction(boolean complateOnly){
		if(null != selectTenderProjectList){
			selectTenderProjectList.clear();
		}else {
			selectTenderProjectList = new ArrayList<TenderPackOpeningInfo>();
		}
		this.complateOnly = complateOnly;
		if(complateOnlyBtn.getVisible()){
			if(!complateOnly){
				return;
			}
		}

		int selectProjectCount = 0;
		int noSelectProjectCount = 0;
		int selectPackCount = 0;
		int noSelectPackCount = 0;
		for(GridItem gridItem : grid.getItems()){
			TenderPackOpeningInfo tenderProject = (TenderPackOpeningInfo)gridItem.getData("tenderPackOpeningInfo");
			if(gridItem.getItemCount() > 0){
				List<TenderPackOpeningInfo> childList = new ArrayList<TenderPackOpeningInfo>();
				for(GridItem chidItem : gridItem.getItems()){
					if(chidItem.getCheckVisible(1) && chidItem.getChecked(1)){
						selectPackCount ++;
						TenderPackOpeningInfo tenderPack = (TenderPackOpeningInfo)chidItem.getData("tenderPackOpeningInfo");
						childList.add(tenderPack);
					}else {
						noSelectPackCount ++;
					}
				}
				if(childList.size() > 0){
					tenderProject.setTenderPackOpeningInfoList(childList);
					selectTenderProjectList.add(tenderProject);
					selectProjectCount ++;
				}else {
					noSelectProjectCount ++;
				}
			}else if(null == gridItem.getParentItem()){
				if(gridItem.getCheckVisible(1) && gridItem.getChecked(1)){
					selectTenderProjectList.add(tenderProject);
					selectProjectCount ++;
				}else {
					noSelectProjectCount ++;
				}
			}
		}
		if(selectTenderProjectList.size() == 0){
			MessageDialog.openShortMessage("请至少选择一个要完成开标的项目！");
			return;
		}
		String msg = getSelectionMessage(selectProjectCount, noSelectProjectCount, selectPackCount, noSelectPackCount);
		if(noSelectProjectCount > 0 || noSelectPackCount > 0){
			msg = msg+"未选择，";
		}
		if(complateOnly){
			if(!MessageDialog.openConfirm(getShell(), "完成开标", msg.concat("确认将已选择的项目设置为完成开标吗？"), new String[]{"确认完成开标", Messages.Button_cancel})){
				selectTenderProjectList.clear();
				return;
			}
		}else {
			
//			if(!MessageDialog.openConfirm(getShell(), "完成解密并上传结果", msg.concat("完成解密并上传结果后，参与开标的").concat(SUPPLIER_NAME).concat("将会查看到所有").concat(SUPPLIER_NAME).concat("的开标汇总表，确认要进行此操作吗？"), new String[]{"确认完成解密并上传结果", Messages.Button_cancel})){
//				selectTenderProjectList.clear();
//				return;
//			}
			ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), Messages.Button_complateAndUploadOpeningResult, msg.toString().concat(Messages.Tips_confirmComplateAndUploadOpeningResult), null);
			String tenderMethod = selectTenderProjectList.get(0).getTenderProject().getTenderMethod();
			if(null != menuFunctions && MenuFunction.SHOW.equals(menuFunctions.getAuthority("PUBLIC_TYPE"))){
//			 如果是竞争性谈判和竞争性磋商（目前是其他），则需要选择是否公开
				if(!TenderProjectEnum.STAGE_BUS_TEC.equals(bidopeningStage) && (TenderProjectEnum.JZXTP.equals(tenderMethod) || TenderProjectEnum.CONSULTATION.equals(tenderMethod) || TenderProjectEnum.OTHER.equals(tenderMethod))) {
					publicType = "02";
					confirmDialog.addCheckBox("向投标人公开开标一览表汇总表", "01".equals(publicType), new SelectionAdapter() {
						public void widgetSelected(SelectionEvent e) {
							if(confirmDialog.getCheckBtnSelection()) {
								publicType = "01";
								MessageDialog.openShortMessage("参与开标的投标人可以看到开标一览表汇总表！");
							}else {
								MessageDialog.openShortMessage("参与开标的投标人不能看到开标一览表汇总表！");
								publicType = "02";
							}
						}
					});
				}
			}
			confirmDialog.addButton("确认完成开标并上传结果", "01", null);
			confirmDialog.addCancel(Messages.Button_cancel, null);
			confirmDialog.setTipsAlignment(SWT.LEFT);
			confirmDialog.setTips("完成开标并上传结果后，还未成功解密的标书将不能继续解密！");
			confirmDialog.setTipsColor(SWTResourceManager.getColor(255, 0, 0));
			confirmDialog.open();
			if("01".equals(confirmDialog.getClickStatus())){
			}else {
				selectTenderProjectList.clear();
//				return;
			}
		}
		getShell().close();
	}
	
	
	public List<TenderPackOpeningInfo> getSelectTenderPackList(){
		return selectTenderProjectList;
	}

	public boolean isComplateOnly(){
		return complateOnly;
	}
	
	public String getPublicType() {
		return publicType;
	}
	/**
	 * Return the initial size of the dialog.
	 */
	@Override
	protected Point getInitialSize() {
		ScreenUtils  util = new ScreenUtils();
		return new Point((int)(util.getScreenWight() * 0.7), (int)(util.getScreenHight() * 0.8));
//		return new Point(900, 600);
	}

}
