package com.gx.obe.opening.dialog;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.nebula.widgets.grid.Grid;
import org.eclipse.nebula.widgets.grid.GridColumn;
import org.eclipse.nebula.widgets.grid.GridItem;
import org.eclipse.nebula.widgets.grid.listener.GridCheckedListener;
import org.eclipse.nebula.widgets.grid.listener.GridSelectionListener;
import org.eclipse.swt.SWT;
import org.eclipse.swt.core.ImageResolver;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.utils.GridUtils;
import org.eclipse.swt.core.widgets.EButton;
import org.eclipse.swt.core.widgets.EDialog;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.core.widgets.EMenu;
import org.eclipse.swt.core.widgets.ImageButton;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;

import com.gx.obe.ColorConstants;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.I18NEnum;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.ScreenUtils;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.service.TenderProjectService;
import com.gx.obe.web.vo.TenderPackOpeningInfo;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

public class BatchMultyProjectStartBidOpeningHallDialog extends EDialog {

	private Grid grid;
	private List<TenderProjectEntity> tenderProjectList;
	private String bidopeningStage;
	private TenderProjectService tenderProjectService ;
	private String PACK_NAME = "包件";
	private String SUPPLIER_NAME = "供应商";
	private GridColumn supplierCountColumn;
	private EButton confirmBtn;
	private ImageButton complateBtn;
	private ImageButton unComplateBtn;
	private ImageButton curBtn;
	private ELink synchronizedInfoBtn;
	private boolean synchronizedInfoOnly = false;
	private GridColumn effectiveCountColumn;
	private ELink selectionInvertBtn;
	private List<TenderProjectEntity> selectTenderProjectList;
	private GridColumn indexColumn;

	/**
	 * Create the dialog.
	 * @param parentShell
	 */
	public BatchMultyProjectStartBidOpeningHallDialog(Shell parentShell, List<TenderProjectEntity> tenderProjectList, String bidopeningStage) {
		super(parentShell);
		this.tenderProjectList = tenderProjectList;
		this.bidopeningStage = bidopeningStage;
	}

	/**
	 * Create contents of the dialog.
	 * @param parent
	 */
	@Override
	protected Control createDialogArea(Composite parent) {
		Composite container = (Composite) super.createDialogArea(parent);
		container.setLayout(new GridLayout(1, false));
		
		Composite composite_3 = new Composite(container, SWT.NONE);
		composite_3.setBackground(ColorConstants.BORDER_LINE_COLOR);
		composite_3.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_composite_3 = new GridLayout(1, false);
		gl_composite_3.verticalSpacing = 1;
		gl_composite_3.horizontalSpacing = 1;
		gl_composite_3.marginHeight = 1;
		gl_composite_3.marginWidth = 1;
		composite_3.setLayout(gl_composite_3);
		
		Composite composite = new Composite(composite_3, SWT.NONE);
		composite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		composite.setLayout(new GridLayout(5, false));
		composite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		
		complateBtn = new ImageButton(composite, SWT.NONE);
		complateBtn.setSelectionForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		complateBtn.setSelectionBgColor(ColorConstants.BUTTON_BG);
		complateBtn.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		complateBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				listTenderPack(true);
			}
		});
		complateBtn.setText(Messages.Button_openRemoteBidOpeningHallAlready);
		
		unComplateBtn = new ImageButton(composite, SWT.NONE);
		unComplateBtn.setSelectionBgColor(ColorConstants.BUTTON_BG);
		unComplateBtn.setSelectionForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		unComplateBtn.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		unComplateBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				listTenderPack(false);
			}
		});
		unComplateBtn.setText(Messages.Button_openRemoteBidOpeningHallNot);
		
		ELink selectionAllBtn = new ELink(composite, SWT.NONE);
		selectionAllBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/select_all.png"));
		
		selectionAllBtn.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true, false, 1, 1));
		selectionAllBtn.setText("全选(有效投标超过三家)");
		selectionAllBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				selectionAction(1);
			}
		});
		
		selectionInvertBtn = new ELink(composite, SWT.NONE);
		selectionInvertBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		selectionInvertBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/switch.png"));
		selectionInvertBtn.setText(Messages.Button_selectInvert);
		selectionInvertBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				selectionAction(-1);
			}
		});
		
		ELink selectionNoBtn = new ELink(composite, SWT.NONE);
		selectionNoBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		selectionNoBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/disselect_all.png"));
		selectionNoBtn.setText(Messages.Button_deselected);
		selectionNoBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				selectionAction(0);
			}
		});
		
		Composite composite_1 = new Composite(composite_3, SWT.NONE);
		composite_1.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_composite_1 = new GridLayout(1, false);
		gl_composite_1.marginHeight = 0;
		gl_composite_1.marginWidth = 0;
		composite_1.setLayout(gl_composite_1);
		
		
		
		grid = new Grid(composite_1, SWT.V_SCROLL);
		grid.setHeaderVisible(true);
		grid.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		indexColumn = new GridColumn(grid, SWT.NONE);
		indexColumn.setText(Messages.Num);
		indexColumn.setWidth(50);
		indexColumn.setMaxmumWidth(70);
		
		GridColumn packNameColumn = new GridColumn(grid, SWT.CHECK);
		packNameColumn.setCellSelectionEnabled(true);
		packNameColumn.setText("项目");
		packNameColumn.setWidth(250);
		packNameColumn.setMinimumWidth(150);
		packNameColumn.setWordWrap(true);
		
		supplierCountColumn = new GridColumn(grid, SWT.CENTER);
		supplierCountColumn.setText("投标家数");
		supplierCountColumn.setWidth(80);
		supplierCountColumn.setMaxmumWidth(80);
		
		effectiveCountColumn = new GridColumn(grid, SWT.CENTER);
		effectiveCountColumn.setText("有效家数");
		effectiveCountColumn.setWidth(80);
		effectiveCountColumn.setMaxmumWidth(80);
		
//		GridColumn gridColumn = new GridColumn(grid, SWT.NONE);
//		gridColumn.setText("开标大厅开启状态");
//		gridColumn.setWidth(150);
//		
		Composite composite_2 = new Composite(container, SWT.NONE);
		composite_2.setLayout(new GridLayout(3, false));
		composite_2.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		synchronizedInfoBtn = new ELink(composite_2, SWT.NONE);
		synchronizedInfoBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				confirmAction(true);
			}
		});
		synchronizedInfoBtn.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1));
		synchronizedInfoBtn.setText("仅同步签到信息");
		
		confirmBtn = new EButton(composite_2, SWT.NONE);
		confirmBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				confirmAction(false);
			}
		});
		GridData gd_button = new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1);
		gd_button.widthHint = 90;
		confirmBtn.setLayoutData(gd_button);
		confirmBtn.setText(Messages.Button_confirm);
		
		EButton button_1 = new EButton(composite_2, SWT.NONE);
		GridData gd_button_1 = new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1);
		gd_button_1.widthHint = 90;
		button_1.setLayoutData(gd_button_1);
		button_1.setText(Messages.Button_cancel);
		button_1.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				getShell().close();
			}
		});
		tenderProjectService = new TenderProjectService();
		init();
		return container;
	}
	
	/**
	 * @Description: 
	 * @author guoyr 
	 */
	private void init(){
		grid.setItemHeight(Constants.ROW_HIGHT);
		indexColumn.setTreeIndent(0);
		grid.setAutoHeight(true);
		grid.setTreeLinesVisible(false);
		indexColumn.setTreeTogglePic(ImageResolver.RESOLVER_INSTANCE.loadImage(IconsActivator.PLUGIN_ID,"icons/tree_expend.png"), ImageResolver.RESOLVER_INSTANCE.loadImage(IconsActivator.PLUGIN_ID,"icons/tree_close.png"));
		indexColumn.setShowTreeTogglePic(true);
		indexColumn.setTree(true);
		
		String tenderType = "";
		if(null != tenderProjectList && tenderProjectList.size() > 0){
			tenderProjectList.get(0);
			tenderType = tenderProjectList.get(0).getTenderType();
		}
		PACK_NAME = com.gx.obe.components.core.I18N.getString(I18NEnum.SUBPACKAGE, tenderType);
		SUPPLIER_NAME = com.gx.obe.components.core.I18N.getString(I18NEnum.SUPPLIERNAME, tenderType);
		
		listTenderPack(false);
		// 添加投标人表格的选中事件和右键菜单事件
		grid.addListener(SWT.Selection, new GridSelectionListener(){
			public void rightMouseButtonDown(GridItem item) {
				supplierMenuDetectAction();
			}
			
		});
		synchronizedInfoBtn.setVisible(false);
		synchronizedInfoBtn.setEnabled(false);
		((GridData)selectionInvertBtn.getLayoutData()).exclude = true;
		selectionInvertBtn.setVisible(false);
		
		final String keyCharacter = PropertiesUtils.getProperty("keyCharacter", "g");
		if(null != keyCharacter && keyCharacter.length() > 0){
			final Listener keyListener = new Listener() {
				public void handleEvent(Event e) {
					if ((e.stateMask == SWT.CTRL) && e.keyCode == keyCharacter.charAt(0)){
						boolean visible = !synchronizedInfoBtn.getVisible();
						synchronizedInfoBtn.setVisible(visible);
						synchronizedInfoBtn.setEnabled(visible);
						// 仅同步时允许启动
						confirmBtn.setEnabled(!visible);
						((GridData)selectionInvertBtn.getLayoutData()).exclude = !visible;
						selectionInvertBtn.setVisible(visible);
						selectionInvertBtn.getParent().layout();
					}
				}
			};
			
			grid.getDisplay().addFilter(SWT.KeyDown, keyListener);;
			grid.addDisposeListener(new DisposeListener() {
				public void widgetDisposed(DisposeEvent e) {
					grid.getDisplay().removeFilter(SWT.KeyDown, keyListener);  
				}
			});
		}
		grid.addListener(SWT.Selection, new GridCheckedListener(1, false));
	}
	
	/**
	 * @Description: 投标人右建菜单
	 * @author guoyr
	 */
	private void supplierMenuDetectAction(){
		if(grid.getSelectionCount() > 0){
			final GridItem gridItem = grid.getSelection()[0];
			
			if(null != gridItem.getData("isComplate")){
				final EMenu gmenu = new EMenu(getShell());
				gmenu.addMenuItem("允许重新启动远程签到", ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/ok.png"), true, new EMenu.ClickListener() {
					public void click() {
						gridItem.setCheckVisible(1, true);
						gridItem.setChecked(1, true);
						GridItem projectItem = gridItem.getParentItem();
						if(null != projectItem){
							projectItem.setCheckVisible(1, true);
							projectItem.setChecked(1, true);
							GridUtils.refreshGridCheckedStatus(projectItem, 1);
						}else if(gridItem.getItemCount() > 0){
							for(GridItem childItem : gridItem.getItems()){
								childItem.setCheckVisible(1, true);
								childItem.setChecked(1, true);
							}
						}
					}
				});
				gmenu.addMenuItem("允许全部重新启动远程签到", ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/ok.png"), true, new EMenu.ClickListener() {
					public void click() {
						for(GridItem gridItem : grid.getItems()){
							gridItem.setCheckVisible(1, true);
							gridItem.setChecked(1, true);
							gridItem.setGrayed(1, false);
						}
					}
				});
				gmenu.open();
			}
		}
	}
	
	private void listTenderPack(final boolean isShowStartOnly){
		if(null != curBtn){
			if(!curBtn.getEnabled()){
				return;
			}
			curBtn.setSelection(false);
		}
		if(isShowStartOnly){
			curBtn = complateBtn;
		}else {
			curBtn = unComplateBtn;
		}
		curBtn.setSelection(true);
		complateBtn.setEnabled(false);
		unComplateBtn.setEnabled(false);
		grid.removeAll();
		new Thread(new Runnable(){
			private int projectIndex = 1;
			public void run(){
				if(null != tenderProjectList && tenderProjectList.size() > 0){
					final boolean isPriceStage = null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_PRICE) ? true : false;
					for(final TenderProjectEntity tenderProjectEntity : tenderProjectList){
						if(null != tenderProjectEntity.getChildList() && tenderProjectEntity.getChildList().size() > 0){
							final List<TenderPackOpeningInfo> tenderPackOpeningInfoList = tenderProjectService.getTenderPackOpeningInfoList(tenderProjectEntity.getId(), bidopeningStage);
							Display.getDefault().syncExec(new Runnable(){
								public void run(){
									if(!grid.isDisposed()){
										int projectTenderCount = 0;
										int projectEffectiveCount = 0;
										GridItem projectGridItem = null;
										int index = 1;
										boolean projectIsStart = false;
										for(TenderPackOpeningInfo tenderPackOpeningInfo : tenderPackOpeningInfoList){
											TenderProjectEntity tenderPack = tenderPackOpeningInfo.getTenderProject();
											String startBidOpening = tenderPack.getStartBidOpening();
											if(isPriceStage){
												startBidOpening = tenderPack.getStartPriceBidOpening();
											}
											boolean isStart = false;
											if(null != startBidOpening && startBidOpening.equals(CommonEnum.YES)){
												isStart = true;
											}
											if(isStart && !isShowStartOnly){
												continue;
											}
											if(isShowStartOnly){
												if(!isStart){
													continue;
												}
											}else if(isStart){
												continue;
											}
											if(!projectIsStart){
												projectIsStart = isStart;
											}
											int effectiveCount = tenderPackOpeningInfo.getTenderCount() - tenderPackOpeningInfo.getRevokeCount() - Math.max(tenderPackOpeningInfo.getDecFailCount(), tenderPackOpeningInfo.getNoPriceCount());
											projectTenderCount += tenderPackOpeningInfo.getTenderCount();
											projectEffectiveCount += effectiveCount;
											if(null == projectGridItem){
												projectGridItem = addGridItem(tenderProjectEntity, null, projectIndex+"", projectTenderCount, projectEffectiveCount, projectIsStart);
											}
											addGridItem(tenderPack, projectGridItem, projectIndex +"."+index, tenderPackOpeningInfo.getTenderCount(), effectiveCount, isStart);
											index++;
										}
										if(null != projectGridItem){
											projectGridItem.setData("tenderCount", projectTenderCount);
											projectGridItem.setData("effectiveCount", projectEffectiveCount);
											projectGridItem.setText(2, projectTenderCount+"");
											projectGridItem.setText(3, projectEffectiveCount+"");
											if(projectTenderCount == 0){
												projectGridItem.setCheckVisible(1, false);
											}
											if(projectEffectiveCount < 3){
												projectGridItem.setForeground(3, SWTResourceManager.getColor(SWT.COLOR_RED));
												projectGridItem.setForeground(2, SWTResourceManager.getColor(SWT.COLOR_RED));
											}
											if(projectIsStart){
												projectGridItem.setData("isComplate", true);
												projectGridItem.setCheckVisible(1, false);
												projectGridItem.setImage(1, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/ok.png"));
											}
											projectGridItem.setExpanded(true);
//											projectGridItem.setCheckable(1, false);
											projectIndex ++;
										}
										
									}
								}
							});
						
							
						}else {
							final TenderPackOpeningInfo tenderPackOpeningInfo = tenderProjectService.getTenderPackOpeningInfo(tenderProjectEntity.getId(), bidopeningStage);
							final TenderProjectEntity _tenderProject = tenderPackOpeningInfo.getTenderProject();
							String startBidOpening = _tenderProject.getStartBidOpening();
							if(isPriceStage){
								startBidOpening = _tenderProject.getStartPriceBidOpening();
							}
							final boolean isStart = (null != startBidOpening && startBidOpening.equals(CommonEnum.YES))? true : false;
							if(isStart && !isShowStartOnly){
								continue;
							}
							if(isShowStartOnly){
								if(!isStart){
									continue;
								}
							}else if(isStart){
								continue;
							}
							final int effectiveCount = tenderPackOpeningInfo.getTenderCount() - tenderPackOpeningInfo.getRevokeCount() - Math.max(tenderPackOpeningInfo.getDecFailCount(), tenderPackOpeningInfo.getNoPriceCount());
							Display.getDefault().syncExec(new Runnable(){
								public void run(){
									if(!grid.isDisposed()){
										addGridItem(_tenderProject, null, projectIndex+"", tenderPackOpeningInfo.getTenderCount(), effectiveCount, isStart);
									}
								}
							});
							projectIndex++;
						}
					}
				}
				Display.getDefault().syncExec(new Runnable(){
					public void run(){
						if(!complateBtn.isDisposed()){
							complateBtn.setEnabled(true);
							unComplateBtn.setEnabled(true);
						}
					}
				});
			}
		}).start();
	}
	
	private GridItem addGridItem(TenderProjectEntity tenderProjectEntity, GridItem parentItem, String index, int tenderCount, int effectiveCount, boolean isComplate){
		GridItem gridItem = null;//new GridItem(null != parentItem ? parentItem : grid, SWT.NONE);;
		if(null != parentItem ){
			gridItem = new GridItem(parentItem, SWT.NONE);
		}else {
			
			gridItem = new GridItem(grid, SWT.NONE);
		}
		gridItem.setData("tenderCount", tenderCount);
		gridItem.setData("effectiveCount", effectiveCount);
		gridItem.setData("tenderProjectEntity", tenderProjectEntity);
		gridItem.setText(0, index);
		gridItem.setText(1, "["+tenderProjectEntity.getTenderNo() + "]"+ tenderProjectEntity.getTenderName());
		
		gridItem.setFont(2, SWTResourceManager.getFont("微软雅黑", 11, SWT.BOLD));
		gridItem.setFont(3, SWTResourceManager.getFont("微软雅黑", 11, SWT.BOLD));
		gridItem.setText(2, tenderCount+"");
		gridItem.setText(3, effectiveCount+"");
		if(tenderCount == 0){
			gridItem.setCheckVisible(1, false);
		}
		if(effectiveCount < 3){
			gridItem.setForeground(3, SWTResourceManager.getColor(SWT.COLOR_RED));
			gridItem.setForeground(2, SWTResourceManager.getColor(SWT.COLOR_RED));
		}
		if(isComplate){
			gridItem.setData("isComplate", true);
			gridItem.setCheckVisible(1, false);
			gridItem.setImage(1, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/ok.png"));
		}
		return gridItem;
	}
	/**
	 * @Description: 全选、反选和取消选择
	 * @author guoyr
	 * @param selectionType 
	 */
	private void selectionAction(int selectionType){
		if(selectionType == 1){
			GridUtils.checkAll(grid, 1, false);
			int selectProjectCount = 0;
			int noSelectProjectCount = 0;
			int selectPackCount = 0;
			int noSelectPackCount = 0;
			for(GridItem gridItem : grid.getItems()){
				if(gridItem.getItemCount() > 0){
					int selectChildCount = 0;
					for(GridItem chidItem : gridItem.getItems()){
						int effectiveCount = (Integer)chidItem.getData("effectiveCount");
						if(effectiveCount < 3){
							continue;
						}
						selectChildCount ++;
						chidItem.setChecked(1, true);
					}
					selectPackCount += selectChildCount;
					noSelectPackCount += (gridItem.getItemCount() - selectPackCount);
					if(selectChildCount > 0){
						selectProjectCount ++;
						gridItem.setChecked(1, true);
					}else {
						noSelectProjectCount ++;
					}
					GridUtils.refreshGridCheckedStatus(gridItem, 1);
				}else if(null == gridItem.getParentItem()){
					int effectiveCount = (Integer)gridItem.getData("effectiveCount");
					if(effectiveCount < 3){
						noSelectProjectCount ++;
					}else {
						gridItem.setChecked(1, true);
						selectProjectCount ++;
					}
				}
			}
			String msg = "没有可选的项目！";
			if(selectProjectCount > 0){
				msg = getSelectionMessage(selectProjectCount, noSelectProjectCount, selectPackCount, noSelectPackCount);
				if(noSelectPackCount > 0){
					msg += "有效投标家数不足三家未选择（如需选择请手动选择）！";
				}
			}
			MessageDialog.openShortMessage(msg);
		}else if(selectionType == -1){
			GridUtils.checkAllBack(grid, 1);
		}else {
			GridUtils.checkAll(grid, 1, false);
		}
	}
	
	private String getSelectionMessage(int selectProjectCount, int noSelectProjectCount, int selectPackCount, int noSelectPackCount){
		StringBuilder msg = new StringBuilder();
		if(selectProjectCount > 0){
			msg.append("已选择").append(selectProjectCount).append("个项目");
			if(selectPackCount > 0){
				msg.append("（共计").append(selectPackCount).append(Messages.Number_2).append(PACK_NAME).append("）");
			}
			if(noSelectPackCount > 0 || noSelectProjectCount > 0){
				msg.append("，其中");
				if(noSelectProjectCount > 0){
					msg.append(noSelectProjectCount).append("个项目");
					if(noSelectPackCount > 0){
						msg.append("（共计").append(noSelectPackCount).append(Messages.Number_2).append(PACK_NAME).append("）");
					}
				}else if(noSelectPackCount >0){
					msg.append("共计").append(noSelectPackCount).append(Messages.Number_2).append(PACK_NAME).append("");
					
				}
			}
		}
		return msg.toString();
	}

	/**
	 * @Description: 确认开启远程开标大厅
	 * @author guoyr 
	 */
	private void confirmAction(boolean isSynchronizedInfoOnly){
		this.synchronizedInfoOnly = isSynchronizedInfoOnly;
		if(null == selectTenderProjectList){
			selectTenderProjectList = new ArrayList<TenderProjectEntity>();
		}else {
			selectTenderProjectList.clear();
		}
		if(synchronizedInfoBtn.getVisible()){
			if(!isSynchronizedInfoOnly){
				return;
			}
		}

		int selectProjectCount = 0;
		int noSelectProjectCount = 0;
		int selectPackCount = 0;
		int noSelectPackCount = 0;
		for(GridItem gridItem : grid.getItems()){
			TenderProjectEntity tenderProjectEntity = (TenderProjectEntity)gridItem.getData("tenderProjectEntity");
			if(gridItem.getItemCount() > 0){
				List<TenderProjectEntity> childList = new ArrayList<TenderProjectEntity>();
				for(GridItem chidItem : gridItem.getItems()){
					if(chidItem.getChecked(1)){
						selectPackCount ++;
						TenderProjectEntity tenderPack = (TenderProjectEntity)chidItem.getData("tenderProjectEntity");
						childList.add(tenderPack);
					}else {
						noSelectPackCount ++;
					}
				}
				
				if(childList.size() > 0){
					
					tenderProjectEntity.setChildList(childList);
					selectTenderProjectList.add(tenderProjectEntity);
					selectProjectCount ++;
				}else {
					noSelectProjectCount ++;
				}
			}else if(null == gridItem.getParentItem()){
				if(gridItem.getChecked(1)){
					selectTenderProjectList.add(tenderProjectEntity);
					selectProjectCount ++;
				}else {
					noSelectProjectCount ++;
				}
			}
		}
		if(selectTenderProjectList.size() == 0){
			if(isSynchronizedInfoOnly){
				MessageDialog.openShortMessage("请至少选择一个要同步签到信息的项目！");
			}else {
				MessageDialog.openShortMessage("请至少选择一个要启动远程签到的项目！");
			}
			return;
		}
		String msg = getSelectionMessage(selectProjectCount, noSelectProjectCount, selectPackCount, noSelectPackCount);
		if(null != msg && msg.length() > 0){
			if(noSelectProjectCount > 0 || noSelectPackCount > 0){
				msg = msg.concat("未选择，");
			}
		}
		
		if(isSynchronizedInfoOnly){
			if(!MessageDialog.openConfirm(getShell(), "同步签到信息", msg.concat("确认要同步已选择项目的签到信息吗？"), new String[]{"确认同步", Messages.Button_cancel})){
				selectTenderProjectList.clear();
				return;
			}
		}else {
			if(!MessageDialog.openConfirm(getShell(), Messages.Button_openRemoteBidOpeningHall, msg.concat("确认要将已选择的项目启动远程签到吗？"), new String[]{Messages.Button_openRemoteBidOpeningHall, Messages.Button_cancel})){
				selectTenderProjectList.clear();
				return;
			}
		}
		getShell().close();
	
	}
	
	
	public List<TenderProjectEntity> getSelectTenderProjectList(){
		return selectTenderProjectList;
	}
	
	public boolean isSynchronizedInfoOnly(){
		return synchronizedInfoOnly;
	};
	/**
	 * Return the initial size of the dialog.
	 */
	@Override
	protected Point getInitialSize() {
		ScreenUtils  util = new ScreenUtils();
		return new Point((int)(util.getScreenWight() * 0.6), (int)(util.getScreenHight() * 0.7));
//		return new Point(700, 500);
	}

}
