package com.gx.obe.opening.dialog;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.eclipse.nebula.widgets.grid.Grid;
import org.eclipse.nebula.widgets.grid.GridColumn;
import org.eclipse.nebula.widgets.grid.GridItem;
import org.eclipse.nebula.widgets.grid.listener.GridSelectionListener;
import org.eclipse.swt.SWT;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.utils.GridUtils;
import org.eclipse.swt.core.widgets.EButton;
import org.eclipse.swt.core.widgets.EDialog;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.core.widgets.EMenu;
import org.eclipse.swt.core.widgets.ImageButton;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;

import com.gx.obe.ColorConstants;
import com.gx.obe.business.entity.MenuFunction;
import com.gx.obe.business.enumeration.MenuFunctionEnum;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.utils.MenuFunctionUtils;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.I18NEnum;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.message.Messages;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.service.TenderProjectService;
import com.gx.obe.web.vo.TenderPackOpeningInfo;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

public class BatchRemoteBidOpeningDialog extends EDialog {

	private Grid grid;
	private TenderProjectEntity tenderProjectEntity;
	private String bidopeningStage;
	private TenderProjectService tenderProjectService ;
	private GridColumn packNameColumn;
	private String PACK_NAME = "包件";
	private String SUPPLIER_NAME = "供应商";
	private GridColumn supplierCountColumn;
	private EButton confirmBtn;
	private List<TenderProjectEntity> tenderPackList;
	private ImageButton complateBtn;
	private ImageButton unComplateBtn;
	private ImageButton curBtn;
	private ELink synchronizedInfoBtn;
	private boolean synchronizedInfoOnly = false;
	private boolean isFocus = false;
	private GridColumn signCountColumn;
	private GridColumn effectiveCountColumn;
	private ELink selectionAllSignBtn;
	private ELink selectionInvertBtn;
	private MenuFunctionUtils menuFunctions;
	private boolean filterLessThanThree = true;
	private Date bidOpeningTime;
	private ELink selectionAllEffectiveBtn;
	private boolean anonymousAllInfo = false;


	/**
	 * Create the dialog.
	 * @param parentShell
	 */
	public BatchRemoteBidOpeningDialog(Shell parentShell, TenderProjectEntity tenderProjectEntity, Date bidOpeningTime, String bidopeningStage, MenuFunctionUtils menuFunctions, boolean anonymousAllInfo) {
		super(parentShell);
		this.tenderProjectEntity = tenderProjectEntity;
		this.bidopeningStage = bidopeningStage;
		this.bidOpeningTime = bidOpeningTime;
		this.menuFunctions = menuFunctions;
		this.anonymousAllInfo = anonymousAllInfo;
		if(null != parentShell.getData("isFocus")){
			isFocus = true;
		}
	}

	/**
	 * Create contents of the dialog.
	 * @param parent
	 */
	@Override
	protected Control createDialogArea(Composite parent) {
		Composite container = (Composite) super.createDialogArea(parent);
		container.setLayout(new GridLayout(1, false));
		
		Composite composite_3 = new Composite(container, SWT.NONE);
		composite_3.setBackground(ColorConstants.BORDER_LINE_COLOR);
		composite_3.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_composite_3 = new GridLayout(1, false);
		gl_composite_3.verticalSpacing = 1;
		gl_composite_3.horizontalSpacing = 1;
		gl_composite_3.marginHeight = 1;
		gl_composite_3.marginWidth = 1;
		composite_3.setLayout(gl_composite_3);
		
		Composite composite = new Composite(composite_3, SWT.NONE);
		composite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		composite.setLayout(new GridLayout(6, false));
		composite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		
		complateBtn = new ImageButton(composite, SWT.NONE);
		complateBtn.setSelectionForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		complateBtn.setSelectionBgColor(ColorConstants.BUTTON_BG);
		complateBtn.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		complateBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				listTenderPack(true);
			}
		});
		complateBtn.setText("已启动解密");
		
		unComplateBtn = new ImageButton(composite, SWT.NONE);
		unComplateBtn.setSelectionBgColor(ColorConstants.BUTTON_BG);
		unComplateBtn.setSelectionForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		unComplateBtn.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1));
		unComplateBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				listTenderPack(false);
			}
		});
		unComplateBtn.setText("未启动解密");
		
		
		selectionAllEffectiveBtn = new ELink(composite, SWT.NONE);
		selectionAllEffectiveBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		selectionAllEffectiveBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/select_all.png"));
		selectionAllEffectiveBtn.setText("全选(有效投标够3家)");
		selectionAllEffectiveBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				selectionAction(1);
			}
		});
		
		selectionAllSignBtn = new ELink(composite, SWT.NONE);
		selectionAllSignBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		selectionAllSignBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/select_all.png"));
		selectionAllSignBtn.setText("全选(签到够3家)");
		selectionAllSignBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				selectionAction(2);
			}
		});
		
		
		selectionInvertBtn = new ELink(composite, SWT.NONE);
		selectionInvertBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		selectionInvertBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/switch.png"));
		selectionInvertBtn.setText(Messages.Button_selectInvert);
		selectionInvertBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				selectionAction(-1);
			}
		});
		
		ELink selectionNoBtn = new ELink(composite, SWT.NONE);
		selectionNoBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		selectionNoBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/disselect_all.png"));
		selectionNoBtn.setText(Messages.Button_deselected);
		selectionNoBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				selectionAction(0);
			}
		});
		
		Composite composite_1 = new Composite(composite_3, SWT.NONE);
		composite_1.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_composite_1 = new GridLayout(1, false);
		gl_composite_1.marginHeight = 0;
		gl_composite_1.marginWidth = 0;
		composite_1.setLayout(gl_composite_1);
		
		grid = new Grid(composite_1, SWT.V_SCROLL);
		grid.setHeaderVisible(true);
		grid.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		GridColumn indexColumn = new GridColumn(grid, SWT.CENTER);
		indexColumn.setText(Messages.Num);
		indexColumn.setWidth(150);
		indexColumn.setWidth(50);
		indexColumn.setMaxmumWidth(50);
		
		packNameColumn = new GridColumn(grid, SWT.CHECK);
		packNameColumn.setText("包件");
		packNameColumn.setWidth(250);
		packNameColumn.setMinimumWidth(150);
		
		supplierCountColumn = new GridColumn(grid, SWT.CENTER);
		supplierCountColumn.setText("投标家数");
		supplierCountColumn.setWidth(80);
		supplierCountColumn.setMaxmumWidth(80);
		
		effectiveCountColumn = new GridColumn(grid, SWT.CENTER);
		effectiveCountColumn.setText("有效家数");
		effectiveCountColumn.setWidth(80);
		effectiveCountColumn.setMaxmumWidth(80);
		
		signCountColumn = new GridColumn(grid, SWT.CENTER);
		signCountColumn.setText("签到家数");
		signCountColumn.setWidth(80);
		signCountColumn.setMaxmumWidth(80);
		
		Composite composite_2 = new Composite(container, SWT.NONE);
		composite_2.setLayout(new GridLayout(4, false));
		composite_2.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		synchronizedInfoBtn = new ELink(composite_2, SWT.NONE);
		synchronizedInfoBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				synchronizedInfoAction();
			}
		});
		synchronizedInfoBtn.setText("仅同步解密信息");
		
		Label label = new Label(composite_2, SWT.NONE);
		label.setForeground(SWTResourceManager.getColor(255, 69, 0));
		label.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		label.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, false, 1, 1));
		label.setText(Messages.Tips_checkSynchronizNewTenderInfo);
		
		confirmBtn = new EButton(composite_2, SWT.NONE);
		confirmBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				confirmAction();
			}
		});
		GridData gd_button = new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1);
		gd_button.widthHint = 90;
		confirmBtn.setLayoutData(gd_button);
		confirmBtn.setText(Messages.Button_confirm);
		
		EButton button_1 = new EButton(composite_2, SWT.NONE);
		GridData gd_button_1 = new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1);
		gd_button_1.widthHint = 90;
		button_1.setLayoutData(gd_button_1);
		button_1.setText(Messages.Button_cancel);
		button_1.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				getShell().close();
			}
		});
		tenderProjectService = new TenderProjectService();
		init();
		return container;
	}
	
	/**
	 * @Description: 
	 * @author guoyr 
	 */
	private void init(){
		if (anonymousAllInfo) {
	        selectionAllSignBtn.setText(Messages.Button_selectAll);
	        selectionAllEffectiveBtn.setVisible(false);
        }
		filterLessThanThree  = !MenuFunction.HIDE.equals(menuFunctions.getAuthority(MenuFunctionEnum.LESS_THAN_THREE_FILTER)) ? true : false;
		confirmBtn.setEnabled(false);
		grid.setItemHeight(Constants.ROW_HIGHT);
		PACK_NAME = com.gx.obe.components.core.I18N.getString(I18NEnum.SUBPACKAGE, tenderProjectEntity.getTenderType());
		SUPPLIER_NAME = com.gx.obe.components.core.I18N.getString(I18NEnum.SUPPLIERNAME, tenderProjectEntity.getTenderType());
		grid.setAutoHeight(true);
		packNameColumn.setWordWrap(true);
		packNameColumn.setText(PACK_NAME);
		
		if(isFocus){
			signCountColumn.setVisible(false);
			((GridData)selectionAllSignBtn.getLayoutData()).exclude = true;
			selectionAllSignBtn.setVisible(false);
		}
		
		listTenderPack(false);
		
		// 添加投标人表格的选中事件和右键菜单事件
		grid.addListener(SWT.Selection, new GridSelectionListener(){
			public void rightMouseButtonDown(GridItem item) {
				supplierMenuDetectAction();
			}
			
		});
		synchronizedInfoBtn.setVisible(false);
		synchronizedInfoBtn.setEnabled(false);
		((GridData)selectionInvertBtn.getLayoutData()).exclude = true;
		selectionInvertBtn.setVisible(false);
		final String keyCharacter = PropertiesUtils.getProperty("keyCharacter", "g");
		if(null != keyCharacter && keyCharacter.length() > 0){
			final Listener keyListener = new Listener() {
				public void handleEvent(Event e) {
					if ((e.stateMask == SWT.CTRL) && e.keyCode == keyCharacter.charAt(0)){
						boolean visible = !synchronizedInfoBtn.getVisible();
						synchronizedInfoBtn.setVisible(visible);
						synchronizedInfoBtn.setEnabled(visible);
						// 仅同步时允许启动
						confirmBtn.setEnabled(!visible);
						((GridData)selectionInvertBtn.getLayoutData()).exclude = !visible;
						selectionInvertBtn.setVisible(visible);
						selectionInvertBtn.getParent().layout();
					}
				}
			};
			
			grid.getDisplay().addFilter(SWT.KeyDown, keyListener);;
			grid.addDisposeListener(new DisposeListener() {
				public void widgetDisposed(DisposeEvent e) {
					grid.getDisplay().removeFilter(SWT.KeyDown, keyListener);  
				}
			});
		}
	}
	
	/**
	 * @Description: 投标人右建菜单
	 * @author guoyr
	 */
	private void supplierMenuDetectAction(){
		if(grid.getSelectionCount() > 0){
			final GridItem gridItem = grid.getSelection()[0];
			if(null != gridItem.getData("isComplate")){
				final EMenu gmenu = new EMenu(getShell());
				gmenu.addMenuItem("允许重新解密", ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/ok.png"), true, new EMenu.ClickListener() {
					public void click() {
						gridItem.setCheckVisible(1, true);
						gridItem.setChecked(1, true);
					}
				});
				gmenu.addMenuItem("允许所有已开启解密的重新解密", ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/ok.png"), true, new EMenu.ClickListener() {
					public void click() {
						for(GridItem gridItem : grid.getItems()){
							if(null != gridItem.getData("isComplate")){
								gridItem.setCheckVisible(1, true);
								gridItem.setChecked(1, true);
							}
						}
					}
				});
				gmenu.open();
			}
		}
	}
	
	private void listTenderPack(final boolean isShowComplateOnly){
		if(null != curBtn){
			if(!curBtn.getEnabled()){
				return;
			}
			curBtn.setSelection(false);
		}
		if(isShowComplateOnly){
			curBtn = complateBtn;
		}else {
			curBtn = unComplateBtn;
		}
		curBtn.setSelection(true);
		complateBtn.setEnabled(false);
		unComplateBtn.setEnabled(false);
		grid.removeAll();
		new Thread(new Runnable(){
			public void run(){
				final List<TenderPackOpeningInfo> tenderPackOpeningInfoList = tenderProjectService.getTenderPackOpeningInfoList(tenderProjectEntity.getId(), bidopeningStage);
				final boolean isPriceStage = null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_PRICE) ? true : false;
				Display.getDefault().syncExec(new Runnable(){
					public void run(){
						if(!grid.isDisposed()){
							int index = 1;
							for(TenderPackOpeningInfo tenderPackOpeningInfo : tenderPackOpeningInfoList){
								TenderProjectEntity tenderPack = tenderPackOpeningInfo.getTenderProject();
								String startBidOpening = tenderPack.getStartBidOpening();
								if(isPriceStage){
									startBidOpening = tenderPack.getStartPriceBidOpening();
								}
								if(!isFocus && (null == startBidOpening || !startBidOpening.equals(CommonEnum.YES))){
									// 未开启开标大厅的不能解密
									continue;
								}
								boolean isComplate = false;
								if(isPriceStage){
									if(null != tenderPack.getPriceBidStatus() && (tenderPack.getPriceBidStatus().equals(CommonEnum.IN_PROGRESS) || tenderPack.getPriceBidStatus().equals(CommonEnum.COMPLETE))){
										isComplate = true;
									}
								}else {
									if(null != tenderPack.getBusinessBidStatus() && (tenderPack.getBusinessBidStatus().equals(CommonEnum.IN_PROGRESS) || tenderPack.getBusinessBidStatus().equals(CommonEnum.COMPLETE))){
										isComplate = true;
									}
								}
								
								if(isShowComplateOnly){
									if(!isComplate){
										continue;
									}
								}else if(isComplate){
									continue;
								}
								GridItem gridItem = new GridItem(grid, SWT.NONE);
								int effectiveCount = tenderPackOpeningInfo.getTenderCount() - tenderPackOpeningInfo.getRevokeCount() - Math.max(tenderPackOpeningInfo.getDecFailCount(), tenderPackOpeningInfo.getNoPriceCount());
								gridItem.setData("effectiveCount", effectiveCount);
								gridItem.setData("signCount", tenderPackOpeningInfo.getSignCount());
								gridItem.setData("tenderPack", tenderPack);
								gridItem.setText(0, index+"");
								gridItem.setText(1, "["+tenderPack.getTenderNo() + "]"+ tenderPack.getTenderName());
								if(tenderPackOpeningInfo.getTenderCount() == 0){
									gridItem.setCheckVisible(1, false);
								}else if(tenderPackOpeningInfo.getSignCount() == 0){
//									gridItem.setCheckVisible(1, false);
								}
								int minSupplierCount = 3;
								if(TenderProjectEnum.JZXTP.equals(tenderPack.getTenderMethod())){
									minSupplierCount = 2;
								}else if(TenderProjectEnum.DYLY.equals(tenderPack.getTenderMethod())){
									minSupplierCount = 1;
								}
								if((filterLessThanThree || TenderProjectEnum.GKZB.equals(tenderPack.getTenderMethod())|| TenderProjectEnum.YQZB.equals(tenderPack.getTenderMethod())) && tenderPackOpeningInfo.getTenderCount() < minSupplierCount){
									gridItem.setCheckVisible(1, false);
									gridItem.setImage(1, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/warning.png"));
									gridItem.setToolTipText(1, "有效投标家数不足"+minSupplierCount+"家！");
								}
								if(tenderPackOpeningInfo.getTenderCount() < 3) {
									gridItem.setForeground(1, SWTResourceManager.getColor(SWT.COLOR_RED));
									gridItem.setForeground(2, SWTResourceManager.getColor(SWT.COLOR_RED));
									if(tenderPackOpeningInfo.getTenderCount() == 0) {
										gridItem.setCheckVisible(1, false);
										gridItem.setImage(1, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/warning.png"));
										gridItem.setToolTipText(1, "未投标！");
									}
								}
								if(isComplate){
									gridItem.setData("isComplate", true);
									gridItem.setCheckVisible(1, false);
									gridItem.setImage(1, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/ok.png"));
								}
								gridItem.setText(2, tenderPackOpeningInfo.getTenderCount()+"");
								gridItem.setFont(2, SWTResourceManager.getFont("微软雅黑", 11, SWT.BOLD));
								
								gridItem.setText(3, effectiveCount+"");
								gridItem.setFont(3, SWTResourceManager.getFont("微软雅黑", 11, SWT.BOLD));
								if(effectiveCount < 3){
									gridItem.setForeground(3, SWTResourceManager.getColor(SWT.COLOR_RED));
								}
								
								gridItem.setText(4, tenderPackOpeningInfo.getSignCount()+"");
								gridItem.setFont(4, SWTResourceManager.getFont("微软雅黑", 11, SWT.BOLD));
								if(tenderPackOpeningInfo.getSignCount() < 3){
									gridItem.setForeground(4, SWTResourceManager.getColor(SWT.COLOR_RED));
								}else if(effectiveCount == tenderPackOpeningInfo.getSignCount()){
									gridItem.setForeground(4, SWTResourceManager.getColor(SWT.COLOR_DARK_GREEN));
								}
								if(null != tenderPackOpeningInfo.getBidOpeningTime() && tenderPackOpeningInfo.getBidOpeningTime().getTime() != bidOpeningTime.getTime()){
									gridItem.setCheckVisible(1, false);
									gridItem.setCheckable(1, false);
									gridItem.setImage(1, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/count_down.png"));
									gridItem.setToolTipText(1, "与当前选定的开标时间不符！");
								}
								
								if (anonymousAllInfo) {
								    gridItem.setText(2, "*");
								    gridItem.setText(3, "*");
								    gridItem.setText(4, "*");
                                }
								index++;
							}
							if(index > 1){
								confirmBtn.setEnabled(true);
							}
						}
						if(!complateBtn.isDisposed()){
							complateBtn.setEnabled(true);
							unComplateBtn.setEnabled(true);
						}
					}
				});
				
			}
		}).start();
	}
	
	/**
	 * @Description: 全选、反选和取消选择
	 * @author guoyr
	 * @param selectionType 
	 */
	private void selectionAction(int selectionType){
		int selectCount = 0;
		int noSelectCount = 0;
		if(selectionType == 1){
			GridUtils.checkAll(grid, 1, false);
			for(GridItem gridItem : grid.getItems()){
				if(!gridItem.getCheckVisible(1)){
					continue;
				}
				int effectiveCount = (Integer)gridItem.getData("effectiveCount");
				if(effectiveCount < 3){
					noSelectCount ++;
					continue;
				}
				gridItem.setChecked(1, true);
				selectCount ++;
			}
			StringBuilder msg = new StringBuilder();
			if(selectCount > 0){
				msg.append("已选择").append(selectCount).append(Messages.Number_2).append(PACK_NAME);
			}else {
				msg.append("没有可选的").append(PACK_NAME);
			}
			if(noSelectCount > 0){
				msg.append("，其中").append(noSelectCount).append(Messages.Number_2).append(PACK_NAME).append("有效投标家数不足三家未选择（如需选择请手动选择）！");
			}
			MessageDialog.openShortMessage(msg.toString());
		}else if(selectionType == 2){
			if (anonymousAllInfo) {
		        GridUtils.checkAll(grid, 1, true);
		        return;
            }
			GridUtils.checkAll(grid, 1, false);
			for(GridItem gridItem : grid.getItems()){
				if(!gridItem.getCheckVisible(1)){
					continue;
				}
				int signCount = (Integer)gridItem.getData("signCount");
				if(signCount < 3){
					noSelectCount ++;
					continue;
				}
				gridItem.setChecked(1, true);
				selectCount ++;
			}
			StringBuilder msg = new StringBuilder();
			if(selectCount > 0){
				msg.append("已选择").append(selectCount).append(Messages.Number_2).append(PACK_NAME);
			}else {
				msg.append("没有可选的").append(PACK_NAME);
			}
			if(noSelectCount > 0){
				msg.append("，其中").append(noSelectCount).append(Messages.Number_2).append(PACK_NAME).append("在线签到家数不足三家未选择（如需选择请手动选择）！");
			}
			MessageDialog.openShortMessage(msg.toString());
		}else if(selectionType == -1){
			GridUtils.checkAllBack(grid, 1);
		}else {
			GridUtils.checkAll(grid, 1, false);
		}
	}

	/**
	 * @Description: 确认开启远程开标大厅
	 * @author guoyr 
	 */
	private void confirmAction(){
		synchronizedInfoOnly = false;
		if(null != tenderPackList){
			tenderPackList.clear();
		}else {
			tenderPackList = new ArrayList<TenderProjectEntity>();
		}
		if(confirmBtn.getEnabled()){
			List<GridItem> gridItems = GridUtils.getCheckedItems(grid, 1, true);
			int noThreeCount = 0;
			int effectiveNoThreeCount = 0;
			for(GridItem gridItem : gridItems){
				int effectiveCount = (Integer)gridItem.getData("effectiveCount");
				if(effectiveCount < 3){
					effectiveNoThreeCount ++;
				}
				int signCount = (Integer)gridItem.getData("signCount");
				if(signCount < 3){
					noThreeCount ++;
//					if(MessageDialog.openConfirm(getShell(), Messages.Button_decryptRemote, "“"+gridItem.getText(1)+"” 已签到的"+SUPPLIER_NAME+"不足三家，确认要远程解密当前"+PACK_NAME+"吗？", new String[]{"确认解密", "不解密"})){
//						tenderPackList.add((TenderProjectEntity)gridItem.getData("tenderPack"));
//					}else {
//						gridItem.setChecked(1, false);
//					}
					tenderPackList.add((TenderProjectEntity)gridItem.getData("tenderPack"));
				}else {
					tenderPackList.add((TenderProjectEntity)gridItem.getData("tenderPack"));
				}
			}
//			tenderPackList = GridUtils.getCheckedValues(grid, 1, "tenderPack", true);
			if(tenderPackList.size() == 0){
				MessageDialog.openShortMessage("请至少选择一个要远程解密的"+PACK_NAME+"！");
				return;
			}
			if(isFocus){
				StringBuilder msg = new StringBuilder();
				if(effectiveNoThreeCount > 0){
					if (!anonymousAllInfo) {
						msg.append(effectiveNoThreeCount).append(Messages.Number_2).append(PACK_NAME).append("有效投标的").append(SUPPLIER_NAME).append("不足三家；\r\n");
					}
				}
				if(!MessageDialog.openConfirm(getShell(), "远程集中解密", msg.toString() + "确认要远程集中解密已选择的"+PACK_NAME+"吗？", new String[]{"确认集中解密", Messages.Button_cancel})){
					tenderPackList.clear();
				}
			}else {
				
				StringBuilder msg = new StringBuilder();
				if (!anonymousAllInfo) {
					if(effectiveNoThreeCount > 0){
						msg.append(effectiveNoThreeCount).append(Messages.Number_2).append(PACK_NAME).append("有效投标的").append(SUPPLIER_NAME).append("不足三家；\r\n");
					}
					if(noThreeCount > 0){
						msg.append(noThreeCount).append(Messages.Number_2).append(PACK_NAME).append("已在线签到的").append(SUPPLIER_NAME).append("不足三家；\r\n");
					}
				}
				if(!MessageDialog.openConfirm(getShell(), Messages.Button_decryptRemote, msg.toString()+"确认要远程解密已选择的"+PACK_NAME+"吗？", new String[]{"确认远程解密", Messages.Button_cancel})){
					tenderPackList.clear();
				}
			}
			getShell().close();
		}
	}
	
	private void synchronizedInfoAction(){
		if(synchronizedInfoBtn.getEnabled()){
			if(null != tenderPackList){
				tenderPackList.clear();
			}else {
				tenderPackList = new ArrayList<TenderProjectEntity>();
			}
			List<GridItem> gridItems = GridUtils.getCheckedItems(grid, 1, true);
			int noThreeCount = 0;
			for(GridItem gridItem : gridItems){
				int signCount = (Integer)gridItem.getData("signCount");
				if(signCount < 3){
					noThreeCount ++;
					tenderPackList.add((TenderProjectEntity)gridItem.getData("tenderPack"));
				}else {
					tenderPackList.add((TenderProjectEntity)gridItem.getData("tenderPack"));
				}
			}
			if(tenderPackList.size() == 0){
				MessageDialog.openShortMessage("请至少选择一个要同步解密信息的"+PACK_NAME+"！");
				return;
			}
			StringBuilder msg = new StringBuilder();
			if(!isFocus && noThreeCount > 0){
				msg.append(noThreeCount).append(Messages.Number_2).append(PACK_NAME).append("存在已签到的").append(SUPPLIER_NAME).append("不足三家，");
			}
			if(!MessageDialog.openConfirm(getShell(), Messages.Button_syncDecryptInfo, msg.toString()+"确认要同步已选择"+PACK_NAME+"的解密信息吗？", new String[]{"确认同步", Messages.Button_cancel})){
				tenderPackList.clear();
				return;
			}
			synchronizedInfoOnly = true;
			getShell().close();
		}
	}
	
	public boolean isSynchronizedInfoOnly(){
		return synchronizedInfoOnly;
	};
	
	
	public List<TenderProjectEntity> getSelectTenderPackList(){
		return tenderPackList;
	}

	/**
	 * Return the initial size of the dialog.
	 */
	@Override
	protected Point getInitialSize() {
		return new Point(800, 600);
	}

}
