package com.gx.obe.opening.dialog;

import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.eclipse.nebula.widgets.grid.Grid;
import org.eclipse.nebula.widgets.grid.GridColumn;
import org.eclipse.nebula.widgets.grid.GridItem;
import org.eclipse.nebula.widgets.grid.listener.GridSelectionListener;
import org.eclipse.swt.SWT;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.utils.GridUtils;
import org.eclipse.swt.core.widgets.ConfirmDialog;
import org.eclipse.swt.core.widgets.EButton;
import org.eclipse.swt.core.widgets.EDialog;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.core.widgets.EMenu;
import org.eclipse.swt.core.widgets.ImageButton;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;

import com.gx.obe.ColorConstants;
import com.gx.obe.business.entity.MenuFunction;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.utils.MenuFunctionUtils;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.I18NEnum;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.config.ConfigConstants;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.message.Messages;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.service.TenderProjectService;
import com.gx.obe.web.vo.TenderPackOpeningInfo;
import com.gx.utils.ActionLogUtils;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

public class BatchRemoteSignResultDialog extends EDialog {

	private Grid grid;
	private TenderProjectEntity tenderProjectEntity;
	private String bidopeningStage;
	private TenderProjectService tenderProjectService ;
	private GridColumn packNameColumn;
	private String PACK_NAME = "包件";
	private String SUPPLIER_NAME = "供应商";
	private GridColumn supplierCountColumn;
	private EButton confirmBtn;
//	private List<TenderProjectEntity> tenderPackList;
	private List<TenderPackOpeningInfo> tenderPackList;
	private GridColumn confirmCountColumn;
	private ImageButton complateBtn;
	private ImageButton unComplateBtn;
	private ImageButton curBtn;
	private boolean complateOnly = false;
	private ELink synchronizedInfoBtn;
	private ELink selectionInvertBtn;
	private Date bidOpeningTime;
	private boolean anonymousAllInfo = false;
	private ELink selectionAllBtn;
	private String publicType = "01";
	private MenuFunctionUtils menuFunctions;
	/**
	 * Create the dialog.
	 * @param parentShell
	 */
	public BatchRemoteSignResultDialog(Shell parentShell, TenderProjectEntity tenderProjectEntity, Date bidOpeningTime, String bidopeningStage, boolean anonymousAllInfo, MenuFunctionUtils menuFunctions) {
		super(parentShell);
		this.tenderProjectEntity = tenderProjectEntity;
		this.bidOpeningTime = bidOpeningTime;
		this.bidopeningStage = bidopeningStage;
		this.anonymousAllInfo = anonymousAllInfo;
		this.menuFunctions = menuFunctions;
	}

	/**
	 * Create contents of the dialog.
	 * @param parent
	 */
	@Override
	protected Control createDialogArea(Composite parent) {
		Composite container = (Composite) super.createDialogArea(parent);
		container.setLayout(new GridLayout(1, false));
		
		Composite composite_3 = new Composite(container, SWT.NONE);
		composite_3.setBackground(ColorConstants.BORDER_LINE_COLOR);
		composite_3.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_composite_3 = new GridLayout(1, false);
		gl_composite_3.verticalSpacing = 1;
		gl_composite_3.horizontalSpacing = 1;
		gl_composite_3.marginHeight = 1;
		gl_composite_3.marginWidth = 1;
		composite_3.setLayout(gl_composite_3);
		
		Composite composite = new Composite(composite_3, SWT.NONE);
		composite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		composite.setLayout(new GridLayout(5, false));
		composite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		
		complateBtn = new ImageButton(composite, SWT.NONE);
		complateBtn.setSelectionForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		complateBtn.setSelectionBgColor(ColorConstants.BUTTON_BG);
		complateBtn.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		complateBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				listTenderPack(true);
			}
		});
		complateBtn.setText("已完成开标");
		
		unComplateBtn = new ImageButton(composite, SWT.NONE);
		unComplateBtn.setSelectionBgColor(ColorConstants.BUTTON_BG);
		unComplateBtn.setSelectionForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		unComplateBtn.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		unComplateBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				listTenderPack(false);
			}
		});
		unComplateBtn.setText("未完成开标");
		
		
		selectionAllBtn = new ELink(composite, SWT.NONE);
		selectionAllBtn.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true, false, 1, 1));
		selectionAllBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/select_all.png"));
		selectionAllBtn.setText("全选(已解密够3家)");
		selectionAllBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				selectionAction(1);
			}
		});
		
		selectionInvertBtn = new ELink(composite, SWT.NONE);
		selectionInvertBtn.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		selectionInvertBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/switch.png"));
		selectionInvertBtn.setText(Messages.Button_selectInvert);
		selectionInvertBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				selectionAction(-1);
			}
		});
		
		ELink selectionNoBtn = new ELink(composite, SWT.NONE);
		selectionNoBtn.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		selectionNoBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/disselect_all.png"));
		selectionNoBtn.setText(Messages.Button_deselected);
		selectionNoBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				selectionAction(0);
			}
		});
		
		Composite composite_1 = new Composite(composite_3, SWT.NONE);
		composite_1.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_composite_1 = new GridLayout(1, false);
		gl_composite_1.marginHeight = 0;
		gl_composite_1.marginWidth = 0;
		composite_1.setLayout(gl_composite_1);
		
		grid = new Grid(composite_1, SWT.V_SCROLL);
		grid.setHeaderVisible(true);
		grid.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		GridColumn indexColumn = new GridColumn(grid, SWT.CENTER);
		indexColumn.setText(Messages.Num);
		indexColumn.setWidth(150);
		indexColumn.setWidth(50);
		indexColumn.setMaxmumWidth(50);
		
		packNameColumn = new GridColumn(grid, SWT.CHECK);
		packNameColumn.setText("包件");
//		packNameColumn.setWidth(250);
		packNameColumn.setMinimumWidth(150);
		
		supplierCountColumn = new GridColumn(grid, SWT.CENTER);
		supplierCountColumn.setText("投标家数");
		supplierCountColumn.setWidth(80);
		supplierCountColumn.setMaxmumWidth(80);
		
//		GridColumn signCountColumn = new GridColumn(grid, SWT.CENTER);
//		signCountColumn.setText("签到家数");
//		signCountColumn.setWidth(80);
//		signCountColumn.setMaxmumWidth(80);
		
		GridColumn decCountColumn = new GridColumn(grid, SWT.CENTER);
		decCountColumn.setText("已解密家数");
		decCountColumn.setWidth(80);
		decCountColumn.setMaxmumWidth(80);
		
		GridColumn decFailCountColumn = new GridColumn(grid, SWT.CENTER);
		decFailCountColumn.setText("解密失败家数");
		decFailCountColumn.setWidth(80);
		decFailCountColumn.setMaxmumWidth(100);
		
		confirmCountColumn = new GridColumn(grid, SWT.CENTER);
		confirmCountColumn.setText("已确认家数");
		confirmCountColumn.setWidth(80);
		confirmCountColumn.setMaxmumWidth(80);
		
		Composite composite_2 = new Composite(container, SWT.NONE);
		composite_2.setLayout(new GridLayout(3, false));
		composite_2.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		
		synchronizedInfoBtn = new ELink(composite_2, SWT.NONE);
		synchronizedInfoBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				confirmAction(true);
			}
		});
		synchronizedInfoBtn.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1));
		synchronizedInfoBtn.setText("仅完成开标");
		
		confirmBtn = new EButton(composite_2, SWT.NONE);
		confirmBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				confirmAction(false);
			}
		});
		GridData gd_button = new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1);
		confirmBtn.setLayoutData(gd_button);
		confirmBtn.setText(Messages.Button_complateAndUploadOpeningResult);
		
		EButton button_1 = new EButton(composite_2, SWT.NONE);
		GridData gd_button_1 = new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1);
		gd_button_1.widthHint = 90;
		button_1.setLayoutData(gd_button_1);
		button_1.setText(Messages.Button_cancel);
		button_1.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				getShell().close();
			}
		});
		tenderProjectService = new TenderProjectService();
		init();
		return container;
	}
	
	/**
	 * @Description: 
	 * @author guoyr 
	 */
	private void init(){
		if (anonymousAllInfo) {
			selectionAllBtn.setText(Messages.Button_selectAll);
		}
		confirmBtn.setEnabled(false);
		grid.setItemHeight(Constants.ROW_HIGHT);
		PACK_NAME = com.gx.obe.components.core.I18N.getString(I18NEnum.SUBPACKAGE, tenderProjectEntity.getTenderType());
		SUPPLIER_NAME = com.gx.obe.components.core.I18N.getString(I18NEnum.SUPPLIERNAME, tenderProjectEntity.getTenderType());
		grid.setAutoHeight(true);
		packNameColumn.setWordWrap(true);
		packNameColumn.setText(PACK_NAME);
//		if(null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_BUS_TEC)){
//			stageLabel.setImage(ResourceManager.getPluginImage(SWTCoreActivator.PLUGIN_ID, "icons/tender_pager.png"));
//			stageLabel.setText("商务标、技术标 - 远程解密");
//		}else if(null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_PRICE)){
//			stageLabel.setImage(ResourceManager.getPluginImage(SWTCoreActivator.PLUGIN_ID, "icons/tender_pager.png"));
//			stageLabel.setText("经济标 - 远程解密");
//		}else{
//			stageLabel.setText("");
//			
//		}
		
		if(PropertiesUtils.getProperty(ConfigConstants.SHOW_CONFIRM_STATUS, "00").equals("00")){
			confirmCountColumn.setVisible(false);
		}
		
		listTenderPack(false);
		
		// 添加投标人表格的选中事件和右键菜单事件
		grid.addListener(SWT.Selection, new GridSelectionListener(){
			public void rightMouseButtonDown(GridItem item) {
				supplierMenuDetectAction();
			}
			
		});
		
		synchronizedInfoBtn.setVisible(false);
		synchronizedInfoBtn.setEnabled(false);
		((GridData)selectionInvertBtn.getLayoutData()).exclude = true;
		selectionInvertBtn.setVisible(false);
		
		final String keyCharacter = PropertiesUtils.getProperty("keyCharacter", "g");
		if(null != keyCharacter && keyCharacter.length() > 0){
			final Listener keyListener = new Listener() {
				public void handleEvent(Event e) {
					if ((e.stateMask == SWT.CTRL) && e.keyCode == keyCharacter.charAt(0)){
						boolean visible = !synchronizedInfoBtn.getVisible();
						synchronizedInfoBtn.setVisible(visible);
						synchronizedInfoBtn.setEnabled(visible);
						// 仅同步时允许启动
						confirmBtn.setEnabled(!visible);
						
						((GridData)selectionInvertBtn.getLayoutData()).exclude = !visible;
						selectionInvertBtn.setVisible(visible);
						selectionInvertBtn.getParent().layout();
					}
				}
			};
			grid.getDisplay().addFilter(SWT.KeyDown, keyListener);;
			grid.addDisposeListener(new DisposeListener() {
				public void widgetDisposed(DisposeEvent e) {
					grid.getDisplay().removeFilter(SWT.KeyDown, keyListener);  
				}
			});
		
		}
	}
	
	/**
	 * @Description: 投标人右建菜单
	 * @author guoyr
	 */
	private void supplierMenuDetectAction(){
		if(grid.getSelectionCount() > 0){
			final GridItem gridItem = grid.getSelection()[0];
			
			if(null != gridItem.getData("isComplate")){
				final EMenu gmenu = new EMenu(getShell());
				gmenu.addMenuItem("允许重新上传结果", ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/ok.png"), true, new EMenu.ClickListener() {
					public void click() {
						gridItem.setCheckVisible(1, true);
						gridItem.setChecked(1, true);
					}
				});
				gmenu.addMenuItem("允许所有已完成的重新上传结果", ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/ok.png"), true, new EMenu.ClickListener() {
					public void click() {
						for(GridItem gridItem : grid.getItems()){
							if(null != gridItem.getData("isComplate")){
								gridItem.setCheckVisible(1, true);
								gridItem.setChecked(1, true);
							}
						}
					}
				});
				gmenu.open();
			}
		}
	}
	
	private void listTenderPack(final boolean isShowComplateOnly){
		if(null != curBtn){
			if(!curBtn.getEnabled()){
				return;
			}
			curBtn.setSelection(false);
		}
		if(isShowComplateOnly){
			curBtn = complateBtn;
		}else {
			curBtn = unComplateBtn;
		}
		curBtn.setSelection(true);
		complateBtn.setEnabled(false);
		unComplateBtn.setEnabled(false);
		grid.removeAll();
		new Thread(new Runnable(){
			public void run(){
				final List<TenderPackOpeningInfo> tenderPackOpeningInfoList = tenderProjectService.getTenderPackOpeningInfoList(tenderProjectEntity.getId(), bidopeningStage);
				final boolean isPriceStage = null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_PRICE) ? true : false;
				Display.getDefault().syncExec(new Runnable(){
					public void run(){
						if(!grid.isDisposed()){
							int index = 1;
							for(TenderPackOpeningInfo tenderPackOpeningInfo : tenderPackOpeningInfoList){
								TenderProjectEntity tenderPack = tenderPackOpeningInfo.getTenderProject();
								
								boolean isComplate = false;
								if(isPriceStage){
									if(null == tenderPack.getPriceBidStatus() || CommonEnum.NOT_START.equals(tenderPack.getPriceBidStatus())){
										// 如果未启动开标则不能完成
										continue;
									}
									if(null != tenderPack.getPriceBidStatus() && tenderPack.getPriceBidStatus().equals(CommonEnum.COMPLETE)){
										isComplate = true;
									}
								}else {
									if(null == tenderPack.getBusinessBidStatus() || CommonEnum.NOT_START.equals(tenderPack.getBusinessBidStatus())){
										// 如果未启动开标则不能完成
										continue;
									}
									if(null != tenderPack.getBusinessBidStatus() && tenderPack.getBusinessBidStatus().equals(CommonEnum.COMPLETE)){
										isComplate = true;
									}
								}
								if(isShowComplateOnly){
									if(!isComplate){
										continue;
									}
								}else if(isComplate){
									continue;
								}

								GridItem gridItem = new GridItem(grid, SWT.NONE);
								gridItem.setData("tenderCount", tenderPackOpeningInfo.getTenderCount());
								gridItem.setData("signCount", tenderPackOpeningInfo.getSignCount());
								gridItem.setData("decCount", tenderPackOpeningInfo.getDecCount());
								gridItem.setData("decFailCount", tenderPackOpeningInfo.getDecFailCount());
								gridItem.setData("confirmCount", tenderPackOpeningInfo.getConfirmCount());
								gridItem.setData("tenderPack", tenderPack);
								gridItem.setData("tenderPackOpeningInfo", tenderPackOpeningInfo);
								
								gridItem.setText(0, index+"");
								gridItem.setText(1, "["+tenderPack.getTenderNo() + "]"+ tenderPack.getTenderName());
								if(tenderPackOpeningInfo.getTenderCount() == 0){
									gridItem.setCheckVisible(1, false);
								}else if(tenderPackOpeningInfo.getSignCount() == 0){
//									gridItem.setCheckVisible(1, false);
								}
								if(tenderPackOpeningInfo.getDecFailCount() > 0){
									gridItem.setText(4, tenderPackOpeningInfo.getDecFailCount()+"");
									gridItem.setImage(1, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/warning.png"));
									gridItem.setForeground(1, SWTResourceManager.getColor(SWT.COLOR_RED));
								}
								if(isComplate){
									gridItem.setData("isComplate", true);
									gridItem.setCheckVisible(1, false);
									gridItem.setImage(1, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/ok.png"));
								}
								gridItem.setText(2, tenderPackOpeningInfo.getTenderCount()+"");
//								gridItem.setText(3, tenderPackOpeningInfo.getSignCount()+"");
								gridItem.setText(3, tenderPackOpeningInfo.getDecCount()+"");
								
								gridItem.setText(5, tenderPackOpeningInfo.getConfirmCount()+"");
								gridItem.setFont(2, SWTResourceManager.getFont("微软雅黑", 11, SWT.BOLD));
								gridItem.setFont(3, SWTResourceManager.getFont("微软雅黑", 11, SWT.BOLD));
								gridItem.setFont(4, SWTResourceManager.getFont("微软雅黑", 11, SWT.BOLD));
								gridItem.setFont(5, SWTResourceManager.getFont("微软雅黑", 11, SWT.BOLD));
//								gridItem.setFont(6, SWTResourceManager.getFont("微软雅黑", 11, SWT.BOLD));
								if(tenderPackOpeningInfo.getDecCount() < 3){
									gridItem.setForeground(4, SWTResourceManager.getColor(SWT.COLOR_RED));
									if(tenderPackOpeningInfo.getDecCount() < tenderPackOpeningInfo.getSignCount()){
										gridItem.setForeground(4, SWTResourceManager.getColor(SWT.COLOR_RED));
										gridItem.setForeground(1, SWTResourceManager.getColor(SWT.COLOR_RED));
										if(!isComplate) {
											gridItem.setImage(1, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/warning.png"));
										}
									}
									if(tenderPackOpeningInfo.getDecCount() == 0) {
										gridItem.setCheckVisible(1, false);
										gridItem.setCheckable(1, false);
										gridItem.setImage(1, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/warning.png"));
										gridItem.setToolTipText(1, "未解密");
									}
								}else {
									if(tenderPackOpeningInfo.getDecCount() > 0 && tenderPackOpeningInfo.getConfirmCount() < tenderPackOpeningInfo.getDecCount()){
										gridItem.setForeground(5, SWTResourceManager.getColor(SWT.COLOR_RED));
									}else if(tenderPackOpeningInfo.getDecCount() > 0 && tenderPackOpeningInfo.getConfirmCount() == tenderPackOpeningInfo.getDecCount()){
										gridItem.setForeground(5, SWTResourceManager.getColor(SWT.COLOR_DARK_GREEN));
									}
									if(tenderPackOpeningInfo.getConfirmQuestionCount() > 0){
										gridItem.setForeground(5, SWTResourceManager.getColor(255, 255, 0));
									}
								}
								
								if(tenderPackOpeningInfo.getDecFailCount() > 0){
									for(int i = 1; i < grid.getColumnCount(); i++){
										gridItem.setForeground(i, SWTResourceManager.getColor(SWT.COLOR_RED));
									}
									gridItem.setCheckVisible(1, false);
									gridItem.setCheckable(1, false);
									gridItem.setToolTipText(1, MessageFormat.format(Messages.Tips_decryptFailedCount, tenderPackOpeningInfo.getDecFailCount()));
									gridItem.setImage(1, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/flag_red.png"));
								}
								
								if(tenderPackOpeningInfo.getNoPriceCount() > 0){
									for(int i = 1; i < grid.getColumnCount(); i++){
										gridItem.setForeground(i, SWTResourceManager.getColor(SWT.COLOR_RED));
									}
									gridItem.setToolTipText(1, MessageFormat.format(Messages.Tips_obtainQuotationFailedCount, tenderPackOpeningInfo.getNoPriceCount()));
									if(tenderPackOpeningInfo.getNoPriceCount() != tenderPackOpeningInfo.getDecCount()){
										gridItem.setCheckVisible(1, false);
										gridItem.setCheckable(1, false);
									}
									gridItem.setImage(1, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/about.png"));
								}
								
								if(null != tenderPackOpeningInfo.getBidOpeningTime() && tenderPackOpeningInfo.getBidOpeningTime().getTime() != bidOpeningTime.getTime()){
									gridItem.setCheckVisible(1, false);
									gridItem.setCheckable(1, false);
									gridItem.setImage(1, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/count_down.png"));
									gridItem.setToolTipText(1, "与当前选定的开标时间不符！");
								}
								if (anonymousAllInfo) {
								    gridItem.setText(2, "*");
								    gridItem.setText(3, "*");
								    gridItem.setText(4, "*");
								    gridItem.setText(5, "*");
                                }
								index++;
							
								
							}
							if(index > 0){
								confirmBtn.setEnabled(true);
							}
						}
						if(!complateBtn.isDisposed()){
							complateBtn.setEnabled(true);
							unComplateBtn.setEnabled(true);
						}
					}
				});
				
			}
		}).start();
	}
	
	/**
	 * @Description: 全选、反选和取消选择
	 * @author guoyr
	 * @param selectionType 
	 */
	private void selectionAction(int selectionType){
		if(selectionType == 1){
			if (anonymousAllInfo) {
		        GridUtils.checkAll(grid, 1, true);
		        return;
            }
			GridUtils.checkAll(grid, 1, false);
			int selectCount = 0;
			int noSelectCount = 0;
			int noComplateCount = 0;
			for(GridItem gridItem : grid.getItems()){
				if(!gridItem.getCheckVisible(1)){
					continue;
				}
				int decCount = (Integer)gridItem.getData("decCount");
				if(decCount < 3){
					noSelectCount ++;
					continue;
				}
				int signCount = (Integer)gridItem.getData("signCount");
				int tenderCount = (Integer)gridItem.getData("tenderCount");
				if(signCount > 0) {
					if(decCount < signCount) {
						noComplateCount ++;
						continue;
					}
				}else {
					if(decCount < tenderCount) {
						noComplateCount ++;
						continue;
					}
				}
				gridItem.setChecked(1, true);
				selectCount ++;
			}
			StringBuilder msg = new StringBuilder();
			if(selectCount > 0){
				msg.append("已选择").append(selectCount).append(Messages.Number_2).append(PACK_NAME);
			}else {
				msg.append("没有可选的").append(PACK_NAME);
			}
			if(noSelectCount > 0){
				msg.append(";\r\n其中").append(noSelectCount).append(Messages.Number_2).append(PACK_NAME).append("已解密家数不足三家（如需选择请手动选择）！");
			}
			if(noComplateCount > 0){
				msg.append(";\r\n其中").append(noComplateCount).append(Messages.Number_2).append(PACK_NAME).append("存在还未解密的"+SUPPLIER_NAME+"（如需选择请手动选择）！");
			}
			MessageDialog.openShortMessage(msg.toString());
		}else if(selectionType == -1){
			GridUtils.checkAllBack(grid, 1);
		}else {
			GridUtils.checkAll(grid, 1, false);
		}
	}
	
	/**
	 * @Description: 确认开启远程开标大厅
	 * @author guoyr 
	 */
	private void confirmAction(boolean complateOnly){
		this.complateOnly = complateOnly;
		if(null != tenderPackList){
			tenderPackList.clear();
		}else {
			tenderPackList = new ArrayList<TenderPackOpeningInfo>();
		}
		if(confirmBtn.getEnabled() || complateOnly){
			List<GridItem> gridItems = GridUtils.getCheckedItems(grid, 1, true);
			int hasNoConfirm = 0;
			int hasDecFialed = 0;
			int noThree = 0;
			int noComplateCount = 0;
			for(GridItem gridItem : gridItems){
				int decCount = (Integer)gridItem.getData("decCount");
				int decFailCount = (Integer)gridItem.getData("decFailCount");
				int confirmCount = (Integer)gridItem.getData("confirmCount");
				if(confirmCountColumn.getVisible() && confirmCount < decCount){
					hasNoConfirm ++;
				}
				if(decFailCount > 0){
					hasDecFialed ++;
				}
				if(decCount < 3){
					noThree++;
				}
				int signCount = (Integer)gridItem.getData("signCount");
				int tenderCount = (Integer)gridItem.getData("tenderCount");
				if(signCount > 0) {
					if(decCount < signCount) {
						noComplateCount ++;
					}
				}else {
					if(decCount < tenderCount) {
						noComplateCount ++;
					}
				}
//				tenderPackList.add((TenderProjectEntity)gridItem.getData("tenderPack"));
				tenderPackList.add((TenderPackOpeningInfo)gridItem.getData("tenderPackOpeningInfo"));
			}
			StringBuilder tips = new StringBuilder();
			if(hasNoConfirm > 0){
				tips.append(hasNoConfirm).append(Messages.Number_2).append(PACK_NAME).append("存在未确认的").append(SUPPLIER_NAME).append("；");
			}
			if(hasDecFialed > 0){
				if(tips.length() > 0){
					tips.append("\r\n");
				}
				tips.append(hasDecFialed).append(Messages.Number_2).append(PACK_NAME).append("存在解失败的").append(SUPPLIER_NAME).append("；");
			}
			if(noThree > 0){
				if(tips.length() > 0){
					tips.append("\r\n");
				}
				tips.append(noThree).append(Messages.Number_2).append(PACK_NAME).append("已解密的").append(SUPPLIER_NAME).append("不足三家；");
			}
			if(noComplateCount > 0){
				if(tips.length() > 0){
					tips.append("\r\n");
				}
				tips.append(noComplateCount).append(Messages.Number_2).append(PACK_NAME).append("存在还未解密的").append(SUPPLIER_NAME).append("；");
			}
			if(tips.length() > 0){
				tips.append("\r\n");
				tips.append("完成开标并上传结果后，还未成功解密的标书将不能继续解密！");
			}
//			tenderPackList = GridUtils.getCheckedValues(grid, 1, "tenderPack", true);
			if(tenderPackList.size() == 0){
				MessageDialog.openShortMessage("请至少选择一个要完成开标的"+PACK_NAME+"！");
				return;
			}
			if(complateOnly){
				if(!MessageDialog.openConfirm(getShell(), "完成开标", tips+"确认要将已选择的"+PACK_NAME+"设置为完成开标吗？", new String[]{"确认完成开标", Messages.Button_cancel})){
					tenderPackList.clear();
					return;
				}
			}else {
//				if(!MessageDialog.openConfirm(getShell(), "完成解密并上传结果", msg+"完成解密并上传结果后，还未解密的"+SUPPLIER_NAME+"将不能继续解密，每个"+PACK_NAME+"参与开标的"+SUPPLIER_NAME+"将会查看到所有"+SUPPLIER_NAME+"的开标汇总表，确认要进行此操作吗？", new String[]{"确认完成解密并上传结果", Messages.Button_cancel})){
//					tenderPackList.clear();
//				}
				
				ConfirmDialog confirmDialog = new ConfirmDialog(getShell(), Messages.Button_complateAndUploadOpeningResult, Messages.Tips_confirmComplateAndUploadOpeningResult, null);
				if(null != menuFunctions && MenuFunction.SHOW.equals(menuFunctions.getAuthority("PUBLIC_TYPE"))){
//				 如果是竞争性谈判和竞争性磋商（目前是其他），则需要选择是否公开
					if(!TenderProjectEnum.STAGE_BUS_TEC.equals(bidopeningStage) && (TenderProjectEnum.JZXTP.equals(tenderProjectEntity.getTenderMethod()) || TenderProjectEnum.CONSULTATION.equals(tenderProjectEntity.getTenderMethod()) || TenderProjectEnum.OTHER.equals(tenderProjectEntity.getTenderMethod()))) {
						publicType = "02";
						confirmDialog.addCheckBox("向投标人公开开标一览表汇总表", "01".equals(publicType), new SelectionAdapter() {
							public void widgetSelected(SelectionEvent e) {
								if(confirmDialog.getCheckBtnSelection()) {
									publicType = "01";
									MessageDialog.openShortMessage("参与开标的投标人可以看到开标一览表汇总表！");
								}else {
									MessageDialog.openShortMessage("参与开标的投标人不能看到开标一览表汇总表！");
									publicType = "02";
								}
							}
						});
					}
				}
				confirmDialog.addButton("确认完成开标并上传结果", "01", null);
				confirmDialog.addCancel(Messages.Button_cancel, null);
				if(tips.length() > 0) {
					confirmDialog.setTipsAlignment(SWT.LEFT);
					confirmDialog.setTips(tips.toString());
					confirmDialog.setTipsColor(SWTResourceManager.getColor(255, 0, 0));
				}
				confirmDialog.open();
				if("01".equals(confirmDialog.getClickStatus())){
					ActionLogUtils.addServerLog(tenderProjectEntity.getId(),"确认批量完成开标并上传结果", tips.toString());
				}else {
					tenderPackList.clear();
//					return;
				}
			}
			getShell().close();
		}
	}
	
	public void addPublicType(ConfirmDialog confirmDialog) {

	}
	
	public List<TenderPackOpeningInfo> getSelectTenderPackList(){
		return tenderPackList;
	}

	public String getPublicType() {
		return publicType;
	}

	public boolean isComplateOnly(){
		return complateOnly;
	}
	/**
	 * Return the initial size of the dialog.
	 */
	@Override
	protected Point getInitialSize() {
		return new Point(900, 600);
	}

}
