package com.gx.obe.opening.dialog;

import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.eclipse.nebula.widgets.grid.Grid;
import org.eclipse.nebula.widgets.grid.GridColumn;
import org.eclipse.nebula.widgets.grid.GridItem;
import org.eclipse.nebula.widgets.grid.listener.GridSelectionListener;
import org.eclipse.swt.SWT;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.utils.GridUtils;
import org.eclipse.swt.core.widgets.EButton;
import org.eclipse.swt.core.widgets.EDialog;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.core.widgets.EMenu;
import org.eclipse.swt.core.widgets.ImageButton;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;

import com.gx.obe.ColorConstants;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.I18NEnum;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.message.Messages;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.service.TenderProjectService;
import com.gx.obe.web.vo.TenderPackOpeningInfo;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

public class BatchStartBidOpeningHallDialog extends EDialog {

	private Grid grid;
	private TenderProjectEntity tenderProjectEntity;
	private String bidopeningStage;
	private TenderProjectService tenderProjectService ;
	private GridColumn packNameColumn;
	private String PACK_NAME = "包件";
	private String SUPPLIER_NAME = "供应商";
	private GridColumn supplierCountColumn;
	private EButton confirmBtn;
	private List<TenderProjectEntity> tenderPackList;
	private ImageButton complateBtn;
	private ImageButton unComplateBtn;
	private ImageButton curBtn;
	private ELink synchronizedInfoBtn;
	private boolean synchronizedInfoOnly = false;
	private GridColumn effectiveCountColumn;
	private ELink selectionInvertBtn;
	private Date bidOpeningTime;
	private boolean anonymousAllInfo = false;
	private ELink selectionAllBtn;

	/**
	 * Create the dialog.
	 * @param parentShell
	 */
	public BatchStartBidOpeningHallDialog(Shell parentShell, TenderProjectEntity tenderProjectEntity, Date bidOpeningTime, String bidopeningStage, boolean anonymousAllInfo) {
		super(parentShell);
		this.tenderProjectEntity = tenderProjectEntity;
		this.bidOpeningTime = bidOpeningTime;
		this.bidopeningStage = bidopeningStage;
		this.anonymousAllInfo = anonymousAllInfo;
	}

	/**
	 * Create contents of the dialog.
	 * @param parent
	 */
	@Override
	protected Control createDialogArea(Composite parent) {
		Composite container = (Composite) super.createDialogArea(parent);
		container.setLayout(new GridLayout(1, false));
		
		Composite composite_3 = new Composite(container, SWT.NONE);
		composite_3.setBackground(ColorConstants.BORDER_LINE_COLOR);
		composite_3.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_composite_3 = new GridLayout(1, false);
		gl_composite_3.verticalSpacing = 1;
		gl_composite_3.horizontalSpacing = 1;
		gl_composite_3.marginHeight = 1;
		gl_composite_3.marginWidth = 1;
		composite_3.setLayout(gl_composite_3);
		
		Composite composite = new Composite(composite_3, SWT.NONE);
		composite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		composite.setLayout(new GridLayout(5, false));
		composite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		
		complateBtn = new ImageButton(composite, SWT.NONE);
		complateBtn.setSelectionForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		complateBtn.setSelectionBgColor(ColorConstants.BUTTON_BG);
		complateBtn.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		complateBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				listTenderPack(true);
			}
		});
		complateBtn.setText(Messages.Button_openRemoteBidOpeningHallAlready);
		
		unComplateBtn = new ImageButton(composite, SWT.NONE);
		unComplateBtn.setSelectionBgColor(ColorConstants.BUTTON_BG);
		unComplateBtn.setSelectionForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		unComplateBtn.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		unComplateBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				listTenderPack(false);
			}
		});
		unComplateBtn.setText(Messages.Button_openRemoteBidOpeningHallNot);
		
		selectionAllBtn = new ELink(composite, SWT.NONE);
		selectionAllBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/select_all.png"));
		
		selectionAllBtn.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true, false, 1, 1));
		selectionAllBtn.setText("全选(有效投标超过三家)");
		selectionAllBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				selectionAction(1);
			}
		});
		
		selectionInvertBtn = new ELink(composite, SWT.NONE);
		selectionInvertBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		selectionInvertBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/switch.png"));
		selectionInvertBtn.setText(Messages.Button_selectInvert);
		selectionInvertBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				selectionAction(-1);
			}
		});
		
		ELink selectionNoBtn = new ELink(composite, SWT.NONE);
		selectionNoBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		selectionNoBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/disselect_all.png"));
		selectionNoBtn.setText(Messages.Button_deselected);
		selectionNoBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				selectionAction(0);
			}
		});
		
		Composite composite_1 = new Composite(composite_3, SWT.NONE);
		composite_1.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_composite_1 = new GridLayout(1, false);
		gl_composite_1.marginHeight = 0;
		gl_composite_1.marginWidth = 0;
		composite_1.setLayout(gl_composite_1);
		
		
		
		grid = new Grid(composite_1, SWT.V_SCROLL);
		grid.setHeaderVisible(true);
		grid.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		GridColumn indexColumn = new GridColumn(grid, SWT.CENTER);
		indexColumn.setText(Messages.Num);
		indexColumn.setWidth(150);
		indexColumn.setWidth(50);
		indexColumn.setMaxmumWidth(50);
		
		packNameColumn = new GridColumn(grid, SWT.CHECK);
		packNameColumn.setCellSelectionEnabled(true);
		packNameColumn.setText("包件");
		packNameColumn.setWidth(250);
		packNameColumn.setMinimumWidth(150);
		
		supplierCountColumn = new GridColumn(grid, SWT.CENTER);
		supplierCountColumn.setText("投标家数");
		supplierCountColumn.setWidth(80);
		supplierCountColumn.setMaxmumWidth(80);
		
		effectiveCountColumn = new GridColumn(grid, SWT.CENTER);
		effectiveCountColumn.setText("有效家数");
		effectiveCountColumn.setWidth(80);
		effectiveCountColumn.setMaxmumWidth(80);
		
//		GridColumn gridColumn = new GridColumn(grid, SWT.NONE);
//		gridColumn.setText("开标大厅开启状态");
//		gridColumn.setWidth(150);
//		
		Composite composite_2 = new Composite(container, SWT.NONE);
		composite_2.setLayout(new GridLayout(3, false));
		composite_2.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		synchronizedInfoBtn = new ELink(composite_2, SWT.NONE);
		synchronizedInfoBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				synchronizedInfoAction();
			}
		});
		synchronizedInfoBtn.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1));
		synchronizedInfoBtn.setText("仅同步签到信息");
		
		confirmBtn = new EButton(composite_2, SWT.NONE);
		confirmBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				confirmAction();
			}
		});
		GridData gd_button = new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1);
		gd_button.widthHint = 90;
		confirmBtn.setLayoutData(gd_button);
		confirmBtn.setText(Messages.Button_confirm);
		
		EButton button_1 = new EButton(composite_2, SWT.NONE);
		GridData gd_button_1 = new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1);
		gd_button_1.widthHint = 90;
		button_1.setLayoutData(gd_button_1);
		button_1.setText(Messages.Button_cancel);
		button_1.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				getShell().close();
			}
		});
		tenderProjectService = new TenderProjectService();
		init();
		return container;
	}
	
	/**
	 * @Description: 
	 * @author guoyr 
	 */
	private void init(){
		if (anonymousAllInfo) {
			selectionAllBtn.setText(Messages.Button_selectAll);
		}
		confirmBtn.setEnabled(false);
		grid.setItemHeight(Constants.ROW_HIGHT);
		PACK_NAME = com.gx.obe.components.core.I18N.getString(I18NEnum.SUBPACKAGE, tenderProjectEntity.getTenderType());
		SUPPLIER_NAME = com.gx.obe.components.core.I18N.getString(I18NEnum.SUPPLIERNAME, tenderProjectEntity.getTenderType());
		packNameColumn.setText(PACK_NAME);
//		titleLabel.setText("请选择要批量开启远程开标大厅的"+PACK_NAME);
		grid.setAutoHeight(true);
		packNameColumn.setWordWrap(true);
		
		listTenderPack(false);
		// 添加投标人表格的选中事件和右键菜单事件
		grid.addListener(SWT.Selection, new GridSelectionListener(){
			public void rightMouseButtonDown(GridItem item) {
				supplierMenuDetectAction();
			}
			
		});
		synchronizedInfoBtn.setVisible(false);
		synchronizedInfoBtn.setEnabled(false);
		((GridData)selectionInvertBtn.getLayoutData()).exclude = true;
		selectionInvertBtn.setVisible(false);
		
		final String keyCharacter = PropertiesUtils.getProperty("keyCharacter", "g");
		if(null != keyCharacter && keyCharacter.length() > 0){
			final Listener keyListener = new Listener() {
				public void handleEvent(Event e) {
					if ((e.stateMask == SWT.CTRL) && e.keyCode == keyCharacter.charAt(0)){
						boolean visible = !synchronizedInfoBtn.getVisible();
						synchronizedInfoBtn.setVisible(visible);
						synchronizedInfoBtn.setEnabled(visible);
						// 仅同步时允许启动
						confirmBtn.setEnabled(!visible);
						((GridData)selectionInvertBtn.getLayoutData()).exclude = !visible;
						selectionInvertBtn.setVisible(visible);
						selectionInvertBtn.getParent().layout();
					}
				}
			};
			
			grid.getDisplay().addFilter(SWT.KeyDown, keyListener);;
			grid.addDisposeListener(new DisposeListener() {
				public void widgetDisposed(DisposeEvent e) {
					grid.getDisplay().removeFilter(SWT.KeyDown, keyListener);  
				}
			});
		}
	}
	
	/**
	 * @Description: 投标人右建菜单
	 * @author guoyr
	 */
	private void supplierMenuDetectAction(){
		if(grid.getSelectionCount() > 0){
			final GridItem gridItem = grid.getSelection()[0];
			
			if(null != gridItem.getData("isComplate")){
				final EMenu gmenu = new EMenu(getShell());
				gmenu.addMenuItem("允许重新启动远程签到", ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/ok.png"), true, new EMenu.ClickListener() {
					public void click() {
						gridItem.setCheckVisible(1, true);
						gridItem.setChecked(1, true);
					}
				});
				gmenu.addMenuItem("允许全部重新启动远程签到", ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/ok.png"), true, new EMenu.ClickListener() {
					public void click() {
						for(GridItem gridItem : grid.getItems()){
							if(null != gridItem.getData("isComplate")){
								gridItem.setCheckVisible(1, true);
								gridItem.setChecked(1, true);
							}
						}
					}
				});
				gmenu.open();
			}
		}
	}
	
	private void listTenderPack(final boolean isShowStartOnly){
		if(null != curBtn){
			if(!curBtn.getEnabled()){
				return;
			}
			curBtn.setSelection(false);
		}
		if(isShowStartOnly){
			curBtn = complateBtn;
		}else {
			curBtn = unComplateBtn;
		}
		curBtn.setSelection(true);
		complateBtn.setEnabled(false);
		unComplateBtn.setEnabled(false);
		grid.removeAll();
		new Thread(new Runnable(){
			public void run(){
				final List<TenderPackOpeningInfo> tenderPackOpeningInfoList = tenderProjectService.getTenderPackOpeningInfoList(tenderProjectEntity.getId(), bidopeningStage);
				final boolean isPriceStage = null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_PRICE) ? true : false;
//				if(null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_PRICE)){
//					isPriceStage = true;
//				}else if(null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_BUS_TEC)){
//					isBusAndTecStage = true;
//				}
				Display.getDefault().syncExec(new Runnable(){
					public void run(){
						if(!grid.isDisposed()){
							int index = 1;
							for(TenderPackOpeningInfo tenderPackOpeningInfo : tenderPackOpeningInfoList){
								TenderProjectEntity tenderPack = tenderPackOpeningInfo.getTenderProject();
								String startBidOpening = tenderPack.getStartBidOpening();
								if(isPriceStage){
									startBidOpening = tenderPack.getStartPriceBidOpening();
								}
								boolean isStart = false;
								if(null != startBidOpening && startBidOpening.equals(CommonEnum.YES)){
									isStart = true;
								}
								if(isStart && !isShowStartOnly){
									continue;
								}
								if(isShowStartOnly){
									if(!isStart){
										continue;
									}
								}else if(isStart){
									continue;
								}
								
								GridItem gridItem = new GridItem(grid, SWT.NONE);
								int effectiveCount = tenderPackOpeningInfo.getTenderCount() - tenderPackOpeningInfo.getRevokeCount() - Math.max(tenderPackOpeningInfo.getDecFailCount(), tenderPackOpeningInfo.getNoPriceCount());
								gridItem.setData("effectiveCount", effectiveCount);
								gridItem.setData("tenderCount", tenderPackOpeningInfo.getTenderCount());
								gridItem.setData("tenderPack", tenderPack);
								gridItem.setText(0, index+"");
								gridItem.setText(1, "["+tenderPack.getTenderNo() + "]"+ tenderPack.getTenderName());
								if(tenderPackOpeningInfo.getTenderCount() == 0){
									gridItem.setCheckVisible(1, false);
								}
								gridItem.setFont(2, SWTResourceManager.getFont("微软雅黑", 11, SWT.BOLD));
								gridItem.setFont(3, SWTResourceManager.getFont("微软雅黑", 11, SWT.BOLD));
								if(isStart){
									gridItem.setData("isComplate", true);
									gridItem.setCheckVisible(1, false);
									gridItem.setImage(1, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/ok.png"));
								}
								if (anonymousAllInfo) {
								    gridItem.setText(2, "*");
                                    gridItem.setText(3, "*");
                                }else {
                                	gridItem.setText(2, tenderPackOpeningInfo.getTenderCount()+"");
                                	gridItem.setText(3, effectiveCount+"");
                                }
								if(effectiveCount < 3){
									gridItem.setForeground(3, SWTResourceManager.getColor(SWT.COLOR_RED));
									gridItem.setForeground(2, SWTResourceManager.getColor(SWT.COLOR_RED));
								}
								if(null != tenderPackOpeningInfo.getBidOpeningTime() && tenderPackOpeningInfo.getBidOpeningTime().getTime() != bidOpeningTime.getTime()){
									gridItem.setCheckVisible(1, false);
									gridItem.setImage(1, ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/count_down.png"));
									gridItem.setCheckable(1, false);
									gridItem.setToolTipText(1, "与当前选定的开标时间不符！");
								}
								index++;
							}
							if(index > 1){
								confirmBtn.setEnabled(true);
							}
						}
						if(!complateBtn.isDisposed()){
							complateBtn.setEnabled(true);
							unComplateBtn.setEnabled(true);
						}
					}
				});
				
			}
		}).start();
	}
	
	/**
	 * @Description: 全选、反选和取消选择
	 * @author guoyr
	 * @param selectionType 
	 */
	private void selectionAction(int selectionType){
		if(selectionType == 1){
			if (anonymousAllInfo) {
				GridUtils.checkAll(grid, 1, true);
				return;
			}
			GridUtils.checkAll(grid, 1, false);
			int selectCount = 0;
			int noSelectCount = 0;
			for(GridItem gridItem : grid.getItems()){
				if(!gridItem.getCheckVisible(1)){
					continue;
				}
				int effectiveCount = (Integer)gridItem.getData("effectiveCount");
				if(effectiveCount < 3){
					noSelectCount ++;
					continue;
				}
				gridItem.setChecked(1, true);
				selectCount ++;
			}
			StringBuilder msg = new StringBuilder();
			if(selectCount > 0){
				msg.append("已选择").append(selectCount).append(Messages.NumCouns).append(PACK_NAME);
			}else {
				msg.append("没有可选的").append(PACK_NAME);
			}
			if(noSelectCount > 0){
				msg.append("，其中").append(noSelectCount).append(Messages.NumCouns).append(PACK_NAME).append("有效投标家数不足三家未选择（如需选择请手动选择）！");
			}
			MessageDialog.openShortMessage(msg.toString());
		}else if(selectionType == -1){
			GridUtils.checkAllBack(grid, 1);
		}else {
			GridUtils.checkAll(grid, 1, false);
		}
	}

	/**
	 * @Description: 确认开启远程开标大厅
	 * @author guoyr 
	 */
	private void confirmAction(){
		synchronizedInfoOnly = false;
		if(null != tenderPackList){
			tenderPackList.clear();
		}else {
			tenderPackList = new ArrayList<TenderProjectEntity>();
		}
		if(confirmBtn.getEnabled()){
			List<GridItem> gridItems = GridUtils.getCheckedItems(grid, 1, true);
			int noThreeCount = 0; 
			for(GridItem gridItem : gridItems){
				
				int effectiveCount = (Integer)gridItem.getData("effectiveCount");
				if(effectiveCount < 3){
					noThreeCount ++;
//					if(MessageDialog.openConfirm(getShell(), Messages.Button_openRemoteBidOpeningHall, "“"+gridItem.getText(1)+"” 已投标的"+SUPPLIER_NAME+"不足三家，确认要开启当前"+PACK_NAME+"的远程开标大厅吗？", new String[]{"确认开启", "不开启"})){
//						tenderPackList.add((TenderProjectEntity)gridItem.getData("tenderPack"));
//					}else {
//						gridItem.setChecked(1, false);
//					}
					tenderPackList.add((TenderProjectEntity)gridItem.getData("tenderPack"));
				}else {
					tenderPackList.add((TenderProjectEntity)gridItem.getData("tenderPack"));
				}
			}
//			tenderPackList = GridUtils.getCheckedValues(grid, 1, "tenderPack", true);
			if(tenderPackList.size() == 0){
				MessageDialog.openShortMessage("请至少选择一个要启动远程签到的"+PACK_NAME);
				return;
			}
			StringBuilder msg = new StringBuilder();
			if(noThreeCount > 0){
				if (!anonymousAllInfo) {
					msg.append(noThreeCount).append(Messages.NumCouns).append(PACK_NAME).append("有效投标的").append(SUPPLIER_NAME).append("不足三家，");
				}
			}
			if(!MessageDialog.openConfirm(getShell(), Messages.Button_openRemoteBidOpeningHall, msg.toString()+"确认要将已选择的"+PACK_NAME+"启动远程签到吗？", new String[]{Messages.Button_openRemoteBidOpeningHall, Messages.Button_cancel})){
				tenderPackList.clear();
			}
			getShell().close();
		}
	}
	
	private void synchronizedInfoAction(){
		if(null != tenderPackList){
			tenderPackList.clear();
		}else {
			tenderPackList = new ArrayList<TenderProjectEntity>();
		}
		if(synchronizedInfoBtn.getEnabled()){
			List<GridItem> gridItems = GridUtils.getCheckedItems(grid, 1, true);
			int noThreeCount = 0; 
			for(GridItem gridItem : gridItems){
				int signCount = (Integer)gridItem.getData("tenderCount");
				if(signCount < 3){
					noThreeCount ++;
					tenderPackList.add((TenderProjectEntity)gridItem.getData("tenderPack"));
				}else {
					tenderPackList.add((TenderProjectEntity)gridItem.getData("tenderPack"));
				}
			}
			if(tenderPackList.size() == 0){
				MessageDialog.openShortMessage("请至少选择一个要同步签到信息的"+PACK_NAME);
				return;
			}
			StringBuilder msg = new StringBuilder();
			if(noThreeCount > 0){
				msg.append(noThreeCount).append(Messages.Number_2).append(PACK_NAME).append("存在已投标的").append(SUPPLIER_NAME).append("不足三家，");
			}
			if(!MessageDialog.openConfirm(getShell(), "同步签到信息", msg.toString()+"确认要同步已选择"+PACK_NAME+"的签到信息吗？", new String[]{"确认同步", Messages.Button_cancel})){
				tenderPackList.clear();
				return;
			}
			synchronizedInfoOnly = true;
			getShell().close();
		}
	}
	
	public List<TenderProjectEntity> getSelectTenderPackList(){
		return tenderPackList;
	}
	
	public boolean isSynchronizedInfoOnly(){
		return synchronizedInfoOnly;
	};
	/**
	 * Return the initial size of the dialog.
	 */
	@Override
	protected Point getInitialSize() {
		return new Point(700, 500);
	}

}
