package com.gx.obe.opening.dialog;

import java.io.File;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.utils.FileDialogUtils;
import org.eclipse.swt.core.widgets.EButton;
import org.eclipse.swt.core.widgets.EDialog;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.FileUtils;
import com.gx.obe.util.utils.LogUtils;
import com.gx.obe.web.entity.tender.TenderProjectRuleEntity;
import com.gx.obe.web.service.ProjectRuleService;
import com.gx.tools.tts.ITTS;
import com.gx.tools.tts.TTSEnginUtil;
import com.gx.utils.PdfPoiUtil;
import com.gx.utils.WordPoiUtil;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

/**
 * @Description: 选择视频设备界面
 * @author guoyr
 */
public class BidOpeningPlanDialog extends EDialog {
	private EButton saveBtn;
	private Text text;
	private TenderProjectRuleEntity tenderProjectRuleEntity;
	private ProjectRuleService projectRuleService;
	private String BIDOPENING_STAGE;
	private ITTS tts;
	{
		LogUtils.logClass(BidOpeningPlanDialog.class);
	}

	/** 
	 * @author guoyr
	 * @param parentShell
	 * @param tenderProjectEntity
	 * @param supplier 
	 */
	public BidOpeningPlanDialog(Shell parentShell, TenderProjectRuleEntity tenderProjectRuleEntity, String STAGE_PRICE) {
		super(parentShell);
		
		setTitle("开标议程");
		this.tenderProjectRuleEntity = tenderProjectRuleEntity;
		this.BIDOPENING_STAGE = STAGE_PRICE;
		this.setOperator(SWT.MAX | SWT.CLOSE);
		projectRuleService = new ProjectRuleService();
		
	}

	/**
	 * @Description: 
	 * @author guoyr
	 * @param parent
	 * @return 
	 */
	@Override
	protected Control createDialogArea(Composite parent) {
		
		Composite top = (Composite) super.createDialogArea(parent);
		GridLayout gl_top = new GridLayout(1, false);
		gl_top.horizontalSpacing = 0;
		top.setLayout(gl_top);
		
		Composite composite = new Composite(top, SWT.NONE);
		GridLayout gl_composite = new GridLayout(1, false);
		gl_composite.marginHeight = 0;
		gl_composite.marginWidth = 0;
		composite.setLayout(gl_composite);
		composite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		ELink button = new ELink(composite, SWT.NONE);
		button.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				importBidOpenPlan();
			}
		});
		button.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true, false, 1, 1));
		button.setText("导入开标议程");
		button.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/import.png"));
		Composite container = new Composite(top, SWT.NONE);
		GridLayout gl_container = new GridLayout(1, false);
		gl_container.marginHeight = 0;
		gl_container.marginWidth = 0;
		container.setLayout(gl_container);
		container.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		text = new Text(container, SWT.BORDER | SWT.WRAP | SWT.H_SCROLL | SWT.V_SCROLL | SWT.CANCEL);
		text.setFont(SWTResourceManager.getFont("微软雅黑", 11, SWT.NORMAL));
		text.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		
//		ESepator label_1 = new ESepator(top, SWT.SEPARATOR | SWT.HORIZONTAL);
//		label_1.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
//		label_1.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		
		Composite composite_1 = new Composite(top, SWT.NONE);
		composite_1.setBackgroundMode(SWT.INHERIT_FORCE);
		composite_1.setBackgroundImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/fill_bg.png"));
		composite_1.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, false, 1, 1));
		GridLayout gl_composite_1 = new GridLayout(2, false);
		gl_composite_1.marginHeight = 0;
		gl_composite_1.marginWidth = 0;
		composite_1.setLayout(gl_composite_1);
		

		EButton ttsBtn = new EButton(composite_1, SWT.NONE);
		ttsBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				ttsAction();
			}
		});
		GridData gd_ttsBtn = new GridData(SWT.LEFT, SWT.FILL, false, false, 1, 1);
		gd_ttsBtn.widthHint = 90;
		ttsBtn.setLayoutData(gd_ttsBtn);
		ttsBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/voice_start.png"));
		ttsBtn.setText("试听");
		
		saveBtn = new EButton(composite_1, SWT.NONE);
		saveBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				saveAction();
			}
		});
		GridData gd_importFileBtn = new GridData(SWT.LEFT, SWT.FILL, false, false, 1, 1);
		gd_importFileBtn.widthHint = 90;
		saveBtn.setLayoutData(gd_importFileBtn);
		saveBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/success.png"));
		saveBtn.setText(Messages.Button_ok);
		init();
		return container;
	}
	
	
	/**
	 * @Description: 初始化数据
	 * @author guoyr 
	 */
	private void init(){
		if(BIDOPENING_STAGE.equals(TenderProjectEnum.STAGE_PRICE)){
			text.setText(null != tenderProjectRuleEntity.getPriceBidOpeningAgenda() ? tenderProjectRuleEntity.getPriceBidOpeningAgenda() : "");
		}else{
			text.setText(null != tenderProjectRuleEntity.getBidOpeningAgenda() ? tenderProjectRuleEntity.getBidOpeningAgenda() : "");
		}
	}
	/**
	 * @Description: 导入开标议程
	 * @author guoyr 
	 */
	private void importBidOpenPlan(){
		String importFileName = FileDialogUtils.getFileNames(SWT.SINGLE, "选择议程", new String[] { "*.doc;*.docx;*.pdf;*.txt"});
		if(null != importFileName && !"".equals(importFileName.trim())){
			File file = new File(importFileName);
			String singContent = "";
			if(null != file && file.exists()){
				String fileType = file.getName().substring(file.getName().lastIndexOf(".")).toLowerCase();
				if(fileType.startsWith(".doc")){
					singContent = WordPoiUtil.getText(file.getAbsolutePath());
				}else if(fileType.startsWith(".pdf")){
					singContent = PdfPoiUtil.getText(file.getAbsolutePath());
				}else if(fileType.startsWith(".txt")){
					singContent = FileUtils.readFileByLines(importFileName, "utf8");
				}
			}
			if(null != singContent && singContent.length() > 0){
				text.setText(singContent);
			}
		}
	}

	protected Point getInitialSize() {
		return new Point(756, 494);
	}
	
	private void ttsAction(){
		if(null == tts){
			tts = TTSEnginUtil.getTTSEngin();
		}
		tts.speak("");
		if(text.getText().trim().length() == 0){
			MessageDialog.openShortMessage("请录入或导入开议程内容！");
			return;
		}
		tts.speak(text.getText());
	}	
	
	/**
	 * 
	 * @Description: 保存开标议程
	 * @author guoyr 
	 */
	private void saveAction(){
		String bidOpeningAgenda = text.getText().trim();
		boolean result = false;
		if(bidOpeningAgenda.length() > 0){
			if(BIDOPENING_STAGE.equals(TenderProjectEnum.STAGE_PRICE)){
				tenderProjectRuleEntity.setPriceBidOpeningAgenda(bidOpeningAgenda);
				result = projectRuleService.updateAssignProperty(tenderProjectRuleEntity, new String[]{"id","priceBidOpeningAgenda"});
			}else{
				tenderProjectRuleEntity.setBidOpeningAgenda(bidOpeningAgenda);
				result = projectRuleService.updateAssignProperty(tenderProjectRuleEntity, new String[]{"id","bidOpeningAgenda"});
			}
			if(result){
				getShell().close();
			}else{
				MessageDialog.openError(getShell(), Messages.Dialog_warmTips, Messages.Tips_saveFail);
			}
			
		}
	}
}
