package com.gx.obe.opening.dialog;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.widgets.EButton;
import org.eclipse.swt.core.widgets.EDialog;
import org.eclipse.swt.core.widgets.ELabel;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import com.gx.obe.ColorConstants;
import com.gx.obe.components.core.I18NEnum;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.LogUtils;
import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.SupplierOpeningResult;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.service.SupplierOpeningResultService;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

/** 
 * @Description: 确认超时
 * @author guoyr 
 */
public class ConfirmeTimeOutDialog extends EDialog {
	private Text opinionText;
	private Supplier supplier;
	private TenderProjectEntity tenderProjectEntity;
	private EButton saveBtn;
	private Label supplierName;
	private SupplierOpeningResultService supplierOpeningResultService;
	private String supplierNameN;
	private SupplierOpeningResult supplierOpeningResult;
	
	{
		LogUtils.logClass(ConfirmeTimeOutDialog.class);
	}
	
	public ConfirmeTimeOutDialog(Shell parentShell, TenderProjectEntity tenderProjectEntity, Supplier supplier, SupplierOpeningResult supplierOpeningResult) {
		super(parentShell);
		this.tenderProjectEntity = tenderProjectEntity;
		this.supplier = supplier;
		supplierNameN = com.gx.obe.components.core.I18N.getString(I18NEnum.SUPPLIERNAME, null != tenderProjectEntity ? tenderProjectEntity.getTenderType() : null);
		setTitle("录入开标意见");
		supplierOpeningResultService = new SupplierOpeningResultService();
	}

	@Override
	protected Control createDialogArea(Composite parent) {
		
		Composite top = (Composite) super.createDialogArea(parent);
		GridLayout gl_top = new GridLayout(1, false);
		gl_top.verticalSpacing = 0;
		gl_top.horizontalSpacing = 0;
		gl_top.marginHeight = 0;
		gl_top.marginWidth = 0;
		top.setLayout(gl_top);
		
		Composite container = new Composite(top, SWT.NONE);
		container.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		GridLayout gl_container = new GridLayout(1, false);
		gl_container.marginHeight = 10;
		gl_container.marginWidth = 10;
		container.setLayout(gl_container);
		
		supplierName = new Label(container, SWT.WRAP);
		supplierName.setFont(SWTResourceManager.getFont("宋体", 10, SWT.BOLD));
		supplierName.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		supplierName.setText("北京国信创新科技股份有限公司");
		
		ELabel lblsbd = new ELabel(container, SWT.WRAP);
		lblsbd.setForeground(SWTResourceManager.getColor(SWT.COLOR_DARK_GRAY));
		lblsbd.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		lblsbd.setText("请输入"+TenderProjectEnum.getOpenBidEnum(tenderProjectEntity.getPhaseType())+"意见");
		
		ESepator label_1 = new ESepator(top, SWT.SEPARATOR | SWT.HORIZONTAL);
		label_1.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		label_1.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		
		Composite composite = new Composite(top, SWT.NONE);
		FillLayout fl_composite = new FillLayout(SWT.HORIZONTAL);
		fl_composite.marginWidth = 2;
		composite.setLayout(fl_composite);
		GridData gd_composite = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_composite.heightHint = 80;
		composite.setLayoutData(gd_composite);
		
		opinionText = new Text(composite, SWT.WRAP | SWT.V_SCROLL);
		opinionText.setTextLimit(1000);
		
		ESepator label = new ESepator(top, SWT.SEPARATOR | SWT.HORIZONTAL);
		label.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		label.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		
		Composite composite_1 = new Composite(top, SWT.NONE);
		composite_1.setBackgroundMode(SWT.INHERIT_FORCE);
		composite_1.setBackgroundImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/fill_bg.png"));
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		GridLayout gl_composite_1 = new GridLayout(2, false);
		composite_1.setLayout(gl_composite_1);
		
		saveBtn = new EButton(composite_1, SWT.NONE);
		saveBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				saveAction();
			}
		});
		GridData gd_revokeBtn = new GridData(SWT.RIGHT, SWT.CENTER, true, false, 1, 1);
		gd_revokeBtn.widthHint = 90;
		saveBtn.setLayoutData(gd_revokeBtn);
		saveBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/save.png"));
		saveBtn.setText("保存意见");
		
		EButton cancel_btn = new EButton(composite_1, SWT.NONE);
		cancel_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/close.png"));
		cancel_btn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				cancelAction();
			}
		});
		GridData gd_cancleBtn = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
		gd_cancleBtn.widthHint = 90;
		cancel_btn.setLayoutData(gd_cancleBtn);
		cancel_btn.setText(Messages.Button_close);

		init();
		return container;
	}
	
	/**
	 * @Description:初始化 
	 * @author guoyr 
	 */
	private void init(){
		if(null == supplier){
			saveBtn.setEnabled(false);
		}
		supplierName.setText(supplier.getSupplierName());
		
		if(null != supplierOpeningResult && null != supplierOpeningResult.getBidOpeningOpinion()){
			opinionText.setText(supplierOpeningResult.getBidOpeningOpinion());
		}
		
	}

	/**
	 * @Description: 导入投标文件
	 * @author guoyr 
	 */
	private void saveAction(){
		if(saveBtn.getEnabled()){

			boolean isNews = false;
			if(null == supplierOpeningResult || null == supplierOpeningResult.getId()){
				supplierOpeningResult = supplierOpeningResultService.getSupplierOpeningResult(tenderProjectEntity.getId(), supplier.getId());
			}
			if(null == supplierOpeningResult){
				isNews = true;
				supplierOpeningResult = new SupplierOpeningResult();
			}
			supplierOpeningResult.setTenderId(tenderProjectEntity.getId());
			supplierOpeningResult.setSupplierId(supplier.getId());
			supplierOpeningResult.setBidOpeningOpinion(opinionText.getText());
			boolean revokeSuccess = true;
			if(isNews){
				revokeSuccess = null != supplierOpeningResultService.saveOrUpdateNoEmptyReturn(supplierOpeningResult);
			}else {
				revokeSuccess = supplierOpeningResultService.updateAssignProperty(supplierOpeningResult, new String[]{"bidOpeningOpinion"});
			}
			if(revokeSuccess){
				getShell().close();
			}else {
				MessageDialog.openError(getShell(), Messages.Dialog_warmTips, Messages.Tips_saveFail);
			}
		}
	}
	
	private void cancelAction(){
		this.getShell().close();
	}

	/**
	 * Return the initial size of the dialog.
	 */
	@Override
	protected Point getInitialSize() {
		return new Point(387, 253);
	}
}
