package com.gx.obe.opening.dialog;

import java.io.File;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.CallBack;
import org.eclipse.swt.core.listener.TextHintListener;
import org.eclipse.swt.core.utils.FileDialogUtils;
import org.eclipse.swt.core.widgets.EButton;
import org.eclipse.swt.core.widgets.EDialog;
import org.eclipse.swt.core.widgets.ELabel;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.ProgressBar;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import com.gx.obe.ColorConstants;
import com.gx.obe.common.file.enumeration.FileConstants;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.message.Messages;
import com.gx.obe.thread.ImportBidFileThread;
import com.gx.obe.util.utils.LogUtils;
import com.gx.obe.util.utils.StringUtils;
import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

/**
 * @Description: 导入投标文件
 * @author guoyr
 */
public class ImportBidFileDialog extends EDialog {
	private Text text;
	private Text text_1;
	private Supplier supplier;
	private TenderProjectEntity tenderProjectEntity;
	private EButton importFileBtn;
	private ProgressBar progressBar;
	private CLabel selectFileBtn;
	private ELabel supplierName;
	private Shell parentShell;
	private boolean importSuccess = false;
//	private ELink importOtherSingleFile;
	private CLabel bidFileTypeLabel;

	{
		LogUtils.logClass(ImportBidFileDialog.class);
	}

	/** 
	 * @author guoyr
	 * @param parentShell
	 * @param tenderProjectEntity
	 * @param supplier 
	 */
	public ImportBidFileDialog(Shell parentShell, TenderProjectEntity tenderProjectEntity, Supplier supplier) {
		super(parentShell);
		setTitle("导入投标文件");
		this.parentShell = parentShell;
		this.tenderProjectEntity = tenderProjectEntity;
		this.supplier = supplier;
	}

	/**
	 * @Description: 
	 * @author guoyr
	 * @param parent
	 * @return 
	 */
	@Override
	protected Control createDialogArea(Composite parent) {
		
		Composite top = (Composite) super.createDialogArea(parent);
		GridLayout gl_top = new GridLayout(1, false);
		gl_top.verticalSpacing = 0;
		gl_top.horizontalSpacing = 0;
		gl_top.marginHeight = 0;
		gl_top.marginWidth = 0;
		top.setLayout(gl_top);
		
		Composite container = new Composite(top, SWT.NONE);
		container.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_container = new GridLayout(2, false);
		container.setLayout(gl_container);
		
		supplierName = new ELabel(container, SWT.WRAP);
		supplierName.setFont(SWTResourceManager.getFont("宋体", 10, SWT.BOLD));
		supplierName.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		supplierName.setText("北京国信创新科技股份有限公司");
		
		CLabel label = new CLabel(container, SWT.NONE);
		label.setBottomMargin(0);
		label.setTopMargin(0);
		label.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/upload_impot.png"));
		label.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, true, 1, 2));
		label.setText("");
		
		Composite composite_2 = new Composite(container, SWT.NONE);
		composite_2.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		GridLayout gl_composite_2 = new GridLayout(2, false);
		gl_composite_2.horizontalSpacing = 0;
		gl_composite_2.marginHeight = 0;
		gl_composite_2.marginWidth = 0;
		composite_2.setLayout(gl_composite_2);
		
		bidFileTypeLabel = new CLabel(composite_2, SWT.NONE);
		bidFileTypeLabel.setRightMargin(0);
		bidFileTypeLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		bidFileTypeLabel.setForeground(SWTResourceManager.getColor(SWT.COLOR_DARK_GRAY));
		bidFileTypeLabel.setText("请导入sbd格式标书文件");
		
//		importOtherSingleFile = new ELink(composite_2, SWT.NONE);
//		importOtherSingleFile.setLeftMargin(0);
//		importOtherSingleFile.addMouseListener(new MouseAdapter() {
//			@Override
//			public void mouseUp(MouseEvent e) {
////				importSingleBidFileAction();
//			}
//		});
//		importOtherSingleFile.setShowSubLine(false);
//		importOtherSingleFile.setText("单独导入其他文件");
		
		Composite composite = new Composite(container, SWT.BORDER);
		GridLayout gl_composite = new GridLayout(2, false);
		gl_composite.marginHeight = 0;
		gl_composite.marginWidth = 0;
		composite.setLayout(gl_composite);
		composite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 2, 1));
		
		text = new Text(composite, SWT.READ_ONLY);
		text.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		selectFileBtn = new CLabel(composite, SWT.NONE);
		selectFileBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/search.png"));
		selectFileBtn.setCursor(SWTResourceManager.getCursor(SWT.CURSOR_HAND));
		selectFileBtn.setText("浏览");
		selectFileBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				selectFileAction();
			}
		});
		
		text_1 = new Text(container, SWT.BORDER | SWT.READ_ONLY | SWT.WRAP | SWT.V_SCROLL);
		GridData gd_text_1 = new GridData(SWT.FILL, SWT.FILL, true, true, 2, 1);
		gd_text_1.heightHint = 80;
		text_1.setLayoutData(gd_text_1);
		
		ESepator label_1 = new ESepator(top, SWT.SEPARATOR | SWT.HORIZONTAL);
		label_1.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		label_1.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		
		Composite composite_1 = new Composite(top, SWT.NONE);
		composite_1.setBackgroundMode(SWT.INHERIT_FORCE);
		composite_1.setBackgroundImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/fill_bg.png"));
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		GridLayout gl_composite_1 = new GridLayout(3, false);
		composite_1.setLayout(gl_composite_1);
		
		progressBar = new ProgressBar(composite_1, SWT.SMOOTH | SWT.INDETERMINATE);
		progressBar.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1));
		
		importFileBtn = new EButton(composite_1, SWT.NONE);
		importFileBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				importFileAction();
			}
		});
		GridData gd_importFileBtn = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
		gd_importFileBtn.widthHint = 90;
		importFileBtn.setLayoutData(gd_importFileBtn);
		importFileBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/upload.png"));
		importFileBtn.setText(Messages.Button_import);
		
		EButton cancel_btn = new EButton(composite_1, SWT.NONE);
		cancel_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/close.png"));
		cancel_btn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				cancelAction();
			}
		});
		GridData gd_cancleBtn = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
		gd_cancleBtn.widthHint = 90;
		cancel_btn.setLayoutData(gd_cancleBtn);
		cancel_btn.setText(Messages.Button_close);

		init();
		return container;
	}
	
	/**
	 * @Description: 界面数据初始化
	 * @author guoyr 
	 */
	private void init(){
		if(null != tenderProjectEntity.getPhaseType() && tenderProjectEntity.getPhaseType().equals(TenderProjectEnum.PHASE_TYPE_PRE)){
			bidFileTypeLabel.setText("请导入"+FileConstants.EZG+"格式文件");
			text.addPaintListener(new TextHintListener("请导入"+FileConstants.EZG+"格式标书文件"));
		}else {
			bidFileTypeLabel.setText("请导入"+FileConstants.ETB+"格式文件");
			text.addPaintListener(new TextHintListener("请导入"+FileConstants.ETB+"格式标书文件"));
		}
		importFileBtn.setEnabled(false);
		progressBar.setVisible(false);
		if(null != supplier && null != tenderProjectEntity){
			supplierName.setText(supplier.getSupplierName());
		}else {
			selectFileBtn.setEnabled(false);
		}
	}
	
	/**
	 * @Description: 选择标书 
	 * @author guoyr 
	 */
	private void selectFileAction(){
//		importOtherSingleFile.setEnabled(false);
		if(selectFileBtn.getEnabled()){
			String[] bidFileType = new String[]{"*"+FileConstants.ETB, "*.etb;*.sbd;*.ezg"};
			if(null != tenderProjectEntity.getPhaseType() && tenderProjectEntity.getPhaseType().equals(TenderProjectEnum.PHASE_TYPE_PRE)){
				bidFileType = new String[]{"*"+FileConstants.EZG, "*.etb;*.sbd;*.ezg"};
			}
			String fileNames = FileDialogUtils.getFileNames(SWT.SINGLE, "请选择标书文件", bidFileType, new String[]{bidFileType[0],"所有标书文件"});
			
			if(StringUtils.isEmpty(fileNames)){
				importFileBtn.setEnabled(false);
				return ;
			}else {
				importFileBtn.setEnabled(true);
				text.setText(fileNames);
			}
		}
		// 为了避免在双击选择文件是不小心点击导入其他单独文件连接，在选择文件1秒后再将其设为可用
//		new Thread(new Runnable(){
//			public void run(){
//				try {
//					Thread.sleep(1000);
//				} catch (InterruptedException e) {
//				}
//				Display.getDefault().syncExec(new Runnable(){
//					public void run(){
//						if(!importOtherSingleFile.isDisposed()){
//							importOtherSingleFile.setEnabled(true);
//						}
//					}
//				});
//			};
//		}).start();
	}

	/**
	 * @Description: 导入投标文件
	 * @author guoyr 
	 */
	private void importFileAction(){
		if(importFileBtn.getEnabled()){
			progressBar.setVisible(true);
			importFileBtn.setEnabled(false);
			selectFileBtn.setEnabled(false);
			new ImportBidFileThread(tenderProjectEntity, supplier, new File(text.getText()), new CallBack(){
				@Override
				public void after() {
					importSuccess = true;
					try {
						Thread.sleep(1000);
					} catch (InterruptedException e) {
					}
					Display.getDefault().syncExec(new Runnable() {
						public void run() {
							if(null != progressBar && !progressBar.isDisposed()){
								progressBar.setVisible(false);
								selectFileBtn.setEnabled(true);
								importFileBtn.setEnabled(true);
								getShell().close();
							}
						}
					});
				}
				@Override
				public void callBackString(String msg) {
					showMessage(msg);
				}
				
			}).start();
		}
	}
	
	/**
	 * @Description: 单独导入其它格式文件
	 * @author guoyr 
	 */
	private void importSingleBidFileAction(){
//		if(importOtherSingleFile.getEnabled()){
//			ImportSingleBidFileDialog dialog = new ImportSingleBidFileDialog(parentShell, tenderProjectEntity, supplier);
//			dialog.setTitle(supplier.getSupplierName());
//			dialog.open();
//			getShell().close();
//		}
	}
	
	/**
	 * @Description:显示消息 
	 * @author guoyr
	 * @param msg 
	 */
	public void showMessage(final String msg){
		Display.getDefault().syncExec(new Runnable() {
			public void run() {
				if(null != text_1 && !text_1.isDisposed()){
					text_1.setText(text_1.getText()+msg+"\r\n");
					text_1.setSelection(text_1.getText().length());
				}
			}
		});
	}
	
	private void cancelAction(){
		this.getShell().close();
	}
	public boolean isImportSuccess() {
		return importSuccess;
	}

	public void setImportSuccess(boolean importSuccess) {
		this.importSuccess = importSuccess;
	}

	@Override
	protected Point getInitialSize() {
		return new Point(413, 263);
	}
}
