package com.gx.obe.opening.dialog;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.ole.win32.OleAutomation;
import org.eclipse.swt.ole.win32.OleClientSite;
import org.eclipse.swt.ole.win32.OleFrame;
import org.eclipse.swt.ole.win32.Variant;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.FileDialog;
import org.eclipse.swt.widgets.Menu;
import org.eclipse.swt.widgets.MenuItem;
import org.eclipse.swt.widgets.Shell;  
public class SWTVideoPlayer {
	 static OleClientSite site;  
     static OleAutomation auto;  
     public static void main(String[] args) {  
         Display display = new Display();  
         Shell shell = new Shell(display);  
         shell.setSize(300,180);  
         shell.setText("SWT Video Player");  

         shell.setLayout(new FillLayout());  

         OleFrame frm = new OleFrame(shell, SWT.NONE);  

         site = new OleClientSite(frm, SWT.NONE,"MediaPlayer.MediaPlayer.1");  
         auto = new OleAutomation(site);  
         int[] ids = auto.getIDsOfNames(new String[] { "Play" });  
         auto.invoke(ids[0]);  
         addFileMenu(frm);  
         shell.open();  

         while (!shell.isDisposed()){  
             if (!display.readAndDispatch()){  
                 display.sleep();  
             }  
         }  

         site.deactivateInPlaceClient();  
         site.dispose();  
         auto.dispose();  
     }  
      
     public static void addFileMenu(OleFrame frame) {  
         final Shell shell = frame.getShell();  
         Menu menuBar = shell.getMenuBar();  
         if (menuBar == null) {  
             menuBar = new Menu(shell, SWT.BAR);  
             shell.setMenuBar(menuBar);  
         }  
         MenuItem fileMenu = new MenuItem(menuBar, SWT.CASCADE);  
         fileMenu.setText("&File");  
         Menu menuFile = new Menu(fileMenu);  
         fileMenu.setMenu(menuFile);  
         frame.setFileMenus(new MenuItem[] { fileMenu });  

         MenuItem menuFileOpen = new MenuItem(menuFile, SWT.CASCADE);  
         menuFileOpen.setText("Open");  
         menuFileOpen.addSelectionListener(new SelectionAdapter() {  
             public void widgetSelected(SelectionEvent e) {  
                 fileOpen();  
             }  
         });  
           
         MenuItem menuFileExit = new MenuItem(menuFile, SWT.CASCADE);  
         menuFileExit.setText("Exit");  
         menuFileExit.addSelectionListener(new SelectionAdapter() {  
             public void widgetSelected(SelectionEvent e) {  
                 shell.dispose();  
             }  
         });  
     }  

     public static void fileOpen() {  
         FileDialog dialog = new FileDialog(site.getShell(), SWT.OPEN);  
         dialog.setFilterExtensions(new String[] { "*.wma","*.mp3","*.wav" });  
         String filename = dialog.open();  
         if (filename != null) {  
             OleAutomation player = new OleAutomation(site);  
             int playURL[] = player.getIDsOfNames(new String[] { "Open" });  
             if (playURL != null) {  
                 Variant theFile = new Variant(filename);  
                 player.invoke(playURL[0],new Variant[] { theFile});  
             }  
         }  
     }  
      
     public static void setURL(String fileName){  
         if (fileName != null) {  
             OleAutomation player = new OleAutomation(site);  
             int playURL[] = player.getIDsOfNames(new String[] { "Open" });  
             if (playURL != null) {  
                 Variant theFile = new Variant(fileName);  
                 player.invoke(playURL[0],new Variant[] { theFile});  
             }  
         }  
     }  

}
