package com.gx.obe.opening.dialog;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.widgets.EButton;
import org.eclipse.swt.core.widgets.EDialog;
import org.eclipse.swt.core.widgets.ImageButton;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Shell;

import com.gx.obe.ColorConstants;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.message.Messages;
import com.gx.obe.opening.Activator;
import com.gx.obe.web.entity.tender.TenderProjectRuleEntity;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

public class SelectBidOpeningTypeDialog extends EDialog {

	private Group openingTypeComposite;
	private Group stageTypeComposite;
	private TenderProjectRuleEntity tenderProjectRuleEntity;
	private boolean isFocusDecrypt = false;
	private String bidopeningStage = null;
	private String decryptType;
	
	
	/**
	 * Create the dialog.
	 * @param parentShell
	 */
	public SelectBidOpeningTypeDialog(Shell parentShell, String openingType, TenderProjectRuleEntity tenderProjectRuleEntity) {
		super(parentShell);
		this.decryptType = openingType;
		this.tenderProjectRuleEntity = tenderProjectRuleEntity;
	}

	/**
	 * Create contents of the dialog.
	 * @param parent
	 */
	@Override
	protected Control createDialogArea(Composite parent) {
		Composite container = (Composite) super.createDialogArea(parent);
		container.setLayout(new GridLayout(1, false));
		
		Composite composite = new Composite(container, SWT.NONE);
		composite.setLayout(new GridLayout(1, false));
		composite.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, true, 1, 1));
		
		CLabel label = new CLabel(composite, SWT.NONE);
		label.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, false, true, 1, 1));
		label.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/tender_pager.png"));
		
		openingTypeComposite = new Group(container, SWT.NONE);
		openingTypeComposite.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.NORMAL));
		openingTypeComposite.setLayout(new GridLayout(2, false));
		openingTypeComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		openingTypeComposite.setText("解密类型");
		
		
		stageTypeComposite = new Group(container, SWT.NONE);
		stageTypeComposite.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.NORMAL));
		stageTypeComposite.setText("阶段类型");
		stageTypeComposite.setLayout(new GridLayout(2, false));
		stageTypeComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		Composite composite_1 = new Composite(container, SWT.NONE);
		composite_1.setLayout(new GridLayout(2, true));
		composite_1.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, false, 1, 1));
		
		EButton confirmBtn = new EButton(composite_1, SWT.NONE);
		confirmBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				confirmAction();
			}
		});
		GridData gd_confirmBtn = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
		gd_confirmBtn.heightHint = 30;
		gd_confirmBtn.widthHint = 90;
		confirmBtn.setLayoutData(gd_confirmBtn);
		confirmBtn.setText(Messages.Button_confirm);
		
		EButton cancelBtn = new EButton(composite_1, SWT.NONE);
		cancelBtn.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		cancelBtn.setText(Messages.Button_cancel);
		cancelBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				close();
			}
		});

		init();
		return container;
	}
	
	private void init(){
		
		ImageButton isRemoteBtn = null;
		ImageButton isFocusBtn = null;
//		String decryptType = PropertiesUtils.getProperty(ConfigConstants.DECRYPT_TYPE, Constants.DECRYPT_REMOTE + "," + Constants.DECRYPT_FOCUS);
		if(decryptType.indexOf(Constants.DECRYPT_REMOTE) >= 0){
			isRemoteBtn = addDecBidTypeBtn(openingTypeComposite, "投标人远程解密", "isFocus", "00");
		}
		if(decryptType.indexOf(Constants.DECRYPT_FOCUS) >= 0){
			isFocusBtn = addDecBidTypeBtn(openingTypeComposite, "服务器集中解密", "isFocus", "01");
		}
		String isFocusType = PropertiesUtils.getProperty("isFocus", "01");
		if(null != isFocusBtn && isFocusType.equals("01")){
			isFocusBtn.notifyListeners(SWT.MouseUp, null);
		}else if(null != isRemoteBtn && isFocusType.equals("00")){
			isRemoteBtn.notifyListeners(SWT.MouseUp, null);
		}
		
		if(null != tenderProjectRuleEntity.getBidOpeningStage() && tenderProjectRuleEntity.getBidOpeningStage().equals(TenderProjectEnum.BID_OPENING_TWO_STAGE)){
			this.setTitle("请选择解密类型和阶标段类型");
			addDecBidTypeBtn(stageTypeComposite, Messages.BusinessTechnologyBid, "bidopeningStage", TenderProjectEnum.STAGE_BUS_TEC);
			addDecBidTypeBtn(stageTypeComposite, Messages.EconomicBid, "bidopeningStage", TenderProjectEnum.STAGE_PRICE);
		}else {
			this.setTitle("请选择解密类型");
			stageTypeComposite.dispose();
		}
	}

	/**
	 * @Description: 确认
	 * @author guoyr 
	 */
	private void confirmAction(){
		String isFocusType = null;
		for(Control control : openingTypeComposite.getChildren()){
			ImageButton isFocusButton = (ImageButton)control;
			if(isFocusButton.getSelection()){
				isFocusType = (String)isFocusButton.getData("isFocus");
				break;
			}
		}
		
		if(!stageTypeComposite.isDisposed()){
			for(Control control : stageTypeComposite.getChildren()){
				ImageButton bidopeningStageButton = (ImageButton)control;
				if(bidopeningStageButton.getSelection()){
					bidopeningStage = (String)bidopeningStageButton.getData("bidopeningStage");
					break;
				}
			}
		}else {
			bidopeningStage = TenderProjectEnum.STAGE_ALL;
		}
		if(null == isFocusType){
			MessageDialog.openWarning(getShell(), "请选择解密类型！");
			return ;
		}
		if(isFocusType.equals("01")){
			isFocusDecrypt = true;
		}
		PropertiesUtils.saveProperty("isFocus", isFocusDecrypt ? "01" : "00");
		if(null == bidopeningStage){
			MessageDialog.openWarning(getShell(), "请选择阶段类型！");
			return ;
		}
		close();
	}
	
	private ImageButton addDecBidTypeBtn(final Composite parent, String title, String key, final String value){
		final ImageButton label = new ImageButton(parent, SWT.NONE);
		label.setText(title);
		label.setLeftMargin(20);
		label.setRightMargin(20);
		label.setSubImageRightMargin(5);
		label.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, true, 1, 1));
		label.setData(key, value);
//		label.setBorderColor(SWTResourceManager.getColor(60, 138, 226));
//		label.setActiveBorderColor(SWTResourceManager.getColor(255, 153, 0));
//		label.setSelectionBorderColor(SWTResourceManager.getColor(77, 163, 19));
		label.setSelectionForeground(SWTResourceManager.getColor(77, 163, 19));
		label.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/unchecked.png"));
		label.setForeground(ColorConstants.FONT_BLACK_COLOR);
		label.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.NORMAL));
		label.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				for(Control control : parent.getChildren()){
					if(control.equals(label)){
						continue;
					}
					ImageButton button = (ImageButton)control;
					button.setSelection(false);
					button.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/unchecked.png"));
				}
				if(label.getSelection()){
					label.setSelection(false);
					label.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/unchecked.png"));
				}else {
					label.setSelection(true);
					label.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/checked.png"));
				}
			}
		});
		return label;
	}
	
	
	public boolean isFocusDecrypt() {
		return isFocusDecrypt;
	}

	public void setFocusDecrypt(boolean isFocusDecrypt) {
		this.isFocusDecrypt = isFocusDecrypt;
	}

	public String getBidopeningStage() {
		return bidopeningStage;
	}

	public void setBidopeningStage(String bidopeningStage) {
		this.bidopeningStage = bidopeningStage;
	}

	/**
	 * Return the initial size of the dialog.
	 */
	@Override
	protected Point getInitialSize() {
		return new Point(450, 300);
	}
}
