package com.gx.obe.opening.dialog;

import java.text.SimpleDateFormat;
import java.util.Date;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.widgets.EButton;
import org.eclipse.swt.core.widgets.EDialog;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import com.gx.obe.ColorConstants;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.message.Messages;
import com.gx.obe.opening.thread.SendNoticeThread;
import com.gx.obe.util.utils.LogUtils;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.swtdesigner.ResourceManager;

/** 
 * @Description: 发送开标通告
 * @author guoyr 
 */
public class SendBidOpeningNoticeDialog extends EDialog {
	private Text noticeText;
	private TenderProjectEntity tenderProjectEntity;
	private EButton sendBtn;
	private SendNoticeThread sendNoticeThread;	
	private Text history_messgae_text;
	private StringBuilder sendMessage = new StringBuilder();
	private SimpleDateFormat format = new SimpleDateFormat("yyyy年MM月dd日 HH:mm:ss");
	{
		LogUtils.logClass(SendBidOpeningNoticeDialog.class);
	}
	
	public SendBidOpeningNoticeDialog(Shell parentShell, TenderProjectEntity tenderProjectEntity) {
		super(parentShell);
		this.tenderProjectEntity = tenderProjectEntity;
		setTitle("发送通告");
	}

	@Override
	protected Control createDialogArea(Composite parent) {
		
		Composite top = (Composite) super.createDialogArea(parent);
		GridLayout gl_top = new GridLayout(1, false);
		gl_top.verticalSpacing = 0;
		gl_top.horizontalSpacing = 0;
		gl_top.marginHeight = 0;
		gl_top.marginWidth = 0;
		top.setLayout(gl_top);
		
	
		
//		ScrolledComposite scrolledComposite = new ScrolledComposite(top, SWT.BORDER | SWT.H_SCROLL | SWT.V_SCROLL);
//		scrolledComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
//		scrolledComposite.setExpandHorizontal(true);
//		scrolledComposite.setExpandVertical(true);
		
		Composite composite_2 = new Composite(top, SWT.NONE);
		composite_2.setLayout(new GridLayout(1, false));
		composite_2.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		history_messgae_text = new Text(composite_2, SWT.WRAP | SWT.V_SCROLL);
		history_messgae_text.setEditable(false);
		history_messgae_text.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
//		scrolledComposite.setContent(composite_2);
//		scrolledComposite.setMinSize(composite_2.computeSize(SWT.DEFAULT, SWT.DEFAULT));
		
//		Composite container = new Composite(top, SWT.NONE);
//		container.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
//		GridLayout gl_container = new GridLayout(1, false);
//		gl_container.marginHeight = 10;
//		gl_container.marginWidth = 10;
//		container.setLayout(gl_container);
		
		ESepator label_1 = new ESepator(top, SWT.SEPARATOR | SWT.HORIZONTAL);
		label_1.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		label_1.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		
		Composite composite = new Composite(top, SWT.NONE);
		FillLayout fl_composite = new FillLayout(SWT.HORIZONTAL);
		fl_composite.marginWidth = 2;
		composite.setLayout(fl_composite);
		GridData gd_composite = new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1);
		gd_composite.heightHint = 100;
		composite.setLayoutData(gd_composite);
		
		noticeText = new Text(composite, SWT.WRAP | SWT.V_SCROLL);
		noticeText.setTextLimit(200);
		
		ESepator label = new ESepator(top, SWT.SEPARATOR | SWT.HORIZONTAL);
		label.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		label.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		
		Composite composite_1 = new Composite(top, SWT.NONE);
		composite_1.setBackgroundMode(SWT.INHERIT_FORCE);
		composite_1.setBackgroundImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/fill_bg.png"));
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		GridLayout gl_composite_1 = new GridLayout(2, false);
		composite_1.setLayout(gl_composite_1);
		
		sendBtn = new EButton(composite_1, SWT.NONE);
		sendBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				
				sendMessageAction();
			}
		});
		GridData gd_revokeBtn = new GridData(SWT.RIGHT, SWT.CENTER, true, false, 1, 1);
		sendBtn.setLayoutData(gd_revokeBtn);
		sendBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/send.png"));
		sendBtn.setText("发送通告");
		
		EButton cancel_btn = new EButton(composite_1, SWT.NONE);
		cancel_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/close.png"));
		cancel_btn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				cancelAction();
			}
		});
		GridData gd_cancleBtn = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
		cancel_btn.setLayoutData(gd_cancleBtn);
		cancel_btn.setText(Messages.Button_close);

		init();
		return top;
	}
	
	private void init(){
		final Runnable sendNoticeRunnable = new Runnable(){
			public void run(){
				if(!history_messgae_text.isDisposed()){
					history_messgae_text.setText(sendMessage.toString());
					history_messgae_text.setSelection(history_messgae_text.getText().length());
				}
			}
		};
		sendNoticeThread = new SendNoticeThread(tenderProjectEntity, "", new SendNoticeThread.SendListener() {
			public void sendMessage(boolean sendFlag, Date sendTime, String message) {
				if(sendFlag){
					sendMessage.append(format.format(sendTime));
				}else {
					sendMessage.append(format.format(sendTime) +"  [消息发送失败]");
				}
				sendMessage.append("\r\n");
				sendMessage.append(message);
				sendMessage.append("\r\n");
				Display.getDefault().asyncExec(sendNoticeRunnable);
			}
		});
		sendNoticeThread.start();
	}
	

	/**
	 * @Description: 发送消息内容
	 * @author guoyr 
	 */
	private void sendMessageAction(){
		if(sendBtn.getEnabled()){
			if(noticeText.getText().trim().length() > 0){
				String message = noticeText.getText();
				noticeText.setText("");
				sendNoticeThread.sendNotice(message);
			}else {
				MessageDialog.openShortMessage("请输入发送内容！");
			}
		}
	}
	
	private void cancelAction(){
		this.getShell().close();
	}


	/**
	 * Return the initial size of the dialog.
	 */
	@Override
	protected Point getInitialSize() {
		return new Point(726, 575);
	}
}
