package com.gx.obe.opening.listener;

import java.util.Date;

import org.eclipse.swt.widgets.Composite;

import com.gx.obe.util.thread.CountTimeThread;

public interface MeetingRoomListener {
	
	/**
	 * @Description: 获取加载容器
	 * @author guoyr
	 * @return 
	 */
	public abstract Composite getLoadParent();

	public abstract Composite getOperatorParent();
	
	public abstract void refreshOperator();
	
	/**
	 * @Description: 刷新会议室标题
	 * @author guoyr
	 * @param meetingTitle 
	 */
	public void refreshMeetingTitle(String meetingTitle);
	
	/**
	 * @Description: 刷新会议时间
	 * @author guoyr
	 * @param meetingTimeTitle
	 * @param meetingTime 
	 */
	public void refreshMeetingTime(String meetingTimeTitle, Date meetingTime);
	
	public void addCountTimeListener(CountTimeThread.CountTime countTimeListener);
	/**
	 * @Description: 显示当前时间
	 * @author guoyr
	 * @param delayTime 
	 */
	public void showNowTime(long delayTime);
	
	/**
	 * @Description: 刷新倒计时
	 * @author guoyr
	 * @param countDownTimeTitle
	 * @param countDownTime 
	 */
	public void refreshCountDownTime(String countDownTimeTitle, Date countDownTime);
	
	/**
	 * @Description: 刷新有人的座位
	 * @author guoyr 
	 */
	public void refreshPeopleCount(int peopleCount);
	
	/**
	 * @Description: 刷新主持人桌子
	 * @author guoyr
	 * @param title 
	 */
	public void refreshManagerTable(String title);
	/**
	 * @Description: 退出会议室
	 * @author guoyr 
	 */
	public void exitMeetingRoom();
	
	public void open();
}
