package com.gx.obe.opening.listener;

import java.util.Date;

import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.SupplierOpeningResult;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.entity.tender.TenderProjectRuleEntity;

public interface SupplierBidopeningListener {

	/**
	 * @Description: 刷新投标人信息
	 * @author guoyr
	 * @param tenderProjectEntity
	 * @param tenderProjectRuleEntity
	 * @param supplier
	 */
	public void refreshSupplierInfo(TenderProjectEntity tenderProjectEntity, TenderProjectRuleEntity tenderProjectRuleEntity, Supplier supplier);
	
	/**
	 * @Description: 刷新签到信息
	 * @author guoyr
	 * @param signTime
	 * @param signPerson
	 * @param signPersonCard
	 * @param signPersonTel 
	 */
	public void refreshSignInfo(Date signTime, String signPerson, String signPersonCard, String signPersonTel);
	
	/**
	 * @Description: 刷新确认信息
	 * @author guoyr
	 * @param supplierOpeningResult 
	 */
	public void refreshConfirmInfo(SupplierOpeningResult supplierOpeningResult);
	
	/**
	 * @Description: 刷新进入开标室状态
	 * @author guoyr
	 * @param supplierOpeningResult 
	 */
	public void refreshEnterRoomStatus(String status);
	
	/**
	 * @Description: 能否开标
	 * @author guoyr
	 * @return
	 */
	public boolean canOpenBid();
	
	/**
	 * @Description: 是否解密商务标
	 * @author guoyr
	 * @return 
	 */
	public boolean isDecBusinessBid();
	/**
	 * @Description: 是否解密技术标
	 * @author guoyr
	 * @return 
	 */
	public boolean isDecTechnologyBid();
	/**
	 * @Description: 是否解密价格标
	 * @author guoyr
	 * @return 
	 */
	public boolean isDecPriceBid();
	/**
	 * @Description: 获得投标人
	 * @author guoyr
	 * @return
	 */
	public Supplier getSupplier();
	
	/**
	 * @Description: 获得解密标书监听
	 * @author guoyr
	 * @return 
	 */
	public DecryptBidFileProgressListener getDecryptBidFileListener();
	
	/**
	 * @Description: 设置列宽
	 * @author guoyr
	 * @param bidFileStatusWidth
	 * @param bidBondWidth
	 * @param tenderFeeWidth
	 * @param signStatusWidth
	 * @param priceWidth
	 * @param statusWidth
	 */
	public void setColumnWidth(int supplierNameWidth, int bidFileStatusWidth, int bidBondWidth, int tenderFeeWidth, int signStatusWidth, int confirmStatusWidth, int priceWidth, int statusWidth);
}
