package com.gx.obe.opening.shell;

import java.awt.Dimension;
import java.awt.Toolkit;
import java.io.File;
import java.util.Date;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.ImageResolver;
import org.eclipse.swt.core.widgets.ImageButton;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.events.ControlAdapter;
import org.eclipse.swt.events.ControlEvent;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.graphics.Cursor;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;

import com.gx.obe.common.file.entity.BiddingFile;
import com.gx.obe.common.file.enumeration.FileConstants;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.thread.MyRunnable;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.opening.Activator;
import com.gx.obe.report.dataset.word.BidOpeningAgendaTemplate;
import com.gx.obe.util.thread.CountTimeThread;
import com.gx.obe.util.utils.DateUtils;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.listener.WebEntityListener;
import com.gx.obe.web.service.TenderProjectService;
import com.gx.tools.tts.ITTS;
import com.gx.tools.tts.TTSEnginUtil;
import com.gx.utils.NowTimeUtils;
import com.gx.utils.PdfPoiUtil;
import com.gx.utils.WordPoiUtil;
import com.report.word.WordDataSet;
import com.report.word.WordGenerateAdapter;
import com.report.word.WordTemplate;
import com.report.word.WordTemplateReportUtil;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

public class BidOpeningCountDownShell extends Shell {

	private ImageResolver imageResolver = new ImageResolver();
	private TenderProjectService tenderProjectService;
	private TenderProjectEntity tenderProjectEntity;
	private CLabel hour_first_label;
	private CLabel hour_second_label;
	private CLabel minute_first_label;
	private CLabel minute_second_label;
	private CLabel seconds_first_label;
	private CLabel seconds_second_label;
	private CountTimeThread countTimeThread;
	private Image zoomBgImage;
	private Label bidOpeningTimeLabel;
	private Label weakLabel;
	private Label projectName;
	private Label projectCode;
	private Label packageName;
	private Composite content_composite;
	private Composite project_composite;
	private ImageButton startVideo_btn;
	private ImageButton stopVideo_btn;
	private ImageButton restartVideo_btn;
	private ITTS tts;
	private String singContent = null;
	private Thread readFileThread;
	private PaintListener paintListener;
	private String bidopeningStage;
	private Date bidOpeningTime;
	private String bidOpeningAgenda;
	public BidOpeningCountDownShell(Shell parentShell, TenderProjectEntity tenderPack, Date bidOpeningTime, String bidOpeningAgenda) {
		super(parentShell, SWT.NO_TRIM);
		setBackgroundMode(SWT.INHERIT_FORCE);
		this.tenderProjectEntity = tenderPack;
		this.bidOpeningTime = bidOpeningTime;
		this.bidOpeningAgenda = bidOpeningAgenda;
		
		setBackgroundImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID,"icons/countdown_bg.jpg"));
		GridLayout gridLayout = new GridLayout(1, false);
		setLayout(gridLayout);
		
		Composite composite_1 = new Composite(this, SWT.NONE);
		GridLayout gl_composite_1 = new GridLayout(1, false);
		gl_composite_1.marginHeight = 0;
		composite_1.setLayout(gl_composite_1);
		composite_1.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		
		ImageButton close_btn = new ImageButton(composite_1, SWT.NONE);
		close_btn.setSurroundColor(SWTResourceManager.getColor(255, 153, 0));
		close_btn.setActiveSurroundColor(SWTResourceManager.getColor(255, 0, 0));
		close_btn.setSurroundMargin(5);
		close_btn.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/main_close.png"));
		close_btn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				close();
			}
		});
		
		content_composite = new Composite(this, SWT.NONE);
		content_composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_content_composite = new GridLayout(1, false);
		gl_content_composite.marginWidth = 20;
		content_composite.setLayout(gl_content_composite);
		
		project_composite = new Composite(content_composite, SWT.NONE);
		project_composite.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, true, 1, 1));
		GridLayout gl_project_composite = new GridLayout(1, false);
		gl_project_composite.marginWidth = 20;
		gl_project_composite.verticalSpacing = 15;
		gl_project_composite.marginHeight = 0;
		project_composite.setLayout(gl_project_composite);
		
		projectName = new Label(project_composite, SWT.WRAP);
		projectName.setAlignment(SWT.CENTER);
		projectName.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		projectName.setFont(SWTResourceManager.getFont("微软雅黑", 35, SWT.BOLD));
		projectName.setForeground(SWTResourceManager.getColor(80, 80, 80));
		projectName.setText("");
		
		projectCode = new Label(project_composite, SWT.WRAP);
		projectCode.setAlignment(SWT.CENTER);
		projectCode.setFont(SWTResourceManager.getFont("微软雅黑", 30, SWT.NORMAL));
		projectCode.setForeground(SWTResourceManager.getColor(102, 102, 102));
		projectCode.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		projectCode.setText("");
		
		packageName = new Label(project_composite, SWT.WRAP);
		packageName.setAlignment(SWT.CENTER);
		packageName.setFont(SWTResourceManager.getFont("微软雅黑", 30, SWT.NORMAL));
		packageName.setForeground(SWTResourceManager.getColor(102, 102, 102));
		packageName.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		packageName.setText("");
		
		final CLabel label = new CLabel(content_composite, SWT.NONE);
		label.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID,"icons/topline.png"));
		label.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		label.addPaintListener(new PaintListener() {
			public void paintControl(PaintEvent arg0) {
				Image topLine = ResourceManager.getPluginImage(Activator.PLUGIN_ID,"icons/topline.png");
				GC gc = arg0.gc;
				gc.drawImage(topLine, 0, 0, topLine.getBounds().width, topLine.getBounds().height, label.getBounds().x, label.getBounds().height - topLine.getBounds().height, label.getBounds().width, topLine.getBounds().height);
				label.removePaintListener(this);
				label.setImage(null);
				label.addPaintListener(this);
			}
		});
		
		Composite composite = new Composite(content_composite, SWT.NONE);
		GridLayout gl_composite = new GridLayout(5, false);
		gl_composite.marginHeight = 20;
		composite.setLayout(gl_composite);
		composite.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, true, 1, 1));
		{
			
			Composite hour_omposite = new Composite(composite, SWT.NONE);
			GridLayout gl_hour_omposite = new GridLayout(2, false);
			gl_hour_omposite.verticalSpacing = 0;
			hour_omposite.setLayout(gl_hour_omposite);
			
			Composite composite_8 = new Composite(hour_omposite, SWT.NONE);
			composite_8.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
			GridLayout gl_composite_8 = new GridLayout(3, false);
			gl_composite_8.horizontalSpacing = 0;
			composite_8.setLayout(gl_composite_8);
			
			Label label_3 = new Label(composite_8, SWT.NONE);
			label_3.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
			label_3.setFont(SWTResourceManager.getFont("微软雅黑", 15, SWT.NORMAL));
			label_3.setText("倒\r\n计\r\n时    ");
			label_3.setForeground(SWTResourceManager.getColor(102, 102, 102));
			
			hour_first_label = new CLabel(composite_8, SWT.NONE);
			hour_first_label.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
			hour_first_label.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/time/time_blue_bg.png"));
			
			hour_second_label = new CLabel(composite_8, SWT.NONE);
			hour_second_label.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/time/time_blue_bg.png"));
			
			CLabel hour_sep_label = new CLabel(hour_omposite, SWT.NONE);
			hour_sep_label.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/time/blue_sep.png"));
			
			Label label_5 = new Label(hour_omposite, SWT.NONE);
			label_5.setFont(SWTResourceManager.getFont("微软雅黑", 15, SWT.NORMAL));
			label_5.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
			label_5.setText("时");
			label_5.setForeground(SWTResourceManager.getColor(102, 102, 102));
			new Label(hour_omposite, SWT.NONE);
		}
		{
			
			Composite minute_composite = new Composite(composite, SWT.NONE);
			GridLayout gl_minute_composite = new GridLayout(2, false);
			gl_minute_composite.verticalSpacing = 0;
			minute_composite.setLayout(gl_minute_composite);
			
			Composite composite_8 = new Composite(minute_composite, SWT.NONE);
			GridLayout gl_composite_8 = new GridLayout(2, false);
			gl_composite_8.horizontalSpacing = 0;
			composite_8.setLayout(gl_composite_8);
			
			minute_first_label = new CLabel(composite_8, SWT.NONE);
			minute_first_label.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
			minute_first_label.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/time/time_blue_bg.png"));
			
			minute_second_label = new CLabel(composite_8, SWT.NONE);
			minute_second_label.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
			minute_second_label.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/time/time_blue_bg.png"));
			
			CLabel minute_sep_label = new CLabel(minute_composite, SWT.NONE);
			minute_sep_label.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/time/blue_sep.png"));
			
			Label label_5 = new Label(minute_composite, SWT.NONE);
			label_5.setFont(SWTResourceManager.getFont("微软雅黑", 15, SWT.NORMAL));
			label_5.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
			label_5.setText("分");
			label_5.setForeground(SWTResourceManager.getColor(102, 102, 102));
			new Label(minute_composite, SWT.NONE);
		}
		{
			
			Composite seconds_composite = new Composite(composite, SWT.NONE);
			GridLayout gl_seconds_composite = new GridLayout(1, false);
			gl_seconds_composite.verticalSpacing = 0;
			seconds_composite.setLayout(gl_seconds_composite);
			
			Composite composite_8 = new Composite(seconds_composite, SWT.NONE);
			GridLayout gl_composite_8 = new GridLayout(2, false);
			gl_composite_8.horizontalSpacing = 0;
			composite_8.setLayout(gl_composite_8);
			
			seconds_first_label = new CLabel(composite_8, SWT.NONE);
			seconds_first_label.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
			seconds_first_label.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/time/time_blue_bg.png"));
			
			seconds_second_label = new CLabel(composite_8, SWT.NONE);
			seconds_second_label.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
			seconds_second_label.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/time/time_blue_bg.png"));
			
			Label label_5 = new Label(seconds_composite, SWT.NONE);
			label_5.setFont(SWTResourceManager.getFont("微软雅黑", 15, SWT.NORMAL));
			label_5.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
			label_5.setText("秒");
			label_5.setForeground(SWTResourceManager.getColor(102, 102, 102));
		}
		
		CLabel label_8 = new CLabel(composite, SWT.NONE);
		label_8.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/verline.png"));
		label_8.setText("");
		
		Composite composite_7 = new Composite(composite, SWT.NONE);
		GridLayout gl_composite_7 = new GridLayout(1, false);
		gl_composite_7.marginHeight = 0;
		gl_composite_7.horizontalSpacing = 0;
		gl_composite_7.verticalSpacing = 0;
		composite_7.setLayout(gl_composite_7);
		
		startVideo_btn = createRadioBtn(composite_7, SWT.NONE);
		startVideo_btn.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/v_play.png"));
		startVideo_btn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				startAndPauseAction();
			}
		});
		
		stopVideo_btn = createRadioBtn(composite_7, SWT.NONE);
		stopVideo_btn.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/v_stop.png"));
		stopVideo_btn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				stopAction();
			}
		});
		
		restartVideo_btn = createRadioBtn(composite_7, SWT.NONE);
		restartVideo_btn.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/v_back.png"));
		restartVideo_btn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				restartAction();
			}
		});
		
		Composite composite_4 = new Composite(content_composite, SWT.NONE);
		composite_4.setLayout(new GridLayout(1, false));
		composite_4.setLayoutData(new GridData(SWT.CENTER, SWT.TOP, false, true, 1, 1));
		{
			CLabel label_4 = new CLabel(composite_4, SWT.NONE);
			label_4.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/bottomLine.png"));
			label_4.setText("");
		}
		
		Composite composite_6 = new Composite(composite_4, SWT.NONE);
		composite_6.setLayout(new GridLayout(3, false));
		composite_6.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		
		Label label_5 = new Label(composite_6, SWT.NONE);
		label_5.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true, false, 1, 1));
		label_5.setFont(SWTResourceManager.getFont("微软雅黑", 15, SWT.NORMAL));
		label_5.setText(TenderProjectEnum.getOpenBidEnum(tenderPack.getPhaseType())+"时间");
		label_5.setForeground(SWTResourceManager.getColor(102, 102, 102));
		
		bidOpeningTimeLabel = new Label(composite_6, SWT.NONE);
		bidOpeningTimeLabel.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, false, 1, 1));
		bidOpeningTimeLabel.setFont(SWTResourceManager.getFont("微软雅黑", 15, SWT.NORMAL));
		bidOpeningTimeLabel.setForeground(SWTResourceManager.getColor(102, 102, 102));
		bidOpeningTimeLabel.setText(" 2016年05月26日  15:49 ");
		
		weakLabel = new Label(composite_6, SWT.NONE);
		weakLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		weakLabel.setFont(SWTResourceManager.getFont("微软雅黑", 15, SWT.NORMAL));
		weakLabel.setForeground(SWTResourceManager.getColor(102, 102, 102));
		weakLabel.setText(" 星期四 ");
		{
			CLabel label_4 = new CLabel(composite_4, SWT.NONE);
			label_4.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/bottomLine.png"));
			label_4.setText("");
		}
		tenderProjectService = new TenderProjectService();
		createContents();
		init();
	}
	
	class RefreshActionThread extends MyRunnable{
		private WebEntityListener<TenderProjectEntity> listener;
		private String id;
 		public RefreshActionThread(String id ,WebEntityListener<TenderProjectEntity> listener){
			this.listener = listener;	
			this.id = id;
		}
		@Override
		public void run() {
			TenderProjectEntity parentProject = tenderProjectService.getById(id);
 			listener.run(parentProject);
		}
	}	
	/**
	 * @Description: 初始化
	 * @author guoyr 
	 */
	private void init(){
		if(null != tenderProjectEntity.getParentId()){
			RefreshActionThread refreshActionThread = new RefreshActionThread(tenderProjectEntity.getParentId(), new WebEntityListener<TenderProjectEntity>() {
				@Override
				public void run(final TenderProjectEntity parentProject) {
					Display.getDefault().syncExec(new Runnable(){
						public void run(){
							projectName.setText(parentProject.getTenderName());
							projectCode.setText("项目编号："+parentProject.getTenderNo());
							packageName.setText(tenderProjectEntity.getTenderName());
							initLayout();
						} 
					});
				}
			});
			refreshActionThread.start();
			
		}else {
			projectName.setText(tenderProjectEntity.getTenderName());
			projectCode.setText("项目编号："+tenderProjectEntity.getTenderNo());
			packageName.dispose();
			initLayout();
		}
	}
	
	
	private void initLayout(){
		project_composite.layout();
		content_composite.layout();
		
		this.setMaximized(true);
		showCountDownTime();
		startCountTimeThread();
		
		paintListener = new PaintListener() {
			public void paintControl(PaintEvent arg0) {
				drawBg();
			}
		};
		addPaintListener(paintListener);
		addControlListener(new ControlAdapter() {
			public void controlResized(ControlEvent e) {
				addPaintListener(paintListener);
			}
		});
//		Image playBgImage = ResourceManager.getPluginImage(SWTCoreActivator.PLUGIN_ID, "icons/playbg.png");
		bidOpeningTimeLabel.setText(DateUtils.getFormat(bidOpeningTime, "yyyy年MM月dd日  HH:mm"));
		String[] weekArry = new String[]{"星期一", "星期二", "星期三", "星期四", "星期五", "星期六", "星期日"};
		int week = DateUtils.get(bidOpeningTime, DateUtils.WEEK);
		weakLabel.setText(weekArry[week]);
		
		MouseDragListener mouseDragListener = new MouseDragListener(this);
		projectName.addListener(SWT.MouseDown, mouseDragListener);
		projectName.addListener(SWT.MouseUp, mouseDragListener);
		projectName.addListener(SWT.MouseMove, mouseDragListener);
		addListener(SWT.MouseDown, mouseDragListener);
		addListener(SWT.MouseUp, mouseDragListener);
		addListener(SWT.MouseMove, mouseDragListener);
		
		readFileThread = new Thread(new Runnable(){
			public void run(){
				singContent = bidOpeningAgenda;
				if(null == bidOpeningAgenda || bidOpeningAgenda.length() == 0){
					File file = BiddingFile.getBidOpeningPlanFile(tenderProjectEntity.getId());
					if(null == file){
						File templateFile = new File(FileConstants.PRODUCT_ROOT.concat(FileConstants.RESOURCE_FOLDER).concat(File.separator).concat(BiddingFile.BID_OPENING_AGENDA_DIR).concat(File.separator).concat("开标议程.docx"));
						if(null != templateFile && templateFile.exists()){
							String outFilePath = FileConstants.getBiddingFilePath(tenderProjectEntity.getId()).concat(BiddingFile.BID_KBYC).concat(templateFile.getName().substring(templateFile.getName().lastIndexOf(".")));
							WordTemplateReportUtil.generate(templateFile.getAbsolutePath(), outFilePath, new WordGenerateAdapter(){
								public WordDataSet initDataSet(WordTemplate wordTemplate) {
									BidOpeningAgendaTemplate bidOpeningAgendaDataSet = new BidOpeningAgendaTemplate();
									bidOpeningAgendaDataSet.init(tenderProjectEntity, wordTemplate);
									return bidOpeningAgendaDataSet.getBaseDataSet();
								}
							});
							file = new File(outFilePath);
						}
					}
					
					if(null != file && file.exists()){
						String fileType = file.getName().substring(file.getName().lastIndexOf(".")).toLowerCase();
						if(fileType.startsWith(".doc")){
							singContent = WordPoiUtil.getText(file.getAbsolutePath());
						}else if(fileType.startsWith(".pdf")){
							singContent = PdfPoiUtil.getText(file.getAbsolutePath());
						}
					}
				}
			};
		});
		readFileThread.start();
	}
	
	private ImageButton createRadioBtn(Composite parentComposite, int tyle){
		ImageButton imageButton = new ImageButton(parentComposite, SWT.NONE);
		imageButton.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		imageButton.setSurroundColor(SWTResourceManager.getColor(229, 229, 229));
		imageButton.setActiveSurroundColor(SWTResourceManager.getColor(255, 153, 0));
		imageButton.setSurroundMargin(3);
		imageButton.setTopMargin(0);
		imageButton.setBottomMargin(0);
		return imageButton;
	}
	
	private void drawBg(){
		removePaintListener(paintListener);
		final Image bgImage = ResourceManager.getPluginImage(Activator.PLUGIN_ID,"icons/countdown_bg.jpg");
		if(null != zoomBgImage && !zoomBgImage.isDisposed()){
			zoomBgImage.dispose();
		}
		zoomBgImage = new Image(null, bgImage.getImageData());
		GC gc = new GC(zoomBgImage);
		gc.drawImage(bgImage, 0, 0, bgImage.getBounds().width, bgImage.getBounds().height, 0, 0, getBounds().width, getBounds().height);
		setBackgroundImage(zoomBgImage);
		gc.dispose();
	
	}
	/**
	 * @Description: 开始暂停
	 * @author guoyr 
	 */
	private void startAndPauseAction(){
		if(null == tts){
			tts = TTSEnginUtil.getTTSEngin();
		}
		if(tts.isSpeaking()){
			if(tts.isPause()){
				tts.resume();
				startVideo_btn.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/v_pause.png"));
			}else {
				tts.pausea();
				startVideo_btn.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/v_play.png"));
			}
		}else {
			startVideo_btn.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/v_pause.png"));
			new Thread(new Runnable(){
				public void run(){
					try {
						readFileThread.join();
					} catch (InterruptedException e) {
					}
					if(null != singContent){
						tts.speak(singContent);
					}
				}
			}).start();
		}
	}
	
	/**
	 * @Description: 停止
	 * @author guoyr 
	 */
	private void stopAction(){
		if(null != tts){
			tts.stop();
		}
		startVideo_btn.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/v_play.png"));
	}
	
	/**
	 * @Description: 重新开始
	 * @author guoyr 
	 */
	private void restartAction(){
		if(null != tts){
			tts.stop();
		}
		startVideo_btn.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/v_play.png"));
		startAndPauseAction();
	}
	
	/**
	 * @Description: 启动倒计时线程
	 * @author guoyr
	 */
	private void startCountTimeThread(){
		countTimeThread = new CountTimeThread(NowTimeUtils.getNowDate(), bidOpeningTime, new CountTimeThread.CountTime() {
			private long dayFlag = -1;
			private long hourFlg = -1;
			private long minuteFlg = -1;
			private long secondFlg = -1;
			public void countTime(final long day, final long hour, final long minute, final long second) {
				Display.getDefault().syncExec(new Runnable(){
					public void run(){
						if(!hour_first_label.isDisposed()){
							if(day > 0){
								if(dayFlag != day){
									dayFlag = day;
									hour_first_label.setData("8");
									hour_second_label.setData("8");
									hour_first_label.redraw();
									hour_second_label.redraw();
								}
							}else {
								if(hourFlg != hour){
									if(hour > 9){
										hour_first_label.setData((hour+"").substring(0,1));
										hour_second_label.setData((hour+"").substring(1));
									}else {
										hour_first_label.setData("0");
										hour_second_label.setData(hour+"");
									}
									hour_first_label.redraw();
									hour_second_label.redraw();
								}
							}
							
							if(minuteFlg != minute){
								if(minute > 9){
									minute_first_label.setData((minute+"").substring(0,1));
									minute_second_label.setData((minute+"").substring(1));
								}else {
									minute_first_label.setData("0");
									minute_second_label.setData(minute+"");
								}
								minute_first_label.redraw();
								minute_second_label.redraw();
							}
							if(secondFlg != second){
								
								if(second > 9){
									seconds_first_label.setData((second+"").substring(0,1));
									seconds_second_label.setData((second+"").substring(1));
								}else {
									seconds_first_label.setData("0");
									seconds_second_label.setData(second+"");
								}
								seconds_first_label.redraw();
								seconds_second_label.redraw();
							}
						}
					}
				});
			}
		});
		countTimeThread.start();
	}

	/**
	 * @Description: 显示倒计时
	 * @author guoyr
	 */
	private void showCountDownTime(){
		Image image_0 = imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/time/white_0.png");
		final int x = (hour_first_label.getBounds().width - image_0.getBounds().width)/2 + 2;
		final int y = (hour_first_label.getBounds().height - image_0.getBounds().height)/2;
		hour_first_label.addPaintListener(new NumPaintListener(x, y));
		hour_second_label.addPaintListener(new NumPaintListener(x, y));
		minute_first_label.addPaintListener(new NumPaintListener(x, y));
		minute_second_label.addPaintListener(new NumPaintListener(x, y));
		seconds_first_label.addPaintListener(new NumPaintListener(x, y));
		seconds_second_label.addPaintListener(new NumPaintListener(x, y));
	}
	
	/**
	 * @Description: 鼠标拖动事件
	 * @author guoyr
	 */
	public class MouseDragListener implements Listener{
		Point origin = null;
		private Shell shell;
		public MouseDragListener(Shell shell){
			this.shell = shell;
		}
		public void handleEvent(Event e) {
			switch (e.type) {
			case SWT.MouseDown:
				origin = new Point(e.x, e.y);
				setCursor(new Cursor(null,SWT.CURSOR_SIZEALL));
				break;
			case SWT.MouseUp:
				setCursor(new Cursor(null,SWT.CURSOR_ARROW));
				origin = null;
				setAlpha(255);
				shell.setMaximized(true);
				break;
			case SWT.MouseMove:
				if (origin != null) {
					setAlpha(100);
					setSize(800, 600);
					Point p = Display.getDefault().map(shell, null, e.x, e.y);
					int x = p.x - origin.x;
					int y =  p.y - origin.y;
					if(x < 0){
						x = 0;
					}
					if(y < 0){
						y = 0;
					}
					shell.setMaximized(false);
					setLocation(x, y);
				}
				break;
			}
		}

	}
	
	class NumPaintListener implements PaintListener{

		private int x;
		private int y;
		public NumPaintListener(int x, int y){
			this.x = x;
			this.y = y;
		}
		public void paintControl(PaintEvent arg0) {
			String num = (String)((CLabel)arg0.getSource()).getData();
			if(null == num){
				num = "0";
			}
			arg0.gc.drawImage(imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/time/white_"+num+".png"), x, y);
			arg0.gc.dispose();
		}
	}

	protected void createContents() {
		setText("开标工具-开标议程");
		setSize(450, 300);
		Dimension d = Toolkit.getDefaultToolkit().getScreenSize(); // 取得当前屏幕属性
		int w = d.width; // 获取屏幕宽度
		int h = d.height; // 获取屏幕高度
		setSize(w,h);

	}

	@Override
	protected void checkSubclass() {
	}

	@Override
	public void close() {
		imageResolver.disposite();
		countTimeThread.stop();
		if(null != zoomBgImage){
			zoomBgImage.dispose();
		}
		if(null != tts){
			tts.release();
		}
		super.close();
	}
}
