package com.gx.obe.opening.shell;

import java.awt.image.BufferedImage;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Date;
import java.util.List;
import java.util.Timer;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.ImageResolver;
import org.eclipse.swt.core.utils.SwtUtils;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.events.ControlAdapter;
import org.eclipse.swt.events.ControlEvent;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MenuDetectEvent;
import org.eclipse.swt.events.MenuDetectListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseTrackAdapter;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Cursor;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.ImageData;
import org.eclipse.swt.graphics.PaletteData;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.RGB;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.graphics.Transform;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Canvas;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;

import com.gx.obe.ColorConstants;
import com.gx.obe.common.composite.LedConfigComposite;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.shell.ToolsShell;
import com.gx.obe.config.ConfigConstants;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.listener.ScrollLEDListener;
import com.gx.obe.message.Messages;
import com.gx.obe.opening.Activator;
import com.gx.obe.opening.listener.MeetingRoomListener;
import com.gx.obe.util.thread.CountTimeThread;
import com.gx.obe.util.utils.ObjectUtils;
import com.gx.obe.util.utils.ScreenUtils;
import com.gx.obe.util.utils.StringUtils;
import com.gx.utils.NowTimeUtils;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

public class BidOpeningRoomShell extends Shell implements MeetingRoomListener{

	private ImageResolver imageResolver = new ImageResolver();
	private Image zoomBgImage;
//	private Label projectName;
	private Composite meetingTitleComposite;
	private PaintListener titlePaintListener;
//	private PaintListener paintListener;
	private Image bgImage = ResourceManager.getPluginImage(Activator.PLUGIN_ID,"icons/decrypt_bg.png");
	private Timer decStartTimer;
	private Timer decEndTimer;
	private Composite topComposite;
	private Composite leftComposite;
	private Composite topCenterComposite;
	private Composite rightComposite;
	private Composite bottomComposite;
	private Canvas leftBlackborad;
	private Canvas rightBlackborad;
	private Image charsLeftPeopleImage;
	private Image charsRightPeopleImage;
	private Image charsLeftImage;
	private Image charsRightImage;
	private String meetingTitle;
	private int titleFontHeight = 20;
	private SimpleDateFormat timeFormat = new SimpleDateFormat("HH:mm:ss");
	private String meetingTimeTitle = Messages.BidOpeningTimeOnBoard;
	private Font boardFont = SWTResourceManager.getFont("微软雅黑", 25, SWT.BOLD);
	private Color boardTitleColor = SWTResourceManager.getColor(231, 22, 52);
	private Date meetingTime;
	private String countDownTimeTitle = Messages.CountdownOnBoard;
	private Date countDownTime;
	private String[] countDownTimeStr = new String[]{"0", "0", ":", "0", "0", ":", "0", "0"};
	private int firstStartRow = 1;
	private int ROW_CHAIRS = 11;
	private int peopleCount = 0;
	private Composite loadComposite;
	private PaintListener leftBlackboardListener;
	private PaintListener rightBlackboardListener;
	private CountTimeThread countTimeThread;
	private Image leftBlackboardImage;
	private Image rightBlackboardImage;
	private Image roomImage;
	private GridLayout topCentGridLayout;
	private final int  LEFT_WIDTH = 340;
	private final int  TOP_HEIGHT = 185;
	private final int  BG_WIDHT = 1920;
	private final int  BG_HEIGHT = 1080;
	private final int  BOTTOM_HEIGHT = 275;
	private Canvas exitBtn;
	private Canvas manageTable;
	private Composite chairsFirstComposite;
	private Composite chairsSecondComposite;
	private Composite chairsThirdComposite;
	private Composite chairsFourthComposite;
	private Composite[] chairsRows;
	private Runnable rightBlackBoardRunnable;
	private String curRoomBg = "bg.jpg";
	private String tableTitle = null;
	private boolean showNowTime = false;
	private Composite operatorComposite;
	private ScrollLEDListener scrollLEDListener;
	private CountTimeThread.CountTime countTimeListener;
	private FormData operatorCompositeFormData;
	private ScreenUtils screenUtils = new ScreenUtils();
	
	public BidOpeningRoomShell(Shell parentShell) {
		super(parentShell, SWT.NO_TRIM);
		addDisposeListener(new DisposeListener() {
			public void widgetDisposed(DisposeEvent arg0) {
				close();
			}
		});
		setBackgroundMode(SWT.INHERIT_FORCE);
		setBackgroundImage(bgImage);
		
		setLayout(new FormLayout());
		
		topComposite = new Composite(this, SWT.NONE);
		FormData topFormData = new FormData();
		topFormData.top = new FormAttachment(0, 0);
		topFormData.bottom = new FormAttachment(TOP_HEIGHT, BG_HEIGHT, 0);
		topFormData.left = new FormAttachment(0, 0);
		topFormData.right = new FormAttachment(100, 0);
		topComposite.setLayoutData(topFormData);
		
		leftComposite = new Composite(this, SWT.NONE);
		leftComposite.addMouseListener(new MouseAdapter() {
			public void mouseDoubleClick(MouseEvent e) {
				changeRoomBgAction();
			}
		});
		FormData leftFormData = new FormData();
		leftFormData.right = new FormAttachment(LEFT_WIDTH, BG_WIDHT, 0);
		leftFormData.top = new FormAttachment(TOP_HEIGHT, BG_HEIGHT, 0);
		leftFormData.left  = new FormAttachment(0, 0);
		leftFormData.bottom = new FormAttachment(BG_HEIGHT - 275, BG_HEIGHT, 0);
		leftComposite.setLayoutData(leftFormData);
		
		leftComposite.setLayout(new FormLayout());
		
		leftBlackborad = new CLabel(leftComposite, SWT.NONE);
		FormData leftBoardFormData = new FormData();
		leftBoardFormData.left = new FormAttachment(61, LEFT_WIDTH,0);
		leftBoardFormData.right = new FormAttachment(LEFT_WIDTH - 118, LEFT_WIDTH, 0);
		leftBoardFormData.top = new FormAttachment(126, BG_HEIGHT - TOP_HEIGHT - BOTTOM_HEIGHT, 0);
		leftBoardFormData.bottom = new FormAttachment(126 + 196, BG_HEIGHT - TOP_HEIGHT - BOTTOM_HEIGHT, 0);
		leftBlackborad.setLayoutData(leftBoardFormData);
		
		topCenterComposite = new Composite(this, SWT.NONE);
		
		FormData centFormData = new FormData();
		centFormData.top = new FormAttachment(TOP_HEIGHT, BG_HEIGHT, 0);
		centFormData.left = new FormAttachment(LEFT_WIDTH, BG_WIDHT, 0);
		centFormData.right = new FormAttachment(BG_WIDHT - LEFT_WIDTH, BG_WIDHT, 0);
		centFormData.bottom = new FormAttachment(BG_HEIGHT - BOTTOM_HEIGHT, BG_HEIGHT, 0);
		topCenterComposite.setLayoutData(centFormData);
		
		topCentGridLayout = new GridLayout(1, false);
		topCentGridLayout.verticalSpacing = 0;
		topCentGridLayout.horizontalSpacing = 0;
		topCentGridLayout.marginHeight = 8;
		topCentGridLayout.marginWidth = 8;
		topCenterComposite.setLayout(topCentGridLayout);
		
		meetingTitleComposite = new Composite(topCenterComposite, SWT.NONE);
		GridData gd_project_composite = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_project_composite.heightHint = 45;
		meetingTitleComposite.setLayoutData(gd_project_composite);
		GridLayout gl_project_composite = new GridLayout(1, false);
		meetingTitleComposite.setLayout(gl_project_composite);
		
		loadComposite = new Composite(topCenterComposite, SWT.NONE);
		GridLayout gl_loadComposite = new GridLayout(1, false);
		gl_loadComposite.verticalSpacing = 0;
		gl_loadComposite.horizontalSpacing = 0;
		gl_loadComposite.marginHeight = 0;
		gl_loadComposite.marginWidth = 0;
		loadComposite.setLayout(gl_loadComposite);
		loadComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		rightComposite = new Composite(this, SWT.NONE);
		FormData rightFormData = new FormData();
		rightFormData.left = new FormAttachment(BG_WIDHT - LEFT_WIDTH, BG_WIDHT, 0);
		rightFormData.right = new FormAttachment(100, 0);
		rightFormData.top = new FormAttachment(TOP_HEIGHT, BG_HEIGHT, 0);
		rightFormData.bottom = new FormAttachment(BG_HEIGHT - BOTTOM_HEIGHT, BG_HEIGHT, 0);
		
		rightComposite.setLayoutData(rightFormData);
		rightComposite.setLayout(new FormLayout());
		rightComposite.addMouseListener(new MouseAdapter() {
			public void mouseDoubleClick(MouseEvent e) {
				changeRoomBgAction();
			}
		});
		
		rightBlackborad = new CLabel(rightComposite, SWT.NONE);
		FormData rightBoardFormData = new FormData();
		rightBoardFormData.left = new FormAttachment(118, LEFT_WIDTH,0);
		rightBoardFormData.right = new FormAttachment(LEFT_WIDTH - 61, LEFT_WIDTH, 0);
		rightBoardFormData.top = new FormAttachment(126, BG_HEIGHT - TOP_HEIGHT - BOTTOM_HEIGHT, 0);
		rightBoardFormData.bottom = new FormAttachment(126 + 196, BG_HEIGHT - TOP_HEIGHT - BOTTOM_HEIGHT, 0);
		rightBlackborad.setLayoutData(rightBoardFormData);
		
		bottomComposite = new Composite(this, SWT.TRANSPARENT);
		FormData bottomFormData = new FormData();
		bottomFormData.left = new FormAttachment(0, 0);
		bottomFormData.right = new FormAttachment(100, 0);
		bottomFormData.top = new FormAttachment(BG_HEIGHT - BOTTOM_HEIGHT, BG_HEIGHT, -2);
		bottomFormData.bottom = new FormAttachment(100, 0);
		bottomComposite.setLayoutData(bottomFormData);
		bottomComposite.setLayout(new FormLayout());
		
		chairsFirstComposite = new Composite(bottomComposite, SWT.TRANSPARENT);
		chairsFirstComposite.setFont(SWTResourceManager.getFont("微软雅黑", 8, SWT.BOLD));
		chairsFirstComposite.setLayout(new GridLayout(ROW_CHAIRS, true));
		FormData chairsFirstFormData = new FormData();
		chairsFirstFormData.left = new FormAttachment(438, BG_WIDHT, 0);
		chairsFirstFormData.right = new FormAttachment(BG_WIDHT - 438, BG_WIDHT, 0);
		chairsFirstFormData.top = new FormAttachment(10, BOTTOM_HEIGHT, 0);
		chairsFirstFormData.bottom = new FormAttachment(BOTTOM_HEIGHT - 10 - 125, BOTTOM_HEIGHT, 0);
		chairsFirstComposite.setLayoutData(chairsFirstFormData);
		chairsFirstComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_RED));
		
		chairsSecondComposite = new Composite(bottomComposite, SWT.TRANSPARENT);
		chairsSecondComposite.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		chairsSecondComposite.setLayout(new GridLayout(ROW_CHAIRS, true));
		FormData chairsSecondFormData = new FormData();
		chairsSecondFormData.left = new FormAttachment(346, BG_WIDHT, 0);
		chairsSecondFormData.right = new FormAttachment(BG_WIDHT - 346, BG_WIDHT, 0);
		chairsSecondFormData.top = new FormAttachment(10 + 40, BOTTOM_HEIGHT, 0);
		chairsSecondFormData.bottom = new FormAttachment((10 + 40 + 146), BOTTOM_HEIGHT, 0);
		chairsSecondComposite.setLayoutData(chairsSecondFormData);
		chairsSecondComposite.setBackground(SWTResourceManager.getColor(123, 239, 10));
		
		chairsThirdComposite = new Composite(bottomComposite, SWT.TRANSPARENT);
		chairsThirdComposite.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.BOLD));
		chairsThirdComposite.setLayout(new GridLayout(ROW_CHAIRS, true));
		FormData chairsThirdFormData = new FormData();
		chairsThirdFormData.left = new FormAttachment(244, BG_WIDHT, 0);
		chairsThirdFormData.right = new FormAttachment(BG_WIDHT - 244, BG_WIDHT, 0);
		chairsThirdFormData.top = new FormAttachment(10 + 90, BOTTOM_HEIGHT, 0);
		chairsThirdFormData.bottom = new FormAttachment((10 + 90 + 170), BOTTOM_HEIGHT, 0);
		chairsThirdComposite.setLayoutData(chairsThirdFormData);
		chairsThirdComposite.setBackground(SWTResourceManager.getColor(0, 239, 150));
		
		chairsFourthComposite = new Composite(bottomComposite, SWT.TRANSPARENT);
		chairsFourthComposite.setFont(SWTResourceManager.getFont("微软雅黑", 14, SWT.BOLD));
		chairsFourthComposite.setLayout(new GridLayout(ROW_CHAIRS, true));
		FormData chairsFourthFormData = new FormData();
		chairsFourthFormData.left = new FormAttachment(123, BG_WIDHT, 0);
		chairsFourthFormData.right = new FormAttachment(BG_WIDHT - 123, BG_WIDHT, 0);
		chairsFourthFormData.top = new FormAttachment(BOTTOM_HEIGHT - 129, BOTTOM_HEIGHT, 0);
		chairsFourthFormData.bottom = new FormAttachment(BOTTOM_HEIGHT + 65, BOTTOM_HEIGHT, 0);
		chairsFourthComposite.setLayoutData(chairsFourthFormData);
		chairsFourthComposite.setBackground(SWTResourceManager.getColor(50, 139, 255));
		
		
		exitBtn = new Canvas(this, SWT.TRANSPARENT);
		FormData exitFormData = new FormData();
		exitFormData.left = new FormAttachment(100, -5 - 73);
		exitFormData.right = new FormAttachment(100, -5);
		exitFormData.bottom = new FormAttachment(BG_HEIGHT - 100, BG_HEIGHT, 20);
		exitFormData.top = new FormAttachment(BG_HEIGHT - 100, BG_HEIGHT, -73);
		exitBtn.setLayoutData(exitFormData);
		
		manageTable = new Canvas(this, SWT.TRANSPARENT);
		FormData manageTableFormData = new FormData();
		manageTableFormData.left = new FormAttachment(142, BG_WIDHT, 0);
		manageTableFormData.right = new FormAttachment(142 + 280, BG_WIDHT, 0);
		manageTableFormData.bottom = new FormAttachment(BG_HEIGHT - 140 , BG_HEIGHT, 0);
		manageTableFormData.top = new FormAttachment(BG_HEIGHT - 140 - 230, BG_HEIGHT,0);
		manageTable.setLayoutData(manageTableFormData);
		
		operatorComposite = new Composite(this, SWT.TRANSPARENT);
		operatorCompositeFormData = new FormData();
		operatorCompositeFormData.left = new FormAttachment(0);
		operatorCompositeFormData.right = new FormAttachment(100);
		operatorCompositeFormData.bottom = new FormAttachment(100);
		operatorCompositeFormData.top = new FormAttachment(100, - 40);
		operatorComposite.setLayoutData(operatorCompositeFormData);
		GridLayout gl_composite = new GridLayout(1, false);
		gl_composite.marginTop = 0;
		gl_composite.marginHeight = 0;
		gl_composite.marginBottom = 0;
		gl_composite.marginWidth = 2;
		operatorComposite.setLayout(gl_composite);
		createContents();
		init();
	}
	
	
	/**
	 * @Description: 初始化
	 * @author guoyr 
	 */
	private void init(){
		operatorCompositeFormData.top =new FormAttachment(100, -screenUtils.getTaskBarHight());
		MouseDragListener mouseDragListener = new MouseDragListener(this);
		leftBlackborad.addListener(SWT.MouseDown, mouseDragListener);
		leftBlackborad.addListener(SWT.MouseUp, mouseDragListener);
		leftBlackborad.addListener(SWT.MouseMove, mouseDragListener);
		meetingTitleComposite.addMenuDetectListener(new MenuDetectListener() {
			public void menuDetected(MenuDetectEvent arg0) {
				ledConfigAction();
			}
		});
		meetingTitleComposite.addMouseListener(new MouseAdapter() {
			public void mouseDoubleClick(MouseEvent e) {
				ledConfigAction();
			}
		});
		charsLeftPeopleImage = imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/opening_room/chars_left_people.png");
		charsRightPeopleImage = imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/opening_room/chars_right_people.png");
		charsLeftImage = imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/opening_room/chars_left.png");
		charsRightImage = imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/opening_room/chars_right.png");
		exitBtn.moveAbove(bottomComposite);
		exitBtn.moveAbove(rightComposite);
		roomImage = ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID,"icons/opening_room/"+curRoomBg);
		drawBg2();
		chairsSecondComposite.moveAbove(chairsFirstComposite);
		chairsThirdComposite.moveAbove(chairsSecondComposite);
		chairsFourthComposite.moveAbove(chairsThirdComposite);
		chairsRows = new Composite[]{chairsFirstComposite, chairsSecondComposite, chairsThirdComposite, chairsFourthComposite};
		for(int rowIndex = 0; rowIndex < chairsRows.length; rowIndex++){
			drawSupplierRowChairs(rowIndex);
		}
		
		manageTable.moveAbove(bottomComposite);
		manageTable.moveAbove(topCenterComposite);
		manageTable.moveAbove(leftComposite);
		bottomComposite.moveAbove(manageTable);
		operatorComposite.moveAbove(bottomComposite);
		exitBtn.moveAbove(bottomComposite);
//		if(null != paintListener){
//			removePaintListener(paintListener);
//		}
//		paintListener = new PaintListener() {
//			public void paintControl(PaintEvent arg0) {
//				drawBg2();
//			}
//		};
//		addPaintListener(paintListener);
		addControlListener(new ControlAdapter() {
			public void controlResized(ControlEvent e) {
				drawBg2();
			}
		});
		
		meetingTitleComposite.setForeground(SWTResourceManager.getColor(231, 22, 52));
		meetingTitleComposite.setFont(SWTResourceManager.getFont("微软雅黑", titleFontHeight, SWT.BOLD));
		if(null != scrollLEDListener){
			meetingTitleComposite.removePaintListener(scrollLEDListener);
		}
		scrollLEDListener = new ScrollLEDListener(meetingTitleComposite);
		scrollLEDListener.setCircleScroll("01".equals(PropertiesUtils.getProperty("circleScroll", "01")));
		meetingTitleComposite.addPaintListener(scrollLEDListener);
		
		meetingTitleComposite.addControlListener(new ControlAdapter() {
			public void controlResized(ControlEvent e) {
				titleFontHeight = 20;
				meetingTitleComposite.redraw();
			}
		});
		
		meetingTitleComposite.addControlListener(new ControlAdapter() {
			public void controlResized(ControlEvent e) {
				titleFontHeight = 20;
				meetingTitleComposite.redraw();
			}
		});
		
		if(null != leftBlackboardListener){
			leftBlackborad.removePaintListener(leftBlackboardListener);
		}
		final Image blackBoardImage = imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/opening_room/blackboard.png");
		leftBlackboardListener = new PaintListener() {
			public void paintControl(PaintEvent arg0) {
				arg0.gc.drawImage(blackBoardImage, 0, 0, blackBoardImage.getBounds().width, blackBoardImage.getBounds().height, 0, 0, leftBlackborad.getBounds().width, leftBlackborad.getBounds().height);
				drawLeftBlackboardTitle(arg0.gc);
				drawLeftBlackboardTime(arg0.gc);
			}
		};
		leftBlackborad.addPaintListener(leftBlackboardListener);
		if(null != rightBlackboardListener){
			rightBlackborad.removePaintListener(rightBlackboardListener);
		}
		final Image rightBlackBoardImage = imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/opening_room/right_blackboard.png");
		rightBlackboardListener = new PaintListener() {
			public void paintControl(PaintEvent arg0) {
				arg0.gc.drawImage(rightBlackBoardImage, 0, 0, rightBlackBoardImage.getBounds().width, rightBlackBoardImage.getBounds().height, 0, 0, rightBlackborad.getBounds().width, rightBlackborad.getBounds().height);
				
				drawRightBlackborad(arg0);
			}
		};
		rightBlackborad.addPaintListener(rightBlackboardListener);
		final Image exitBlueImage = imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/opening_room/exit_blue.png");
		final Image exitRedImage = imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/opening_room/exit_red.png");
		exitBtn.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		exitBtn.setForeground(SWTResourceManager.getColor(51, 51, 51));
		exitBtn.addPaintListener(new PaintListener() {
			public void paintControl(PaintEvent arg0) {
				if(null != exitBtn.getData("mouseEnter")){
					arg0.gc.drawImage(exitRedImage, 0, 0, exitRedImage.getBounds().width, exitRedImage.getBounds().height, 0, 0, exitBtn.getBounds().width, exitBtn.getBounds().height -20);
				}else {
					arg0.gc.drawImage(exitBlueImage, 0, 0, exitBlueImage.getBounds().width, exitBlueImage.getBounds().height, 0, 0, exitBtn.getBounds().width, exitBtn.getBounds().height -20);
				}
				Point e = arg0.gc.textExtent(Messages.Button_goToHome);
				arg0.gc.drawText(Messages.Button_goToHome, (exitBtn.getBounds().width - e.x)/2, exitBtn.getBounds().height -e.y, true);
			}
		});
		manageTable.addPaintListener(new PaintListener() {
			public void paintControl(PaintEvent arg0) {
				Image managerTableImage = ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID,"icons/opening_room/manager_table.png");
				arg0.gc.drawImage(managerTableImage, 0, 0, managerTableImage.getBounds().width, managerTableImage.getBounds().height, 0, 0, manageTable.getBounds().width, manageTable.getBounds().height);
				if(null != tableTitle && tableTitle.length() > 0){
					arg0.gc.setForeground(ColorConstants.FONT_BLACK_COLOR);
					arg0.gc.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.BOLD));
					Point e = arg0.gc.textExtent(tableTitle);
					arg0.gc.drawText(tableTitle, (manageTable.getBounds().width - e.x)/2, (int)(150/(double)244*manageTable.getBounds().height)- e.y/2, true);
				}
			}
		});
		exitBtn.addMouseTrackListener(new MouseTrackAdapter(){
			public void mouseEnter(MouseEvent e) {
				exitBtn.setData("mouseEnter", "1");
				exitBtn.redraw();
			}
			public void mouseExit(MouseEvent e) {
				exitBtn.setData("mouseEnter", null);
				exitBtn.redraw();
			}
		});
		exitBtn.addMouseListener(new MouseAdapter(){
			public void mouseUp(MouseEvent e) {
				exitMeetingRoom();
			}
			
		});
		rightBlackBoardRunnable = new Runnable(){
			public void run(){
				if(!rightBlackborad.isDisposed()){
					rightBlackborad.redraw();
				}
			}
		}; 
		int w = screenUtils.getScreenWight(); // 获取屏幕宽度
		int h = screenUtils.getScreenHight() - screenUtils.getTaskBarHight(); // 获取屏幕高度
		setLocation(0, 0);
		setSize(w,h);
//		this.setMaximized(true);
		
	}
	
	/**
	 * @Description: 修改开标大厅背景
	 * @author guoyr 
	 */
	private void changeRoomBgAction(){
		if(curRoomBg.equals("bg.jpg")){
			curRoomBg = "bg_2.jpg";
		}else {
			curRoomBg = "bg.jpg";
		}
		roomImage = ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID,"icons/opening_room/"+curRoomBg);
		drawBg2();
	}
	/**
	 * @Description: 鼠标拖动事件
	 * @author guoyr
	 */
	public class MouseDragListener implements Listener{
		Point origin = null;
		private Shell shell;
		public MouseDragListener(Shell shell){
			this.shell = shell;
		}
		public void handleEvent(Event e) {
			switch (e.type) {
			case SWT.MouseDown:
				origin = new Point(e.x, e.y);
				setCursor(new Cursor(null,SWT.CURSOR_SIZEALL));
				break;
			case SWT.MouseUp:
				setCursor(new Cursor(null,SWT.CURSOR_ARROW));
				origin = null;
				setAlpha(255);
//				shell.setMaximized(true);
				int w = screenUtils.getScreenWight(); // 获取屏幕宽度
				int h = screenUtils.getScreenHight() - screenUtils.getTaskBarHight(); // 获取屏幕高度
				shell.setLocation(0, 0);
				shell.setSize(w,h);
				shell.redraw();
				break;
			case SWT.MouseMove:
				if (origin != null) {
					setAlpha(100);
					setSize(800, 600);
					Point p = Display.getDefault().map(shell, null, e.x, e.y);
					int x = p.x - origin.x;
					int y =  p.y - origin.y;
					if(x < 0){
						x = 0;
					}
					if(y < 0){
						y = 0;
					}
					shell.setMaximized(false);
					setLocation(x, y);
				}
				break;
			}
		}

	}
	
	class NumPaintListener implements PaintListener{

		private int x;
		private int y;
		public NumPaintListener(int x, int y){
			this.x = x;
			this.y = y;
		}
		public void paintControl(PaintEvent arg0) {
			String num = (String)((CLabel)arg0.getSource()).getData();
			if(null == num){
				num = "0";
			}
			arg0.gc.drawImage(imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/time/white_"+num+".png"), x, y);
			arg0.gc.dispose();
		}
	}

	protected void createContents() {
		setText("开标工具-远程开标大厅");
		setSize(450, 300);
		int w = screenUtils.getScreenWight(); // 获取屏幕宽度
		int h = screenUtils.getScreenHight() - screenUtils.getTaskBarHight(); // 获取屏幕高度
		setSize(w,h);

	}

	@Override
	protected void checkSubclass() {
	}
	

	private void drawBg2(){
		Rectangle rectangle = getBounds();
		Image roomBgImage = new Image(Display.getDefault(), rectangle);
		
		layout();
		GC gc = new GC(roomBgImage);
		gc.drawImage(roomImage, 0, 0, roomImage.getBounds().width, roomImage.getBounds().height, 0, 0, roomBgImage.getBounds().width, roomBgImage.getBounds().height);
		
		Point centerPoint = topCenterComposite.getLocation();
		Image backBgImage = ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID,"icons/opening_room/room_back.png");
		gc.drawImage(backBgImage, 0, 0, backBgImage.getBounds().width, backBgImage.getBounds().height, centerPoint.x, centerPoint.y, topCenterComposite.getBounds().width,topCenterComposite.getBounds().height);
		
		Image screenImage = ResourceManager.getPluginImage(Activator.PLUGIN_ID,"icons/bg_01.jpg");
		gc.drawImage(screenImage, 0, 0, screenImage.getBounds().width, screenImage.getBounds().height, centerPoint.x + topCentGridLayout.marginWidth, centerPoint.y + topCentGridLayout.marginHeight + meetingTitleComposite.getBounds().height, topCenterComposite.getBounds().width - topCentGridLayout.marginWidth * 2, Math.max(topCenterComposite.getBounds().height - topCentGridLayout.marginHeight * 2 - meetingTitleComposite.getBounds().height, 0));
//		gc.setBackground(Display.getDefault().getSystemColor(SWT.COLOR_WHITE));
//		gc.fillRoundRectangle(centerPoint.x + topCentGridLayout.marginWidth, centerPoint.y + topCentGridLayout.marginHeight + meetingTitleComposite.getBounds().height, topCenterComposite.getBounds().width - topCentGridLayout.marginWidth * 2, topCenterComposite.getBounds().height - topCentGridLayout.marginHeight * 2 - meetingTitleComposite.getBounds().height, 5, 5);
		
		Image ledImage = ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID,"icons/opening_room/led.png");
		Point titlePoint = Display.getDefault().map(meetingTitleComposite, BidOpeningRoomShell.this, 0,0);
		
		gc.drawImage(ledImage, 0, 0, 20, ledImage.getBounds().height, titlePoint.x, titlePoint.y, 20, meetingTitleComposite.getBounds().height);
		gc.drawImage(ledImage, 20, 0, ledImage.getBounds().width - 40 , ledImage.getBounds().height, titlePoint.x + 20, titlePoint.y, meetingTitleComposite.getBounds().width - 40, meetingTitleComposite.getBounds().height);
		gc.drawImage(ledImage, ledImage.getBounds().width - 20, 0, 20, ledImage.getBounds().height, titlePoint.x + meetingTitleComposite.getBounds().width - 20, titlePoint.y, 20, meetingTitleComposite.getBounds().height);
		
//		Image managerTableImage = ResourceManager.getPluginImage(SWTCoreIconsActivator.PLUGIN_ID,"icons/opening_room/manager_table.png");
//		int tableWidth = (int)(getBounds().width * 250 / (double)roomImage.getBounds().width);
//		int tableHeight = (int)(tableWidth / (managerTableImage.getBounds().width / (double)managerTableImage.getBounds().height));
//		int tableX = centerPoint.x  -  tableWidth +(int)(tableWidth)/4;
//		int tableY = bottomComposite.getBounds().y - (int)(tableWidth)/3;
//		gc.drawImage(managerTableImage, 0, 0, managerTableImage.getBounds().width, managerTableImage.getBounds().height, tableX, tableY, tableWidth, tableHeight);
		
		int videoMargin = (int)(110 / (double)roomImage.getBounds().width * rectangle.width);
		Image videoImage = ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID,"icons/opening_room/video.png");
		int videoWidth = (int)(rectangle.width * (videoImage.getBounds().width /(double)roomImage.getBounds().width));
		int videoHeight = (int)(videoWidth/(videoImage.getBounds().width /(double)videoImage.getBounds().height));
		gc.drawImage(videoImage, 0, 0, videoImage.getBounds().width, videoImage.getBounds().height, leftComposite.getBounds().width - videoMargin, leftComposite.getBounds().y, videoWidth, videoHeight);
		
		Transform transform = new Transform(Display.getDefault());
	    transform.setElements(-1, 0, 0, 1, 0 ,0);
	    gc.setTransform(transform);
	    gc.drawImage(videoImage, 0, 0, videoImage.getBounds().width, videoImage.getBounds().height, -1*(rightComposite.getBounds().x + videoMargin) , rightComposite.getBounds().y, videoWidth, videoHeight);
	    transform.dispose();
	    transform = new Transform(Display.getDefault());
	    gc.setTransform(transform);
	    
		gc.dispose();
		setBackgroundImage(roomBgImage);
	}
	
	/**
	 * @Description: 刷新会议时间
	 * @author guoyr
	 * @param meetingTimeTitle
	 * @param meetingTime 
	 */
	public void refreshMeetingTime(String meetingTimeTitle, Date meetingTime){
		this.meetingTimeTitle = meetingTimeTitle;
		this.meetingTime = meetingTime;
		Display.getDefault().syncExec(new Runnable(){
			public void run(){
				if(!leftBlackborad.isDisposed()){
					leftBlackborad.redraw();
				}
			}
		});
	}
		
	private void drawLeftBlackboardTitle(GC gc){
		
		double bgWidth = 157;
		double bgHight = 167;
		
		Rectangle boardRectangle = leftBlackborad.getBounds();
		int leftMargin = (int)(boardRectangle.width * (12 / bgWidth));
		int rightMargin = (int)(boardRectangle.width * (10 / bgWidth));
		int topMargin = (int)(5 * boardRectangle.height/bgHight); 
		int bottomMargin = (int)(0 * boardRectangle.height/bgHight); 
		int rectangleWidth = boardRectangle.width - leftMargin - rightMargin;
		int rectangleHeight = (int)((boardRectangle.height - topMargin)/2 - bottomMargin);
		gc.setFont(boardFont);
		Point e = gc.textExtent(StringUtils.hasLength(meetingTimeTitle) ? meetingTimeTitle.substring(0, 1) : "郭");
		double maxFontHeight = e.y;
		double maxFongWidth = e.x;
		double totalSize = maxFongWidth;
		for(int i = 1; i < meetingTimeTitle.length(); i++){
			maxFongWidth = maxFongWidth * 0.9;
			totalSize += maxFongWidth;
		}
		
		maxFongWidth = e.x;
		double sep = 0;
		if(totalSize > rectangleWidth){
			maxFongWidth = maxFongWidth * rectangleWidth / totalSize;
//			maxFontHeight = maxFongWidth * e.y / e.x;
			totalSize = rectangleWidth;
		}else {
			sep = (rectangleWidth - totalSize)/(meetingTimeTitle.length() - 1);
			if(sep > maxFongWidth/3) {
				sep = maxFongWidth/3;
			}
		}
		totalSize += sep*(meetingTimeTitle.length() -1);
		
		int x = leftMargin + (int)(boardRectangle.width - totalSize - rightMargin)/2;
		
		Transform transform = new Transform(Display.getDefault());
		transform.setElements(1, 0.25f, 0, 1, 0 ,0);
		gc.setTransform(transform);
		
		for(int i = 0; i < meetingTimeTitle.length(); i++){
			String str = meetingTimeTitle.substring(i, i+1);
			Image strImage = drawImage(gc, str, 0, gc.getFont(), boardTitleColor);
			gc.drawImage(strImage, 0, 0, strImage.getBounds().width, strImage.getBounds().height, x,topMargin + (rectangleHeight - (int)maxFontHeight)/2 , (int)maxFongWidth, (int)maxFontHeight);
			strImage.dispose();
			x += maxFongWidth;
			x += sep;
			maxFongWidth = maxFongWidth * 0.9;
			maxFontHeight = maxFontHeight * 0.95;
		}
		transform.dispose();
	}
	private void drawLeftBlackboardTime(GC gc){
		double bgWidth = 157;
		double bgHight = 167;
		
		Rectangle boardRectangle = leftBlackborad.getBounds();
		int leftMargin = (int)(boardRectangle.width * ((5+9) / bgWidth));
		int rightMargin = (int)(boardRectangle.width * (5 / bgWidth));
		int topMargin = -10;//(int)(10 * leftBlackboardRectangle.height/bgHight); 
		int bottomMargin = 0;//(int)(0 * leftBlackboardRectangle.height/bgHight); 
		int rectangleWidth = boardRectangle.width - leftMargin - rightMargin;
		int titleTopOffset = (int)(8 * boardRectangle.height/bgHight); 
		int rectangleHeight = (int)((boardRectangle.height - titleTopOffset)/2 - topMargin - bottomMargin);
		int y = (boardRectangle.height - titleTopOffset)/2 + topMargin;
		Transform transform = new Transform(Display.getDefault());
		transform.setElements(1, 0.18f, 0, 1, 0 ,0);
		gc.setTransform(transform);
		Image numImage = imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/time/red_8.png");
//		Image numSepImage = imageResolver.loadImage(SWTCoreIconsActivator.PLUGIN_ID,"icons/time/red_sep.png");
		double numSize = numImage.getBounds().width;
		double numWidth = numImage.getBounds().width;
		double maxNumHeight = numImage.getBounds().height;
		double maxNumWidth = numImage.getBounds().width;
		for(int i = 1; i < 6; i++){
			numWidth = numWidth * 0.95;
			numSize += numWidth;
		}
		numSize += 5 * 2;
		double vacantSize = 0;
		if (numSize > rectangleWidth) {
			maxNumWidth = maxNumWidth * rectangleWidth / numSize;
			maxNumHeight = maxNumWidth * numImage.getBounds().height * 1.2 / numImage.getBounds().width;
			numSize = rectangleWidth;
		} else {
			vacantSize = (rectangleWidth - numSize) / 2d;
		}
		 
		int x = leftMargin + (int)(rectangleWidth - numSize)/2;
		String meetingTimeStr = "00:00:00";
		if(null != meetingTime){
			meetingTimeStr = timeFormat.format(meetingTime);
		}
		for(int i = 0; i < meetingTimeStr.length(); i++){
			String str = meetingTimeStr.substring(i, i+1);
			Image drawImage = null;
			if(str.equals(":")){
				drawImage = imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/time/red_sep.png");
			}else {
				drawImage = imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/time/red_"+str+".png");
			}
			if(null != drawImage){
				gc.drawImage(drawImage, 0, 0, drawImage.getBounds().width, drawImage.getBounds().height, x, y + (rectangleHeight - (int)maxNumHeight)/2 , (i == 2 || i == 5) ? 5 : (int)maxNumWidth, (int)maxNumHeight);
			}
			if (i == 2 || i == 5) {
				x += 5;
			}else {
				x += maxNumWidth;
				maxNumWidth = (int)(maxNumWidth * 0.95);
				maxNumHeight = (int)(maxNumHeight * 0.95);
			}
		}
		transform.dispose();
	}
	private void drawRightBlackboardTitle(GC gc){
		
		double bgWidth = 157;
		double bgHight = 167;
		
		Rectangle boardRectangle = rightBlackborad.getBounds();
		int leftMargin = (int)(boardRectangle.width * (5 / bgWidth));
		int rightMargin = (int)(boardRectangle.width * ((8+10) / bgWidth));
		int topMargin = (int)(30 * boardRectangle.height/bgHight); 
		int bottomMargin = (int)(0 * boardRectangle.height/bgHight); 
		int rectangleWidth = boardRectangle.width - leftMargin - rightMargin;
		int rectangleHeight = (int)((boardRectangle.height - topMargin)/2 - bottomMargin);
		
		gc.setFont(SWTResourceManager.getFont("微软雅黑", 25, SWT.BOLD));
		Point e = gc.textExtent(StringUtils.hasLength(countDownTimeTitle) ? countDownTimeTitle.substring(0, 1) : "郭");
		double maxFontHeight = e.y;
		double maxFongWidth = e.x;
		double totalSize = maxFongWidth;
		for(int i = 1; i < countDownTimeTitle.length(); i++){
			maxFongWidth = maxFongWidth * 0.98;
//			maxFontHeight = maxFontHeight * 0.95d;
			totalSize += maxFongWidth;
		}
		
		double strRate = 0;
		double sep = 0;
		if(totalSize > rectangleWidth){
			strRate = totalSize / rectangleWidth;
			maxFongWidth = maxFongWidth/strRate;
			totalSize = rectangleWidth;
//			maxFontHeight = maxFongWidth / ((double)e.x / e.y);
		}else {
			sep = (rectangleWidth - totalSize)/(countDownTimeTitle.length() - 1);
			if(sep > maxFongWidth/3) {
				sep = maxFongWidth/3;
			}
		}
		totalSize += sep*(countDownTimeTitle.length() -1);
		
		int x = leftMargin + (int)(boardRectangle.width - totalSize - rightMargin)/2;
		
		Transform transform = new Transform(Display.getDefault());
		transform.setElements(1, -0.25f, 0, 1, 0, (float) (maxFontHeight*0.25));
		gc.setTransform(transform);
		if(null == countDownTimeTitle){
		}
		Color fontColor = SWTResourceManager.getColor(231, 22, 52);
//		fontColor = SWTResourceManager.getColor(SWT.COLOR_WHITE);
		for(int i = 0; i < countDownTimeTitle.length(); i++){
			String str = countDownTimeTitle.substring(i, i+1);
			Image strImage = drawImage(gc, str, 0, gc.getFont(), fontColor);
			gc.drawImage(strImage, 0, 0, strImage.getBounds().width, strImage.getBounds().height, x,topMargin + (rectangleHeight - (int)maxFontHeight)/2 , (int)maxFongWidth, (int)maxFontHeight);
			strImage.dispose();
			x += maxFongWidth;
			maxFongWidth = (int)(maxFongWidth / 0.95);
			maxFontHeight = (int)(maxFontHeight/ 0.95);
			x += sep;
		}
		transform.dispose();
	}
	private Image drawRightBlackboardTime(GC gc){
		
		double bgWidth = 157;
		double bgHight = 167;
		
		Rectangle boardRectangle = rightBlackborad.getBounds();
		int leftMargin = (int)(boardRectangle.width * ((5+9) / bgWidth));
		int rightMargin = (int)(boardRectangle.width * (5 / bgWidth));
		int topMargin = -10;//(int)(10 * leftBlackboardRectangle.height/bgHight); 
		int bottomMargin = 0;//(int)(0 * leftBlackboardRectangle.height/bgHight); 
		int rectangleWidth = boardRectangle.width - leftMargin - rightMargin;
		int titleTopOffset = (int)(8 * boardRectangle.height/bgHight); 
		int rectangleHeight = (int)((boardRectangle.height - titleTopOffset)/2 - topMargin - bottomMargin);
		int y = (boardRectangle.height - titleTopOffset)/2 + topMargin;
		
		Image numImage = imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/time/red_8.png");
//		Image numSepImage = imageResolver.loadImage(SWTCoreIconsActivator.PLUGIN_ID,"icons/time/red_sep.png");
		int numTotalLength = numImage.getBounds().width;
		int maxNumHeight = numImage.getBounds().height;
		int maxNumWidth = numImage.getBounds().width;
		for(int i = 1; i < 6; i++){
			maxNumHeight = (int)(maxNumHeight * 0.95);
			maxNumWidth = (int)(maxNumWidth * 0.95);
			numTotalLength += maxNumWidth;
		}
		numTotalLength += 5 *2;
		double numRate = 0;
		
		if(numTotalLength > boardRectangle.width -10){
			numRate = (double)numTotalLength/(boardRectangle.width -10);
			numTotalLength = boardRectangle.width -10;
			maxNumWidth = (int)(maxNumWidth/numRate);
			maxNumHeight = (int)(maxNumWidth / ((double)numImage.getBounds().width / numImage.getBounds().height) * 1.2);
		}
		
		int x = leftMargin + (int)(rectangleWidth - numTotalLength)/2;
		Transform transform = new Transform(Display.getDefault());
		transform.setElements(1, -0.18f, 0, 1, 0, maxNumHeight*0.82f);
		gc.setTransform(transform);
		for(int i = 0; i < countDownTimeStr.length; i++){
			String str = countDownTimeStr[i];
			Image drawImage = null;
			if(str.equals(":")){
				drawImage = imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/time/red_sep.png");
			}else {
				drawImage = imageResolver.loadImage(IconsActivator.PLUGIN_ID,"icons/time/red_"+str+".png");
			}
			if(null != drawImage){
				gc.drawImage(drawImage, 0, 0, drawImage.getBounds().width, drawImage.getBounds().height, x, y + (rectangleHeight - (int)maxNumHeight)/2 , (i == 2 || i == 5) ? 5 : (int)maxNumWidth, (int)maxNumHeight);
			}
			if(i == 2 || i == 5){
				x += 5;
			}else {
				x += maxNumWidth;
				maxNumWidth = (int)(maxNumWidth / 0.95);
				maxNumHeight = (int)(maxNumHeight / 0.92);
			}
		}
		transform.dispose();
		return null;
	}
	
	/**
	 * @Description: 刷新倒计时
	 * @author guoyr
	 * @param countDownTimeTitle
	 * @param countDownTime 
	 */
	public void refreshCountDownTime(String countDownTimeTitle, Date countDownTime){
		this.countDownTimeTitle = countDownTimeTitle;
		this.countDownTime = countDownTime;
		startCountTimeThread(countDownTime);
		Display.getDefault().syncExec(rightBlackBoardRunnable);
	}
	
	
	private void drawRightBlackborad(PaintEvent arg0){
//		Image image = new Image(Display.getDefault(), rightBlackboardImage.getImageData());
		Transform transform = new Transform(Display.getDefault());
		arg0.gc.setTransform(transform);
		arg0.gc.setFont(SWTResourceManager.getFont("微软雅黑", 25, SWT.BOLD));
		
		if(null == countDownTimeTitle || countDownTimeTitle.length() == 0){
			countDownTimeTitle = Messages.CountdownOnBoard;
		}
		drawRightBlackboardTitle(arg0.gc);
		drawRightBlackboardTime(arg0.gc);
		arg0.gc.dispose();
	}
	
	
	/** 
	 * @Description: 绘制会议室标题
	 * @author guoyr
	 * @param meetingTitle 
	 */
	public void refreshMeetingTitle(String meetingTitle){
//		meetingTitle += "\r\n中华人民共和国中华人民共和国";
		if(null != meetingTitle){
			this.meetingTitle = meetingTitle;
			String ledContent = PropertiesUtils.getProperty(ConfigConstants.OPENINGROOM_LED_CONTENT, "");
			List<String> ledContents = new ArrayList<String>();
			ledContents.add(meetingTitle);
			if(null != ledContent && ledContent.length() > 0){
				String[] titles = ledContent.split("\r\n");
				ledContents.addAll(Arrays.asList(titles));
			}
			scrollLEDListener.setCircleScroll("01".equals(PropertiesUtils.getProperty(ConfigConstants.LED_CIRCLE_SCROLL, "01")));
			scrollLEDListener.refreshSpeed(ObjectUtils.getIntValue(PropertiesUtils.getProperty(ConfigConstants.LED_SCROLL_TIME, "200"), 200), ObjectUtils.getIntValue(PropertiesUtils.getProperty(ConfigConstants.LED_SCROLL_STEP, "5"), 5));
			scrollLEDListener.refreshLEDContent(ledContents);
		}
	}
	
	/**
	 * @Description: 绘制会议室标题
	 * @author guoyr
	 * @param gc 
	 */
	private void drawMeetingTitle(GC gc){
//		gc.setAlpha(200);
		gc.setForeground(SWTResourceManager.getColor(231, 22, 52));
//		gc.setForeground(Display.getDefault().getSystemColor(SWT.COLOR_WHITE));
//		gc.fillRectangle(project_composite.getBounds());
		if(null != meetingTitle && meetingTitle.length() > 0){
			gc.setFont(SWTResourceManager.getFont("微软雅黑", titleFontHeight, SWT.BOLD));
			Point e = gc.textExtent(meetingTitle, SWT.DRAW_MNEMONIC | SWT.DRAW_TAB | SWT.DRAW_TRANSPARENT | SWT.DRAW_DELIMITER);
			while(e.x > meetingTitleComposite.getBounds().width -10){
				titleFontHeight --;
				gc.setFont(SWTResourceManager.getFont("微软雅黑", titleFontHeight, SWT.BOLD));
				e = gc.textExtent(meetingTitle, SWT.DRAW_MNEMONIC | SWT.DRAW_TAB | SWT.DRAW_TRANSPARENT | SWT.DRAW_DELIMITER);
			}
			
			int x = (meetingTitleComposite.getBounds().width - e.x)/2;
			int y = (meetingTitleComposite.getBounds().height - e.y)/2;
			gc.setAlpha(250);
			gc.drawText(meetingTitle, x, y, true);
		}
	}
	
	
	/**
	 * @Description: 刷新主持人桌子
	 * @author guoyr
	 * @param title 
	 */
	public void refreshManagerTable(String title){
		this.tableTitle = title;
		manageTable.redraw();
	}
	
	/**
	 * @Description: 更多设置
	 * @author guoyr 
	 */
	private void ledConfigAction(){
		
		final ToolsShell moreToolsShell = new ToolsShell(getShell());
		final Composite ledConfigComposite = moreToolsShell.addToolBar("配置LED显示", null, false);
		ledConfigComposite.setLayout(new GridLayout(2, false));
		
		
		LedConfigComposite ledScroll = new LedConfigComposite(ledConfigComposite, meetingTitle, SWT.NONE);
		ledScroll.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		ledScroll.addScrollLEDListener(scrollLEDListener);
		
		moreToolsShell.setWidth(700);
		moreToolsShell.pack();
		SwtUtils.setCenter(moreToolsShell);
		moreToolsShell.open();
	}
	
	/**
	 * @Description: 绘制座位
	 * @author guoyr 
	 */
	private void drawSupplierRowChairs(int rowIndex){
		final Composite chairsComposite = chairsRows[rowIndex];
		chairsComposite.setForeground(SWTResourceManager.getColor(255, 255, 255));
		chairsComposite.setBackground(SWTResourceManager.getColor(231, 22, 52));
		int center = ROW_CHAIRS/2;
		for(Control control : chairsComposite.getChildren()){
			control.dispose();
		}
		for(int i = 0; i < ROW_CHAIRS; i++) {
			int chairWidth = (int)((charsLeftPeopleImage.getBounds().width / (double)charsLeftPeopleImage.getBounds().height)*chairsComposite.getBounds().height);
			
			final Canvas chair = new Canvas(chairsComposite, SWT.TRANSPARENT);
			GridData gridData = new GridData(SWT.CENTER, SWT.FILL, true, true, 1, 1);
			gridData.widthHint = chairWidth;
			chair.setLayoutData(gridData);
			final boolean leftChair = i < center;
			final boolean rigthChair = i > center;
			final boolean isCenter = i == center;
			chair.addPaintListener(new PaintListener() {
				public void paintControl(PaintEvent arg0) {
					if(isCenter){
						String rowNum = (String)chair.getData("rowNum");
						if(null != rowNum && rowNum.length() > 0){
							arg0.gc.setFont(chairsComposite.getFont());
							arg0.gc.setForeground(SWTResourceManager.getColor(255, 255, 255));
							Point point = arg0.gc.textExtent(rowNum);
							arg0.gc.setAlpha(120);
							int numStrY = (int)(chair.getBounds().height/2.5);
							arg0.gc.fillOval(0, numStrY + (chair.getBounds().height/3 - point.y - 4)/2, chair.getBounds().width - 0, point.y + 4);
							arg0.gc.setAlpha(-1);
							arg0.gc.drawText(rowNum, (chair.getBounds().width - point.x)/2, numStrY + (chair.getBounds().height/3 - point.y)/2, true);
						}
					
					}else {
						Image charsImage = null;
						boolean hasPeople = null != chair.getData("people");
						if(leftChair){
							charsImage = hasPeople ? charsLeftPeopleImage : charsLeftImage;
						}else if(rigthChair){
							charsImage = hasPeople ? charsRightPeopleImage : charsRightImage;
						}
//						arg0.gc.drawImage(charsImage, 0, 0, charsImage.getBounds().width, charsImage.getBounds().height, 2, 2, chair.getBounds().width - 4, chair.getBounds().height -4);
						arg0.gc.drawImage(charsImage, 0, 0, charsImage.getBounds().width, charsImage.getBounds().height, 0, 0, chair.getBounds().width - 0, chair.getBounds().height -0);
					}
				}
			});
			
		}
		chairsComposite.layout();
	}
	
	/**
	 * @Description: 刷新有人的座位
	 * @author guoyr 
	 */
	public void refreshPeopleCount(final int peopleCount){
		if(this.peopleCount != peopleCount){
			this.peopleCount = peopleCount;
			final int charsCount = ROW_CHAIRS -1;
			final int centerNum = ROW_CHAIRS /2;
			int totalRow = peopleCount / charsCount;
			if(peopleCount % charsCount > 0){
				totalRow += 1;
			}
			final boolean showRowNum = totalRow > 4;
			firstStartRow = Math.max(totalRow - 4 + 1, 1);

			for(int rowIndex = 0; rowIndex < chairsRows.length; rowIndex++){
				int curRowPeople = Math.max(peopleCount - charsCount * (firstStartRow + rowIndex - 1), 0);
				drawChairsPeople(rowIndex, showRowNum ? (firstStartRow + rowIndex) : -1, curRowPeople, charsCount, centerNum);
			}
		}
	}
	
	private void drawChairsPeople(final int rowIndex, final int rowNum, final int curRowPeople, final int charsCount, final int centerNum){
			Display.getDefault().syncExec(new Runnable(){
				public void run(){
					int startIndex = -1;
					int endIndex = -1;
					if(curRowPeople > 0){
						if(curRowPeople <= charsCount){
							startIndex = (charsCount - curRowPeople)/2; 
						}
						endIndex = startIndex + curRowPeople -1;
					}
					Composite chairsComposite = chairsRows[rowIndex];
					if(null != chairsComposite && !chairsComposite.isDisposed()){
						Control[] chairs = chairsComposite.getChildren();
						for(int i = 0; i < charsCount; i++){
							boolean hasPeople = false;
							if(i >= startIndex && i <= endIndex){
								hasPeople = true;
							}
							int chairIndex = (i < centerNum) ? i : (i + 1);
							boolean oldChairHasPeople = null != chairs[chairIndex].getData("people");
							chairs[chairIndex].setData("people", hasPeople ? "true" : null);
							if(oldChairHasPeople != hasPeople){
								chairs[chairIndex].redraw();
							}
							if(i == centerNum){
								String oldRowNum = (String)chairs[centerNum].getData("rowNum");
								if(!(null != oldRowNum && oldRowNum.equals(rowNum + "")) || (null == oldRowNum && rowNum > 0)){
									chairs[centerNum].setData("rowNum", rowNum > 0 ? (rowNum + "") : null);
									chairs[centerNum].redraw();
								}
							}
						}
					}
				}
			});
	}
	
	private Image drawImage(GC gc, String string, float rotate, Font font, Color fontColor){
		Point e = gc.textExtent(string);
		BufferedImage bufferedImage = new BufferedImage(e.x, e.y,BufferedImage.TYPE_INT_RGB);  
		PaletteData palette = new PaletteData(0, 0, 0);  
		ImageData imageData = new ImageData(e.x, e.y,  bufferedImage.getColorModel().getPixelSize(), palette); 
		imageData.transparentPixel = imageData.palette.getPixel(new RGB(0, 0, 0));
		Image strImage = new Image(Display.getDefault(), imageData);
		GC imageGc = new GC(strImage);
		Transform transform = new Transform(Display.getDefault());
		if(rotate != 0){
			transform.setElements(1, rotate, 0, 1, 0 ,0);
		}
		imageGc.setTransform(transform);
		imageGc.setFont(font);
		imageGc.setForeground(fontColor);
		imageGc.setBackground(fontColor);
		imageGc.drawText(string, 0, 0,true);
		imageGc.dispose();
		transform.dispose();
		return strImage;
	}
	
	public Composite getLoadParent() {
		return loadComposite;
	}
	
	public Composite getOperatorParent(){
		return operatorComposite;
	}
	
	public void refreshOperator(){
		operatorComposite.layout();
	}
	
	
	public void addCountTimeListener(CountTimeThread.CountTime countTimeListener){
		this.countTimeListener= countTimeListener;
		
	}
	
	/**
	 * @Description: 启动倒计时线程
	 * @author guoyr
	 */
	private void startCountTimeThread(Date countDownTime){
		showNowTime = false;
		if(null != countTimeThread){
			countTimeThread.stop();
			countTimeThread = null;
		}
		countTimeThread = new CountTimeThread(NowTimeUtils.getNowDate() , countDownTime, new CountTimeThread.CountTime(6) {
			Runnable drawRunnable = new Runnable(){
				public void run(){
					if(!rightBlackborad.isDisposed()){
						rightBlackborad.redraw();
					}
				}
			};
			public void countTime(String[] countDownTime) {
				
				countDownTimeStr[0] = countDownTime[countDownTime.length-6];
				countDownTimeStr[1] = countDownTime[countDownTime.length-5];
				countDownTimeStr[3] = countDownTime[countDownTime.length-4];
				countDownTimeStr[4] = countDownTime[countDownTime.length-3];
				countDownTimeStr[6] = countDownTime[countDownTime.length-2];
				countDownTimeStr[7] = countDownTime[countDownTime.length-1];
				Display.getDefault().asyncExec(drawRunnable);
				if(null != countTimeListener){
					countTimeListener.countTime(countDownTime);
				}
			}
		});
		countTimeThread.start();
	}
	
	/**
	 * @Description: 显示当前时间
	 * @author guoyr
	 * @param delayTime 
	 */
	public void showNowTime(final long delayTime){

		if(showNowTime){
			return;
		}
		showNowTime  = true;
		Thread countDownOrNowTimeThread = new Thread(new Runnable(){
			public void run(){
				final String weak = NowTimeUtils.getWeakDay();
//				long millis = NowTimeUtils.getNowDate().getTime();
//				Calendar calendar = Calendar.getInstance();
//				calendar.setTimeInMillis(millis);
				if(delayTime > 0){
					try {
						Thread.sleep(delayTime);
					} catch (InterruptedException e) {
					}
				}
				// 如果设置延迟时间为负数，则表示停止
				if(delayTime < 0){
					showNowTime = false;
				}
				
				while(showNowTime){
					refreshNowTime(weak, NowTimeUtils.getNowDate());
					try {
						Thread.sleep(1000);
					} catch (InterruptedException e) {
					}
				}
			}
		});
		countDownOrNowTimeThread.setName("开标大厅显示当前时间或倒计时线程");
		countDownOrNowTimeThread.start();
		
	}
	
	/**
	 * @Description: 刷新当前时间
	 * @author guoyr
	 * @param weak
	 * @param nowTime 
	 */
	private void refreshNowTime(String weak, Date nowTime){
		this.countDownTimeTitle = weak;
		String meetingTimeStr = "00:00:00";
		if(null != nowTime){
			meetingTimeStr = timeFormat.format(nowTime);
			for(int i = 0; i < meetingTimeStr.length(); i++){
				if(i == 2 || i == 5){
					countDownTimeStr[i] = ":";
				}else {
					countDownTimeStr[i] = meetingTimeStr.substring(i, i+1);
				}
			}
			Display.getDefault().syncExec(rightBlackBoardRunnable);
		}
	}
	
	
	/**
	 * @Description: 退出会议室
	 * @author guoyr 
	 */
	public void exitMeetingRoom(){
		close();
	}
	
	public void close() {
		showNowTime = false;
		if(null != countTimeThread){
			countTimeThread.stop();
			countTimeThread = null;
		}
		if(null != zoomBgImage){
			zoomBgImage.dispose();
		}
		if(null != decStartTimer){
			decStartTimer.cancel();
		}
		if(null != decEndTimer){
			decEndTimer.cancel();
		}
		if(null != imageResolver){
			imageResolver.disposite();
		}
		
		super.close();
	}



}
