package com.gx.obe.opening.shell;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.utils.SwtUtils;
import org.eclipse.swt.core.widgets.EButton;
import org.eclipse.swt.core.widgets.ImageButton;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Shell;

import com.gx.obe.ColorConstants;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.button.Tips;
import com.gx.obe.message.Messages;
import com.gx.obe.opening.Activator;
import com.gx.obe.opening.listener.DecBidListener;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

/**
 * @Description: 配置唱标参数
 * @author guoyr
 */
public class BidOpeningSelectShell extends Shell {

	
	private Composite composite;
	private Composite bidTypeComposite;
	private DecBidListener decBidListener;
	private boolean decTechnologyBid = true;
	private boolean decBusinessBid = true;
	private boolean decPriceBid = true;
	private ImageButton technologyBidBtn;
	private ImageButton businessBidBtn;
	private ImageButton priceBidBtn;

	public BidOpeningSelectShell(Shell shell, boolean decBusinessBid, boolean decTechnologyBid, boolean decPriceBid, DecBidListener decBidListener) {
		super(shell, SWT.NO_TRIM | SWT.APPLICATION_MODAL);
		this.decBusinessBid = decBusinessBid;
		this.decTechnologyBid = decTechnologyBid;
		this.decPriceBid = decPriceBid;
		this.decBidListener = decBidListener;
		setBackground(ColorConstants.SKIN_BG);
		setBackgroundMode(SWT.INHERIT_FORCE);
		FillLayout fillLayout = new FillLayout(SWT.HORIZONTAL);
		fillLayout.marginHeight = 1;
		fillLayout.marginWidth = 1;
		setLayout(fillLayout);
		this.setAlpha(240);
		composite = new Composite(this, SWT.NONE);
		composite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		composite.setBackgroundMode(SWT.INHERIT_FORCE);
		GridLayout gl_composite = new GridLayout(1, false);
		gl_composite.verticalSpacing = 0;
		gl_composite.horizontalSpacing = 0;
		composite.setLayout(gl_composite);
		
		Tips label_1 = new Tips(composite, SWT.NONE);
		label_1.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		label_1.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.NORMAL));
		label_1.setText("请选择要解密的标书类型！");
		
		bidTypeComposite = new Composite(composite, SWT.NONE);
		bidTypeComposite.setLayout(new GridLayout(3, false));
		bidTypeComposite.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, true, 1, 1));
		
		Composite composite_2 = new Composite(composite, SWT.NONE);
		composite_2.setLayout(new GridLayout(2, true));
		composite_2.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		
		EButton saveBtn = new EButton(composite_2, SWT.NONE);
		saveBtn.setBackground(ColorConstants.SKIN_BG);
		saveBtn.setForeground(ColorConstants.SKIN_FOREGROUND);
		saveBtn.setActiveBorderColor(ColorConstants.SKIN_ACTIVE_BG);
		saveBtn.setActiveBgColor(ColorConstants.SKIN_ACTIVE_BG);
		saveBtn.setActiveForeground(ColorConstants.SKIN_ACTIVE_FOREGROUND);
		saveBtn.setArcWidth(6);
		saveBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				decAction();
			}
		});
		saveBtn.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		GridData gd_savebutton_1 = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_savebutton_1.heightHint = 30;
		gd_savebutton_1.widthHint = 90;
		saveBtn.setLayoutData(gd_savebutton_1);
		saveBtn.setText("确认解密");
		
		EButton clolseBtn = new EButton(composite_2, SWT.NONE);
		clolseBtn.setBackground(ColorConstants.SKIN_BG);
		clolseBtn.setForeground(ColorConstants.SKIN_FOREGROUND);
		clolseBtn.setActiveBorderColor(ColorConstants.SKIN_ACTIVE_BG);
		clolseBtn.setActiveBgColor(ColorConstants.SKIN_ACTIVE_BG);
		clolseBtn.setActiveForeground(ColorConstants.SKIN_ACTIVE_FOREGROUND);
		clolseBtn.setArcWidth(6);
		clolseBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				getShell().close();
			}
		});
		clolseBtn.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		GridData gd_close_button_1 = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_close_button_1.heightHint = 30;
		gd_close_button_1.widthHint = 90;
		clolseBtn.setLayoutData(gd_close_button_1);
		clolseBtn.setText(Messages.Button_close);
		
		init();
		createContents();
	}
	
	/**
	 * @Description: 初始化界面
	 * @author guoyr
	 */
	private void init(){
		businessBidBtn = addDecBidTypeBtn(Messages.BusinessBid, decBusinessBid);
		if(decBusinessBid){
			businessBidBtn.addMouseListener(new MouseAdapter() {
				public void mouseUp(MouseEvent e) {
					if(businessBidBtn.getSelection()){
						businessBidBtn.setSubImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/unchecked.png"));
						businessBidBtn.setSelection(false);
						technologyBidBtn.setSubImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/unchecked.png"));
						technologyBidBtn.setSelection(false);
					}else {
						businessBidBtn.setSubImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/checked.png"));
						businessBidBtn.setSelection(true);
						technologyBidBtn.setSubImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/checked.png"));
						technologyBidBtn.setSelection(true);
					}
				}
			});
		}
		technologyBidBtn = addDecBidTypeBtn(Messages.TechnologyBid, decTechnologyBid);
		if(decTechnologyBid){
			technologyBidBtn.addMouseListener(new MouseAdapter() {
				public void mouseUp(MouseEvent e) {
					if(technologyBidBtn.getSelection()){
						businessBidBtn.setSubImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/unchecked.png"));
						businessBidBtn.setSelection(false);
						technologyBidBtn.setSubImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/unchecked.png"));
						technologyBidBtn.setSelection(false);
					}else {
						businessBidBtn.setSubImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/checked.png"));
						businessBidBtn.setSelection(true);
						technologyBidBtn.setSubImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/checked.png"));
						technologyBidBtn.setSelection(true);
					}
				}
			});
		}
		priceBidBtn = addDecBidTypeBtn(Messages.EconomicBid, decPriceBid);
		if(decPriceBid){
			priceBidBtn.addMouseListener(new MouseAdapter() {
				public void mouseUp(MouseEvent e) {
					if(priceBidBtn.getSelection()){
						priceBidBtn.setSubImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/unchecked.png"));
						priceBidBtn.setSelection(false);
					}else {
						priceBidBtn.setSubImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/checked.png"));
						priceBidBtn.setSelection(true);
					}
				}
			});
		}
	}
	
	private ImageButton addDecBidTypeBtn(String title, boolean isSelection){
		final ImageButton label = new ImageButton(bidTypeComposite, SWT.BOTTOM);
		label.setText(title);
		label.setLeftMargin(20);
		label.setRightMargin(20);
		label.setSubImageHorAlign(SWT.RIGHT);
		label.setSubImageRightMargin(5);
		label.setBorderColor(SWTResourceManager.getColor(60, 138, 226));
		label.setActiveBorderColor(SWTResourceManager.getColor(255, 153, 0));
		label.setSelectionBorderColor(SWTResourceManager.getColor(77, 163, 19));
		label.setSelectionForeground(SWTResourceManager.getColor(77, 163, 19));
		label.setSelection(isSelection);
		if(isSelection){
			label.setSubImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/checked.png"));
		}else {
			label.setSubImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/unchecked.png"));
		}
		
		label.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/tender_pager.png"));
		label.setForeground(ColorConstants.FONT_BLACK_COLOR);
		label.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.NORMAL));
		
		return label;
	}
	

	protected void createContents() {
		setText("");
		setSize(458, 297);
		this.setMinimumSize(100, 20);

	}

	private void decAction(){
		decBusinessBid = businessBidBtn.getSelection();
		decTechnologyBid = technologyBidBtn.getSelection();
		decPriceBid = priceBidBtn.getSelection();
		if(decBusinessBid || decTechnologyBid || decPriceBid){
			getShell().close();
			decBidListener.decBid(decBusinessBid, decTechnologyBid, decPriceBid);
		}else {
			MessageDialog.openShortMessage("请至少选择一种标书类型进行解密！");
		}
	}
	@Override
	public void open() {
//		this.pack();
		SwtUtils.setCenter(getShell());
		super.open();
	}

	/**
	 * @Description: 
	 * @author guoyr
	 */

	@Override
	protected void checkSubclass() {
	}
}
