package com.gx.obe.opening.shell;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.util.ArrayList;
import java.util.List;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.utils.SwtUtils;
import org.eclipse.swt.core.widgets.EButton;
import org.eclipse.swt.core.widgets.ELabel;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import com.gx.obe.ColorConstants;
import com.gx.obe.common.file.enumeration.FileConstants;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.FileUtils;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

import common.Logger;

public class ConfigNoteMessageDialog {
	protected Object result;
	protected Shell shell;
	private Composite top_composite;
	private ELabel label;
	private Composite message_composite;
	private Text add_text;
	String filePath = FileConstants.PRODUCT_ROOT+File.separator+"commonNote.txt";
	private ScrolledComposite scrolledComposite;
	private Composite composite_3;
	private Text text_2;
	private Logger LOG = Logger.getLogger(ConfigNoteMessageDialog.class);
	/**
	 * Open the dialog.
	 * @return the result
	 */
	public Object open() {
		createContents();
		shell.open();
		shell.layout();
		Display display = Display.getDefault();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch()) {
				display.sleep();
			}
		}
		return result;
	}
	
	/**
	 * Create contents of the dialog.
	 * @wbp.parser.entryPoint
	 */
	private void createContents() {
		shell = new Shell(SWT.NO_TRIM | SWT.SYSTEM_MODAL);
		shell.setSize(737, 523);
		shell.setText("常用通告配置");
		shell.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/message.png"));
		shell.setBackgroundImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/title_fill_bg.png"));
		GridLayout gl_shell = new GridLayout(1, false);
		gl_shell.horizontalSpacing = 0;
		gl_shell.verticalSpacing = 0;
		gl_shell.marginHeight = 1;
		gl_shell.marginWidth = 1;
		shell.setLayout(gl_shell);
		
		top_composite = new Composite(shell, SWT.NONE | SWT.SELECTED);
		top_composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		top_composite.setBackgroundImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/title_fill_bg.png"));
		top_composite.setBackgroundMode(SWT.INHERIT_FORCE);
		GridLayout gl_top_composite = new GridLayout(3, false);
		gl_top_composite.marginHeight = 0;
		top_composite.setLayout(gl_top_composite);
		
		label = new ELabel(top_composite, SWT.NONE);
		label.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/message.png"));
		label.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		label.setForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		label.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1));
		label.setText("常用消息配置");
		
		ELabel min_size_btn = new ELabel(top_composite, SWT.NONE | SWT.SELECTED);
		min_size_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/min_size.png"));
		min_size_btn.setMargins(5, 5, 5, 5);
		min_size_btn.setActiveColor(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		min_size_btn.setAlpha(10);
		min_size_btn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				shell.setMinimized(true);
			}
		});
		
		ELabel close_btn = new ELabel(top_composite, SWT.NONE | SWT.SELECTED);
		close_btn.setActiveColor(SWTResourceManager.getColor(SWT.COLOR_RED));
		close_btn.setMargins(5, 5, 5, 5);
		close_btn.setAlpha(10);
		close_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/main_close.png"));
		close_btn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				systemClose();
			}
		});
		message_composite = new Composite(shell, SWT.NONE);
		message_composite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_config_note_composite = new GridLayout(1, false);
		gl_config_note_composite.verticalSpacing = 0;
		gl_config_note_composite.horizontalSpacing = 0;
		gl_config_note_composite.marginHeight = 0;
		gl_config_note_composite.marginWidth = 0;
		message_composite.setLayout(gl_config_note_composite);
		message_composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		Composite parent_composite = new Composite(message_composite, SWT.NONE);
		parent_composite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_parent_composite = new GridLayout(1, false);
		gl_parent_composite.marginHeight = 10;
		gl_parent_composite.marginWidth = 10;
		parent_composite.setLayout(gl_parent_composite);
		parent_composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		Composite composite = new Composite(parent_composite, SWT.NONE);
		GridLayout gl_composite = new GridLayout(1, false);
		gl_composite.verticalSpacing = 0;
		gl_composite.horizontalSpacing = 0;
		gl_composite.marginHeight = 1;
		gl_composite.marginWidth = 1;
		composite.setLayout(gl_composite);
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		scrolledComposite = new ScrolledComposite(composite, SWT.H_SCROLL | SWT.V_SCROLL);
		scrolledComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		scrolledComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		scrolledComposite.setExpandHorizontal(true);
		scrolledComposite.setExpandVertical(true);
		
		composite_3 = new Composite(scrolledComposite, SWT.NONE);
		composite_3.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_composite_3 = new GridLayout(1, false);
		gl_composite_3.marginWidth = 10;
		composite_3.setLayout(gl_composite_3);
		composite_3.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		Composite composite_4 = new Composite(composite_3, SWT.NONE);
		composite_4.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_composite_4 = new GridLayout(2, false);
		gl_composite_4.verticalSpacing = 0;
		gl_composite_4.marginHeight = 0;
		composite_4.setLayout(gl_composite_4);
		GridData gd_composite_4 = new GridData(SWT.FILL, SWT.BOTTOM, true, false, 1, 1);
		gd_composite_4.heightHint = 50;
		composite_4.setLayoutData(gd_composite_4);
		
		text_2 = new Text(composite_4, SWT.NONE);
		text_2.setLayoutData(new GridData(SWT.FILL, SWT.BOTTOM, true, false, 1, 1));
		
		ELink button_3 = new ELink(composite_4, SWT.NONE);
		button_3.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		button_3.setLayoutData(new GridData(SWT.LEFT, SWT.BOTTOM, false, true, 1, 1));
		button_3.setText(Messages.Button_delete);
		button_3.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/delete.png"));
		GridData gd_button_3 = new GridData(SWT.LEFT, SWT.BOTTOM, false, true, 1, 1);
		gd_button_3.widthHint = 50;
		button_3.setLayoutData(gd_button_3);
		button_3.setText(Messages.Button_delete);
		
		
		ESepator sepator_2 = new ESepator(composite_4, SWT.NONE);
		sepator_2.setLayoutData(new GridData(SWT.FILL, SWT.TOP, false, false, 1, 1));
		
		scrolledComposite.setContent(composite_3);
		scrolledComposite.setMinSize(composite_3.computeSize(SWT.DEFAULT, SWT.DEFAULT));
		
		ESepator compositeESepator = new ESepator(composite, SWT.NONE);
		compositeESepator.setLayoutData(new GridData(SWT.FILL, SWT.TOP, false, false, 1, 1));
		compositeESepator.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		
		Composite composite_2 = new Composite(composite, SWT.NONE);
		composite_2.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_composite_2 = new GridLayout(2, false);
		gl_composite_2.marginWidth = 10;
		gl_composite_2.verticalSpacing = 0;
		gl_composite_2.marginHeight = 40;
		composite_2.setLayout(gl_composite_2);
		GridData gd_composite_2 = new GridData(SWT.FILL, SWT.BOTTOM, true, false, 1, 1);
		gd_composite_2.heightHint = 100;
		composite_2.setLayoutData(gd_composite_2);
		
		add_text = new Text(composite_2, SWT.NONE);
		add_text.setLayoutData(new GridData(SWT.FILL, SWT.BOTTOM, true, false, 1, 1));
		
		ELink add_button = new ELink(composite_2, SWT.NONE);
		add_button.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				addComposite();
			}
		});
		add_button.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		add_button.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/add.png"));
		GridData gd_button_2 = new GridData(SWT.RIGHT, SWT.BOTTOM, false, false, 1, 1);
		add_button.setLayoutData(gd_button_2);
		gd_button_2.widthHint = 50;
		add_button.setText(Messages.Button_add);
		
		ESepator sepator_3 = new ESepator(composite_2, SWT.NONE);
		sepator_3.setLayoutData(new GridData(SWT.FILL, SWT.TOP, false, false, 1, 1));
		sepator_3.setBackground(ResourceManager.getColor(SWT.COLOR_GRAY));
		
		Composite composite_1 = new Composite(message_composite, SWT.NONE);
		composite_1.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		composite_1.setLayout(new GridLayout(3, false));
		composite_1.setLayoutData(new GridData(SWT.CENTER, SWT.FILL, true, false, 1, 1));
		
		Label label_2 = new Label(composite_1, SWT.NONE);
		label_2.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1));
		
		EButton save_button = new EButton(composite_1, SWT.NONE);
		save_button.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				saveConfig(composite_3);
			}
		});
		save_button.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/save.png"));
		GridData gd_button = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
		gd_button.widthHint = 80;
		save_button.setLayoutData(gd_button);
		save_button.setText(Messages.Button_save);
		
		EButton close_button = new EButton(composite_1, SWT.NONE);
		close_button.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				systemClose();
			}
		});
		close_button.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/close.png"));
		GridData gd_button_1 = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
		gd_button_1.widthHint = 80;
		close_button.setLayoutData(gd_button_1);
		close_button.setText(Messages.Button_close);
		
	
		init();

	}
	/**
	 * @Description: 界面数据初始化
	 * @author guoyr 
	 */
	private void init(){
		SwtUtils.setMouseDragListener(top_composite, true);
		SwtUtils.setCenter(shell);
		showCommonMessage(readTxt());
		message_composite.getParent().layout();
	}
	/**
	 * @Description: 显示已存在的常用公告
	 * @author guoyr
	 * @param commonMassageList
	 * @param parentComposite 
	 */
	private void showCommonMessage(List<String> commonMassageList){
		Control[] controls = composite_3.getChildren();
		for(Control control : controls){
			control.dispose();
		}
		
		for(int i = 0; i < commonMassageList.size(); i ++){
			createItem(commonMassageList.get(i));
		}
		composite_3.layout();
		scrolledComposite.setMinSize(composite_3.computeSize(SWT.DEFAULT, SWT.DEFAULT));
	}
	/**
	 * @Description: 保存操作
	 * @author guoyr 
	 */
	private void saveConfig(Composite composite ){
		Control[] controls = composite.getChildren();
		StringBuffer buffer = new StringBuffer();
		
		//获取显示的所有文本框数据
		for(Control control : controls){
			Composite firstComposite = (Composite) control;
			Control[] chidrenControls = firstComposite.getChildren();
			for(Control childControl : chidrenControls){
				if(childControl instanceof Text){
					String value = ((Text) childControl).getText().trim();
					if(null != value){
						buffer.append(value + "\r\n");
					}
				}
			}
		}
		FileUtils.writerFile(filePath, buffer.toString(), "UTF-8");
	}
	/**
	 * @Description: 添加
	 * @author guoyr
	 * @param parentComposite 
	 */
	private void addComposite(){
		String value = add_text.getText().trim();
		createItem(value);
		composite_3.layout();
		scrolledComposite.setMinSize(composite_3.computeSize(SWT.DEFAULT, SWT.DEFAULT));
		scrolledComposite.forceFocus();
	}
	
	/**
	 * @Description: 添加单条常用通告面板
	 * @author guoyr
	 * @param textValue
	 * @param parentComposite 
	 */
	private void createItem(String textValue){
		
		final Composite composite_4 = new Composite(composite_3, SWT.NONE);
		composite_4.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_composite_4 = new GridLayout(2, false);
		gl_composite_4.verticalSpacing = 0;
		gl_composite_4.marginHeight = 0;
		composite_4.setLayout(gl_composite_4);
		GridData gd_composite_4 = new GridData(SWT.FILL, SWT.BOTTOM, true, false, 1, 1);
		gd_composite_4.heightHint = 50;
		composite_4.setLayoutData(gd_composite_4);
		
		Text valueText = new Text(composite_4, SWT.NONE);
		valueText.setLayoutData(new GridData(SWT.FILL, SWT.BOTTOM, true, false, 1, 1));
		valueText.setText(textValue);
		
		ELink delete_button = new ELink(composite_4, SWT.NONE);
		delete_button.setLayoutData(new GridData(SWT.LEFT, SWT.BOTTOM, false, true, 1, 1));
		delete_button.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				composite_4.dispose();
				composite_3.layout();
				scrolledComposite.setMinSize(composite_3.computeSize(SWT.DEFAULT, SWT.DEFAULT));
				scrolledComposite.forceFocus();
			}
		});
		delete_button.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/delete.png"));
		GridData gd_button_3 = new GridData(SWT.LEFT, SWT.BOTTOM, false, true, 1, 1);
		gd_button_3.widthHint = 50;
		delete_button.setLayoutData(gd_button_3);
		delete_button.setText(Messages.Button_delete);
		delete_button.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		
		ESepator sepator_2 = new ESepator(composite_4, SWT.NONE);
		sepator_2.setLayoutData(new GridData(SWT.FILL, SWT.TOP, false, false, 1, 1));
		sepator_2.setBackground(ResourceManager.getColor(SWT.COLOR_GRAY));
		
	}
	/**
	 * @Description: 系统关闭按钮事件
	 * @author guoyr 
	 */
	public void systemClose(){
		shell.close();
	}
	/**
	 * @Description: 获取常用通告
	 * @author guoyr 
	 */
	private List<String> readTxt(){
		List<String> commonNoteList = new ArrayList<String>();
		File file = new File(filePath);//Text文件
		BufferedReader br = null;
		try {
			br = new BufferedReader(new InputStreamReader(
					new FileInputStream(file), "UTF-8"));
			String s = null;
			while((s = br.readLine())!=null){//使用readLine方法，一次读一行
				commonNoteList.add(s);
			}
		} catch (Exception e) {
			LOG.error("", e);
		}finally{
			if(null != br){
				try {
					br.close();
				} catch (IOException e) {
					LOG.error("", e);
				}
			}
		}
		return commonNoteList;
	}
}
