package com.gx.obe.opening.shell;

import java.text.MessageFormat;
import java.util.Properties;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.CallBack;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.utils.SwtUtils;
import org.eclipse.swt.core.widgets.EButton;
import org.eclipse.swt.core.widgets.ELabel;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Scale;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import com.gx.obe.ColorConstants;
import com.gx.obe.business.enumeration.ProjectRuleEnum;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.config.ConfigConstants;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.message.Messages;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.entity.tender.TenderProjectRuleEntity;
import com.gx.obe.web.service.ProjectRuleService;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

/**
 * @Description: 配置唱标参数
 * @author guoyr
 */
public class ConfigSingShell extends Shell {

	private TenderProjectEntity tenderProjectEntity;
	private TenderProjectRuleEntity tenderProjectRuleEntity;
	private Composite composite;
//	private Composite priceUtinComposite;
	private Label speekRateLabel;
	private Scale scale;
	private int speed = 0;
	private CallBack callBack;
	private Text fileText;
	private Button filterKhBtn;
	private Properties configProperties;
	private Button signTenderName;
	private Button sealSituation_btn;
	private Button singBidPriceLimitBtn;
	private Text singBidPriceLimitNameText;
	private Text singPrefixText;
	private Text singSuffixText;
	
	public ConfigSingShell(Shell shell, TenderProjectEntity tenderProjectEntity, TenderProjectRuleEntity tenderProjectRuleEntity, CallBack callBack) {
		super(shell, SWT.NO_TRIM | SWT.APPLICATION_MODAL);
		setBackground(ColorConstants.SKIN_BG);
		setBackgroundMode(SWT.INHERIT_FORCE);
		FillLayout fillLayout = new FillLayout(SWT.HORIZONTAL);
		fillLayout.marginHeight = 1;
		fillLayout.marginWidth = 1;
		setLayout(fillLayout);
		this.tenderProjectEntity = tenderProjectEntity;
		this.tenderProjectRuleEntity = tenderProjectRuleEntity;
		this.callBack = callBack;
		this.setAlpha(240);
		composite = new Composite(this, SWT.NONE);
		composite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		composite.setBackgroundMode(SWT.INHERIT_FORCE);
		GridLayout gl_composite = new GridLayout(1, false);
		gl_composite.verticalSpacing = 0;
		gl_composite.horizontalSpacing = 0;
		composite.setLayout(gl_composite);
		
		Composite composite_3 = new Composite(composite, SWT.NONE);
		composite_3.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		GridLayout gl_composite_3 = new GridLayout(2, false);
		gl_composite_3.marginWidth = 0;
		gl_composite_3.marginHeight = 0;
		composite_3.setLayout(gl_composite_3);
		
		Label label_7 = new Label(composite_3, SWT.NONE);
		label_7.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		label_7.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1));
		label_7.setText("唱标配置");
		
		ELabel label_5 = new ELabel(composite_3, SWT.SELECTED);
		label_5.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		label_5.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				getShell().close();
			}
		});
		label_5.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/close_gry.png"));
		label_5.setText("");
		
		Composite baseRoleComposite = new Composite(composite, SWT.NONE);
		baseRoleComposite.setFont(SWTResourceManager.getFont("微软雅黑", 11, SWT.BOLD));
		GridLayout gl_group = new GridLayout(2, false);
		gl_group.marginWidth = 10;
		gl_group.marginHeight = 8;
		baseRoleComposite.setLayout(gl_group);
		baseRoleComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
//		Label label_1 = new Label(baseRoleComposite, SWT.NONE);
//		label_1.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
//		label_1.setText("    金额单位：");
//		
//		priceUtinComposite = new Composite(baseRoleComposite, SWT.NONE);
//		GridLayout gl_priceUtinComposite = new GridLayout(3, false);
//		gl_priceUtinComposite.marginHeight = 0;
//		gl_priceUtinComposite.marginWidth = 0;
//		priceUtinComposite.setLayout(gl_priceUtinComposite);
//		priceUtinComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
//		
//		Button button_2 = new Button(priceUtinComposite, SWT.RADIO);
//		button_2.setSelection(true);
//		button_2.setText("元");
//		button_2.setData(CommonEnum.YUAN);
//		
//		Button button_3 = new Button(priceUtinComposite, SWT.RADIO);
//		button_3.setText("万元");
//		button_3.setData(CommonEnum.WAN_YUAN);
//		
//		Label label_23 = new Label(priceUtinComposite, SWT.WRAP);
//		label_23.setForeground(SWTResourceManager.getColor(SWT.COLOR_DARK_GRAY));
//		label_23.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
//		label_23.setText("设置系统中所有金额单位。");
		
		speekRateLabel = new Label(baseRoleComposite, SWT.NONE);
		speekRateLabel.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		speekRateLabel.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, true, false, 1, 1));
		speekRateLabel.setText(Messages.SpeechRate + "：");
		
		Composite composite_1 = new Composite(baseRoleComposite, SWT.NONE);
		composite_1.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		GridLayout gl_composite_1 = new GridLayout(3, false);
		gl_composite_1.marginWidth = 0;
		gl_composite_1.marginHeight = 0;
		composite_1.setLayout(gl_composite_1);
		
		Label label_3 = new Label(composite_1, SWT.NONE);
		label_3.setText(Messages.Slow);
		scale = new Scale(composite_1, SWT.NONE);
		scale.setSelection(10);
		scale.setPageIncrement(1);
		scale.setMaximum(20);
		
		Label label_2 = new Label(composite_1, SWT.NONE);
		label_2.setText(Messages.Fast);
		
		Label label_6 = new Label(baseRoleComposite, SWT.NONE);
		label_6.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		label_6.setText(Messages.SingOption + "：");
		
		Composite singSelection_composite = new Composite(baseRoleComposite, SWT.NONE);
		singSelection_composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		GridLayout gl_singSelectioncomposite = new GridLayout(3, false);
		gl_singSelectioncomposite.horizontalSpacing = 20;
		gl_singSelectioncomposite.marginWidth = 0;
		gl_singSelectioncomposite.marginHeight = 0;
		singSelection_composite.setLayout(gl_singSelectioncomposite);
		
		signTenderName = new Button(singSelection_composite, SWT.CHECK);
		signTenderName.setText(MessageFormat.format(Messages.SingFormat, Messages.ProjectName));
		
		Composite composite_4 = new Composite(singSelection_composite, SWT.NONE);
		composite_4.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		GridLayout gl_composite_4 = new GridLayout(3, false);
		gl_composite_4.marginWidth = 0;
		gl_composite_4.marginHeight = 0;
		composite_4.setLayout(gl_composite_4);
		
		singBidPriceLimitBtn = new Button(composite_4, SWT.CHECK);
		singBidPriceLimitBtn.setText("");
		
		Composite singBidPriceLimitComposite = new Composite(composite_4, SWT.NONE);
		singBidPriceLimitComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		GridLayout gl_singBidPriceLimitComposite = new GridLayout(2, false);
		gl_singBidPriceLimitComposite.verticalSpacing = 0;
		gl_singBidPriceLimitComposite.horizontalSpacing = 0;
		gl_singBidPriceLimitComposite.marginHeight = 0;
		gl_singBidPriceLimitComposite.marginWidth = 0;
		singBidPriceLimitComposite.setLayout(gl_singBidPriceLimitComposite);
		
		Label singBidPrice = new Label(singBidPriceLimitComposite, SWT.CHECK);
		singBidPrice.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 2));
		singBidPrice.setText(MessageFormat.format(Messages.SingFormat, ""));
		
		singBidPriceLimitNameText = new Text(singBidPriceLimitComposite, SWT.NONE);
		GridData gd_singBidPriceLimitNameText = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
		gd_singBidPriceLimitNameText.widthHint = 80;
		singBidPriceLimitNameText.setLayoutData(gd_singBidPriceLimitNameText);
		singBidPriceLimitNameText.setTextLimit(10);
		
		ESepator singBidPriceLimitSep = new ESepator(singBidPriceLimitComposite, SWT.NONE);
		singBidPriceLimitSep.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		singBidPriceLimitSep.setBackground(ColorConstants.BORDER_LINE_COLOR);
		
		sealSituation_btn = new Button(singSelection_composite, SWT.CHECK);
		sealSituation_btn.setText(MessageFormat.format(Messages.SingFormat, Messages.SealingStatus));
		
		Label label = new Label(baseRoleComposite, SWT.NONE);
		label.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		label.setText(Messages.SingFilter + "：");
		
		filterKhBtn = new Button(baseRoleComposite, SWT.CHECK);
		filterKhBtn.setText(Messages.SingFilterTitle);
		
		Label preTitleLabel = new Label(baseRoleComposite, SWT.NONE);
		preTitleLabel.setLayoutData(new GridData(SWT.RIGHT, SWT.TOP, false, false, 1, 2));
		preTitleLabel.setText(Messages.SingStartContent + "：");
		
		Label preTips = new Label(baseRoleComposite, SWT.WRAP);
		preTips.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		preTips.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		preTips.setText(Messages.Tips_singStartContent);
		
		singPrefixText = new Text(baseRoleComposite, SWT.BORDER | SWT.WRAP | SWT.MULTI | SWT.V_SCROLL);
		singPrefixText.setTextLimit(1000);
		GridData gd_singPrefixText = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_singPrefixText.heightHint = 50;
		singPrefixText.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		singPrefixText.setLayoutData(gd_singPrefixText);
		
		Label suffixTitleLabel = new Label(baseRoleComposite, SWT.NONE);
		suffixTitleLabel.setLayoutData(new GridData(SWT.RIGHT, SWT.TOP, false, false, 1, 2));
		suffixTitleLabel.setText(Messages.SingEndContent + "：");
		
		Label suffixTips = new Label(baseRoleComposite, SWT.WRAP);
		suffixTips.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		suffixTips.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		suffixTips.setText(Messages.Tips_singEndContent);
		
		singSuffixText = new Text(baseRoleComposite, SWT.BORDER | SWT.WRAP | SWT.MULTI | SWT.V_SCROLL);
		singSuffixText.setTextLimit(1000);
		singSuffixText.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		GridData gd_singSuffixText = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_singSuffixText.heightHint = 50;
		singSuffixText.setLayoutData(gd_singSuffixText);
		Label ssLabel = new Label(baseRoleComposite, SWT.NONE);
		ssLabel.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		ssLabel.setText(Messages.SingReplace + "：");
		
		Label filterChar = new Label(baseRoleComposite, SWT.CHECK);
		filterChar.setForeground(ColorConstants.NOTE_TIPS_COLOR);
		filterChar.setText(Messages.Tips_singReplace);
		
		Label label_4 = new Label(baseRoleComposite, SWT.NONE);
		label_4.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		
		fileText = new Text(baseRoleComposite, SWT.BORDER | SWT.WRAP | SWT.MULTI);
		fileText.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		fileText.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridData gd_fileText = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_fileText.heightHint = 40;
		fileText.setLayoutData(gd_fileText);
		
		Composite composite_2 = new Composite(composite, SWT.NONE);
		composite_2.setLayout(new GridLayout(1, false));
		composite_2.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		
		EButton saveBtn = new EButton(composite_2, SWT.NONE);
		saveBtn.setBorderColor(ColorConstants.SKIN_BG);
		saveBtn.setBackground(ColorConstants.SKIN_BG);
		saveBtn.setForeground(ColorConstants.SKIN_FOREGROUND);
		saveBtn.setActiveBorderColor(ColorConstants.SKIN_ACTIVE_BG);
		saveBtn.setActiveBgColor(ColorConstants.SKIN_ACTIVE_BG);
		saveBtn.setActiveForeground(ColorConstants.SKIN_ACTIVE_FOREGROUND);
		saveBtn.setArcWidth(6);
		saveBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				saveConfigAction();
			}
		});
		saveBtn.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		GridData gd_savebutton_1 = new GridData(SWT.CENTER, SWT.FILL, true, true, 1, 1);
		gd_savebutton_1.heightHint = 35;
		gd_savebutton_1.widthHint = 200;
		saveBtn.setLayoutData(gd_savebutton_1);
		saveBtn.setText(Messages.Button_save);
		
		init();
		createContents();
	}
	
	/**
	 * @Description: 初始化界面
	 * @author guoyr
	 */
	private void init(){
		if(null == configProperties){
			configProperties = PropertiesUtils.getProperties("config.properties");
		}
		singBidPriceLimitNameText.addModifyListener(new ModifyListener() {
			public void modifyText(ModifyEvent arg0) {
				if(singBidPriceLimitNameText.getText().trim().length() == 0){
					singBidPriceLimitNameText.setText(Messages.BiddingControlPrice);
				}
			}
		});
		singBidPriceLimitBtn.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				if(singBidPriceLimitBtn.getSelection() && null == tenderProjectEntity.getBidPriceLimit()){
					MessageDialog.openShortMessage(MessageFormat.format(Messages.Tips_notSetFormat, Messages.BiddingControlPrice));
					singBidPriceLimitBtn.setSelection(false);
				}
				singBidPriceLimitNameText.getParent().setEnabled(singBidPriceLimitBtn.getSelection());
			}
		});
		
		// 唱标语速
		speed = Integer.parseInt(configProperties.getProperty(ConfigConstants.SPEED, "0"));
		filterKhBtn.setSelection(configProperties.getProperty(ConfigConstants.FILTER_BRACKET_CONTENT, "00").equals("01"));
		signTenderName.setSelection(configProperties.getProperty(ConfigConstants.SING_TENDERNAME, "00").equals("01"));
		sealSituation_btn.setSelection(configProperties.getProperty(ConfigConstants.SEAL_SITUATION, "01").equals("01"));
		
		Object signBidPriceLimitName = tenderProjectRuleEntity.getParamByKey(ProjectRuleEnum.PARAM_PRICE_LIMIT_NAME);
		if(null != signBidPriceLimitName && signBidPriceLimitName.toString().length() > 0){
			singBidPriceLimitNameText.setText(signBidPriceLimitName.toString());
		}else {
			singBidPriceLimitNameText.setText(Messages.BiddingControlPrice);
		}
		Object signBidPriceLimit = tenderProjectRuleEntity.getParamByKey(ProjectRuleEnum.PARAM_SIGN_BID_PRICE_LIMIT);
		if(null != signBidPriceLimit && signBidPriceLimit.toString().equals("01")){
			singBidPriceLimitBtn.setSelection(true);
		}else {
			singBidPriceLimitBtn.setSelection(false);
		}
		singBidPriceLimitBtn.notifyListeners(SWT.Selection, null);
		
		fileText.setText(configProperties.getProperty(ConfigConstants.FILTER_CHAR, "0"));
		scale.setSelection(speed+10);
		speekRateLabel.setText(Messages.SpeechRate + "：\r\n( "+speed+" )"); 
		scale.addListener(SWT.Selection, new Listener() { 
			public void handleEvent(Event event) { 
				speed = scale.getSelection() - 10;
				speekRateLabel.setText(Messages.SpeechRate + "：\r\n( "+speed+" )"); 
				
			} 
		});
//		WidgetUtils.setRadioChecked(priceUtinComposite, null != tenderProjectRuleEntity.getPriceUnitType()?tenderProjectRuleEntity.getPriceUnitType():CommonEnum.YUAN);
		
	}
	
	public TenderProjectRuleEntity getProjectRule() {
		return tenderProjectRuleEntity;
	}

	protected void createContents() {
		setText("");
		setSize(700, 500);
//		this.setMinimumSize(100, 20);
//		this.pack();

	}

	@Override
	public void open() {
//		this.pack();
		SwtUtils.setCenter(getShell());
		super.open();
	}

	/**
	 * @Description: 
	 * @author guoyr
	 */
	private void saveConfigAction() {
		PropertiesUtils.setPropertyValue(ConfigConstants.SPEED, speed+"");
		String[] params = new String[]{"id","params"};
		if(singBidPriceLimitBtn.getSelection()){
			tenderProjectRuleEntity.setParam(ProjectRuleEnum.PARAM_SIGN_BID_PRICE_LIMIT, "01");	
			tenderProjectRuleEntity.setParam(ProjectRuleEnum.PARAM_PRICE_LIMIT_NAME, singBidPriceLimitNameText.getText().trim());	
		}else {
			tenderProjectRuleEntity.setParam(ProjectRuleEnum.PARAM_SIGN_BID_PRICE_LIMIT, null);	
		}
//		String priceUnit = ObjectUtils.getObjString(WidgetUtils.getRadioVal(priceUtinComposite));
		ProjectRuleService projectRuleService = new ProjectRuleService();
//		if(!ObjectUtils.equals(tenderProjectRuleEntity.getPriceUnitType(), priceUnit)){
//			tenderProjectRuleEntity.setPriceUintType(priceUnit);
//			params = new String[]{"id","params", "priceUint"};
//			projectRuleService.updateAssignProperty(tenderProjectRuleEntity, params);
//		}
		projectRuleService.updateAssignProperty(tenderProjectRuleEntity, params);
		
		PropertiesUtils.setPropertyValue(ConfigConstants.FILTER_BRACKET_CONTENT, filterKhBtn.getSelection()?"01" : "00");
		PropertiesUtils.setPropertyValue(ConfigConstants.FILTER_CHAR, fileText.getText().trim());
		PropertiesUtils.setPropertyValue(ConfigConstants.SING_TENDERNAME, signTenderName.getSelection() ? "01" : "00");
		PropertiesUtils.setPropertyValue(ConfigConstants.SEAL_SITUATION, sealSituation_btn.getSelection() ? "01" : "00");
		configProperties.put(ConfigConstants.FILTER_BRACKET_CONTENT, filterKhBtn.getSelection()?"01" : "00");
		configProperties.put(ConfigConstants.FILTER_CHAR, fileText.getText().trim());
		configProperties.put(ConfigConstants.SING_TENDERNAME, signTenderName.getSelection()?"01" : "00");
		configProperties.put(ConfigConstants.SEAL_SITUATION, sealSituation_btn.getSelection()?"01" : "00");
		PropertiesUtils.saveProperties(configProperties);
		getShell().close();
		if(null != callBack){
			callBack.callBackObject(tenderProjectRuleEntity);
		}
	}

	@Override
	protected void checkSubclass() {
	}
}
