package com.gx.obe.opening.shell;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.listener.RoundBorderLineListener;
import org.eclipse.swt.core.widgets.EButton;
import org.eclipse.swt.core.widgets.ImageButton;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;

import com.gx.obe.ColorConstants;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.config.ConfigConstants;
import com.gx.obe.config.utils.PropertiesUtils;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

public class OpeningTipsShell extends Shell {


	private Listener deactivateListener;
	private Button noTipsAgainBtn;

	/**
	 * Create the shell.
	 * @param display
	 */
	public OpeningTipsShell(Shell parentShell) {
		super(parentShell, SWT.NO_TRIM | SWT.TRANSPARENT);
		GridLayout gridLayout = new GridLayout(3, false);
		gridLayout.marginWidth = 1;
		gridLayout.marginHeight = 1;
		setLayout(gridLayout);
//		this.setBackground(ColorConstants.SKIN_BG);
//		this.setBackgroundMode(SWT.INHERIT_FORCE);
		this.addPaintListener(new RoundBorderLineListener(ColorConstants.SKIN_BG));
		ImageButton tipsIco = new ImageButton(this, SWT.NONE);
//		tipsIco.setSurroundColor(ColorConstants.SKIN_FOREGROUND);
//		tipsIco.setSurroundMargin(5);
		tipsIco.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1));
		tipsIco.setText("");
		tipsIco.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/tips_blue.png"));
		
		Label tips = new Label(this, SWT.NONE);
		tips.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1));
		tips.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		tips.setForeground(ColorConstants.FONT_BLUE_COLOR);
		tips.setText("请您按照以下箭头所示顺序和相关提示，结合业务进度，逐步进行开标操作！");
		
		Composite composite = new Composite(this, SWT.NONE);
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		composite.setLayout(new GridLayout(2, false));
		
		noTipsAgainBtn = new Button(composite, SWT.CHECK);
		noTipsAgainBtn.setText("不在提示");
		
		EButton iKnowBtn = new EButton(composite, SWT.NONE);
		iKnowBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				if(noTipsAgainBtn.getSelection()) {
					PropertiesUtils.saveProperty(ConfigConstants.SHOW_OPENING_TIPS, "00");
				}
				close();
			}
		});
		iKnowBtn.setText("我知道了");
		
		
		
		init();
		createContents();
	}
	
	private void init() {
		addDisposeListener(new DisposeListener() {
			public void widgetDisposed(DisposeEvent e) {
				removeListener(SWT.Deactivate, deactivateListener);
			}
		});
		deactivateListener = new Listener(){
			@Override
			public void handleEvent(Event arg0) {
				close();
			}
		};
		
		addListener(SWT.Deactivate, deactivateListener);
	}

	/**
	 * Create contents of the shell.
	 */
	protected void createContents() {
		setText("SWT Application");
		setSize(458, 29);

	}

	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}

}
