package com.gx.obe.opening.shell;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseTrackAdapter;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;

import com.gx.obe.ColorConstants;
import com.gx.obe.common.widget.composite.PageFoodComposite;
import com.gx.obe.common.widget.composite.PageFoodComposite.PageListener;
import com.gx.obe.common.widget.listener.SelectionTenderPackListener;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.service.TenderProjectService;
import com.swtdesigner.SWTResourceManager;

public class SelectSingBidTenderPackShell extends Shell {

	private ScrolledComposite scrolledComposite;
	private Composite contentComposite;
	private PageFoodComposite pageFoodComposite;
	public static int PAGE_SIZE = 6;
	public static int CUR_PAGE_NO = 1;
	private TenderProjectService tenderProjectService;
	private String curPackId;
	private String parentId;
	private Listener deactivateListener;
	private SelectionTenderPackListener listener;
	
	/**
	 * Create the shell.
	 * @param display
	 */
	public SelectSingBidTenderPackShell(Shell shell, String parentId, String curPackId, SelectionTenderPackListener listener) {
		super(shell, SWT.NO_TRIM);
		setBackground(ColorConstants.SKIN_BG);
		this.parentId = parentId;
		this.curPackId = curPackId;
		this.listener = listener;
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.marginHeight = 1;
		gridLayout.marginWidth = 1;
		setLayout(gridLayout);
		addDisposeListener(new DisposeListener() {
			public void widgetDisposed(DisposeEvent arg0) {
				removeListener(SWT.Deactivate, deactivateListener);
			}
		});
		Composite composite = new Composite(this, SWT.NONE);
		composite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
//		composite.setBackground(SWTResourceManager.getColor(176, 215, 232));
		composite.setLayout(new GridLayout(1, false));
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		scrolledComposite = new ScrolledComposite(composite, SWT.NONE | SWT.H_SCROLL | SWT.V_SCROLL);
		scrolledComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		scrolledComposite.setExpandHorizontal(true);
		scrolledComposite.setExpandVertical(true);
		
		contentComposite = new Composite(scrolledComposite, SWT.NONE);
		contentComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_contentComposite = new GridLayout(1, false);
		gl_contentComposite.marginWidth = 5;
		gl_contentComposite.marginHeight = 5;
		gl_contentComposite.verticalSpacing = 0;
		contentComposite.setLayout(gl_contentComposite);
		
		scrolledComposite.setContent(contentComposite);
		scrolledComposite.setMinSize(contentComposite.computeSize(SWT.DEFAULT, SWT.DEFAULT));
		
		pageFoodComposite = new PageFoodComposite(composite, SWT.NONE);
		pageFoodComposite.setBackgroundMode(SWT.INHERIT_FORCE);
		pageFoodComposite.setBackground(SWTResourceManager.getColor(255, 255, 255));
		pageFoodComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		tenderProjectService = new TenderProjectService();
		createContents();
		init();
	}
	
	private void init(){
		this.setAlpha(220);
		deactivateListener = new Listener(){
			public void handleEvent(Event arg0) {
				close();
			}
		};
		
		addListener(SWT.Deactivate, deactivateListener);
		
		pageFoodComposite.addPageListener(new PageListener(){
			public void changed(int pageNo, int pageSize) {
				queryProjectPage(pageNo);
			}
		});
		queryProjectPage(CUR_PAGE_NO);
		scrolledComposite.getVerticalBar().setIncrement(15);
		scrolledComposite.forceFocus();
		scrolledComposite.addListener(SWT.Activate, new Listener() {
	        public void handleEvent(Event e) {
	            scrolledComposite.forceFocus();
	        }
	    });
	}
	
	/**
	 * @Description: 刷新投标项目列表
	 * @author guoyr
	 */
	private void queryProjectPage(int pageNo) {
		CUR_PAGE_NO = pageNo;
		for(Control control : contentComposite.getChildren()){
			control.dispose();
		}
		com.gx.obe.web.entity.Page<TenderProjectEntity> projectPage = tenderProjectService.getSignBidTenderPackagePageList(parentId, CUR_PAGE_NO, PAGE_SIZE);
		if(null != projectPage && null != projectPage.getRecords()){
			int index = 0;
			for(TenderProjectEntity packMap : projectPage.getRecords()){
				String tenderId = packMap.getId();
				if(null !=curPackId && tenderId.equals(curPackId)){
					continue;
				}
				createTrComposite(packMap, index++);
			}
			pageFoodComposite.refreshPages(projectPage);
		}
		contentComposite.layout();
		scrolledComposite.setMinSize(contentComposite.computeSize(SWT.DEFAULT, SWT.DEFAULT));
		scrolledComposite.forceFocus();
//		Composite trComposite = new Composite(contentComposite, SWT.NONE);
//		GridData gd_trComposite = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
//		trComposite.setLayoutData(gd_trComposite);
//		trComposite.setBackground(SWTResourceManager.getColor(255, 255, 255));
	}

	private Composite createTrComposite(TenderProjectEntity packMap, final int index){
		final TenderProjectEntity tenderPack = packMap;
		tenderPack.setParentId(parentId);
		final Composite tenderPackCoposite = new Composite(contentComposite, SWT.NONE);
		if(index % 2 == 0){
			tenderPackCoposite.setBackground(ColorConstants.ENENT_LINE_COLOR);
		}else {
			tenderPackCoposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		}
//		tenderPackCoposite.setBackground(SWTResourceManager.getColor(60, 138, 226));
		tenderPackCoposite.setBackgroundMode(SWT.INHERIT_FORCE);
		tenderPackCoposite.setLayout(new GridLayout(2, false));
		tenderPackCoposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		final Label tenderNoLabel = new Label(tenderPackCoposite, SWT.NONE);
		tenderNoLabel.setFont(SWTResourceManager.getFont("微软雅黑", 11, SWT.NORMAL));
		tenderNoLabel.setForeground(SWTResourceManager.getColor(100, 100, 100));
		tenderNoLabel.setText("["+tenderPack.getTenderNo()+"]");
		
		final Label tenderNameLabel = new Label(tenderPackCoposite, SWT.WRAP);
		tenderNameLabel.setForeground(ColorConstants.FONT_BLACK_COLOR);
		tenderNameLabel.setFont(SWTResourceManager.getFont("微软雅黑", 11, SWT.NORMAL));
		tenderNameLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		tenderNameLabel.setText(tenderPack.getTenderName());
		
		ESepator sep = new ESepator(tenderPackCoposite, SWT.NONE);
		sep.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 2, 1));
		sep.setLineStyle(SWT.LINE_DOT);
		
		MouseTrackAdapter mouseTrackAdapter = new MouseTrackAdapter() {
			public void mouseEnter(MouseEvent e) {
				tenderPackCoposite.setBackground(ColorConstants.SKIN_BG);
				tenderNoLabel.setCursor(SWTResourceManager.getCursor(SWT.CURSOR_HAND));
				tenderNameLabel.setCursor(SWTResourceManager.getCursor(SWT.CURSOR_HAND));
				tenderNoLabel.setForeground(ColorConstants.SKIN_FOREGROUND);
				tenderNameLabel.setForeground(ColorConstants.SKIN_FOREGROUND);
			}
			public void mouseExit(MouseEvent e) {
				tenderNoLabel.setCursor(null);
				tenderNameLabel.setCursor(null);
				tenderNoLabel.setForeground(SWTResourceManager.getColor(100, 100, 100));
				tenderNameLabel.setForeground(ColorConstants.FONT_BLACK_COLOR);
				if(index % 2 == 0){
					tenderPackCoposite.setBackground(ColorConstants.ENENT_LINE_COLOR);
				}else {
					tenderPackCoposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
				}
			}
		};
		MouseAdapter mouseAdapter = new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				if(null != listener){
					getShell().close();
					listener.selectPack(tenderPack);
				}
			}
		};
		tenderNoLabel.addMouseListener(mouseAdapter);
		tenderNameLabel.addMouseListener(mouseAdapter);

		
		tenderPackCoposite.addMouseTrackListener(mouseTrackAdapter);
		tenderNoLabel.addMouseTrackListener(mouseTrackAdapter);
		tenderNameLabel.addMouseTrackListener(mouseTrackAdapter);
		
		return tenderPackCoposite;
	}
	/**
	 * Create contents of the shell.
	 */
	protected void createContents() {
		setText("SWT OpeningApplication");
		setSize(500, 300);

	}

	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}
}
