package com.gx.obe.opening.shell;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStreamReader;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.utils.SwtUtils;
import org.eclipse.swt.core.widgets.EButton;
import org.eclipse.swt.core.widgets.ECombo;
import org.eclipse.swt.core.widgets.ELabel;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.core.widgets.ImageButton;
import org.eclipse.swt.events.ControlAdapter;
import org.eclipse.swt.events.ControlEvent;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.events.TraverseEvent;
import org.eclipse.swt.events.TraverseListener;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

import com.gx.obe.common.file.enumeration.FileConstants;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.message.Messages;
import com.gx.obe.opening.Activator;
import com.gx.obe.opening.thread.SendNoticeThread;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

import common.Logger;

public class SendBidOpeningNoticeShell{

	protected Object result;
	protected Shell shell;
	private Composite top_composite;
	private ELabel label;
	private Text noticeText;
	private EButton sendBtn;
	private SendNoticeThread sendNoticeThread;	
	private Text history_messgae_text;
	private SimpleDateFormat format = new SimpleDateFormat("yyyy年MM月dd日 HH:mm:ss");
	private ECombo combo;
	String filePath = FileConstants.PRODUCT_ROOT+File.separator+"commonNote.txt";
	private TenderProjectEntity tenderProjectEntity;
	private StringBuilder sendMessage = new StringBuilder();
	private Logger LOG = Logger.getLogger(SendBidOpeningNoticeShell.class);
	private Image loginBgImage;
	private Composite sendForm_compoite;
	private Composite op_composite;
	private Composite bottom_composite;

	/**
	 * Open the dialog.
	 * @return the result
	 */
	public Object open() {
		createContents();
		shell.open();
		shell.layout();
		Display display = Display.getDefault();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch()) {
				display.sleep();
			}
		}
		return result;
	}
	public SendBidOpeningNoticeShell(TenderProjectEntity tenderProjectEntity){
		this.tenderProjectEntity = tenderProjectEntity;
	} 
	/**
	 * Create contents of the dialog.
	 * @wbp.parser.entryPoint
	 */
	private void createContents() {
		shell = new Shell(SWT.NO_TRIM);
		shell.addDisposeListener(new DisposeListener() {
			public void widgetDisposed(DisposeEvent arg0) {
				if(null != loginBgImage && !loginBgImage.isDisposed()){
					loginBgImage.dispose();
					loginBgImage = null;
				}
			}
		});
		shell.setSize(740, 504);
		shell.setText("发送通告");
		shell.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/message.png"));
		GridLayout gl_shell = new GridLayout(1, false);
		gl_shell.horizontalSpacing = 0;
		gl_shell.verticalSpacing = 0;
		gl_shell.marginHeight = 1;
		gl_shell.marginWidth = 1;
		shell.setLayout(gl_shell);
		
		top_composite = new Composite(shell, SWT.NONE | SWT.SELECTED);
		top_composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		top_composite.setBackgroundMode(SWT.INHERIT_FORCE);
		GridLayout gl_top_composite = new GridLayout(3, false);
		gl_top_composite.marginHeight = 2;
		top_composite.setLayout(gl_top_composite);
		
		
		label = new ELabel(top_composite, SWT.NONE);
		label.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/message.png"));
		label.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.NORMAL));
		label.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, false, 1, 1));
		label.setText("发送通告");
		
		ELabel min_size_btn = new ELabel(top_composite, SWT.NONE | SWT.SELECTED);
		min_size_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/min_size.png"));
		min_size_btn.setMargins(5, 5, 5, 5);
		min_size_btn.setActiveColor(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		min_size_btn.setAlpha(10);
		min_size_btn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				shell.setMinimized(true);
			}
		});
		
		ELabel close_btn = new ELabel(top_composite, SWT.NONE | SWT.SELECTED);
		close_btn.setActiveColor(SWTResourceManager.getColor(SWT.COLOR_RED));
		close_btn.setMargins(5, 5, 5, 5);
		close_btn.setAlpha(10);
		close_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/main_close.png"));
		close_btn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				close();
			}
		});
		
		Composite composite = new Composite(shell, SWT.NONE);
//		composite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		composite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		GridLayout gl_composite = new GridLayout(1, false);
		gl_composite.verticalSpacing = 0;
		gl_composite.horizontalSpacing = 0;
		composite.setLayout(gl_composite);
		
		history_messgae_text = new Text(composite, SWT.READ_ONLY | SWT.WRAP | SWT.V_SCROLL);
		history_messgae_text.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		sendForm_compoite = new Composite(composite, SWT.NONE);
		GridLayout gl_sendForm_compoite = new GridLayout(1, false);
		gl_sendForm_compoite.verticalSpacing = 0;
		gl_sendForm_compoite.horizontalSpacing = 0;
		gl_sendForm_compoite.marginHeight = 1;
		gl_sendForm_compoite.marginWidth = 1;
		sendForm_compoite.setLayout(gl_sendForm_compoite);
		sendForm_compoite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		
		op_composite = new Composite(sendForm_compoite, SWT.NONE);
//		composite_5.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_composite_5 = new GridLayout(4, false);
		gl_composite_5.marginWidth = 10;
		op_composite.setLayout(gl_composite_5);
		op_composite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		Label label_1 = new Label(op_composite, SWT.NONE);
//		label_1.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		label_1.setLayoutData(new GridData(SWT.RIGHT, SWT.CENTER, false, false, 1, 1));
		label_1.setText("常用通告：");
		
		combo = new ECombo(op_composite, SWT.READ_ONLY);
		combo.addSelectionListener(new ECombo.ComboSelectoinListener() {
			public void itemSelectoin(String name, Object value, int index) {
				noticeText.setText(name);
				noticeText.forceFocus();
				noticeText.setSelection(noticeText.getText().length());
			}
		});
			
		combo.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		ImageButton label_2 = new ImageButton(op_composite, SWT.NONE);
		label_2.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				configMessage();
			}
		});
		label_2.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/config.png"));
		label_2.setToolTipText("设置常用通告");
		
		ELink button_2 = new ELink(op_composite, SWT.NONE);
		button_2.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				clearMessage();
			}
		});
		button_2.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/delete.png"));
		GridData gd_button_2 = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
		gd_button_2.widthHint = 80;
		button_2.setLayoutData(gd_button_2);
		button_2.setText("清空消息");
		
		noticeText = new Text(sendForm_compoite, SWT.WRAP | SWT.V_SCROLL);
		noticeText.setTopIndex(8);
		noticeText.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		noticeText.setForeground(SWTResourceManager.getColor(SWT.COLOR_DARK_GREEN));
		GridData gd_noticeText = new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1);
		gd_noticeText.heightHint = 114;
		noticeText.setLayoutData(gd_noticeText);
		
		bottom_composite = new Composite(shell, SWT.NONE);
		bottom_composite.setBackgroundMode(SWT.INHERIT_FORCE);
		GridLayout gl_composite_4 = new GridLayout(2, false);
		bottom_composite.setLayout(gl_composite_4);
		bottom_composite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		
		
		sendBtn = new EButton(bottom_composite, SWT.NONE);
		sendBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				sendMessageAction();
			}
		});
		GridData gd_button = new GridData(SWT.RIGHT, SWT.CENTER, true, true, 1, 1);
		gd_button.widthHint = 80;
		sendBtn.setLayoutData(gd_button);
		sendBtn.setText(Messages.Button_send);
		sendBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/send.png"));
		
		EButton cancel_btn = new EButton(bottom_composite, SWT.NONE);
		cancel_btn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				close();
			}
		});
		GridData gd_button_1 = new GridData(SWT.LEFT, SWT.CENTER, false, false, 1, 1);
		gd_button_1.widthHint = 80;
		cancel_btn.setLayoutData(gd_button_1);
		cancel_btn.setText(Messages.Button_cancel);
		cancel_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/close.png"));
		init();
	}
	
	/**
	 * @Description: 初始化
	 * @author guoyr 
	 */
	private void init(){
		combo.setBorderColor(SWTResourceManager.getColor(203, 213, 222));
		SwtUtils.setMouseDragListener(top_composite, true);
		SwtUtils.setCenter(shell);
		setComboDate(readTxt());
		final Runnable sendNoticeRunnable = new Runnable(){
			public void run(){
				if(!history_messgae_text.isDisposed()){
					history_messgae_text.setText(sendMessage.toString());
					history_messgae_text.setSelection(history_messgae_text.getText().length());
				}
			}
		};
		sendNoticeRunnable.run();
		sendNoticeThread = new SendNoticeThread(tenderProjectEntity, "", new SendNoticeThread.SendListener() {
			public void sendMessage(boolean sendFlag, Date sendTime, String message) {
				if(sendFlag){
					sendMessage.append(format.format(sendTime));
				}else {
					sendMessage.append(format.format(sendTime) +"  [消息发送失败]");
				}
				sendMessage.append("\r\n      ");
				sendMessage.append(message);
				sendMessage.append("\r\n");
				Display.getDefault().asyncExec(sendNoticeRunnable);
			}
		});
		sendNoticeThread.start();
		// 加入加回车事件
		noticeText.addTraverseListener(new TraverseListener() {
			public void keyTraversed(TraverseEvent e) {
				if(e.keyCode == 13 || e.keyCode == 16777296){
					sendMessageAction();
				}
			}
		});
		shell.addControlListener(new ControlAdapter() {

			@Override
			public void controlResized(ControlEvent e) {
				shell.addPaintListener(new PaintListener() {
					public void paintControl(PaintEvent arg0) {
						shell.removePaintListener(this);
						if(null != loginBgImage && !loginBgImage.isDisposed()){
							loginBgImage.dispose();
							loginBgImage = null;
						}
						loginBgImage = new Image(null, shell.getBounds().width, shell.getBounds().height);
						GC gc = new GC(loginBgImage);
						Image bgImage = ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/bg_01.jpg");
						gc.setAlpha(240);
						gc.drawImage(bgImage, 0, 0, bgImage.getBounds().width, bgImage.getBounds().height, 0, 0, shell.getBounds().width, shell.getBounds().height);
						
						gc.setForeground(SWTResourceManager.getColor(249, 250, 252));
						gc.setBackground(SWTResourceManager.getColor(60, 138, 226));
						gc.setAlpha(-1);
						gc.fillGradientRectangle(0, 0, shell.getBounds().width, top_composite.getBounds().height, false);
						
						Point sendFormPoint = Display.getDefault().map(sendForm_compoite, shell , 0,0);
						gc.setForeground(SWTResourceManager.getColor(203, 213, 222));
						gc.setBackground(SWTResourceManager.getColor(241, 245, 248));
						gc.setAlpha(-1);
						gc.fillGradientRectangle(0, sendFormPoint.y, shell.getBounds().width, op_composite.getBounds().height, true);
						
						Point bottomFormPoint = Display.getDefault().map(bottom_composite, shell , 0,0);
						gc.setAlpha(100);
						gc.setForeground(SWTResourceManager.getColor(241, 245, 248));
						gc.setBackground(SWTResourceManager.getColor(233, 213, 222));
						gc.fillGradientRectangle(0, bottomFormPoint.y, shell.getBounds().width, bottom_composite.getBounds().height, true);
//						gc.setForeground(SWTResourceManager.getColor(232, 236, 239));
//						gc.drawLine(0, bottomFormPoint.y, shell.getBounds().width, bottomFormPoint.y);
						gc.drawRectangle(0, 0, shell.getBounds().width -1, shell.getBounds().height -1);
						shell.setBackgroundImage(loginBgImage);
						shell.setBackgroundMode(SWT.INHERIT_FORCE);
						gc.dispose();
					}
				});
				
			}
		});
		noticeText.forceFocus();
	}
	
	/**
	 * @Description:设置下拉选数据 
	 * @author guoyr
	 * @param commonNoteList 
	 */
	private void setComboDate(List<String> commonNoteList){
		combo.removeAll();
		for(int i = 0; i < commonNoteList.size(); i++){
			String text = commonNoteList.get(i);
			combo.addItem(text, text);
		}
	}
	
	/**
	 * @Description: 发送消息内容
	 * @author guoyr 
	 */
	private void sendMessageAction(){
		if(sendBtn.getEnabled()){
			if(noticeText.getText().trim().length() > 0){
				String message = noticeText.getText();
				noticeText.setText("");
				sendNoticeThread.sendNotice(message);
			}else {
				MessageDialog.openShortMessage("请输入发送内容！");
			}
		}
	}
	
	/**
	 * @Description: 清空消息
	 * @author guoyr 
	 */
	private void clearMessage(){
		history_messgae_text.setText("");
		history_messgae_text.setSelection(0);
	}
	
	/**
	 * @Description: 获取常用通告
	 * @author guoyr 
	 */
	private List<String> readTxt(){
		List<String> commonNoteList = new ArrayList<String>();
		File file = new File(filePath);//Text文件
		BufferedReader br = null;
		try {
			br = new BufferedReader(new InputStreamReader(
					new FileInputStream(file), "UTF-8"));
			String lineValue = null;
			while((lineValue = br.readLine())!=null){//使用readLine方法，一次读一行
				commonNoteList.add(lineValue);
			}
		} catch (Exception e) {
			LOG.error("", e);
		}finally{
			if(null != br){
				try {
					br.close();
				} catch (IOException e) {
					LOG.error("", e);
				}
			}
		}
		return commonNoteList;
	}
	
	public void active(){
		if(null != shell && !shell.isDisposed()){
			shell.setVisible(true);
			shell.setMinimized(false);
			shell.forceActive();
			noticeText.forceFocus();
		}
	}
	
	public boolean isDisposed(){
		return shell.isDisposed();
	}
	
	public void close(){
		if(null != shell && !shell.isDisposed()){
			shell.close();
		}
	}
	/**
	 * @Description: 配置常用通告消息
	 * @author guoyr 
	 */
	private void configMessage(){
		ConfigNoteMessageDialog dialog = new ConfigNoteMessageDialog();
		dialog.open();
		setComboDate(readTxt());
	}
}
