package com.gx.obe.opening.shell;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.utils.SwtUtils;
import org.eclipse.swt.core.widgets.ImageButton;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;

import com.gx.obe.ColorConstants;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.message.Messages;
import com.gx.obe.opening.composite.SendBidOpeningMessageComposite;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

public class SendMessageDialog  extends Shell {

	protected Object result;
	private Listener deactivateListener;
	private TenderProjectEntity tenderProjectEntity;
	private String bidopeningStage;
	private String stageIds;
	private SendBidOpeningMessageComposite sendBidOpeningMessageComposite;
	private Label title;

	/**
	 * Create the dialog.
	 * @param parent
	 * @param style
	 */
	public SendMessageDialog(Shell parent, TenderProjectEntity tenderProjectEntity, String bidopeningStage, String stageIds) {
		super(parent, SWT.NO_TRIM | SWT.ON_TOP);
		this.tenderProjectEntity = tenderProjectEntity;
		this.bidopeningStage = bidopeningStage;
		this.stageIds = stageIds;
		setText(Messages.Message);
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.marginWidth = 1;
		gridLayout.verticalSpacing = 1;
		gridLayout.marginHeight = 1;
		setLayout(gridLayout);
		this.setData("tenderProjectEntity", tenderProjectEntity);
		this.setData("bidopeningStage", bidopeningStage);
		
		Composite composite = new Composite(this, SWT.NONE);
		composite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		composite.setLayout(new GridLayout(2, false));
		
		title = new Label(composite, SWT.NONE);
		title.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		title.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		title.setForeground(ColorConstants.FONT_BLACK_COLOR);
		title.setText(Messages.Message);
		
		ImageButton closeBtn = new ImageButton(composite, SWT.NONE);
		closeBtn.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, false, 1, 1));
		closeBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/main_close.png"));
		closeBtn.setArcWidth(5);
		closeBtn.setLeftMargin(5);
		closeBtn.setRightMargin(5);
		closeBtn.setBackgroundColor(SWTResourceManager.getColor(255, 199, 198));
		closeBtn.setBorderColor(SWTResourceManager.getColor(SWT.COLOR_RED));
		closeBtn.setActiveBgColor(SWTResourceManager.getColor(SWT.COLOR_RED));
		closeBtn.addMouseListener(new MouseAdapter(){
			public void mouseUp(MouseEvent e) {
				hiddenDialog();
			}
			
		});
		sendBidOpeningMessageComposite = new SendBidOpeningMessageComposite(this, SWT.NONE);
		sendBidOpeningMessageComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		createContents();
		init();
	}
	
	private void init(){
		this.setAlpha(200);
		SwtUtils.setMouseDragListener(title);
//		SwtUtils.setCircleRegion(this, 2);
//		SwtUtils.setCircleRegion(composite, 2);
		this.setMinimumSize(400, 300);
//		deactivateListener = new Listener(){
//			public void handleEvent(Event arg0) {
//				hiddenDialog();
////				close();
//			}
//		};
//		addListener(SWT.Deactivate, deactivateListener);
		if(null != sendBidOpeningMessageComposite && !sendBidOpeningMessageComposite.isDisposed()){
			sendBidOpeningMessageComposite.setTenderPackStageIds(stageIds);
		}
//		ScreenUtils screenUtils = new ScreenUtils();
////		Point point = computeSize(SWT.DEFAULT, SWT.DEFAULT);
////		setSize(util.getScreenWight(), point.y); 
////		shell.setLocation((util.getScreenHight() - point.x)/2, util.getScreenHight() - point.y);
//		shell.setLocation((screenUtils.getScreenWight() - this.getBounds().width), screenUtils.getScreenHight() -  this.getBounds().height - 40);
	}
	
	public void hiddenDialog(){
		setMinimized(true);
		setVisible(false);
	}
	
	public void showDialog(){
		setMinimized(false);
		setVisible(true);
	}
	/**
	 * Create contents of the shell.
	 */
	protected void createContents() {
		setText("");
		setSize(400, 300);
	}
	
	
	@Override
	public void close() {
//		removeListener(SWT.Deactivate, deactivateListener);
		super.close();
	}
	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}
	
}

