package com.gx.obe.opening.shell;

import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Optional;
import java.util.stream.IntStream;
import java.util.stream.Stream;

import org.eclipse.nebula.widgets.grid.Grid;
import org.eclipse.nebula.widgets.grid.GridColumn;
import org.eclipse.nebula.widgets.grid.GridColumnGroup;
import org.eclipse.nebula.widgets.grid.GridItem;
import org.eclipse.nebula.widgets.grid.listener.GridSelectionListener;
import org.eclipse.swt.SWT;
import org.eclipse.swt.core.ImageResolver;
import org.eclipse.swt.core.MessageDialog;
import org.eclipse.swt.core.utils.SwtUtils;
import org.eclipse.swt.core.utils.WidgetUtils;
import org.eclipse.swt.core.widgets.ELabel;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.core.widgets.EMenu;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.core.widgets.ImageButton;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.custom.StackLayout;
import org.eclipse.swt.events.ControlAdapter;
import org.eclipse.swt.events.ControlEvent;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Cursor;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;

import com.gx.obe.ColorConstants;
import com.gx.obe.action.bean.Action;
import com.gx.obe.bpt.entity.BidPriceTable;
import com.gx.obe.bpt.entity.BidPriceTableItem;
import com.gx.obe.bpt.entity.BidPriceTableTitle;
import com.gx.obe.bpt.service.BidPriceTableService;
import com.gx.obe.business.entity.MenuFunction;
import com.gx.obe.business.enumeration.MenuEnum;
import com.gx.obe.business.enumeration.ProjectRuleEnum;
import com.gx.obe.common.dialog.BidOpeningReportDialog;
import com.gx.obe.common.dialog.GridResizeDialog;
import com.gx.obe.common.dialog.UploadOpenBiddingResultAndFileDialog;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.listener.SelectionTenderPackListener;
import com.gx.obe.common.widget.shell.ToolsShell;
import com.gx.obe.common.widget.utils.MenuFunctionUtils;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.I18NEnum;
import com.gx.obe.components.core.enumeration.BidPriceEnum;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.components.core.util.MoneyUtils;
import com.gx.obe.config.ConfigConstants;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.listener.ProjectRuleListener;
import com.gx.obe.message.Messages;
import com.gx.obe.opening.Activator;
import com.gx.obe.opening.composite.BidOpeningRuleComposite;
import com.gx.obe.opening.dialog.DownLoadBidFileOnLineWindow;
import com.gx.obe.opening.dialog.ViewBidFilesDialog;
import com.gx.obe.opening.widgets.BidopeningOpBigButton;
import com.gx.obe.opening.widgets.BidopeningOpButton;
import com.gx.obe.report.composite.EvaluationReportComposite;
import com.gx.obe.report.dialog.EvaluationReportDialog;
import com.gx.obe.template.enumeration.TemplateTypeEnum;
import com.gx.obe.util.utils.ColumnAlignmentUtils;
import com.gx.obe.util.utils.Keys;
import com.gx.obe.util.utils.ObjectUtils;
import com.gx.obe.util.utils.StringUtils;
import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.SupplierOpeningResult;
import com.gx.obe.web.entity.auth.Menu;
import com.gx.obe.web.entity.price.BidPrice;
import com.gx.obe.web.entity.price.BidPriceResult;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.entity.tender.TenderProjectRuleEntity;
import com.gx.obe.web.service.BidPriceResultService;
import com.gx.obe.web.service.BidPriceService;
import com.gx.obe.web.service.MenuService;
import com.gx.obe.web.service.ProjectRuleService;
import com.gx.obe.web.service.SupplierService;
import com.gx.obe.web.service.TenderProjectService;
import com.gx.tools.tts.ITTS;
import com.gx.tools.tts.TTSEnginUtil;
import com.gx.tools.utils.BidPriceUtils;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

public class SingBidShell extends Shell {

	private final BidPriceTableService bidPriceTableService = new BidPriceTableService();
	
	private ImageResolver imageResolver = new ImageResolver();
	private TenderProjectService tenderProjectService ;
	private ProjectRuleService projectRuleService;
	private TenderProjectEntity curTenderPack;
	private TenderProjectEntity tenderProjectEntity;
	private TenderProjectRuleEntity projectRule;
	private Image zoomBgImage;
	private Label projectName;
	private Composite project_composite;
	private Composite decryptMainComposite;
	private Composite progressComposite;
	private PaintListener paintListener;
	private Composite sendMessageComposite;
	private String SUPPLIER_NAME;
	private Image bgImage = ResourceManager.getPluginImage(Activator.PLUGIN_ID,"icons/decrypt_bg.png");
	private Label packName;
	private Composite packageComposite;
	private SelectionTenderPackListener selectionTenderPackListener;
	private BidPriceService bidPriceService ;
	private BidPriceResultService bidPriceResultService ;
	private SupplierService supplierService = new SupplierService();
	// 开标完成后回调
	private List<Supplier> supplierList;
	private Grid supplierGrid;
	private Supplier supplier;
	private Grid supplierBidPriceTableGrid;
	private Grid bidPriceTableTotalGrid;
	private CLabel supplierNameLabel;
	private ImageButton preSupplierBtn;
	private ImageButton nextSupplierBtn;
	private ImageButton singFinishBtn;
	private ImageButton viewPriceFileBtn;
	private Composite openBidViewComposite;
	private StackLayout openBidViewCompositeStaticLayout;
	private ImageButton speakBtn;
	private ITTS tts;
	private boolean isSpeakTTS = false;
	private boolean isStartSpeekContent = false;
	private Color titleColor = SWTResourceManager.getColor(50, 50, 50);
	private Composite singBidPriceContentComposite;
	private ImageButton stopSpeekLabel;
	private int resultFontSize = 12;//默认字体大小10
	private int supplierFontSize = 15;//默认字体大小10
	private ImageButton exportReportBtn;
	private ImageButton uploadReportBtn;
	private ImageButton remoteSignatureBtn;
	private ImageButton configLabel;
	private List<BidPrice> bidPriceList;
	private boolean filterBracketContent = true;
	private ELabel supplierName_label;
	private List<String> singSupplierIdList;
	private BidopeningOpBigButton totalResultBtn;
	private boolean showBidPrice = true;
	private boolean onlyShowPrice = false;
	private Map<String, Integer> bidPriceTableTotalColumnMap;
	private Map<Integer, Integer> bidPriceTableDetailColumnMap;
	private ImageButton selectOnlyShowPriceBtn;
	private Composite top_composite;
	private Composite limitPriceComposite;
	private Label limitPriceLabel;
	private MenuFunctionUtils menuFunctionUtils = new  MenuFunctionUtils();
	private Composite toolsComposite;
	public SingBidShell(Shell parentShell, TenderProjectEntity tenderProjectEntity) {
		super(parentShell, SWT.NO_TRIM);
		addDisposeListener(new DisposeListener() {
			public void widgetDisposed(DisposeEvent arg0) {
				close();
			}
		});
		setBackgroundMode(SWT.INHERIT_FORCE);
		this.tenderProjectEntity = tenderProjectEntity;
		
		setBackgroundImage(bgImage);
		GridLayout gridLayout = new GridLayout(1, false);
		setLayout(gridLayout);
		
		project_composite = new Composite(this, SWT.NONE);
		project_composite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		GridLayout gl_project_composite = new GridLayout(1, false);
		gl_project_composite.marginTop = 20;
		gl_project_composite.marginWidth = 20;
		gl_project_composite.marginHeight = 0;
		project_composite.setLayout(gl_project_composite);
		
		projectName = new Label(project_composite, SWT.WRAP);
		projectName.setAlignment(SWT.CENTER);
		projectName.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, false, 1, 1));
		projectName.setFont(SWTResourceManager.getFont("微软雅黑", 20, SWT.BOLD));
		projectName.setForeground(SWTResourceManager.getColor(51, 51, 51));
		projectName.setText(Messages.ProjectName);
		
		packageComposite = new Composite(this, SWT.NONE);
		packageComposite.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, true, false, 1, 1));
		GridLayout gl_packageComposite = new GridLayout(2, false);
		packageComposite.setLayout(gl_packageComposite);
		
		packName = new Label(packageComposite, SWT.WRAP);
		packName.setAlignment(SWT.CENTER);
		packName.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		packName.setFont(SWTResourceManager.getFont("微软雅黑", 18, SWT.BOLD));
		packName.setForeground(SWTResourceManager.getColor(100, 100, 100));
		packName.setText("请选择包件");
		
		ELink changePackLink = new ELink(packageComposite, SWT.WRAP);
		changePackLink.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				changeTenderPackAction();
			}
		});
		changePackLink.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		changePackLink.setFont(SWTResourceManager.getFont("微软雅黑", 18, SWT.BOLD));
		changePackLink.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/switch_big.png"));
		changePackLink.setToolTipText(Messages.Button_change);
		
		Composite centerComposite = new Composite(this, SWT.NONE);
		GridLayout gl_centerComposite = new GridLayout(2, false);
		gl_centerComposite.horizontalSpacing = 15;
		gl_centerComposite.marginWidth = 50;
		centerComposite.setLayout(gl_centerComposite);
		centerComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		decryptMainComposite = new Composite(centerComposite, SWT.NONE);
		GridLayout gl_decryptMainComposite = new GridLayout(1, false);
		gl_decryptMainComposite.verticalSpacing = 0;
		gl_decryptMainComposite.horizontalSpacing = 0;
		gl_decryptMainComposite.marginHeight = 10;
		gl_decryptMainComposite.marginWidth = 10;
		decryptMainComposite.setLayout(gl_decryptMainComposite);
		decryptMainComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		top_composite = new Composite(decryptMainComposite, SWT.NONE);
		GridLayout gl_top_composite = new GridLayout(7, false);
		top_composite.setLayout(gl_top_composite);
		top_composite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 3, 1));
		top_composite.setBackground(ColorConstants.SKIN_BG);
		top_composite.setBackgroundMode(SWT.INHERIT_FORCE);
		
		supplierNameLabel = new CLabel(top_composite, SWT.NONE);
		supplierNameLabel.setForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		supplierNameLabel.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/sing.png"));
		supplierNameLabel.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.BOLD));
		supplierNameLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		supplierNameLabel.setText("北京国信创新科技股份有限公司");
		
		selectOnlyShowPriceBtn = new ImageButton(top_composite, SWT.CHECK);
		selectOnlyShowPriceBtn.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.BOLD));
		selectOnlyShowPriceBtn.setForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		selectOnlyShowPriceBtn.setText(Messages.Button_showBidPriceOnly);
		selectOnlyShowPriceBtn.setLayoutData(new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1));
		selectOnlyShowPriceBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/unchecked.png"));
		menuFunctionUtils.addFunction(selectOnlyShowPriceBtn, "SHOW_PRICE_ONLY");
		
		viewPriceFileBtn = createButtonStyle(top_composite);
		viewPriceFileBtn.setText(Messages.Button_original);
		viewPriceFileBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/attachments.png"));
		viewPriceFileBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				viewOpenbidPriceViewAction();
			}
		});
		menuFunctionUtils.addFunction(viewPriceFileBtn, "VIEW_ORIGINAL_FILE");
		
		ImageButton downloadFileButton = createButtonStyle(top_composite);
		downloadFileButton.setText(Messages.Button_downloadDecBidFile);
		downloadFileButton.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				downloadDecFileAction();
			}
		});
		downloadFileButton.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/download.png"));
		menuFunctionUtils.addFunction(downloadFileButton, "DOWNLOAD_DEC_FILE");
		
		ImageButton biggerButton = createButtonStyle(top_composite);
		biggerButton.setCursor(SWTResourceManager.getCursor(SWT.CURSOR_HAND));
		biggerButton.setText(Messages.Button_enlarge);
		biggerButton.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				addFontSize();
			}
		});
		biggerButton.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/enlarge.png"));
		
		ImageButton smallButton = createButtonStyle(top_composite);
		smallButton.setText(Messages.Button_reduce);
		smallButton.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				reduceFontSize();
			}
		});
		smallButton.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/reduce.png"));

		configLabel = createButtonStyle(top_composite);
		configLabel.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/config.png"));
		configLabel.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				configAction();
			}
		});
		configLabel.setText(Messages.Config_moreConfiguration);
		menuFunctionUtils.addFunction(configLabel, "MORE_CONFIG");
		
		limitPriceComposite = new Composite(decryptMainComposite, SWT.NONE);
		GridLayout gl_composite = new GridLayout(2, false);
		gl_composite.marginHeight = 0;
		gl_composite.marginWidth = 0;
		limitPriceComposite.setLayout(gl_composite);
		GridData gd_composite = new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1);
		limitPriceComposite.setLayoutData(gd_composite);
		menuFunctionUtils.addFunction(limitPriceComposite, "LIMIT_PRICE");
		
		CLabel cleanTenderStepName = new CLabel(limitPriceComposite, SWT.NONE);
		cleanTenderStepName.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, true, 1, 1));
		cleanTenderStepName.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		cleanTenderStepName.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/tips_blue.png"));
		cleanTenderStepName.setText("");
		
		limitPriceLabel = new Label(limitPriceComposite, SWT.NONE);
		limitPriceLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		limitPriceLabel.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.BOLD));
		limitPriceLabel.setText("");
		
		openBidViewComposite = new Composite(decryptMainComposite, SWT.NONE);
//		openBidViewComposite.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		openBidViewCompositeStaticLayout = new StackLayout();
		openBidViewComposite.setLayout(openBidViewCompositeStaticLayout);
		openBidViewComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		singBidPriceContentComposite = new Composite(openBidViewComposite, SWT.NONE);
		GridLayout gl_composite_10 = new GridLayout(1, false);
		gl_composite_10.marginWidth = 0;
		gl_composite_10.marginHeight = 0;
		gl_composite_10.verticalSpacing = 0;
		singBidPriceContentComposite.setLayout(gl_composite_10);
		
		bidPriceTableTotalGrid = new Grid(singBidPriceContentComposite, SWT.H_SCROLL | SWT.V_SCROLL);
		bidPriceTableTotalGrid.setHeaderVisible(true);
		bidPriceTableTotalGrid.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		Composite composite_9 = new Composite(openBidViewComposite, SWT.NONE);
		GridLayout gl_composite_9 = new GridLayout(1, false);
		gl_composite_9.verticalSpacing = 0;
		gl_composite_9.marginHeight = 0;
		gl_composite_9.marginWidth = 0;
		composite_9.setLayout(gl_composite_9);
		
		supplierName_label = new ELabel(composite_9, SWT.WRAP | SWT.CENTER);
		supplierName_label.setText("供应商名称");
		supplierName_label.setFont(SWTResourceManager.getFont("微软雅黑", 15, SWT.BOLD));
		supplierName_label.setTopMargin(8);
		supplierName_label.setBottomMargin(8);
		supplierName_label.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		ESepator supplierSep = new ESepator(composite_9, SWT.NONE);
		supplierSep.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
		supplierSep.setBackground(ColorConstants.SEP_LIGHT_COLOR);
		
		supplierBidPriceTableGrid = new Grid(composite_9, SWT.H_SCROLL | SWT.V_SCROLL);
		supplierBidPriceTableGrid.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		supplierBidPriceTableGrid.setItemMinHeight(30);
		GridColumn gridColumn_2 = new GridColumn(supplierBidPriceTableGrid, SWT.RIGHT);
		gridColumn_2.setText("标题");
		gridColumn_2.setWidth(150);
		gridColumn_2.setWordWrap(true);
		
		GridColumn gridColumn_1 = new GridColumn(supplierBidPriceTableGrid, SWT.NONE);
		gridColumn_1.setText("结果");
		gridColumn_1.setWidth(300);
		gridColumn_1.setWordWrap(true);
		
		progressComposite = new Composite(centerComposite, SWT.NONE);
		GridLayout gl_progressComposite = new GridLayout(1, false);
		gl_progressComposite.verticalSpacing = 0;
		gl_progressComposite.horizontalSpacing = 0;
		gl_progressComposite.marginHeight = 0;
		gl_progressComposite.marginWidth = 0;
		progressComposite.setLayout(gl_progressComposite);
		progressComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1));
		
		toolsComposite = new Composite(progressComposite, SWT.NONE);
		toolsComposite.setLayout(new GridLayout(3, true));
		toolsComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		
		BidopeningOpBigButton closeBtn = new BidopeningOpBigButton(toolsComposite, SWT.NONE);
		closeBtn.setBorderColor(null);
		closeBtn.setBackgroundColor(SWTResourceManager.getColor(208, 88, 89));
		closeBtn.setActiveBackgroundColor(SWTResourceManager.getColor(SWT.COLOR_RED));
		closeBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 3, 1));
		closeBtn.setText(Messages.Quit);
		closeBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				exitAction();
			}
		});
		
		speakBtn = new BidopeningOpButton(toolsComposite, SWT.BOTTOM);
		speakBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		speakBtn.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/sing_star.png"));
		speakBtn.setText(Messages.Button_singVoice);
		speakBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				speakTTSAction();
			}
		});
		
		stopSpeekLabel = new BidopeningOpButton(toolsComposite, SWT.BOTTOM);
		stopSpeekLabel.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		stopSpeekLabel.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/sing_stop.png"));
		stopSpeekLabel.setText(Messages.Button_stopSingVoice);
		stopSpeekLabel.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				stopTTS();
			}
		});
		
		singFinishBtn = new BidopeningOpButton(toolsComposite, SWT.NONE);
		singFinishBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		singFinishBtn.setImage(ResourceManager.getPluginImage(Activator.PLUGIN_ID, "icons/sign_complate.png"));
		singFinishBtn.setText(Messages.Button_finishSing);
		singFinishBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				singFinshAction();
			}
		});
		
		totalResultBtn = new BidopeningOpBigButton(toolsComposite, SWT.NONE);
		totalResultBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 3, 1));
		totalResultBtn.setText(Messages.Button_openingRecordTotal);
		totalResultBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				showTotalResultAction();
			}
		});
		
		Composite nextComposite = new Composite(toolsComposite, SWT.NONE);
		GridLayout gl_nextComposite = new GridLayout(2, false);
		gl_nextComposite.marginHeight = 0;
		gl_nextComposite.marginWidth = 0;
		nextComposite.setLayout(gl_nextComposite);
		nextComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 3, 1));
		
		preSupplierBtn = new BidopeningOpBigButton(nextComposite, SWT.NONE);
		preSupplierBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/arrow_up.png"));
		preSupplierBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				previewAction();
			}
		});
		preSupplierBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		preSupplierBtn.setText(Messages.PreviousSupplier);
		
		nextSupplierBtn = new BidopeningOpBigButton(nextComposite, SWT.NONE);
		nextSupplierBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		nextSupplierBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/arrow_down.png"));
		nextSupplierBtn.setText(Messages.NextSupplier);
		nextSupplierBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				nextAction();
			}
		});
		
		exportReportBtn = new BidopeningOpBigButton(toolsComposite, SWT.NONE);
		exportReportBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 3, 1));
		exportReportBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/upload.png"));
		exportReportBtn.setText(Messages.Button_generateOpeningRecordTotal);
		exportReportBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				createOpenbidReport();
			}
		});
		menuFunctionUtils.addFunction(exportReportBtn, "LOCAL_SIGNATURE");
		
		remoteSignatureBtn = new BidopeningOpBigButton(toolsComposite, SWT.NONE);
		remoteSignatureBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 3, 1));
		remoteSignatureBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/signature.png"));
//		remoteSignatureBtn.setText(Messages.Button_remoteSignatureOpeningResult);
		remoteSignatureBtn.setText(Messages.Button_openingListSignature);
		remoteSignatureBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				uploadReport();
			}
		});
		menuFunctionUtils.addFunction(remoteSignatureBtn, "REMOTE_SIGNATURE");
		
		uploadReportBtn = new BidopeningOpBigButton(toolsComposite, SWT.NONE);
		uploadReportBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/white/upload.png"));
		uploadReportBtn.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 3, 1));
		uploadReportBtn.setText(Messages.Button_uploadOpeningResultAndFile);
		uploadReportBtn.addMouseListener(new MouseAdapter() {
			@Override
			public void mouseUp(MouseEvent e) {
				uploadOpeningResultAndFile();
			}
		});
		menuFunctionUtils.addFunction(uploadReportBtn, "UPLOAD_OPENING_RESULT");
		
		sendMessageComposite = new Composite(progressComposite, SWT.NONE);
		GridLayout gl_sendMessageComposite = new GridLayout(1, false);
		gl_sendMessageComposite.marginHeight = 0;
		sendMessageComposite.setLayout(gl_sendMessageComposite);
		GridData gd_sendMessageComposite = new GridData(SWT.FILL, SWT.FILL, false, true, 1, 1);
		gd_sendMessageComposite.heightHint = 300;
		sendMessageComposite.setLayoutData(gd_sendMessageComposite);
		
		supplierGrid = new Grid(sendMessageComposite, SWT.V_SCROLL | SWT.BORDER);
		supplierGrid.addSelectionListener(new SelectionAdapter() {
			@Override
			public void widgetSelected(SelectionEvent e) {
				supplierSelectAction();
			}
		});
		supplierGrid.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		GridColumn gridColumn = new GridColumn(supplierGrid, SWT.NONE);
		gridColumn.setText("New Column");
		gridColumn.setWidth(200);
		gridColumn.setWordWrap(true);
		
		GridItem gridItem = new GridItem(supplierGrid, SWT.NONE);
		gridItem.setBackground(SWTResourceManager.getColor(SWT.COLOR_GRAY));
		gridItem.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.BOLD));
		gridItem.setText("");
		tenderProjectService = new TenderProjectService();
		createContents();
		init();
	}
	
	/**
	 * @Description: 初始化
	 * @author guoyr 
	 */
	private void init(){
		bidPriceService = new BidPriceService();
		bidPriceResultService = new BidPriceResultService();
		projectRuleService = new ProjectRuleService();
		SUPPLIER_NAME = com.gx.obe.components.core.I18N.getString(I18NEnum.SUPPLIERNAME, tenderProjectEntity.getTenderType());
		
//		TenderProjectEntity curTenderPack = null;
		packName.setText("");
		
		curTenderPack = getTenderPackInfo();
		
		selectOnlyShowPriceBtn.setSelectionForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		
		selectionTenderPackListener = new SelectionTenderPackListener(){
			public void selectPack(final TenderProjectEntity tenderPack) {
				// 选择后重新查询一次
				loadTenderPackMan(tenderPack);
			}
		};
		
		
		filterBracketContent  = PropertiesUtils.getProperty(ConfigConstants.FILTER_BRACKET_CONTENT, "00").equals("01");
		
		supplierGrid.setShowEvenBackground(false);
		supplierGrid.setLinesVisible(true);
		supplierGrid.setAutoHeight(true);
		singFinishBtn.setEnabled(false);
		supplierGrid.setItemHeight(50);
		supplierBidPriceTableGrid.setItemHeight(50);
		supplierBidPriceTableGrid.setShowEvenBackground(false);
		supplierBidPriceTableGrid.setAutoHeight(true);
		supplierBidPriceTableGrid.setAutoWidth(true);
		
		bidPriceTableTotalGrid.setItemHeight(50);
		bidPriceTableTotalGrid.setAutoHeight(true);
		bidPriceTableTotalGrid.setShowEvenBackground(false);
		bidPriceTableTotalGrid.setAutoWidth(true);
		bidPriceTableTotalGrid.addListener(SWT.Selection, new GridSelectionListener(){
			@Override
			public void rightMouseButtonDown(GridItem item) {
				menuDetectAction();
			}
		});
		sendMessageComposite.layout();
		
		selectOnlyShowPriceBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				selectOnlyShowPriceAction();
			}
		});
		
		MouseDragListener mouseDragListener = new MouseDragListener(this);
		projectName.addListener(SWT.MouseDown, mouseDragListener);
		projectName.addListener(SWT.MouseUp, mouseDragListener);
		projectName.addListener(SWT.MouseMove, mouseDragListener);
		addListener(SWT.MouseDown, mouseDragListener);
		addListener(SWT.MouseUp, mouseDragListener);
		addListener(SWT.MouseMove, mouseDragListener);
		
		paintListener = new PaintListener() {
			public void paintControl(PaintEvent arg0) {
				drawBg();
			}
		};
		addPaintListener(paintListener);
		addControlListener(new ControlAdapter() {
			public void controlResized(ControlEvent e) {
				addPaintListener(paintListener);
			}
		});
		MenuService menuService = new MenuService();
		final Menu menu = menuService.getMenutByMenuCode(MenuEnum.OPENING_SETTING);
		menuFunctionUtils.initFunctionAuthority(menu);
		if(MenuFunction.SHOW.equals(menuFunctionUtils.getAuthority("UPLOAD_OPENING_RESULT"))){
			WidgetUtils.setControlVisible(uploadReportBtn, true);
		}else {
			WidgetUtils.setControlVisible(uploadReportBtn, false);
		}
		if(TenderProjectEnum.REMOTE.equals(curTenderPack.getRemoteStatus())){
			if(!remoteSignatureBtn.getVisible()) {
				WidgetUtils.setControlVisible(exportReportBtn, true);
			}
		}else {
			WidgetUtils.setControlVisible(remoteSignatureBtn, false);
			// 如果没有显示远程签字确认，则至少显示生成开标一览表
			if(!exportReportBtn.getVisible()) {
				WidgetUtils.setControlVisible(exportReportBtn, true);
			}
		}
		
		toolsComposite.layout();
		progressComposite.layout();
		loadTenderPackMan(curTenderPack);
		this.setMaximized(true);
	}
	
	/**
	 * @Description: 获得唱标包件（标段）
	 * @author guoyr
	 * @return 
	 */
	private TenderProjectEntity getTenderPackInfo(){
		TenderProjectEntity tenderProject = null;
		TenderProjectEntity tenderPack = null;
		if(null != tenderProjectEntity.getParentId()){
			tenderProject = tenderProjectService.getById(tenderProjectEntity.getParentId());
			tenderPack = tenderProjectService.getById(tenderProjectEntity.getId());
			WidgetUtils.setControlVisible(packageComposite, true);
		}else {
			tenderProject = tenderProjectEntity;
			// 带分包的项目
			if(CommonEnum.YES.equals(tenderProjectEntity.getIsPack())){
				tenderPack = getFirstTenderPack(tenderProjectEntity.getId());
				WidgetUtils.setControlVisible(packageComposite, true);
			}else {
				tenderPack = tenderProjectService.getById(tenderProjectEntity.getId());
				WidgetUtils.setControlVisible(packageComposite, false);
			}
		}
		projectName.setText(tenderProject.getTenderName());
		project_composite.layout();
		tenderPack.setParentProjectEntity(tenderProject);
		packName.setText(tenderPack.getTenderName());
		packageComposite.layout();
		return tenderPack;
	}
	
	/**
	 * @Description: 显示限价
	 * @author guoyr 
	 */
	private void showLimitPriceCom() {
		StringBuilder limitPriceStr = new StringBuilder();
		Object signBidPriceLimit = projectRule.getParamByKey(ProjectRuleEnum.PARAM_SIGN_BID_PRICE_LIMIT);
		if(null != signBidPriceLimit && signBidPriceLimit.toString().equals("01")){
			if(null != curTenderPack.getBidPriceLimit()){
				Object signBidPriceLimitName = projectRule.getParamByKey(ProjectRuleEnum.PARAM_PRICE_LIMIT_NAME);
				if(null != signBidPriceLimitName && signBidPriceLimitName.toString().length() > 0){
					limitPriceStr.append(signBidPriceLimitName).append("：");
				}else {
					limitPriceStr.append(Messages.BiddingControlPrice).append("：");
				}
				String limitPriceString = curTenderPack.getBidPriceLimitWithUnit(projectRule.getPriceUnitUseDefault());
				if(null != curTenderPack.getBidPriceLimit()){
					limitPriceStr.append(limitPriceString + "， ");
				}else{
					limitPriceStr.append("0"+limitPriceString + "， ");
				}
				String moneyCn = MoneyUtils.amountToChinese(curTenderPack.getBidPriceLimit().doubleValue());
				limitPriceStr.append(moneyCn);
			}
			limitPriceStr.append("。");
		}
		if(limitPriceStr.length() > 0){
			limitPriceLabel.setText(limitPriceStr.toString());
			WidgetUtils.setControlVisible(limitPriceComposite, true);
		}else{
			WidgetUtils.setControlVisible(limitPriceComposite, false);
		}
		decryptMainComposite.layout();
	}


	/**
	 * @Description: 选择唱评标价
	 * @author guoyr 
	 */
	private void selectOnlyShowPriceAction(){
		selectOnlyShowPriceBtn.setSelection(!selectOnlyShowPriceBtn.getSelection());
		if(selectOnlyShowPriceBtn.getSelection()){
			selectOnlyShowPriceBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/checked.png"));
		}else {
			selectOnlyShowPriceBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/unchecked.png"));
		}
		onlyShowPrice = selectOnlyShowPriceBtn.getSelection();
		loadTenderPackMan(this.curTenderPack);
	}
	
	/**
	 * @Description: 切换包件
	 * @author guoyr 
	 */
	private void changeTenderPackAction(){
		if(null != curTenderPack){
			SelectSingBidTenderPackShell selectTenderPackShell = new SelectSingBidTenderPackShell(getShell(), curTenderPack.getParentId() , curTenderPack.getId(), selectionTenderPackListener);
			Point point = packName.toDisplay(0,packName.getBounds().height);
			selectTenderPackShell.setLocation(point);
			selectTenderPackShell.open();
		}
	}
	
	/**
	 * @Description: 加载包件信息
	 * @author guoyr
	 * @param tenderPack 
	 */
	private void loadTenderPackMan(TenderProjectEntity tenderPack){
		this.curTenderPack = tenderPack;
		if(null == curTenderPack){
			return;
		}
		
		projectRule = projectRuleService.getProjectRule(curTenderPack.getId());
		if(null == projectRule){
			projectRule = new TenderProjectRuleEntity();
		}
//		// 避免切换包件时查出来的包件的时间没有
//		Date bidOpeningStartTime = null;
//		Date priceOpeningTime = null;
//		if(null != projectRule){
//			bidOpeningStartTime = projectRule.getBidOpeningStartTime();
//			priceOpeningTime = projectRule.getPriceBidOpeningTime();
//		}
//		
		packName.setText("["+curTenderPack.getTenderNo() + "]"+curTenderPack.getTenderName());
		packageComposite.layout();
		
		showLimitPriceCom();
		showAllSupplierList();
		layout();
	}
	/**
	 * @Description: 获得项目下的第一个包件
	 * @author guoyr 
	 */
	private TenderProjectEntity getFirstTenderPack(String projectId){
		com.gx.obe.web.entity.Page<TenderProjectEntity> projectPage = tenderProjectService.getSignBidTenderPackagePageList(projectId, SelectSingBidTenderPackShell.CUR_PAGE_NO, 6);
		if(null != projectPage && null != projectPage.getRecords() && projectPage.getRecords().size() > 0){
			return projectPage.getRecords().get(0);
		}
		return null;
	}
	
	/**
	 * @Description: 鼠标拖动事件
	 * @author guoyr
	 */
	public class MouseDragListener implements Listener{
		Point origin = null;
		private Shell shell;
		public MouseDragListener(Shell shell){
			this.shell = shell;
		}
		public void handleEvent(Event e) {
			switch (e.type) {
			case SWT.MouseDown:
				origin = new Point(e.x, e.y);
				setCursor(new Cursor(null,SWT.CURSOR_SIZEALL));
				break;
			case SWT.MouseUp:
				setCursor(new Cursor(null,SWT.CURSOR_ARROW));
				origin = null;
				setAlpha(255);
				shell.setMaximized(true);
				break;
			case SWT.MouseMove:
				if (origin != null) {
					setAlpha(100);
					setSize(800, 600);
					Point p = Display.getDefault().map(shell, null, e.x, e.y);
					int x = p.x - origin.x;
					int y =  p.y - origin.y;
					if(x < 0){
						x = 0;
					}
					if(y < 0){
						y = 0;
					}
					shell.setMaximized(false);
					setLocation(x, y);
				}
				break;
			}
		}

	}
	

	protected void createContents() {
		setText(Messages.Button_signBid);
		setSize(1223, 737);
//		Dimension d = Toolkit.getDefaultToolkit().getScreenSize(); // 取得当前屏幕属性
//		int w = d.width; // 获取屏幕宽度
//		int h = d.height; // 获取屏幕高度
//		setSize(w,h);

	}

	/**
	 * @Description: 完成开标
	 * @author guoyr 
	 */
	
	@Override
	protected void checkSubclass() {
	}
	

	
	private void exitAction(){
		this.close();
	}

	private void drawBg(){
		removePaintListener(paintListener);
		zoomBgImage = new Image(null, bgImage.getImageData());
		GC gc = new GC(zoomBgImage);
		gc.drawImage(bgImage, 0, 0, bgImage.getBounds().width, bgImage.getBounds().height, 0, 0, getBounds().width, getBounds().height);
//		Point decryptFinishBgPoint = Display.getDefault().map(decryptFinishComposite, BidOpeningRemoteDecryptShell.this, 0,0);
//		Image decryptFinishBgImage = ResourceManager.getPluginImage(SWTCoreActivator.PLUGIN_ID, "icons/decrypt_finish.png");
//		gc.drawImage(decryptFinishBgImage, 0, 0, decryptFinishBgImage.getBounds().width, decryptFinishBgImage.getBounds().height, decryptFinishBgPoint.x, decryptFinishBgPoint.y, decryptFinishComposite.getBounds().width, decryptFinishComposite.getBounds().height);
		
		Point decryptMainPoint = Display.getDefault().map(decryptMainComposite, SingBidShell.this, 0,0);
		Point progressCompositePoint = Display.getDefault().map(progressComposite, SingBidShell.this, 0,0);
		gc.setAlpha(150);
		gc.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		gc.fillRectangle(decryptMainPoint.x, decryptMainPoint.y, decryptMainComposite.getBounds().width, decryptMainComposite.getBounds().height);
		gc.fillRectangle(progressCompositePoint.x, progressCompositePoint.y, progressComposite.getBounds().width, progressComposite.getBounds().height);
		setBackgroundImage(zoomBgImage);
		gc.dispose();
		
	
	}
	
	/**
	 * @Description: 列出投标人
	 * @author guoyr 
	 */
	private void showAllSupplierList(){
		stopSpeekLabel.setEnabled(false);
		singFinishBtn.setEnabled(false);
		stopTTS();
		supplierGrid.removeAll();
		supplierList = supplierService.getOpenBidSuccessSupplier(curTenderPack.getId());
		if(null != supplierList && supplierList.size() > 0){
			if(supplierList.size() > 10){
				supplierGrid.setItemHeight(Constants.ROW_HIGHT);
			}else {
				supplierGrid.setItemHeight(50);
			}
			singSupplierIdList = new ArrayList<String>();
			for(Supplier supplier : supplierList){
				GridItem gridItem = new GridItem(supplierGrid, SWT.NONE);
				gridItem.setFont(SWTResourceManager.getFont("微软雅黑", 11, SWT.NORMAL));
				gridItem.setData("supplier", supplier);
				gridItem.setText(0, supplier.getSupplierName());
				singSupplierIdList.add(supplier.getId());
			}
			supplierGrid.setSelection(0);
		}
		refreshBidPriceTable();
		showTotalResultAction();
		refreshBtnStatus();
	}
	
	
	
	/**
	 * @Description: 开标记录汇总表
	 * @author guoyr 
	 */
	private void showTotalResultAction(){
		openBidViewCompositeStaticLayout.topControl = bidPriceTableTotalGrid.getParent();
		supplierNameLabel.setText(Messages.Button_openingRecordTotal);
		supplier = null;
		refreshPriceTableGrid();
		openBidViewComposite.layout();
		refreshBtnStatus();
		// 点击Messages.Button_singVoice按钮，切换Messages.PreviousSupplier或Messages.NextSupplier投标人唱标。
		autoSpeakAction();
		
	}
	/**
	 * @Description: 投标人选中事件
	 * @author guoyr 
	 */
	private void supplierSelectAction(){
		if(supplierGrid.getSelectionCount() > 0){
			GridItem selectGridItem  = supplierGrid.getSelection()[0];
			supplierGrid.setFocusItem(selectGridItem);
			supplier = (Supplier)selectGridItem.getData("supplier");
			if(null != supplier){
				supplierNameLabel.setText(supplier.getSupplierName());
				showSupplierPriceTable(supplier);
				openBidViewCompositeStaticLayout.topControl = supplierBidPriceTableGrid.getParent();
			}
		}
		refreshBtnStatus();
		openBidViewComposite.layout();
		// 点击Messages.Button_singVoice按钮，切换Messages.PreviousSupplier或Messages.NextSupplier投标人唱标。
		autoSpeakAction();
	}
	
	/**
	 * @Description: 列出开标一览表总表
	 * @author guoyr 
	 */
	private void refreshBidPriceTable(){
		if(null == bidPriceTableTotalColumnMap){
			bidPriceTableTotalColumnMap = new HashMap<String, Integer>();
		}else {
			bidPriceTableTotalColumnMap.clear();
		}
		if(null != bidPriceList){
			bidPriceList.clear();
		}
		bidPriceList = bidPriceService.getTenderBidPriceTableList(curTenderPack.getId());
		if(null == bidPriceList || bidPriceList.size() == 0){
			bidPriceList = new ArrayList<BidPrice>();
			if(showBidPrice){
				bidPriceList.add(BidPriceUtils.getTotalBidprice());
			}
		}
		for(GridColumn column : bidPriceTableTotalGrid.getColumns()){
			column.dispose();
		}
		GridColumn supplierNameColumn = new GridColumn(bidPriceTableTotalGrid, SWT.NONE);
		supplierNameColumn.setHeaderFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		supplierNameColumn.setText(MessageFormat.format(Messages.NameFormat, SUPPLIER_NAME));
		supplierNameColumn.setWidth(200);
		supplierNameColumn.setWordWrap(true);
		
		refreshPriceDetailColumnGroup();
		
		for(BidPrice bidPrice : bidPriceList){
			if(StringUtils.isEmpty(bidPrice.getBidPriceName())){
				continue;
			}
			GridColumn gridColumn = null;
			if(BidPriceEnum.IS_PRICE_ITEM.equals(bidPrice.getBidPriceType())){
				if(!showBidPrice)continue;
				gridColumn = new GridColumn(bidPriceTableTotalGrid, SWT.RIGHT);;
			}else {
				if(onlyShowPrice)continue;
				gridColumn = new GridColumn(bidPriceTableTotalGrid, ColumnAlignmentUtils.getAlignment(bidPrice.getBidPriceName()));;
			}
			
			gridColumn.setWordWrap(true);
			gridColumn.setHeaderWordWrap(true);
			gridColumn.setHeaderFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
			gridColumn.setText(bidPrice.getBidPriceName());
			gridColumn.setMinimumWidth(100);
			gridColumn.setWidth(100);
			gridColumn.setMaxmumWidth(250);
			bidPriceTableTotalColumnMap.put(bidPrice.getId(), bidPriceTableTotalGrid.indexOf(gridColumn));
		}
		// 如果显示标书密封情况
		if(!onlyShowPrice && PropertiesUtils.getProperty(ConfigConstants.SEAL_SITUATION, CommonEnum.NO).equals(CommonEnum.YES)){
			GridColumn itemColumn = new GridColumn(bidPriceTableTotalGrid, SWT.CENTER);
			itemColumn.setHeaderFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
			itemColumn.setText(Messages.SealingStatus);
			itemColumn.setMinimumWidth(60);
			itemColumn.setWidth(60);
			itemColumn.setMaxmumWidth(250);
			bidPriceTableTotalColumnMap.put("ID_"+Messages.SealingStatus, bidPriceTableTotalGrid.indexOf(itemColumn));
		}	
	}
	
	/**
	 * @Description: 刷新报价明细列
	 * @author chenxw
	 */
	private void refreshPriceDetailColumnGroup() {
		Optional<Map<Integer, Integer>> mapOptional = Optional.ofNullable(bidPriceTableDetailColumnMap);
		mapOptional.ifPresent(Map::clear);
		bidPriceTableDetailColumnMap = mapOptional.orElseGet(HashMap::new);
		GridColumnGroup gridColumnGroup = new GridColumnGroup(bidPriceTableTotalGrid, SWT.NONE);
		gridColumnGroup.setText("投标报价明细");
		gridColumnGroup.setHeaderFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		Optional<List<BidPriceTableTitle>> bidPriceTableTitleList = Optional.ofNullable(supplierList)
				.map(List::stream)
				.flatMap(Stream::findFirst)
				.map(t -> bidPriceTableService.getBidPriceTableDetailBySupplierId(curTenderPack.getId(), t.getId()))
				.map(BidPriceTable::getBidPriceTableTitleList);
		bidPriceTableTitleList.map(List::stream).ifPresent(s -> s.forEach(t -> {
			GridColumn gridColumn = new GridColumn(gridColumnGroup, SWT.NONE);
			gridColumn.setText(Optional.of(t).map(BidPriceTableTitle::getTitleName).orElse("未知列"));
			gridColumn.setWordWrap(true);
			gridColumn.setHeaderFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
			gridColumn.setMinimumWidth(100);
			gridColumn.setWidth(100);
			gridColumn.setMaxmumWidth(250);
//			Optional.of(t).map(BidPriceTableTitle::getContentAlignment).map(ContentAlignment::getSwtValueByKey).filter(i -> i == 0).ifPresent(gridColumn::setAlignment);
			gridColumn.setAlignment(SWT.CENTER);
			bidPriceTableDetailColumnMap.put(t.getSortNo(), bidPriceTableTotalGrid.indexOf(gridColumn));
		}));
	}

	/**
	 * @Description: 刷新开标一览表总表
	 * @author guoyr 
	 */
	private void refreshPriceTableGrid(){
		bidPriceTableTotalGrid.removeAll();
		if(null != supplierList && supplierList.size() > 0){
			for(int i = 0; i < supplierList.size(); i++){
				Supplier supplier = supplierList.get(i);
				GridItem gridItem = new GridItem(bidPriceTableTotalGrid, SWT.NONE);
				gridItem.setFont(SWTResourceManager.getFont("微软雅黑", resultFontSize, SWT.NONE));
				gridItem.setText(0, supplier.getSupplierName());
				
				StringBuilder singContent = new StringBuilder();
				singContent.append("。");
				singContent.append(supplier.getSupplierName()).append("。");
				
				refreshSupplierOpenBidResult(supplier, gridItem, singContent);
			
				// 如果显示标书密封情况
				if(!onlyShowPrice && PropertiesUtils.getProperty(ConfigConstants.SEAL_SITUATION, CommonEnum.NO).equals(CommonEnum.YES)){
					int columnCount = bidPriceTableTotalColumnMap.get("ID_"+Messages.SealingStatus);
					gridItem.setText(columnCount, Messages.SealingStatusIntact);
					singContent.append(Messages.SealingStatus + "：").append(gridItem.getText(columnCount)).append("。");
				}	
				gridItem.setData("singContent", singContent.toString());
				
				refreshDetailItem(gridItem, supplier);
			}
		}
	}
	
	
	/**
	 * @Description: 
	 * @author chenxw
	 * @param gridItem 
	 * @param supplier 
	 */
	private void refreshDetailItem(GridItem gridItem, Supplier supplier) {
		Optional<BidPriceTable> bidPriceTable = Optional.of(supplier)
				.map(t -> bidPriceTableService.getBidPriceTableDetailBySupplierId(curTenderPack.getId(), t.getId()));
		
		Optional<List<BidPriceTableItem>> bidPriceTableItemList = bidPriceTable.map(BidPriceTable::getBidPriceTableItemList);
		Optional<List<BidPriceTableTitle>> bidPriceTableTitleList = bidPriceTable.map(BidPriceTable::getBidPriceTableTitleList);
		Optional<Map<Keys, String>> bidPriceTableValueMap = bidPriceTable.map(BidPriceTable::getBidPriceTableValueMap);
		
		bidPriceTableItemList.ifPresent(l -> IntStream
				.range(0, bidPriceTableTotalGrid.getColumnCount())
				.filter(ic -> !bidPriceTableDetailColumnMap.values().contains(ic))
				.forEach(ic -> gridItem.setRowSpan(ic, l.size() - 1)));
		
		bidPriceTableItemList.map(List::stream).flatMap(Stream::findFirst).ifPresent(item -> bidPriceTableTitleList
				.map(List::stream)
				.ifPresent(ts -> ts
						.forEach(title -> gridItem
								.setText(
										bidPriceTableDetailColumnMap.getOrDefault(title.getSortNo(), -1), 
										bidPriceTableValueMap.map(m -> m.get(new Keys(title.getId(), item.getId()))).orElse("")
										))));
		bidPriceTableItemList.map(List::stream).ifPresent(is -> is.skip(1).forEach(item -> {
			GridItem detailItem = new GridItem(bidPriceTableTotalGrid, SWT.NONE);
			detailItem.setFont(SWTResourceManager.getFont("微软雅黑", resultFontSize, SWT.NONE));
			bidPriceTableTitleList.map(List::stream).ifPresent(ts -> ts
					.forEach(title -> detailItem
							.setText(
									bidPriceTableDetailColumnMap.getOrDefault(title.getSortNo(), -1), 
									bidPriceTableValueMap.map(m -> m.get(new Keys(title.getId(), item.getId()))).orElse("")
									)));
		}));
	}

	private void refreshSupplierOpenBidResult(Supplier supplier, GridItem gridItem, StringBuilder singContent) {
		SupplierOpeningResult supplierOpeningResult = supplier.getSupplierOpeningResult();
		//获取报价结果
		List<BidPriceResult> bidPriceResultList = bidPriceResultService.getBidPriceResultTableList(curTenderPack.getId(), supplier.getId());
		if(null == bidPriceResultList || bidPriceResultList.size() == 0){
			bidPriceResultList = new ArrayList<BidPriceResult>();
			if(showBidPrice && null != supplierOpeningResult){
				bidPriceResultList.add(supplierOpeningResult.getBidPriceResult(projectRule.getPriceUnitUseDefault(), projectRule.getCurrencyCode(), projectRule.getCurrencyName()));
			}
		}
		// 如果投标报价多于一个，则显示总投标报价
		for (BidPriceResult bidPriceResult : bidPriceResultList) {
			if(StringUtils.isEmpty(bidPriceResult.getBidPriceName())){
				continue;
			}
			
			if(BidPriceEnum.IS_PRICE_ITEM.equals(bidPriceResult.getBidPriceType())){
				if(!showBidPrice)continue;
			}else {
				if(onlyShowPrice)continue;
			}
			int columnCount = 2;
			if(null != bidPriceTableTotalColumnMap.get(bidPriceResult.getBidPriceId())){
				columnCount = bidPriceTableTotalColumnMap.get(bidPriceResult.getBidPriceId());
				gridItem.setText(columnCount, bidPriceResult.getContentValue(projectRule.getPriceUnitUseDefault()));
			}
			singContent.append(bidPriceResult.getFilterSingTitle(filterBracketContent)).append(" ：");
			singContent.append(TTSEnginUtil.getSingContent(bidPriceResult));
		}
	}
	
	
	/**
	 * @Description: 显示投标人的开标一览表信息
	 * @author guoyr
	 * @param supplier
	 * @param priceViewMapList 
	 */
	private void showSupplierPriceTable(Supplier supplier){
		supplierBidPriceTableGrid.removeAll();
		supplierName_label.setFont(SWTResourceManager.getFont("微软雅黑", supplierFontSize, SWT.BOLD));
		supplierName_label.setText(supplier.getSupplierName());
		StringBuilder supplierSingContent = new StringBuilder();
		supplierSingContent.append(supplier.getSupplierName()).append("。");
		SupplierOpeningResult supplierOpeningResult = supplier.getSupplierOpeningResult();
		
		//获取报价结果
		List<BidPriceResult> bidPriceResultList = bidPriceResultService.getBidPriceResultTableList(curTenderPack.getId(), supplier.getId());
		if(null == bidPriceResultList || bidPriceResultList.size() == 0){
			bidPriceResultList = new ArrayList<BidPriceResult>();
			if(showBidPrice && null != supplierOpeningResult){
				bidPriceResultList.add(supplierOpeningResult.getBidPriceResult(projectRule.getPriceUnitUseDefault(), projectRule.getCurrencyCode(), projectRule.getCurrencyName()));
			}
		}
		// 如果投标报价多于一个，则显示总投标报价
		for (BidPriceResult bidPriceResult : bidPriceResultList) {
			if(StringUtils.isEmpty(bidPriceResult.getBidPriceName())){
				continue;
			}
			
			if(BidPriceEnum.IS_PRICE_ITEM.equals(bidPriceResult.getBidPriceType())){
				if(!showBidPrice)continue;
			}else {
				if(onlyShowPrice)continue;
			}
			GridItem gridItem = new GridItem(supplierBidPriceTableGrid, SWT.NONE);
			gridItem.setForeground(0, titleColor);
			gridItem.setFont(0, SWTResourceManager.getFont("微软雅黑", supplierFontSize, SWT.BOLD));
			gridItem.setFont(1, SWTResourceManager.getFont("微软雅黑", supplierFontSize, SWT.NONE));
			gridItem.setText(0, bidPriceResult.getBidPriceName().concat("："));
			
			gridItem.setText(1, bidPriceResult.getContentValue(projectRule.getPriceUnitUseDefault()));
			supplierSingContent.append(bidPriceResult.getFilterSingTitle(filterBracketContent)).append(" ：");
			supplierSingContent.append(TTSEnginUtil.getSingContent(bidPriceResult));
		}
	
		// 如果显示标书密封情况
		if(!onlyShowPrice && PropertiesUtils.getProperty(ConfigConstants.SEAL_SITUATION, CommonEnum.NO).equals(CommonEnum.YES)){
			GridItem itemGridItem = new GridItem(supplierBidPriceTableGrid, SWT.NONE);
			itemGridItem.setForeground(0, titleColor);
			itemGridItem.setFont(0, SWTResourceManager.getFont("微软雅黑", supplierFontSize, SWT.BOLD));
			itemGridItem.setFont(1, SWTResourceManager.getFont("微软雅黑", supplierFontSize, SWT.NONE));
			itemGridItem.setText(0, Messages.SealingStatus +"：");
			itemGridItem.setText(1, Messages.SealingStatusIntact);
			supplierSingContent.append(Messages.SealingStatus + "："+Messages.SealingStatusIntact+"。");
		}	
		supplierBidPriceTableGrid.setData(supplier.getId(), supplierSingContent.toString());
	}

	/**
	 * @Description: 查看上一家投标人
	 * @author guoyr 
	 */
	private void previewAction(){
		if(preSupplierBtn.getEnabled()){
			int selectIndex = supplierGrid.getSelectionIndex();
			if(selectIndex > 0){
				supplierGrid.setSelection(selectIndex -1);
				supplierSelectAction();
				Rectangle rectangle = supplierGrid.getBounds();
				supplierGrid.scroll(0, 0, 0, 0, rectangle.width, rectangle.height, true);
				supplierGrid.getVerticalBar().setSelection(supplierGrid.getSelectionIndex());
				supplierGrid.getVerticalBar().notifyListeners(SWT.Selection, null);
			}
		}
	}
	
	/**
	 * @Description: 查看下一家投标人
	 * @author guoyr 
	 */
	private void nextAction(){
		if(nextSupplierBtn.getEnabled()){
			int selectIndex = supplierGrid.getSelectionIndex();
			if(selectIndex < supplierGrid.getItemCount()){
				if(null == supplier){
					supplierGrid.setSelection(selectIndex);
				}else {
					supplierGrid.setSelection(selectIndex + 1);
				}
				supplierSelectAction();
				Rectangle rectangle = supplierGrid.getBounds();
				supplierGrid.scroll(0, 0, 0, 0, rectangle.width, rectangle.height, true);
				supplierGrid.getVerticalBar().setSelection(supplierGrid.getSelectionIndex());
				supplierGrid.getVerticalBar().notifyListeners(SWT.Selection, null);
			}
		}
	}
	
	/**
	 * @Description: 唱标结束
	 * @author guoyr 
	 */
	private void singFinshAction(){
		if(singFinishBtn.getEnabled()){
			singFinishBtn.setEnabled(false);
			isSpeakTTS = false;
			if(null != tts){
				if(null != projectRule.getSingSuffix() && projectRule.getSingSuffix().length() > 0){
					tts.speak(projectRule.getSingSuffix());
				}else {
					tts.speak("唱标完毕，各投标代表对唱标内容有无疑议，。若无异议，请各投标代表在"+TenderProjectEnum.getOpenBidEnum(tenderProjectEntity.getPhaseType())+"记录表上签字确认。");
				}
			}
		}
	}
	
	/**
	 * @Description: 刷新按钮 
	 * @author guoyr 
	 */
	private void refreshBtnStatus(){
		int selectIndex = supplierGrid.getSelectionIndex();
		if(null != supplier){
			viewPriceFileBtn.setEnabled(true);
			((GridData)viewPriceFileBtn.getLayoutData()).exclude = false;
			viewPriceFileBtn.setVisible(true);
		}else {
			viewPriceFileBtn.setEnabled(false);
			((GridData)viewPriceFileBtn.getLayoutData()).exclude = true;
			viewPriceFileBtn.setVisible(false);
		}
		top_composite.layout();
		
		preSupplierBtn.setEnabled(true);
		nextSupplierBtn.setEnabled(true);
		if (selectIndex <= 0) {
			preSupplierBtn.setEnabled(false);
		}
		if (selectIndex == supplierGrid.getItemCount() - 1) {
			nextSupplierBtn.setEnabled(false);
		}
	}
	
	/**
	 * @Description:查看开标一览表原文件 
	 * @author guoyr 
	 */
	private void viewOpenbidPriceViewAction(){
		if(viewPriceFileBtn.getEnabled()){
			ViewBidFilesDialog dialog = new ViewBidFilesDialog(getShell(), curTenderPack, supplier);
			dialog.open();
		}
//		if(!viewPriceFileBtn.getEnabled())return;
//		List<BidFile> bidPriceFileList = BidFile.getSupplierBidFileList(tenderProjectEntity.getId(), supplier.getId(), BidFile.TYPE_BIDPRICE);
//		if(null != bidPriceFileList && bidPriceFileList.size() > 0){
//			OpenDocumentDialog dialog = new OpenDocumentDialog(getShell(),bidPriceFileList.get(0),  true);
//			dialog.setTitle("["+supplier.getSupplierName()+"]开标一览表");
//			dialog.setOperator(SWT.MAX | SWT.CLOSE);
//			dialog.open();
//		}else {
//			MessageDialog.openWarning(getShell(), "未找到["+supplier.getSupplierName()+"]的开标一览表"+"！");
//		}
	}
	
	/**
	 * @Description: 启动语音
	 * @author guoyr 
	 */
	private void speakTTSAction(){
		if(null == tts){
			tts = TTSEnginUtil.getTTSEngin();
		}
		if(null != tts){
			speakBtn.setEnabled(true);
			stopSpeekLabel.setEnabled(true);
			isSpeakTTS = true;
			autoSpeakAction();
			singFinishBtn.setEnabled(true);
		}else {
			speakBtn.setEnabled(false);
			stopSpeekLabel.setEnabled(false);
			MessageDialog.openShortMessage("未找到语音引擎！");
			return;
		}
	}

	/**
	 * @Description: 停止语音
	 * @author guoyr
	 */
	private void stopTTS(){
		isSpeakTTS = false;
		stopSpeekLabel.setEnabled(false);
		if(null != tts){
			tts.stop();
		}
	}
	
	/**
	 * @Description: 语音唱标
	 * @author guoyr 
	 */
	private void autoSpeakAction(){
		// 初始化TTS语音
		if(isSpeakTTS && null != tts){
//			tts.stop();
		}else {
			return;
		}
		
		final StringBuilder speakSb = new StringBuilder();
		if(!isStartSpeekContent){
			if(null != projectRule.getSingPrefix() && projectRule.getSingPrefix().length() > 0){
				speakSb.append("。").append(projectRule.getSingPrefix()).append("。");
			}
			
			if(PropertiesUtils.getProperty(ConfigConstants.SING_TENDERNAME, "00").equals("01")){
				if(null != curTenderPack.getParentId()){
					TenderProjectEntity parentProject = tenderProjectService.getById(curTenderPack.getParentId());
					speakSb.append(parentProject.getTenderName());
					speakSb.append("，");
				}
				speakSb.append(curTenderPack.getTenderName());
				speakSb.append("。");
			}
			
			Object signBidPriceLimit = projectRule.getParamByKey(ProjectRuleEnum.PARAM_SIGN_BID_PRICE_LIMIT);
			if(null != signBidPriceLimit && signBidPriceLimit.toString().equals("01")){
				if(null != curTenderPack.getBidPriceLimit()){
					Object signBidPriceLimitName = projectRule.getParamByKey(ProjectRuleEnum.PARAM_PRICE_LIMIT_NAME);
					if(null != signBidPriceLimitName && signBidPriceLimitName.toString().length() > 0){
						speakSb.append(signBidPriceLimitName).append("：");
					}else {
						speakSb.append(Messages.BiddingControlPrice).append("：");
					}
					String moneyCn = MoneyUtils.amountToChinese(curTenderPack.getBidPriceLimit().doubleValue());
					speakSb.append(moneyCn.replace("陆", "六"));
				}
				speakSb.append("。");
			}
			
		}
		isStartSpeekContent = true;
		if(null == supplier){
			if(null != singSupplierIdList && singSupplierIdList.size() == 0){
				return;
			}
			// 开标一览表总表
			for(GridItem gridItem : bidPriceTableTotalGrid.getItems()){
				Object singContent = gridItem.getData("singContent");
				if (singContent != null) {
					speakSb.append(singContent);
				}
			}
		}else {// 每位投标人详细信息
			
			Object supplierName = supplierBidPriceTableGrid.getData(supplier.getId());
			if (supplierName != null) {
				speakSb.append(supplierName);
			}
			if(null != singSupplierIdList && singSupplierIdList.size() > 0){
				singSupplierIdList.remove(supplier.getId());
			}
		}
		if(null != tts && speakSb.length() > 0){
			tts.speak(speakSb.toString());
		}
	}
	
	class SingTTSThread implements Runnable{
		private String content;
		private Thread thread;
		private boolean isStart = false;
		public SingTTSThread(){
			
			thread = new Thread(this);
		}
		public void start(String content){
			this.content = content;
			if(!isStart){
				thread.start();
			}else {
				Speak();
			}
		}
		public void stop(){
			this.content = "";
			try {
				tts.speak("");
			} catch (Exception e) {
			}
		}
		public void Speak(){
			
			if(null != thread && null != tts){
				isStart = true;
				try {
					tts.speak(content);
				} catch (Exception e) {
				}
			}
		}
		public void run(){
			Speak();
		}
	};
	
	/**
	 * @Description: 根据唱标结果生成报表
	 * @author guoyr 
	 */
	private void createOpenbidReport(){
		if(!CommonEnum.COMPLETE.equals(curTenderPack.getBidOpeningStatus())){
			if(!MessageDialog.openConfirm(getShell(), null, Messages.Tips_notComplateBidOpeningOperate, new String[]{Messages.Button_confirm, Messages.Button_cancel})){
				return;
			}
		}
		EvaluationReportDialog dialog = new EvaluationReportDialog(getShell(), curTenderPack, TemplateTypeEnum.OPEN_BID.getKey(), EvaluationReportComposite.REPORT_BID_OPENING);
		dialog.setTitle(Messages.Button_generateOpeningRecordTotal);
		// 最大化和关闭
		dialog.setOperator(SWT.MAX | SWT.CLOSE);
		dialog.open();
	}
	
	/**
	 * @Description: 上传开标结果
	 * @author guoyr
	 */
	private void uploadReport(){
		if(!CommonEnum.COMPLETE.equals(curTenderPack.getBidOpeningStatus())){
			if(!MessageDialog.openConfirm(getShell(), null, Messages.Tips_notComplateBidOpeningOperate, new String[]{Messages.Button_confirm, Messages.Button_cancel})){
				return;
			}
		}
//			UploadOpenBiddingResultAndFileDialog dialog = new UploadOpenBiddingResultAndFileDialog(getShell(), curTenderPack);
		BidOpeningReportDialog dialog = new BidOpeningReportDialog(getShell(), curTenderPack, false, menuFunctionUtils);
		dialog.setTitle(Messages.Button_remoteSignatureOpeningResult);
		dialog.open();
	}
	
	/**
	 * @Description: 上传开标结果及附件
	 * @author guoyr 
	 */
	private void uploadOpeningResultAndFile() {
		if(!ObjectUtils.equals(curTenderPack.getBidOpeningStatus(), CommonEnum.COMPLETE)){
			MessageDialog.openInformation(getShell(), Messages.Tips_notComplateBidOpening);
			return;
		}
		UploadOpenBiddingResultAndFileDialog dialog = new UploadOpenBiddingResultAndFileDialog(getShell(), curTenderPack);
		dialog.setTitle(Messages.Button_uploadBidOpeningResult);
		dialog.open();
	}
	private ImageButton createButtonStyle(Composite parent){
		ImageButton button = new ImageButton(parent, SWT.NONE);
		button.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, false, false, 1, 1));
//		button.setCursor(SWTResourceManager.getCursor(SWT.CURSOR_HAND));
//		button.setSurroundColor(SWTResourceManager.getColor(60, 138, 226));
		button.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		button.setForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
//		button.setBorderColor(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		
		button.setActiveForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
//		button.setActiveSurroundColor(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		button.setActiveBorderColor(SWTResourceManager.getColor(SWT.COLOR_WHITE));
//		button.setText(Messages.Button_reduce);
		button.setSurroundMargin(2);
		button.setFillSurround(false);
		return button;
	}
	
	
	/**
	 * @Description: 放大字体事件
	 * @author guoyr 
	 */
	public void addFontSize(){
		if(null != supplier){
			addSupplierViewFontSize();
		}else {
			addResultFontSize();
		}
	}
	private void addResultFontSize(){
//		最大字体限定不超过36
		if(resultFontSize > 36){
			return ;
		}else{
			//每次字体自动变大，比之前大三个像素
			resultFontSize =resultFontSize+2;
			//开标一览表 调整字体大小
			GridItem[]  items = bidPriceTableTotalGrid.getItems();
			for(GridItem item : items ){
				item.setFont(SWTResourceManager.getFont("微软雅黑", resultFontSize, SWT.NORMAL));
			}
			// 表格刷新
			bidPriceTableTotalGrid.resizeColumnWidth();
		}
	}
	private void addSupplierViewFontSize(){
		if(supplierFontSize>36){
			return ;
		}else{
			//每次字体自动变大，比之前大三个像素
			supplierFontSize =supplierFontSize+2;
			
			//单个投标人信息列表调整字体大小
			GridItem[] items =  supplierBidPriceTableGrid.getItems();
			for(GridItem item : items ){
				item.setFont(0, SWTResourceManager.getFont("微软雅黑", supplierFontSize, SWT.BOLD));
				item.setFont(1, SWTResourceManager.getFont("微软雅黑", supplierFontSize, SWT.NONE));
			}
			supplierName_label.setFont(SWTResourceManager.getFont("微软雅黑", supplierFontSize < 15 ? 15:supplierFontSize, SWT.BOLD));
			supplierBidPriceTableGrid.setItemHeight(supplierBidPriceTableGrid.getItemHeight() + 1);
			supplierName_label.getParent().layout();
		}
	}

	/**
	 * @Description: 缩小字体事件
	 * @author guoyr 
	 */
	public void reduceFontSize(){
		if(null != supplier){
			reduceSupplierViewFontSize();
		}else {
			reduceResultFontSize();
		}
	}
	public void reduceResultFontSize(){
		if (resultFontSize < 11){
			return ;
		}else{
			//每次字体缩小3个像素
			resultFontSize =resultFontSize-2;
			//开标一览总表
			GridItem[]  items = bidPriceTableTotalGrid.getItems();
			for(GridItem item : items ){
				item.setFont(SWTResourceManager.getFont("微软雅黑", resultFontSize, SWT.NORMAL));
			}
			bidPriceTableTotalGrid.setItemHeight(50);
			bidPriceTableTotalGrid.resizeColumnWidth();
		} 
	}
	
	public void reduceSupplierViewFontSize(){
		if (supplierFontSize < 11){
			return ;
		}else{
			//每次字体缩小3个像素
			supplierFontSize =supplierFontSize-2;
			//单个投标人数据表
			GridItem[] items = supplierBidPriceTableGrid.getItems();
			for(GridItem item : items ){
				item.setFont(0, SWTResourceManager.getFont("微软雅黑", supplierFontSize, SWT.BOLD));
				item.setFont(1, SWTResourceManager.getFont("微软雅黑", supplierFontSize, SWT.NONE));
			}
			supplierName_label.setFont(SWTResourceManager.getFont("微软雅黑", supplierFontSize < 15 ? 15:supplierFontSize, SWT.BOLD));
			supplierBidPriceTableGrid.setItemHeight(50);
			supplierName_label.getParent().layout();
		} 
	}
	
	/**
	 * @Description: 唱标配置
	 * @author guoyr
	 */
	private void configAction(){
		Action projectAction = new Action(){
			public void run() {
			}
		};
		projectAction.setTenderProject(curTenderPack);
		final ToolsShell moreToolsShell = new ToolsShell(getShell());
		final Composite configComposite = moreToolsShell.addToolBar(Messages.Config_moreConfiguration, null, false);
		configComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		configComposite.setLayout(new GridLayout(1, true));
		configComposite.setData("tenderProjectEntity", curTenderPack);
		BidOpeningRuleComposite bidOpeningRuleComposite = new BidOpeningRuleComposite(configComposite, projectAction, SWT.None);
		bidOpeningRuleComposite.addProjectRuleListener(new ProjectRuleListener(){
			public void updateProjectRule(TenderProjectRuleEntity _projectRule) {
				if(!moreToolsShell.isDisposed()){
					moreToolsShell.close();
				}
				projectRule = _projectRule;
				showLimitPriceCom();
				supplierSelectAction();
			}
		});
		bidOpeningRuleComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		moreToolsShell.setWidth(700);
		moreToolsShell.pack();
		SwtUtils.setCenter(moreToolsShell);
		moreToolsShell.open();
	}
	
	private void downloadDecFileAction(){
		DownLoadBidFileOnLineWindow downLoadBidFileOnLineWindow = new DownLoadBidFileOnLineWindow(curTenderPack);
		downLoadBidFileOnLineWindow.open();
	}
	private void menuDetectAction() {

		final EMenu gmenu = new EMenu(getShell());
		gmenu.addMenuItem("设置固定行高", ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/config.png"), true,new EMenu.ClickListener() {
			public void click() { 
				GridResizeDialog dialog = new GridResizeDialog(getShell(), bidPriceTableTotalGrid, 1, bidPriceTableTotalGrid.getColumnCount() -1);
				dialog.setShellTrim();
				dialog.open();
			}
		});
		
		gmenu.open();
	
	}
	public void close() {
		imageResolver.disposite();
		if(null != zoomBgImage){
			zoomBgImage.dispose();
		}
		if(null != tts){
			tts.release();
		}
		super.close();
	}
	
}
