package com.gx.obe.opening.shell;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.CallBack;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.core.widgets.ImageButton;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.custom.StyleRange;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;

import com.gx.obe.ColorConstants;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.composite.PageNumComposite;
import com.gx.obe.common.widget.dialog.MessageViewDialog;
import com.gx.obe.common.widget.listener.PageListener;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.config.ConfigConstants;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.message.Messages;
import com.gx.obe.opening.composite.TenderPackOpeningListItemComposite;
import com.gx.obe.opening.listener.BatchRemoteBidOpeningListener;
import com.gx.obe.opening.listener.TenderPackOpeningStatus;
import com.gx.obe.opening.thread.DownloadSupplierBidPriceUtils;
import com.gx.obe.opening.widgets.BidOpeningStatusButton;
import com.gx.obe.web.entity.Page;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.entity.tender.TenderProjectRuleEntity;
import com.gx.obe.web.service.TenderProjectService;
import com.gx.obe.web.vo.TenderPackOpeningInfo;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

public class TenderPackListDetailsShell extends Shell {

	private Composite tenderPackOpeningListItemComposite;
	private TenderProjectService tenderProjectService ;
	private TenderProjectEntity tenderProjectEntity;
	private String bidopeningStage;
	private TenderPackOpeningInfo tenderProjectOpeningInfo;
	private TenderProjectRuleEntity tenderProjectRuleEntity;
	private StyledText styledText;
	private BidOpeningStatusButton tenderCountBtn;
	private BidOpeningStatusButton effectiveCountBtn;
	private BidOpeningStatusButton signCountBtn;
	private BidOpeningStatusButton descCountBtn;
	private BidOpeningStatusButton confirmCountBtn;
	private BidOpeningStatusButton curStatusCount;
	private int CUR_TYPE = 0;
	private ScrolledComposite scrolledComposite;
	private Composite decryptSupplierComposite;
	private GridLayout gl_decryptSupplierComposite;
	private Composite decryptMainComposite;
	private PageNumComposite pageComposite;
	private boolean isFocus = false;
	private boolean showOpeningCount = false;
	private BatchRemoteBidOpeningListener batchRemoteBidOpeningListener;
	private ELink refreshBtn;
	private List<TenderPackOpeningInfo> tenderPackOpeningInfoList = null;
	private int PAGE_SIZE = 20;
	private int PAGE_NO = 1;

	/**
	 * Create the shell.
	 * @param tenderProjectOpeningInfo 
	 * @param display
	 */
	public TenderPackListDetailsShell(Shell parentShell, TenderPackOpeningInfo tenderProjectOpeningInfo, TenderProjectRuleEntity tenderProjectRuleEntity, String bidopeningStage, boolean showOpeningCount, BatchRemoteBidOpeningListener batchRemoteBidOpeningListener) {
		super(parentShell, SWT.NO_TRIM | SWT.PRIMARY_MODAL);
		setBackground(ColorConstants.BORDER_LINE_COLOR);
		setBackgroundMode(SWT.INHERIT_FORCE);
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.verticalSpacing = 0;
		gridLayout.horizontalSpacing = 0;
		gridLayout.marginHeight = 1;
		gridLayout.marginWidth = 1;
		setLayout(gridLayout);
		
		this.bidopeningStage = bidopeningStage;
		this.tenderProjectOpeningInfo = tenderProjectOpeningInfo;
		this.tenderProjectRuleEntity = tenderProjectRuleEntity;
		this.batchRemoteBidOpeningListener = batchRemoteBidOpeningListener;
		this.showOpeningCount = showOpeningCount;
		if(null != parentShell.getData("isFocus")){
			isFocus = true;
		}
		
		Composite composite_2 = new Composite(this, SWT.NONE);
		composite_2.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_composite_2 = new GridLayout(1, false);
		gl_composite_2.marginWidth = 1;
		gl_composite_2.verticalSpacing = 0;
		gl_composite_2.horizontalSpacing = 0;
		gl_composite_2.marginHeight = 1;
		composite_2.setLayout(gl_composite_2);
		composite_2.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		tenderPackOpeningListItemComposite = new Composite(composite_2, SWT.NONE);
		tenderPackOpeningListItemComposite.setBackground(SWTResourceManager.getColor(249, 253, 254));
//		tenderPackOpeningListItemComposite.setBackground(ColorConstants.SKIN_BG);
		GridLayout gl_tenderPackOpeningListItemComposite = new GridLayout(10, false);
		gl_tenderPackOpeningListItemComposite.marginWidth = 5;
		gl_tenderPackOpeningListItemComposite.horizontalSpacing = 2;
		gl_tenderPackOpeningListItemComposite.marginHeight = 0;
		tenderPackOpeningListItemComposite.setLayout(gl_tenderPackOpeningListItemComposite);
		tenderPackOpeningListItemComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		styledText = new StyledText(tenderPackOpeningListItemComposite, SWT.READ_ONLY);
		styledText.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1));
		
		tenderCountBtn = new BidOpeningStatusButton(tenderPackOpeningListItemComposite, SWT.NONE);
		GridData gd_tenderCountBtn = new GridData(SWT.FILL, SWT.CENTER, false, true, 1, 1);
		gd_tenderCountBtn.minimumWidth = 50;
		tenderCountBtn.setLayoutData(gd_tenderCountBtn);
		tenderCountBtn.setForeground(SWTResourceManager.getColor(41, 150, 206));
		tenderCountBtn.setFont(SWTResourceManager.getFont("微软雅黑", 13, SWT.NORMAL));
		tenderCountBtn.setStatusName(Messages.Opening_tendered);
		tenderCountBtn.setText(" 0 个");
		
		effectiveCountBtn = new BidOpeningStatusButton(tenderPackOpeningListItemComposite, SWT.NONE);
		GridData gd_effectiveCountBtn = new GridData(SWT.FILL, SWT.CENTER, false, true, 1, 1);
		gd_effectiveCountBtn.minimumWidth = 50;
		effectiveCountBtn.setLayoutData(gd_effectiveCountBtn);
		effectiveCountBtn.setForeground(SWTResourceManager.getColor(41, 150, 206));
		effectiveCountBtn.setFont(SWTResourceManager.getFont("微软雅黑", 13, SWT.NORMAL));
		effectiveCountBtn.setStatusName(Messages.Opening_ecryptable);
		effectiveCountBtn.setText(" 0 个");
		
		signCountBtn = new BidOpeningStatusButton(tenderPackOpeningListItemComposite, SWT.NONE);
		GridData gd_signCountBtn = new GridData(SWT.FILL, SWT.CENTER, false, true, 1, 1);
		gd_signCountBtn.minimumWidth = 50;
		signCountBtn.setLayoutData(gd_signCountBtn);
		signCountBtn.setForeground(SWTResourceManager.getColor(41, 150, 206));
		signCountBtn.setFont(SWTResourceManager.getFont("微软雅黑", 13, SWT.NORMAL));
		signCountBtn.setStatusName(Messages.Opening_signedIn);
		signCountBtn.setText(" 0 个");
		
		descCountBtn = new BidOpeningStatusButton(tenderPackOpeningListItemComposite, SWT.NONE);
		GridData gd_descCountBtn = new GridData(SWT.FILL, SWT.CENTER, false, true, 1, 1);
		gd_descCountBtn.minimumWidth = 50;
		descCountBtn.setLayoutData(gd_descCountBtn);
		descCountBtn.setForeground(SWTResourceManager.getColor(41, 150, 206));
		descCountBtn.setFont(SWTResourceManager.getFont("微软雅黑", 13, SWT.NORMAL));
		descCountBtn.setStatusName(Messages.Opening_decrypted);
		descCountBtn.setText(" 0 个");
		
		confirmCountBtn = new BidOpeningStatusButton(tenderPackOpeningListItemComposite, SWT.NONE);
		GridData gd_confirmCountBtn = new GridData(SWT.FILL, SWT.CENTER, false, true, 1, 1);
		gd_confirmCountBtn.minimumWidth = 50;
		confirmCountBtn.setLayoutData(gd_confirmCountBtn);
		confirmCountBtn.setForeground(SWTResourceManager.getColor(41, 150, 206));
		confirmCountBtn.setFont(SWTResourceManager.getFont("微软雅黑", 13, SWT.NORMAL));
		confirmCountBtn.setStatusName(Messages.Opening_confirmed);
		confirmCountBtn.setText(" 0 个");
		
		refreshBtn = new ELink(tenderPackOpeningListItemComposite, SWT.NONE);
		refreshBtn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/refresh.png"));
		refreshBtn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				refreshAction();
			}
		});
		refreshBtn.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		refreshBtn.setLayoutData(new GridData(SWT.RIGHT, SWT.FILL, false, false, 1, 1));
		refreshBtn.setText(Messages.Button_refresh);
		
		ImageButton close_btn = new ImageButton(tenderPackOpeningListItemComposite, SWT.NONE);
		close_btn.setArcWidth(50);
		close_btn.setLeftMargin(10);
		close_btn.setRightMargin(10);
		close_btn.setTopMargin(10);
		close_btn.setBottomMargin(10);
		close_btn.setBorderColor(SWTResourceManager.getColor(SWT.COLOR_RED));
		close_btn.setActiveBackgroundColor(SWTResourceManager.getColor(SWT.COLOR_RED));
		close_btn.setActiveForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
//		close_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/back.png"));
		close_btn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				close();
			}
		});
		close_btn.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		close_btn.setForeground(SWTResourceManager.getColor(SWT.COLOR_RED));
		GridData gd_close_btn = new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1);
		gd_close_btn.heightHint = 35;
		gd_close_btn.widthHint = 35;
		close_btn.setLayoutData(gd_close_btn);
		close_btn.setText(" 返回 ");
		
		ESepator label = new ESepator(tenderPackOpeningListItemComposite, SWT.NONE);
		label.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 10, 1));
		label.setBackground(SWTResourceManager.getColor(224, 224, 224));
		label.setBackground(SWTResourceManager.getColor(41, 150, 206));
		label.setLineWidth(3);
//		label.setLineStyle(SWT.LINE_DOT);
		
		decryptMainComposite = new Composite(composite_2, SWT.NONE);
		GridLayout gl_decryptMainComposite = new GridLayout(1, false);
		gl_decryptMainComposite.horizontalSpacing = 0;
		gl_decryptMainComposite.verticalSpacing = 0;
		gl_decryptMainComposite.marginHeight = 0;
		gl_decryptMainComposite.marginWidth = 0;
		decryptMainComposite.setLayout(gl_decryptMainComposite);
		decryptMainComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		scrolledComposite = new ScrolledComposite(decryptMainComposite, SWT.H_SCROLL | SWT.V_SCROLL);
		scrolledComposite.setLayoutData(new GridData(SWT.LEFT, SWT.CENTER, true, true, 1, 1));
		scrolledComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		scrolledComposite.setExpandHorizontal(true);
		scrolledComposite.setExpandVertical(true);
		
		decryptSupplierComposite = new Composite(scrolledComposite, SWT.NONE);
		gl_decryptSupplierComposite = new GridLayout(1, false);
		gl_decryptSupplierComposite.marginHeight = 0;
		gl_decryptSupplierComposite.marginWidth = 0;
		gl_decryptSupplierComposite.verticalSpacing = 0;
		decryptSupplierComposite.setLayout(gl_decryptSupplierComposite);
		
		scrolledComposite.setContent(decryptSupplierComposite);
		scrolledComposite.setMinSize(decryptSupplierComposite.computeSize(SWT.DEFAULT, SWT.DEFAULT));
		
		pageComposite = new PageNumComposite(decryptMainComposite, SWT.NONE);
		pageComposite.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.BOLD));
		pageComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, false, 1, 1));
		tenderProjectService = new TenderProjectService();
		init();
		createContents();
	}

	/**
	 * @Description: 初始化
	 * @author guoyr 
	 */
	private void init() {
		tenderProjectEntity = tenderProjectOpeningInfo.getTenderProject();
		// 打开详情的时候重新查询，并刷新
		showTenderPackInfo();
		showStatusCount();
		showTenderPackList(0);
		if(null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_BUS_TEC)){
			((GridData)refreshBtn.getLayoutData()).exclude = true;
			refreshBtn.setVisible(false);
			tenderPackOpeningListItemComposite.layout();
		}
		
		if(isFocus || PropertiesUtils.getProperty(ConfigConstants.SHOW_SIGN_INFO_STATUS, "01").equals("00")){
			((GridData)signCountBtn.getLayoutData()).exclude = true;
			signCountBtn.setVisible(false);
		}
		
		if(PropertiesUtils.getProperty(ConfigConstants.SHOW_CONFIRM_STATUS, "00").equals("00")){
			((GridData)confirmCountBtn.getLayoutData()).exclude = true;
			confirmCountBtn.setVisible(false);
		}
		pageComposite.setVisible(false);
		pageComposite.setBorderColor(SWTResourceManager.getColor(204, 204, 204));
		pageComposite.setForeground(SWTResourceManager.getColor(204, 204, 204));
		pageComposite.setSelectionBgColor(SWTResourceManager.getColor(24, 112, 221));
		pageComposite.setSelectionForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		pageComposite.addPageListener(new PageListener(){
			public void changed(int pageNo, int pageSize) {
				PAGE_NO = pageNo;
				showTenderPackList(CUR_TYPE);
			}
		});
	}

	/**
	 * @Description: 刷新
	 * @author guoyr 
	 */
	private void refreshAction(){
		refreshBtn.setEnabled(false);
		new Thread(new Runnable(){
			public void run(){
				tenderProjectOpeningInfo = tenderProjectService.getTenderProjectOpeningInfo(tenderProjectEntity, bidopeningStage);
				Display.getDefault().syncExec(new Runnable(){
					public void run(){
						if(!tenderCountBtn.isDisposed()){
							refreshBtn.setEnabled(true);
							showStatusCount();
						}
					}
				});
				if(null != batchRemoteBidOpeningListener){
					batchRemoteBidOpeningListener.refreshBidOpeningStatusInfo(tenderProjectOpeningInfo);
				}
			}
		}).start();
	}

	public void showTenderPackInfo(){
		styledText.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.NORMAL));
		styledText.setText("["+tenderProjectEntity.getTenderNo()+"]" + tenderProjectEntity.getTenderName());
		StyleRange styleRange = new StyleRange(); 
		styleRange.start = 0;
		styleRange.length = 1;
		styleRange.foreground = SWTResourceManager.getColor(100, 100, 100);
		styledText.setStyleRange(styleRange);
		styleRange.start = tenderProjectEntity.getTenderNo().length() + 1;
		styleRange.length = 1;
		styledText.setStyleRange(styleRange);
		
		StyleRange tenderNoStyle = new StyleRange(); 
		tenderNoStyle.start = 1;
		tenderNoStyle.length = tenderProjectEntity.getTenderNo().length();
		tenderNoStyle.font = SWTResourceManager.getFont("微软雅黑", 12, SWT.BOLD);
		tenderNoStyle.foreground = SWTResourceManager.getColor(209, 89, 88);
		styledText.setStyleRange(tenderNoStyle);
		
		StyleRange tenderNameStyle = new StyleRange(); 
		tenderNameStyle.start = tenderProjectEntity.getTenderNo().length() + 2;
		tenderNameStyle.length = tenderProjectEntity.getTenderName().length();
		tenderNameStyle.foreground = SWTResourceManager.getColor(102, 102, 102);
		styledText.setStyleRange(tenderNameStyle);
	}
	
	/**
	 * @Description: 显示统计数据
	 * @author guoyr 
	 */
	private void showStatusCount(){
		tenderCountBtn.setText(tenderProjectOpeningInfo.getTenderCount()+Messages.SupplierCouns);
		if(showOpeningCount && tenderProjectOpeningInfo.getOpeningCount() > 0){
			effectiveCountBtn.setStatusName(Messages.Opening_ecryptable);
			effectiveCountBtn.setText(tenderProjectOpeningInfo.getOpeningCount()+Messages.SupplierCouns);
		}else {
			effectiveCountBtn.setStatusName(Messages.Opening_canOpening);
			effectiveCountBtn.setText(tenderProjectOpeningInfo.getThreeTenderCount()+Messages.SupplierCouns);
		}
//		effectiveCountBtn.setText((tenderPackOpeningInfo.getTenderCount() - tenderPackOpeningInfo.getRevokeCount() - tenderPackOpeningInfo.getInvalidCount())+Messages.SupplierCouns);
		signCountBtn.setText(tenderProjectOpeningInfo.getSignCount()+Messages.SupplierCouns);
		descCountBtn.setText(tenderProjectOpeningInfo.getDecCount()+Messages.SupplierCouns);
		confirmCountBtn.setText(tenderProjectOpeningInfo.getConfirmCount()+Messages.SupplierCouns);
	}
	
	/**
	 * @Description: 显示包件列表
	 * @author guoyr 
	 */
	private void showTenderPackList(final int type){
		CUR_TYPE = type;
		if(null != curStatusCount){
//			curStatusCount.setSelection(false);
		}
		if(type == 1){
			curStatusCount = signCountBtn;
		}else if(type == 2){
			curStatusCount = descCountBtn;
		}else if(type == 3){
			curStatusCount = descCountBtn;
		}else if(type == 4){
//			curStatusCount = complateStatusCount;
		}else {
			curStatusCount = tenderCountBtn;
		}
//		curStatusCount.setSelection(true);
		new Thread(new Runnable(){
			private int supplierListHeight = 300;
			public void run(){
				if(null == tenderPackOpeningInfoList || tenderPackOpeningInfoList.size() == 0){
					tenderPackOpeningInfoList = tenderProjectService.getTenderPackOpeningInfoList(tenderProjectOpeningInfo.getTenderProject().getId(), bidopeningStage);
				}
				Display.getDefault().syncExec(new Runnable(){
					public void run(){
						if(!decryptSupplierComposite.isDisposed()){
							supplierListHeight = scrolledComposite.getBounds().height - gl_decryptSupplierComposite.marginHeight * 2 - gl_decryptSupplierComposite.marginTop - gl_decryptSupplierComposite.marginBottom;
							PAGE_SIZE = supplierListHeight / (TenderPackOpeningListItemComposite.rowHeight + gl_decryptSupplierComposite.verticalSpacing);
							if(null != tenderPackOpeningInfoList && tenderPackOpeningInfoList.size() > PAGE_SIZE && !pageComposite.getVisible()){
								supplierListHeight -= Math.max(pageComposite.getBounds().height, 31);
								PAGE_SIZE = supplierListHeight / (TenderPackOpeningListItemComposite.rowHeight + gl_decryptSupplierComposite.verticalSpacing);
							}
						}
					}
				});
				final Page<TenderPackOpeningInfo> projectPage = new Page<TenderPackOpeningInfo>();
				if(null != tenderPackOpeningInfoList){
					int totalCount = 0;
					List<TenderPackOpeningInfo> tenderPackList = new ArrayList<TenderPackOpeningInfo>();
					int pageStart = (PAGE_NO-1) * PAGE_SIZE;
					for(TenderPackOpeningInfo tenderPackOpeningInfo : tenderPackOpeningInfoList){
						if(null != tenderPackOpeningInfo){
							boolean isJoin = false;
							if(type == 1){
								isJoin = tenderPackOpeningInfo.isSignComplate();
							}else if(type == 2){
								isJoin = tenderPackOpeningInfo.isDecComplate();
							}else if(type == 3){
								isJoin = tenderPackOpeningInfo.isConfirmComplate();
							}else if(type == 4){
								isJoin = tenderPackOpeningInfo.isComplate();
							}else {
								isJoin = true;
							}
							
							if(isJoin){
								if(totalCount >= pageStart && totalCount < pageStart + PAGE_SIZE){
									tenderPackList.add(tenderPackOpeningInfo);
								} 
								totalCount ++;
							}
						}
					}
					projectPage.setRecords(tenderPackList);
					projectPage.setCurrent(PAGE_NO);
					projectPage.setSize(PAGE_SIZE);
					projectPage.setTotal(totalCount);
				}
				
				Display.getDefault().syncExec(new Runnable(){
					public void run(){
						if(!decryptSupplierComposite.isDisposed()){
							decryptSupplierComposite.setData("isFocus", isFocus ? "1" : null);
							for(Control control : decryptSupplierComposite.getChildren()){
								control.dispose();
							}
							List<TenderPackOpeningStatus> curPageTenderPackOpeningStatusList = new ArrayList<TenderPackOpeningStatus>();
							int width = decryptSupplierComposite.getBounds().width;
							int totalHeight = 0;
							if(null != projectPage && null != projectPage.getRecords() && projectPage.getSize() > 0){
								for(TenderPackOpeningInfo tenderPackOpeningInfo : projectPage.getRecords()){
									TenderProjectEntity tenderPack = tenderPackOpeningInfo.getTenderProject();
									
									TenderPackOpeningListItemComposite tenderPackOpeningListItemComposite = new TenderPackOpeningListItemComposite(decryptSupplierComposite, SWT.NONE);
									tenderPackOpeningListItemComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1));
									GridData gd_item = new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1);
									gd_item.widthHint = 500;
									tenderPackOpeningListItemComposite.setLayoutData(gd_item);
									totalHeight += tenderPackOpeningListItemComposite.computeSize(width, SWT.DEFAULT).y;
									tenderPackOpeningListItemComposite.addBatchRemoteBidOpeningListener(batchRemoteBidOpeningListener);
									tenderPackOpeningListItemComposite.setTenderPack(tenderPack);
									tenderPackOpeningListItemComposite.refreshTenderPackOpeningInfo(tenderPackOpeningInfo, tenderProjectRuleEntity, bidopeningStage, showOpeningCount, false);
									curPageTenderPackOpeningStatusList.add(tenderPackOpeningListItemComposite);
								}
							}
							
							boolean oldVisible = pageComposite.getVisible();
							if(projectPage.getPages() > 1){
								pageComposite.refreshPages(projectPage);
								if(!oldVisible){
									((GridData)pageComposite.getLayoutData()).exclude = false;
									pageComposite.setVisible(true);
								}
							}else {
								if(oldVisible){
									((GridData)pageComposite.getLayoutData()).exclude = true;
									pageComposite.setVisible(false);
								}
							}
							if(!decryptMainComposite.isDisposed()){
								decryptMainComposite.layout();
								if(projectPage.getSize() > 0){
									supplierListHeight = scrolledComposite.getBounds().height - gl_decryptSupplierComposite.marginHeight * 2 - gl_decryptSupplierComposite.marginTop - gl_decryptSupplierComposite.marginBottom;
									int surplusHeight = supplierListHeight - projectPage.getSize() * gl_decryptSupplierComposite.verticalSpacing - totalHeight;
									if(surplusHeight > 0){
										int perHeight = surplusHeight/projectPage.getSize();
										for(TenderPackOpeningStatus tenderPackOpeningStatus : curPageTenderPackOpeningStatusList){
											TenderPackOpeningListItemComposite tenderPackOpeningListItemComposite = (TenderPackOpeningListItemComposite)tenderPackOpeningStatus;
											int height = tenderPackOpeningListItemComposite.computeSize(width, SWT.DEFAULT).y + perHeight;
											((GridData)tenderPackOpeningListItemComposite.getLayoutData()).heightHint = height > 70 ? 70 : height;
										}
									}
								}
								decryptSupplierComposite.layout();
								scrolledComposite.setMinSize(decryptSupplierComposite.computeSize(SWT.DEFAULT, SWT.DEFAULT));
							}
							
						}
					}
				});
			}
		}).start();
	}
	
	
	/**
	 * @Description: 在线同步报价
	 * @author guoyr 
	 */
	private void downloadBidPriceAction(){
		final MessageViewDialog dialog = new MessageViewDialog(getShell(),-1);
		dialog.setTitle(Messages.Button_syncQuoteInfo);
		DownloadSupplierBidPriceUtils downloadSupplierBidPriceUtils = new DownloadSupplierBidPriceUtils(tenderProjectEntity);
		final int[] downloadSuccess = new int[]{0};
		CallBack callBack = new CallBack(){
			public void callBackString(String msg) {
				dialog.getCallBack().callBackString(msg);
			}
			
			public void after() {
				dialog.getCallBack().after();
			}
			public void callBackBoolean(boolean bool) {
				if(bool){
					downloadSuccess[0]++;
				}
			}
		};
		int count = 0;
//		for(Supplier supplier : supplierList){
//			if(null != supplier.getTenderTime()){
//				count ++;
//				downloadSupplierBidPriceUtils.downloadBidPrice(supplier, callBack);
//			}
//		}
//		if(count == 0){
//			dialog.getCallBack().callBackString(MessageFormat.format(Messages.Tips_noSupplierTendered, SUPPLIER_NAME));
//		}
//		dialog.open();
//		if(downloadSuccess[0] > 0){
//			tenderPackOpeningInfo = tenderProjectService.getTenderPackOpeningInfo(tenderPack.getId(), bidopeningStage);
//			showStatusCount();
//			if(null != batchRemoteBidOpeningListener){
//				batchRemoteBidOpeningListener.refreshDescInfo(tenderPackOpeningInfo);
//			}
//		}
	}
	
	/**
	 * Create contents of the shell.
	 */
	protected void createContents() {
		setText("项目开标明细");
		setSize(800, 600);
	}

	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}
}
