package com.gx.obe.opening.shell;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.swt.SWT;
import org.eclipse.swt.core.CallBack;
import org.eclipse.swt.core.utils.WidgetUtils;
import org.eclipse.swt.core.widgets.ELink;
import org.eclipse.swt.core.widgets.ESepator;
import org.eclipse.swt.core.widgets.ImageButton;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.custom.StyleRange;
import org.eclipse.swt.custom.StyledText;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;

import com.gx.obe.ColorConstants;
import com.gx.obe.common.icons.IconsActivator;
import com.gx.obe.common.widget.dialog.MessageViewDialog;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.config.ConfigConstants;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.message.Messages;
import com.gx.obe.opening.composite.RemoteDecryptPackDetailComposite;
import com.gx.obe.opening.composite.TenderPackBidOpeningDetailComposite;
import com.gx.obe.opening.listener.BatchRemoteDecryptListener;
import com.gx.obe.opening.thread.DownloadSupplierBidPriceUtils;
import com.gx.obe.opening.widgets.BidOpeningStatusButton;
import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.entity.tender.TenderProjectRuleEntity;
import com.gx.obe.web.service.SupplierService;
import com.gx.obe.web.service.TenderProjectService;
import com.gx.obe.web.vo.TenderPackOpeningInfo;
import com.gx.utils.NowTimeUtils;
import com.swtdesigner.ResourceManager;
import com.swtdesigner.SWTResourceManager;

public class TenderPackOpeningSupplierDetailsShell extends Shell {

	private Composite tenderPackOpeningListItemComposite;
	private SupplierService supplierService = new SupplierService();
	private TenderProjectService tenderProjectService ;
	private TenderProjectEntity tenderPack;
	private String bidopeningStage;
	private TenderPackOpeningInfo tenderPackOpeningInfo;
	private TenderProjectRuleEntity tenderProjectRuleEntity;
	private StyledText styledText;
	private BidOpeningStatusButton tenderCountBtn;
	private BidOpeningStatusButton effectiveCountBtn;
	private BidOpeningStatusButton signCountBtn;
	private BidOpeningStatusButton descCountBtn;
	private BidOpeningStatusButton confirmCountBtn;
	private Composite loadContent;
	private List<Supplier> supplierList;
	private ELink viewBidopeningResult_btn;
	private ELink showDecryptDetail_btn;
	private boolean isFocus = false;
	private BatchRemoteDecryptListener batchRemoteBidOpeningListener;
	private ELink downloadBidPrice_btn;
	private ELink sign_btn;

	/**
	 * Create the shell.
	 * @param tenderPackOpeningInfo 
	 * @param display
	 */
	public TenderPackOpeningSupplierDetailsShell(Shell parentShell, TenderPackOpeningInfo tenderPackOpeningInfo, TenderProjectRuleEntity tenderProjectRuleEntity, String bidopeningStage) {
		super(parentShell, SWT.NO_TRIM | SWT.PRIMARY_MODAL);
		setBackground(ColorConstants.BORDER_LINE_COLOR);
		setBackgroundMode(SWT.INHERIT_FORCE);
		GridLayout gridLayout = new GridLayout(1, false);
		gridLayout.verticalSpacing = 0;
		gridLayout.horizontalSpacing = 0;
		gridLayout.marginHeight = 1;
		gridLayout.marginWidth = 1;
		setLayout(gridLayout);
		
		this.bidopeningStage = bidopeningStage;
		this.tenderPackOpeningInfo = tenderPackOpeningInfo;
		this.tenderProjectRuleEntity = tenderProjectRuleEntity;
		if(null != parentShell.getData("isFocus")){
			isFocus = true;
		}
		
		Composite composite_2 = new Composite(this, SWT.NONE);
		composite_2.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_composite_2 = new GridLayout(1, false);
		gl_composite_2.marginWidth = 1;
		gl_composite_2.verticalSpacing = 0;
		gl_composite_2.horizontalSpacing = 0;
		gl_composite_2.marginHeight = 1;
		composite_2.setLayout(gl_composite_2);
		composite_2.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		
		tenderPackOpeningListItemComposite = new Composite(composite_2, SWT.NONE);
		tenderPackOpeningListItemComposite.setBackground(SWTResourceManager.getColor(249, 253, 254));
//		tenderPackOpeningListItemComposite.setBackground(ColorConstants.SKIN_BG);
		GridLayout gl_tenderPackOpeningListItemComposite = new GridLayout(11, false);
		gl_tenderPackOpeningListItemComposite.marginWidth = 5;
		gl_tenderPackOpeningListItemComposite.horizontalSpacing = 2;
		gl_tenderPackOpeningListItemComposite.marginHeight = 0;
		tenderPackOpeningListItemComposite.setLayout(gl_tenderPackOpeningListItemComposite);
		tenderPackOpeningListItemComposite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
		
		styledText = new StyledText(tenderPackOpeningListItemComposite, SWT.READ_ONLY);
		styledText.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, true, 1, 1));
		
		tenderCountBtn = new BidOpeningStatusButton(tenderPackOpeningListItemComposite, SWT.NONE);
		GridData gd_tenderCountBtn = new GridData(SWT.FILL, SWT.CENTER, false, true, 1, 1);
//		gd_tenderCountBtn.widthHint = 50;
		tenderCountBtn.setLayoutData(gd_tenderCountBtn);
		tenderCountBtn.setForeground(SWTResourceManager.getColor(41, 150, 206));
		tenderCountBtn.setFont(SWTResourceManager.getFont("微软雅黑", 13, SWT.NORMAL));
		tenderCountBtn.setStatusName(Messages.Opening_tendered);
		tenderCountBtn.setText(" 0 个");
		
		effectiveCountBtn = new BidOpeningStatusButton(tenderPackOpeningListItemComposite, SWT.NONE);
		GridData gd_effectiveCountBtn = new GridData(SWT.FILL, SWT.CENTER, false, true, 1, 1);
//		gd_effectiveCountBtn.widthHint = 50;
		effectiveCountBtn.setLayoutData(gd_effectiveCountBtn);
		effectiveCountBtn.setForeground(SWTResourceManager.getColor(41, 150, 206));
		effectiveCountBtn.setFont(SWTResourceManager.getFont("微软雅黑", 13, SWT.NORMAL));
		effectiveCountBtn.setStatusName(Messages.Opening_ecryptable);
		effectiveCountBtn.setText(" 0 个");
		
		signCountBtn = new BidOpeningStatusButton(tenderPackOpeningListItemComposite, SWT.NONE);
		GridData gd_signCountBtn = new GridData(SWT.FILL, SWT.CENTER, false, true, 1, 1);
//		gd_signCountBtn.widthHint = 50;
		signCountBtn.setLayoutData(gd_signCountBtn);
		signCountBtn.setForeground(SWTResourceManager.getColor(41, 150, 206));
		signCountBtn.setFont(SWTResourceManager.getFont("微软雅黑", 13, SWT.NORMAL));
		signCountBtn.setStatusName(Messages.Opening_signedIn);
		signCountBtn.setText(" 0 个");
		
		descCountBtn = new BidOpeningStatusButton(tenderPackOpeningListItemComposite, SWT.NONE);
		GridData gd_descCountBtn = new GridData(SWT.FILL, SWT.CENTER, false, true, 1, 1);
//		gd_descCountBtn.widthHint = 50;
		descCountBtn.setLayoutData(gd_descCountBtn);
		descCountBtn.setForeground(SWTResourceManager.getColor(41, 150, 206));
		descCountBtn.setFont(SWTResourceManager.getFont("微软雅黑", 13, SWT.NORMAL));
		descCountBtn.setStatusName(Messages.Opening_decrypted);
		descCountBtn.setText(" 0 个");
		
		confirmCountBtn = new BidOpeningStatusButton(tenderPackOpeningListItemComposite, SWT.NONE);
		GridData gd_confirmCountBtn = new GridData(SWT.FILL, SWT.CENTER, false, true, 1, 1);
//		gd_confirmCountBtn.widthHint = 50;
		confirmCountBtn.setLayoutData(gd_confirmCountBtn);
		confirmCountBtn.setForeground(SWTResourceManager.getColor(41, 150, 206));
		confirmCountBtn.setFont(SWTResourceManager.getFont("微软雅黑", 13, SWT.NORMAL));
		confirmCountBtn.setStatusName(Messages.Opening_confirmed);
		confirmCountBtn.setText(" 0 个");
		
		showDecryptDetail_btn = new ELink(tenderPackOpeningListItemComposite, SWT.NONE);
		showDecryptDetail_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/decrypt.png"));
		showDecryptDetail_btn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				showDecryptDetail();
			}
		});
		showDecryptDetail_btn.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		showDecryptDetail_btn.setLayoutData(new GridData(SWT.RIGHT, SWT.FILL, false, false, 1, 1));
		showDecryptDetail_btn.setText(Messages.BidOpeningResult);
		
		viewBidopeningResult_btn = new ELink(tenderPackOpeningListItemComposite, SWT.NONE);
		viewBidopeningResult_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/items.png"));
		viewBidopeningResult_btn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				showBidOpeningResult();
			}
		});
		viewBidopeningResult_btn.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		viewBidopeningResult_btn.setLayoutData(new GridData(SWT.RIGHT, SWT.FILL, false, false, 1, 1));
		viewBidopeningResult_btn.setText(Messages.BidPrice);
		
		downloadBidPrice_btn = new ELink(tenderPackOpeningListItemComposite, SWT.NONE);
		downloadBidPrice_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/download.png"));
		downloadBidPrice_btn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				downloadBidPriceAction();
			}
		});
		downloadBidPrice_btn.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		downloadBidPrice_btn.setLayoutData(new GridData(SWT.RIGHT, SWT.FILL, false, false, 1, 1));
		downloadBidPrice_btn.setText(Messages.Button_syncQuoteInfo);
		
		sign_btn = new ELink(tenderPackOpeningListItemComposite, SWT.NONE);
		sign_btn.setImage(ResourceManager.getPluginImage(IconsActivator.PLUGIN_ID, "icons/btn/blue/sing.png"));
		sign_btn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				signBidAction();
			}
		});
		sign_btn.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		sign_btn.setLayoutData(new GridData(SWT.RIGHT, SWT.FILL, false, false, 1, 1));
		sign_btn.setText(Messages.Button_signBid);
		
		ImageButton close_btn = createButton(Messages.Button_close, null, SWTResourceManager.getColor(SWT.COLOR_RED), SWTResourceManager.getColor(SWT.COLOR_RED));
		close_btn.addMouseListener(new MouseAdapter() {
			public void mouseUp(MouseEvent e) {
				close();
			}
		});
		
		ESepator label = new ESepator(tenderPackOpeningListItemComposite, SWT.NONE);
		label.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 10, 1));
		label.setBackground(SWTResourceManager.getColor(224, 224, 224));
		label.setBackground(SWTResourceManager.getColor(41, 150, 206));
		label.setLineWidth(3);
//		label.setLineStyle(SWT.LINE_DOT);
		
		loadContent = new Composite(composite_2, SWT.NONE);
		loadContent.setBackground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		GridLayout gl_composite_1 = new GridLayout(1, false);
		gl_composite_1.verticalSpacing = 0;
		gl_composite_1.horizontalSpacing = 0;
		loadContent.setLayout(gl_composite_1);
		loadContent.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 2, 1));
		tenderProjectService = new TenderProjectService();
		init();
		createContents();
	}

	/**
	 * @Description: 初始化
	 * @author guoyr 
	 */
	private void init() {
		WidgetUtils.setControlVisible(tenderCountBtn, false);
		WidgetUtils.setControlVisible(effectiveCountBtn, false);
		WidgetUtils.setControlVisible(signCountBtn, false);
		WidgetUtils.setControlVisible(descCountBtn, false);
		WidgetUtils.setControlVisible(confirmCountBtn, false);
		WidgetUtils.setControlVisible(tenderCountBtn, false);
		
		tenderPack = tenderPackOpeningInfo.getTenderProject();
		// 打开详情的时候重新查询，并刷新
		showTenderPackInfo();
		showStatusCount();
		
		supplierList = getSupplierOpenBidList(tenderPackOpeningInfo.getTenderProject().getId());
		showDecryptDetail();
		if(null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_BUS_TEC)){
			((GridData)viewBidopeningResult_btn.getLayoutData()).exclude = true;
			viewBidopeningResult_btn.setVisible(false);
			((GridData)sign_btn.getLayoutData()).exclude = true;
			sign_btn.setVisible(false);
			((GridData)showDecryptDetail_btn.getLayoutData()).exclude = true;
			showDecryptDetail_btn.setVisible(false);
			((GridData)downloadBidPrice_btn.getLayoutData()).exclude = true;
			downloadBidPrice_btn.setVisible(false);
			tenderPackOpeningListItemComposite.layout();
		}
		
		if(isFocus || PropertiesUtils.getProperty(ConfigConstants.SHOW_SIGN_INFO_STATUS, "01").equals("00")){
			((GridData)signCountBtn.getLayoutData()).exclude = true;
			signCountBtn.setVisible(false);
		}
		
		if(PropertiesUtils.getProperty(ConfigConstants.SHOW_CONFIRM_STATUS, "00").equals("00")){
			((GridData)confirmCountBtn.getLayoutData()).exclude = true;
			confirmCountBtn.setVisible(false);
		}
		new Thread(new Runnable(){
			public void run(){
				tenderPackOpeningInfo = tenderProjectService.getTenderPackOpeningInfo(tenderPack.getId(), bidopeningStage);
				Display.getDefault().syncExec(new Runnable(){
					public void run(){
						if(!tenderCountBtn.isDisposed()){
							showStatusCount();
						}
					}
				});
				if(null != batchRemoteBidOpeningListener){
					batchRemoteBidOpeningListener.refreshDescInfo(tenderPackOpeningInfo);
				}
			}
		}).start();
	}

	/**
	 * @Description: 刷新
	 * @author guoyr 
	 */
	private void refresh(){
		showStatusCount();
		supplierList = getSupplierOpenBidList(tenderPackOpeningInfo.getTenderProject().getId());
	}

	private List<Supplier> getSupplierOpenBidList(String tenderId){
		if(null == supplierList){
			supplierList = new ArrayList<Supplier>();
		}else {
			supplierList.clear();
		}

//		long start = Calendar.getInstance().getTimeInMillis();
//		List<Map<String, Object>> supplierMapList = supplierService.getSupplierBidOpeningInfoList(tenderId);
//		System.out.println("  查询  "+ (Calendar.getInstance().getTimeInMillis() - start));
//		start = Calendar.getInstance().getTimeInMillis();
//		if(null != supplierMapList){
//			for(Map<String, Object> supplierMap : supplierMapList){
//				Supplier supplier = new Supplier();
//				supplier.setId((String)supplierMap.get("SUPPLIER_ID"));
//				supplier.setOrgCode((String)supplierMap.get("ORG_CODE"));
//				supplier.setSupplierName((String)supplierMap.get("SUPPLIER_NAME"));
//				supplier.setTenderTime((Date)supplierMap.get("TENDER_TIME"));
//				supplier.setSignTime((Date)supplierMap.get("SIGN_TIME"));
//				supplier.setSignPerson((String)supplierMap.get("SIGN_PERSON"));
//				supplier.setPriceSignTime((Date)supplierMap.get("PRICE_SIGN_TIME"));
//				supplier.setPriceSignPerson((String)supplierMap.get("PRICE_SIGN_PERSON"));
//				supplier.setPriceSignPerson((String)supplierMap.get("PRICE_SIGN_PERSON"));
//				SupplierOpeningResult supplierOpeningResult = new SupplierOpeningResult();
//				supplierOpeningResult.setId((String)supplierMap.get("OPENING_RESULT_ID"));
//				supplierOpeningResult.setRevokeStatus((String)supplierMap.get("REVOKE_STATUS"));
//				supplierOpeningResult.setBusinessBidStatus((String)supplierMap.get("BUSINESS_BID_STATUS"));
//				supplierOpeningResult.setTechnologyBidStatus((String)supplierMap.get("TECHNOLOGY_BID_STATUS"));
//				supplierOpeningResult.setPriceBidStatus((String)supplierMap.get("PRICE_BID_STATUS"));
//				supplierOpeningResult.setBidOpeningStatus((String)supplierMap.get("BID_OPENING_STATUS"));
//				supplierOpeningResult.setBidOpeningTime((Date)supplierMap.get("BID_OPENING_TIME"));
//				supplierOpeningResult.setPriceBidOpeningTime((Date)supplierMap.get("PRICE_BID_OPENING_TIME"));
//				supplier.setSupplierOpeningResult(supplierOpeningResult);
//				supplierList.add(supplier);
//			}
//			
//		System.out.println("组装"+ (Calendar.getInstance().getTimeInMillis() - start));
//		}
//		start = Calendar.getInstance().getTimeInMillis();
		supplierList = supplierService.getSupplierOpenBidList(tenderId);
//		System.out.println(Calendar.getInstance().getTimeInMillis() - start);
		return supplierList;
	}
	public void showTenderPackInfo(){
		styledText.setFont(SWTResourceManager.getFont("微软雅黑", 12, SWT.NORMAL));
		styledText.setText("["+tenderPack.getTenderNo()+"]" + tenderPack.getTenderName());
		StyleRange styleRange = new StyleRange(); 
		styleRange.start = 0;
		styleRange.length = 1;
		styleRange.foreground = SWTResourceManager.getColor(100, 100, 100);
		styledText.setStyleRange(styleRange);
		styleRange.start = tenderPack.getTenderNo().length() + 1;
		styleRange.length = 1;
		styledText.setStyleRange(styleRange);
		
		StyleRange tenderNoStyle = new StyleRange(); 
		tenderNoStyle.start = 1;
		tenderNoStyle.length = tenderPack.getTenderNo().length();
		tenderNoStyle.font = SWTResourceManager.getFont("微软雅黑", 12, SWT.BOLD);
		tenderNoStyle.foreground = SWTResourceManager.getColor(209, 89, 88);
		styledText.setStyleRange(tenderNoStyle);
		
		StyleRange tenderNameStyle = new StyleRange(); 
		tenderNameStyle.start = tenderPack.getTenderNo().length() + 2;
		tenderNameStyle.length = tenderPack.getTenderName().length();
		tenderNameStyle.foreground = SWTResourceManager.getColor(102, 102, 102);
		styledText.setStyleRange(tenderNameStyle);
	}
	
	/**
	 * @Description: 显示统计数据
	 * @author guoyr 
	 */
	private void showStatusCount(){
		tenderCountBtn.setText(tenderPackOpeningInfo.getTenderCount()+Messages.SupplierCouns);
		if(tenderPackOpeningInfo.getOpeningCount() > 0){
			effectiveCountBtn.setStatusName(Messages.Opening_ecryptable);
			effectiveCountBtn.setText(tenderPackOpeningInfo.getOpeningCount()+Messages.SupplierCouns);
		}else {
			effectiveCountBtn.setStatusName(Messages.Opening_canOpening);
			effectiveCountBtn.setText(tenderPackOpeningInfo.getThreeTenderCount()+Messages.SupplierCouns);
		}
//		effectiveCountBtn.setText(tenderPackOpeningInfo.getOpeningCount()+Messages.SupplierCouns);
//		effectiveCountBtn.setText((tenderPackOpeningInfo.getTenderCount() - tenderPackOpeningInfo.getRevokeCount() - tenderPackOpeningInfo.getInvalidCount())+Messages.SupplierCouns);
		signCountBtn.setText(tenderPackOpeningInfo.getSignCount()+Messages.SupplierCouns);
		descCountBtn.setText(tenderPackOpeningInfo.getDecCount()+Messages.SupplierCouns);
		confirmCountBtn.setText(tenderPackOpeningInfo.getConfirmCount()+Messages.SupplierCouns);
	}
	
	/**
	 * @Description: 显示解密详情
	 * @author guoyr 
	 */
	private void showDecryptDetail(){
		for(Control control : loadContent.getChildren()){
			control.dispose();
		}
		if(null != supplierList){
			
			ScrolledComposite scrolledComposite = new ScrolledComposite(loadContent, SWT.H_SCROLL | SWT.V_SCROLL);
			scrolledComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
			scrolledComposite.setExpandHorizontal(true);
			scrolledComposite.setExpandVertical(true);
			
			Composite remoteDecryptComposite = new Composite(scrolledComposite, SWT.NONE);
			remoteDecryptComposite.setLayout(new GridLayout(1, false));
			scrolledComposite.setContent(remoteDecryptComposite);
			scrolledComposite.setMinSize(remoteDecryptComposite.computeSize(SWT.DEFAULT, SWT.DEFAULT));
			
			
			int supplierCount = 0;
			int index = 1;
			boolean isAnonymous = false;
			if(tenderProjectRuleEntity.getIsAnonymous()) {
				if (TenderProjectEnum.STAGE_PRICE.equals(bidopeningStage)) {
					if(null != tenderProjectRuleEntity.getPriceBidOpeningTime() && tenderProjectRuleEntity.getPriceBidOpeningTime().after(NowTimeUtils.getNowDate())){
						isAnonymous = true;
					}else if(null != tenderProjectRuleEntity.getBidOpeningStartTime() && tenderProjectRuleEntity.getBidOpeningStartTime().after(NowTimeUtils.getNowDate())){
						isAnonymous = true;
					}
				}
			}
			for (Supplier supplier : supplierList) {
				supplier.setAnonymous(isAnonymous);
				if(null != supplier.getTenderTime()){
					if(isFocus){
						remoteDecryptComposite.setData("isFocus", "1");
					}
					RemoteDecryptPackDetailComposite composite = new RemoteDecryptPackDetailComposite(remoteDecryptComposite, SWT.NONE);
					composite.setLayoutData(new GridData(SWT.FILL, SWT.CENTER, true, false, 1, 1));
					composite.refresh(index ++, tenderPack, supplier, bidopeningStage);
					supplierCount ++;
				}
			}
			if(supplierCount < 6){
				((GridLayout)remoteDecryptComposite.getLayout()).verticalSpacing = 10;
			}
			remoteDecryptComposite.layout();
			scrolledComposite.setMinSize(remoteDecryptComposite.computeSize(SWT.DEFAULT, SWT.DEFAULT));
			scrolledComposite.getVerticalBar().setIncrement(100);
			scrolledComposite.forceFocus();
//			addListener(SWT.Activate, new Listener() {
//				public void handleEvent(Event e) {
//					scrolledComposite.setFocus();
//				}
//			});
			loadContent.layout();
		}
	}
	
	/**
	 * @Description: 在线同步报价
	 * @author guoyr 
	 */
	private void downloadBidPriceAction(){
		final MessageViewDialog dialog = new MessageViewDialog(getShell(),-1);
		dialog.setTitle(Messages.Button_syncQuoteInfo);
		DownloadSupplierBidPriceUtils downloadSupplierBidPriceUtils = new DownloadSupplierBidPriceUtils(tenderPack);
		final int[] downloadSuccess = new int[]{0};
		CallBack callBack = new CallBack(){
			public void callBackString(String msg) {
				dialog.getCallBack().callBackString(msg);
			}
			
			public void after() {
				dialog.getCallBack().after();
			}
			public void callBackBoolean(boolean bool) {
				if(bool){
					downloadSuccess[0]++;
				}
			}
		};
		int count = 0;
		for(Supplier supplier : supplierList){
			if(null != supplier.getTenderTime()){
				count ++;
				downloadSupplierBidPriceUtils.downloadBidPrice(supplier, callBack);
			}
		}
		if(count == 0){
			dialog.getCallBack().callBackString(Messages.Tips_noSyncQuotation);
		}
		dialog.open();
		if(downloadSuccess[0] > 0){
			tenderPackOpeningInfo = tenderProjectService.getTenderPackOpeningInfo(tenderPack.getId(), bidopeningStage);
			showStatusCount();
			if(null != batchRemoteBidOpeningListener){
				batchRemoteBidOpeningListener.refreshDescInfo(tenderPackOpeningInfo);
			}
		}
	}
	
	/**
	 * @Description: 显示开标结果（开标一览表）
	 * @author guoyr 
	 */
	private void showBidOpeningResult(){
		for(Control control : loadContent.getChildren()){
			control.dispose();
		}
		TenderPackBidOpeningDetailComposite tenderPackBidOpeningDetailComposite = new TenderPackBidOpeningDetailComposite(loadContent, SWT.NONE);
		tenderPackBidOpeningDetailComposite.refresh(tenderPack, tenderProjectRuleEntity, supplierList);
		tenderPackBidOpeningDetailComposite.setLayoutData(new GridData(SWT.FILL, SWT.FILL, true, true, 1, 1));
		loadContent.layout();
		
	}
	/**
	 * @Description: 显示开标结果（开标一览表）
	 * @author guoyr 
	 */
	private void signBidAction(){
		SingBidShell singBidShell = new SingBidShell(getShell(), tenderPack);
		singBidShell.open();
		
	}
	
	
	public void addBatchRemoteBidOpeningListener(BatchRemoteDecryptListener batchRemoteBidOpeningListener){
		this.batchRemoteBidOpeningListener = batchRemoteBidOpeningListener;
		
	}
	
	private ImageButton createButton(String text, Image image, Color border, Color bgColor){
		ImageButton imageButton = new ImageButton(tenderPackOpeningListItemComposite, SWT.NONE);
		imageButton.setArcWidth(100);
		imageButton.setLeftMargin(10);
		imageButton.setRightMargin(10);
		imageButton.setTopMargin(10);
		imageButton.setBottomMargin(10);
		imageButton.setText(text);
		imageButton.setBorderColor(border);
		imageButton.setActiveBackgroundColor(bgColor);
		imageButton.setActiveForeground(SWTResourceManager.getColor(SWT.COLOR_WHITE));
		
		imageButton.setFont(SWTResourceManager.getFont("微软雅黑", 10, SWT.NORMAL));
		imageButton.setForeground(SWTResourceManager.getColor(SWT.COLOR_RED));
		GridData gd_btn = new GridData(SWT.CENTER, SWT.CENTER, false, false, 1, 1);
		gd_btn.heightHint = 35;
		imageButton.setLayoutData(gd_btn);
		
		return imageButton;
	}
	/**
	 * Create contents of the shell.
	 */
	protected void createContents() {
		setText("开标结果明细");
		setSize(800, 600);
	}

	@Override
	protected void checkSubclass() {
		// Disable the check that prevents subclassing of SWT components
	}
}
