package com.gx.obe.opening.thread;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.List;

import com.gx.obe.business.http.HttpUtils;
import com.gx.obe.common.widget.thread.MyRunnable;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.config.ConfigConstants;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.listener.BidPriceResolveListener;
import com.gx.obe.opening.listener.BatchRemoteDecryptListener;
import com.gx.obe.util.utils.StringUtils;
import com.gx.obe.web.entity.TransactionServer;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.entity.tender.TenderProjectRuleEntity;
import com.gx.obe.web.service.TenderProjectService;
import com.gx.obe.web.vo.TenderPackOpeningInfo;
import com.gx.utils.ActionLogUtils;

public class BatchDownRemoteBidOpeningResultThread extends MyRunnable{

	
	private Thread thread;
	private TenderProjectEntity tenderProjectEntity;
	private String bidopeningStage;
	
	private BatchRemoteDecryptListener remoteProjectBidOpeningListener;
	private TenderProjectService tenderProjectService ;
//	private RemoteProjectSignInfoThread remoteProjectSignInfoThread;
	private RemoteProjectDecryptInfoThread remoteProjectBidOpeningInfoThread;

	
	public BatchDownRemoteBidOpeningResultThread(TenderProjectEntity tenderProjectEntity, TenderProjectRuleEntity tenderProjectRuleEntity, String bidopeningStage, BatchRemoteDecryptListener rempteProjectBidOpeningListener){
		this.tenderProjectEntity = tenderProjectEntity;
		this.bidopeningStage = bidopeningStage;
		this.remoteProjectBidOpeningListener = rempteProjectBidOpeningListener;
	}
	
	
	public void start(){
		thread = new Thread(this);
		thread.setName(tenderProjectEntity.getTenderName()+"[下载解密信息线程]" + bidopeningStage);
		thread.start();
	}
	
	public void stop(){
		
//		if(null != remoteProjectSignInfoThread){
//			remoteProjectSignInfoThread.stop();
//			remoteProjectSignInfoThread = null;
//		}
		if(null != remoteProjectBidOpeningInfoThread){
			remoteProjectBidOpeningInfoThread.stop();
			remoteProjectBidOpeningInfoThread = null;
		}
		thread = null;
		BidPriceResolveListener.stopDownloadPriceThread();
	}
	public void join(){
		if(null != thread){
			try {
				thread.join();
			} catch (InterruptedException e) {
			}
		}
	}
	public void run() {
		boolean needConfirm = false;
		needConfirm = PropertiesUtils.getProperty(ConfigConstants.SHOW_CONFIRM_STATUS, "00").equals("01");
		if(null == tenderProjectService){
			tenderProjectService = new TenderProjectService();
		}
		TransactionServer transactionServer = HttpUtils.getTransactionServer(tenderProjectEntity.getTransactionServerId());
		boolean isPriceStage = false;
		boolean isBusAndTecStage = false;
		if(null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_PRICE)){
			isPriceStage = true;
		}else if(null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_BUS_TEC)){
			isBusAndTecStage = true;
		}
		remoteProjectBidOpeningListener.setDownloadBidopeningInfo(true);
		int decryptTotalCount = 0;
		int decryptFailCount = 0;
		int noPriceCount = 0;
		long startTime = 0;
		long useTime = -1;
		boolean isStopRemoteDecrypt = false;
		while(null != thread){
			isStopRemoteDecrypt = false;
			startTime = Calendar.getInstance().getTimeInMillis();
			decryptTotalCount = 0;
			decryptFailCount = 0;
			noPriceCount = 0;
//			List<TenderProjectEntity> tenderPackList = tenderProjectService.getTenderPackBidOpeningInfoList(tenderProjectEntity.getId());
			List<TenderPackOpeningInfo> tenderPackOpeningInfoList = tenderProjectService.getTenderPackOpeningInfoList(tenderProjectEntity.getId(), bidopeningStage);
			if(null != tenderPackOpeningInfoList && tenderPackOpeningInfoList.size() > 0){
				
				List<TenderProjectEntity> getBidOpeningInfoList = new ArrayList<TenderProjectEntity>();
				for(TenderPackOpeningInfo tenderPackOpeningInfo : tenderPackOpeningInfoList){
					if(tenderPackOpeningInfo.getTenderCount() == 0){
						continue;
					}
					decryptTotalCount += tenderPackOpeningInfo.getDecCount();
					decryptFailCount += tenderPackOpeningInfo.getDecFailCount();
					noPriceCount += tenderPackOpeningInfo.getNoPriceCount();
					// 先进行刷新
					remoteProjectBidOpeningListener.refreshDescInfo(tenderPackOpeningInfo);
					TenderProjectEntity tenderPack = tenderPackOpeningInfo.getTenderProject();
					String bidStatus = tenderPack.getBusinessBidStatus();
					if(isPriceStage){
						bidStatus = tenderPack.getPriceBidStatus();
					}
					if(StringUtils.isEmpty(bidStatus) || CommonEnum.NOT_START.equals(bidStatus) || CommonEnum.COMPLETE.equals(bidStatus)) {
						continue;
					}
					if(needConfirm){
						if(tenderPackOpeningInfo.isDecComplate() && tenderPackOpeningInfo.isConfirmComplate()){
							continue;
						}
					}else {
						// 如果不需要确认结果，则当前包件解密完成就不再获取远程开标结果
						if(tenderPackOpeningInfo.isDecComplate() && tenderPackOpeningInfo.getDecFailCount() == 0 && tenderPackOpeningInfo.getNoPriceCount() == 0){
							continue;
						}
					}
					
					getBidOpeningInfoList.add(tenderPack);
					
				}
				if(null != thread && getBidOpeningInfoList.size() > 0){
					if(null != remoteProjectBidOpeningInfoThread){
						remoteProjectBidOpeningInfoThread.stop();
						remoteProjectBidOpeningInfoThread = null;
					}

					// 每隔10秒刷新
					if(useTime > 10000){
						// 此次刷新时间超过10秒
					}else if(useTime > 0){
						try {
							Thread.sleep(10000 - useTime);
						} catch (InterruptedException e) {
						}
					}
				
					// 下载解密和确认信息
					remoteProjectBidOpeningInfoThread = new RemoteProjectDecryptInfoThread(tenderProjectEntity, bidopeningStage, transactionServer, getBidOpeningInfoList, remoteProjectBidOpeningListener);
					remoteProjectBidOpeningInfoThread.start();
				}else {
					break;
				}
			}
			if(null != remoteProjectBidOpeningInfoThread){
				remoteProjectBidOpeningInfoThread.join();
			}
			useTime = Calendar.getInstance().getTimeInMillis() - startTime;
		}
		remoteProjectBidOpeningListener.setDownloadBidopeningInfo(false);
		if(null != thread){
			ActionLogUtils.addServerLog(tenderProjectEntity.getId(),"批量可解密标书已全部解密完成", "decryptTotalCount:" + decryptTotalCount +"decryptFailCount:" + decryptFailCount +"noPriceCount:" +noPriceCount);
			remoteProjectBidOpeningListener.decryptComplate(decryptTotalCount, decryptFailCount, noPriceCount);
		}else {
			ActionLogUtils.addServerLog(tenderProjectEntity.getId(),"停止批量获得远程开标信息", "decryptTotalCount:" + decryptTotalCount +"decryptFailCount:" + decryptFailCount +"noPriceCount:" +noPriceCount);
		}
	}
	
}
