package com.gx.obe.opening.thread;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Properties;

import org.apache.log4j.Logger;

import com.gx.obe.VideoConfigConstants;
import com.gx.obe.WebserviceConstants;
import com.gx.obe.business.http.HttpUrl;
import com.gx.obe.business.http.HttpUtils;
import com.gx.obe.common.widget.listener.ProgressMessageListener;
import com.gx.obe.common.widget.thread.MyRunnable;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.components.core.enumeration.VideoMeetingEmum;
import com.gx.obe.config.ConfigConstants;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.http.json.JsonUtil;
import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.DateUtils;
import com.gx.obe.util.utils.ObjectUtils;
import com.gx.obe.web.entity.BidOpeningRoom;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.service.BidOpeningRoomService;
import com.gx.obe.web.service.TenderProjectService;
import com.gx.utils.ActionLogUtils;
import com.gx.utils.Params;

/** 
 * @Description: 批量启动远程开标大厅
 * @author guoyr 
 */
public class BatchRemoteStartBidopeningHallThread extends MyRunnable{
	
	private TenderProjectEntity tenderProjectEntity;
	private List<TenderProjectEntity> tenderPackList;
	private ProgressMessageListener callBack;
	private Thread thread;
	private final String TIMESTAMP_STR = "yyyy-MM-dd HH:mm:ss";
	private String bidopeningStage;
	private Date bidOpeningTime;
	private Date signEndTime;
	private Date decEndTime;
	private boolean synchronizedInfoOnly = false;
	private Logger LOG = Logger.getLogger(BatchRemoteStartBidopeningHallThread.class);
	private TenderProjectService tenderProjectService;

	
	public BatchRemoteStartBidopeningHallThread(TenderProjectEntity tenderProjectEntity, List<TenderProjectEntity> tenderPackList, String bidopeningStage, Date bidOpeningTime, Date signEndTime, Date decEndTime, boolean synchronizedInfoOnly, ProgressMessageListener callBack){
		this.tenderProjectEntity = tenderProjectEntity;
		this.tenderPackList = tenderPackList;
		this.bidopeningStage = bidopeningStage;
		this.bidOpeningTime = bidOpeningTime;
		this.signEndTime = signEndTime;
		this.decEndTime = decEndTime;
		this.synchronizedInfoOnly = synchronizedInfoOnly;
		this.callBack = callBack;
		tenderProjectService = new TenderProjectService();
	}
	public void start(){
		thread = new Thread(this);
		thread.start();
	}
	public void stop(){
		thread = null;
	}
	public void join(){
		if(null != thread){
			try {
				thread.join();
			} catch (InterruptedException e) {
			}
		}
	}
	public void run(){
		boolean isPriceStage = false;
		String openStageType = "00";
		if(null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_PRICE)){
			isPriceStage = true;
			openStageType = "02";
		}else if(null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_BUS_TEC)){
			openStageType = "01";
		}
		boolean startRemoteBidopening = false;
		if(synchronizedInfoOnly){
			startRemoteBidopening = true;
			ActionLogUtils.addServerLog(tenderProjectEntity.getId(),"仅本地启动远程开标大厅", new Params("tenderNo", tenderProjectEntity.getTenderNo()).add("openStageType", openStageType));
		}else {
			callBack.message(Messages.Tips_starting, 0);
			HttpUrl httpUrl = HttpUtils.getProjectHttpUrl(tenderProjectEntity, PropertiesUtils.getWebserviceProperty(WebserviceConstants.START_REMOTE_BIDOPENING_METHOD, ""));
			if(null != httpUrl){
				httpUrl.setName("批量启动远程开标大厅");
				if(null != tenderPackList){
					StringBuilder stageIds = new StringBuilder();
					
					for(TenderProjectEntity tenderPack : tenderPackList){
						if(stageIds.length() > 0){
							stageIds.append(",");
						}
						stageIds.append(tenderPack.getStageId());
					}
					httpUrl.setAttribute("stageIds", stageIds.toString());
				}
				httpUrl.setAttribute("openStageType", openStageType);
				Date bidOpeningSignDeadLine = signEndTime;//null != signEndTime ? signEndTime : bidOpeningTime;
				httpUrl.setAttribute("bidOpeningSignDeadLine", null != bidOpeningSignDeadLine ? DateUtils.getFormat(bidOpeningSignDeadLine, TIMESTAMP_STR) : null);// 签到截止时间
				httpUrl.setAttribute("bidOpeningTime", DateUtils.getFormat(bidOpeningTime, TIMESTAMP_STR));//开标开标时间
				httpUrl.setAttribute("bidOpeningDeadLine", null != decEndTime ? DateUtils.getFormat(decEndTime, TIMESTAMP_STR) : null);// 解密截止时间
				String bidOpeningRoomAddress = "";
				if(null != tenderProjectEntity.getBidOpeningRoomId()){
					BidOpeningRoomService bidOpeningRoomService = new BidOpeningRoomService();
					BidOpeningRoom bidOpeningRoom = bidOpeningRoomService.getBidOpeningRoomById(tenderProjectEntity.getBidOpeningRoomId());
					if(null != bidOpeningRoom){
						bidOpeningRoomAddress = bidOpeningRoom.getBidOpeningRoomAddress();
					}
				}
				if(null == bidOpeningRoomAddress || bidOpeningRoomAddress.length() == 0 && null != tenderProjectEntity.getOpeningAddress()){
					bidOpeningRoomAddress = tenderProjectEntity.getOpeningAddress();
				}
				httpUrl.setAttribute("bidOpeningRoom", null != bidOpeningRoomAddress? bidOpeningRoomAddress : "");
				Properties videoProperties = PropertiesUtils.getProperties("videoConfig.properties");
				String videoDeskLiveUrl = ObjectUtils.getObjString(videoProperties.getProperty(VideoConfigConstants.VIDEO_DESK_LIVE_URL));

				String meetingServerAddress = PropertiesUtils.getProperty(ConfigConstants.MEETING_SERVER_ADDRESS, "");
				String meetingCleintServerAddress = PropertiesUtils.getProperty(ConfigConstants.MEETING_CLEINT_SERVER_ADDRESS, "");
				String meetingCleintServerPort = PropertiesUtils.getProperty(ConfigConstants.MEETING_CLEINT_SERVER_PORT, "1089");
				String videoMeetingType = PropertiesUtils.getProperty(ConfigConstants.VIDEO_MEETING_TYPE, VideoMeetingEmum.MEETING_BK);
				Map<String, Object> params = new HashMap<String, Object>();
				
				String roomIdAndPwd = tenderProjectEntity.getBidMeeting();
				String roomId = "";
				String rpwd = "123456";
				if(null != roomIdAndPwd && roomIdAndPwd.length() > 0) {
					if(roomIdAndPwd.contains("_")) {
						roomId = roomIdAndPwd.substring(0,roomIdAndPwd.indexOf("_"));
						rpwd = roomIdAndPwd.substring(roomIdAndPwd.indexOf("_")+1);
			    	}else {
			    		roomId = roomIdAndPwd;
			    	}
				}
				
				params.put("roomPassWord", rpwd);// 自动广播音频
				params.put("meetingClientServerAddress", meetingCleintServerAddress);// 自动广播视频
				params.put("videoMeetingType", videoMeetingType);// 文字群聊
				params.put("meetingClientServerPort", meetingCleintServerPort);// 文字私聊
				params.put("meetingServerAddress", meetingServerAddress);// 标注白板
				params.put("id", "");// 保存白板
				params.put("roomId", roomId);//客户端录制会议
//				params.put("file_share", true);// 发送文件
//				params.put("reserve_presenter_video", true);// 保留主讲视频
				String roomPermission = JsonUtil.jsonObjectToStr(params);
//				serviceUtils.addParameter("roomPermission", roomPermission);//1、用户密码验证；2、会议室密码验证；3、匿名登录
//				{"roomPassWord":"123456","meetingClientServerAddress":"123.57.53.254","videoMeetingType":"00","meetingClientServerPort":"1089","id":"","meetingServerAddress":"http://123.57.53.254:8080/fmapi/webservice/jaxws?wsdl","roomId":"10049"}
				httpUrl.setAttribute("bidOpeningLiveCameraUrl",roomPermission);
				httpUrl.setAttribute("bidOpeningLiveDesktopUrl", "");
				
				startRemoteBidopening = HttpUtils.doPost(httpUrl).getStatus();
				ActionLogUtils.addServerLog(tenderProjectEntity.getId(),"批量启动远程开标大厅", httpUrl, startRemoteBidopening);
				if(!startRemoteBidopening) {
					startRemoteBidopening = HttpUtils.doPost(httpUrl).getStatus();
					ActionLogUtils.addServerLog(tenderProjectEntity.getId(),"第二次批量启动远程开标大厅", httpUrl, startRemoteBidopening);
				}
			}
		}
		
		if(startRemoteBidopening){
			if(isPriceStage){
				List<TenderProjectEntity> aa = new ArrayList<TenderProjectEntity>();
				for(TenderProjectEntity tenderPack : tenderPackList){
					aa.add(tenderPack);
					tenderPack.setStartPriceBidOpening(CommonEnum.YES);
				}
				tenderProjectService.batchUpdateProperty(tenderPackList, new String[]{"id","startPriceBidOpening"});
				tenderProjectEntity.setStartPriceBidOpening(CommonEnum.YES);
				tenderProjectService.updateAssignProperty(tenderProjectEntity, new String[]{"id","startPriceBidOpening"});
			}else {
				for(TenderProjectEntity tenderPack : tenderPackList){
					tenderPack.setStartBidOpening(CommonEnum.YES);
				}
				tenderProjectService.batchUpdateProperty(tenderPackList, new String[]{"id","startBidOpening"});
				tenderProjectEntity.setStartBidOpening(CommonEnum.YES);
				tenderProjectService.updateAssignProperty(tenderProjectEntity, new String[]{"id","startBidOpening"});
			}
			if(synchronizedInfoOnly) {
				callBack.message(Messages.Tips_synchronizingSigninInfo, 1);
			}else {
				callBack.message(Messages.Tips_startOpeningHallSuccess, 1);
			}
		}else {
			callBack.message(Messages.Tips_startOpeningHallFail, -1);
		}
		callBack.finish(startRemoteBidopening);
	
	}
}
