package com.gx.obe.opening.thread;

import java.util.Calendar;
import java.util.Date;

import org.eclipse.swt.core.CallBack;

import com.gx.obe.util.utils.DateUtils;

/**
 * @Description: 
 * @author guoyr
 */
public class CountDownTimeThread extends Thread{

	private long mSecond = 0;// 毫秒
	private long second = 0;// 秒
	private long minute = 0;// 分
	private long hour = 0;// 时
	private long day = 0;// 天
	private long countTime = 0;
	private CallBack callBack;
	private boolean stop = false;
	private String countStr = "";
	private String countHHmmssStr = "";

	/**
	 * @param startDate 开始时间
	 * @param targetDate 目标时间
	 */
	public CountDownTimeThread(Date startDate, Date targetDate, CallBack callBack){
		this.callBack = callBack;
		Calendar startCal = Calendar.getInstance();
		startCal.setTime(startDate);
		Calendar targetCal = Calendar.getInstance();
		targetCal.setTime(targetDate);
		countTime = targetCal.getTimeInMillis() - startCal.getTimeInMillis();
		
	}
	@Override
	public void run() {
		while(countTime > 0 && !stop){
			computer(countTime);
			callBack.callBack();
			try {
				Thread.sleep(1000);
			} catch (InterruptedException e) {
			}
			countTime -= 1000;
		}
		if(countTime <= 0){
			countHHmmssStr = "";
			countStr = "";
			mSecond = 0;// 毫秒
			second = 0;// 秒
			minute = 0;// 分
			hour = 0;// 时
			day = 0;// 天
		}
		callBack.callBack();
	}

	private void computer(long countTime){
		countStr = "";
		mSecond = 0;// 毫秒
		second = 0;// 秒
		minute = 0;// 分
		hour = 0;// 时
		day = 0;// 天
		if (countTime < 0) {
			countHHmmssStr = "";
			countStr ="";
			return;
		}
		if (countTime < 1000) {
			mSecond = countTime;
			countHHmmssStr = "";
			countStr= "0秒";
			return ;
		}
		// 长于1秒的过程，毫秒不计
		countTime /= 1000;
		if (countTime < 60) {
			second = countTime;
			countHHmmssStr = "00:00:"+((countTime<10?"0":"")+countTime);
			countStr = String.valueOf(countTime) + "秒";
			return;
		}
		if (countTime < 3600) {
			minute = countTime / 60;
			second = countTime % 60;
			countHHmmssStr = "00:"+((minute < 10?"0":"")+minute )+":"+((second < 10?"0":"")+second);
			countStr = String.valueOf(minute) + "分" + String.valueOf(second)
					+ "秒";
			return;
		}
		if (countTime < 86400) {
			hour = countTime / 3600;
			minute = (countTime - hour * 3600) / 60;
			second = (countTime - hour * 3600) % 60;
			countHHmmssStr = ((hour < 10?"0":"")+hour) + ":" +((minute < 10?"0":"")+minute) + ":"+
			((second < 10?"0":"")+second);
			countStr = String.valueOf(hour) + "小时" + String.valueOf(minute) + "分"
					+ String.valueOf(second) + "秒";
			return;
		}

		day = countTime / 86400;
		hour = (countTime - day * 86400) / 3600;
		minute = (countTime - day * 86400 - hour * 3600) / 60;
		second = (countTime - day * 86400 - hour * 3600) % 60;
		long totalHour = day*24 + hour;
		countHHmmssStr = ((totalHour < 10?"0":"")+totalHour) + ":"
		+ ((minute < 10?"0":"")+minute) + ":" + ((second < 10?"0":"")+second);
		countStr = String.valueOf(day) + "天" + String.valueOf(hour) + "小时"
				+ String.valueOf(minute) + "分" + String.valueOf(second) + "秒";
		return;
	
	}
	
	public static String getHHmmssStr(long msUsed) {
		if (msUsed < 1000) {
			return "";
		}
		// 长于1秒的过程，毫秒不计
		msUsed /= 1000;
		if (msUsed < 60) {
			return "00:00:"+(msUsed < 10?"0":"")+msUsed  + "";
		}
		if (msUsed < 3600) {
			long nMinute = msUsed / 60;
			long nSecond = msUsed % 60;
			return "00:"+((nMinute < 10?"0":"")+nMinute ) + ":" + ((nSecond < 10?"0":"")+nSecond );
		}
		// 3600 * 24 = 86400
		if (msUsed < 86400) {
			long nHour = msUsed / 3600;
			long nMinute = (msUsed - nHour * 3600) / 60;
			long nSecond = (msUsed - nHour * 3600) % 60;
			return ((nHour < 10?"0":"")+nHour ) + ":" +((nMinute < 10?"0":"")+nMinute ) + ":"
					+ ((nSecond < 10?"0":"")+nSecond );
		}

		long nDay = msUsed / 86400;
		long nHour = (msUsed - nDay * 86400) / 3600;
		return String.valueOf(nDay) + "天" + String.valueOf(nHour) + "小时";
	}
	public long getmSecond() {
		return mSecond;
	}
	public void setmSecond(long mSecond) {
		this.mSecond = mSecond;
	}
	public long getSecond() {
		return second;
	}
	public void setSecond(long second) {
		this.second = second;
	}
	public long getMinute() {
		return minute;
	}
	public void setMinute(long minute) {
		this.minute = minute;
	}
	public long getHour() {
		return hour;
	}
	public void setHour(long hour) {
		this.hour = hour;
	}
	public long getDay() {
		return day;
	}
	public void setDay(long day) {
		this.day = day;
	}
	public long getCountTime() {
		return countTime;
	}
	public void setCountTime(long countTime) {
		this.countTime = countTime;
	}
	public String getCountStr() {
		return countStr;
	}
	public void setCountStr(String countStr) {
		this.countStr = countStr;
	}
	public boolean isStop() {
		return stop;
	}
	public void setStop() {
		this.stop = true;
	}
	public String getCountHHmmssStr() {
		return countHHmmssStr;
	}
	public void setCountHHmmssStr(String countHHmmssStr) {
		this.countHHmmssStr = countHHmmssStr;
	}
	public static void main(String[] arges){
		new CountDownTimeThread(new Date(), DateUtils.add(new Date(), 3, 3), new CallBack(){

			@Override
			public void callBack(String msg, Object obj) {
				if(msg.equals("full")){
				}
			}
			
		}).start();
	}
}
