package com.gx.obe.opening.thread;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import org.eclipse.swt.core.CallBack;

import com.gx.obe.WebserviceConstants;
import com.gx.obe.business.http.HttpResponse;
import com.gx.obe.business.http.HttpUrl;
import com.gx.obe.business.http.HttpUtils;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.service.TenderProjectService;

import net.sf.json.JSONArray;
import net.sf.json.JSONObject;

public class GetBidOpeningNoticeListThread implements Runnable{
	private TenderProjectEntity tenderProjectEntity;
	private TenderProjectService tenderProjectService ;
	private CallBack callBack;
	public GetBidOpeningNoticeListThread(TenderProjectEntity tenderProjectEntity, CallBack callBack ){
		this.tenderProjectEntity = tenderProjectEntity;
		this.callBack = callBack;
		this.tenderProjectService = new TenderProjectService();
	}
	
	public void run(){
		HttpUrl httpUrl = HttpUtils.getProjectHttpUrl(tenderProjectEntity, PropertiesUtils.getWebserviceProperty(WebserviceConstants.GET_BID_OPENING_NOTICE_LIST, ""));
		if(null != httpUrl){
			httpUrl.setName("获取开标消息");
			httpUrl.setAttribute("stageId", getStageId());
//		httpUrl.setAttribute(name, value)
			HttpResponse httpResponse = HttpUtils.doPost(httpUrl);
			try {
				if(!httpResponse.getStatus()){
					if(null != httpResponse.getMsg() && null != callBack){
						callBack.callBackString("消息："+httpResponse.getMsg());
					}
				}
				JSONArray  array = httpResponse.getDataJSONArray("bidOpeningNoticeInfoList");
				if(null != array) {
					Object[] objects = array.toArray();
					List<Map<String, String>> messageList = new ArrayList<Map<String, String>>();
					for(Object obj : objects){
						JSONObject jSONObject = (JSONObject)obj;
						Map<String, String> messageMap = new HashMap<String, String>();
						messageMap.put("sender", jSONObject.getString("sender"));
						messageMap.put("noticeContents", jSONObject.getString("noticeContents"));
						messageMap.put("sendTime", jSONObject.getString("sendTime"));
						messageList.add(messageMap);
					}
					callBack.callBackObject(messageList);
				}
			} catch (Exception e1) {
			}
			callBack.after();
		}
	}
	private String getStageId(){
		if(null != tenderProjectEntity.getIsPack() && CommonEnum.YES.equals(tenderProjectEntity.getIsPack())){
			List<TenderProjectEntity> tenderPacks = tenderProjectService.getSubPackageList(tenderProjectEntity.getId());
			if(null != tenderPacks && tenderPacks.size() > 0){
				return tenderPacks.get(0).getStageId();
			}else{
				return "";
			}
		
		}else{
			return tenderProjectEntity.getStageId();
		}
	}	
}
