package com.gx.obe.opening.thread;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import com.gx.obe.common.widget.thread.MyRunnable;
import com.gx.obe.components.core.Constants;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.opening.listener.BatchRemoteDecryptListener;
import com.gx.obe.opening.listener.DecryptRemoteBidFileListener;
import com.gx.obe.util.utils.StringUtils;
import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.service.TenderProjectService;
import com.gx.obe.web.vo.TenderPackOpeningInfo;
import com.gx.utils.ActionLogUtils;

public class MultyProjectDownRemoteBidOpeningResultThread implements Runnable{

	
	private Thread thread;
	private List<TenderProjectEntity> tenderProjectList;
	private String bidopeningStage;
	
	private BatchRemoteDecryptListener remoteProjectBidOpeningListener;
	private TenderProjectService tenderProjectService;
	private List<MyRunnable> myRunnableList = new ArrayList<MyRunnable>();
	private List<String> downLoadDecryptList = new ArrayList<String>();
	private Map<String, Integer> tenderProjectDecryptCountMap = new HashMap<String, Integer>();
	private Map<String, Integer> tenderProjectDecryptFailCountMap = new HashMap<String, Integer>();
	private Map<String, Integer> tenderProjectNoPriceCountMap = new HashMap<String, Integer>();
	
	
	public MultyProjectDownRemoteBidOpeningResultThread(List<TenderProjectEntity> tenderProjectList, String bidopeningStage, BatchRemoteDecryptListener rempteProjectBidOpeningListener){
		this.tenderProjectList = tenderProjectList;
		this.bidopeningStage = bidopeningStage;
		this.remoteProjectBidOpeningListener = rempteProjectBidOpeningListener;
		tenderProjectService = new TenderProjectService();
	}
	
	
	public void start(){
		thread = new Thread(this);
		thread.setName(tenderProjectList.size()+"个项目远程开标" + bidopeningStage);
		thread.start();
	}
	
	public void stop(){
		thread = null;
		for(MyRunnable myRunnable : myRunnableList){
			myRunnable.stop();
		}
		downLoadDecryptList.clear();
	}
	
	public void run() {
		boolean isPriceStage = false;
		if(null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_PRICE)){
			isPriceStage = true;
		}
		remoteProjectBidOpeningListener.setDownloadBidopeningInfo(true);
		for(final TenderProjectEntity tenderProjectEntity : tenderProjectList){
			downLoadDecryptList.add(tenderProjectEntity.getId());
			if(null != tenderProjectEntity.getChildList() && tenderProjectEntity.getChildList().size() > 0){
//				for(TenderProjectEntity tenderPack : tenderProjectEntity.getChildList()){
//					downLoadDecryptList.add(tenderPack.getId());
//				}
				
				// 按项目批量获取解密信息
				BatchDownRemoteBidOpeningResultThread batchDownRemoteBidOpeningResultThread = new BatchDownRemoteBidOpeningResultThread(tenderProjectEntity, null, bidopeningStage, new BatchRemoteDecryptListener(){

					Map<String, TenderPackOpeningInfo> tenderPackOpeningInfoMap = new HashMap<String, TenderPackOpeningInfo>();
					TenderPackOpeningInfo tenderProjectOpeningInfo = new TenderPackOpeningInfo(tenderProjectEntity, tenderProjectEntity.getChildList());
					
					public synchronized void refreshDescInfo(TenderPackOpeningInfo _tenderPackOpeningInfo) {
						tenderPackOpeningInfoMap.put(_tenderPackOpeningInfo.getTenderProject().getId(), _tenderPackOpeningInfo);
						int openingCount = 0;
						int decCount = 0;
						int decFailCount = 0;
						int noPriceCount = 0;
						for(Entry<String, TenderPackOpeningInfo> entry : tenderPackOpeningInfoMap.entrySet()){
							TenderPackOpeningInfo tenderPackOpeningInfo = entry.getValue();
							openingCount += tenderPackOpeningInfo.getOpeningCount();
							decCount += tenderPackOpeningInfo.getDecCount();
							decFailCount += tenderPackOpeningInfo.getDecFailCount();
							noPriceCount += tenderPackOpeningInfo.getNoPriceCount();
						}
						
						boolean refreshDecInfo = false;
						if(decCount != tenderProjectOpeningInfo.getDecCount()){
							refreshDecInfo = true;
						}
						if(openingCount != tenderProjectOpeningInfo.getOpeningCount()){
							refreshDecInfo = true;
						}
						tenderProjectOpeningInfo.setOpeningCount(openingCount);
						tenderProjectOpeningInfo.setDecCount(decCount);
						tenderProjectOpeningInfo.setDecFailCount(decFailCount);
						tenderProjectOpeningInfo.setNoPriceCount(noPriceCount);
						if(refreshDecInfo){
							remoteProjectBidOpeningListener.refreshDescInfo(tenderProjectOpeningInfo);
						}
						refreshDecryptCount(tenderProjectOpeningInfo);
					}
					public synchronized void setDownloadBidopeningInfo(boolean isDownloading) {
						if(!isDownloading){
							downLoadDecryptList.remove(tenderProjectEntity.getId());
						}
					}
					public void decryptComplate(int decryptCount, int decFileCount, int noPriceCount){
					}
					
				});
				batchDownRemoteBidOpeningResultThread.start();
				
				myRunnableList.add(batchDownRemoteBidOpeningResultThread);
			}else {
				String bidStatus = tenderProjectEntity.getBusinessBidStatus();
				if(isPriceStage){
					bidStatus = tenderProjectEntity.getPriceBidStatus();
				}
				boolean getRemoteDecryptStatus = true;
				if(StringUtils.isEmpty(bidStatus) || CommonEnum.NOT_START.equals(bidStatus) ||CommonEnum.COMPLETE.equals(bidStatus)) {
					getRemoteDecryptStatus = false;
				}
				
				// 只有已经启动解密的标段，才获取解密信息
				if(getRemoteDecryptStatus){
					// 获取供应商的解密信息
					RemoteDecryptStatusThread getRemoteDecryptStatusThread = new RemoteDecryptStatusThread(tenderProjectEntity, bidopeningStage, new DecryptRemoteBidFileListener(){
						public void startRemoteDecrypt(final boolean flag){}
						public void stopRemoteDecrypt(){
							downLoadDecryptList.remove(tenderProjectEntity.getId());
						}
						public void refreshBidOpeningStatus(Supplier supplier, String businessBidStatus, String technologyBidStatus, String priceBidStatus, boolean hasBidPrice){}
						public void refreshProgress(int totalCount, int successCount, int noDecCount, int failedDecCout, int errorsCount){
							TenderPackOpeningInfo tenderPackOpeningInfo = tenderProjectService.getTenderPackOpeningInfo(tenderProjectEntity.getId(), bidopeningStage);
							remoteProjectBidOpeningListener.refreshDescInfo(tenderPackOpeningInfo);
							refreshDecryptCount(tenderPackOpeningInfo);
						}
					});
					getRemoteDecryptStatusThread.start();
					myRunnableList.add(getRemoteDecryptStatusThread);
				}else {
					TenderPackOpeningInfo tenderPackOpeningInfo = tenderProjectService.getTenderPackOpeningInfo(tenderProjectEntity.getId(), bidopeningStage);
					remoteProjectBidOpeningListener.refreshDescInfo(tenderPackOpeningInfo);
					refreshDecryptCount(tenderPackOpeningInfo);
				}
			}
		}
		
		for(MyRunnable myRunnable : myRunnableList){
			myRunnable.join();
		}
//		while(downLoadDecryptList.size() > 0){
//			try {
//				Thread.sleep(2000);
//			} catch (InterruptedException e) {
//			}
//		}
		remoteProjectBidOpeningListener.setDownloadBidopeningInfo(false);
		int totalDecryptCount = 0;
		int totalErrorsCount = 0;
		int noPriceCount = 0;
		for(Entry<String, Integer> entry : tenderProjectDecryptCountMap.entrySet()){
			totalDecryptCount += entry.getValue();
		}
		for(Entry<String, Integer> entry : tenderProjectDecryptFailCountMap.entrySet()){
			totalErrorsCount += entry.getValue();
		}
		for(Entry<String, Integer> entry : tenderProjectNoPriceCountMap.entrySet()){
			noPriceCount += entry.getValue();
		}
		if(null != thread){
			stop();
			ActionLogUtils.addServerLog(Constants.USER.getId(),"多项目批量可解密标书已全部解密完成", "totalDecryptCount:" + totalDecryptCount +"totalFailCount:" + totalErrorsCount +"noPriceCount:" +noPriceCount);
			remoteProjectBidOpeningListener.decryptComplate(totalDecryptCount, totalErrorsCount, noPriceCount);
		}else {
			ActionLogUtils.addServerLog(Constants.USER.getId(),"停止多项目批量获取解密信息, ", "totalDecryptCount:" + totalDecryptCount +"totalFailCount:" + totalErrorsCount +"noPriceCount:" +noPriceCount);
			
		}
	}
	
	private void refreshDecryptCount(TenderPackOpeningInfo tenderPackOpeningInfo) {
		tenderProjectDecryptCountMap.put(tenderPackOpeningInfo.getTenderProject().getId(), tenderPackOpeningInfo.getDecCount());
		tenderProjectDecryptFailCountMap.put(tenderPackOpeningInfo.getTenderProject().getId(), tenderPackOpeningInfo.getDecFailCount());
		tenderProjectNoPriceCountMap.put(tenderPackOpeningInfo.getTenderProject().getId(), tenderPackOpeningInfo.getNoPriceCount());
	}
}
