package com.gx.obe.opening.thread;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.Map.Entry;

import com.gx.obe.common.widget.thread.MyRunnable;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.opening.listener.BatchRemoteSignListener;
import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.service.TenderProjectService;
import com.gx.obe.web.vo.TenderPackOpeningInfo;

public class MultyProjectDownRemoteSignInfoThread implements Runnable{

	
	private Thread thread;
	private String bidopeningStage;
	private List<TenderProjectEntity> tenderProjectList;
	
	private BatchRemoteSignListener remoteProjectSignListener;
	private TenderProjectService tenderProjectService;
	private List<MyRunnable> myRunnableList = new ArrayList<MyRunnable>();

	
	public MultyProjectDownRemoteSignInfoThread(List<TenderProjectEntity> tenderProjectList, String bidopeningStage, BatchRemoteSignListener remoteProjectSignListener){
		this.tenderProjectList = tenderProjectList;
		this.bidopeningStage = bidopeningStage;
		this.remoteProjectSignListener = remoteProjectSignListener;
		tenderProjectService = new TenderProjectService();
	}
	
	
	public void start(){
		thread = new Thread(this);
		thread.setName(tenderProjectList.size()+"个项目远程签到" + bidopeningStage);
		thread.start();
	}
	
	public void stop(){
		thread = null;
		for(MyRunnable myRunnable : myRunnableList){
			myRunnable.stop();
		}
	}
	
	public void run() {
		boolean isPriceStage = false;
		if(null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_PRICE)){
			isPriceStage = true;
		}
		for(final TenderProjectEntity tenderProjectEntity : tenderProjectList){
			if(null != tenderProjectEntity.getChildList() && tenderProjectEntity.getChildList().size() > 0){
				
				BatchRemoteSignListener _remoteProjectSignListener = new BatchRemoteSignListener(){
					Map<String, TenderPackOpeningInfo> tenderPackOpeningInfoMap = new HashMap<String, TenderPackOpeningInfo>();
					TenderPackOpeningInfo tenderProjectOpeningInfo = new TenderPackOpeningInfo(tenderProjectEntity, tenderProjectEntity.getChildList());
					public synchronized void refreshSignInfo(TenderPackOpeningInfo _tenderPackOpeningInfo) {
						tenderPackOpeningInfoMap.put(_tenderPackOpeningInfo.getTenderProject().getId(), _tenderPackOpeningInfo);

						int signCount = 0;
						for(Entry<String, TenderPackOpeningInfo> entry : tenderPackOpeningInfoMap.entrySet()){
							TenderPackOpeningInfo tenderPackOpeningInfo = entry.getValue();
							signCount += tenderPackOpeningInfo.getSignCount();
						}
						
						if(signCount > tenderProjectOpeningInfo.getSignCount()){
							tenderProjectOpeningInfo.setSignCount(signCount);
							remoteProjectSignListener.refreshSignInfo(tenderProjectOpeningInfo);
						}
						
					}
				};
				
				// 按项目批量获取签到信息
				BatchDownRemoteSignInfoThread batchDownRemoteSignInfoThread = new BatchDownRemoteSignInfoThread(tenderProjectEntity, null, bidopeningStage, _remoteProjectSignListener);
				batchDownRemoteSignInfoThread.start();
				myRunnableList.add(batchDownRemoteSignInfoThread);
			}else {
				boolean isStartSign = false;
				String startBidopening = tenderProjectEntity.getStartBidOpening();
				if(isPriceStage){
					startBidopening = tenderProjectEntity.getStartPriceBidOpening();
				}
				if(null != startBidopening && startBidopening.equals(CommonEnum.YES)){
					isStartSign = true;
				}
				if(isStartSign){
					// 获取供应商的签到信息
					RemoteSupplierSignThread getSupplierRemoteSignThread = new RemoteSupplierSignThread(tenderProjectEntity, bidopeningStage, new RemoteSupplierSignThread.RemoteSignListener() {
						public void refreshSignInfo(Supplier supplier, Date signTime, String signPerson, String signPersonTel, String signPersonCard){
						}
						public void refreshSignCount(int signCount){
							remoteProjectSignListener.refreshSignInfo(tenderProjectService.getTenderPackOpeningInfo(tenderProjectEntity.getId(), bidopeningStage));
						}
					});
					getSupplierRemoteSignThread.start();
					myRunnableList.add(getSupplierRemoteSignThread);
				}
			}
		}
	}
	
}
