package com.gx.obe.opening.thread;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.opening.listener.BatchRemoteBidOpeningListener;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.service.TenderProjectService;
import com.gx.obe.web.vo.TenderPackOpeningInfo;

public class MultyProjectRefreshBidOpeningInfoThread implements Runnable{

	private Thread thread;
	private List<TenderProjectEntity> tenderProjectList;
	private String bidopeningStage;
	private BatchRemoteBidOpeningListener projectBidOpeningListener;
	private TenderProjectService tenderProjectService;
	
	public MultyProjectRefreshBidOpeningInfoThread(List<TenderProjectEntity> tenderProjectList, String bidopeningStage, BatchRemoteBidOpeningListener projectBidOpeningListener){
		this.tenderProjectList = tenderProjectList;
		this.bidopeningStage = bidopeningStage;
		this.projectBidOpeningListener = projectBidOpeningListener;
		this.tenderProjectService = new TenderProjectService();
	}
	
	public void start(){
		thread = new Thread(this);
		thread.setName(tenderProjectList.size() +"个项目远程开标");
		thread.start();
	}
	
	public void stop(){
		thread = null;
	}
	
	public void run() {
		
		List<TenderPackOpeningInfo> tenderProjectOpeningInfoList = new ArrayList<TenderPackOpeningInfo>();
		if(null != tenderProjectList){
			for(TenderProjectEntity tenderProjectEntity : tenderProjectList){
				TenderPackOpeningInfo tenderProjectOpeningInfo = null;
				if(null == tenderProjectEntity.getParentId() && (null != tenderProjectEntity.getIsPack() && tenderProjectEntity.getIsPack().equals(CommonEnum.YES))){
					tenderProjectOpeningInfo = tenderProjectService.getTenderProjectOpeningInfo(tenderProjectEntity, bidopeningStage);
				}else {
					tenderProjectOpeningInfo = tenderProjectService.getTenderPackOpeningInfo(tenderProjectEntity.getId(), bidopeningStage);
				}
				if(null != tenderProjectOpeningInfo){
					
					tenderProjectOpeningInfoList.add(tenderProjectOpeningInfo);
				}
			}
			if(null != thread){
				projectBidOpeningListener.initRefreshTenderPackList(tenderProjectOpeningInfoList);
			}
			Map<String, TenderPackOpeningInfo> tenderPackOpeningInfoMap = new HashMap<String, TenderPackOpeningInfo>();
			for(TenderPackOpeningInfo tenderProjectOpeningInfo : tenderProjectOpeningInfoList){
				tenderPackOpeningInfoMap.put(tenderProjectOpeningInfo.getTenderProject().getId(), tenderProjectOpeningInfo);
			}
			if(null != thread){
				projectBidOpeningListener.refreshTenderPackBidOpeningInfo(tenderPackOpeningInfoMap);
			}
		}
	}
	
}
