package com.gx.obe.opening.thread;

import java.text.MessageFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.gx.obe.common.widget.listener.ProgressMessageListener;
import com.gx.obe.common.widget.thread.MyRunnable;
import com.gx.obe.listener.ProgressMessageAdapter;
import com.gx.obe.message.Messages;
import com.gx.obe.opening.listener.OpenRemoteHallListener;
import com.gx.obe.web.entity.tender.TenderProjectEntity;

/** 
 * @Description: 批量启动远程开标大厅
 * @author guoyr 
 */
public class MultyProjectRemoteStartBidopeningHallThread implements Runnable{
	
	private List<TenderProjectEntity> tenderProjectList;
	private OpenRemoteHallListener openRemoteHallListener;
	private Thread thread;
	private String bidopeningStage;
	private Date bidOpeningTime;
	private Date signEndTime;
	private Date decEndTime;
	private boolean synchronizedInfoOnly = false;
	private List<MyRunnable> myRunnableList = new ArrayList<MyRunnable>();
	private ProgressMessageListener callBack;
	
	public MultyProjectRemoteStartBidopeningHallThread(List<TenderProjectEntity> tenderProjectList, String bidopeningStage, Date bidOpeningTime, Date signEndTime, Date decEndTime, boolean synchronizedInfoOnly, OpenRemoteHallListener openRemoteHallListener, ProgressMessageListener callBack){
		this.tenderProjectList = tenderProjectList;
		this.bidopeningStage = bidopeningStage;
		this.bidOpeningTime = bidOpeningTime;
		this.signEndTime = signEndTime;
		this.decEndTime = decEndTime;
		this.synchronizedInfoOnly = synchronizedInfoOnly;
		this.openRemoteHallListener = openRemoteHallListener;
		this.callBack = callBack;
	}
	public void start(){
		thread = new Thread(this);
		thread.start();
	}
	public void stop(){
		thread = null;
		for(MyRunnable myRunnable : myRunnableList){
			myRunnable.stop();
		}
	}
	public void join(){
		if(null != thread){
			try {
				thread.join();
			} catch (InterruptedException e) {
			}
		}
	}
	public void run(){
		boolean flag = true;
		for(final TenderProjectEntity tenderProjectEntity : tenderProjectList){
			if(null != tenderProjectEntity.getChildList() && tenderProjectEntity.getChildList().size() > 0){
				// 按项目批量获取签到信息
				BatchRemoteStartBidopeningHallThread batchRemoteStartBidopeningHallThread = new BatchRemoteStartBidopeningHallThread(tenderProjectEntity, tenderProjectEntity.getChildList(), bidopeningStage, bidOpeningTime, signEndTime, decEndTime, synchronizedInfoOnly, new ProgressMessageAdapter() {
					public void finish(boolean flag) {
						openRemoteHallListener.openRemoteHall(flag, tenderProjectEntity, "");
						if(flag) {
							if(synchronizedInfoOnly){
								callBack.message(MessageFormat.format(Messages.Tips_synchronizingProjectSigninInfo, tenderProjectEntity.getTenderName()), 1);
							}else {
								callBack.message(MessageFormat.format(Messages.Tips_startProjectOpeningHallSuccess, tenderProjectEntity.getTenderName()), 1);
							}
						}else {
							flag = false;
							callBack.message(MessageFormat.format(Messages.Tips_startProjectOpeningHallFail, tenderProjectEntity.getTenderName()), -1);
						}
					}
				});
//				new OpenRemoteHallListener(){
//					public void openRemoteHall(final boolean openRemoteHall, TenderProjectEntity tenderProjectEntity, String msg){
//						openRemoteHallListener.openRemoteHall(openRemoteHall, tenderProjectEntity, msg);
//					}
//				});
				
				batchRemoteStartBidopeningHallThread.start();
				myRunnableList.add(batchRemoteStartBidopeningHallThread);
			}else {
				// 获取供应商的签到信息
				StartRemoteBidopeningHallThread startRemoteBidopeningHallThread = new StartRemoteBidopeningHallThread(tenderProjectEntity, tenderProjectEntity, bidopeningStage, bidOpeningTime, signEndTime, decEndTime, new ProgressMessageAdapter() {
					public void finish(boolean flag) {
						openRemoteHallListener.openRemoteHall(flag, tenderProjectEntity, "");
						if(flag) {
							if(synchronizedInfoOnly){
								callBack.message(MessageFormat.format(Messages.Tips_synchronizingProjectSigninInfo, tenderProjectEntity.getTenderName()), 1);
							}else {
								callBack.message(MessageFormat.format(Messages.Tips_startProjectOpeningHallSuccess, tenderProjectEntity.getTenderName()), 1);
							}
						}else {
							flag = false;
							callBack.message(MessageFormat.format(Messages.Tips_startProjectOpeningHallFail, tenderProjectEntity.getTenderName()), -1);
						}
					}
				});
//				new OpenRemoteHallListener(){
//					public void openRemoteHall(final boolean openRemoteHall, TenderProjectEntity tenderProjectEntity, String msg){
//						openRemoteHallListener.openRemoteHall(openRemoteHall, tenderProjectEntity, msg);
//					}
//				});
				startRemoteBidopeningHallThread.start();
				myRunnableList.add(startRemoteBidopeningHallThread);
			}
		}
		for(MyRunnable myRunnable : myRunnableList){
			myRunnable.join();
		}
		callBack.finish(flag);
	}
}
