package com.gx.obe.opening.thread;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.gx.obe.opening.listener.BatchRemoteBidOpeningListener;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.entity.tender.TenderProjectRuleEntity;
import com.gx.obe.web.service.TenderProjectService;
import com.gx.obe.web.vo.TenderPackOpeningInfo;

public class RefreshProjectBidOpeningInfoThread implements Runnable{

	private Thread thread;
	private TenderProjectEntity tenderProjectEntity;
	private TenderProjectRuleEntity tenderProjectRuleEntity;
	private String bidopeningStage;
	private BatchRemoteBidOpeningListener projectBidOpeningListener;
	private TenderProjectService tenderProjectService;
	private int refreshCount = 0;
	
	public RefreshProjectBidOpeningInfoThread(TenderProjectEntity tenderProjectEntity, TenderProjectRuleEntity tenderProjectRuleEntity, String bidopeningStage, BatchRemoteBidOpeningListener projectBidOpeningListener){
		this.tenderProjectEntity = tenderProjectEntity;
		this.tenderProjectRuleEntity = tenderProjectRuleEntity;
		this.bidopeningStage = bidopeningStage;
		this.projectBidOpeningListener = projectBidOpeningListener;
		this.tenderProjectService = new TenderProjectService();
	}
	
	public void start(){
		thread = new Thread(this);
		thread.setName(tenderProjectEntity.getTenderName()+"远程开标");
		thread.start();
	}
	
	public void stop(){
		thread = null;
	}
	
	public void run() {
		
		List<TenderPackOpeningInfo> tenderPackOpeningInfoList = tenderProjectService.getTenderPackOpeningInfoList(tenderProjectEntity.getId(), bidopeningStage);
		if(null != thread){
			projectBidOpeningListener.initRefreshTenderPackList(tenderPackOpeningInfoList);
		}
		Map<String, TenderPackOpeningInfo> tenderPackOpeningInfoMap = new HashMap<String, TenderPackOpeningInfo>();
		for(TenderPackOpeningInfo tenderPackOpeningInfo : tenderPackOpeningInfoList){
			tenderPackOpeningInfoMap.put(tenderPackOpeningInfo.getTenderProject().getId(), tenderPackOpeningInfo);
		}
		if(null != thread){
			projectBidOpeningListener.refreshTenderPackBidOpeningInfo(tenderPackOpeningInfoMap);
		}
	}
	
}
