package com.gx.obe.opening.thread;

import java.util.ArrayList;
import java.util.List;

import com.gx.obe.opening.listener.SupplierRemoteBidOpeningListener;
import com.gx.obe.web.entity.Supplier;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.entity.tender.TenderProjectRuleEntity;
import com.gx.obe.web.service.SupplierService;
import com.gx.obe.web.service.TenderProjectService;
import com.gx.obe.web.vo.TenderPackOpeningInfo;

public class RefreshSupplierRemoteBidOpeningInfoThread implements Runnable{

	private Thread thread;
	private TenderProjectEntity tenderProjectEntity;
	private TenderProjectRuleEntity tenderProjectRuleEntity;
	private String bidopeningStage;
	private SupplierRemoteBidOpeningListener supplierRemoteBidOpeningListener;
	private TenderProjectService tenderProjectService ;
	private SupplierService supplierService = new SupplierService();
	
	public RefreshSupplierRemoteBidOpeningInfoThread(TenderProjectEntity tenderProjectEntity, TenderProjectRuleEntity tenderProjectRuleEntity, String bidopeningStage, SupplierRemoteBidOpeningListener supplierRemoteBidOpeningListener){
		this.tenderProjectEntity = tenderProjectEntity;
		this.tenderProjectRuleEntity = tenderProjectRuleEntity;
		this.bidopeningStage = bidopeningStage;
		this.supplierRemoteBidOpeningListener = supplierRemoteBidOpeningListener;
		this.tenderProjectService = new TenderProjectService();
	}
	
	public void start(){
		thread = new Thread(this);
		thread.setName(tenderProjectEntity.getTenderName()+"远程开标");
		thread.start();
	}
	
	public void stop(){
		thread = null;
	}
	
	public void run() {
		
		TenderPackOpeningInfo tenderPackOpeningInfo = tenderProjectService.getTenderPackOpeningInfo(tenderProjectEntity.getId(), bidopeningStage);
		List<Supplier> tempSupplierList = supplierService.getSupplierOpenBidList(tenderProjectEntity.getId());
		List<Supplier> supplierList = new ArrayList<Supplier>();
		if(null != tempSupplierList){
			for(Supplier supplier : tempSupplierList){
				if(null != supplier.getTenderTime()){
					supplierList.add(supplier);
				}
			}
		}
		
		if(null != thread){
			supplierRemoteBidOpeningListener.refreshDescInfo(tenderPackOpeningInfo);
			supplierRemoteBidOpeningListener.refreshSupplierList(supplierList);
		}
	}
	
}
