package com.gx.obe.opening.thread;

import java.util.Date;

import com.gx.obe.WebserviceConstants;
import com.gx.obe.business.http.HttpUrl;
import com.gx.obe.business.http.HttpUtils;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.utils.NowTimeUtils;

/** 
 * @Description: 启动远程开标流程
 * @author guoyr 
 */
public class SendNoticeThread implements Runnable{
	
	private TenderProjectEntity tenderProjectEntity;
	private String bidopeningStage;
	private Thread thread;
	private HttpUrl httpUrl;
	private SendListener sendListener;
	private String message;
	public SendNoticeThread(TenderProjectEntity tenderProjectEntity, String bidopeningStage, SendListener sendListener){
		this.tenderProjectEntity = tenderProjectEntity;
		this.bidopeningStage = bidopeningStage;
		this.sendListener = sendListener;
	}
	public void start(){
		if(null == httpUrl){
			httpUrl = HttpUtils.getProjectHttpUrl(tenderProjectEntity, PropertiesUtils.getWebserviceProperty(WebserviceConstants.SEND_BIDOPENING_NOTICE_METHOD, ""));
		}
		if(null != httpUrl){
			httpUrl.setName("发送开标消息");
			String openStageType = "00";
			if(null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_PRICE)){
				openStageType = "02";
			}else if(null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_BUS_TEC)){
				openStageType = "01";
			}
			httpUrl.setAttribute("openStageType", openStageType);
		}
		thread = new Thread(this);
		thread.start();
		
	}
	public void stop(){
		thread = null;
	}
	public void join(){
		if(null != thread){
			try {
				thread.join();
			} catch (InterruptedException e) {
			}
		}
	}
	public void sendNotice(String notice){
		sendNotice(null, notice);
	}
	public void sendNotice(String stageIds, String notice){
		this.message = notice;
		if(null != thread && null != notice && notice.length() > 0){
			if(null != stageIds){
				httpUrl.setAttribute("stageIds", stageIds);
			}
			httpUrl.setAttribute("noticeContent", notice);
			start();
		}
	}
	public void run(){
		if(null != httpUrl && null != httpUrl.getAttribute("noticeContent")){
			if(HttpUtils.doPost(httpUrl).getStatus()) {
				if(null != sendListener){
					sendListener.sendMessage(true, NowTimeUtils.getNowDate(), message);
				}
			}
		}
	}
	
	public static interface SendListener{
		public void sendMessage(boolean sendFlag, Date sendTime, String message);
	}
}
