package com.gx.obe.opening.thread;

import java.util.Date;
import java.util.HashMap;
import java.util.Map;

import com.gx.obe.WebserviceConstants;
import com.gx.obe.business.http.HttpResponse;
import com.gx.obe.business.http.HttpUrl;
import com.gx.obe.business.http.HttpUtils;
import com.gx.obe.common.widget.listener.ProgressMessageListener;
import com.gx.obe.common.widget.thread.MyRunnable;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.components.core.enumeration.TenderProjectEnum;
import com.gx.obe.components.core.enumeration.VideoMeetingEmum;
import com.gx.obe.config.ConfigConstants;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.http.json.JsonUtil;
import com.gx.obe.message.Messages;
import com.gx.obe.util.utils.DateUtils;
import com.gx.obe.web.entity.BidOpeningRoom;
import com.gx.obe.web.entity.tender.TenderProjectEntity;
import com.gx.obe.web.service.BidOpeningRoomService;
import com.gx.obe.web.service.TenderProjectService;
import com.gx.utils.ActionLogUtils;

/** 
 * @Description: 启动远程开标流程
 * @author guoyr 
 */
public class StartRemoteBidopeningHallThread extends MyRunnable{
	
	private TenderProjectEntity tenderProjectEntity;
	private TenderProjectEntity parentTenderProjectEntity;
	private ProgressMessageListener openRemoteHallListener;
	private Thread thread;
	private final String TIMESTAMP_STR = "yyyy-MM-dd HH:mm:ss";
	private String bidopeningStage;
	private Date bidOpeningTime;
	private Date signEndTime;
	private Date decEndTime;
	private TenderProjectService tenderProjectServices;

	public StartRemoteBidopeningHallThread(TenderProjectEntity parentTenderProjectEntity, TenderProjectEntity tenderProjectEntity, String bidopeningStage, Date bidOpeningTime, Date signEndTime, Date decEndTime, ProgressMessageListener openRemoteHallListener){
		this.tenderProjectEntity = tenderProjectEntity;
		this.bidopeningStage = bidopeningStage;
		this.bidOpeningTime = bidOpeningTime;
		this.signEndTime = signEndTime;
		this.decEndTime = decEndTime;
		this.openRemoteHallListener = openRemoteHallListener;
		this.parentTenderProjectEntity = parentTenderProjectEntity;
		tenderProjectServices = new TenderProjectService();
	}
	public void start(){
		thread = new Thread(this);
		thread.start();
	}
	public void stop(){
		thread = null;
	}
	public void join(){
		if(null != thread){
			try {
				thread.join();
			} catch (InterruptedException e) {
			}
		}
	}
	public void run(){
		openRemoteHallListener.message(Messages.Tips_startingOpeningHall, 0);
		HttpUrl httpUrl = HttpUtils.getProjectHttpUrl(tenderProjectEntity, PropertiesUtils.getWebserviceProperty(WebserviceConstants.START_REMOTE_BIDOPENING_METHOD, ""));
		if(null != httpUrl){
			httpUrl.setName("启动远程开标大厅");
			boolean isPriceStage = false;
			String openStageType = "00";
			if(null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_PRICE)){
				isPriceStage = true;
				openStageType = "02";
			}else if(null != bidopeningStage && bidopeningStage.equals(TenderProjectEnum.STAGE_BUS_TEC)){
				openStageType = "01";
			}
			httpUrl.setAttribute("openStageType", openStageType);
			Date bidOpeningSignDeadLine = signEndTime;//null != signEndTime ? signEndTime : bidOpeningTime;
			httpUrl.setAttribute("bidOpeningSignDeadLine", null != bidOpeningSignDeadLine ? DateUtils.getFormat(bidOpeningSignDeadLine, TIMESTAMP_STR) : null);// 签到截止时间
			httpUrl.setAttribute("bidOpeningTime", DateUtils.getFormat(bidOpeningTime, TIMESTAMP_STR));//开标开标时间
//			Date bidOpeningDeadLine = null != decEndTime ? decEndTime  : DateUtils.add(bidOpeningTime, DateUtils.HOUR, 1);
			httpUrl.setAttribute("bidOpeningDeadLine", null != decEndTime ? DateUtils.getFormat(decEndTime, TIMESTAMP_STR): null);// 解密截止时间
			String bidOpeningRoomAddress = "";
			if(null != tenderProjectEntity.getBidOpeningRoomId()){
				BidOpeningRoomService bidOpeningRoomService = new BidOpeningRoomService();
				BidOpeningRoom bidOpeningRoom = bidOpeningRoomService.getBidOpeningRoomById(tenderProjectEntity.getBidOpeningRoomId());
				if(null != bidOpeningRoom){
					bidOpeningRoomAddress = bidOpeningRoom.getBidOpeningRoomAddress();
				}
			}
			if(null == bidOpeningRoomAddress || bidOpeningRoomAddress.length() == 0 && null != tenderProjectEntity.getOpeningAddress()){
				bidOpeningRoomAddress = tenderProjectEntity.getOpeningAddress();
			}
			httpUrl.setAttribute("bidOpeningRoom", null != bidOpeningRoomAddress? bidOpeningRoomAddress : "");
//			Properties videoProperties = PropertiesUtils.getProperties("videoConfig.properties");
			
//			String videoDeskLiveUrl = ObjectUtils.getObjString(videoProperties.getProperty(VideoConfigConstants.VIDEO_DESK_LIVE_URL));
			String meetingServerAddress = PropertiesUtils.getProperty(ConfigConstants.MEETING_SERVER_ADDRESS, "");
			String meetingCleintServerAddress = PropertiesUtils.getProperty(ConfigConstants.MEETING_CLEINT_SERVER_ADDRESS, "");
			String meetingCleintServerPort = PropertiesUtils.getProperty(ConfigConstants.MEETING_CLEINT_SERVER_PORT, "1089");
			String videoMeetingType = PropertiesUtils.getProperty(ConfigConstants.VIDEO_MEETING_TYPE, VideoMeetingEmum.MEETING_BK);
			Map<String, Object> params = new HashMap<String, Object>();
			
			String roomIdAndPwd = parentTenderProjectEntity.getBidMeeting();
			String roomId = "";
			String rpwd = "123456";
			if(null != roomIdAndPwd && roomIdAndPwd.length() > 0) {
				if(roomIdAndPwd.contains("_")) {
					roomId = roomIdAndPwd.substring(0,roomIdAndPwd.indexOf("_"));
					rpwd = roomIdAndPwd.substring(roomIdAndPwd.indexOf("_")+1);
		    	}else {
		    		roomId = roomIdAndPwd;
		    	}
			}
			
			params.put("roomPassWord", rpwd);// 自动广播音频
			params.put("meetingClientServerAddress", meetingCleintServerAddress);// 自动广播视频
			params.put("videoMeetingType", videoMeetingType);// 文字群聊
			params.put("meetingClientServerPort", meetingCleintServerPort);// 文字私聊
			params.put("meetingServerAddress", meetingServerAddress);// 标注白板
			params.put("id", "");// 保存白板
			params.put("roomId", roomId);//客户端录制会议
//			params.put("file_share", true);// 发送文件
//			params.put("reserve_presenter_video", true);// 保留主讲视频
			String roomPermission = JsonUtil.jsonObjectToStr(params);
//			serviceUtils.addParameter("roomPermission", roomPermission);//1、用户密码验证；2、会议室密码验证；3、匿名登录
//			{"roomPassWord":"123456","meetingClientServerAddress":"123.57.53.254","videoMeetingType":"00","meetingClientServerPort":"1089","id":"","meetingServerAddress":"http://123.57.53.254:8080/fmapi/webservice/jaxws?wsdl","roomId":"10049"}
			httpUrl.setAttributeTransference("bidOpeningLiveCameraUrl",roomPermission);
			httpUrl.setAttribute("bidOpeningLiveDesktopUrl", "");
			
			
//			httpUrl.setAttribute("bidOpeningLiveCameraUrl", VideoConfigConstants.getLivingAddress());
//			httpUrl.setAttribute("bidOpeningLiveDesktopUrl", videoDeskLiveUrl);
			boolean startRemoteBidopening = false;
			
			HttpResponse httpResponse = HttpUtils.doPost(httpUrl);
			startRemoteBidopening = httpResponse.getStatus();
			ActionLogUtils.addServerLog(tenderProjectEntity.getId(),"启动远程开标大厅", httpUrl, startRemoteBidopening);
			if(!startRemoteBidopening) {
				httpResponse = HttpUtils.doPost(httpUrl);
				startRemoteBidopening = httpResponse.getStatus();
				ActionLogUtils.addServerLog(tenderProjectEntity.getId(),"第二次启动远程开标大厅", httpUrl, startRemoteBidopening);
			}
			
			if(startRemoteBidopening){
				openRemoteHallListener.message(Messages.Tips_startOpeningHallSuccess, 1);
				if(isPriceStage){
					tenderProjectEntity.setStartPriceBidOpening(CommonEnum.YES);
					tenderProjectServices.updateAssignProperty(tenderProjectEntity, new String[]{"id","startPriceBidOpening"});
				}else {
					tenderProjectEntity.setStartBidOpening(CommonEnum.YES);
					tenderProjectServices.updateAssignProperty(tenderProjectEntity, new String[]{"id","startBidOpening"});
				}
			}else {
				if(null != httpResponse.getMsg()) {
					openRemoteHallListener.message(httpResponse.getMsg(), -1);
				}
				openRemoteHallListener.message(Messages.Tips_startOpeningHallFail, -1);
				
			}
			openRemoteHallListener.finish(startRemoteBidopening);
		
		
		}
	}
}
