package com.gx.obe.opening.thread;

import java.io.File;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.util.Date;

import com.gx.obe.WebserviceConstants;
import com.gx.obe.business.http.HttpUpload;
import com.gx.obe.business.http.HttpUrl;
import com.gx.obe.business.http.HttpUtils;
import com.gx.obe.business.http.UploadListener;
import com.gx.obe.common.file.enumeration.FileConstants;
import com.gx.obe.common.file.utils.ZipUtils;
import com.gx.obe.components.core.enumeration.CommonEnum;
import com.gx.obe.config.utils.PropertiesUtils;
import com.gx.obe.web.entity.tender.TenderProjectEntity;

/**
 * @Description: 上传开标议程
 * @author guoyr
 */
public class UploadBidOpeningAgendaFileThread implements Runnable{
	private TenderProjectEntity tenderProjectEntity;
	private Thread thread;
	private File bidOpeningAgendaFile;
	private UploadListener uploadListener;
	
	public UploadBidOpeningAgendaFileThread(TenderProjectEntity tenderProjectEntity, File bidOpeningAgendaFile, UploadListener uploadListener){
		this.tenderProjectEntity = tenderProjectEntity;
		this.bidOpeningAgendaFile = bidOpeningAgendaFile;
		this.uploadListener = uploadListener;
	}
	public void start(){
		thread = new Thread(this);
		thread.start();
	}
	public void stop(){
		thread = null;
	}
	public void join(){
		try {
			thread.join();
		} catch (InterruptedException e) {
		}
	}
	public void run(){
		uploadOpenBidResult();
	}
	public void uploadOpenBidResult() {
		boolean uploadSuccess = false;
		// 获得上传的结构化开标数据
		if(null != bidOpeningAgendaFile && bidOpeningAgendaFile.exists()){
			HttpUrl httpUrl = HttpUtils.getProjectHttpUrl(tenderProjectEntity, PropertiesUtils.getWebserviceProperty(WebserviceConstants.UPLOAD_FILE_SERVLET, ""));
			httpUrl.setAttribute("fileType", "bidOpeningAgendaFile");
			
			HttpUpload httpURLUpload=new HttpUpload(uploadListener);
			File tempZipFile = new File(FileConstants.TEMP_FOLDER + "bidOpeningAgendaFile("+new Date().getTime()+").zip");
			try {
				ZipUtils.zip(new String[]{bidOpeningAgendaFile.getAbsolutePath()}, tempZipFile.getAbsolutePath(), "开标议程", false, uploadListener);
			} catch (FileNotFoundException e) {
			} catch (IOException e) {
			}
			uploadSuccess = httpURLUpload.upload(httpUrl, tempZipFile.exists() ? tempZipFile : bidOpeningAgendaFile);
			if(uploadSuccess){
				callBackMsg(true, "上传成功!");
				tenderProjectEntity.setUploadOpeningResultStatus(CommonEnum.COMPLETE);
				if(tempZipFile.exists()){
					tempZipFile.delete();
				}
			}else {
				tenderProjectEntity.setUploadOpeningResultStatus(CommonEnum.FAILE);
				callBackMsg(false, "上传失败，此次上传结束。");
			}
		}else {
			callBackMsg(false, "未找到要上传的文件！");
		}
		if(null != uploadListener){
			uploadListener.finish(uploadSuccess);
		}
	}
	
	private void callBackMsg(boolean bool, String msg){
		if(null != uploadListener){
			uploadListener.info((bool?"√":"×")+ msg);
		}
	}
}
