package com.gx.obe.opening.utils;

import java.util.Comparator;

import com.gx.obe.web.vo.TenderPackOpeningInfo;

public class TenderPackDecInfoComparator implements Comparator<TenderPackOpeningInfo>{
	public static final int ORDERBY_NO_SIGN = 1;
	public static final int ORDERBY_NO_DEC = 2;
	public static final int ORDERBY_NO_CONFIRM = 3;
	public static final int ORDERBY_NO_COMPLATE = 4;

	public int orderType;
	public TenderPackDecInfoComparator(int orderType){
		this.orderType = orderType;
		
	}
	public int compare(TenderPackOpeningInfo after, TenderPackOpeningInfo before) {
		double afterTotalCount = after.getOpeningCount() > 0 ? after.getOpeningCount() : after.getTenderCount();
		double beforeTotalCount = before.getOpeningCount() > 0 ? before.getOpeningCount() : before.getTenderCount();
		if(orderType == ORDERBY_NO_SIGN){
			if(after.getSignCount() != 0 && before.getSignCount() != 0 && after.getTenderCount() != 0 && before.getTenderCount() != 0){
				double comp = after.getSignCount()/(double)after.getTenderCount() - before.getSignCount()/(double)before.getTenderCount();
				if(comp < 0){
					return -1;
				}else if(comp > 0){
					return 1;
				}
			}
			if(after.getSignCount() < before.getSignCount()){
				return -1;
			}else if(after.getSignCount() > before.getSignCount()){
				return 1;
			}
			return before.getTenderCount() - after.getTenderCount();
			
		}else if(orderType == ORDERBY_NO_CONFIRM){
			// 先显示有质疑的
			if(after.getConfirmQuestionCount() > before.getConfirmQuestionCount()){
				return -1;
			}else if(after.getConfirmQuestionCount() < before.getConfirmQuestionCount()){
				return 1;
			}else {
				if(afterTotalCount != 0 && beforeTotalCount != 0){
					if(after.getConfirmCount() != 0 && before.getConfirmCount() != 0){
						double comp = after.getConfirmCount()/afterTotalCount - before.getConfirmCount()/beforeTotalCount;
						if(comp < 0){
							return -1;
						}else if(comp > 0){
							return 1;
						}
					}else if(after.getDecCount() != 0 && before.getDecCount() != 0){
						double comp = after.getDecCount()/afterTotalCount - before.getDecCount()/beforeTotalCount;
						if(comp < 0){
							return -1;
						}else if(comp > 0){
							return 1;
						}
					}
				}
				return (int)(beforeTotalCount - afterTotalCount);
			}
			
		}else if(orderType == ORDERBY_NO_COMPLATE){
			if(after.getComplateSupplierCount() != 0 && before.getComplateSupplierCount() != 0 && afterTotalCount != 0 && beforeTotalCount != 0){
				double comp = after.getComplateSupplierCount()/afterTotalCount - before.getComplateSupplierCount()/beforeTotalCount;
				if(comp < 0){
					return -1;
				}else if(comp > 0){
					return 1;
				}
			}
			if(after.getComplateSupplierCount() < before.getComplateSupplierCount()){
				return -1;
			}else if(after.getComplateSupplierCount() > before.getComplateSupplierCount()){
				return 1;
			}
			return (int)(beforeTotalCount - afterTotalCount);
		}else {
			if(Math.max(after.getDecFailCount(), after.getNoPriceCount()) > Math.max(before.getDecFailCount(), before.getNoPriceCount())){
				return -1;
			}else if(Math.max(after.getDecFailCount(), after.getNoPriceCount()) < Math.max(before.getDecFailCount(), before.getNoPriceCount())){
				return 1;
			}else {
				if(after.getDecCount() != 0 && before.getDecCount() != 0 && afterTotalCount != 0 && beforeTotalCount != 0){
					double comp = after.getDecCount() / afterTotalCount - before.getDecCount() / beforeTotalCount;
					if(comp < 0){
						return -1;
					}else if(comp > 0){
						return 1;
					}
				}
				if(after.getDecCount() < before.getDecCount()){
					return -1;
				}else if(after.getDecCount() > before.getDecCount()){
					return 1;
				}
			}
			return (int)(beforeTotalCount - afterTotalCount);
		}
	}

}
