package com.gx.obe.opening.widgets;

import org.eclipse.swt.SWT;
import org.eclipse.swt.SWTException;
import org.eclipse.swt.core.ImageResolver;
import org.eclipse.swt.custom.CLabel;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Font;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.ImageData;
import org.eclipse.swt.graphics.ImageLoader;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;

import com.gx.obe.message.Messages;
import com.swtdesigner.SWTResourceManager;

public class BidOpeningStatusButton extends CLabel{

	/** Gap between icon and text */
	private int GAP = 0;
	/** Left and right margins */
	private static final int DEFAULT_MARGIN = 1;
	/** a string inserted in the middle of text that has been shortened */
	/** the alignment. Either CENTER, RIGHT, LEFT. Default is LEFT*/
	private int align = SWT.CENTER;
	private int leftMargin = DEFAULT_MARGIN;
	private int topMargin = DEFAULT_MARGIN;
	private int rightMargin = DEFAULT_MARGIN;
	private int bottomMargin = DEFAULT_MARGIN;
	
	/** the current text */
	private String text;
	private String toolTipText;
	/** the current icon */
	private Image image;
	private int imageWidth = 24;
	private int imageHeight = 16;
	// The tooltip is used for two purposes - the application can set
	// a tooltip or the tooltip can be used to display the full text when the
	// the text has been truncated due to the label being too short.
	// The appToolTip stores the tooltip set by the application.  Control.tooltiptext 
	// contains whatever tooltip is currently being displayed.
	private String appToolTipText;
	private int lineSpacing = 0;// 默认的行距
	private int leftOffset = 0;
	private int rightOffset = 0;
	
	private Color borderColor;
	private Color disenableColor;
	private Color disenableFontColor;
	private Color backgroundColor;
	private Image backgroundImage;
	private Color complateColor = SWTResourceManager.getColor(99, 183, 35);
	private Color whiteColor = Display.getCurrent().getSystemColor(SWT.COLOR_WHITE);
	private Color errorColor = SWTResourceManager.getColor(SWT.COLOR_RED);//SWTResourceManager.getColor(255, 153, 153);
	private static int DRAW_FLAGS = SWT.DRAW_MNEMONIC | SWT.DRAW_TAB | SWT.DRAW_TRANSPARENT | SWT.DRAW_DELIMITER;
	private boolean isComplate = false;
	private int arcWidth = 0;
	private int alpha = -1;
	private int borderWidth = 1;
	private boolean enabled = true;
	private int errorCount = 0;
	private int lineStyle = SWT.LINE_CUSTOM;
	private Image subImage;
	private ImageResolver imageResolver = new ImageResolver();
	private ImageData[] imageDatas;
	private Image[] images;
	private int current;
	 private int repeatCount;
	private Runnable animationTimer;
	private String statusName = Messages.Opening_tendered;
	private Font statusFont = SWTResourceManager.getFont("微软雅黑", 8, SWT.NORMAL);
	private Font textFont = SWTResourceManager.getFont("微软雅黑", 11, SWT.NORMAL);
	
	private static int checkStyle(int style) {
		int _sytle = SWT.NONE;
		return _sytle;
//		if ((style & SWT.BORDER) != 0)
//			style |= SWT.SHADOW_IN;
//		int mask = SWT.SHADOW_IN | SWT.SHADOW_OUT | SWT.SHADOW_NONE
//				| SWT.LEFT_TO_RIGHT | SWT.RIGHT_TO_LEFT;
//		style = style & mask;
//		return style |= SWT.NO_FOCUS | SWT.DOUBLE_BUFFERED;
	}
	public BidOpeningStatusButton(Composite parent, int style) {
		super(parent, checkStyle(style));
		
		addListener(SWT.Dispose, new Listener() {
			public void handleEvent(Event event) {
				dispose(event);
			}
		});
		
		addPaintListener(new PaintListener() {
			public void paintControl(PaintEvent event) {
				doPaint(event.gc);
			}
		});
	}

	public Point computeSize(int wHint, int hHint, boolean changed) {
		if(!this.getVisible()){
			return new Point(0, 0);
		}
		checkWidget();
		Point e = getTotalSize(image, text);
		if (wHint == SWT.DEFAULT){
			e.x += leftMargin + rightMargin;
		} else {
			e.x = wHint;
		}
		if (hHint == SWT.DEFAULT) {
			e.y += topMargin + bottomMargin;
		} else {
			e.y = hHint;
		}
		return e;
	}

	private Point getTotalSize(Image image, String text) {
		Point size = new Point(0, 0);
		GC gc = new GC(this);
		gc.setFont(textFont);
		if(isComplate){
			if (image != null) {
				Rectangle r = image.getBounds();
				if(imageWidth > 0){
					size.x += imageWidth;
				}else {
					
					size.x += r.width;
				}
				if(imageHeight > 0){
					size.y += imageHeight;
				}else {
					size.y += r.height;
				}
			}else {
//				size.y += imageHeight;
//				size.x += imageWidth;
				Point e = gc.textExtent(text, DRAW_FLAGS);
				imageHeight = e.y;
				size.y += e.y;
				size.x += e.x;
			}
		}else if (text != null && text.length() > 0) {
			Point e = gc.textExtent(text, DRAW_FLAGS);
			size.y += e.y;
			size.x = Math.max(size.x, e.x);
		}
		gc.setFont(statusFont);
		Point e = gc.textExtent(statusName, DRAW_FLAGS);
		size.x = Math.max(size.x, e.x + 2);
		gc.dispose();
		size.y += GAP;
		size.y += 16;// 已解密
		return size;
	}
	private Point getTotalSize(Image image, String text, GC gc, int recWidth, int recHeight) {
		Point size = new Point(0, 0);
		gc.setFont(SWTResourceManager.getFont("微软雅黑", 11, SWT.NORMAL));
		if(isComplate){
			if (image != null) {
				Rectangle r = image.getBounds();
				if(imageWidth > 0){
					size.x += imageWidth;
				}else {
					
					size.x += r.width;
				}
				if(imageHeight > 0){
					size.y += imageHeight;
				}else {
					size.y += r.height;
				}
			}else {
//				size.y += imageHeight;
//				size.x += imageWidth;
				Point e = gc.textExtent(text, DRAW_FLAGS);
				imageHeight = e.y;
				size.y += e.y;
				size.x += e.x;
			}
		}else if (text != null && text.length() > 0) {
			Point e = gc.textExtent(text, DRAW_FLAGS);
			size.y += e.y;// 50个
			size.x = Math.max(size.x, e.x);
		} 
		gc.setFont(statusFont);
		Point e = gc.textExtent(statusName, DRAW_FLAGS);
		size.x = Math.max(size.x, e.x + 2);
		
		size.y += GAP;
		size.y += 16;// 已解密
		return size;
	}
	
	public void setBackgroundImage(Image image) {
		setBackground(image);
	}
	public void setComplate(boolean isComplate){
		if(this.isComplate != isComplate){
			this.isComplate = isComplate;
			checkWidget();
			redraw();
		}
	}
	public boolean isComplate(){
		return this.isComplate;
	}
	
	public void setBackground(Image image) {
		checkWidget();
		if (image == backgroundImage) return;
		backgroundImage = image;
		redraw();
	}
	public void setImage(Image image){
		checkWidget();
		if(null != image){
			this.image = image;
		}
		redraw();
	}
	public void setImage(Image image, int width, int height){
		checkWidget();
		if(null != image){
			this.image = image;
			this.imageWidth = width;
			this.imageHeight = height;
		}
		redraw();
	}
	public void setEnabled(boolean enabled){
		if(enabled != this.enabled){
			this.enabled = enabled;
			this.redraw();
		}
	}
	
	public void setErrorCount(int errorCount) {
		this.errorCount = errorCount;
	}
	public boolean getEnabled(){
		return this.enabled;
	}
	public void setBackground(Color color){
		setBackgroundColor(color);
	}
	public void setBackgroundColor(Color color){
		checkWidget();
		this.backgroundColor = color;
		redraw();
	}
	
	private void refresh(){
		GC myGc = new GC(this);
		doPaint(myGc);
		myGc.dispose();
	}
	
	private void doPaint(GC gc) {
		if(!this.getVisible()){
			return;
		}
		Rectangle rect = getClientArea();
		if (rect.width == 0 || rect.height == 0) return;
		
		String t = text;
		Image img = image;
		
		// 获得图标和文字需要的大小
		Point extent = getTotalSize(img, t, gc, rect.width, rect.height);
		gc.setFont(textFont);
		// determine horizontal position
		// draw a background image behind the text
		Image bgImage = backgroundImage;
		try {
			if (bgImage != null) {
				// 中间
				if(leftOffset + rightOffset > 0){
					gc.drawImage(bgImage, leftOffset, 0, bgImage.getBounds().width -leftOffset -rightOffset, bgImage.getBounds().height, 0, 0, rect.width, rect.height);
					drawBackgroundImage(rect, gc, bgImage, leftOffset, rightOffset);
				}else {
					gc.drawImage(bgImage, 0, 0, bgImage.getBounds().width, bgImage.getBounds().height, 0, 0, rect.width, rect.height);
				}
			} else {
				drawBorder(gc, rect);
			}
		} catch (SWTException e) {
			if ((getStyle() & SWT.DOUBLE_BUFFERED) == 0) {
				gc.setBackground(getBackground());
				gc.fillRectangle(rect);
			}
		}

		/*
		 * Compute text height and image height. If image height is more than
		 * the text height, draw image starting from top margin. Else draw text
		 * starting from top margin.
		 */
		int drawImgHeight = 0;
		int drawImgWidth = 0;
		
		Rectangle imageRect = null;
		if (img != null) {
			imageRect = img.getBounds();
		    drawImgHeight = imageRect.height;
		    drawImgWidth = imageRect.width;
		    
		    if(imageWidth > 0){
		    	drawImgWidth = imageWidth;
		    }
		    if(imageHeight > 0){
		    	drawImgHeight = imageHeight;
		    }
//		    if(moreWidth > 0){
//		    	imageRect.width -= moreWidth;
//		    }
		}
		
		Color  fontColor = this.getForeground(); 
		

		int y = (rect.height - extent.y)/2;
		if (topMargin == DEFAULT_MARGIN && bottomMargin == DEFAULT_MARGIN) {
			y = (rect.height - extent.y)/2;
		}else if(topMargin != bottomMargin){
			y = topMargin;
		}
		
		y=0;
		if (isComplate) {
			gc.setForeground(complateColor);
			if(null != img){
				int imgX = (rect.width - drawImgWidth)/2;
				gc.drawImage(img, 0, 0, imageRect.width, imageRect.height, imgX , y, drawImgWidth, drawImgHeight);
				y +=  drawImgHeight;
				extent.y -= drawImgHeight + GAP;
			}else {
				gc.setAntialias(SWT.ON);//消除锯齿
				gc.setAdvanced(true);
				int x = (rect.width - imageHeight)/2;
		            
				gc.setLineWidth(2);
		            for (int i=1; i < 4; i++){
		            	gc.drawLine(x, y + imageHeight/2 - 0 + i, x + imageWidth/2 - 3, y + imageHeight - 6 + i);
		            	gc.drawLine(x + imageWidth/2 - 3, y + imageHeight - 6 + i, x + imageWidth-2,  4+i);
		            }
		            y += imageHeight;
			}
			
		}else if(null != text && text.length() > 0){
			Point textPoint = gc.textExtent(text, DRAW_FLAGS);
			int lineWidth = textPoint.x;
			int x = (rect.width - lineWidth)/2;
			String unit = text.substring(text.length() - 1);
			gc.drawText(text.substring(0, text.length() - 1), x, y, DRAW_FLAGS);
			
			gc.setForeground(SWTResourceManager.getColor(166, 167, 169));
			Point unitPoint = gc.textExtent(unit, DRAW_FLAGS);
			gc.drawText(unit, x + lineWidth - unitPoint.x, y + textPoint.y - unitPoint.y, DRAW_FLAGS);
			y += textPoint.y;
		}
		
		y += GAP;
		gc.setFont(statusFont);
		Point typeTextPoint = gc.textExtent(statusName, DRAW_FLAGS);
//		gc.drawRoundRectangle(0, 0, rect.width -1, rect.height -1, arcWidth, arcWidth);
//		gc.drawRoundRectangle((rect.width - typeTextPoint.x)/2 -1, y , typeTextPoint.x + 2, typeTextPoint.y, 3, 3);
		if(isComplate){
			gc.setBackground(complateColor);
		}else {
			gc.setBackground(fontColor);
		}
		gc.setAntialias(SWT.ON);//消除锯齿
		gc.setAdvanced(true);
		int drawX = (rect.width - typeTextPoint.x)/2 -1;
		gc.fillRoundRectangle(drawX, y , typeTextPoint.x + 3, typeTextPoint.y, 5, 5);
		gc.setForeground(whiteColor);
		gc.drawText(statusName, (rect.width - typeTextPoint.x)/2, y , DRAW_FLAGS);
		if(errorCount > 0){
//			gc.setLineWidth(1);
//			gc.setForeground(errorColor);
//			gc.drawOval(rect.width - 10, y - 5, 5, 5);
			int x = 2;
			String errorsStr = errorCount+"";
			Point errorsPoint = gc.textExtent(errorsStr, DRAW_FLAGS);
			gc.setBackground(errorColor);
			gc.setForeground(whiteColor);
			int subTextSurrondWidth = Math.max(errorsStr.length() > 1 ? errorsPoint.x + 2 : errorsPoint.x  - 2, errorsPoint.y -2);
			int subTextSurrondHeight = errorsPoint.y -2;
			int errorX = Math.max(x -2 , getBounds().width- subTextSurrondWidth);
			int errorY = Math.max(2, y - subTextSurrondHeight +3 );
			gc.setAlpha(200);
			gc.setAdvanced(true);
			if(subTextSurrondWidth > subTextSurrondHeight) {
				gc.fillRoundRectangle(errorX , errorY , subTextSurrondWidth, subTextSurrondHeight, subTextSurrondHeight, subTextSurrondHeight);
			}else {
				gc.fillOval(errorX , errorY , subTextSurrondWidth, subTextSurrondHeight);
			}
			gc.setAdvanced(false);
			gc.setAlpha(-1);
			gc.drawText(errorsStr, errorX +(subTextSurrondWidth - errorsPoint.x)/2, errorY + (subTextSurrondHeight - errorsPoint.y)/2 , true);
		
		}
	
	}
	
	private void drawBackgroundImage(Rectangle rect, GC gc, Image bgImage, int leftWidth, int rightWidth){
		Rectangle bgImageRect = bgImage.getBounds();
		if(leftWidth + rightWidth == 0){
			gc.drawImage(bgImage, 0, 0, bgImageRect.width, bgImageRect.height, 0, rect.height - bgImageRect.height, rect.width, bgImageRect.height);
		}else {
			gc.drawImage(bgImage, leftWidth, 0, Math.max(bgImageRect.width -leftWidth -rightWidth, 1), bgImageRect.height, leftWidth, rect.height - bgImageRect.height, Math.max(rect.width -(leftWidth)-(rightWidth), 1), bgImageRect.height);
			if(leftWidth != 0){
				// 最左边
				gc.drawImage(bgImage, 0, 0, leftWidth, bgImageRect.height, 0, rect.height - bgImageRect.height, leftWidth, bgImageRect.height);
			}
			if(rightWidth != 0){
				// 最右边
				gc.drawImage(bgImage, bgImageRect.width - rightWidth, 0, rightWidth, bgImageRect.height, rect.width -rightWidth, rect.height - bgImageRect.height, rightWidth, bgImageRect.height);
			}
		}
	}
	
	private void drawBorder(GC gc, Rectangle rect){
		gc.setLineWidth(1);
		Color _borderColor = null;
		Color bgColor = backgroundColor;
		
		boolean isRound = arcWidth > 0;
		if(alpha != 0){
			gc.setAlpha(alpha);
			if(null == bgColor && null != _borderColor){
				bgColor = _borderColor;
				gc.setAlpha(5);
			}
			if(null != bgColor){
				gc.setBackground(bgColor);
				if(!getEnabled()){
					if(null != disenableColor){
						gc.setBackground(disenableColor);
					}else {
//					gc.setBackground(Display.getCurrent().getSystemColor(SWT.COLOR_GRAY));
						gc.setBackground(SWTResourceManager.getColor(210, 210, 210));
//					gc.setAlpha(40);
					}
					
				}
				if(null != _borderColor){
					//不减小大小
					if(isRound){
						gc.setAntialias(SWT.ON);
						gc.setAdvanced(true);
						gc.fillRoundRectangle(0, 0, rect.width, rect.height, arcWidth, arcWidth);
					}else {
						gc.fillRectangle(0, 0, rect.width, rect.height);
					}
				}else {
					if(isRound){
						gc.setAntialias(SWT.ON);//消除锯齿
						gc.setAdvanced(true);
						gc.fillRoundRectangle(0, 0, rect.width, rect.height, arcWidth, arcWidth);
						// 如果有圆角，且没有边框，效果不好，所以用背景色进行划线
						gc.setForeground(bgColor);
						gc.drawRoundRectangle(0, 0, rect.width -1, rect.height -1, arcWidth, arcWidth);
					}else {
						gc.fillRectangle(rect);
					}
				}
			}
			gc.setAlpha(-1);
		}
		
		if(null != _borderColor){
			gc.setLineWidth(borderWidth);
			
			gc.setForeground(_borderColor);
			if(!getEnabled()){
				if(null != disenableColor){
					gc.setForeground(disenableColor);
				}else {
					gc.setForeground(SWTResourceManager.getColor(210, 210, 210));
				}
			}
			gc.setLineStyle(lineStyle);
			if(isRound){
				gc.setAntialias(SWT.ON);//消除锯齿
				gc.setAdvanced(true);
				gc.drawRoundRectangle(0, 0, rect.width -1, rect.height -1, arcWidth, arcWidth);
			}else {
				gc.drawRectangle(0, 0, rect.width -1, rect.height -1);
			}
		}
	}
//	Image getCurrentImage() {
//        if  (image  !=   null )
//            return  image;
//
//        if  (images  ==   null )
//            return   null ;
//
//        return  images[current];
//   }
	 /** 
     *  @param  repeatCount 0 forever
      */ 
	public   void  setGifPath(String gifPath) {
		setGifPath(gifPath, -1, -1);
	}
     public   void  setGifPath(String gifPath, int width, int height) {
    	 if(width > 0){
    		 this.imageWidth = width;
    	 }
    	 if(height > 0){
    		 this.imageHeight = height;
    	 }
    	 ImageLoader loader  =   new  ImageLoader();
         imageDatas  =  loader.load(gifPath);
         repeatCount = loader.repeatCount;
        convertImageDatasToImages();
        startAnimationTimer();
        
//        redraw()
        ;
    }
     void  convertImageDatasToImages() {
         images  =   new  Image[imageDatas.length];
         
          //  Step 1: Determine the size of the resulting images. 
          int  width  =  imageDatas[ 0 ].width;
          int  height  =  imageDatas[ 0 ].height;
          if(imageWidth > 0 && width > imageWidth){
        	  width = imageWidth;
          }
          if(imageHeight > 0 && height > imageHeight){
        	  height = imageHeight;
          }
          //  Step 2: Construct each image. 
          int  transition  =  SWT.DM_FILL_BACKGROUND;
          for  ( int  i  =   0 ; i  <  imageDatas.length; i ++ ) {
             ImageData imageData  =  imageDatas[i];
             images[i]  =   new Image(Display.getDefault(), imageData);
//             images[i]  =   new Image(null, width, height);
             GC gc  =  new  GC(images[i]);
              //  Do the transition from the previous image. 
              switch  (transition) {
              case  SWT.DM_FILL_NONE:
              case  SWT.DM_UNSPECIFIED:
            	  
                  //  Start from last image. 
                 gc.drawImage(images[i  -   1 ], 0, 0);
                  break ;
              case  SWT.DM_FILL_PREVIOUS:
                  //  Start from second last image. 
                 gc.drawImage(images[i  -   2 ],  0, 0);
                  break ;
              default :
                  //  DM_FILL_BACKGROUND or anything else,
                  //  just fill with default background. 
//                 gc.setBackground(bg);
//                 gc.fillRectangle( 0 ,  0 , width, height);
                  break ;
             }

              //  Draw the current image and clean up. 
             Image img  =   new  Image(Display.getDefault(), imageData);
             gc.setForeground(SWTResourceManager.getColor(10, 10, 210));
             gc.drawLine(0, 0, 100, 20);
             gc.drawImage(img,  0 ,  0 , imageData.width, imageData.height, imageData.x, imageData.y, imageData.width , imageData.height);
             img.dispose();
             gc.dispose();

              //  Compute the next transition.
              //  Special case: Can't do DM_FILL_PREVIOUS on the
              //  second image since there is no "second last"
              //  image to use. 
             transition  =  imageData.disposalMethod;
              if  (i  ==   0   &&  transition  ==  SWT.DM_FILL_PREVIOUS)
                 transition  =  SWT.DM_FILL_NONE;
         }
          image = images[0];
     }
	void  startAnimationTimer() {
        if  (images  ==   null   ||  images.length  <   2 )
            return ;

        final   int  delay  =  imageDatas[current].delayTime  *   10 ;
        Display.getDefault().timerExec(delay, animationTimer  =   new  Runnable() {

			public   void  run() {
                if  (isDisposed())
                    return ;

               current  =  (current  +   1 )  %  images.length;
               image = images[current];
//               refresh();
               redraw();

                if  (current  +   1   ==  images.length  &&  repeatCount  !=   0 
                        &&   -- repeatCount  <=   0 )
                    return ;
                Display.getDefault().timerExec(delay,  this );
           }
       });
   }

    void  stopAnimationTimer() {
        if  (animationTimer  !=   null )
        	Display.getDefault().timerExec( - 1 , animationTimer);
   }
	public void setBorderStyle(int lineStyle){
		this.lineStyle = lineStyle;
		
	}
	public void setFont(Font font) {
		super.setFont(font);
		redraw();
	}
	public void setText(String _text) {
		checkWidget();
		if (null == _text) _text = ""; //$NON-NLS-1$
		if (!_text.equals(this.text)) {
			this.text = _text;
			redraw();
		}
	}
	public String getText(){
		return text;
	}

	public int getAlpha() {
		return alpha;
	}
	public void setAlpha(int alpha) {
		if(alpha < 0 || alpha > 255){
			alpha = -1;
		}
		this.alpha = alpha;
	}
	public void setLeftOffset(int leftOffset) {
		this.leftOffset = leftOffset;
	}

	public void setRightOffset(int rightOffset) {
		this.rightOffset = rightOffset;
	}

	public int getLeftMargin() {
		return leftMargin;
	}

	public void setLeftMargin(int leftMargin) {
		this.leftMargin = leftMargin;
	}

	public int getTopMargin() {
		return topMargin;
	}

	public void setTopMargin(int topMargin) {
		this.topMargin = topMargin;
	}

	public int getRightMargin() {
		return rightMargin;
	}

	public void setRightMargin(int rightMargin) {
		this.rightMargin = rightMargin;
	}

	public int getBottomMargin() {
		return bottomMargin;
	}

	public void setBottomMargin(int bottomMargin) {
		this.bottomMargin = bottomMargin;
	}

	public Color getBorderColor() {
		return borderColor;
	}
	public void setBorderColor(Color borderColor) {
		this.borderColor = borderColor;
	}
	public int getArcWidth() {
		return arcWidth;
	}
	public void setArcWidth(int arcWidth) {
		this.arcWidth = arcWidth;
	}
	public int getBorderWidth() {
		return borderWidth;
	}
	public void setBorderWidth(int borderWidth) {
		this.borderWidth = borderWidth;
	}
	
	public void setGAP(int gap){
		if(gap < 0){
			GAP = 0;
		}
		this.GAP = gap;
	}
	
	public int getLineSpacing() {
		return lineSpacing;
	}
	public void setLineSpacing(int lineSpacing) {
		this.lineSpacing = lineSpacing;
	}
	public Image getSubImage() {
		return subImage;
	}
	public void setSubImage(Image subImage) {
		this.subImage = subImage;
	}
	
	public Color getDisenableColor() {
		return disenableColor;
	}
	public void setDisenableColor(Color disenableColor) {
		this.disenableColor = disenableColor;
	}
	public Color getDisenableFontColor() {
		return disenableFontColor;
	}
	public void setDisenableFontColor(Color disenableFontColor) {
		this.disenableFontColor = disenableFontColor;
	}
	
	
	@Override
	public Image getImage() {
		return image;
	}
	
	@Override
	public void setToolTipText(String string) {
		super.setToolTipText(string);
		this.toolTipText = string;
	}
	@Override
	public String getToolTipText() {
		return toolTipText;
	}
	
	public String getStatusName() {
		return statusName;
	}
	public void setStatusName(String statusName) {
		if(null != statusName){
			this.statusName = statusName;
		}
	}
	/**
	 * @Description: 释放资源
	 * @author guoyr
	 * @param event 
	 */
	private void dispose(Event event) {
		imageResolver.disposite();
		if  (images  !=   null )
            for  ( int  i  =   0 ; i  <  images.length; i ++ ){
            	
            	if(null != images[i] && !images[i].isDisposed()){
            		images[i].dispose();
            	}
            }
	}
}
